
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 1

/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yylval          base_yylval
#define yychar          base_yychar
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs
#define yylloc          base_yylloc

/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 5 "preproc.y"

#include "postgres_fe.h"

#include "extern.h"
#include "ecpg_config.h"
#include <unistd.h>

/* Location tracking support --- simpler than bison's default */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
                if (N) \
			(Current) = (Rhs)[1]; \
		else \
		        (Current) = (Rhs)[0]; \
	} while (0)

/*
 * The %name-prefix option below will make bison call base_yylex, but we
 * really want it to call filtered_base_yylex (see parser.c).
 */
#define base_yylex filtered_base_yylex

/*
 * This is only here so the string gets into the POT.  Bison uses it
 * internally.
 */
#define bison_gettext_dummy gettext_noop("syntax error")

/*
 * Variables containing simple states.
 */
int struct_level = 0;
int braces_open; /* brace level counter */
char *current_function;
int ecpg_internal_var = 0;
char	*connection = NULL;
char	*input_filename = NULL;

static int	FoundInto = 0;
static int	initializer = 0;
static int	pacounter = 1;
static char     pacounter_buffer[sizeof(int) * CHAR_BIT * 10 / 3]; /* a rough guess at the size we need */
static struct this_type actual_type[STRUCT_DEPTH];
static char *actual_startline[STRUCT_DEPTH];
static int 	varchar_counter = 1;

/* temporarily store struct members while creating the data structure */
struct ECPGstruct_member *struct_member_list[STRUCT_DEPTH] = { NULL };

/* also store struct type so we can do a sizeof() later */
static char *ECPGstruct_sizeof = NULL;

/* for forward declarations we have to store some data as well */
static char *forward_name = NULL;

struct ECPGtype ecpg_no_indicator = {ECPGt_NO_INDICATOR, NULL, NULL, NULL, {NULL}, 0};
struct variable no_indicator = {"no_indicator", &ecpg_no_indicator, 0, NULL};

struct ECPGtype ecpg_query = {ECPGt_char_variable, NULL, NULL, NULL, {NULL}, 0};

/*
 * Handle parsing errors and warnings
 */
void
mmerror(int error_code, enum errortype type, const char *error, ...)
{
	va_list ap;

	/* internationalize the error message string */
	error = _(error);

	fprintf(stderr, "%s:%d: ", input_filename, yylineno);

	switch(type)
	{
		case ET_WARNING:
			fprintf(stderr, _("WARNING: "));
			break;
		case ET_ERROR:
		case ET_FATAL:
			fprintf(stderr, _("ERROR: "));
			break;
	}

	va_start(ap, error);
	vfprintf(stderr, error, ap);
	va_end(ap);

	fprintf(stderr, "\n");

	switch(type)
	{
		case ET_WARNING:
			break;
		case ET_ERROR:
			ret_value = error_code;
			break;
		case ET_FATAL:
			if (yyin)
				fclose(yyin);
			if (yyout)
				fclose(yyout);
			
			if (strcmp(output_filename, "-") != 0 && unlink(output_filename) != 0)
			        fprintf(stderr, _("could not remove output file \"%s\"\n"), output_filename);
			exit(error_code);
	}
}

/*
 * string concatenation
 */

static char *
cat2_str(char *str1, char *str2)
{
	char * res_str	= (char *)mm_alloc(strlen(str1) + strlen(str2) + 2);

	strcpy(res_str, str1);
	if (strlen(str1) != 0 && strlen(str2) != 0)
		strcat(res_str, " ");
	strcat(res_str, str2);
	free(str1);
	free(str2);
	return(res_str);
}

static char *
cat_str(int count, ...)
{
	va_list		args;
	int			i;
	char		*res_str;

	va_start(args, count);

	res_str = va_arg(args, char *);

	/* now add all other strings */
	for (i = 1; i < count; i++)
		res_str = cat2_str(res_str, va_arg(args, char *));

	va_end(args);

	return(res_str);
}

char *
make_str(const char *str)
{
	char * res_str = (char *)mm_alloc(strlen(str) + 1);

	strcpy(res_str, str);
	return res_str;
}

static char *
make2_str(char *str1, char *str2)
{
	char * res_str	= (char *)mm_alloc(strlen(str1) + strlen(str2) + 1);

	strcpy(res_str, str1);
	strcat(res_str, str2);
	free(str1);
	free(str2);
	return(res_str);
}

static char *
make3_str(char *str1, char *str2, char *str3)
{
	char * res_str	= (char *)mm_alloc(strlen(str1) + strlen(str2) +strlen(str3) + 1);

	strcpy(res_str, str1);
	strcat(res_str, str2);
	strcat(res_str, str3);
	free(str1);
	free(str2);
	free(str3);
	return(res_str);
}

/* and the rest */
static char *
make_name(void)
{
	return mm_strdup(yytext);
}

static char *
create_questionmarks(char *name, bool array)
{
	struct variable *p = find_variable(name);
	int count;
	char *result = EMPTY;

	/* In case we have a struct, we have to print as many "?" as there are attributes in the struct
	 * An array is only allowed together with an element argument
	 * This is essantially only used for inserts, but using a struct as input parameter is an error anywhere else
	 * so we don't have to worry here. */

	if (p->type->type == ECPGt_struct || (array && p->type->type == ECPGt_array && p->type->u.element->type == ECPGt_struct))
	{
		struct ECPGstruct_member *m;

		if (p->type->type == ECPGt_struct)
			m = p->type->u.members;
		else
			m = p->type->u.element->u.members;

		for (count = 0; m != NULL; m=m->next, count++);
	}
	else
		count = 1;

	for (; count > 0; count --)
	{
		sprintf(pacounter_buffer, "$%d", pacounter++);
		result = cat_str(3, result, mm_strdup(pacounter_buffer), make_str(" , "));
	}

	/* removed the trailing " ," */

	result[strlen(result)-3] = '\0';
	return(result);
}

static char *
adjust_outofscope_cursor_vars(struct cursor *cur)
{
	/* Informix accepts DECLARE with variables that are out of scope when OPEN is called.
	 * For instance you can DECLARE a cursor in one function, and OPEN/FETCH/CLOSE
	 * it in other functions. This is very useful for e.g. event-driver programming,
	 * but may also lead to dangerous programming. The limitation when this is allowed
	 * and doesn's cause problems have to be documented, like the allocated variables
	 * must not be realloc()'ed.
	 *
	 * We have to change the variables to our own struct and just store the pointer
	 * instead of the variable. Do it only for local variables, not for globals.
	 */

	char *result = make_str("");
	int insert;

	for (insert = 1; insert >= 0; insert--)
	{
		struct arguments *list;
		struct arguments *ptr;
		struct arguments *newlist = NULL;
		struct variable *newvar, *newind;

		list = (insert ? cur->argsinsert : cur->argsresult);

		for (ptr = list; ptr != NULL; ptr = ptr->next)
		{
			char temp[20];
			char *original_var;
			bool skip_set_var = false;

			/* change variable name to "ECPGget_var(<counter>)" */
			original_var = ptr->variable->name;
			sprintf(temp, "%d))", ecpg_internal_var);

			/* Don't emit ECPGset_var() calls for global variables */
			if (ptr->variable->brace_level == 0)
			{
				newvar = ptr->variable;
				skip_set_var = true;
			}
			else if ((ptr->variable->type->type == ECPGt_char_variable) && (!strncmp(ptr->variable->name, "ECPGprepared_statement", strlen("ECPGprepared_statement"))))
			{
				newvar = ptr->variable;
				skip_set_var = true;
			}
			else if ((ptr->variable->type->type != ECPGt_varchar && ptr->variable->type->type != ECPGt_char && ptr->variable->type->type != ECPGt_unsigned_char && ptr->variable->type->type != ECPGt_string) && atoi(ptr->variable->type->size) > 1)
			{
				newvar = new_variable(cat_str(4, make_str("("), mm_strdup(ecpg_type_name(ptr->variable->type->u.element->type)), make_str(" *)(ECPGget_var("), mm_strdup(temp)), ECPGmake_array_type(ECPGmake_simple_type(ptr->variable->type->u.element->type, make_str("1"), ptr->variable->type->u.element->counter), ptr->variable->type->size), 0);
				sprintf(temp, "%d, (", ecpg_internal_var++);
			}
			else if ((ptr->variable->type->type == ECPGt_varchar || ptr->variable->type->type == ECPGt_char || ptr->variable->type->type == ECPGt_unsigned_char || ptr->variable->type->type == ECPGt_string) && atoi(ptr->variable->type->size) > 1)
			{
				newvar = new_variable(cat_str(4, make_str("("), mm_strdup(ecpg_type_name(ptr->variable->type->type)), make_str(" *)(ECPGget_var("), mm_strdup(temp)), ECPGmake_simple_type(ptr->variable->type->type, ptr->variable->type->size, ptr->variable->type->counter), 0);
				if (ptr->variable->type->type == ECPGt_varchar)
					sprintf(temp, "%d, &(", ecpg_internal_var++);
				else
					sprintf(temp, "%d, (", ecpg_internal_var++);
			}
			else if (ptr->variable->type->type == ECPGt_struct || ptr->variable->type->type == ECPGt_union)
			{
				sprintf(temp, "%d)))", ecpg_internal_var);
				newvar = new_variable(cat_str(4, make_str("(*("), mm_strdup(ptr->variable->type->type_name), make_str(" *)(ECPGget_var("), mm_strdup(temp)), ECPGmake_struct_type(ptr->variable->type->u.members, ptr->variable->type->type, ptr->variable->type->type_name, ptr->variable->type->struct_sizeof), 0);
				sprintf(temp, "%d, &(", ecpg_internal_var++);
			}
			else if (ptr->variable->type->type == ECPGt_array)
			{
				if (ptr->variable->type->u.element->type == ECPGt_struct || ptr->variable->type->u.element->type == ECPGt_union)
				{
					sprintf(temp, "%d)))", ecpg_internal_var);
					newvar = new_variable(cat_str(4, make_str("(*("), mm_strdup(ptr->variable->type->u.element->type_name), make_str(" *)(ECPGget_var("), mm_strdup(temp)), ECPGmake_struct_type(ptr->variable->type->u.element->u.members, ptr->variable->type->u.element->type, ptr->variable->type->u.element->type_name, ptr->variable->type->u.element->struct_sizeof), 0);
					sprintf(temp, "%d, (", ecpg_internal_var++);
				}
				else
				{
					newvar = new_variable(cat_str(4, make_str("("), mm_strdup(ecpg_type_name(ptr->variable->type->type)), make_str(" *)(ECPGget_var("), mm_strdup(temp)), ECPGmake_array_type(ECPGmake_simple_type(ptr->variable->type->u.element->type, ptr->variable->type->u.element->size, ptr->variable->type->u.element->counter), ptr->variable->type->size), 0);
					sprintf(temp, "%d, &(", ecpg_internal_var++);
				}
			}
			else
			{
				newvar = new_variable(cat_str(4, make_str("*("), mm_strdup(ecpg_type_name(ptr->variable->type->type)), make_str(" *)(ECPGget_var("), mm_strdup(temp)), ECPGmake_simple_type(ptr->variable->type->type, ptr->variable->type->size, ptr->variable->type->counter), 0);
				sprintf(temp, "%d, &(", ecpg_internal_var++);
			}

			/* create call to "ECPGset_var(<counter>, <pointer>. <line number>)" */
			if (!skip_set_var)
				result = cat_str(5, result, make_str("ECPGset_var("), mm_strdup(temp), mm_strdup(original_var), make_str("), __LINE__);\n"));

			/* now the indicator if there is one and it's not a global variable */
			if ((ptr->indicator->type->type == ECPGt_NO_INDICATOR) || (ptr->indicator->brace_level == 0))
			{
				newind = ptr->indicator;
			}
			else
			{
				/* change variable name to "ECPGget_var(<counter>)" */
				original_var = ptr->indicator->name;
				sprintf(temp, "%d))", ecpg_internal_var);

				if (ptr->indicator->type->type == ECPGt_struct || ptr->indicator->type->type == ECPGt_union)
				{
					sprintf(temp, "%d)))", ecpg_internal_var);
					newind = new_variable(cat_str(4, make_str("(*("), mm_strdup(ptr->indicator->type->type_name), make_str(" *)(ECPGget_var("), mm_strdup(temp)), ECPGmake_struct_type(ptr->indicator->type->u.members, ptr->indicator->type->type, ptr->indicator->type->type_name, ptr->indicator->type->struct_sizeof), 0);
					sprintf(temp, "%d, &(", ecpg_internal_var++);
				}
				else if (ptr->indicator->type->type == ECPGt_array)
				{
					if (ptr->indicator->type->u.element->type == ECPGt_struct || ptr->indicator->type->u.element->type == ECPGt_union)
					{
						sprintf(temp, "%d)))", ecpg_internal_var);
						newind = new_variable(cat_str(4, make_str("(*("), mm_strdup(ptr->indicator->type->u.element->type_name), make_str(" *)(ECPGget_var("), mm_strdup(temp)), ECPGmake_struct_type(ptr->indicator->type->u.element->u.members, ptr->indicator->type->u.element->type, ptr->indicator->type->u.element->type_name, ptr->indicator->type->u.element->struct_sizeof), 0);
						sprintf(temp, "%d, (", ecpg_internal_var++);
					}
					else
					{
						newind = new_variable(cat_str(4, make_str("("), mm_strdup(ecpg_type_name(ptr->indicator->type->u.element->type)), make_str(" *)(ECPGget_var("), mm_strdup(temp)), ECPGmake_array_type(ECPGmake_simple_type(ptr->indicator->type->u.element->type, ptr->indicator->type->u.element->size, ptr->indicator->type->u.element->counter), ptr->indicator->type->size), 0);
						sprintf(temp, "%d, &(", ecpg_internal_var++);
					}
				}
				else if (atoi(ptr->indicator->type->size) > 1)
				{
					newind = new_variable(cat_str(4, make_str("("), mm_strdup(ecpg_type_name(ptr->indicator->type->type)), make_str(" *)(ECPGget_var("), mm_strdup(temp)), ECPGmake_simple_type(ptr->indicator->type->type, ptr->indicator->type->size, ptr->variable->type->counter), 0);
					sprintf(temp, "%d, (", ecpg_internal_var++);
				}
				else
				{
					newind = new_variable(cat_str(4, make_str("*("), mm_strdup(ecpg_type_name(ptr->indicator->type->type)), make_str(" *)(ECPGget_var("), mm_strdup(temp)), ECPGmake_simple_type(ptr->indicator->type->type, ptr->indicator->type->size, ptr->variable->type->counter), 0);
					sprintf(temp, "%d, &(", ecpg_internal_var++);
				}

				/* create call to "ECPGset_var(<counter>, <pointer>. <line number>)" */
				result = cat_str(5, result, make_str("ECPGset_var("), mm_strdup(temp), mm_strdup(original_var), make_str("), __LINE__);\n"));
			}

			add_variable_to_tail(&newlist, newvar, newind);
		}

		if (insert)
			cur->argsinsert_oos = newlist;
		else
			cur->argsresult_oos = newlist;
	}

	return result;
}

/* This tests whether the cursor was declared and opened in the same function. */
#define SAMEFUNC(cur)	\
	((cur->function == NULL) ||		\
	 (cur->function != NULL && !strcmp(cur->function, current_function)))

static struct cursor *
add_additional_variables(char *name, bool insert)
{
	struct cursor *ptr;
	struct arguments *p;

	for (ptr = cur; ptr != NULL; ptr=ptr->next)
	{
		if (strcmp(ptr->name, name) == 0)
			break;
	}

	if (ptr == NULL)
	{
		mmerror(PARSE_ERROR, ET_ERROR, "cursor \"%s\" does not exist", name);
		return NULL;
	}

	if (insert)
	{
		/* add all those input variables that were given earlier
		 * note that we have to append here but have to keep the existing order */
		for (p = (SAMEFUNC(ptr) ? ptr->argsinsert : ptr->argsinsert_oos); p; p = p->next)
			add_variable_to_tail(&argsinsert, p->variable, p->indicator);
	}

	/* add all those output variables that were given earlier */
	for (p = (SAMEFUNC(ptr) ? ptr->argsresult : ptr->argsresult_oos); p; p = p->next)
		add_variable_to_tail(&argsresult, p->variable, p->indicator);

	return ptr;
}

static void
add_typedef(char *name, char * dimension, char * length, enum ECPGttype type_enum, char *type_dimension, char *type_index, int initializer, int array)
{
	/* add entry to list */
	struct typedefs *ptr, *this;

	if ((type_enum == ECPGt_struct ||
	     type_enum == ECPGt_union) &&
	    initializer == 1)
		mmerror(PARSE_ERROR, ET_ERROR, "initializer not allowed in type definition");
	else if (INFORMIX_MODE && strcmp(name, "string") == 0)
		mmerror(PARSE_ERROR, ET_ERROR, "type name \"string\" is reserved in Informix mode");
	else
	{
		for (ptr = types; ptr != NULL; ptr = ptr->next)
		{
			if (strcmp(name, ptr->name) == 0)
				/* re-definition is a bug */
				mmerror(PARSE_ERROR, ET_ERROR, "type \"%s\" is already defined", name);
		}
		adjust_array(type_enum, &dimension, &length, type_dimension, type_index, array, true);

		this = (struct typedefs *) mm_alloc(sizeof(struct typedefs));

		/* initial definition */
		this->next = types;
		this->name = name;
		this->brace_level = braces_open;
		this->type = (struct this_type *) mm_alloc(sizeof(struct this_type));
		this->type->type_enum = type_enum;
		this->type->type_str = mm_strdup(name);
		this->type->type_dimension = dimension; /* dimension of array */
		this->type->type_index = length;	/* length of string */
		this->type->type_sizeof = ECPGstruct_sizeof;
		this->struct_member_list = (type_enum == ECPGt_struct || type_enum == ECPGt_union) ?
		ECPGstruct_member_dup(struct_member_list[struct_level]) : NULL;

		if (type_enum != ECPGt_varchar &&
			type_enum != ECPGt_char &&
			type_enum != ECPGt_unsigned_char &&
			type_enum != ECPGt_string &&
			atoi(this->type->type_index) >= 0)
			mmerror(PARSE_ERROR, ET_ERROR, "multidimensional arrays for simple data types are not supported");

		types = this;
	}
}


/* Line 189 of yacc.c  */
#line 544 "preproc.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     SQL_ALLOCATE = 258,
     SQL_AUTOCOMMIT = 259,
     SQL_BOOL = 260,
     SQL_BREAK = 261,
     SQL_CALL = 262,
     SQL_CARDINALITY = 263,
     SQL_CONNECT = 264,
     SQL_COUNT = 265,
     SQL_DATETIME_INTERVAL_CODE = 266,
     SQL_DATETIME_INTERVAL_PRECISION = 267,
     SQL_DESCRIBE = 268,
     SQL_DESCRIPTOR = 269,
     SQL_DISCONNECT = 270,
     SQL_FOUND = 271,
     SQL_FREE = 272,
     SQL_GET = 273,
     SQL_GO = 274,
     SQL_GOTO = 275,
     SQL_IDENTIFIED = 276,
     SQL_INDICATOR = 277,
     SQL_KEY_MEMBER = 278,
     SQL_LENGTH = 279,
     SQL_LONG = 280,
     SQL_NULLABLE = 281,
     SQL_OCTET_LENGTH = 282,
     SQL_OPEN = 283,
     SQL_OUTPUT = 284,
     SQL_REFERENCE = 285,
     SQL_RETURNED_LENGTH = 286,
     SQL_RETURNED_OCTET_LENGTH = 287,
     SQL_SCALE = 288,
     SQL_SECTION = 289,
     SQL_SHORT = 290,
     SQL_SIGNED = 291,
     SQL_SQL = 292,
     SQL_SQLERROR = 293,
     SQL_SQLPRINT = 294,
     SQL_SQLWARNING = 295,
     SQL_START = 296,
     SQL_STOP = 297,
     SQL_STRUCT = 298,
     SQL_UNSIGNED = 299,
     SQL_VAR = 300,
     SQL_WHENEVER = 301,
     S_ADD = 302,
     S_AND = 303,
     S_ANYTHING = 304,
     S_AUTO = 305,
     S_CONST = 306,
     S_DEC = 307,
     S_DIV = 308,
     S_DOTPOINT = 309,
     S_EQUAL = 310,
     S_EXTERN = 311,
     S_INC = 312,
     S_LSHIFT = 313,
     S_MEMPOINT = 314,
     S_MEMBER = 315,
     S_MOD = 316,
     S_MUL = 317,
     S_NEQUAL = 318,
     S_OR = 319,
     S_REGISTER = 320,
     S_RSHIFT = 321,
     S_STATIC = 322,
     S_SUB = 323,
     S_VOLATILE = 324,
     S_TYPEDEF = 325,
     CSTRING = 326,
     CVARIABLE = 327,
     CPP_LINE = 328,
     IP = 329,
     DOLCONST = 330,
     ECONST = 331,
     NCONST = 332,
     UCONST = 333,
     UIDENT = 334,
     IDENT = 335,
     FCONST = 336,
     SCONST = 337,
     BCONST = 338,
     XCONST = 339,
     Op = 340,
     ICONST = 341,
     PARAM = 342,
     TYPECAST = 343,
     DOT_DOT = 344,
     COLON_EQUALS = 345,
     ABORT_P = 346,
     ABSOLUTE_P = 347,
     ACCESS = 348,
     ACTION = 349,
     ADD_P = 350,
     ADMIN = 351,
     AFTER = 352,
     AGGREGATE = 353,
     ALL = 354,
     ALSO = 355,
     ALTER = 356,
     ALWAYS = 357,
     ANALYSE = 358,
     ANALYZE = 359,
     AND = 360,
     ANY = 361,
     ARRAY = 362,
     AS = 363,
     ASC = 364,
     ASSERTION = 365,
     ASSIGNMENT = 366,
     ASYMMETRIC = 367,
     AT = 368,
     AUTHORIZATION = 369,
     BACKWARD = 370,
     BEFORE = 371,
     BEGIN_P = 372,
     BETWEEN = 373,
     BIGINT = 374,
     BINARY = 375,
     BIT = 376,
     BOOLEAN_P = 377,
     BOTH = 378,
     BY = 379,
     CACHE = 380,
     CALLED = 381,
     CASCADE = 382,
     CASCADED = 383,
     CASE = 384,
     CAST = 385,
     CATALOG_P = 386,
     CHAIN = 387,
     CHAR_P = 388,
     CHARACTER = 389,
     CHARACTERISTICS = 390,
     CHECK = 391,
     CHECKPOINT = 392,
     CLASS = 393,
     CLOSE = 394,
     CLUSTER = 395,
     COALESCE = 396,
     COLLATE = 397,
     COLUMN = 398,
     COMMENT = 399,
     COMMENTS = 400,
     COMMIT = 401,
     COMMITTED = 402,
     CONCURRENTLY = 403,
     CONFIGURATION = 404,
     CONNECTION = 405,
     CONSTRAINT = 406,
     CONSTRAINTS = 407,
     CONTENT_P = 408,
     CONTINUE_P = 409,
     CONVERSION_P = 410,
     COPY = 411,
     COST = 412,
     CREATE = 413,
     CREATEDB = 414,
     CREATEROLE = 415,
     CREATEUSER = 416,
     CROSS = 417,
     CSV = 418,
     CURRENT_P = 419,
     CURRENT_CATALOG = 420,
     CURRENT_DATE = 421,
     CURRENT_ROLE = 422,
     CURRENT_SCHEMA = 423,
     CURRENT_TIME = 424,
     CURRENT_TIMESTAMP = 425,
     CURRENT_USER = 426,
     CURSOR = 427,
     CYCLE = 428,
     DATA_P = 429,
     DATABASE = 430,
     DAY_P = 431,
     DEALLOCATE = 432,
     DEC = 433,
     DECIMAL_P = 434,
     DECLARE = 435,
     DEFAULT = 436,
     DEFAULTS = 437,
     DEFERRABLE = 438,
     DEFERRED = 439,
     DEFINER = 440,
     DELETE_P = 441,
     DELIMITER = 442,
     DELIMITERS = 443,
     DESC = 444,
     DICTIONARY = 445,
     DISABLE_P = 446,
     DISCARD = 447,
     DISTINCT = 448,
     DO = 449,
     DOCUMENT_P = 450,
     DOMAIN_P = 451,
     DOUBLE_P = 452,
     DROP = 453,
     EACH = 454,
     ELSE = 455,
     ENABLE_P = 456,
     ENCODING = 457,
     ENCRYPTED = 458,
     END_P = 459,
     ENUM_P = 460,
     ESCAPE = 461,
     EXCEPT = 462,
     EXCLUDE = 463,
     EXCLUDING = 464,
     EXCLUSIVE = 465,
     EXECUTE = 466,
     EXISTS = 467,
     EXPLAIN = 468,
     EXTERNAL = 469,
     EXTRACT = 470,
     FALSE_P = 471,
     FAMILY = 472,
     FETCH = 473,
     FIRST_P = 474,
     FLOAT_P = 475,
     FOLLOWING = 476,
     FOR = 477,
     FORCE = 478,
     FOREIGN = 479,
     FORWARD = 480,
     FREEZE = 481,
     FROM = 482,
     FULL = 483,
     FUNCTION = 484,
     FUNCTIONS = 485,
     GLOBAL = 486,
     GRANT = 487,
     GRANTED = 488,
     GREATEST = 489,
     GROUP_P = 490,
     HANDLER = 491,
     HAVING = 492,
     HEADER_P = 493,
     HOLD = 494,
     HOUR_P = 495,
     IDENTITY_P = 496,
     IF_P = 497,
     ILIKE = 498,
     IMMEDIATE = 499,
     IMMUTABLE = 500,
     IMPLICIT_P = 501,
     IN_P = 502,
     INCLUDING = 503,
     INCREMENT = 504,
     INDEX = 505,
     INDEXES = 506,
     INHERIT = 507,
     INHERITS = 508,
     INITIALLY = 509,
     INLINE_P = 510,
     INNER_P = 511,
     INOUT = 512,
     INPUT_P = 513,
     INSENSITIVE = 514,
     INSERT = 515,
     INSTEAD = 516,
     INT_P = 517,
     INTEGER = 518,
     INTERSECT = 519,
     INTERVAL = 520,
     INTO = 521,
     INVOKER = 522,
     IS = 523,
     ISNULL = 524,
     ISOLATION = 525,
     JOIN = 526,
     KEY = 527,
     LANGUAGE = 528,
     LARGE_P = 529,
     LAST_P = 530,
     LC_COLLATE_P = 531,
     LC_CTYPE_P = 532,
     LEADING = 533,
     LEAST = 534,
     LEFT = 535,
     LEVEL = 536,
     LIKE = 537,
     LIMIT = 538,
     LISTEN = 539,
     LOAD = 540,
     LOCAL = 541,
     LOCALTIME = 542,
     LOCALTIMESTAMP = 543,
     LOCATION = 544,
     LOCK_P = 545,
     LOGIN_P = 546,
     MAPPING = 547,
     MATCH = 548,
     MAXVALUE = 549,
     MINUTE_P = 550,
     MINVALUE = 551,
     MODE = 552,
     MONTH_P = 553,
     MOVE = 554,
     NAME_P = 555,
     NAMES = 556,
     NATIONAL = 557,
     NATURAL = 558,
     NCHAR = 559,
     NEXT = 560,
     NO = 561,
     NOCREATEDB = 562,
     NOCREATEROLE = 563,
     NOCREATEUSER = 564,
     NOINHERIT = 565,
     NOLOGIN_P = 566,
     NONE = 567,
     NOSUPERUSER = 568,
     NOT = 569,
     NOTHING = 570,
     NOTIFY = 571,
     NOTNULL = 572,
     NOWAIT = 573,
     NULL_P = 574,
     NULLIF = 575,
     NULLS_P = 576,
     NUMERIC = 577,
     OBJECT_P = 578,
     OF = 579,
     OFF = 580,
     OFFSET = 581,
     OIDS = 582,
     ON = 583,
     ONLY = 584,
     OPERATOR = 585,
     OPTION = 586,
     OPTIONS = 587,
     OR = 588,
     ORDER = 589,
     OUT_P = 590,
     OUTER_P = 591,
     OVER = 592,
     OVERLAPS = 593,
     OVERLAY = 594,
     OWNED = 595,
     OWNER = 596,
     PARSER = 597,
     PARTIAL = 598,
     PARTITION = 599,
     PASSWORD = 600,
     PLACING = 601,
     PLANS = 602,
     POSITION = 603,
     PRECEDING = 604,
     PRECISION = 605,
     PRESERVE = 606,
     PREPARE = 607,
     PREPARED = 608,
     PRIMARY = 609,
     PRIOR = 610,
     PRIVILEGES = 611,
     PROCEDURAL = 612,
     PROCEDURE = 613,
     QUOTE = 614,
     RANGE = 615,
     READ = 616,
     REAL = 617,
     REASSIGN = 618,
     RECHECK = 619,
     RECURSIVE = 620,
     REFERENCES = 621,
     REINDEX = 622,
     RELATIVE_P = 623,
     RELEASE = 624,
     RENAME = 625,
     REPEATABLE = 626,
     REPLACE = 627,
     REPLICA = 628,
     RESET = 629,
     RESTART = 630,
     RESTRICT = 631,
     RETURNING = 632,
     RETURNS = 633,
     REVOKE = 634,
     RIGHT = 635,
     ROLE = 636,
     ROLLBACK = 637,
     ROW = 638,
     ROWS = 639,
     RULE = 640,
     SAVEPOINT = 641,
     SCHEMA = 642,
     SCROLL = 643,
     SEARCH = 644,
     SECOND_P = 645,
     SECURITY = 646,
     SELECT = 647,
     SEQUENCE = 648,
     SEQUENCES = 649,
     SERIALIZABLE = 650,
     SERVER = 651,
     SESSION = 652,
     SESSION_USER = 653,
     SET = 654,
     SETOF = 655,
     SHARE = 656,
     SHOW = 657,
     SIMILAR = 658,
     SIMPLE = 659,
     SMALLINT = 660,
     SOME = 661,
     STABLE = 662,
     STANDALONE_P = 663,
     START = 664,
     STATEMENT = 665,
     STATISTICS = 666,
     STDIN = 667,
     STDOUT = 668,
     STORAGE = 669,
     STRICT_P = 670,
     STRIP_P = 671,
     SUBSTRING = 672,
     SUPERUSER_P = 673,
     SYMMETRIC = 674,
     SYSID = 675,
     SYSTEM_P = 676,
     TABLE = 677,
     TABLES = 678,
     TABLESPACE = 679,
     TEMP = 680,
     TEMPLATE = 681,
     TEMPORARY = 682,
     TEXT_P = 683,
     THEN = 684,
     TIME = 685,
     TIMESTAMP = 686,
     TO = 687,
     TRAILING = 688,
     TRANSACTION = 689,
     TREAT = 690,
     TRIGGER = 691,
     TRIM = 692,
     TRUE_P = 693,
     TRUNCATE = 694,
     TRUSTED = 695,
     TYPE_P = 696,
     UNBOUNDED = 697,
     UNCOMMITTED = 698,
     UNENCRYPTED = 699,
     UNION = 700,
     UNIQUE = 701,
     UNKNOWN = 702,
     UNLISTEN = 703,
     UNTIL = 704,
     UPDATE = 705,
     USER = 706,
     USING = 707,
     VACUUM = 708,
     VALID = 709,
     VALIDATOR = 710,
     VALUE_P = 711,
     VALUES = 712,
     VARCHAR = 713,
     VARIADIC = 714,
     VARYING = 715,
     VERBOSE = 716,
     VERSION_P = 717,
     VIEW = 718,
     VOLATILE = 719,
     WHEN = 720,
     WHERE = 721,
     WHITESPACE_P = 722,
     WINDOW = 723,
     WITH = 724,
     WITHOUT = 725,
     WORK = 726,
     WRAPPER = 727,
     WRITE = 728,
     XML_P = 729,
     XMLATTRIBUTES = 730,
     XMLCONCAT = 731,
     XMLELEMENT = 732,
     XMLFOREST = 733,
     XMLPARSE = 734,
     XMLPI = 735,
     XMLROOT = 736,
     XMLSERIALIZE = 737,
     YEAR_P = 738,
     YES_P = 739,
     ZONE = 740,
     NULLS_FIRST = 741,
     NULLS_LAST = 742,
     WITH_TIME = 743,
     POSTFIXOP = 744,
     UMINUS = 745
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 471 "preproc.y"

	double	dval;
	char	*str;
	int     ival;
	struct	when		action;
	struct	index		index;
	int		tagname;
	struct	this_type	type;
	enum	ECPGttype	type_enum;
	enum	ECPGdtype	dtype_enum;
	struct	fetch_desc	descriptor;
	struct  su_symbol	struct_union;
	struct	prep		prep;



/* Line 214 of yacc.c  */
#line 1087 "preproc.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 1112 "preproc.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   93686

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  510
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  657
/* YYNRULES -- Number of rules.  */
#define YYNRULES  2561
/* YYNRULES -- Number of states.  */
#define YYNSTATES  4489

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   745

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   497,     2,     2,
     502,   503,   495,   493,   505,   494,   504,   496,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   507,   506,
     490,   489,   491,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   500,     2,   501,   498,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   508,     2,   509,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   492,   499
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     7,     9,    11,    13,    15,    17,
      19,    21,    23,    25,    27,    29,    31,    33,    35,    37,
      39,    41,    43,    45,    47,    49,    51,    53,    55,    57,
      59,    61,    63,    65,    67,    69,    71,    73,    75,    77,
      79,    81,    83,    85,    87,    89,    91,    93,    95,    97,
      99,   101,   103,   105,   107,   109,   111,   113,   115,   117,
     119,   121,   123,   125,   127,   129,   131,   133,   135,   137,
     139,   141,   143,   145,   147,   149,   151,   153,   155,   157,
     159,   161,   163,   165,   167,   169,   171,   173,   175,   177,
     179,   181,   183,   185,   187,   189,   191,   193,   195,   197,
     199,   201,   203,   205,   207,   209,   211,   213,   215,   217,
     219,   221,   223,   225,   227,   229,   231,   233,   235,   237,
     239,   241,   243,   245,   247,   248,   254,   256,   257,   260,
     261,   264,   265,   268,   271,   275,   279,   281,   283,   285,
     287,   289,   291,   293,   295,   297,   299,   301,   303,   307,
     311,   314,   316,   319,   322,   325,   329,   333,   339,   345,
     346,   350,   356,   362,   367,   371,   377,   381,   387,   393,
     400,   402,   404,   408,   414,   421,   426,   428,   429,   432,
     433,   435,   437,   439,   441,   443,   445,   448,   452,   456,
     460,   464,   468,   472,   476,   480,   483,   489,   492,   495,
     498,   501,   505,   509,   513,   515,   519,   521,   525,   527,
     529,   532,   535,   538,   540,   542,   544,   546,   548,   550,
     552,   556,   563,   565,   567,   569,   571,   573,   574,   576,
     578,   581,   585,   590,   594,   597,   600,   602,   606,   611,
     617,   622,   625,   630,   632,   634,   636,   638,   640,   643,
     646,   649,   652,   657,   662,   667,   672,   674,   678,   681,
     685,   690,   697,   704,   711,   717,   723,   730,   737,   742,
     750,   753,   760,   765,   769,   773,   777,   781,   785,   790,
     795,   799,   803,   807,   811,   815,   819,   824,   829,   833,
     836,   840,   844,   848,   851,   854,   858,   861,   863,   865,
     866,   869,   870,   874,   877,   878,   880,   884,   888,   890,
     896,   900,   903,   906,   917,   924,   926,   928,   930,   932,
     934,   936,   940,   943,   944,   946,   948,   952,   956,   958,
     960,   964,   968,   972,   976,   981,   983,   984,   987,   988,
     992,   993,   995,   996,   998,  1002,  1005,  1007,  1009,  1011,
    1015,  1016,  1018,  1022,  1024,  1036,  1047,  1049,  1051,  1054,
    1057,  1060,  1063,  1064,  1066,  1067,  1071,  1072,  1074,  1078,
    1080,  1084,  1086,  1088,  1090,  1092,  1094,  1098,  1103,  1106,
    1107,  1111,  1113,  1115,  1118,  1120,  1124,  1129,  1134,  1137,
    1143,  1145,  1148,  1151,  1154,  1158,  1162,  1166,  1167,  1169,
    1171,  1173,  1175,  1177,  1179,  1183,  1185,  1191,  1199,  1208,
    1218,  1230,  1234,  1235,  1237,  1241,  1243,  1246,  1249,  1252,
    1253,  1255,  1259,  1263,  1270,  1275,  1276,  1278,  1280,  1283,
    1286,  1287,  1291,  1295,  1298,  1300,  1302,  1305,  1308,  1313,
    1314,  1317,  1320,  1323,  1324,  1328,  1333,  1338,  1339,  1342,
    1343,  1348,  1349,  1355,  1359,  1360,  1362,  1366,  1368,  1371,
    1375,  1376,  1382,  1387,  1389,  1390,  1392,  1395,  1398,  1400,
    1403,  1407,  1410,  1413,  1416,  1419,  1423,  1427,  1429,  1433,
    1435,  1436,  1438,  1441,  1443,  1445,  1449,  1456,  1467,  1469,
    1470,  1472,  1475,  1478,  1479,  1482,  1485,  1487,  1488,  1494,
    1502,  1504,  1505,  1512,  1515,  1516,  1520,  1526,  1534,  1541,
    1550,  1558,  1565,  1572,  1577,  1578,  1580,  1584,  1589,  1591,
    1595,  1597,  1600,  1603,  1606,  1609,  1611,  1613,  1624,  1627,
    1628,  1631,  1634,  1636,  1637,  1642,  1649,  1655,  1660,  1665,
    1674,  1676,  1678,  1680,  1688,  1698,  1707,  1723,  1744,  1746,
    1748,  1750,  1754,  1756,  1758,  1760,  1764,  1766,  1770,  1771,
    1773,  1774,  1776,  1778,  1783,  1784,  1786,  1790,  1791,  1793,
    1795,  1797,  1799,  1801,  1803,  1806,  1807,  1809,  1812,  1814,
    1817,  1818,  1821,  1823,  1826,  1829,  1836,  1845,  1854,  1859,
    1865,  1870,  1875,  1880,  1884,  1892,  1901,  1908,  1915,  1922,
    1929,  1933,  1935,  1939,  1943,  1945,  1947,  1949,  1951,  1953,
    1955,  1959,  1963,  1967,  1969,  1973,  1977,  1979,  1980,  1982,
    1986,  2000,  2002,  2006,  2011,  2017,  2022,  2030,  2033,  2035,
    2036,  2039,  2040,  2042,  2043,  2050,  2059,  2068,  2070,  2074,
    2080,  2086,  2094,  2104,  2112,  2122,  2128,  2135,  2142,  2147,
    2149,  2151,  2153,  2155,  2157,  2159,  2161,  2163,  2167,  2171,
    2175,  2179,  2181,  2185,  2187,  2190,  2193,  2197,  2203,  2206,
    2209,  2210,  2217,  2225,  2233,  2241,  2250,  2259,  2266,  2275,
    2285,  2295,  2303,  2314,  2322,  2331,  2340,  2349,  2358,  2360,
    2362,  2364,  2366,  2368,  2370,  2372,  2374,  2376,  2378,  2380,
    2382,  2384,  2386,  2389,  2392,  2396,  2401,  2407,  2412,  2418,
    2422,  2427,  2431,  2436,  2438,  2441,  2445,  2449,  2453,  2457,
    2462,  2467,  2471,  2475,  2480,  2485,  2490,  2495,  2497,  2499,
    2501,  2502,  2510,  2518,  2529,  2531,  2533,  2536,  2541,  2547,
    2549,  2553,  2556,  2559,  2562,  2565,  2567,  2570,  2573,  2578,
    2582,  2585,  2588,  2591,  2595,  2598,  2601,  2607,  2613,  2619,
    2621,  2625,  2627,  2630,  2634,  2635,  2637,  2641,  2644,  2651,
    2658,  2668,  2672,  2673,  2677,  2678,  2684,  2687,  2688,  2692,
    2696,  2700,  2708,  2716,  2727,  2729,  2731,  2733,  2748,  2750,
    2751,  2753,  2754,  2756,  2757,  2760,  2761,  2763,  2767,  2772,
    2777,  2784,  2786,  2789,  2790,  2792,  2794,  2795,  2797,  2799,
    2800,  2810,  2823,  2831,  2834,  2835,  2839,  2842,  2844,  2848,
    2852,  2855,  2857,  2861,  2865,  2869,  2872,  2875,  2877,  2879,
    2881,  2883,  2886,  2888,  2890,  2892,  2894,  2899,  2905,  2907,
    2911,  2915,  2917,  2920,  2925,  2931,  2933,  2935,  2937,  2939,
    2943,  2947,  2950,  2953,  2956,  2959,  2961,  2964,  2967,  2969,
    2971,  2973,  2977,  2980,  2981,  2984,  2986,  2990,  2996,  2998,
    3001,  3003,  3004,  3010,  3018,  3024,  3032,  3038,  3046,  3050,
    3056,  3062,  3068,  3070,  3074,  3077,  3079,  3082,  3084,  3087,
    3099,  3110,  3121,  3124,  3127,  3128,  3138,  3141,  3142,  3147,
    3152,  3157,  3159,  3161,  3163,  3164,  3172,  3179,  3186,  3193,
    3200,  3208,  3218,  3228,  3235,  3242,  3249,  3256,  3263,  3272,
    3281,  3288,  3295,  3302,  3308,  3314,  3323,  3332,  3341,  3350,
    3357,  3359,  3360,  3363,  3364,  3372,  3379,  3386,  3393,  3400,
    3407,  3414,  3422,  3429,  3436,  3443,  3450,  3458,  3466,  3474,
    3484,  3494,  3501,  3508,  3515,  3524,  3533,  3542,  3549,  3563,
    3565,  3567,  3571,  3575,  3577,  3579,  3581,  3583,  3585,  3587,
    3589,  3590,  3592,  3594,  3596,  3598,  3600,  3602,  3603,  3610,
    3619,  3623,  3626,  3627,  3630,  3633,  3636,  3639,  3643,  3647,
    3650,  3653,  3656,  3659,  3663,  3666,  3672,  3677,  3681,  3685,
    3689,  3691,  3693,  3694,  3698,  3701,  3704,  3706,  3710,  3713,
    3715,  3716,  3725,  3736,  3740,  3745,  3750,  3751,  3754,  3760,
    3763,  3764,  3768,  3772,  3776,  3780,  3784,  3788,  3792,  3796,
    3800,  3804,  3808,  3812,  3816,  3821,  3825,  3829,  3831,  3832,
    3838,  3845,  3850,  3853,  3854,  3859,  3863,  3869,  3876,  3881,
    3888,  3895,  3901,  3909,  3911,  3912,  3919,  3931,  3943,  3955,
    3969,  3979,  3991,  4002,  4007,  4010,  4016,  4019,  4020,  4025,
    4031,  4037,  4042,  4049,  4051,  4055,  4057,  4059,  4061,  4063,
    4066,  4071,  4073,  4075,  4077,  4078,  4080,  4081,  4083,  4084,
    4088,  4089,  4092,  4097,  4101,  4107,  4109,  4111,  4113,  4115,
    4117,  4119,  4121,  4123,  4127,  4130,  4132,  4134,  4136,  4138,
    4140,  4141,  4147,  4152,  4156,  4157,  4159,  4161,  4163,  4165,
    4170,  4179,  4183,  4184,  4190,  4192,  4197,  4200,  4202,  4206,
    4209,  4213,  4214,  4221,  4224,  4225,  4231,  4235,  4236,  4239,
    4242,  4245,  4249,  4251,  4255,  4257,  4260,  4262,  4263,  4271,
    4273,  4277,  4279,  4281,  4285,  4291,  4294,  4296,  4300,  4308,
    4310,  4312,  4313,  4317,  4320,  4323,  4326,  4327,  4330,  4333,
    4335,  4337,  4341,  4345,  4347,  4350,  4355,  4360,  4363,  4367,
    4373,  4379,  4381,  4383,  4393,  4395,  4398,  4403,  4408,  4413,
    4416,  4420,  4422,  4426,  4431,  4434,  4436,  4437,  4441,  4445,
    4450,  4455,  4460,  4465,  4468,  4470,  4472,  4473,  4475,  4477,
    4478,  4480,  4486,  4488,  4489,  4491,  4492,  4496,  4498,  4502,
    4507,  4511,  4514,  4517,  4519,  4521,  4523,  4524,  4527,  4532,
    4538,  4541,  4545,  4547,  4549,  4551,  4553,  4557,  4558,  4560,
    4562,  4564,  4566,  4568,  4572,  4573,  4576,  4577,  4579,  4583,
    4585,  4586,  4588,  4591,  4596,  4601,  4604,  4605,  4608,  4612,
    4615,  4616,  4618,  4622,  4624,  4627,  4629,  4632,  4638,  4645,
    4651,  4653,  4656,  4658,  4663,  4667,  4672,  4678,  4683,  4689,
    4694,  4700,  4703,  4708,  4710,  4713,  4716,  4719,  4721,  4723,
    4724,  4729,  4732,  4734,  4737,  4740,  4745,  4747,  4751,  4753,
    4756,  4760,  4762,  4765,  4766,  4769,  4774,  4775,  4777,  4781,
    4784,  4787,  4791,  4797,  4804,  4807,  4811,  4815,  4820,  4821,
    4823,  4825,  4827,  4829,  4831,  4834,  4840,  4842,  4844,  4846,
    4848,  4851,  4855,  4859,  4860,  4862,  4864,  4866,  4868,  4870,
    4873,  4876,  4879,  4882,  4885,  4887,  4891,  4892,  4894,  4896,
    4898,  4900,  4906,  4909,  4911,  4913,  4915,  4917,  4923,  4926,
    4929,  4932,  4934,  4938,  4942,  4945,  4947,  4948,  4952,  4953,
    4959,  4962,  4968,  4971,  4973,  4976,  4980,  4981,  4983,  4985,
    4987,  4989,  4991,  4993,  4997,  5001,  5005,  5009,  5013,  5017,
    5021,  5022,  5024,  5029,  5031,  5035,  5041,  5044,  5047,  5051,
    5055,  5059,  5063,  5067,  5071,  5075,  5079,  5083,  5087,  5090,
    5093,  5097,  5101,  5104,  5108,  5114,  5119,  5126,  5130,  5136,
    5141,  5148,  5153,  5160,  5166,  5174,  5178,  5181,  5186,  5189,
    5193,  5197,  5202,  5206,  5211,  5215,  5220,  5226,  5233,  5240,
    5248,  5255,  5263,  5270,  5278,  5282,  5287,  5292,  5299,  5302,
    5306,  5311,  5313,  5317,  5320,  5323,  5327,  5331,  5335,  5339,
    5343,  5347,  5351,  5355,  5359,  5363,  5366,  5369,  5375,  5382,
    5389,  5397,  5401,  5406,  5408,  5410,  5413,  5418,  5420,  5422,
    5424,  5427,  5430,  5433,  5435,  5440,  5446,  5453,  5462,  5469,
    5477,  5485,  5491,  5493,  5495,  5500,  5502,  5507,  5509,  5514,
    5516,  5521,  5523,  5525,  5527,  5529,  5531,  5533,  5540,  5545,
    5550,  5555,  5560,  5567,  5573,  5579,  5585,  5590,  5597,  5602,
    5607,  5612,  5617,  5623,  5631,  5639,  5649,  5654,  5661,  5667,
    5675,  5683,  5691,  5694,  5698,  5702,  5706,  5711,  5712,  5717,
    5719,  5723,  5727,  5729,  5731,  5733,  5736,  5739,  5740,  5743,
    5744,  5746,  5750,  5754,  5757,  5760,  5761,  5768,  5770,  5771,
    5775,  5776,  5779,  5782,  5783,  5785,  5790,  5793,  5796,  5799,
    5802,  5805,  5810,  5814,  5820,  5822,  5824,  5826,  5828,  5830,
    5832,  5834,  5836,  5838,  5840,  5842,  5844,  5846,  5848,  5850,
    5855,  5857,  5862,  5864,  5869,  5871,  5874,  5876,  5879,  5881,
    5885,  5887,  5891,  5893,  5897,  5899,  5903,  5907,  5911,  5914,
    5916,  5920,  5924,  5925,  5927,  5929,  5931,  5933,  5935,  5937,
    5939,  5941,  5946,  5950,  5953,  5957,  5958,  5962,  5966,  5969,
    5972,  5974,  5975,  5978,  5981,  5985,  5988,  5990,  5992,  5996,
    6002,  6004,  6007,  6012,  6015,  6016,  6018,  6019,  6021,  6024,
    6027,  6030,  6034,  6040,  6042,  6045,  6046,  6049,  6051,  6052,
    6054,  6056,  6058,  6062,  6066,  6068,  6072,  6076,  6079,  6081,
    6083,  6085,  6089,  6091,  6094,  6096,  6100,  6102,  6104,  6106,
    6108,  6110,  6112,  6114,  6117,  6119,  6121,  6123,  6125,  6127,
    6130,  6136,  6139,  6143,  6150,  6152,  6154,  6156,  6158,  6160,
    6162,  6164,  6166,  6168,  6171,  6174,  6176,  6178,  6180,  6182,
    6184,  6186,  6188,  6190,  6192,  6194,  6196,  6198,  6200,  6202,
    6204,  6206,  6208,  6210,  6212,  6214,  6216,  6218,  6220,  6222,
    6224,  6226,  6228,  6230,  6232,  6234,  6236,  6238,  6240,  6242,
    6244,  6246,  6248,  6250,  6252,  6254,  6256,  6258,  6260,  6262,
    6264,  6266,  6268,  6270,  6272,  6274,  6276,  6278,  6280,  6282,
    6284,  6286,  6288,  6290,  6292,  6294,  6296,  6298,  6300,  6302,
    6304,  6306,  6308,  6310,  6312,  6314,  6316,  6318,  6320,  6322,
    6324,  6326,  6328,  6330,  6332,  6334,  6336,  6338,  6340,  6342,
    6344,  6346,  6348,  6350,  6352,  6354,  6356,  6358,  6360,  6362,
    6364,  6366,  6368,  6370,  6372,  6374,  6376,  6378,  6380,  6382,
    6384,  6386,  6388,  6390,  6392,  6394,  6396,  6398,  6400,  6402,
    6404,  6406,  6408,  6410,  6412,  6414,  6416,  6418,  6420,  6422,
    6424,  6426,  6428,  6430,  6432,  6434,  6436,  6438,  6440,  6442,
    6444,  6446,  6448,  6450,  6452,  6454,  6456,  6458,  6460,  6462,
    6464,  6466,  6468,  6470,  6472,  6474,  6476,  6478,  6480,  6482,
    6484,  6486,  6488,  6490,  6492,  6494,  6496,  6498,  6500,  6502,
    6504,  6506,  6508,  6510,  6512,  6514,  6516,  6518,  6520,  6522,
    6524,  6526,  6528,  6530,  6532,  6534,  6536,  6538,  6540,  6542,
    6544,  6546,  6548,  6550,  6552,  6554,  6556,  6558,  6560,  6562,
    6564,  6566,  6568,  6570,  6572,  6574,  6576,  6578,  6580,  6582,
    6584,  6586,  6588,  6590,  6592,  6594,  6596,  6598,  6600,  6602,
    6604,  6606,  6608,  6610,  6612,  6614,  6616,  6618,  6620,  6622,
    6624,  6626,  6628,  6630,  6632,  6634,  6636,  6638,  6640,  6642,
    6644,  6646,  6648,  6650,  6652,  6654,  6656,  6658,  6660,  6662,
    6664,  6666,  6668,  6670,  6672,  6674,  6676,  6678,  6680,  6682,
    6684,  6686,  6688,  6690,  6692,  6694,  6696,  6698,  6700,  6702,
    6704,  6706,  6708,  6710,  6712,  6714,  6716,  6718,  6720,  6722,
    6724,  6726,  6728,  6730,  6732,  6734,  6736,  6738,  6740,  6742,
    6744,  6746,  6748,  6750,  6752,  6754,  6756,  6758,  6760,  6762,
    6764,  6766,  6768,  6770,  6772,  6774,  6776,  6778,  6780,  6782,
    6784,  6786,  6788,  6790,  6792,  6794,  6796,  6798,  6800,  6802,
    6804,  6806,  6808,  6810,  6812,  6814,  6816,  6818,  6820,  6822,
    6824,  6826,  6828,  6830,  6832,  6834,  6836,  6838,  6840,  6842,
    6844,  6846,  6848,  6850,  6852,  6854,  6856,  6858,  6860,  6862,
    6864,  6866,  6868,  6870,  6872,  6874,  6876,  6878,  6880,  6882,
    6884,  6886,  6888,  6890,  6892,  6894,  6896,  6898,  6900,  6902,
    6904,  6906,  6908,  6910,  6912,  6914,  6916,  6918,  6920,  6922,
    6924,  6926,  6928,  6930,  6932,  6934,  6936,  6937,  6940,  6945,
    6949,  6952,  6954,  6956,  6958,  6960,  6962,  6963,  6972,  6975,
    6981,  6985,  6988,  6991,  6995,  7003,  7005,  7007,  7009,  7010,
    7013,  7016,  7018,  7019,  7021,  7025,  7027,  7030,  7031,  7034,
    7035,  7038,  7039,  7041,  7045,  7050,  7054,  7056,  7058,  7060,
    7062,  7065,  7066,  7069,  7074,  7075,  7078,  7081,  7084,  7086,
    7088,  7096,  7100,  7102,  7104,  7106,  7108,  7111,  7112,  7114,
    7118,  7122,  7126,  7130,  7131,  7136,  7142,  7148,  7149,  7151,
    7153,  7155,  7158,  7161,  7163,  7166,  7167,  7175,  7176,  7182,
    7183,  7188,  7191,  7194,  7195,  7198,  7200,  7202,  7204,  7206,
    7208,  7210,  7212,  7214,  7216,  7218,  7220,  7226,  7229,  7231,
    7235,  7238,  7241,  7245,  7246,  7252,  7254,  7255,  7261,  7264,
    7267,  7269,  7271,  7273,  7276,  7279,  7283,  7285,  7288,  7291,
    7295,  7299,  7304,  7307,  7309,  7312,  7314,  7316,  7319,  7322,
    7326,  7328,  7330,  7332,  7334,  7335,  7337,  7341,  7347,  7348,
    7351,  7352,  7354,  7357,  7361,  7364,  7366,  7368,  7370,  7371,
    7373,  7375,  7377,  7379,  7381,  7384,  7387,  7391,  7392,  7394,
    7397,  7399,  7404,  7408,  7413,  7417,  7420,  7422,  7426,  7428,
    7430,  7432,  7434,  7437,  7440,  7442,  7445,  7448,  7450,  7452,
    7454,  7459,  7464,  7469,  7474,  7479,  7481,  7482,  7486,  7490,
    7495,  7497,  7501,  7505,  7510,  7512,  7516,  7520,  7522,  7524,
    7526,  7533,  7535,  7539,  7543,  7550,  7552,  7556,  7560,  7562,
    7564,  7567,  7570,  7572,  7574,  7576,  7578,  7580,  7582,  7584,
    7586,  7588,  7590,  7592,  7594,  7596,  7598,  7600,  7602,  7607,
    7612,  7614,  7616,  7621,  7626,  7630,  7631,  7639,  7641,  7642,
    7643,  7651,  7655,  7660,  7664,  7666,  7668,  7670,  7673,  7677,
    7683,  7686,  7692,  7695,  7697,  7699,  7701,  7703,  7705,  7707,
    7709,  7711,  7713,  7715,  7717,  7719,  7721,  7723,  7725,  7727,
    7729,  7731,  7733,  7735,  7737,  7739,  7741,  7743,  7745,  7747,
    7749,  7751,  7753,  7755,  7757,  7759,  7761,  7763,  7765,  7767,
    7769,  7771,  7773,  7775,  7777,  7779,  7781,  7783,  7785,  7787,
    7789,  7791,  7793,  7795,  7797,  7799,  7801,  7803,  7805,  7807,
    7809,  7811,  7813,  7815,  7817,  7819,  7821,  7823,  7825,  7827,
    7829,  7831,  7833,  7835,  7837,  7839,  7841,  7843,  7845,  7847,
    7849,  7851,  7853,  7855,  7857,  7859,  7861,  7863,  7865,  7867,
    7869,  7871,  7873,  7875,  7877,  7879,  7881,  7883,  7885,  7887,
    7889,  7891,  7895,  7897,  7898,  7900,  7903,  7905,  7908,  7910,
    7912,  7914,  7917,  7920,  7922,  7924,  7926,  7928,  7930,  7932,
    7934,  7936,  7938,  7940,  7942,  7944,  7946,  7948,  7950,  7952,
    7955,  7959,  7961,  7964,  7966,  7970,  7972,  7976,  7978,  7980,
    7982,  7984,  7986,  7988,  7990,  7992,  7994,  7996,  7998,  8000,
    8002,  8004,  8006,  8008,  8010,  8012,  8014,  8016,  8018,  8020,
    8022,  8024,  8026,  8028,  8030,  8032,  8034,  8036,  8038,  8040,
    8042,  8044,  8046,  8048,  8050,  8052,  8054,  8056,  8058,  8060,
    8062,  8064,  8066,  8068,  8070,  8072,  8074,  8076,  8078,  8080,
    8082,  8084,  8086,  8088,  8090,  8092,  8094,  8096,  8098,  8101,
    8105,  8108,  8112,  8114,  8118,  8122,  8126,  8130,  8134,  8138,
    8140,  8142,  8143,  8146,  8149,  8151,  8153,  8156,  8158,  8160,
    8162,  8163
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     511,     0,    -1,  1018,    -1,   811,    -1,   812,    -1,   730,
      -1,   817,    -1,   640,    -1,   654,    -1,   764,    -1,   528,
      -1,   785,    -1,   786,    -1,   620,    -1,   553,    -1,   522,
      -1,   520,    -1,   820,    -1,   819,    -1,   658,    -1,   524,
      -1,   523,    -1,   827,    -1,   551,    -1,   563,    -1,   822,
      -1,   708,    -1,   548,    -1,   564,    -1,  1020,    -1,   674,
      -1,   775,    -1,   821,    -1,   816,    -1,   638,    -1,   649,
      -1,   745,    -1,   527,    -1,   687,    -1,   693,    -1,   694,
      -1,   627,    -1,   531,    -1,   619,    -1,   579,    -1,   635,
      -1,   659,    -1,   513,    -1,   519,    -1,   655,    -1,   807,
      -1,  1161,    -1,   862,    -1,   676,    -1,   849,    -1,   552,
      -1,   772,    -1,   675,    -1,   777,    -1,   639,    -1,   653,
      -1,   530,    -1,   697,    -1,   698,    -1,   699,    -1,   633,
      -1,   794,    -1,   701,    -1,   637,    -1,   673,    -1,   525,
      -1,   526,    -1,   657,    -1,   815,    -1,   842,    -1,   833,
      -1,   711,    -1,   715,    -1,   726,    -1,   735,    -1,   844,
      -1,   797,    -1,   806,    -1,   851,    -1,   795,    -1,   839,
      -1,   700,    -1,   779,    -1,   768,    -1,   767,    -1,   769,
      -1,   782,    -1,   716,    -1,   727,    -1,   787,    -1,   866,
      -1,   799,    -1,   706,    -1,   798,    -1,   855,    -1,   824,
      -1,   545,    -1,   535,    -1,   547,    -1,   804,    -1,  1097,
      -1,  1023,    -1,  1040,    -1,  1098,    -1,  1080,    -1,  1095,
      -1,  1081,    -1,  1041,    -1,  1085,    -1,  1107,    -1,  1099,
      -1,  1086,    -1,  1115,    -1,  1117,    -1,  1110,    -1,  1102,
      -1,  1118,    -1,  1121,    -1,  1123,    -1,    -1,   158,   381,
    1012,   514,   515,    -1,   469,    -1,    -1,   515,   518,    -1,
      -1,   516,   517,    -1,    -1,   345,  1151,    -1,   345,   319,
      -1,   203,   345,  1151,    -1,   444,   345,  1151,    -1,   418,
      -1,   313,    -1,   252,    -1,   310,    -1,   159,    -1,   307,
      -1,   160,    -1,   308,    -1,   161,    -1,   309,    -1,   291,
      -1,   311,    -1,   150,   283,  1013,    -1,   454,   449,  1151,
      -1,   451,  1002,    -1,   517,    -1,   420,  1011,    -1,    96,
    1002,    -1,   381,  1002,    -1,   247,   381,  1002,    -1,   247,
     235,  1002,    -1,   158,   451,  1012,   514,   515,    -1,   101,
     381,  1012,   514,   516,    -1,    -1,   247,   175,  1004,    -1,
     101,   381,  1012,   521,   546,    -1,   101,   451,  1012,   514,
     516,    -1,   101,   451,  1012,   546,    -1,   198,   381,  1002,
      -1,   198,   381,   242,   212,  1002,    -1,   198,   451,  1002,
      -1,   198,   451,   242,   212,  1002,    -1,   158,   235,  1012,
     514,   515,    -1,   101,   235,  1012,   529,   451,  1002,    -1,
      95,    -1,   198,    -1,   198,   235,  1002,    -1,   198,   235,
     242,   212,  1002,    -1,   158,   387,   532,   114,  1012,   533,
      -1,   158,   387,  1131,   533,    -1,  1131,    -1,    -1,   533,
     534,    -1,    -1,   579,    -1,   735,    -1,   619,    -1,   659,
      -1,   715,    -1,   804,    -1,   399,   536,    -1,   399,   286,
     536,    -1,   399,   397,   536,    -1,   537,   432,   538,    -1,
     537,   489,   538,    -1,   537,   432,   181,    -1,   537,   489,
     181,    -1,   537,   227,   164,    -1,   430,   485,   542,    -1,
     434,   802,    -1,   397,   135,   108,   434,   802,    -1,   131,
    1151,    -1,   387,  1151,    -1,   301,   543,    -1,   381,   544,
      -1,   397,   114,   544,    -1,   397,   114,   181,    -1,   474,
     331,   950,    -1,  1130,    -1,   537,   504,  1131,    -1,   539,
      -1,   538,   505,   539,    -1,   541,    -1,   625,    -1,   361,
     443,    -1,   361,   147,    -1,   371,   361,    -1,   395,    -1,
     438,    -1,   216,    -1,   328,    -1,   544,    -1,  1151,    -1,
    1153,    -1,   937,  1151,   939,    -1,   937,   502,  1011,   503,
    1151,   939,    -1,   625,    -1,   181,    -1,   286,    -1,  1151,
      -1,   181,    -1,    -1,  1131,    -1,  1151,    -1,   374,   537,
      -1,   374,   430,   485,    -1,   374,   434,   270,   281,    -1,
     374,   397,   114,    -1,   374,    99,    -1,   399,   536,    -1,
     545,    -1,   402,   537,  1164,    -1,   402,   430,   485,  1164,
      -1,   402,   434,   270,   281,  1164,    -1,   402,   397,   114,
    1164,    -1,   402,    99,    -1,   399,   152,   549,   550,    -1,
      99,    -1,  1000,    -1,   184,    -1,   244,    -1,   137,    -1,
     192,    99,    -1,   192,   425,    -1,   192,   427,    -1,   192,
     347,    -1,   101,   422,   909,   554,    -1,   101,   250,  1001,
     554,    -1,   101,   393,  1001,   554,    -1,   101,   463,  1001,
     554,    -1,   555,    -1,   554,   505,   555,    -1,    95,   587,
      -1,    95,   143,   587,    -1,   101,   783,  1131,   556,    -1,
     101,   783,  1131,   198,   314,   319,    -1,   101,   783,  1131,
     399,   314,   319,    -1,   101,   783,  1131,   399,   411,  1013,
      -1,   101,   783,  1131,   399,   559,    -1,   101,   783,  1131,
     374,   559,    -1,   101,   783,  1131,   399,   414,  1131,    -1,
     198,   783,   242,   212,  1131,   557,    -1,   198,   783,  1131,
     557,    -1,   101,   783,  1131,   784,   441,   917,   558,    -1,
      95,   596,    -1,   198,   151,   242,   212,  1003,   557,    -1,
     198,   151,  1003,   557,    -1,   399,   469,   327,    -1,   399,
     470,   327,    -1,   140,   328,  1003,    -1,   399,   470,   140,
      -1,   201,   436,  1003,    -1,   201,   102,   436,  1003,    -1,
     201,   373,   436,  1003,    -1,   201,   436,    99,    -1,   201,
     436,   451,    -1,   191,   436,  1003,    -1,   191,   436,    99,
      -1,   191,   436,   451,    -1,   201,   385,  1003,    -1,   201,
     102,   385,  1003,    -1,   201,   373,   385,  1003,    -1,   191,
     385,  1003,    -1,   252,  1001,    -1,   306,   252,  1001,    -1,
     341,   432,  1012,    -1,   399,   424,  1003,    -1,   399,   559,
      -1,   374,   559,    -1,   399,   181,   941,    -1,   198,   181,
      -1,   127,    -1,   376,    -1,    -1,   452,   941,    -1,    -1,
     502,   561,   503,    -1,   469,   559,    -1,    -1,   562,    -1,
     561,   505,   562,    -1,  1133,   489,   680,    -1,  1133,    -1,
    1133,   504,  1133,   489,   680,    -1,  1133,   504,  1133,    -1,
     139,   863,    -1,   139,    99,    -1,   156,   570,  1001,   598,
     571,   565,   566,   572,   514,   567,    -1,   156,   867,   432,
     566,   514,   567,    -1,   227,    -1,   432,    -1,  1151,    -1,
     412,    -1,   413,    -1,   568,    -1,   502,   574,   503,    -1,
     568,   569,    -1,    -1,   120,    -1,   327,    -1,   187,   818,
    1151,    -1,   319,   818,  1151,    -1,   163,    -1,   238,    -1,
     359,   818,  1151,    -1,   206,   818,  1151,    -1,   223,   359,
     599,    -1,   223,   359,   495,    -1,   223,   314,   319,   599,
      -1,   120,    -1,    -1,   469,   327,    -1,    -1,   573,   188,
    1151,    -1,    -1,   452,    -1,    -1,   575,    -1,   574,   505,
     575,    -1,  1133,   576,    -1,   541,    -1,   625,    -1,   495,
      -1,   502,   577,   503,    -1,    -1,   578,    -1,   577,   505,
     578,    -1,   541,    -1,   158,   580,   422,  1001,   502,   581,
     503,   609,   610,   611,   612,    -1,   158,   580,   422,  1001,
     324,   704,   582,   610,   611,   612,    -1,   427,    -1,   425,
      -1,   286,   427,    -1,   286,   425,    -1,   231,   427,    -1,
     231,   425,    -1,    -1,   583,    -1,    -1,   502,   584,   503,
      -1,    -1,   585,    -1,   583,   505,   585,    -1,   586,    -1,
     584,   505,   586,    -1,   587,    -1,   593,    -1,   596,    -1,
     588,    -1,   596,    -1,  1131,   917,   589,    -1,  1131,   469,
     332,   589,    -1,   589,   590,    -1,    -1,   151,  1003,   591,
      -1,   591,    -1,   592,    -1,   314,   319,    -1,   319,    -1,
     446,   761,   613,    -1,   354,   272,   761,   613,    -1,   136,
     502,   941,   503,    -1,   181,   942,    -1,   366,  1001,   598,
     601,   605,    -1,   183,    -1,   314,   183,    -1,   254,   184,
      -1,   254,   244,    -1,   282,  1001,   594,    -1,   594,   248,
     595,    -1,   594,   209,   595,    -1,    -1,   182,    -1,   152,
      -1,   251,    -1,   414,    -1,   145,    -1,    99,    -1,   151,
    1003,   597,    -1,   597,    -1,   136,   502,   941,   503,   670,
      -1,   446,   502,   599,   503,   761,   613,   670,    -1,   354,
     272,   502,   599,   503,   761,   613,   670,    -1,   208,   739,
     502,   602,   503,   761,   613,   604,   670,    -1,   224,   272,
     502,   599,   503,   366,  1001,   598,   601,   605,   670,    -1,
     502,   599,   503,    -1,    -1,   600,    -1,   599,   505,   600,
      -1,  1131,    -1,   293,   228,    -1,   293,   343,    -1,   293,
     404,    -1,    -1,   603,    -1,   602,   505,   603,    -1,   741,
     469,   771,    -1,   741,   469,   330,   502,   771,   503,    -1,
     466,   502,   941,   503,    -1,    -1,   606,    -1,   607,    -1,
     606,   607,    -1,   607,   606,    -1,    -1,   328,   450,   608,
      -1,   328,   186,   608,    -1,   306,    94,    -1,   376,    -1,
     127,    -1,   399,   319,    -1,   399,   181,    -1,   253,   502,
    1000,   503,    -1,    -1,   469,   559,    -1,   469,   327,    -1,
     470,   327,    -1,    -1,   328,   146,   198,    -1,   328,   146,
     186,   384,    -1,   328,   146,   351,   384,    -1,    -1,   424,
    1003,    -1,    -1,   452,   250,   424,  1003,    -1,    -1,  1001,
     615,   610,   611,   612,    -1,   502,   616,   503,    -1,    -1,
     617,    -1,   616,   505,   617,    -1,  1131,    -1,   469,   174,
      -1,   469,   306,   174,    -1,    -1,   158,   580,   393,  1001,
     621,    -1,   101,   393,  1001,   622,    -1,   622,    -1,    -1,
     623,    -1,   622,   623,    -1,   125,   625,    -1,   173,    -1,
     306,   173,    -1,   249,   624,   625,    -1,   294,   625,    -1,
     296,   625,    -1,   306,   294,    -1,   306,   296,    -1,   340,
     124,   704,    -1,   409,   514,   625,    -1,   375,    -1,   375,
     514,   625,    -1,   124,    -1,    -1,  1150,    -1,   494,  1150,
      -1,  1013,    -1,   625,    -1,   626,   505,   625,    -1,   158,
     746,   628,   634,   273,   544,    -1,   158,   746,   628,   634,
     273,   544,   236,   629,   630,   632,    -1,   440,    -1,    -1,
    1003,    -1,  1003,   705,    -1,   255,   629,    -1,    -1,   455,
     629,    -1,   306,   455,    -1,   631,    -1,    -1,   198,   634,
     273,   544,   557,    -1,   198,   634,   273,   242,   212,   544,
     557,    -1,   357,    -1,    -1,   158,   424,  1003,   636,   289,
    1151,    -1,   341,  1003,    -1,    -1,   198,   424,  1003,    -1,
     198,   424,   242,   212,  1003,    -1,   158,   224,   174,   472,
    1003,   632,   641,    -1,   198,   224,   174,   472,  1003,   557,
      -1,   198,   224,   174,   472,   242,   212,  1003,   557,    -1,
     101,   224,   174,   472,  1003,   631,   643,    -1,   101,   224,
     174,   472,  1003,   631,    -1,   101,   224,   174,   472,  1003,
     643,    -1,   332,   502,   642,   503,    -1,    -1,   646,    -1,
     642,   505,   646,    -1,   332,   502,   644,   503,    -1,   645,
      -1,   644,   505,   645,    -1,   646,    -1,   399,   646,    -1,
      95,   646,    -1,   198,   647,    -1,   647,   648,    -1,  1133,
      -1,  1151,    -1,   158,   396,  1003,   650,   652,   224,   174,
     472,  1003,   641,    -1,   441,  1151,    -1,    -1,   462,  1151,
      -1,   462,   319,    -1,   651,    -1,    -1,   198,   396,  1003,
     557,    -1,   198,   396,   242,   212,  1003,   557,    -1,   101,
     396,  1003,   651,   643,    -1,   101,   396,  1003,   651,    -1,
     101,   396,  1003,   643,    -1,   158,   451,   292,   222,   656,
     396,  1003,   641,    -1,   171,    -1,   451,    -1,  1012,    -1,
     198,   451,   292,   222,   656,   396,  1003,    -1,   198,   451,
     292,   242,   212,   222,   656,   396,  1003,    -1,   101,   451,
     292,   222,   656,   396,  1003,   643,    -1,   158,   436,  1003,
     660,   661,   328,  1001,   663,   666,   211,   358,  1009,   502,
     667,   503,    -1,   158,   151,   436,  1003,    97,   661,   328,
    1001,   669,   670,   222,   199,   383,   666,   211,   358,  1009,
     502,   667,   503,    -1,   116,    -1,    97,    -1,   662,    -1,
     661,   333,   662,    -1,   260,    -1,   186,    -1,   450,    -1,
     450,   324,   599,    -1,   439,    -1,   222,   664,   665,    -1,
      -1,   199,    -1,    -1,   383,    -1,   410,    -1,   465,   502,
     941,   503,    -1,    -1,   668,    -1,   667,   505,   668,    -1,
      -1,  1011,    -1,  1150,    -1,  1151,    -1,  1149,    -1,    84,
      -1,  1131,    -1,   227,  1001,    -1,    -1,   671,    -1,   671,
     672,    -1,   672,    -1,   672,   671,    -1,    -1,   314,   183,
      -1,   183,    -1,   254,   244,    -1,   254,   184,    -1,   198,
     436,  1003,   328,  1001,   557,    -1,   198,   436,   242,   212,
    1003,   328,  1001,   557,    -1,   158,   110,  1003,   136,   502,
     941,   503,   670,    -1,   198,   110,  1003,   557,    -1,   158,
      98,  1009,   681,   677,    -1,   158,    98,  1009,   682,    -1,
     158,   330,   771,   677,    -1,   158,   441,   704,   677,    -1,
     158,   441,   704,    -1,   158,   441,   704,   108,   502,   915,
     503,    -1,   158,   441,   704,   108,   205,   502,   685,   503,
      -1,   158,   428,   389,   342,   704,   677,    -1,   158,   428,
     389,   190,   704,   677,    -1,   158,   428,   389,   426,   704,
     677,    -1,   158,   428,   389,   149,   704,   677,    -1,   502,
     678,   503,    -1,   679,    -1,   678,   505,   679,    -1,  1133,
     489,   680,    -1,  1133,    -1,   755,    -1,  1017,    -1,   967,
      -1,   625,    -1,  1151,    -1,   502,   972,   503,    -1,   502,
     495,   503,    -1,   502,   683,   503,    -1,   684,    -1,   683,
     505,   684,    -1,  1153,   489,   680,    -1,   686,    -1,    -1,
    1151,    -1,   686,   505,  1151,    -1,   158,   330,   138,   704,
     690,   222,   441,   917,   452,  1005,   691,   108,   688,    -1,
     689,    -1,   688,   505,   689,    -1,   330,  1011,   771,   692,
      -1,   330,  1011,   771,   770,   692,    -1,   229,  1011,  1009,
     747,    -1,   229,  1011,   502,   972,   503,  1009,   747,    -1,
     414,   917,    -1,   181,    -1,    -1,   217,   704,    -1,    -1,
     364,    -1,    -1,   158,   330,   217,   704,   452,  1005,    -1,
     101,   330,   217,   704,   452,  1005,    95,   688,    -1,   101,
     330,   217,   704,   452,  1005,   198,   695,    -1,   696,    -1,
     695,   505,   696,    -1,   330,  1011,   502,   972,   503,    -1,
     229,  1011,   502,   972,   503,    -1,   198,   330,   138,   704,
     452,  1005,   557,    -1,   198,   330,   138,   242,   212,   704,
     452,  1005,   557,    -1,   198,   330,   217,   704,   452,  1005,
     557,    -1,   198,   330,   217,   242,   212,   704,   452,  1005,
     557,    -1,   198,   340,   124,  1002,   557,    -1,   363,   340,
     124,  1002,   432,  1003,    -1,   198,   702,   242,   212,   703,
     557,    -1,   198,   702,   703,   557,    -1,   422,    -1,   393,
      -1,   463,    -1,   250,    -1,   441,    -1,   196,    -1,   155,
      -1,   387,    -1,   428,   389,   342,    -1,   428,   389,   190,
      -1,   428,   389,   426,    -1,   428,   389,   149,    -1,   704,
      -1,   703,   505,   704,    -1,  1131,    -1,  1131,   705,    -1,
     504,  1006,    -1,   705,   504,  1006,    -1,   439,   876,   910,
     707,   557,    -1,   154,   241,    -1,   375,   241,    -1,    -1,
     144,   328,   709,   704,   268,   710,    -1,   144,   328,    98,
    1009,   681,   268,   710,    -1,   144,   328,   229,  1009,   747,
     268,   710,    -1,   144,   328,   330,   771,   770,   268,   710,
      -1,   144,   328,   151,  1003,   328,   704,   268,   710,    -1,
     144,   328,   385,  1003,   328,   704,   268,   710,    -1,   144,
     328,   385,  1003,   268,   710,    -1,   144,   328,   436,  1003,
     328,   704,   268,   710,    -1,   144,   328,   330,   138,   704,
     452,  1005,   268,   710,    -1,   144,   328,   330,   217,   704,
     452,  1005,   268,   710,    -1,   144,   328,   274,   323,   625,
     268,   710,    -1,   144,   328,   130,   502,   917,   108,   917,
     503,   268,   710,    -1,   144,   328,   634,   273,   704,   268,
     710,    -1,   144,   328,   428,   389,   342,   704,   268,   710,
      -1,   144,   328,   428,   389,   190,   704,   268,   710,    -1,
     144,   328,   428,   389,   426,   704,   268,   710,    -1,   144,
     328,   428,   389,   149,   704,   268,   710,    -1,   143,    -1,
     175,    -1,   387,    -1,   250,    -1,   393,    -1,   422,    -1,
     196,    -1,   441,    -1,   463,    -1,   155,    -1,   424,    -1,
     381,    -1,  1151,    -1,   319,    -1,   218,   712,    -1,   299,
     712,    -1,   218,   712,  1165,    -1,   218,   225,   863,  1166,
      -1,   218,   225,   713,   863,  1166,    -1,   218,   115,   863,
    1166,    -1,   218,   115,   713,   863,  1166,    -1,   299,   225,
     863,    -1,   299,   225,   713,   863,    -1,   299,   115,   863,
      -1,   299,   115,   713,   863,    -1,   863,    -1,   713,   863,
      -1,   305,   714,   863,    -1,   355,   714,   863,    -1,   219,
     714,   863,    -1,   275,   714,   863,    -1,    92,  1013,   714,
     863,    -1,   368,  1013,   714,   863,    -1,  1013,   714,   863,
      -1,    99,   714,   863,    -1,   225,  1013,   714,   863,    -1,
     225,    99,   714,   863,    -1,   115,  1013,   714,   863,    -1,
     115,    99,   714,   863,    -1,   227,    -1,   247,    -1,   713,
      -1,    -1,   232,   717,   328,   720,   432,   721,   723,    -1,
     379,   717,   328,   720,   227,   721,   557,    -1,   379,   232,
     331,   222,   717,   328,   720,   227,   721,   557,    -1,   718,
      -1,    99,    -1,    99,   356,    -1,    99,   502,   599,   503,
      -1,    99,   356,   502,   599,   503,    -1,   719,    -1,   718,
     505,   719,    -1,   392,   598,    -1,   366,   598,    -1,   158,
     598,    -1,  1131,   598,    -1,  1000,    -1,   422,  1000,    -1,
     393,  1000,    -1,   224,   174,   472,  1002,    -1,   224,   396,
    1002,    -1,   229,   724,    -1,   175,  1002,    -1,   273,  1002,
      -1,   274,   323,   626,    -1,   387,  1002,    -1,   424,  1002,
      -1,    99,   423,   247,   387,  1002,    -1,    99,   394,   247,
     387,  1002,    -1,    99,   230,   247,   387,  1002,    -1,   722,
      -1,   721,   505,   722,    -1,  1012,    -1,   235,  1012,    -1,
     469,   232,   331,    -1,    -1,   725,    -1,   724,   505,   725,
      -1,  1009,   747,    -1,   232,   718,   432,  1002,   728,   729,
      -1,   379,   718,   227,  1002,   729,   557,    -1,   379,    96,
     331,   222,   718,   227,  1002,   729,   557,    -1,   469,    96,
     331,    -1,    -1,   233,   124,  1012,    -1,    -1,   101,   181,
     356,   731,   733,    -1,   731,   732,    -1,    -1,   247,   387,
    1002,    -1,   222,   381,  1002,    -1,   222,   451,  1002,    -1,
     232,   717,   328,   734,   432,   721,   723,    -1,   379,   717,
     328,   734,   227,   721,   557,    -1,   379,   232,   331,   222,
     717,   328,   734,   227,   721,   557,    -1,   423,    -1,   230,
      -1,   394,    -1,   158,   736,   250,   737,   738,   328,  1001,
     739,   502,   740,   503,   560,   612,   913,    -1,   446,    -1,
      -1,   148,    -1,    -1,  1007,    -1,    -1,   452,  1005,    -1,
      -1,   741,    -1,   740,   505,   741,    -1,  1131,   742,   743,
     744,    -1,   944,   742,   743,   744,    -1,   502,   941,   503,
     742,   743,   744,    -1,   704,    -1,   452,   704,    -1,    -1,
     109,    -1,   189,    -1,    -1,   486,    -1,   487,    -1,    -1,
     158,   746,   229,  1009,   749,   378,   754,   757,   761,    -1,
     158,   746,   229,  1009,   749,   378,   422,   502,   763,   503,
     757,   761,    -1,   158,   746,   229,  1009,   749,   757,   761,
      -1,   333,   372,    -1,    -1,   502,   748,   503,    -1,   502,
     503,    -1,   751,    -1,   748,   505,   751,    -1,   502,   750,
     503,    -1,   502,   503,    -1,   756,    -1,   750,   505,   756,
      -1,   752,   753,   755,    -1,   753,   752,   755,    -1,   753,
     755,    -1,   752,   755,    -1,   755,    -1,   247,    -1,   335,
      -1,   257,    -1,   247,   335,    -1,   459,    -1,  1132,    -1,
     755,    -1,   917,    -1,  1132,   705,   497,   441,    -1,   400,
    1132,   705,   497,   441,    -1,   751,    -1,   751,   181,   941,
      -1,   751,   489,   941,    -1,   759,    -1,   757,   759,    -1,
     126,   328,   319,   258,    -1,   378,   319,   328,   319,   258,
      -1,   415,    -1,   245,    -1,   407,    -1,   464,    -1,   214,
     391,   185,    -1,   214,   391,   267,    -1,   391,   185,    -1,
     391,   267,    -1,   157,   625,    -1,   384,   625,    -1,   546,
      -1,   108,   760,    -1,   273,   544,    -1,   468,    -1,   758,
      -1,  1151,    -1,  1151,   505,  1151,    -1,   469,   677,    -1,
      -1,   753,   755,    -1,   762,    -1,   763,   505,   762,    -1,
     101,   229,   725,   765,   766,    -1,   758,    -1,   765,   758,
      -1,   376,    -1,    -1,   198,   229,  1009,   747,   557,    -1,
     198,   229,   242,   212,  1009,   747,   557,    -1,   198,    98,
    1009,   681,   557,    -1,   198,    98,   242,   212,  1009,   681,
     557,    -1,   198,   330,   771,   770,   557,    -1,   198,   330,
     242,   212,   771,   770,   557,    -1,   502,   917,   503,    -1,
     502,   917,   505,   917,   503,    -1,   502,   312,   505,   917,
     503,    -1,   502,   917,   505,   312,   503,    -1,   964,    -1,
    1131,   504,   771,    -1,   194,   773,    -1,   774,    -1,   773,
     774,    -1,  1151,    -1,   273,   544,    -1,   158,   130,   502,
     917,   108,   917,   503,   469,   229,   725,   776,    -1,   158,
     130,   502,   917,   108,   917,   503,   470,   229,   776,    -1,
     158,   130,   502,   917,   108,   917,   503,   469,   257,   776,
      -1,   108,   246,    -1,   108,   111,    -1,    -1,   198,   130,
     778,   502,   917,   108,   917,   503,   557,    -1,   242,   212,
      -1,    -1,   367,   780,  1001,   781,    -1,   367,   421,  1003,
     781,    -1,   367,   175,  1003,   781,    -1,   250,    -1,   422,
      -1,   223,    -1,    -1,   101,    98,  1009,   681,   370,   432,
    1003,    -1,   101,   155,   704,   370,   432,  1003,    -1,   101,
     175,  1004,   370,   432,  1004,    -1,   101,   229,   725,   370,
     432,  1003,    -1,   101,   235,  1012,   370,   432,  1012,    -1,
     101,   634,   273,  1003,   370,   432,  1003,    -1,   101,   330,
     138,   704,   452,  1005,   370,   432,  1003,    -1,   101,   330,
     217,   704,   452,  1005,   370,   432,  1003,    -1,   101,   387,
    1003,   370,   432,  1003,    -1,   101,   422,   909,   370,   432,
    1003,    -1,   101,   393,  1001,   370,   432,  1003,    -1,   101,
     463,  1001,   370,   432,  1003,    -1,   101,   250,  1001,   370,
     432,  1003,    -1,   101,   422,   909,   370,   783,  1003,   432,
    1003,    -1,   101,   436,  1003,   328,  1001,   370,   432,  1003,
      -1,   101,   381,  1012,   370,   432,  1012,    -1,   101,   451,
    1012,   370,   432,  1012,    -1,   101,   424,  1003,   370,   432,
    1003,    -1,   101,   424,  1003,   399,   559,    -1,   101,   424,
    1003,   374,   559,    -1,   101,   428,   389,   342,   704,   370,
     432,  1003,    -1,   101,   428,   389,   190,   704,   370,   432,
    1003,    -1,   101,   428,   389,   426,   704,   370,   432,  1003,
      -1,   101,   428,   389,   149,   704,   370,   432,  1003,    -1,
     101,   441,   704,   370,   432,  1003,    -1,   143,    -1,    -1,
     399,   174,    -1,    -1,   101,    98,  1009,   681,   399,   387,
    1003,    -1,   101,   196,   704,   399,   387,  1003,    -1,   101,
     229,   725,   399,   387,  1003,    -1,   101,   422,   909,   399,
     387,  1003,    -1,   101,   393,  1001,   399,   387,  1003,    -1,
     101,   463,  1001,   399,   387,  1003,    -1,   101,   441,   704,
     399,   387,  1003,    -1,   101,    98,  1009,   681,   341,   432,
    1012,    -1,   101,   155,   704,   341,   432,  1012,    -1,   101,
     175,  1004,   341,   432,  1012,    -1,   101,   196,   704,   341,
     432,  1012,    -1,   101,   229,   725,   341,   432,  1012,    -1,
     101,   634,   273,  1003,   341,   432,  1012,    -1,   101,   274,
     323,   625,   341,   432,  1012,    -1,   101,   330,   771,   770,
     341,   432,  1012,    -1,   101,   330,   138,   704,   452,  1005,
     341,   432,  1012,    -1,   101,   330,   217,   704,   452,  1005,
     341,   432,  1012,    -1,   101,   387,  1003,   341,   432,  1012,
      -1,   101,   441,   704,   341,   432,  1012,    -1,   101,   424,
    1003,   341,   432,  1012,    -1,   101,   428,   389,   190,   704,
     341,   432,  1012,    -1,   101,   428,   389,   149,   704,   341,
     432,  1012,    -1,   101,   224,   174,   472,  1003,   341,   432,
    1012,    -1,   101,   396,  1003,   341,   432,  1012,    -1,   158,
     746,   385,  1003,   108,   328,   792,   432,  1001,   913,   194,
     793,   788,    -1,   315,    -1,   790,    -1,   502,   789,   503,
      -1,   789,   506,   791,    -1,   791,    -1,   866,    -1,   844,
      -1,   855,    -1,   849,    -1,   795,    -1,   790,    -1,    -1,
     392,    -1,   450,    -1,   186,    -1,   260,    -1,   261,    -1,
     100,    -1,    -1,   198,   385,  1003,   328,  1001,   557,    -1,
     198,   385,   242,   212,  1003,   328,  1001,   557,    -1,   316,
    1131,   796,    -1,   505,  1151,    -1,    -1,   284,  1131,    -1,
     448,  1131,    -1,   448,   495,    -1,    91,   800,    -1,   117,
     800,   803,    -1,   409,   434,   803,    -1,   146,   800,    -1,
     204,   800,    -1,   382,   800,    -1,   386,  1131,    -1,   369,
     386,  1131,    -1,   369,  1131,    -1,   382,   800,   432,   386,
    1131,    -1,   382,   800,   432,  1131,    -1,   352,   434,  1151,
      -1,   146,   353,  1151,    -1,   382,   353,  1151,    -1,   471,
      -1,   434,    -1,    -1,   270,   281,   540,    -1,   361,   329,
      -1,   361,   473,    -1,   801,    -1,   802,   505,   801,    -1,
     802,   801,    -1,   802,    -1,    -1,   158,   580,   463,  1001,
     598,   108,   866,   805,    -1,   158,   333,   372,   580,   463,
    1001,   598,   108,   866,   805,    -1,   469,   136,   331,    -1,
     469,   128,   136,   331,    -1,   469,   286,   136,   331,    -1,
      -1,   285,  1008,    -1,   158,   175,  1004,   514,   808,    -1,
     808,   809,    -1,    -1,   424,   810,  1003,    -1,   424,   810,
     181,    -1,   289,   810,  1151,    -1,   289,   810,   181,    -1,
     426,   810,  1003,    -1,   426,   810,   181,    -1,   202,   810,
    1151,    -1,   202,   810,  1011,    -1,   202,   810,   181,    -1,
     276,   810,  1151,    -1,   276,   810,   181,    -1,   277,   810,
    1151,    -1,   277,   810,   181,    -1,   150,   283,   810,  1013,
      -1,   341,   810,  1003,    -1,   341,   810,   181,    -1,   489,
      -1,    -1,   101,   175,  1004,   514,   813,    -1,   101,   175,
    1004,   399,   424,  1003,    -1,   101,   175,  1004,   546,    -1,
     813,   814,    -1,    -1,   150,   283,   810,  1013,    -1,   198,
     175,  1004,    -1,   198,   175,   242,   212,  1004,    -1,   158,
     196,   704,   818,   917,   589,    -1,   101,   196,   704,   556,
      -1,   101,   196,   704,   198,   314,   319,    -1,   101,   196,
     704,   399,   314,   319,    -1,   101,   196,   704,    95,   596,
      -1,   101,   196,   704,   198,   151,  1003,   557,    -1,   108,
      -1,    -1,   101,   428,   389,   190,   704,   677,    -1,   101,
     428,   389,   149,   704,    95,   292,   222,  1002,   469,   703,
      -1,   101,   428,   389,   149,   704,   101,   292,   222,  1002,
     469,   703,    -1,   101,   428,   389,   149,   704,   101,   292,
     372,   704,   469,   704,    -1,   101,   428,   389,   149,   704,
     101,   292,   222,  1002,   372,   704,   469,   704,    -1,   101,
     428,   389,   149,   704,   198,   292,   222,  1002,    -1,   101,
     428,   389,   149,   704,   198,   292,   242,   212,   222,  1002,
      -1,   158,   690,   155,   704,   222,  1151,   432,  1151,   227,
     704,    -1,   140,   829,  1001,   823,    -1,   140,   829,    -1,
     140,   829,  1007,   328,  1001,    -1,   452,  1007,    -1,    -1,
     453,   830,   831,   829,    -1,   453,   830,   831,   829,  1001,
      -1,   453,   830,   831,   829,   827,    -1,   453,   502,   825,
     503,    -1,   453,   502,   825,   503,  1001,   832,    -1,   826,
      -1,   825,   505,   826,    -1,   828,    -1,   461,    -1,   226,
      -1,   228,    -1,   828,   829,    -1,   828,   829,  1001,   832,
      -1,   104,    -1,   103,    -1,   461,    -1,    -1,   228,    -1,
      -1,   226,    -1,    -1,   502,  1002,   503,    -1,    -1,   213,
     834,    -1,   213,   828,   829,   834,    -1,   213,   461,   834,
      -1,   213,   502,   835,   503,   834,    -1,   866,    -1,   844,
      -1,   855,    -1,   849,    -1,   862,    -1,  1020,    -1,   842,
      -1,   836,    -1,   835,   505,   836,    -1,   837,   838,    -1,
    1131,    -1,   828,    -1,   461,    -1,   541,    -1,   625,    -1,
      -1,   352,  1039,   840,   108,   841,    -1,   352,  1039,   227,
    1084,    -1,   502,   972,   503,    -1,    -1,   866,    -1,   844,
      -1,   855,    -1,   849,    -1,   211,  1039,   843,  1163,    -1,
     158,   580,   422,   614,   108,   211,  1039,   843,    -1,   502,
     969,   503,    -1,    -1,   260,   266,  1001,   845,   848,    -1,
     866,    -1,   502,   846,   503,   866,    -1,   181,   457,    -1,
     847,    -1,   846,   505,   847,    -1,  1131,   993,    -1,   377,
     998,  1164,    -1,    -1,   186,   227,   911,   850,   914,   848,
      -1,   452,   902,    -1,    -1,   290,   876,   910,   852,   854,
      -1,   247,   853,   297,    -1,    -1,    93,   401,    -1,   383,
     401,    -1,   383,   210,    -1,   401,   450,   210,    -1,   401,
      -1,   401,   383,   210,    -1,   210,    -1,    93,   210,    -1,
     318,    -1,    -1,   450,   911,   399,   856,   901,   914,   848,
      -1,   857,    -1,   856,   505,   857,    -1,   858,    -1,   859,
      -1,   860,   489,   995,    -1,   502,   861,   503,   489,   997,
      -1,  1131,   993,    -1,   860,    -1,   861,   505,   860,    -1,
     180,   863,   864,   172,   865,   222,   866,    -1,  1003,    -1,
    1144,    -1,    -1,   864,   306,   388,    -1,   864,   388,    -1,
     864,   120,    -1,   864,   259,    -1,    -1,   469,   239,    -1,
     470,   239,    -1,   868,    -1,   867,    -1,   502,   868,   503,
      -1,   502,   867,   503,    -1,   870,    -1,   869,   880,    -1,
     869,   879,   895,   884,    -1,   869,   879,   883,   896,    -1,
     871,   869,    -1,   871,   869,   880,    -1,   871,   869,   879,
     895,   884,    -1,   871,   869,   879,   883,   896,    -1,   870,
      -1,   867,    -1,   392,   878,   998,   874,   901,   913,   893,
     894,   952,    -1,   900,    -1,   422,   909,    -1,   869,   445,
     877,   869,    -1,   869,   264,   877,   869,    -1,   869,   207,
     877,   869,    -1,   469,   872,    -1,   469,   365,   872,    -1,
     873,    -1,   872,   505,   873,    -1,  1003,   832,   108,   867,
      -1,   266,   875,    -1,  1164,    -1,    -1,   427,   876,  1001,
      -1,   425,   876,  1001,    -1,   286,   427,   876,  1001,    -1,
     286,   425,   876,  1001,    -1,   231,   427,   876,  1001,    -1,
     231,   425,   876,  1001,    -1,   422,  1001,    -1,  1001,    -1,
     422,    -1,    -1,    99,    -1,   193,    -1,    -1,   193,    -1,
     193,   328,   502,   969,   503,    -1,    99,    -1,    -1,   880,
      -1,    -1,   334,   124,   881,    -1,   882,    -1,   881,   505,
     882,    -1,   941,   452,   967,   744,    -1,   941,   743,   744,
      -1,   885,   886,    -1,   886,   885,    -1,   885,    -1,   886,
      -1,   883,    -1,    -1,   283,   887,    -1,   283,   887,   505,
     888,    -1,   218,   892,   889,   891,   329,    -1,   326,   888,
      -1,   326,   890,   891,    -1,   941,    -1,    99,    -1,   941,
      -1,  1013,    -1,   502,   941,   503,    -1,    -1,   943,    -1,
     383,    -1,   384,    -1,   219,    -1,   305,    -1,   235,   124,
     969,    -1,    -1,   237,   941,    -1,    -1,   897,    -1,   222,
     361,   329,    -1,   895,    -1,    -1,   898,    -1,   897,   898,
      -1,   222,   450,   899,   854,    -1,   222,   401,   899,   854,
      -1,   324,  1000,    -1,    -1,   457,   997,    -1,   900,   505,
     997,    -1,   227,   902,    -1,    -1,   903,    -1,   902,   505,
     903,    -1,   909,    -1,   909,   905,    -1,   912,    -1,   912,
     905,    -1,   912,   108,   502,   915,   503,    -1,   912,   108,
    1131,   502,   915,   503,    -1,   912,  1131,   502,   915,   503,
      -1,   867,    -1,   867,   905,    -1,   904,    -1,   502,   904,
     503,   905,    -1,   502,   904,   503,    -1,   903,   162,   271,
     903,    -1,   903,   906,   271,   903,   908,    -1,   903,   271,
     903,   908,    -1,   903,   303,   906,   271,   903,    -1,   903,
     303,   271,   903,    -1,   108,  1131,   502,  1002,   503,    -1,
     108,  1131,    -1,  1131,   502,  1002,   503,    -1,  1131,    -1,
     228,   907,    -1,   280,   907,    -1,   380,   907,    -1,   256,
      -1,   336,    -1,    -1,   452,   502,  1002,   503,    -1,   328,
     941,    -1,  1001,    -1,  1001,   495,    -1,   329,  1001,    -1,
     329,   502,  1001,   503,    -1,   909,    -1,   910,   505,   909,
      -1,   909,    -1,   909,  1131,    -1,   909,   108,  1131,    -1,
     944,    -1,   466,   941,    -1,    -1,   466,   941,    -1,   466,
     164,   324,  1003,    -1,    -1,   916,    -1,   915,   505,   916,
      -1,  1131,   917,    -1,   919,   918,    -1,   400,   919,   918,
      -1,   919,   107,   500,  1011,   501,    -1,   400,   919,   107,
     500,  1011,   501,    -1,   919,   107,    -1,   400,   919,   107,
      -1,   918,   500,   501,    -1,   918,   500,  1162,   501,    -1,
      -1,   921,    -1,   923,    -1,   925,    -1,   929,    -1,   936,
      -1,   937,   939,    -1,   937,   502,  1011,   503,   939,    -1,
     923,    -1,   926,    -1,   930,    -1,   936,    -1,  1132,   922,
      -1,  1132,   705,   922,    -1,   502,   969,   503,    -1,    -1,
     262,    -1,   263,    -1,   405,    -1,   119,    -1,   362,    -1,
     220,   924,    -1,   197,   350,    -1,   179,   922,    -1,   178,
     922,    -1,   322,   922,    -1,   122,    -1,   502,  1011,   503,
      -1,    -1,   927,    -1,   928,    -1,   927,    -1,   928,    -1,
     121,   934,   502,   969,   503,    -1,   121,   934,    -1,   931,
      -1,   932,    -1,   931,    -1,   932,    -1,   933,   502,  1011,
     503,   935,    -1,   933,   935,    -1,   134,   934,    -1,   133,
     934,    -1,   458,    -1,   302,   134,   934,    -1,   302,   133,
     934,    -1,   304,   934,    -1,   460,    -1,    -1,   134,   399,
    1131,    -1,    -1,   431,   502,  1011,   503,   938,    -1,   431,
     938,    -1,   430,   502,  1011,   503,   938,    -1,   430,   938,
      -1,   265,    -1,   488,   485,    -1,   470,   430,   485,    -1,
      -1,   483,    -1,   298,    -1,   176,    -1,   240,    -1,   295,
      -1,   940,    -1,   483,   432,   298,    -1,   176,   432,   240,
      -1,   176,   432,   295,    -1,   176,   432,   940,    -1,   240,
     432,   295,    -1,   240,   432,   940,    -1,   295,   432,   940,
      -1,    -1,   390,    -1,   390,   502,  1011,   503,    -1,   943,
      -1,   941,    88,   917,    -1,   941,   113,   430,   485,   941,
      -1,   493,   941,    -1,   494,   941,    -1,   941,   493,   941,
      -1,   941,   494,   941,    -1,   941,   495,   941,    -1,   941,
     496,   941,    -1,   941,   497,   941,    -1,   941,   498,   941,
      -1,   941,   490,   941,    -1,   941,   491,   941,    -1,   941,
     489,   941,    -1,   941,   966,   941,    -1,   966,   941,    -1,
     941,   966,    -1,   941,   105,   941,    -1,   941,   333,   941,
      -1,   314,   941,    -1,   941,   282,   941,    -1,   941,   282,
     941,   206,   941,    -1,   941,   314,   282,   941,    -1,   941,
     314,   282,   941,   206,   941,    -1,   941,   243,   941,    -1,
     941,   243,   941,   206,   941,    -1,   941,   314,   243,   941,
      -1,   941,   314,   243,   941,   206,   941,    -1,   941,   403,
     432,   941,    -1,   941,   403,   432,   941,   206,   941,    -1,
     941,   314,   403,   432,   941,    -1,   941,   314,   403,   432,
     941,   206,   941,    -1,   941,   268,   319,    -1,   941,   269,
      -1,   941,   268,   314,   319,    -1,   941,   317,    -1,   962,
     338,   962,    -1,   941,   268,   438,    -1,   941,   268,   314,
     438,    -1,   941,   268,   216,    -1,   941,   268,   314,   216,
      -1,   941,   268,   447,    -1,   941,   268,   314,   447,    -1,
     941,   268,   193,   227,   941,    -1,   941,   268,   314,   193,
     227,   941,    -1,   941,   268,   324,   502,   972,   503,    -1,
     941,   268,   314,   324,   502,   972,   503,    -1,   941,   118,
     994,   942,   105,   942,    -1,   941,   314,   118,   994,   942,
     105,   942,    -1,   941,   118,   419,   942,   105,   942,    -1,
     941,   314,   118,   419,   942,   105,   942,    -1,   941,   247,
     984,    -1,   941,   314,   247,   984,    -1,   941,   968,   963,
     867,    -1,   941,   968,   963,   502,   941,   503,    -1,   446,
     867,    -1,   941,   268,   195,    -1,   941,   268,   314,   195,
      -1,   943,    -1,   942,    88,   917,    -1,   493,   942,    -1,
     494,   942,    -1,   942,   493,   942,    -1,   942,   494,   942,
      -1,   942,   495,   942,    -1,   942,   496,   942,    -1,   942,
     497,   942,    -1,   942,   498,   942,    -1,   942,   490,   942,
      -1,   942,   491,   942,    -1,   942,   489,   942,    -1,   942,
     966,   942,    -1,   966,   942,    -1,   942,   966,    -1,   942,
     268,   193,   227,   942,    -1,   942,   268,   314,   193,   227,
     942,    -1,   942,   268,   324,   502,   972,   503,    -1,   942,
     268,   314,   324,   502,   972,   503,    -1,   942,   268,   195,
      -1,   942,   268,   314,   195,    -1,   990,    -1,  1010,    -1,
    1148,   993,    -1,   502,   941,   503,   993,    -1,   985,    -1,
     944,    -1,   867,    -1,   212,   867,    -1,   107,   867,    -1,
     107,   973,    -1,   962,    -1,  1009,   502,   503,   955,    -1,
    1009,   502,   970,   503,   955,    -1,  1009,   502,   459,   971,
     503,   955,    -1,  1009,   502,   970,   505,   459,   971,   503,
     955,    -1,  1009,   502,   970,   880,   503,   955,    -1,  1009,
     502,    99,   970,   879,   503,   955,    -1,  1009,   502,   193,
     970,   879,   503,   955,    -1,  1009,   502,   495,   503,   955,
      -1,   166,    -1,   169,    -1,   169,   502,  1011,   503,    -1,
     170,    -1,   170,   502,  1011,   503,    -1,   287,    -1,   287,
     502,  1011,   503,    -1,   288,    -1,   288,   502,  1011,   503,
      -1,   167,    -1,   171,    -1,   398,    -1,   451,    -1,   165,
      -1,   168,    -1,   130,   502,   941,   108,   917,   503,    -1,
     215,   502,   975,   503,    -1,   339,   502,   977,   503,    -1,
     348,   502,   979,   503,    -1,   417,   502,   980,   503,    -1,
     435,   502,   941,   108,   917,   503,    -1,   437,   502,   123,
     983,   503,    -1,   437,   502,   278,   983,   503,    -1,   437,
     502,   433,   983,   503,    -1,   437,   502,   983,   503,    -1,
     320,   502,   941,   505,   941,   503,    -1,   141,   502,   969,
     503,    -1,   234,   502,   969,   503,    -1,   279,   502,   969,
     503,    -1,   476,   502,   969,   503,    -1,   477,   502,   300,
    1133,   503,    -1,   477,   502,   300,  1133,   505,   947,   503,
      -1,   477,   502,   300,  1133,   505,   969,   503,    -1,   477,
     502,   300,  1133,   505,   947,   505,   969,   503,    -1,   478,
     502,   948,   503,    -1,   479,   502,   950,   941,   951,   503,
      -1,   480,   502,   300,  1133,   503,    -1,   480,   502,   300,
    1133,   505,   941,   503,    -1,   481,   502,   941,   505,   945,
     946,   503,    -1,   482,   502,   950,   941,   108,   919,   503,
      -1,   462,   941,    -1,   462,   306,   456,    -1,   505,   408,
     484,    -1,   505,   408,   306,    -1,   505,   408,   306,   456,
      -1,    -1,   475,   502,   948,   503,    -1,   949,    -1,   948,
     505,   949,    -1,   941,   108,  1133,    -1,   941,    -1,   195,
      -1,   153,    -1,   351,   467,    -1,   416,   467,    -1,    -1,
     468,   953,    -1,    -1,   954,    -1,   953,   505,   954,    -1,
    1131,   108,   956,    -1,   337,   956,    -1,   337,  1131,    -1,
      -1,   502,   957,   958,   879,   959,   503,    -1,  1131,    -1,
      -1,   344,   124,   969,    -1,    -1,   360,   960,    -1,   384,
     960,    -1,    -1,   961,    -1,   118,   961,   105,   961,    -1,
     442,   349,    -1,   442,   221,    -1,   164,   383,    -1,   941,
     349,    -1,   941,   221,    -1,   383,   502,   969,   503,    -1,
     383,   502,   503,    -1,   502,   969,   505,   941,   503,    -1,
     106,    -1,   406,    -1,    99,    -1,    85,    -1,   965,    -1,
     493,    -1,   494,    -1,   495,    -1,   496,    -1,   497,    -1,
     498,    -1,   490,    -1,   491,    -1,   489,    -1,    85,    -1,
     330,   502,   771,   503,    -1,   964,    -1,   330,   502,   771,
     503,    -1,   964,    -1,   330,   502,   771,   503,    -1,   282,
      -1,   314,   282,    -1,   243,    -1,   314,   243,    -1,   941,
      -1,   969,   505,   941,    -1,   971,    -1,   970,   505,   971,
      -1,   941,    -1,   753,    90,   941,    -1,   917,    -1,   972,
     505,   917,    -1,   500,   969,   501,    -1,   500,   974,   501,
      -1,   500,   501,    -1,   973,    -1,   974,   505,   973,    -1,
     976,   227,   941,    -1,    -1,  1153,    -1,   483,    -1,   298,
      -1,   176,    -1,   240,    -1,   295,    -1,   390,    -1,  1151,
      -1,   941,   978,   981,   982,    -1,   941,   978,   981,    -1,
     346,   941,    -1,   942,   247,   942,    -1,    -1,   941,   981,
     982,    -1,   941,   982,   981,    -1,   941,   981,    -1,   941,
     982,    -1,   969,    -1,    -1,   227,   941,    -1,   222,   941,
      -1,   941,   227,   969,    -1,   227,   969,    -1,   969,    -1,
     867,    -1,   502,   969,   503,    -1,   129,   989,   986,   988,
     204,    -1,   987,    -1,   986,   987,    -1,   465,   941,   429,
     941,    -1,   200,   941,    -1,    -1,   941,    -1,    -1,  1131,
      -1,  1131,   992,    -1,   504,  1006,    -1,   504,   495,    -1,
     500,   941,   501,    -1,   500,   941,   507,   941,   501,    -1,
     991,    -1,   992,   991,    -1,    -1,   993,   991,    -1,   112,
      -1,    -1,   941,    -1,   181,    -1,   995,    -1,   996,   505,
     995,    -1,   502,   996,   503,    -1,   999,    -1,   998,   505,
     999,    -1,   941,   108,  1133,    -1,   941,  1153,    -1,   941,
      -1,   495,    -1,  1001,    -1,  1000,   505,  1001,    -1,  1131,
      -1,  1131,   992,    -1,  1003,    -1,  1002,   505,  1003,    -1,
    1131,    -1,  1131,    -1,  1131,    -1,  1133,    -1,  1131,    -1,
    1151,    -1,  1132,    -1,  1131,   992,    -1,  1011,    -1,  1150,
      -1,  1151,    -1,  1149,    -1,    84,    -1,  1009,  1151,    -1,
    1009,   502,   970,   503,  1151,    -1,   920,  1151,    -1,   937,
    1151,   939,    -1,   937,   502,  1011,   503,  1151,   939,    -1,
     438,    -1,   216,    -1,   319,    -1,  1145,    -1,  1143,    -1,
      86,    -1,  1131,    -1,  1011,    -1,  1145,    -1,   493,  1011,
      -1,   494,  1011,    -1,    91,    -1,    92,    -1,    93,    -1,
      94,    -1,    95,    -1,    96,    -1,    97,    -1,    98,    -1,
     100,    -1,   101,    -1,   102,    -1,   110,    -1,   111,    -1,
     113,    -1,   115,    -1,   116,    -1,   117,    -1,   124,    -1,
     125,    -1,   126,    -1,   127,    -1,   128,    -1,   131,    -1,
     132,    -1,   135,    -1,   137,    -1,   138,    -1,   139,    -1,
     140,    -1,   144,    -1,   145,    -1,   146,    -1,   147,    -1,
     149,    -1,   152,    -1,   153,    -1,   154,    -1,   155,    -1,
     156,    -1,   157,    -1,   159,    -1,   160,    -1,   161,    -1,
     163,    -1,   172,    -1,   173,    -1,   174,    -1,   175,    -1,
     177,    -1,   180,    -1,   182,    -1,   184,    -1,   185,    -1,
     186,    -1,   187,    -1,   188,    -1,   190,    -1,   191,    -1,
     192,    -1,   195,    -1,   196,    -1,   197,    -1,   198,    -1,
     199,    -1,   201,    -1,   202,    -1,   203,    -1,   205,    -1,
     206,    -1,   208,    -1,   209,    -1,   210,    -1,   211,    -1,
     213,    -1,   214,    -1,   217,    -1,   219,    -1,   221,    -1,
     223,    -1,   225,    -1,   229,    -1,   230,    -1,   231,    -1,
     233,    -1,   236,    -1,   238,    -1,   239,    -1,   241,    -1,
     242,    -1,   244,    -1,   245,    -1,   246,    -1,   248,    -1,
     249,    -1,   250,    -1,   251,    -1,   252,    -1,   253,    -1,
     255,    -1,   259,    -1,   260,    -1,   261,    -1,   267,    -1,
     270,    -1,   272,    -1,   273,    -1,   274,    -1,   275,    -1,
     276,    -1,   277,    -1,   281,    -1,   284,    -1,   285,    -1,
     286,    -1,   289,    -1,   290,    -1,   291,    -1,   292,    -1,
     293,    -1,   294,    -1,   296,    -1,   297,    -1,   299,    -1,
     300,    -1,   301,    -1,   305,    -1,   306,    -1,   307,    -1,
     308,    -1,   309,    -1,   310,    -1,   311,    -1,   313,    -1,
     315,    -1,   316,    -1,   318,    -1,   321,    -1,   323,    -1,
     324,    -1,   325,    -1,   327,    -1,   330,    -1,   331,    -1,
     332,    -1,   340,    -1,   341,    -1,   342,    -1,   343,    -1,
     344,    -1,   345,    -1,   347,    -1,   349,    -1,   352,    -1,
     353,    -1,   351,    -1,   355,    -1,   356,    -1,   357,    -1,
     358,    -1,   359,    -1,   360,    -1,   361,    -1,   363,    -1,
     364,    -1,   365,    -1,   367,    -1,   368,    -1,   369,    -1,
     370,    -1,   371,    -1,   372,    -1,   373,    -1,   374,    -1,
     375,    -1,   376,    -1,   378,    -1,   379,    -1,   381,    -1,
     382,    -1,   384,    -1,   385,    -1,   386,    -1,   387,    -1,
     388,    -1,   389,    -1,   391,    -1,   393,    -1,   394,    -1,
     395,    -1,   396,    -1,   397,    -1,   399,    -1,   401,    -1,
     402,    -1,   404,    -1,   407,    -1,   408,    -1,   409,    -1,
     410,    -1,   411,    -1,   412,    -1,   413,    -1,   414,    -1,
     415,    -1,   416,    -1,   418,    -1,   420,    -1,   421,    -1,
     423,    -1,   424,    -1,   425,    -1,   426,    -1,   427,    -1,
     428,    -1,   434,    -1,   436,    -1,   439,    -1,   440,    -1,
     441,    -1,   442,    -1,   443,    -1,   444,    -1,   447,    -1,
     448,    -1,   449,    -1,   450,    -1,   453,    -1,   454,    -1,
     455,    -1,   456,    -1,   460,    -1,   462,    -1,   463,    -1,
     464,    -1,   467,    -1,   470,    -1,   471,    -1,   472,    -1,
     473,    -1,   474,    -1,   484,    -1,   485,    -1,   118,    -1,
     119,    -1,   121,    -1,   122,    -1,   134,    -1,   141,    -1,
     178,    -1,   179,    -1,   212,    -1,   215,    -1,   220,    -1,
     234,    -1,   257,    -1,   263,    -1,   265,    -1,   279,    -1,
     302,    -1,   304,    -1,   312,    -1,   320,    -1,   322,    -1,
     335,    -1,   339,    -1,   348,    -1,   350,    -1,   362,    -1,
     383,    -1,   400,    -1,   405,    -1,   417,    -1,   430,    -1,
     431,    -1,   435,    -1,   437,    -1,   458,    -1,   475,    -1,
     476,    -1,   477,    -1,   478,    -1,   479,    -1,   480,    -1,
     481,    -1,   482,    -1,   114,    -1,   120,    -1,   148,    -1,
     162,    -1,   168,    -1,   226,    -1,   228,    -1,   243,    -1,
     256,    -1,   268,    -1,   269,    -1,   271,    -1,   280,    -1,
     282,    -1,   303,    -1,   317,    -1,   336,    -1,   337,    -1,
     338,    -1,   380,    -1,   403,    -1,   461,    -1,    99,    -1,
     103,    -1,   104,    -1,   105,    -1,   106,    -1,   107,    -1,
     108,    -1,   109,    -1,   112,    -1,   123,    -1,   129,    -1,
     130,    -1,   136,    -1,   142,    -1,   143,    -1,   151,    -1,
     158,    -1,   165,    -1,   166,    -1,   167,    -1,   169,    -1,
     170,    -1,   171,    -1,   181,    -1,   183,    -1,   189,    -1,
     193,    -1,   194,    -1,   200,    -1,   204,    -1,   207,    -1,
     216,    -1,   218,    -1,   222,    -1,   224,    -1,   227,    -1,
     232,    -1,   235,    -1,   237,    -1,   247,    -1,   254,    -1,
     264,    -1,   266,    -1,   278,    -1,   283,    -1,   287,    -1,
     288,    -1,   314,    -1,   319,    -1,   326,    -1,   328,    -1,
     329,    -1,   333,    -1,   334,    -1,   346,    -1,   354,    -1,
     366,    -1,   377,    -1,   392,    -1,   398,    -1,   406,    -1,
     419,    -1,   422,    -1,   429,    -1,   433,    -1,   438,    -1,
     446,    -1,   451,    -1,   452,    -1,   459,    -1,   465,    -1,
     466,    -1,   468,    -1,   469,    -1,    -1,  1018,  1019,    -1,
    1140,  1022,   512,   506,    -1,  1140,   512,   506,    -1,  1140,
    1042,    -1,  1047,    -1,  1159,    -1,    73,    -1,   508,    -1,
     509,    -1,    -1,   158,   580,   422,   614,   108,  1021,   866,
     618,    -1,   113,  1083,    -1,     9,   432,  1024,  1031,  1032,
      -1,     9,   432,   181,    -1,     9,  1033,    -1,   175,  1024,
      -1,  1025,  1028,  1030,    -1,  1026,   507,  1027,  1030,   496,
    1025,  1036,    -1,  1035,    -1,  1151,    -1,  1004,    -1,    -1,
    1153,  1147,    -1,    85,  1029,    -1,  1027,    -1,    -1,  1131,
      -1,  1131,   504,  1029,    -1,    74,    -1,   507,  1011,    -1,
      -1,   108,  1083,    -1,    -1,   451,  1033,    -1,    -1,  1034,
      -1,  1034,   496,  1034,    -1,  1034,    21,   124,  1034,    -1,
    1034,   452,  1034,    -1,  1012,    -1,  1151,    -1,  1145,    -1,
    1147,    -1,    85,  1037,    -1,    -1,  1131,  1038,    -1,  1131,
    1038,    85,  1037,    -1,    -1,   489,  1011,    -1,   489,  1153,
      -1,   489,  1145,    -1,  1003,    -1,  1035,    -1,   180,   863,
     864,   172,   865,   222,  1039,    -1,   211,   244,  1084,    -1,
    1043,    -1,  1054,    -1,  1056,    -1,   625,    -1,   505,   625,
      -1,    -1,   939,    -1,   483,   432,   295,    -1,   483,   432,
     390,    -1,   176,   432,   176,    -1,   298,   432,   298,    -1,
      -1,  1049,  1048,  1051,  1050,    -1,  1140,   117,   180,    34,
     506,    -1,  1140,   204,   180,    34,   506,    -1,    -1,  1052,
      -1,  1043,    -1,    73,    -1,  1052,  1043,    -1,  1052,    73,
      -1,  1056,    -1,  1053,  1056,    -1,    -1,    70,  1055,  1063,
    1079,  1135,   918,   506,    -1,    -1,  1060,  1063,  1057,  1076,
     506,    -1,    -1,  1063,  1058,  1076,   506,    -1,  1066,   506,
      -1,   507,  1011,    -1,    -1,  1061,  1062,    -1,  1061,    -1,
    1062,    -1,    56,    -1,    67,    -1,    65,    -1,    50,    -1,
      51,    -1,    69,    -1,  1072,    -1,  1068,    -1,  1064,    -1,
    1135,   502,  1044,  1045,   503,    -1,  1135,  1046,    -1,  1070,
      -1,   205,  1129,  1065,    -1,   205,  1065,    -1,   205,  1129,
      -1,   508,  1157,   509,    -1,    -1,  1070,  1067,   508,  1053,
     509,    -1,  1066,    -1,    -1,  1071,  1069,   508,  1053,   509,
      -1,    43,  1129,    -1,   445,  1129,    -1,    43,    -1,   445,
      -1,  1073,    -1,  1075,  1074,    -1,    44,    35,    -1,    44,
      35,   262,    -1,    44,    -1,    44,   262,    -1,    44,    25,
      -1,    44,    25,   262,    -1,    44,    25,    25,    -1,    44,
      25,    25,   262,    -1,    44,   133,    -1,    35,    -1,    35,
     262,    -1,   262,    -1,    25,    -1,    25,   262,    -1,    25,
      25,    -1,    25,    25,   262,    -1,     5,    -1,   133,    -1,
     197,    -1,    36,    -1,    -1,  1077,    -1,  1076,   505,  1077,
      -1,  1079,  1134,   918,  1059,  1078,    -1,    -1,   489,  1158,
      -1,    -1,   495,    -1,   495,   495,    -1,   180,   410,  1153,
      -1,    15,  1082,    -1,  1083,    -1,   164,    -1,    99,    -1,
      -1,  1004,    -1,   181,    -1,  1035,    -1,  1035,    -1,    71,
      -1,    17,   863,    -1,    17,    99,    -1,    28,   863,  1087,
      -1,    -1,  1088,    -1,   452,  1092,    -1,  1089,    -1,   452,
      37,    14,  1154,    -1,   452,    14,  1003,    -1,   266,    37,
      14,  1154,    -1,   266,    14,  1003,    -1,   266,  1003,    -1,
    1093,    -1,  1093,   505,  1092,    -1,  1094,    -1,  1145,    -1,
    1143,    -1,  1011,    -1,   493,  1011,    -1,   494,  1011,    -1,
    1150,    -1,   493,  1150,    -1,   494,  1150,    -1,  1151,    -1,
    1149,    -1,  1152,    -1,    13,   258,  1039,  1089,    -1,    13,
    1096,  1039,  1089,    -1,    13,  1096,  1039,  1090,    -1,    13,
     258,  1039,  1091,    -1,    13,  1096,  1039,  1091,    -1,    29,
      -1,    -1,     3,    14,  1154,    -1,   177,    14,  1154,    -1,
      18,    14,  1154,  1100,    -1,  1101,    -1,  1100,   505,  1101,
      -1,  1147,   489,  1106,    -1,   399,    14,  1154,  1103,    -1,
    1104,    -1,  1103,   505,  1104,    -1,  1106,   489,  1105,    -1,
    1011,    -1,  1147,    -1,    10,    -1,    18,    14,  1154,   456,
    1105,  1108,    -1,  1109,    -1,  1108,   505,  1109,    -1,  1147,
     489,  1114,    -1,   399,    14,  1154,   456,  1105,  1111,    -1,
    1112,    -1,  1111,   505,  1112,    -1,  1114,   489,  1113,    -1,
    1150,    -1,  1105,    -1,   494,  1150,    -1,   494,  1011,    -1,
    1151,    -1,     8,    -1,   174,    -1,    11,    -1,    12,    -1,
      22,    -1,    23,    -1,    24,    -1,   300,    -1,    26,    -1,
      27,    -1,   350,    -1,    31,    -1,    32,    -1,    33,    -1,
     441,    -1,   399,     4,   489,  1116,    -1,   399,     4,   432,
    1116,    -1,   328,    -1,   325,    -1,   399,   150,   432,  1083,
      -1,   399,   150,   489,  1083,    -1,   399,   150,  1083,    -1,
      -1,   441,  1119,  1135,   268,  1063,   918,  1120,    -1,    30,
      -1,    -1,    -1,    45,  1122,  1133,   268,  1063,   918,  1120,
      -1,    46,    38,  1124,    -1,    46,   314,    16,  1124,    -1,
      46,    40,  1124,    -1,   154,    -1,    39,    -1,    42,    -1,
      20,  1003,    -1,    19,   432,  1003,    -1,   194,  1003,   502,
    1141,   503,    -1,   194,     6,    -1,     7,  1003,   502,  1141,
     503,    -1,     7,  1003,    -1,  1126,    -1,  1127,    -1,     6,
      -1,     7,    -1,     8,    -1,    10,    -1,    11,    -1,    12,
      -1,    16,    -1,    19,    -1,    20,    -1,    21,    -1,    22,
      -1,    23,    -1,    24,    -1,    26,    -1,    27,    -1,    31,
      -1,    32,    -1,    33,    -1,    34,    -1,    37,    -1,    38,
      -1,    39,    -1,    40,    -1,    42,    -1,     9,    -1,    13,
      -1,    15,    -1,    28,    -1,    45,    -1,    46,    -1,     5,
      -1,    25,    -1,    29,    -1,    35,    -1,    43,    -1,    36,
      -1,    44,    -1,  1133,    -1,  1153,    -1,  1014,    -1,  1015,
      -1,  1138,    -1,  1125,    -1,  1136,    -1,   133,    -1,   457,
      -1,  1153,    -1,  1137,    -1,  1015,    -1,  1125,    -1,  1136,
      -1,   133,    -1,   457,    -1,  1153,    -1,  1137,    -1,  1016,
      -1,  1125,    -1,  1136,    -1,  1128,    -1,  1134,    -1,  1128,
      -1,   133,    -1,   164,    -1,   258,    -1,   262,    -1,   432,
      -1,   445,    -1,   457,    -1,  1136,    -1,  1138,    -1,  1135,
      -1,  1014,    -1,  1017,    -1,  1127,    -1,   150,    -1,  1153,
      -1,  1015,    -1,  1016,    -1,  1126,    -1,    50,    -1,    51,
      -1,    56,    -1,    65,    -1,    67,    -1,    70,    -1,    69,
      -1,  1014,    -1,  1138,    -1,   150,    -1,   176,    -1,   240,
      -1,   295,    -1,   298,    -1,   390,    -1,   483,    -1,  1142,
      -1,  1139,   505,  1142,    -1,    41,    -1,    -1,  1157,    -1,
    1147,  1146,    -1,  1147,    -1,  1147,  1146,    -1,  1035,    -1,
    1147,    -1,  1147,    -1,    22,  1147,    -1,    22,  1003,    -1,
      72,    -1,    87,    -1,    83,    -1,    81,    -1,    82,    -1,
      76,    -1,    77,    -1,    78,    -1,    75,    -1,    84,    -1,
      80,    -1,    71,    -1,    79,    -1,  1003,    -1,  1035,    -1,
    1160,    -1,   502,   503,    -1,   502,  1156,   503,    -1,  1155,
      -1,  1156,  1155,    -1,  1158,    -1,  1157,   505,  1158,    -1,
    1156,    -1,   508,  1157,   509,    -1,  1160,    -1,   502,    -1,
     503,    -1,   505,    -1,   506,    -1,  1153,    -1,  1011,    -1,
    1150,    -1,  1151,    -1,   495,    -1,   493,    -1,   494,    -1,
     496,    -1,   497,    -1,   319,    -1,    47,    -1,    48,    -1,
      49,    -1,    50,    -1,    51,    -1,    52,    -1,    53,    -1,
      54,    -1,    55,    -1,    56,    -1,    57,    -1,    58,    -1,
      60,    -1,    59,    -1,    61,    -1,    62,    -1,    63,    -1,
      64,    -1,    65,    -1,    66,    -1,    67,    -1,    68,    -1,
      70,    -1,    69,    -1,     5,    -1,   205,    -1,   240,    -1,
     262,    -1,    25,    -1,   295,    -1,   298,    -1,   390,    -1,
      35,    -1,    36,    -1,    43,    -1,    44,    -1,   483,    -1,
     133,    -1,   220,    -1,   432,    -1,   445,    -1,   458,    -1,
     500,    -1,   501,    -1,   489,    -1,   507,    -1,   177,  1039,
      -1,   177,   352,  1039,    -1,   177,    99,    -1,   177,   352,
      99,    -1,  1011,    -1,   502,  1162,   503,    -1,  1162,   493,
    1162,    -1,  1162,   494,  1162,    -1,  1162,   495,  1162,    -1,
    1162,   496,  1162,    -1,  1162,   497,  1162,    -1,  1151,    -1,
    1131,    -1,    -1,  1088,  1164,    -1,  1164,  1088,    -1,  1088,
      -1,  1164,    -1,   266,  1139,    -1,  1090,    -1,  1164,    -1,
    1089,    -1,    -1,  1165,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,  1340,  1340,  1343,  1345,  1347,  1349,  1351,  1353,  1355,
    1357,  1359,  1361,  1363,  1365,  1367,  1369,  1371,  1373,  1375,
    1377,  1379,  1381,  1383,  1385,  1403,  1405,  1407,  1409,  1411,
    1413,  1415,  1417,  1419,  1421,  1423,  1425,  1427,  1429,  1431,
    1433,  1435,  1437,  1439,  1441,  1443,  1445,  1447,  1449,  1451,
    1453,  1455,  1459,  1461,  1463,  1465,  1467,  1469,  1471,  1473,
    1475,  1477,  1479,  1481,  1483,  1485,  1487,  1489,  1491,  1493,
    1495,  1497,  1499,  1501,  1503,  1505,  1507,  1509,  1511,  1513,
    1515,  1517,  1519,  1521,  1523,  1525,  1532,  1534,  1536,  1538,
    1540,  1542,  1544,  1546,  1548,  1550,  1552,  1558,  1560,  1562,
    1564,  1566,  1568,  1570,  1572,  1574,  1580,  1590,  1594,  1600,
    1604,  1614,  1624,  1625,  1639,  1646,  1652,  1663,  1669,  1678,
    1685,  1691,  1700,  1707,  1715,  1720,  1728,  1733,  1739,  1744,
    1750,  1755,  1761,  1765,  1769,  1773,  1777,  1781,  1785,  1789,
    1793,  1797,  1801,  1805,  1809,  1813,  1817,  1821,  1825,  1829,
    1833,  1841,  1845,  1849,  1853,  1857,  1861,  1869,  1877,  1886,
    1888,  1896,  1904,  1912,  1920,  1924,  1932,  1936,  1944,  1952,
    1960,  1964,  1972,  1976,  1984,  1988,  1996,  2001,  2007,  2012,
    2018,  2022,  2026,  2030,  2034,  2038,  2046,  2050,  2054,  2062,
    2066,  2070,  2074,  2078,  2082,  2086,  2090,  2094,  2099,  2103,
    2107,  2111,  2115,  2119,  2127,  2131,  2139,  2143,  2151,  2155,
    2169,  2173,  2177,  2181,  2189,  2193,  2197,  2201,  2209,  2213,
    2217,  2221,  2225,  2229,  2233,  2241,  2245,  2250,  2256,  2260,
    2268,  2272,  2276,  2280,  2284,  2292,  2296,  2304,  2308,  2312,
    2316,  2320,  2329,  2337,  2341,  2349,  2353,  2361,  2369,  2373,
    2377,  2381,  2389,  2393,  2397,  2401,  2409,  2413,  2421,  2425,
    2429,  2433,  2437,  2441,  2445,  2449,  2453,  2457,  2461,  2465,
    2469,  2473,  2477,  2481,  2485,  2489,  2493,  2497,  2501,  2505,
    2509,  2513,  2517,  2521,  2525,  2529,  2533,  2537,  2541,  2545,
    2549,  2553,  2557,  2561,  2565,  2573,  2577,  2585,  2589,  2594,
    2600,  2605,  2611,  2619,  2624,  2630,  2634,  2642,  2646,  2650,
    2654,  2662,  2667,  2675,  2686,  2697,  2701,  2709,  2713,  2717,
    2725,  2729,  2737,  2742,  2748,  2752,  2756,  2760,  2764,  2768,
    2772,  2776,  2780,  2784,  2788,  2796,  2801,  2807,  2812,  2818,
    2823,  2829,  2834,  2840,  2844,  2852,  2860,  2864,  2868,  2872,
    2877,  2883,  2887,  2895,  2903,  2907,  2915,  2919,  2923,  2927,
    2931,  2935,  2940,  2946,  2951,  2957,  2962,  2968,  2972,  2980,
    2984,  2992,  2996,  3000,  3008,  3012,  3020,  3028,  3036,  3041,
    3047,  3051,  3055,  3063,  3067,  3071,  3075,  3079,  3083,  3087,
    3095,  3099,  3103,  3107,  3115,  3123,  3127,  3132,  3138,  3142,
    3146,  3150,  3154,  3158,  3166,  3170,  3178,  3183,  3187,  3191,
    3195,  3203,  3208,  3214,  3218,  3226,  3234,  3238,  3243,  3248,
    3254,  3258,  3266,  3270,  3278,  3283,  3289,  3293,  3297,  3301,
    3306,  3312,  3320,  3328,  3332,  3336,  3340,  3344,  3352,  3357,
    3363,  3367,  3371,  3376,  3382,  3386,  3390,  3395,  3401,  3406,
    3412,  3417,  3423,  3431,  3436,  3442,  3446,  3454,  3462,  3466,
    3471,  3477,  3485,  3493,  3498,  3504,  3508,  3516,  3520,  3524,
    3528,  3532,  3536,  3540,  3544,  3548,  3552,  3556,  3560,  3568,
    3573,  3579,  3583,  3587,  3595,  3599,  3607,  3611,  3619,  3624,
    3630,  3634,  3642,  3647,  3653,  3657,  3665,  3670,  3676,  3680,
    3688,  3693,  3699,  3707,  3712,  3718,  3722,  3730,  3738,  3742,
    3750,  3754,  3758,  3766,  3771,  3777,  3781,  3789,  3797,  3801,
    3809,  3813,  3817,  3821,  3829,  3837,  3845,  3853,  3861,  3866,
    3872,  3876,  3884,  3889,  3895,  3899,  3907,  3911,  3915,  3923,
    3931,  3935,  3939,  3947,  3951,  3959,  3967,  3971,  3979,  3983,
    3991,  3995,  4003,  4007,  4011,  4015,  4019,  4027,  4032,  4038,
    4043,  4049,  4053,  4061,  4066,  4072,  4076,  4081,  4087,  4091,
    4095,  4099,  4103,  4107,  4115,  4120,  4126,  4130,  4137,  4141,
    4149,  4155,  4159,  4167,  4171,  4179,  4183,  4191,  4200,  4209,
    4213,  4217,  4221,  4225,  4229,  4233,  4237,  4241,  4245,  4249,
    4257,  4265,  4269,  4277,  4281,  4289,  4293,  4297,  4301,  4305,
    4313,  4317,  4325,  4333,  4337,  4345,  4353,  4358,  4364,  4368,
    4376,  4384,  4388,  4396,  4400,  4404,  4408,  4412,  4420,  4425,
    4431,  4436,  4442,  4448,  4454,  4462,  4466,  4474,  4478,  4486,
    4490,  4498,  4502,  4510,  4514,  4522,  4530,  4538,  4542,  4550,
    4554,  4558,  4562,  4566,  4570,  4574,  4578,  4582,  4586,  4590,
    4594,  4602,  4606,  4614,  4618,  4626,  4630,  4638,  4646,  4650,
    4655,  4661,  4665,  4669,  4673,  4677,  4681,  4685,  4689,  4693,
    4697,  4701,  4705,  4709,  4713,  4717,  4721,  4725,  4733,  4737,
    4741,  4745,  4749,  4753,  4757,  4761,  4765,  4769,  4773,  4777,
    4785,  4789,  4797,  4801,  4805,  4809,  4815,  4821,  4827,  4833,
    4839,  4845,  4851,  4861,  4872,  4883,  4894,  4905,  4916,  4927,
    4943,  4959,  4975,  4986,  5002,  5013,  5029,  5044,  5048,  5056,
    5061,  5067,  5075,  5079,  5087,  5091,  5095,  5099,  5103,  5111,
    5115,  5123,  5127,  5131,  5135,  5143,  5147,  5151,  5155,  5159,
    5163,  5167,  5171,  5175,  5179,  5183,  5187,  5191,  5195,  5203,
    5207,  5215,  5219,  5227,  5232,  5238,  5242,  5250,  5258,  5266,
    5270,  5278,  5283,  5289,  5294,  5300,  5308,  5313,  5319,  5323,
    5327,  5335,  5339,  5343,  5351,  5355,  5359,  5367,  5375,  5380,
    5386,  5391,  5397,  5402,  5408,  5413,  5419,  5423,  5431,  5435,
    5439,  5447,  5451,  5456,  5462,  5466,  5471,  5477,  5481,  5486,
    5492,  5496,  5500,  5508,  5513,  5519,  5523,  5531,  5535,  5543,
    5547,  5555,  5559,  5567,  5571,  5575,  5579,  5583,  5591,  5595,
    5599,  5603,  5607,  5615,  5623,  5631,  5635,  5639,  5647,  5651,
    5655,  5663,  5667,  5675,  5679,  5683,  5687,  5691,  5695,  5699,
    5703,  5707,  5711,  5715,  5719,  5723,  5731,  5735,  5739,  5743,
    5751,  5755,  5763,  5768,  5774,  5782,  5786,  5794,  5802,  5806,
    5814,  5819,  5825,  5829,  5837,  5841,  5849,  5853,  5861,  5865,
    5869,  5873,  5881,  5885,  5893,  5901,  5905,  5913,  5917,  5925,
    5929,  5933,  5941,  5945,  5950,  5956,  5964,  5969,  5975,  5979,
    5983,  5991,  5995,  6003,  6008,  6014,  6018,  6022,  6026,  6030,
    6034,  6038,  6042,  6046,  6050,  6054,  6058,  6062,  6066,  6070,
    6074,  6078,  6082,  6086,  6090,  6094,  6098,  6102,  6106,  6110,
    6118,  6123,  6129,  6134,  6140,  6144,  6148,  6152,  6156,  6160,
    6164,  6172,  6176,  6180,  6184,  6188,  6192,  6196,  6200,  6204,
    6208,  6212,  6216,  6220,  6224,  6228,  6232,  6236,  6244,  6252,
    6256,  6260,  6268,  6272,  6280,  6284,  6288,  6292,  6296,  6304,
    6309,  6315,  6319,  6323,  6327,  6335,  6339,  6344,  6350,  6354,
    6362,  6370,  6375,  6381,  6389,  6393,  6401,  6405,  6409,  6413,
    6417,  6421,  6425,  6429,  6433,  6437,  6441,  6445,  6449,  6453,
    6461,  6465,  6470,  6476,  6480,  6484,  6492,  6496,  6500,  6508,
    6513,  6519,  6523,  6531,  6536,  6541,  6547,  6553,  6561,  6569,
    6574,  6580,  6584,  6588,  6592,  6596,  6600,  6604,  6608,  6612,
    6616,  6620,  6624,  6628,  6632,  6636,  6640,  6648,  6653,  6659,
    6663,  6671,  6679,  6684,  6690,  6698,  6702,  6710,  6718,  6722,
    6726,  6730,  6734,  6742,  6747,  6753,  6761,  6765,  6769,  6773,
    6777,  6781,  6789,  6797,  6801,  6805,  6813,  6818,  6824,  6828,
    6832,  6836,  6840,  6848,  6852,  6860,  6864,  6868,  6872,  6880,
    6884,  6892,  6896,  6904,  6909,  6915,  6920,  6926,  6931,  6937,
    6942,  6948,  6952,  6956,  6960,  6968,  6972,  6976,  6980,  6984,
    6988,  6992,  7000,  7004,  7012,  7020,  7024,  7028,  7036,  7040,
    7045,  7051,  7057,  7067,  7072,  7078,  7082,  7086,  7090,  7098,
    7100,  7108,  7113,  7119,  7127,  7131,  7135,  7143,  7147,  7155,
    7163,  7168,  7174,  7182,  7187,  7193,  7201,  7206,  7212,  7216,
    7220,  7224,  7228,  7232,  7236,  7240,  7248,  7253,  7259,  7267,
    7271,  7279,  7283,  7291,  7299,  7307,  7315,  7319,  7327,  7379,
    7383,  7396,  7398,  7402,  7406,  7410,  7419,  7425,  7429,  7437,
    7441,  7449,  7453,  7461,  7465,  7469,  7473,  7477,  7481,  7485,
    7489,  7497,  7501,  7509,  7513,  7517,  7521,  7525,  7529,  7537,
    7541,  7549,  7553,  7561,  7569,  7574,  7576,  7582,  7586,  7590,
    7594,  7598,  7602,  7606,  7610,  7618,  7623,  7629,  7633,  7638,
    7644,  7648,  7652,  7657,  7663,  7668,  7674,  7682,  7686,  7694,
    7698,  7706,  7710,  7714,  7718,  7726,  7731,  7737,  7741,  7746,
    7754,  7758,  7766,  7770,  7778,  7786,  7790,  7795,  7801,  7809,
    7813,  7821,  7825,  7833,  7838,  7844,  7849,  7855,  7859,  7867,
    7872,  7878,  7882,  7890,  7894,  7902,  7907,  7913,  7917,  7925,
    7930,  7936,  7940,  7948,  7952,  7956,  7960,  7964,  7968,  7972,
    7976,  7982,  7986,  7990,  7998,  8002,  8006,  8010,  8014,  8018,
    8026,  8030,  8034,  8038,  8046,  8050,  8054,  8058,  8066,  8071,
    8077,  8081,  8089,  8093,  8097,  8101,  8109,  8113,  8121,  8125,
    8129,  8137,  8145,  8150,  8156,  8160,  8165,  8171,  8175,  8183,
    8191,  8193,  8195,  8199,  8203,  8207,  8215,  8225,  8236,  8245,
    8249,  8253,  8257,  8261,  8265,  8269,  8277,  8281,  8285,  8289,
    8297,  8301,  8309,  8314,  8320,  8324,  8328,  8332,  8336,  8340,
    8344,  8348,  8352,  8356,  8360,  8368,  8373,  8379,  8383,  8391,
    8395,  8403,  8411,  8419,  8423,  8431,  8435,  8443,  8451,  8459,
    8463,  8467,  8471,  8475,  8479,  8487,  8492,  8498,  8503,  8509,
    8513,  8517,  8521,  8529,  8537,  8541,  8546,  8552,  8556,  8560,
    8564,  8568,  8572,  8576,  8580,  8584,  8588,  8592,  8596,  8600,
    8605,  8611,  8615,  8623,  8627,  8631,  8635,  8639,  8643,  8647,
    8651,  8655,  8659,  8663,  8667,  8671,  8675,  8679,  8683,  8687,
    8691,  8695,  8699,  8703,  8707,  8711,  8715,  8719,  8723,  8727,
    8731,  8735,  8739,  8743,  8747,  8751,  8755,  8759,  8763,  8767,
    8771,  8775,  8779,  8783,  8787,  8791,  8795,  8799,  8803,  8807,
    8811,  8815,  8819,  8823,  8827,  8831,  8835,  8839,  8843,  8848,
    8852,  8860,  8864,  8868,  8872,  8876,  8880,  8884,  8888,  8892,
    8896,  8900,  8904,  8908,  8912,  8916,  8920,  8924,  8928,  8932,
    8936,  8940,  8944,  8952,  8956,  8960,  8964,  8968,  8972,  8976,
    8980,  8984,  8988,  8992,  9000,  9004,  9008,  9012,  9016,  9020,
    9024,  9028,  9032,  9036,  9040,  9044,  9048,  9052,  9056,  9060,
    9064,  9068,  9072,  9076,  9080,  9084,  9088,  9092,  9096,  9100,
    9104,  9108,  9112,  9116,  9120,  9124,  9128,  9132,  9136,  9140,
    9144,  9148,  9152,  9156,  9160,  9164,  9168,  9172,  9176,  9180,
    9184,  9188,  9196,  9200,  9208,  9212,  9216,  9221,  9227,  9235,
    9239,  9247,  9251,  9259,  9263,  9271,  9275,  9280,  9286,  9291,
    9297,  9301,  9309,  9317,  9321,  9326,  9332,  9340,  9344,  9351,
    9356,  9362,  9367,  9372,  9378,  9382,  9390,  9394,  9398,  9402,
    9406,  9414,  9418,  9422,  9430,  9434,  9438,  9446,  9450,  9458,
    9462,  9466,  9470,  9474,  9478,  9482,  9486,  9490,  9498,  9502,
    9510,  9514,  9522,  9526,  9530,  9534,  9538,  9542,  9550,  9554,
    9562,  9566,  9574,  9578,  9586,  9590,  9598,  9602,  9606,  9614,
    9618,  9626,  9631,  9637,  9641,  9645,  9649,  9653,  9657,  9661,
    9665,  9673,  9677,  9685,  9693,  9698,  9704,  9708,  9712,  9716,
    9720,  9725,  9731,  9739,  9747,  9751,  9755,  9763,  9767,  9775,
    9783,  9787,  9795,  9803,  9808,  9814,  9819,  9825,  9829,  9837,
    9841,  9845,  9849,  9857,  9861,  9870,  9872,  9880,  9885,  9891,
    9895,  9903,  9907,  9915,  9923,  9927,  9935,  9939,  9943,  9947,
    9955,  9959,  9967,  9971,  9979,  9983,  9991,  9999, 10007, 10015,
   10023, 10031, 10039, 10043, 10051, 10055, 10059, 10063, 10067, 10071,
   10075, 10079, 10083, 10087, 10091, 10095, 10099, 10103, 10104, 10109,
   10115, 10123, 10127, 10128, 10132, 10140, 10144, 10148, 10152, 10156,
   10160, 10164, 10168, 10172, 10176, 10180, 10184, 10188, 10192, 10196,
   10200, 10204, 10208, 10212, 10216, 10220, 10224, 10228, 10232, 10236,
   10240, 10244, 10248, 10252, 10256, 10260, 10264, 10268, 10272, 10276,
   10280, 10284, 10288, 10292, 10296, 10300, 10304, 10308, 10312, 10316,
   10320, 10324, 10328, 10332, 10336, 10340, 10344, 10348, 10352, 10356,
   10360, 10364, 10368, 10372, 10376, 10380, 10384, 10388, 10392, 10396,
   10400, 10404, 10408, 10412, 10416, 10420, 10424, 10428, 10432, 10436,
   10440, 10444, 10448, 10452, 10456, 10460, 10464, 10468, 10472, 10476,
   10480, 10484, 10488, 10492, 10496, 10500, 10504, 10508, 10512, 10516,
   10520, 10524, 10528, 10532, 10536, 10540, 10544, 10548, 10552, 10556,
   10560, 10564, 10568, 10572, 10576, 10580, 10584, 10588, 10592, 10596,
   10600, 10604, 10608, 10612, 10616, 10620, 10624, 10628, 10632, 10636,
   10640, 10644, 10648, 10652, 10656, 10660, 10664, 10668, 10672, 10676,
   10680, 10684, 10688, 10692, 10696, 10700, 10704, 10708, 10712, 10716,
   10720, 10724, 10728, 10732, 10736, 10740, 10744, 10748, 10752, 10756,
   10760, 10764, 10768, 10772, 10776, 10780, 10784, 10788, 10792, 10796,
   10800, 10804, 10808, 10812, 10816, 10820, 10824, 10828, 10832, 10836,
   10840, 10844, 10848, 10852, 10856, 10860, 10864, 10868, 10872, 10876,
   10880, 10884, 10888, 10892, 10896, 10900, 10904, 10908, 10912, 10916,
   10920, 10924, 10928, 10932, 10936, 10940, 10944, 10948, 10952, 10956,
   10960, 10964, 10968, 10972, 10976, 10980, 10984, 10988, 10992, 10996,
   11000, 11004, 11008, 11012, 11016, 11020, 11024, 11028, 11032, 11036,
   11040, 11044, 11048, 11052, 11056, 11060, 11064, 11068, 11072, 11076,
   11080, 11084, 11088, 11092, 11096, 11100, 11104, 11112, 11116, 11120,
   11124, 11128, 11132, 11136, 11140, 11144, 11148, 11152, 11156, 11160,
   11164, 11168, 11172, 11176, 11180, 11184, 11188, 11192, 11196, 11200,
   11204, 11208, 11212, 11216, 11220, 11224, 11228, 11232, 11236, 11240,
   11244, 11248, 11252, 11256, 11260, 11264, 11268, 11272, 11276, 11280,
   11288, 11292, 11296, 11300, 11304, 11308, 11312, 11316, 11320, 11324,
   11328, 11332, 11336, 11340, 11344, 11348, 11352, 11356, 11360, 11364,
   11368, 11372, 11380, 11384, 11388, 11392, 11396, 11400, 11404, 11408,
   11412, 11416, 11420, 11424, 11428, 11432, 11436, 11440, 11444, 11448,
   11452, 11456, 11460, 11464, 11468, 11472, 11476, 11480, 11484, 11488,
   11492, 11496, 11500, 11504, 11508, 11512, 11516, 11520, 11524, 11528,
   11532, 11536, 11540, 11544, 11548, 11552, 11556, 11560, 11564, 11568,
   11572, 11576, 11580, 11584, 11588, 11592, 11596, 11600, 11604, 11608,
   11612, 11616, 11620, 11624, 11628, 11632, 11636, 11640, 11644, 11648,
   11652, 11656, 11660, 11664, 11668, 11672, 11682, 11683, 11686, 11687,
   11688, 11694, 11695, 11696, 11697, 11698, 11711, 11711, 11720, 11736,
   11738, 11741, 11743, 11747, 11759, 11775, 11779, 11790, 11791, 11794,
   11806, 11815, 11816, 11819, 11820, 11821, 11824, 11825, 11828, 11829,
   11832, 11833, 11836, 11838, 11840, 11842, 11846, 11853, 11860, 11876,
   11910, 11920, 11923, 11925, 11938, 11939, 11941, 11943, 11947, 11960,
   11967, 12027, 12036, 12038, 12039, 12042, 12044, 12045, 12048, 12049,
   12050, 12051, 12052, 12059, 12058, 12068, 12070, 12072, 12073, 12076,
   12077, 12078, 12079, 12082, 12083, 12087, 12086, 12103, 12101, 12117,
   12116, 12130, 12136, 12137, 12140, 12142, 12143, 12146, 12147, 12148,
   12149, 12152, 12153, 12156, 12164, 12181, 12189, 12212, 12318, 12352,
   12354, 12356, 12360, 12364, 12363, 12414, 12416, 12415, 12430, 12436,
   12443, 12448, 12451, 12452, 12455, 12456, 12457, 12458, 12459, 12460,
   12461, 12469, 12477, 12480, 12481, 12482, 12483, 12484, 12485, 12493,
   12501, 12502, 12503, 12506, 12507, 12510, 12512, 12516, 12604, 12605,
   12612, 12613, 12614, 12620, 12629, 12632, 12633, 12634, 12635, 12638,
   12639, 12640, 12643, 12645, 12653, 12654, 12660, 12668, 12669, 12672,
   12673, 12676, 12681, 12688, 12693, 12700, 12707, 12707, 12709, 12716,
   12717, 12720, 12721, 12722, 12723, 12724, 12725, 12726, 12727, 12728,
   12734, 12741, 12753, 12759, 12766, 12774, 12775, 12787, 12798, 12809,
   12813, 12814, 12817, 12822, 12826, 12827, 12830, 12836, 12844, 12847,
   12854, 12858, 12859, 12862, 12865, 12869, 12870, 12873, 12879, 12887,
   12888, 12897, 12906, 12918, 12919, 12920, 12921, 12922, 12923, 12924,
   12925, 12926, 12927, 12928, 12929, 12930, 12931, 12932, 12939, 12940,
   12943, 12944, 12951, 12952, 12953, 12960, 12959, 12976, 12977, 12984,
   12983, 13053, 13059, 13065, 13073, 13079, 13085, 13091, 13097, 13103,
   13109, 13115, 13121, 13132, 13133, 13136, 13137, 13138, 13139, 13140,
   13141, 13142, 13143, 13144, 13145, 13146, 13147, 13148, 13149, 13150,
   13151, 13152, 13153, 13154, 13155, 13156, 13157, 13158, 13159, 13162,
   13163, 13164, 13165, 13166, 13167, 13171, 13172, 13173, 13174, 13175,
   13176, 13177, 13180, 13183, 13184, 13185, 13186, 13187, 13188, 13189,
   13190, 13203, 13204, 13205, 13206, 13207, 13208, 13209, 13214, 13215,
   13216, 13217, 13218, 13219, 13225, 13226, 13227, 13228, 13229, 13230,
   13231, 13232, 13233, 13234, 13235, 13238, 13239, 13240, 13241, 13242,
   13245, 13246, 13247, 13248, 13251, 13252, 13253, 13254, 13255, 13256,
   13257, 13274, 13275, 13276, 13279, 13280, 13281, 13282, 13283, 13284,
   13288, 13288, 13291, 13297, 13298, 13301, 13303, 13308, 13318, 13329,
   13336, 13337, 13338, 13341, 13374, 13376, 13378, 13381, 13391, 13401,
   13411, 13412, 13415, 13417, 13418, 13419, 13422, 13424, 13432, 13433,
   13434, 13438, 13439, 13443, 13444, 13447, 13448, 13451, 13452, 13453,
   13454, 13455, 13458, 13459, 13460, 13461, 13462, 13463, 13464, 13465,
   13466, 13467, 13468, 13469, 13470, 13471, 13472, 13473, 13474, 13475,
   13476, 13477, 13478, 13479, 13480, 13481, 13482, 13483, 13484, 13485,
   13486, 13487, 13488, 13489, 13490, 13491, 13492, 13493, 13494, 13495,
   13496, 13497, 13498, 13499, 13500, 13501, 13502, 13503, 13504, 13505,
   13506, 13507, 13508, 13509, 13510, 13511, 13512, 13513, 13516, 13517,
   13518, 13519, 13522, 13523, 13524, 13525, 13526, 13527, 13528, 13529,
   13530, 13533, 13534, 13535, 13536, 13537, 13540, 13541, 13544, 13545,
   13556, 13557
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "SQL_ALLOCATE", "SQL_AUTOCOMMIT",
  "SQL_BOOL", "SQL_BREAK", "SQL_CALL", "SQL_CARDINALITY", "SQL_CONNECT",
  "SQL_COUNT", "SQL_DATETIME_INTERVAL_CODE",
  "SQL_DATETIME_INTERVAL_PRECISION", "SQL_DESCRIBE", "SQL_DESCRIPTOR",
  "SQL_DISCONNECT", "SQL_FOUND", "SQL_FREE", "SQL_GET", "SQL_GO",
  "SQL_GOTO", "SQL_IDENTIFIED", "SQL_INDICATOR", "SQL_KEY_MEMBER",
  "SQL_LENGTH", "SQL_LONG", "SQL_NULLABLE", "SQL_OCTET_LENGTH", "SQL_OPEN",
  "SQL_OUTPUT", "SQL_REFERENCE", "SQL_RETURNED_LENGTH",
  "SQL_RETURNED_OCTET_LENGTH", "SQL_SCALE", "SQL_SECTION", "SQL_SHORT",
  "SQL_SIGNED", "SQL_SQL", "SQL_SQLERROR", "SQL_SQLPRINT",
  "SQL_SQLWARNING", "SQL_START", "SQL_STOP", "SQL_STRUCT", "SQL_UNSIGNED",
  "SQL_VAR", "SQL_WHENEVER", "S_ADD", "S_AND", "S_ANYTHING", "S_AUTO",
  "S_CONST", "S_DEC", "S_DIV", "S_DOTPOINT", "S_EQUAL", "S_EXTERN",
  "S_INC", "S_LSHIFT", "S_MEMPOINT", "S_MEMBER", "S_MOD", "S_MUL",
  "S_NEQUAL", "S_OR", "S_REGISTER", "S_RSHIFT", "S_STATIC", "S_SUB",
  "S_VOLATILE", "S_TYPEDEF", "CSTRING", "CVARIABLE", "CPP_LINE", "IP",
  "DOLCONST", "ECONST", "NCONST", "UCONST", "UIDENT", "IDENT", "FCONST",
  "SCONST", "BCONST", "XCONST", "Op", "ICONST", "PARAM", "TYPECAST",
  "DOT_DOT", "COLON_EQUALS", "ABORT_P", "ABSOLUTE_P", "ACCESS", "ACTION",
  "ADD_P", "ADMIN", "AFTER", "AGGREGATE", "ALL", "ALSO", "ALTER", "ALWAYS",
  "ANALYSE", "ANALYZE", "AND", "ANY", "ARRAY", "AS", "ASC", "ASSERTION",
  "ASSIGNMENT", "ASYMMETRIC", "AT", "AUTHORIZATION", "BACKWARD", "BEFORE",
  "BEGIN_P", "BETWEEN", "BIGINT", "BINARY", "BIT", "BOOLEAN_P", "BOTH",
  "BY", "CACHE", "CALLED", "CASCADE", "CASCADED", "CASE", "CAST",
  "CATALOG_P", "CHAIN", "CHAR_P", "CHARACTER", "CHARACTERISTICS", "CHECK",
  "CHECKPOINT", "CLASS", "CLOSE", "CLUSTER", "COALESCE", "COLLATE",
  "COLUMN", "COMMENT", "COMMENTS", "COMMIT", "COMMITTED", "CONCURRENTLY",
  "CONFIGURATION", "CONNECTION", "CONSTRAINT", "CONSTRAINTS", "CONTENT_P",
  "CONTINUE_P", "CONVERSION_P", "COPY", "COST", "CREATE", "CREATEDB",
  "CREATEROLE", "CREATEUSER", "CROSS", "CSV", "CURRENT_P",
  "CURRENT_CATALOG", "CURRENT_DATE", "CURRENT_ROLE", "CURRENT_SCHEMA",
  "CURRENT_TIME", "CURRENT_TIMESTAMP", "CURRENT_USER", "CURSOR", "CYCLE",
  "DATA_P", "DATABASE", "DAY_P", "DEALLOCATE", "DEC", "DECIMAL_P",
  "DECLARE", "DEFAULT", "DEFAULTS", "DEFERRABLE", "DEFERRED", "DEFINER",
  "DELETE_P", "DELIMITER", "DELIMITERS", "DESC", "DICTIONARY", "DISABLE_P",
  "DISCARD", "DISTINCT", "DO", "DOCUMENT_P", "DOMAIN_P", "DOUBLE_P",
  "DROP", "EACH", "ELSE", "ENABLE_P", "ENCODING", "ENCRYPTED", "END_P",
  "ENUM_P", "ESCAPE", "EXCEPT", "EXCLUDE", "EXCLUDING", "EXCLUSIVE",
  "EXECUTE", "EXISTS", "EXPLAIN", "EXTERNAL", "EXTRACT", "FALSE_P",
  "FAMILY", "FETCH", "FIRST_P", "FLOAT_P", "FOLLOWING", "FOR", "FORCE",
  "FOREIGN", "FORWARD", "FREEZE", "FROM", "FULL", "FUNCTION", "FUNCTIONS",
  "GLOBAL", "GRANT", "GRANTED", "GREATEST", "GROUP_P", "HANDLER", "HAVING",
  "HEADER_P", "HOLD", "HOUR_P", "IDENTITY_P", "IF_P", "ILIKE", "IMMEDIATE",
  "IMMUTABLE", "IMPLICIT_P", "IN_P", "INCLUDING", "INCREMENT", "INDEX",
  "INDEXES", "INHERIT", "INHERITS", "INITIALLY", "INLINE_P", "INNER_P",
  "INOUT", "INPUT_P", "INSENSITIVE", "INSERT", "INSTEAD", "INT_P",
  "INTEGER", "INTERSECT", "INTERVAL", "INTO", "INVOKER", "IS", "ISNULL",
  "ISOLATION", "JOIN", "KEY", "LANGUAGE", "LARGE_P", "LAST_P",
  "LC_COLLATE_P", "LC_CTYPE_P", "LEADING", "LEAST", "LEFT", "LEVEL",
  "LIKE", "LIMIT", "LISTEN", "LOAD", "LOCAL", "LOCALTIME",
  "LOCALTIMESTAMP", "LOCATION", "LOCK_P", "LOGIN_P", "MAPPING", "MATCH",
  "MAXVALUE", "MINUTE_P", "MINVALUE", "MODE", "MONTH_P", "MOVE", "NAME_P",
  "NAMES", "NATIONAL", "NATURAL", "NCHAR", "NEXT", "NO", "NOCREATEDB",
  "NOCREATEROLE", "NOCREATEUSER", "NOINHERIT", "NOLOGIN_P", "NONE",
  "NOSUPERUSER", "NOT", "NOTHING", "NOTIFY", "NOTNULL", "NOWAIT", "NULL_P",
  "NULLIF", "NULLS_P", "NUMERIC", "OBJECT_P", "OF", "OFF", "OFFSET",
  "OIDS", "ON", "ONLY", "OPERATOR", "OPTION", "OPTIONS", "OR", "ORDER",
  "OUT_P", "OUTER_P", "OVER", "OVERLAPS", "OVERLAY", "OWNED", "OWNER",
  "PARSER", "PARTIAL", "PARTITION", "PASSWORD", "PLACING", "PLANS",
  "POSITION", "PRECEDING", "PRECISION", "PRESERVE", "PREPARE", "PREPARED",
  "PRIMARY", "PRIOR", "PRIVILEGES", "PROCEDURAL", "PROCEDURE", "QUOTE",
  "RANGE", "READ", "REAL", "REASSIGN", "RECHECK", "RECURSIVE",
  "REFERENCES", "REINDEX", "RELATIVE_P", "RELEASE", "RENAME", "REPEATABLE",
  "REPLACE", "REPLICA", "RESET", "RESTART", "RESTRICT", "RETURNING",
  "RETURNS", "REVOKE", "RIGHT", "ROLE", "ROLLBACK", "ROW", "ROWS", "RULE",
  "SAVEPOINT", "SCHEMA", "SCROLL", "SEARCH", "SECOND_P", "SECURITY",
  "SELECT", "SEQUENCE", "SEQUENCES", "SERIALIZABLE", "SERVER", "SESSION",
  "SESSION_USER", "SET", "SETOF", "SHARE", "SHOW", "SIMILAR", "SIMPLE",
  "SMALLINT", "SOME", "STABLE", "STANDALONE_P", "START", "STATEMENT",
  "STATISTICS", "STDIN", "STDOUT", "STORAGE", "STRICT_P", "STRIP_P",
  "SUBSTRING", "SUPERUSER_P", "SYMMETRIC", "SYSID", "SYSTEM_P", "TABLE",
  "TABLES", "TABLESPACE", "TEMP", "TEMPLATE", "TEMPORARY", "TEXT_P",
  "THEN", "TIME", "TIMESTAMP", "TO", "TRAILING", "TRANSACTION", "TREAT",
  "TRIGGER", "TRIM", "TRUE_P", "TRUNCATE", "TRUSTED", "TYPE_P",
  "UNBOUNDED", "UNCOMMITTED", "UNENCRYPTED", "UNION", "UNIQUE", "UNKNOWN",
  "UNLISTEN", "UNTIL", "UPDATE", "USER", "USING", "VACUUM", "VALID",
  "VALIDATOR", "VALUE_P", "VALUES", "VARCHAR", "VARIADIC", "VARYING",
  "VERBOSE", "VERSION_P", "VIEW", "VOLATILE", "WHEN", "WHERE",
  "WHITESPACE_P", "WINDOW", "WITH", "WITHOUT", "WORK", "WRAPPER", "WRITE",
  "XML_P", "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT", "XMLFOREST",
  "XMLPARSE", "XMLPI", "XMLROOT", "XMLSERIALIZE", "YEAR_P", "YES_P",
  "ZONE", "NULLS_FIRST", "NULLS_LAST", "WITH_TIME", "'='", "'<'", "'>'",
  "POSTFIXOP", "'+'", "'-'", "'*'", "'/'", "'%'", "'^'", "UMINUS", "'['",
  "']'", "'('", "')'", "'.'", "','", "';'", "':'", "'{'", "'}'", "$accept",
  "prog", "stmt", "CreateRoleStmt", "opt_with", "OptRoleList",
  "AlterOptRoleList", "AlterOptRoleElem", "CreateOptRoleElem",
  "CreateUserStmt", "AlterRoleStmt", "opt_in_database", "AlterRoleSetStmt",
  "AlterUserStmt", "AlterUserSetStmt", "DropRoleStmt", "DropUserStmt",
  "CreateGroupStmt", "AlterGroupStmt", "add_drop", "DropGroupStmt",
  "CreateSchemaStmt", "OptSchemaName", "OptSchemaEltList", "schema_stmt",
  "VariableSetStmt", "set_rest", "var_name", "var_list", "var_value",
  "iso_level", "opt_boolean_or_string", "zone_value", "opt_encoding",
  "ColId_or_Sconst", "VariableResetStmt", "SetResetClause",
  "VariableShowStmt", "ConstraintsSetStmt", "constraints_set_list",
  "constraints_set_mode", "CheckPointStmt", "DiscardStmt",
  "AlterTableStmt", "alter_table_cmds", "alter_table_cmd",
  "alter_column_default", "opt_drop_behavior", "alter_using", "reloptions",
  "opt_reloptions", "reloption_list", "reloption_elem", "ClosePortalStmt",
  "CopyStmt", "copy_from", "copy_file_name", "copy_options",
  "copy_opt_list", "copy_opt_item", "opt_binary", "opt_oids",
  "copy_delimiter", "opt_using", "copy_generic_opt_list",
  "copy_generic_opt_elem", "copy_generic_opt_arg",
  "copy_generic_opt_arg_list", "copy_generic_opt_arg_list_item",
  "CreateStmt", "OptTemp", "OptTableElementList",
  "OptTypedTableElementList", "TableElementList", "TypedTableElementList",
  "TableElement", "TypedTableElement", "columnDef", "columnOptions",
  "ColQualList", "ColConstraint", "ColConstraintElem", "ConstraintAttr",
  "TableLikeClause", "TableLikeOptionList", "TableLikeOption",
  "TableConstraint", "ConstraintElem", "opt_column_list", "columnList",
  "columnElem", "key_match", "ExclusionConstraintList",
  "ExclusionConstraintElem", "ExclusionWhereClause", "key_actions",
  "key_update", "key_delete", "key_action", "OptInherit", "OptWith",
  "OnCommitOption", "OptTableSpace", "OptConsTableSpace",
  "create_as_target", "OptCreateAs", "CreateAsList", "CreateAsElement",
  "opt_with_data", "CreateSeqStmt", "AlterSeqStmt", "OptSeqOptList",
  "SeqOptList", "SeqOptElem", "opt_by", "NumericOnly", "NumericOnly_list",
  "CreatePLangStmt", "opt_trusted", "handler_name", "opt_inline_handler",
  "validator_clause", "opt_validator", "DropPLangStmt", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateFdwStmt", "DropFdwStmt", "AlterFdwStmt", "create_generic_options",
  "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "DropForeignServerStmt",
  "AlterForeignServerStmt", "CreateUserMappingStmt", "auth_ident",
  "DropUserMappingStmt", "AlterUserMappingStmt", "CreateTrigStmt",
  "TriggerActionTime", "TriggerEvents", "TriggerOneEvent",
  "TriggerForSpec", "TriggerForOpt", "TriggerForType", "TriggerWhen",
  "TriggerFuncArgs", "TriggerFuncArg", "OptConstrFromTable",
  "ConstraintAttributeSpec", "ConstraintDeferrabilitySpec",
  "ConstraintTimeSpec", "DropTrigStmt", "CreateAssertStmt",
  "DropAssertStmt", "DefineStmt", "definition", "def_list", "def_elem",
  "def_arg", "aggr_args", "old_aggr_definition", "old_aggr_list",
  "old_aggr_elem", "opt_enum_val_list", "enum_val_list",
  "CreateOpClassStmt", "opclass_item_list", "opclass_item", "opt_default",
  "opt_opfamily", "opt_recheck", "CreateOpFamilyStmt", "AlterOpFamilyStmt",
  "opclass_drop_list", "opclass_drop", "DropOpClassStmt",
  "DropOpFamilyStmt", "DropOwnedStmt", "ReassignOwnedStmt", "DropStmt",
  "drop_type", "any_name_list", "any_name", "attrs", "TruncateStmt",
  "opt_restart_seqs", "CommentStmt", "comment_type", "comment_text",
  "FetchStmt", "fetch_args", "from_in", "opt_from_in", "GrantStmt",
  "RevokeStmt", "privileges", "privilege_list", "privilege",
  "privilege_target", "grantee_list", "grantee", "opt_grant_grant_option",
  "function_with_argtypes_list", "function_with_argtypes", "GrantRoleStmt",
  "RevokeRoleStmt", "opt_grant_admin_option", "opt_granted_by",
  "AlterDefaultPrivilegesStmt", "DefACLOptionList", "DefACLOption",
  "DefACLAction", "defacl_privilege_target", "IndexStmt", "opt_unique",
  "opt_concurrently", "opt_index_name", "access_method_clause",
  "index_params", "index_elem", "opt_class", "opt_asc_desc",
  "opt_nulls_order", "CreateFunctionStmt", "opt_or_replace", "func_args",
  "func_args_list", "func_args_with_defaults",
  "func_args_with_defaults_list", "func_arg", "arg_class", "param_name",
  "func_return", "func_type", "func_arg_with_default",
  "createfunc_opt_list", "common_func_opt_item", "createfunc_opt_item",
  "func_as", "opt_definition", "table_func_column",
  "table_func_column_list", "AlterFunctionStmt", "alterfunc_opt_list",
  "opt_restrict", "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt",
  "oper_argtypes", "any_operator", "DoStmt", "dostmt_opt_list",
  "dostmt_opt_item", "CreateCastStmt", "cast_context", "DropCastStmt",
  "opt_if_exists", "ReindexStmt", "reindex_type", "opt_force",
  "RenameStmt", "opt_column", "opt_set_data", "AlterObjectSchemaStmt",
  "AlterOwnerStmt", "RuleStmt", "RuleActionList", "RuleActionMulti",
  "RuleActionStmt", "RuleActionStmtOrEmpty", "event", "opt_instead",
  "DropRuleStmt", "NotifyStmt", "notify_payload", "ListenStmt",
  "UnlistenStmt", "TransactionStmt", "opt_transaction",
  "transaction_mode_item", "transaction_mode_list",
  "transaction_mode_list_or_empty", "ViewStmt", "opt_check_option",
  "LoadStmt", "CreatedbStmt", "createdb_opt_list", "createdb_opt_item",
  "opt_equal", "AlterDatabaseStmt", "AlterDatabaseSetStmt",
  "alterdb_opt_list", "alterdb_opt_item", "DropdbStmt", "CreateDomainStmt",
  "AlterDomainStmt", "opt_as", "AlterTSDictionaryStmt",
  "AlterTSConfigurationStmt", "CreateConversionStmt", "ClusterStmt",
  "cluster_index_specification", "VacuumStmt", "vacuum_option_list",
  "vacuum_option_elem", "AnalyzeStmt", "analyze_keyword", "opt_verbose",
  "opt_full", "opt_freeze", "opt_name_list", "ExplainStmt",
  "ExplainableStmt", "explain_option_list", "explain_option_elem",
  "explain_option_name", "explain_option_arg", "PrepareStmt",
  "prep_type_clause", "PreparableStmt", "ExecuteStmt",
  "execute_param_clause", "InsertStmt", "insert_rest",
  "insert_column_list", "insert_column_item", "returning_clause",
  "DeleteStmt", "using_clause", "LockStmt", "opt_lock", "lock_type",
  "opt_nowait", "UpdateStmt", "set_clause_list", "set_clause",
  "single_set_clause", "multiple_set_clause", "set_target",
  "set_target_list", "DeclareCursorStmt", "cursor_name", "cursor_options",
  "opt_hold", "SelectStmt", "select_with_parens", "select_no_parens",
  "select_clause", "simple_select", "with_clause", "cte_list",
  "common_table_expr", "into_clause", "OptTempTableName", "opt_table",
  "opt_all", "opt_distinct", "opt_sort_clause", "sort_clause",
  "sortby_list", "sortby", "select_limit", "opt_select_limit",
  "limit_clause", "offset_clause", "select_limit_value",
  "select_offset_value", "opt_select_fetch_first_value",
  "select_offset_value2", "row_or_rows", "first_or_next", "group_clause",
  "having_clause", "for_locking_clause", "opt_for_locking_clause",
  "for_locking_items", "for_locking_item", "locked_rels_list",
  "values_clause", "from_clause", "from_list", "table_ref", "joined_table",
  "alias_clause", "join_type", "join_outer", "join_qual", "relation_expr",
  "relation_expr_list", "relation_expr_opt_alias", "func_table",
  "where_clause", "where_or_current_clause", "TableFuncElementList",
  "TableFuncElement", "Typename", "opt_array_bounds", "SimpleTypename",
  "ConstTypename", "GenericType", "opt_type_modifiers", "Numeric",
  "opt_float", "Bit", "ConstBit", "BitWithLength", "BitWithoutLength",
  "Character", "ConstCharacter", "CharacterWithLength",
  "CharacterWithoutLength", "character", "opt_varying", "opt_charset",
  "ConstDatetime", "ConstInterval", "opt_timezone", "opt_interval",
  "interval_second", "a_expr", "b_expr", "c_expr", "func_expr",
  "xml_root_version", "opt_xml_root_standalone", "xml_attributes",
  "xml_attribute_list", "xml_attribute_el", "document_or_content",
  "xml_whitespace_option", "window_clause", "window_definition_list",
  "window_definition", "over_clause", "window_specification",
  "opt_existing_window_name", "opt_partition_clause", "opt_frame_clause",
  "frame_extent", "frame_bound", "row", "sub_type", "all_Op", "MathOp",
  "qual_Op", "qual_all_Op", "subquery_Op", "expr_list", "func_arg_list",
  "func_arg_expr", "type_list", "array_expr", "array_expr_list",
  "extract_list", "extract_arg", "overlay_list", "overlay_placing",
  "position_list", "substr_list", "substr_from", "substr_for", "trim_list",
  "in_expr", "case_expr", "when_clause_list", "when_clause",
  "case_default", "case_arg", "columnref", "indirection_el", "indirection",
  "opt_indirection", "opt_asymmetric", "ctext_expr", "ctext_expr_list",
  "ctext_row", "target_list", "target_el", "qualified_name_list",
  "qualified_name", "name_list", "name", "database_name", "access_method",
  "attr_name", "index_name", "file_name", "func_name", "AexprConst",
  "Iconst", "RoleId", "SignedIconst", "unreserved_keyword",
  "col_name_keyword", "type_func_name_keyword", "reserved_keyword",
  "statements", "statement", "CreateAsStmt", "$@1", "at", "ECPGConnect",
  "connection_target", "opt_database_name", "db_prefix", "server",
  "opt_server", "server_name", "opt_port", "opt_connection_name",
  "opt_user", "ora_user", "user_name", "char_variable", "opt_options",
  "connect_options", "opt_opt_value", "prepared_name", "ECPGCursorStmt",
  "ECPGExecuteImmediateStmt", "ECPGVarDeclaration",
  "single_vt_declaration", "precision", "opt_scale", "ecpg_interval",
  "ECPGDeclaration", "$@2", "sql_startdeclare", "sql_enddeclare",
  "var_type_declarations", "vt_declarations", "variable_declarations",
  "type_declaration", "$@3", "var_declaration", "$@4", "$@5",
  "opt_bit_field", "storage_declaration", "storage_clause",
  "storage_modifier", "var_type", "enum_type", "enum_definition",
  "struct_union_type_with_symbol", "$@6", "struct_union_type", "$@7",
  "s_struct_union_symbol", "s_struct_union", "simple_type",
  "unsigned_type", "signed_type", "opt_signed", "variable_list",
  "variable", "opt_initializer", "opt_pointer", "ECPGDeclare",
  "ECPGDisconnect", "dis_name", "connection_object", "execstring",
  "ECPGFree", "ECPGOpen", "opt_ecpg_using", "ecpg_using",
  "using_descriptor", "into_descriptor", "into_sqlda", "using_list",
  "UsingValue", "UsingConst", "ECPGDescribe", "opt_output",
  "ECPGAllocateDescr", "ECPGDeallocateDescr", "ECPGGetDescriptorHeader",
  "ECPGGetDescHeaderItems", "ECPGGetDescHeaderItem",
  "ECPGSetDescriptorHeader", "ECPGSetDescHeaderItems",
  "ECPGSetDescHeaderItem", "IntConstVar", "desc_header_item",
  "ECPGGetDescriptor", "ECPGGetDescItems", "ECPGGetDescItem",
  "ECPGSetDescriptor", "ECPGSetDescItems", "ECPGSetDescItem",
  "AllConstVar", "descriptor_item", "ECPGSetAutocommit", "on_off",
  "ECPGSetConnection", "ECPGTypedef", "$@8", "opt_reference", "ECPGVar",
  "$@9", "ECPGWhenever", "action", "ECPGKeywords", "ECPGKeywords_vanames",
  "ECPGKeywords_rest", "ECPGTypeName", "symbol", "ECPGColId", "ColId",
  "type_function_name", "ColLabel", "ECPGColLabel", "ECPGColLabelCommon",
  "ECPGCKeywords", "all_unreserved_keyword", "ECPGunreserved_interval",
  "into_list", "ecpgstart", "c_args", "coutputvariable", "civarind",
  "char_civar", "civar", "indicator", "cvariable", "ecpg_param",
  "ecpg_bconst", "ecpg_fconst", "ecpg_sconst", "ecpg_xconst", "ecpg_ident",
  "quoted_ident_stringvar", "c_stuff_item", "c_stuff", "c_list", "c_term",
  "c_thing", "c_anything", "DeallocateStmt", "Iresult", "execute_rest",
  "ecpg_into", "ecpg_fetch_into", "opt_ecpg_fetch_into", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,    61,
      60,    62,   744,    43,    45,    42,    47,    37,    94,   745,
      91,    93,    40,    41,    46,    44,    59,    58,   123,   125
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   510,   511,   512,   512,   512,   512,   512,   512,   512,
     512,   512,   512,   512,   512,   512,   512,   512,   512,   512,
     512,   512,   512,   512,   512,   512,   512,   512,   512,   512,
     512,   512,   512,   512,   512,   512,   512,   512,   512,   512,
     512,   512,   512,   512,   512,   512,   512,   512,   512,   512,
     512,   512,   512,   512,   512,   512,   512,   512,   512,   512,
     512,   512,   512,   512,   512,   512,   512,   512,   512,   512,
     512,   512,   512,   512,   512,   512,   512,   512,   512,   512,
     512,   512,   512,   512,   512,   512,   512,   512,   512,   512,
     512,   512,   512,   512,   512,   512,   512,   512,   512,   512,
     512,   512,   512,   512,   512,   512,   512,   512,   512,   512,
     512,   512,   512,   512,   512,   512,   512,   512,   512,   512,
     512,   512,   512,   512,   512,   513,   514,   514,   515,   515,
     516,   516,   517,   517,   517,   517,   517,   517,   517,   517,
     517,   517,   517,   517,   517,   517,   517,   517,   517,   517,
     517,   518,   518,   518,   518,   518,   518,   519,   520,   521,
     521,   522,   523,   524,   525,   525,   526,   526,   527,   528,
     529,   529,   530,   530,   531,   531,   532,   532,   533,   533,
     534,   534,   534,   534,   534,   534,   535,   535,   535,   536,
     536,   536,   536,   536,   536,   536,   536,   536,   536,   536,
     536,   536,   536,   536,   537,   537,   538,   538,   539,   539,
     540,   540,   540,   540,   541,   541,   541,   541,   542,   542,
     542,   542,   542,   542,   542,   543,   543,   543,   544,   544,
     545,   545,   545,   545,   545,   546,   546,   547,   547,   547,
     547,   547,   548,   549,   549,   550,   550,   551,   552,   552,
     552,   552,   553,   553,   553,   553,   554,   554,   555,   555,
     555,   555,   555,   555,   555,   555,   555,   555,   555,   555,
     555,   555,   555,   555,   555,   555,   555,   555,   555,   555,
     555,   555,   555,   555,   555,   555,   555,   555,   555,   555,
     555,   555,   555,   555,   555,   556,   556,   557,   557,   557,
     558,   558,   559,   560,   560,   561,   561,   562,   562,   562,
     562,   563,   563,   564,   564,   565,   565,   566,   566,   566,
     567,   567,   568,   568,   569,   569,   569,   569,   569,   569,
     569,   569,   569,   569,   569,   570,   570,   571,   571,   572,
     572,   573,   573,   574,   574,   575,   576,   576,   576,   576,
     576,   577,   577,   578,   579,   579,   580,   580,   580,   580,
     580,   580,   580,   581,   581,   582,   582,   583,   583,   584,
     584,   585,   585,   585,   586,   586,   587,   588,   589,   589,
     590,   590,   590,   591,   591,   591,   591,   591,   591,   591,
     592,   592,   592,   592,   593,   594,   594,   594,   595,   595,
     595,   595,   595,   595,   596,   596,   597,   597,   597,   597,
     597,   598,   598,   599,   599,   600,   601,   601,   601,   601,
     602,   602,   603,   603,   604,   604,   605,   605,   605,   605,
     605,   606,   607,   608,   608,   608,   608,   608,   609,   609,
     610,   610,   610,   610,   611,   611,   611,   611,   612,   612,
     613,   613,   614,   615,   615,   616,   616,   617,   618,   618,
     618,   619,   620,   621,   621,   622,   622,   623,   623,   623,
     623,   623,   623,   623,   623,   623,   623,   623,   623,   624,
     624,   625,   625,   625,   626,   626,   627,   627,   628,   628,
     629,   629,   630,   630,   631,   631,   632,   632,   633,   633,
     634,   634,   635,   636,   636,   637,   637,   638,   639,   639,
     640,   640,   640,   641,   641,   642,   642,   643,   644,   644,
     645,   645,   645,   645,   646,   647,   648,   649,   650,   650,
     651,   651,   652,   652,   653,   653,   654,   654,   654,   655,
     656,   656,   656,   657,   657,   658,   659,   659,   660,   660,
     661,   661,   662,   662,   662,   662,   662,   663,   663,   664,
     664,   665,   665,   666,   666,   667,   667,   667,   668,   668,
     668,   668,   668,   668,   669,   669,   670,   670,   670,   670,
     670,   671,   671,   672,   672,   673,   673,   674,   675,   676,
     676,   676,   676,   676,   676,   676,   676,   676,   676,   676,
     677,   678,   678,   679,   679,   680,   680,   680,   680,   680,
     681,   681,   682,   683,   683,   684,   685,   685,   686,   686,
     687,   688,   688,   689,   689,   689,   689,   689,   690,   690,
     691,   691,   692,   692,   693,   694,   694,   695,   695,   696,
     696,   697,   697,   698,   698,   699,   700,   701,   701,   702,
     702,   702,   702,   702,   702,   702,   702,   702,   702,   702,
     702,   703,   703,   704,   704,   705,   705,   706,   707,   707,
     707,   708,   708,   708,   708,   708,   708,   708,   708,   708,
     708,   708,   708,   708,   708,   708,   708,   708,   709,   709,
     709,   709,   709,   709,   709,   709,   709,   709,   709,   709,
     710,   710,   711,   711,   711,   711,   711,   711,   711,   711,
     711,   711,   711,   712,   712,   712,   712,   712,   712,   712,
     712,   712,   712,   712,   712,   712,   712,   713,   713,   714,
     714,   715,   716,   716,   717,   717,   717,   717,   717,   718,
     718,   719,   719,   719,   719,   720,   720,   720,   720,   720,
     720,   720,   720,   720,   720,   720,   720,   720,   720,   721,
     721,   722,   722,   723,   723,   724,   724,   725,   726,   727,
     727,   728,   728,   729,   729,   730,   731,   731,   732,   732,
     732,   733,   733,   733,   734,   734,   734,   735,   736,   736,
     737,   737,   738,   738,   739,   739,   740,   740,   741,   741,
     741,   742,   742,   742,   743,   743,   743,   744,   744,   744,
     745,   745,   745,   746,   746,   747,   747,   748,   748,   749,
     749,   750,   750,   751,   751,   751,   751,   751,   752,   752,
     752,   752,   752,   753,   754,   755,   755,   755,   756,   756,
     756,   757,   757,   758,   758,   758,   758,   758,   758,   758,
     758,   758,   758,   758,   758,   758,   759,   759,   759,   759,
     760,   760,   761,   761,   762,   763,   763,   764,   765,   765,
     766,   766,   767,   767,   768,   768,   769,   769,   770,   770,
     770,   770,   771,   771,   772,   773,   773,   774,   774,   775,
     775,   775,   776,   776,   776,   777,   778,   778,   779,   779,
     779,   780,   780,   781,   781,   782,   782,   782,   782,   782,
     782,   782,   782,   782,   782,   782,   782,   782,   782,   782,
     782,   782,   782,   782,   782,   782,   782,   782,   782,   782,
     783,   783,   784,   784,   785,   785,   785,   785,   785,   785,
     785,   786,   786,   786,   786,   786,   786,   786,   786,   786,
     786,   786,   786,   786,   786,   786,   786,   786,   787,   788,
     788,   788,   789,   789,   790,   790,   790,   790,   790,   791,
     791,   792,   792,   792,   792,   793,   793,   793,   794,   794,
     795,   796,   796,   797,   798,   798,   799,   799,   799,   799,
     799,   799,   799,   799,   799,   799,   799,   799,   799,   799,
     800,   800,   800,   801,   801,   801,   802,   802,   802,   803,
     803,   804,   804,   805,   805,   805,   805,   806,   807,   808,
     808,   809,   809,   809,   809,   809,   809,   809,   809,   809,
     809,   809,   809,   809,   809,   809,   809,   810,   810,   811,
     811,   812,   813,   813,   814,   815,   815,   816,   817,   817,
     817,   817,   817,   818,   818,   819,   820,   820,   820,   820,
     820,   820,   821,   822,   822,   822,   823,   823,   824,   824,
     824,   824,   824,   825,   825,   826,   826,   826,   826,   827,
     827,   828,   828,   829,   829,   830,   830,   831,   831,   832,
     832,   833,   833,   833,   833,   834,   834,   834,   834,   834,
     834,   834,   835,   835,   836,   837,   837,   837,   838,   838,
     838,   839,   839,   840,   840,   841,   841,   841,   841,   842,
     842,   843,   843,   844,   845,   845,   845,   846,   846,   847,
     848,   848,   849,   850,   850,   851,   852,   852,   853,   853,
     853,   853,   853,   853,   853,   853,   854,   854,   855,   856,
     856,   857,   857,   858,   859,   860,   861,   861,   862,   863,
     863,   864,   864,   864,   864,   864,   865,   865,   865,   866,
     866,   867,   867,   868,   868,   868,   868,   868,   868,   868,
     868,   869,   869,   870,   870,   870,   870,   870,   870,   871,
     871,   872,   872,   873,   874,   874,   874,   875,   875,   875,
     875,   875,   875,   875,   875,   876,   876,   877,   877,   877,
     878,   878,   878,   878,   879,   879,   880,   881,   881,   882,
     882,   883,   883,   883,   883,   884,   884,   885,   885,   885,
     886,   886,   887,   887,   888,   889,   889,   889,   890,   891,
     891,   892,   892,   893,   893,   894,   894,   895,   895,   896,
     896,   897,   897,   898,   898,   899,   899,   900,   900,   901,
     901,   902,   902,   903,   903,   903,   903,   903,   903,   903,
     903,   903,   903,   903,   904,   904,   904,   904,   904,   904,
     905,   905,   905,   905,   906,   906,   906,   906,   907,   907,
     908,   908,   909,   909,   909,   909,   910,   910,   911,   911,
     911,   912,   913,   913,   914,   914,   914,   915,   915,   916,
     917,   917,   917,   917,   917,   917,   918,   918,   918,   919,
     919,   919,   919,   919,   919,   919,   920,   920,   920,   920,
     921,   921,   922,   922,   923,   923,   923,   923,   923,   923,
     923,   923,   923,   923,   923,   924,   924,   925,   925,   926,
     926,   927,   928,   929,   929,   930,   930,   931,   932,   933,
     933,   933,   933,   933,   933,   934,   934,   935,   935,   936,
     936,   936,   936,   937,   938,   938,   938,   939,   939,   939,
     939,   939,   939,   939,   939,   939,   939,   939,   939,   939,
     939,   940,   940,   941,   941,   941,   941,   941,   941,   941,
     941,   941,   941,   941,   941,   941,   941,   941,   941,   941,
     941,   941,   941,   941,   941,   941,   941,   941,   941,   941,
     941,   941,   941,   941,   941,   941,   941,   941,   941,   941,
     941,   941,   941,   941,   941,   941,   941,   941,   941,   941,
     941,   941,   941,   941,   941,   941,   941,   941,   941,   941,
     941,   942,   942,   942,   942,   942,   942,   942,   942,   942,
     942,   942,   942,   942,   942,   942,   942,   942,   942,   942,
     942,   942,   942,   943,   943,   943,   943,   943,   943,   943,
     943,   943,   943,   943,   944,   944,   944,   944,   944,   944,
     944,   944,   944,   944,   944,   944,   944,   944,   944,   944,
     944,   944,   944,   944,   944,   944,   944,   944,   944,   944,
     944,   944,   944,   944,   944,   944,   944,   944,   944,   944,
     944,   944,   944,   944,   944,   944,   944,   944,   944,   944,
     944,   944,   945,   945,   946,   946,   946,   946,   947,   948,
     948,   949,   949,   950,   950,   951,   951,   951,   952,   952,
     953,   953,   954,   955,   955,   955,   956,   957,   957,   958,
     958,   959,   959,   959,   960,   960,   961,   961,   961,   961,
     961,   962,   962,   962,   963,   963,   963,   964,   964,   965,
     965,   965,   965,   965,   965,   965,   965,   965,   966,   966,
     967,   967,   968,   968,   968,   968,   968,   968,   969,   969,
     970,   970,   971,   971,   972,   972,   973,   973,   973,   974,
     974,   975,   975,   976,   976,   976,   976,   976,   976,   976,
     976,   977,   977,   978,   979,   979,   980,   980,   980,   980,
     980,   980,   981,   982,   983,   983,   983,   984,   984,   985,
     986,   986,   987,   988,   988,   989,   989,   990,   990,   991,
     991,   991,   991,   992,   992,   993,   993,   994,   994,   995,
     995,   996,   996,   997,   998,   998,   999,   999,   999,   999,
    1000,  1000,  1001,  1001,  1002,  1002,  1003,  1004,  1005,  1006,
    1007,  1008,  1009,  1009,  1010,  1010,  1010,  1010,  1010,  1010,
    1010,  1010,  1010,  1010,  1010,  1010,  1010,  1010,  1010,  1011,
    1012,  1013,  1013,  1013,  1013,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,
    1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,
    1016,  1016,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,
    1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,
    1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,
    1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,
    1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,
    1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,
    1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,
    1017,  1017,  1017,  1017,  1017,  1017,  1018,  1018,  1019,  1019,
    1019,  1019,  1019,  1019,  1019,  1019,  1021,  1020,  1022,  1023,
    1023,  1023,  1023,  1024,  1024,  1024,  1024,  1025,  1025,  1026,
    1027,  1028,  1028,  1029,  1029,  1029,  1030,  1030,  1031,  1031,
    1032,  1032,  1033,  1033,  1033,  1033,  1034,  1034,  1034,  1035,
    1036,  1036,  1037,  1037,  1038,  1038,  1038,  1038,  1039,  1039,
    1040,  1041,  1042,  1043,  1043,  1044,  1045,  1045,  1046,  1046,
    1046,  1046,  1046,  1048,  1047,  1049,  1050,  1051,  1051,  1052,
    1052,  1052,  1052,  1053,  1053,  1055,  1054,  1057,  1056,  1058,
    1056,  1056,  1059,  1059,  1060,  1060,  1060,  1061,  1061,  1061,
    1061,  1062,  1062,  1063,  1063,  1063,  1063,  1063,  1063,  1064,
    1064,  1064,  1065,  1067,  1066,  1068,  1069,  1068,  1070,  1070,
    1071,  1071,  1072,  1072,  1073,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1075,  1075,  1076,  1076,  1077,  1078,  1078,
    1079,  1079,  1079,  1080,  1081,  1082,  1082,  1082,  1082,  1083,
    1083,  1083,  1084,  1084,  1085,  1085,  1086,  1087,  1087,  1088,
    1088,  1089,  1089,  1090,  1090,  1091,  1092,  1092,  1093,  1093,
    1093,  1094,  1094,  1094,  1094,  1094,  1094,  1094,  1094,  1094,
    1095,  1095,  1095,  1095,  1095,  1096,  1096,  1097,  1098,  1099,
    1100,  1100,  1101,  1102,  1103,  1103,  1104,  1105,  1105,  1106,
    1107,  1108,  1108,  1109,  1110,  1111,  1111,  1112,  1113,  1113,
    1113,  1113,  1113,  1114,  1114,  1114,  1114,  1114,  1114,  1114,
    1114,  1114,  1114,  1114,  1114,  1114,  1114,  1114,  1115,  1115,
    1116,  1116,  1117,  1117,  1117,  1119,  1118,  1120,  1120,  1122,
    1121,  1123,  1123,  1123,  1124,  1124,  1124,  1124,  1124,  1124,
    1124,  1124,  1124,  1125,  1125,  1126,  1126,  1126,  1126,  1126,
    1126,  1126,  1126,  1126,  1126,  1126,  1126,  1126,  1126,  1126,
    1126,  1126,  1126,  1126,  1126,  1126,  1126,  1126,  1126,  1127,
    1127,  1127,  1127,  1127,  1127,  1128,  1128,  1128,  1128,  1128,
    1128,  1128,  1129,  1130,  1130,  1130,  1130,  1130,  1130,  1130,
    1130,  1131,  1131,  1131,  1131,  1131,  1131,  1131,  1132,  1132,
    1132,  1132,  1132,  1132,  1133,  1133,  1133,  1133,  1133,  1133,
    1133,  1133,  1133,  1133,  1133,  1134,  1134,  1134,  1134,  1134,
    1135,  1135,  1135,  1135,  1136,  1136,  1136,  1136,  1136,  1136,
    1136,  1137,  1137,  1137,  1138,  1138,  1138,  1138,  1138,  1138,
    1139,  1139,  1140,  1141,  1141,  1142,  1142,  1143,  1144,  1145,
    1146,  1146,  1146,  1147,  1148,  1149,  1150,  1151,  1151,  1151,
    1151,  1151,  1152,  1153,  1153,  1153,  1154,  1154,  1155,  1155,
    1155,  1156,  1156,  1157,  1157,  1158,  1158,  1159,  1159,  1159,
    1159,  1159,  1160,  1160,  1160,  1160,  1160,  1160,  1160,  1160,
    1160,  1160,  1160,  1160,  1160,  1160,  1160,  1160,  1160,  1160,
    1160,  1160,  1160,  1160,  1160,  1160,  1160,  1160,  1160,  1160,
    1160,  1160,  1160,  1160,  1160,  1160,  1160,  1160,  1160,  1160,
    1160,  1160,  1160,  1160,  1160,  1160,  1160,  1160,  1160,  1160,
    1160,  1160,  1160,  1160,  1160,  1160,  1160,  1160,  1161,  1161,
    1161,  1161,  1162,  1162,  1162,  1162,  1162,  1162,  1162,  1162,
    1162,  1163,  1163,  1163,  1163,  1163,  1164,  1164,  1165,  1165,
    1166,  1166
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     5,     1,     0,     2,     0,
       2,     0,     2,     2,     3,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     3,
       2,     1,     2,     2,     2,     3,     3,     5,     5,     0,
       3,     5,     5,     4,     3,     5,     3,     5,     5,     6,
       1,     1,     3,     5,     6,     4,     1,     0,     2,     0,
       1,     1,     1,     1,     1,     1,     2,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     5,     2,     2,     2,
       2,     3,     3,     3,     1,     3,     1,     3,     1,     1,
       2,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       3,     6,     1,     1,     1,     1,     1,     0,     1,     1,
       2,     3,     4,     3,     2,     2,     1,     3,     4,     5,
       4,     2,     4,     1,     1,     1,     1,     1,     2,     2,
       2,     2,     4,     4,     4,     4,     1,     3,     2,     3,
       4,     6,     6,     6,     5,     5,     6,     6,     4,     7,
       2,     6,     4,     3,     3,     3,     3,     3,     4,     4,
       3,     3,     3,     3,     3,     3,     4,     4,     3,     2,
       3,     3,     3,     2,     2,     3,     2,     1,     1,     0,
       2,     0,     3,     2,     0,     1,     3,     3,     1,     5,
       3,     2,     2,    10,     6,     1,     1,     1,     1,     1,
       1,     3,     2,     0,     1,     1,     3,     3,     1,     1,
       3,     3,     3,     3,     4,     1,     0,     2,     0,     3,
       0,     1,     0,     1,     3,     2,     1,     1,     1,     3,
       0,     1,     3,     1,    11,    10,     1,     1,     2,     2,
       2,     2,     0,     1,     0,     3,     0,     1,     3,     1,
       3,     1,     1,     1,     1,     1,     3,     4,     2,     0,
       3,     1,     1,     2,     1,     3,     4,     4,     2,     5,
       1,     2,     2,     2,     3,     3,     3,     0,     1,     1,
       1,     1,     1,     1,     3,     1,     5,     7,     8,     9,
      11,     3,     0,     1,     3,     1,     2,     2,     2,     0,
       1,     3,     3,     6,     4,     0,     1,     1,     2,     2,
       0,     3,     3,     2,     1,     1,     2,     2,     4,     0,
       2,     2,     2,     0,     3,     4,     4,     0,     2,     0,
       4,     0,     5,     3,     0,     1,     3,     1,     2,     3,
       0,     5,     4,     1,     0,     1,     2,     2,     1,     2,
       3,     2,     2,     2,     2,     3,     3,     1,     3,     1,
       0,     1,     2,     1,     1,     3,     6,    10,     1,     0,
       1,     2,     2,     0,     2,     2,     1,     0,     5,     7,
       1,     0,     6,     2,     0,     3,     5,     7,     6,     8,
       7,     6,     6,     4,     0,     1,     3,     4,     1,     3,
       1,     2,     2,     2,     2,     1,     1,    10,     2,     0,
       2,     2,     1,     0,     4,     6,     5,     4,     4,     8,
       1,     1,     1,     7,     9,     8,    15,    20,     1,     1,
       1,     3,     1,     1,     1,     3,     1,     3,     0,     1,
       0,     1,     1,     4,     0,     1,     3,     0,     1,     1,
       1,     1,     1,     1,     2,     0,     1,     2,     1,     2,
       0,     2,     1,     2,     2,     6,     8,     8,     4,     5,
       4,     4,     4,     3,     7,     8,     6,     6,     6,     6,
       3,     1,     3,     3,     1,     1,     1,     1,     1,     1,
       3,     3,     3,     1,     3,     3,     1,     0,     1,     3,
      13,     1,     3,     4,     5,     4,     7,     2,     1,     0,
       2,     0,     1,     0,     6,     8,     8,     1,     3,     5,
       5,     7,     9,     7,     9,     5,     6,     6,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     3,     3,
       3,     1,     3,     1,     2,     2,     3,     5,     2,     2,
       0,     6,     7,     7,     7,     8,     8,     6,     8,     9,
       9,     7,    10,     7,     8,     8,     8,     8,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     3,     4,     5,     4,     5,     3,
       4,     3,     4,     1,     2,     3,     3,     3,     3,     4,
       4,     3,     3,     4,     4,     4,     4,     1,     1,     1,
       0,     7,     7,    10,     1,     1,     2,     4,     5,     1,
       3,     2,     2,     2,     2,     1,     2,     2,     4,     3,
       2,     2,     2,     3,     2,     2,     5,     5,     5,     1,
       3,     1,     2,     3,     0,     1,     3,     2,     6,     6,
       9,     3,     0,     3,     0,     5,     2,     0,     3,     3,
       3,     7,     7,    10,     1,     1,     1,    14,     1,     0,
       1,     0,     1,     0,     2,     0,     1,     3,     4,     4,
       6,     1,     2,     0,     1,     1,     0,     1,     1,     0,
       9,    12,     7,     2,     0,     3,     2,     1,     3,     3,
       2,     1,     3,     3,     3,     2,     2,     1,     1,     1,
       1,     2,     1,     1,     1,     1,     4,     5,     1,     3,
       3,     1,     2,     4,     5,     1,     1,     1,     1,     3,
       3,     2,     2,     2,     2,     1,     2,     2,     1,     1,
       1,     3,     2,     0,     2,     1,     3,     5,     1,     2,
       1,     0,     5,     7,     5,     7,     5,     7,     3,     5,
       5,     5,     1,     3,     2,     1,     2,     1,     2,    11,
      10,    10,     2,     2,     0,     9,     2,     0,     4,     4,
       4,     1,     1,     1,     0,     7,     6,     6,     6,     6,
       7,     9,     9,     6,     6,     6,     6,     6,     8,     8,
       6,     6,     6,     5,     5,     8,     8,     8,     8,     6,
       1,     0,     2,     0,     7,     6,     6,     6,     6,     6,
       6,     7,     6,     6,     6,     6,     7,     7,     7,     9,
       9,     6,     6,     6,     8,     8,     8,     6,    13,     1,
       1,     3,     3,     1,     1,     1,     1,     1,     1,     1,
       0,     1,     1,     1,     1,     1,     1,     0,     6,     8,
       3,     2,     0,     2,     2,     2,     2,     3,     3,     2,
       2,     2,     2,     3,     2,     5,     4,     3,     3,     3,
       1,     1,     0,     3,     2,     2,     1,     3,     2,     1,
       0,     8,    10,     3,     4,     4,     0,     2,     5,     2,
       0,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     4,     3,     3,     1,     0,     5,
       6,     4,     2,     0,     4,     3,     5,     6,     4,     6,
       6,     5,     7,     1,     0,     6,    11,    11,    11,    13,
       9,    11,    10,     4,     2,     5,     2,     0,     4,     5,
       5,     4,     6,     1,     3,     1,     1,     1,     1,     2,
       4,     1,     1,     1,     0,     1,     0,     1,     0,     3,
       0,     2,     4,     3,     5,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     2,     1,     1,     1,     1,     1,
       0,     5,     4,     3,     0,     1,     1,     1,     1,     4,
       8,     3,     0,     5,     1,     4,     2,     1,     3,     2,
       3,     0,     6,     2,     0,     5,     3,     0,     2,     2,
       2,     3,     1,     3,     1,     2,     1,     0,     7,     1,
       3,     1,     1,     3,     5,     2,     1,     3,     7,     1,
       1,     0,     3,     2,     2,     2,     0,     2,     2,     1,
       1,     3,     3,     1,     2,     4,     4,     2,     3,     5,
       5,     1,     1,     9,     1,     2,     4,     4,     4,     2,
       3,     1,     3,     4,     2,     1,     0,     3,     3,     4,
       4,     4,     4,     2,     1,     1,     0,     1,     1,     0,
       1,     5,     1,     0,     1,     0,     3,     1,     3,     4,
       3,     2,     2,     1,     1,     1,     0,     2,     4,     5,
       2,     3,     1,     1,     1,     1,     3,     0,     1,     1,
       1,     1,     1,     3,     0,     2,     0,     1,     3,     1,
       0,     1,     2,     4,     4,     2,     0,     2,     3,     2,
       0,     1,     3,     1,     2,     1,     2,     5,     6,     5,
       1,     2,     1,     4,     3,     4,     5,     4,     5,     4,
       5,     2,     4,     1,     2,     2,     2,     1,     1,     0,
       4,     2,     1,     2,     2,     4,     1,     3,     1,     2,
       3,     1,     2,     0,     2,     4,     0,     1,     3,     2,
       2,     3,     5,     6,     2,     3,     3,     4,     0,     1,
       1,     1,     1,     1,     2,     5,     1,     1,     1,     1,
       2,     3,     3,     0,     1,     1,     1,     1,     1,     2,
       2,     2,     2,     2,     1,     3,     0,     1,     1,     1,
       1,     5,     2,     1,     1,     1,     1,     5,     2,     2,
       2,     1,     3,     3,     2,     1,     0,     3,     0,     5,
       2,     5,     2,     1,     2,     3,     0,     1,     1,     1,
       1,     1,     1,     3,     3,     3,     3,     3,     3,     3,
       0,     1,     4,     1,     3,     5,     2,     2,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     2,
       3,     3,     2,     3,     5,     4,     6,     3,     5,     4,
       6,     4,     6,     5,     7,     3,     2,     4,     2,     3,
       3,     4,     3,     4,     3,     4,     5,     6,     6,     7,
       6,     7,     6,     7,     3,     4,     4,     6,     2,     3,
       4,     1,     3,     2,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     2,     5,     6,     6,
       7,     3,     4,     1,     1,     2,     4,     1,     1,     1,
       2,     2,     2,     1,     4,     5,     6,     8,     6,     7,
       7,     5,     1,     1,     4,     1,     4,     1,     4,     1,
       4,     1,     1,     1,     1,     1,     1,     6,     4,     4,
       4,     4,     6,     5,     5,     5,     4,     6,     4,     4,
       4,     4,     5,     7,     7,     9,     4,     6,     5,     7,
       7,     7,     2,     3,     3,     3,     4,     0,     4,     1,
       3,     3,     1,     1,     1,     2,     2,     0,     2,     0,
       1,     3,     3,     2,     2,     0,     6,     1,     0,     3,
       0,     2,     2,     0,     1,     4,     2,     2,     2,     2,
       2,     4,     3,     5,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     4,
       1,     4,     1,     4,     1,     2,     1,     2,     1,     3,
       1,     3,     1,     3,     1,     3,     3,     3,     2,     1,
       3,     3,     0,     1,     1,     1,     1,     1,     1,     1,
       1,     4,     3,     2,     3,     0,     3,     3,     2,     2,
       1,     0,     2,     2,     3,     2,     1,     1,     3,     5,
       1,     2,     4,     2,     0,     1,     0,     1,     2,     2,
       2,     3,     5,     1,     2,     0,     2,     1,     0,     1,
       1,     1,     3,     3,     1,     3,     3,     2,     1,     1,
       1,     3,     1,     2,     1,     3,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     1,     1,     1,     1,     2,
       5,     2,     3,     6,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     2,     4,     3,
       2,     1,     1,     1,     1,     1,     0,     8,     2,     5,
       3,     2,     2,     3,     7,     1,     1,     1,     0,     2,
       2,     1,     0,     1,     3,     1,     2,     0,     2,     0,
       2,     0,     1,     3,     4,     3,     1,     1,     1,     1,
       2,     0,     2,     4,     0,     2,     2,     2,     1,     1,
       7,     3,     1,     1,     1,     1,     2,     0,     1,     3,
       3,     3,     3,     0,     4,     5,     5,     0,     1,     1,
       1,     2,     2,     1,     2,     0,     7,     0,     5,     0,
       4,     2,     2,     0,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     5,     2,     1,     3,
       2,     2,     3,     0,     5,     1,     0,     5,     2,     2,
       1,     1,     1,     2,     2,     3,     1,     2,     2,     3,
       3,     4,     2,     1,     2,     1,     1,     2,     2,     3,
       1,     1,     1,     1,     0,     1,     3,     5,     0,     2,
       0,     1,     2,     3,     2,     1,     1,     1,     0,     1,
       1,     1,     1,     1,     2,     2,     3,     0,     1,     2,
       1,     4,     3,     4,     3,     2,     1,     3,     1,     1,
       1,     1,     2,     2,     1,     2,     2,     1,     1,     1,
       4,     4,     4,     4,     4,     1,     0,     3,     3,     4,
       1,     3,     3,     4,     1,     3,     3,     1,     1,     1,
       6,     1,     3,     3,     6,     1,     3,     3,     1,     1,
       2,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     4,     4,
       1,     1,     4,     4,     3,     0,     7,     1,     0,     0,
       7,     3,     4,     3,     1,     1,     1,     2,     3,     5,
       2,     5,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     0,     1,     2,     1,     2,     1,     1,
       1,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       3,     1,     2,     1,     3,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     3,
       2,     3,     1,     3,     3,     3,     3,     3,     3,     1,
       1,     0,     2,     2,     1,     1,     2,     1,     1,     1,
       0,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
    2086,     0,     2,     1,  2516,  2520,  2524,  2525,  2442,  2526,
    2527,  2492,  2493,  2494,  2495,  2496,  2497,  2498,  2499,  2500,
    2501,  2502,  2503,  2505,  2504,  2506,  2507,  2508,  2509,  2510,
    2511,  2512,  2513,  2515,  2514,  2464,  2093,  2461,  2458,  2459,
    2460,  2465,  2463,  2456,  2457,  1699,  2529,  2517,  2530,  2518,
    2519,  2521,  2522,  2491,  2523,  2531,  2532,  2533,  2528,  2536,
    2487,  2488,  2486,  2489,  2490,  2534,  2535,  2478,  2479,  2480,
    2481,  2537,  2094,  2095,  2483,  2087,  2091,  2153,  2224,  2484,
    2485,  2482,  2092,  2477,  2224,     0,  2345,  2346,  2347,     0,
    2348,  2349,  2350,  2276,  2238,  2351,     0,     0,  2352,  2353,
    2354,  2355,  2356,  2357,  2358,  2359,     0,  2360,  2361,  2362,
    2363,  2223,  2364,  2365,  2366,  2367,  2368,  2200,  2206,  2329,
       0,  2180,  2181,  2177,  2179,  2178,  2182,  2165,  1002,   501,
    1082,  1081,     0,  1990,  1002,  1947,  1948,  1991,  1949,  1950,
    1951,   247,     0,  1084,  1952,     0,  1002,  1992,   336,   814,
    1993,  1994,  2108,     0,  1953,  1954,     0,     0,     0,     0,
     501,  1002,     0,     0,  1955,     0,  1956,     0,  1957,  1995,
    1996,     0,  1958,  1997,  1998,  1959,     0,  1960,  1961,  1999,
    2000,  2001,  1962,  2002,  2003,     0,     0,  1206,     0,  1963,
    2004,  1964,  1965,     0,  2005,  1966,  1967,  1968,  2006,  2007,
    2008,  1969,  1970,  1971,     0,  1972,     0,     0,     0,     0,
       0,  2009,  1002,  1973,     0,  1213,     0,  1974,     0,  2010,
    1975,     0,  1976,     0,  1977,  1978,  1979,  1980,  1206,  2325,
    2201,     0,     0,  1086,     0,  1981,  2011,     0,  1982,  1983,
    1984,  1985,  1986,  1987,  1988,  1989,     0,     0,    47,    48,
      16,    15,    21,    20,    70,    71,    37,    10,    61,    42,
     102,   101,   103,    27,    23,    55,    14,    24,    28,    44,
      43,    13,    41,    65,    45,    68,    34,    59,     7,    35,
      60,     8,    49,    72,    19,    46,    69,    30,    57,    53,
      38,    39,    40,    62,    63,    64,    86,    67,    97,    26,
      76,    77,    92,    78,    93,     5,    79,    36,     9,    89,
      88,    90,    56,    31,    58,    87,    91,    11,    12,    94,
      66,    84,    81,    98,    96,   104,    82,    50,     3,     4,
      73,    33,     6,    18,    17,    32,    25,   100,    22,  1084,
      75,    85,    74,    80,    54,    83,    99,    52,    95,  1182,
    1169,  1215,  1181,     0,  1184,  2421,  2422,    29,   124,   106,
     107,   112,  2090,  2142,  2143,  2144,  2224,  2175,  2176,  2169,
    2185,  2195,  2184,  2188,  2196,  2183,  2202,     0,   109,   111,
     113,   116,   110,   105,   108,   115,   120,   114,   119,   117,
     118,   121,   122,   123,  2423,  1390,  2420,    51,  2160,  2159,
       0,  2224,     0,  2369,  2370,  2371,  2372,  2373,  2374,  2424,
    2425,  2426,  2427,  2428,  2430,  2429,  2453,  1705,  1706,  1707,
    1708,  1709,  1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,
    1718,  1719,  1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,
    1728,  2396,  1729,  1730,  1731,  1732,  1733,  1734,  1735,  1736,
    1737,  1738,  2433,  1739,  1740,  1741,  1742,  1743,  1744,  1745,
    1746,  1747,  1748,  1749,  1750,  1751,  1752,  2434,  1753,  1754,
    1755,  1756,  1757,  1758,  1759,  1760,  1761,  1762,  1763,  1764,
    1765,  1766,  1767,  1768,  1769,  1770,  1771,  1772,  1773,  1774,
    1775,  1776,  1777,  1778,  1779,  1780,  1781,  1782,  1783,  1784,
    1785,  1786,  1787,  1788,  1789,  1790,  1791,  2435,  1792,  1793,
    1794,  1795,  1796,  1797,  1798,  1799,  1800,  1801,  1802,  1803,
    1804,  1805,  1806,  1807,  1808,  1809,  1810,  1811,  1812,  1813,
    1814,  1815,  1816,  1817,  1818,  1819,  1820,  1821,  1822,  1823,
    1824,  2436,  1825,  1826,  2437,  1827,  1828,  1829,  1830,  1831,
    1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,  1840,  1841,
    1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,  1850,  1851,
    1852,  1853,  1854,  1855,  1856,  1859,  1857,  1858,  1860,  1861,
    1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,  1870,  1871,
    1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,  1880,  1881,
    1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,  2438,  1890,
    1891,  1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,  1900,
    1901,  1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,  1910,
    1911,  1912,  1913,  1914,  1915,  1916,  1917,  1918,  2108,  1919,
    1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,
    1930,  1931,  1932,  1933,  1934,  2397,  1935,  1936,  1937,  1938,
    1939,  1940,  1941,  1942,  1943,  1944,  2439,  1945,  1946,  2126,
    2431,  2393,  2101,  2122,  2394,  2343,  2344,  1700,  2395,  2392,
    2432,  2128,  2449,  2127,  2391,  2275,     0,     0,  2237,  2236,
    2240,  2239,  2241,  2234,  2235,  1677,  2129,  2245,  2244,  1159,
    2448,  1676,  1160,     0,  2247,  2375,  2376,  2377,  2378,  2380,
    2379,  2381,  2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,
    2020,  2021,  2022,  2023,  2406,  2024,  2025,  2026,  2419,  2027,
    2028,  2407,  2029,  2030,  2031,  2032,  2033,  2034,  2035,  2036,
    2037,  2038,  2039,  2040,  2041,  2042,  2043,  2044,  2045,  2046,
    2047,  2048,  2049,  2050,  2051,  2052,  2408,  2409,  2053,  2054,
    2055,  2056,  2057,  2058,  2059,  2060,  2061,  2062,  2063,  2064,
    2065,  2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,  2074,
    2075,  2410,  2076,  2077,  2411,  2078,  2079,  2080,  2412,  2081,
    2082,  2083,  2084,  2085,  2416,  2417,  2418,  2405,  2198,  2382,
    2404,  2415,  2413,  2414,  2208,  2204,  2212,  2207,     0,     0,
       0,     0,  2224,  1001,  1000,   986,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   500,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2098,     0,  1010,   312,   311,  1083,  1064,   501,     0,   989,
     335,     0,     0,     0,     0,     0,     0,     0,   628,     0,
       0,     0,     0,     0,     0,     0,     0,   177,     0,     0,
     357,   356,     0,     0,     0,   788,     0,     0,     0,     0,
     489,  2107,  2102,  2112,     0,  2105,  2106,  2391,     0,  2540,
    1857,  2138,  2139,  2538,  1903,  1161,     0,   248,   251,   249,
     250,     0,   884,   885,   887,     0,     0,   897,   655,     0,
     654,     0,     0,     0,   652,     0,     0,     0,     0,   656,
     650,     0,   649,     0,     0,     0,   653,     0,   651,     0,
       0,   990,     0,  2190,  2191,  1794,  1122,   362,     0,     0,
       0,     0,  1084,  1091,  1101,  1096,  1098,  1097,  1099,  1095,
    1100,  1706,   730,  1719,   730,  1784,   727,   728,   730,   730,
     730,  1871,     0,     0,   702,     0,   713,  1701,   730,  1702,
    2449,   735,   412,   412,   412,     0,   734,   739,   412,     0,
     983,  1017,  1681,  1205,     0,  1719,  1784,   703,   982,  1919,
    1114,     0,     0,   901,     0,   902,     0,  1886,   994,   234,
    2389,  1895,  1977,  1919,  2390,   230,  2384,  2385,  2387,   204,
    2388,  2386,  2383,  1710,     0,     0,   734,     0,   991,   992,
    1212,  1210,     0,     0,     0,  1727,     0,  1739,  1818,   227,
    1882,  1887,  1895,  1977,  1919,  1944,   186,     0,   241,  1895,
    1977,  1919,     0,  1010,     0,  1185,  1292,  1672,     0,     0,
    2199,   985,   984,  1298,     0,  1085,     0,  1088,     0,  1257,
    1869,  1189,  1191,  1090,  1182,     0,  2089,  1079,  1209,  1209,
       0,  1209,     0,  1174,  1182,  1177,  1181,     0,  1002,     0,
    2167,  2195,  2174,  2230,  2171,     0,     0,  2220,  2216,  2213,
    2221,  2222,  2215,  2203,  1379,  1380,  1381,  1378,  1391,  1377,
       0,  2148,  1382,  2187,  2154,     0,  2162,  2161,  2466,  2467,
    2277,  2100,  2119,     0,     0,     0,     0,     0,     0,     0,
    2246,  2248,  2250,  2210,  2209,  2205,     0,     0,     0,     0,
    2335,  2336,  2334,     0,  2331,  2333,     0,  2230,     0,  2400,
    2394,  2403,     0,  1682,  2395,  2392,  2391,     0,   663,   127,
     777,     0,     0,     0,     0,     0,     0,     0,  1577,  1731,
    1780,  1587,  1585,  1586,  1579,  1580,  1581,  1582,  1583,  1584,
       0,   882,  1578,     0,   127,     0,     0,     0,     0,     0,
       0,     0,     0,  1822,   127,     0,     0,     0,     0,     0,
    1006,  1009,   987,  1067,     0,  1672,     0,     0,   688,     0,
     697,   689,   694,     0,   691,     0,     0,   699,     0,   690,
     692,   693,   698,     0,     0,   695,   696,     0,     0,   998,
     412,     0,     0,     0,     0,     0,   127,  1054,     0,   361,
     360,   127,   359,   358,  1731,  1780,     0,   813,   127,     0,
     179,   529,   504,     0,     0,   593,  1822,   127,     0,     0,
       0,     0,   791,     0,     0,   488,   501,     0,  2111,  2117,
       0,  2109,  2278,  2541,  2539,  2233,     0,  1134,   888,   228,
     229,   886,  1793,     0,   299,     0,     0,  1793,  1045,     0,
    1793,     0,  1793,   172,  1674,  1731,  1780,  1793,     0,     0,
    1793,   164,  1793,     0,  1793,   299,  1793,   505,     0,  1793,
       0,  1793,  1822,   166,     0,  1793,   299,   661,     0,     0,
    2471,  2475,     0,  2473,  2468,  2189,  2243,  2242,  2141,     0,
    2551,     0,  1161,  1093,  2397,  1107,  1106,     0,  1102,  1110,
    1105,     0,   730,   729,     0,   730,     0,  2560,   730,     0,
     730,     0,  2560,   730,     0,     0,     0,   730,  1703,  1704,
       0,     0,  2559,  2557,  2558,   704,   714,     0,   736,     0,
       0,   743,   742,   741,     0,     0,     0,   744,     0,  1296,
    1137,     0,   711,     0,   709,     0,   980,   997,     0,     0,
       0,     0,   904,   904,   904,   993,   233,   231,     0,     0,
       0,     0,     0,     0,   999,     0,     0,  2455,  1688,  1588,
    2454,     0,  1948,  1949,  1950,  1646,     0,  2396,  1951,  1952,
    1505,  1492,  1501,  1506,  1493,  1495,  1502,  1953,  1954,  1766,
    1955,  1956,  1695,  1957,  1958,  1334,  1960,  1961,  1962,  1497,
    1499,  1963,  1964,     0,  1696,  1966,  1967,  1846,  1969,  1970,
    1972,  1973,  1503,  1975,  1976,  1977,  1978,  1979,  1980,  1694,
       0,  1504,  1981,  1983,  1984,  1985,  1986,  1987,  1988,  1989,
       0,     0,  1669,     0,  1479,     0,  1326,  1327,  1349,  1350,
    1328,  1355,  1356,  1368,  1329,     0,  1668,  1393,  1478,  1483,
       0,  1477,  1473,  1196,  1664,     0,  1474,  1684,  1647,  1698,
    1697,  2449,  1655,  1687,  1685,  1686,     0,     0,     0,   197,
       0,     0,  2324,   243,     0,   244,  1670,  1895,   187,   226,
     199,   225,   200,   198,     0,  1729,   188,     0,   195,     0,
       0,     0,     0,     0,     0,     0,   237,   988,     0,  1294,
    1293,     0,     0,  1653,  1673,   670,     0,     0,  1299,     0,
    1077,  1078,  1076,     0,  1073,  1075,  1087,  1084,  1660,  1659,
    1661,     0,  1190,     0,     0,     0,  1172,  1171,  1090,  1207,
    1208,     0,     0,     0,     0,     0,     0,     0,     0,  1250,
    1223,  1224,  1226,  1247,  1251,     0,  1178,  1258,  2088,  2230,
    2231,     0,  2225,     0,  2224,  2224,  2218,  2217,  2214,     0,
       0,     0,     0,     0,     0,     0,  2145,   483,  2147,   481,
       0,     0,  2121,     0,  2125,  2123,     0,  2270,  2273,     0,
    2271,  2272,  2274,     0,  2279,  2280,     0,     0,     0,  2462,
       0,     0,  2261,  2249,  2256,  2258,  2260,  2259,  2268,  2264,
    2267,  2269,  2211,  2224,  2342,     0,  2337,  2340,     0,  2332,
       0,     0,     0,  1683,     0,     0,     0,   664,     0,     0,
       0,   126,  1043,   236,  1041,     0,     0,     0,     0,     0,
    1048,     0,     0,     0,     0,   846,     0,     0,     0,     0,
       0,     0,   847,   845,   848,   855,   868,   871,     0,   767,
     170,   171,     0,     0,     0,   931,     0,     0,   931,     0,
       0,     0,     0,     0,     0,     0,   253,   256,     0,     0,
       0,     0,     0,     0,     0,     0,   131,     0,     0,     0,
       0,   468,   480,     0,     0,     0,     0,     0,   477,     0,
     127,   254,   462,   465,     0,     0,     0,   538,   537,   931,
       0,   252,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   131,   163,     0,
       0,   255,     0,  2155,     0,  1004,  1005,     0,  1008,     0,
    1063,     0,     0,     0,     0,     0,     0,  1731,  1780,     0,
       0,     0,     0,     0,     0,   338,   318,   319,   127,   317,
       0,     0,   590,     0,  1337,  1366,  1344,  1366,  1366,  1333,
    1333,  1346,  1335,  1373,     0,  1366,  1333,  1338,     0,  1336,
    1376,  1376,  1361,     0,  1318,  1319,  1320,  1321,  1347,  1348,
    1322,  1353,  1354,  1323,  1390,  2401,  1333,  2402,  2399,  2398,
       0,  1020,  1053,     0,     0,   129,   629,     0,     0,   591,
       0,   129,     0,   175,     0,   533,     0,     0,     0,     0,
       0,     0,   549,   548,     0,     0,   592,     0,   129,   464,
       0,   454,   412,     0,   790,   793,     0,     0,     0,  2115,
    2110,  2113,     0,  2103,  2117,  1164,  1166,  1165,     0,  1163,
       0,  1306,     0,   299,   297,   298,   588,   896,     0,     0,
       0,     0,   299,     0,     0,  1793,     0,  1793,     0,     0,
     299,   299,     0,     0,     0,     0,   534,     0,   660,   658,
     657,   659,     0,     0,     0,     0,     0,  1793,   299,     0,
       0,   648,  2469,     0,     0,  2472,     0,  2192,  1598,     0,
    2554,  1119,  2555,     0,     0,     0,     0,   215,   216,   214,
    1108,   217,  1109,  1104,  1092,     0,   722,     0,  2560,  2561,
     707,     0,   717,     0,  2560,   705,     0,   718,   715,   716,
       0,     0,     0,  2556,  2440,  2446,   721,     0,     0,   413,
     415,     0,     0,  1752,     0,  1785,  1810,  1811,  1887,  1891,
       0,  1914,     0,   745,   772,   740,     0,     0,  1131,  1124,
       0,     0,  1147,   712,   710,   981,  1112,  1604,     0,     0,
       0,   903,   900,   899,   898,   232,   205,     0,     0,     0,
     774,  1886,   996,     0,     0,  1481,  1482,  1365,  1352,  1645,
       0,     0,  1360,  1359,     0,     0,     0,     0,  1342,  1341,
    1340,  1480,  1612,     0,  1339,     0,     0,     0,     0,  1366,
    1366,  1364,  1412,     0,  1343,     0,     0,  1625,     0,  1631,
       0,     0,     0,  1372,     0,  1370,     0,     0,  1448,     0,
       0,     0,     0,     0,     0,     0,  1396,  1397,  1479,  1598,
       0,  1691,     0,     0,  1358,     0,  1390,  1588,     0,     0,
       0,     0,  1658,  1596,     0,     0,  1426,  1594,     0,  1428,
       0,     0,     0,  1587,  1585,  1586,  1579,  1580,  1581,  1582,
    1583,  1584,  1592,  1409,     0,  1667,     0,  1408,     0,     0,
    1260,  1195,     0,  1689,  1648,     0,  2447,  2450,  1475,  2321,
    2320,  2319,  2318,  2289,     0,  2283,  2284,     0,  2322,  2323,
     245,   246,   242,     0,     0,   202,   201,     0,   223,   224,
     194,   222,     0,   218,   219,  1544,  1543,   203,   193,   191,
     189,   206,   208,   209,   192,   190,   240,   238,     0,     0,
       0,  1650,  1649,  1679,  1654,     0,     0,   299,  2224,  1300,
       0,  1260,  1149,  1151,  1152,     0,  1655,  1071,     0,  1068,
    1663,     0,  1192,     0,     0,  1080,  1188,  1187,  1216,  1217,
     806,  1186,  1241,  1242,  1237,     0,  1256,  1256,  1233,  1227,
    1232,  1230,     0,  1234,  1393,  1249,  1176,  1221,  1222,  1225,
    1175,     0,  1252,  1250,  1226,     0,  2232,  2230,  2170,  1318,
    2224,  2163,  2224,  2219,  2151,  1384,  1385,  1386,  1387,  1388,
    1389,  2152,     0,  2149,  1383,  2150,   482,     0,     0,     0,
    2118,     0,  2099,  2124,  2255,  2364,  2287,     0,  2288,     0,
       0,  2252,     0,  2262,  2265,  2263,  2266,     0,  1318,  2443,
    2338,  2443,  1318,     0,     0,     0,     0,     0,     0,     0,
     665,     0,     0,     0,  1914,   235,  1039,     0,     0,     0,
       0,   776,   775,     0,     0,   795,     0,     0,     0,  1051,
     405,     0,   296,     0,     0,     0,     0,     0,     0,     0,
     853,     0,     0,     0,     0,   854,   851,   852,  1887,   870,
     869,   867,   828,   830,   829,     0,   832,   816,     0,   817,
       0,     0,   827,   835,   833,     0,     0,     0,  1774,   258,
     270,     0,   930,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   289,     0,     0,     0,     0,   294,     0,
       0,     0,   293,     0,     0,     0,     0,     0,     0,     0,
     883,     0,     0,   158,   161,     0,     0,   467,   479,     0,
     471,   472,   469,   473,   474,     0,     0,     0,     0,     0,
       0,   466,     0,     0,   531,   530,   536,     0,     0,     0,
       0,     0,   924,   923,     0,     0,     0,     0,     0,     0,
       0,     0,   540,   541,     0,   542,     0,   162,     0,     0,
       0,     0,     0,     0,   213,  1003,  1007,  1066,  1680,  1065,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   323,
       0,   613,  2398,   589,     0,  1318,     0,  1314,  1310,  1379,
    1378,  1377,     0,  1324,  1333,  1330,     0,  1018,   379,   497,
     168,     0,     0,     0,   601,   604,     0,   125,   179,   362,
       0,   178,   180,   182,   183,   184,   181,   185,   528,   532,
       0,   503,     0,     0,     0,     0,     0,   553,   552,   556,
     554,     0,   550,     0,     0,     0,   157,   461,   463,  2096,
       0,   364,   443,     0,     0,     0,   792,     0,     0,     0,
       0,     0,  2116,     0,     0,     0,     0,  1162,     0,  1270,
    1133,  1261,  1272,  1263,  1265,  1301,     0,  1672,     0,  1131,
       0,   874,     0,  1046,  1793,   299,     0,   872,   173,  1675,
       0,     0,     0,     0,     0,   876,   645,   165,     0,   299,
     299,   506,     0,   299,   167,     0,     0,     0,   498,   299,
     662,  2470,  2476,  2474,  1121,     0,  2552,  2553,   454,  1166,
    1094,  1103,   719,   726,   708,   725,   724,   706,   723,   720,
    2254,     0,     0,  2445,     0,   737,     0,   411,     0,     0,
       0,   751,     0,     0,   750,   765,   752,     0,   754,   747,
     746,   755,     0,     0,   774,  1126,     0,  1127,  1655,     0,
    1123,     0,  1144,     0,  1142,     0,  1297,  1146,  1135,  1113,
       0,  1111,  1116,  1118,  1117,  1115,     0,     0,     0,   734,
       0,     0,   299,   995,     0,  1608,     0,  1609,     0,     0,
       0,  1644,  1640,     0,     0,     0,     0,     0,  1616,  1617,
    1618,  1615,  1619,  1614,     0,     0,  1620,  1613,     0,     0,
       0,     0,     0,  1363,  1362,     0,     0,     0,     0,     0,
       0,     0,  1451,  1483,     0,     0,  1572,     0,  1598,  1630,
       0,     0,  1374,     0,     0,     0,     0,     0,     0,     0,
    1598,  1636,     0,     0,     0,  1542,     0,  1539,     0,     0,
       0,     0,  1655,     0,     0,     0,     0,  1692,  1394,  1410,
    1666,     0,  1657,     0,     0,  1417,     0,  1637,  1444,     0,
    1449,  1432,     0,  1425,     0,  1430,  1434,  1413,  1658,  1597,
       0,  1595,     0,     0,  1411,     0,  1406,  1404,  1405,  1398,
    1399,  1400,  1401,  1402,  1403,  1407,  1576,  1574,  1575,     0,
       0,     0,  1429,  1787,  1818,     0,  1206,  1206,  1194,  1204,
    1665,     0,  1303,     0,     0,     0,     0,  1555,     0,  1602,
       0,  1600,  1682,  2452,  2451,  1656,     0,     0,     0,  1671,
       0,     0,  1390,     0,   239,  1295,  1651,     0,   668,   669,
     667,  1318,  1156,     0,     0,  1306,     0,  1155,  1090,  1074,
    1070,  1069,  1662,  1089,  1193,     0,   804,   805,     0,   809,
       0,     0,  1235,  1248,     0,  1147,  1147,     0,  1239,  1240,
    1231,  1180,  1179,  2168,  2226,  2173,  2194,  2164,  2197,  1392,
    2146,  2186,     0,  2120,  2290,  2291,     0,  2281,  2282,  2251,
    2257,  2328,     0,  2444,     0,     0,   611,   610,     0,     0,
       0,   942,   906,   666,   943,   907,  1040,     0,  1042,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   299,  1049,   944,   295,  1050,   935,     0,     0,
       0,   511,   512,     0,   849,   850,   945,   908,     0,   936,
     831,  1333,   815,     0,     0,   826,     0,   825,  1333,  1333,
     909,   169,   259,   379,   933,   275,   288,   283,   284,   282,
    1793,   299,  1793,   299,     0,     0,     0,     0,   285,   280,
     281,   277,   290,   291,   917,     0,   305,   308,   292,   273,
     276,   274,   257,     0,     0,  1678,     0,     0,   878,     0,
       0,   160,   920,     0,   140,   142,   144,     0,   138,   146,
     141,   143,   145,   139,   147,   137,     0,   136,     0,     0,
       0,   130,   951,   913,   470,   475,   915,   478,   938,   476,
    1709,  1767,  1896,     0,   518,   520,     0,   525,   957,   914,
       0,   937,   953,   922,     0,     0,     0,     0,     0,     0,
       0,  1055,     0,     0,     0,   952,   929,   940,     0,   921,
     916,   939,     0,     0,   211,   210,   212,     0,     0,     0,
       0,     0,     0,     0,     0,   701,   677,   700,     0,     0,
       0,     0,     0,     0,     0,   671,   337,   315,   316,     0,
       0,   314,   320,   612,     0,     0,     0,  1315,  1311,     0,
       0,     0,     0,     0,     0,  1331,     0,     0,  1038,  1038,
    1038,  1038,  1038,  1038,  1038,  1019,  1047,   496,   514,     0,
       0,     0,     0,   151,   128,     0,   634,   600,     0,     0,
     412,   174,     0,     0,     0,   502,   599,   597,   596,   598,
       0,     0,     0,   617,     0,  1307,     0,     0,     0,     0,
     366,     0,     0,   363,   367,   371,   372,   373,     0,   455,
     457,     0,     0,   447,     0,     0,     0,   820,     0,   838,
     821,     0,     0,     0,   858,   863,   859,   841,     0,   486,
    2114,  2108,  1167,  1168,     0,  1182,     0,  1272,     0,  1271,
    1283,     0,     0,  1289,  1287,     0,  1289,     0,  1289,     0,
    1264,     0,  1266,  1283,     0,  1673,     0,  1304,  1132,   299,
       0,     0,   508,   299,     0,   299,     0,   299,   299,     0,
     978,   535,     0,   585,     0,     0,   299,   647,  1599,     0,
       0,  2253,  2441,   738,   414,     0,     0,     0,     0,   749,
       0,   484,   753,     0,   764,   759,   761,     0,   768,     0,
       0,  1129,     0,  1145,  1138,  1140,  1139,     0,     0,  1136,
    1605,   646,     0,     0,   299,     0,   769,  1211,  1606,  1607,
       0,     0,     0,     0,  1641,     0,     0,  1518,  1494,  1496,
    1332,  1508,     0,  1345,  1519,  1520,  1498,  1500,     0,  1589,
       0,     0,  1509,  1453,  1454,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1466,  1465,
    1510,  1571,     0,     0,  1628,  1629,  1511,  1375,  1376,  1376,
       0,     0,  1635,     0,     0,     0,  1516,  1521,     0,     0,
    1526,     0,  1547,     0,     0,     0,  1476,  1599,  1367,  1368,
       0,     0,     0,     0,     0,     0,     0,     0,  1450,  1433,
    1427,     0,  1431,  1435,     0,     0,     0,     0,  1419,  1445,
    1415,     0,     0,  1421,     0,  1446,  1206,  1206,  1206,  1206,
    1203,     0,     0,  1259,     0,  1244,  1215,  1215,     0,  1555,
       0,  1484,     0,  1555,     0,     0,  2303,  2305,  2306,  2307,
    2308,  2309,  2311,  2312,  2314,  2315,  2316,  2304,  2310,  2313,
    2317,  2294,  2295,     0,  2285,  2286,   196,     0,   220,   207,
       0,  2328,     0,     0,  1150,  1131,  1153,  1072,  1218,     0,
    1590,   809,   807,   808,  1220,     0,     0,  1255,  1254,  1253,
    1228,     0,  2228,  2156,     0,     0,  2327,  2330,  2341,  2339,
    2166,   941,   905,   934,  1038,   779,   780,     0,   778,     0,
       0,     0,   404,   794,     0,     0,     0,     0,  1052,   495,
       0,   494,   490,   510,   843,     0,  1333,   818,   823,   824,
       0,   376,     0,     0,     0,   260,     0,     0,   272,     0,
     268,   286,   278,   287,   279,   302,     0,     0,     0,   947,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   948,
       0,     0,   133,   132,     0,   150,     0,   522,   523,   521,
     517,     0,   524,   526,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   946,   910,   672,     0,
       0,   673,   681,     0,     0,   674,     0,     0,     0,     0,
       0,     0,   683,   340,     0,   343,   350,   324,   328,  1054,
    1054,     0,   329,  1054,   325,  1054,   322,   614,     0,  1846,
    1579,  1580,   608,   615,   605,   607,   606,   609,   580,     0,
       0,     0,  1316,     0,  2542,  2550,  2549,     0,  1390,     0,
    1038,  1037,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   390,     0,     0,   384,     0,     0,   863,   378,
     381,   382,     0,   507,   153,     0,     0,   154,   152,     0,
     602,   603,     0,   362,     0,     0,   555,   558,   551,     0,
     616,   618,   594,     0,  1309,   514,  1122,   460,     0,   443,
     397,   439,     0,   453,     0,   441,   440,   442,     0,   449,
    1016,     0,   795,   819,     0,     0,     0,   856,   860,   857,
       0,     0,   834,     0,   842,   812,   973,   974,   971,   972,
       0,     0,  2131,  1158,  2140,  1274,  1281,     0,  1262,     0,
    1288,  1284,     0,  1285,     0,     0,  1286,     0,     0,  1281,
       0,     0,     0,   875,     0,   299,   873,     0,   641,     0,
     643,   877,   299,   299,   543,     0,   499,   457,     0,     0,
       0,     0,   748,   766,     0,   762,     0,     0,   731,   771,
    1125,  1128,  1130,  1143,  1141,   774,     0,   732,   773,  1610,
    1351,     0,  1643,  1639,     0,  1611,     0,  1623,  1622,  1452,
    1624,     0,  1471,     0,     0,  1463,  1461,  1462,  1455,  1456,
    1457,  1458,  1459,  1460,  1464,  1633,  1632,  1626,  1627,  1371,
    1369,     0,  1513,  1514,  1515,  1634,  1522,     0,  1541,  1540,
       0,     0,     0,  1528,     0,     0,  1537,     0,  1573,  1357,
    1390,  1395,     0,     0,  1418,  1638,  1436,     0,     0,     0,
    1414,     0,     0,     0,     0,  1423,  1589,     0,     0,     0,
       0,     0,     0,  1198,  1197,  1302,     0,  1246,     0,     0,
    1214,     0,  1555,  1491,  1558,  1553,  1554,  1603,  1485,  1690,
       0,  1601,  1555,     0,     0,     0,  1652,  2326,     0,  1157,
    1148,     0,  1219,  1236,  1229,  2172,     0,  2227,  2292,  2293,
       0,   785,   786,   784,     0,     0,     0,   580,     0,     0,
     420,     0,   803,   803,     0,     0,   863,   956,   491,   844,
       0,   836,     0,   265,   932,     0,     0,     0,   264,     0,
     299,   299,   306,   307,   310,     0,     0,     0,     0,     0,
     635,   621,     0,     0,   636,   637,     0,     0,   880,   881,
     879,   148,   134,   135,   149,   519,   918,     0,     0,     0,
       0,     0,   955,   928,   954,   926,   925,   927,   919,   545,
       0,   675,     0,     0,   676,   687,   685,   684,   686,   678,
     341,   127,     0,   321,     0,   348,     0,   346,   345,   347,
       0,     0,     0,     0,     0,     0,   582,     0,     0,   587,
     576,   578,     0,     0,     0,  1312,     0,     0,     0,     0,
       0,     0,  1317,  1325,   575,     0,  1029,  1028,  1027,  1031,
    1030,  1033,  1032,  1024,  1023,  1036,  1035,  1022,  1021,  1026,
    1025,     0,     0,   388,   392,   393,   391,   383,   863,   412,
     451,     0,   156,   155,     0,     0,     0,     0,   560,   564,
     595,     0,  1308,   539,  1120,     0,  2097,     0,   369,   374,
     375,     0,   447,   394,     0,   443,   368,   456,     0,     0,
     452,     0,  1011,     0,     0,   822,   839,   840,     0,     0,
     863,   862,     0,   493,     0,  2104,  1273,     0,     0,  1275,
       0,     0,  1277,  1279,     0,     0,     0,     0,     0,  1676,
    1555,  1305,   299,   509,   299,   299,   979,   586,     0,   758,
     757,   756,   485,     0,   760,   299,     0,  1642,  1507,  1517,
    1621,     0,     0,  1472,     0,     0,  1512,  1982,     0,     0,
    1545,  1546,  1527,     0,  1831,  1532,     0,     0,     0,  1693,
    1442,  1440,  1437,     0,  1438,     0,     0,  1420,  1416,     0,
    1422,  1447,  1202,  1201,  1200,  1199,     0,     0,  1549,  1555,
    1555,  1486,  1560,  1557,     0,  1488,  2296,     0,  2299,  2297,
    2298,  2302,  1390,  1154,     0,  2229,  1044,     0,     0,     0,
     406,     0,   863,     0,     0,     0,   801,   806,   806,     0,
     863,   451,   837,   261,   262,   263,   266,   301,   271,   267,
       0,   949,   911,     0,     0,   627,     0,     0,     0,     0,
     950,   912,     0,     0,     0,  1060,     0,     0,   679,   680,
     323,     0,   344,   353,     0,   351,   326,   331,     0,   333,
     332,   327,   330,   584,   583,   581,   577,   579,  1313,     0,
     894,   894,  2543,  2544,  2545,  2546,  2547,  2548,     0,   580,
    1034,     0,     0,   380,   451,   419,     0,   385,     0,   515,
       0,  1016,   364,   514,   559,     0,     0,     0,   619,   458,
       0,   365,     0,     0,   449,     0,     0,     0,   447,     0,
     444,     0,   448,     0,     0,     0,     0,     0,   861,     0,
     865,     0,   833,   810,  1303,     0,   497,  2130,  2134,     0,
    1282,  1291,     0,  1278,  1276,  1267,     0,  1269,   895,   642,
     644,   544,   763,   770,   299,  1467,     0,     0,     0,     0,
    1523,     0,  1524,  1529,  1533,     0,  1530,  1531,  1439,  1443,
    1441,  1424,  1243,  1245,     0,  1183,  1489,  1490,     0,  1215,
    1555,  2301,  2300,   221,  1591,   764,     0,   299,   803,   451,
     421,  1846,   422,   802,   809,   809,     0,   451,   580,     0,
     269,   309,     0,     0,   633,   622,     0,     0,   638,     0,
       0,     0,     0,     0,   682,   313,   339,   349,     0,   334,
     894,     0,   891,   890,   574,     0,   387,   386,     0,   430,
       0,   513,     0,   631,  1012,   527,   561,   562,   557,     0,
       0,   459,   370,   379,   355,   403,   402,   399,   398,   400,
     401,   396,   395,     0,   449,   445,   446,     0,  1013,     0,
    1062,     0,   796,   864,     0,     0,     0,   492,   487,     0,
    2132,  1280,     0,  1268,   733,  1468,     0,  1469,     0,     0,
    1535,  1534,  1548,  1550,     0,     0,  1563,  1487,   781,     0,
     782,   806,   425,     0,   799,   798,   412,   580,   407,   300,
       0,   625,   632,   623,   633,     0,     0,  1056,     0,  1057,
    1058,  1061,   352,   889,   893,   892,     0,   416,   417,   418,
       0,   389,   426,   427,     0,   516,     0,     0,     0,     0,
     377,   438,   354,  1014,  1015,   304,     0,   863,   866,   977,
    2135,  2137,  2136,     0,  1290,  1470,  1538,  1525,  1536,     0,
       0,  1559,     0,     0,     0,     0,   809,     0,   580,     0,
     419,   408,     0,   624,   640,   639,     0,     0,     0,     0,
       0,   428,     0,   429,   450,   630,     0,   563,     0,     0,
     449,   797,   811,   976,   975,     0,  2133,  1551,  1552,  1947,
       0,  1924,     0,  1561,  1564,  1562,  1556,   299,   800,     0,
     409,   423,   430,     0,  1059,   564,   435,     0,   434,     0,
     432,   431,   620,   567,   303,  1303,   959,   970,   958,   960,
     968,   965,   967,   966,   964,     0,  1568,  1567,  1566,  1570,
    1569,   783,     0,   580,   626,     0,   433,   437,   436,   572,
       0,   565,   568,   573,   571,   569,   570,   787,     0,   969,
     963,  1182,  1169,     0,   424,   410,     0,   546,     0,   961,
     970,  1565,     0,   566,   962,     0,   567,     0,   547
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,   247,   248,  1652,  2450,  2353,  3053,  3054,   249,
     250,  1707,   251,   252,   253,   254,   255,   256,   257,  1683,
     258,   259,  1239,  1833,  2461,   260,  2265,  1037,  2140,  2141,
    2405,  2142,  2130,  1510,  1931,  1653,  1675,   262,   263,  1504,
    2122,   264,   265,   266,  1696,  1697,  1660,  1876,  4220,  2342,
    4400,  2915,  2916,   267,   268,  3019,  1778,  3021,  3022,  3486,
     851,  2428,  3841,  3842,  3474,  3475,  3848,  4084,  4085,   269,
    1830,  3082,  3559,  3083,  3917,  3084,  3918,  3085,  3919,  3046,
    3529,  3530,  3531,  3086,  3923,  4271,  3087,  2280,  1361,  1958,
    1959,  4249,  3769,  3770,  4378,  4341,  4342,  4343,  4430,  3925,
    3093,  3569,  3930,  4117,  1850,  2492,  3088,  3089,  3916,   270,
     271,  2487,  1722,  1723,  2359,  3492,  3172,   272,  1256,  3391,
    4156,  3047,  3048,   273,   839,   274,  1837,   275,   276,   277,
     278,  3533,  4118,  1727,  2963,  2964,  2965,  2966,  3442,   279,
    1835,  1728,  2470,   280,   281,   282,  2394,   283,   284,   285,
    1844,  2481,  2482,  3909,  4125,  4258,  4127,  4460,  4461,  4109,
    3859,  3860,  3861,   286,   287,   288,   289,  1829,  2453,  2454,
    3493,  1642,  1782,  2430,  2431,  3549,  3550,   290,  3800,  3801,
     878,  4347,  4323,   291,   292,  3804,  3805,   293,   294,   295,
     296,   297,   930,  1306,  1307,  2889,   298,  2157,   299,  1218,
    3006,   300,   964,  1333,  1334,   301,   302,   975,  2619,   977,
    1972,  3174,  3175,  3638,  2584,  1153,   303,   304,  2594,  2622,
     305,  1655,  2271,  2272,  3764,   306,   879,  1855,  2495,  2858,
    4281,  3771,  4047,  2799,  3354,   307,   880,  1679,  2308,  2498,
    3098,  3099,  2310,  2758,  3581,  2312,  3100,  3105,  3106,  3107,
    3577,  3585,  4150,  4151,   308,  1677,  2301,   309,   310,   311,
    1702,  1170,   312,   902,   903,   313,  4242,   314,  1276,   315,
     996,  1992,   316,  2323,  3406,   317,   318,   319,  4438,  4468,
    4469,  4470,  3590,  4405,   320,  4440,  1376,   322,   323,   324,
     842,  1190,  1191,  1192,   325,  3932,   326,   327,  2447,  3045,
    3512,   328,   329,  2266,  2848,   330,   331,   332,  1823,   333,
     334,   335,   336,  1760,   337,  1543,  1544,   338,   339,   846,
    1057,  1547,  1555,   340,   943,  1327,  1328,  1329,  1933,   341,
    1380,  2611,   944,  1320,   945,  1978,  2596,  2597,  2600,   946,
    1871,   345,  1982,  2605,  2608,   947,  2161,  2162,  2163,  2164,
    2165,  2783,   948,   966,  1266,  2506,   949,  1464,   350,   351,
     352,   353,  1061,  1062,  2100,  2748,   984,  1561,  1022,  1072,
    3730,  2178,  2179,  2199,  2200,  1570,  1571,  2189,  2191,  2801,
    2192,  2810,  2184,  3727,  4018,  2195,  2196,  1573,  1574,  2805,
     354,  2752,  2510,  2511,  2512,  3119,  3129,  3601,  3952,  2513,
    1370,  1054,  2514,  3305,  2519,  3074,  3075,  2313,  2438,  1804,
    1465,  1805,  2445,  1466,  2024,  1807,  1467,  1468,  1469,  1810,
    1470,  1471,  1472,  1473,  2008,  2064,  1474,  1475,  2043,  1101,
    1102,  1918,  2661,  1477,  1478,  3696,  3997,  3988,  2686,  2687,
    2137,  3692,  4195,  4302,  4303,  3738,  3735,  4022,  4199,  4374,
    4413,  4414,  1479,  2739,  2092,  1172,  1480,  3495,  2094,  2681,
    2760,  2761,  2254,  2006,  2628,  2644,  2645,  2658,  3221,  2665,
    2670,  3244,  3245,  2682,  2708,  1481,  2631,  2632,  3205,  2010,
    1482,  1533,  1534,  2108,  2704,  1550,  1551,  1059,  1483,  1484,
    1973,  1046,  3948,  1284,   691,  2924,  2152,  1194,   981,  1485,
    1486,  1487,  3176,  1597,   670,   671,  1139,   795,     2,    75,
     950,  3079,   358,   359,   882,   883,   884,  1258,  1259,  1860,
    1863,  1602,  2232,   672,   673,   700,  3945,  4157,  4290,   936,
     360,   361,   362,   363,  1598,  2228,  1103,    76,    84,    77,
    1104,   400,   401,  2210,   364,   812,   365,  1579,  1083,  3362,
     366,   367,   368,   369,   370,   933,   371,  1085,   372,  1086,
     373,   374,   375,   376,  1093,   377,  1581,  1582,  3757,  1583,
     378,   379,   693,   694,  1318,   380,   381,  1120,  1121,  1352,
    1353,  1608,  1623,  1624,  1625,   382,   687,   383,   384,   385,
    1614,  1615,   386,  2115,  2116,  2237,  2117,   387,  2824,  2825,
     388,  3331,  3332,  4029,  3333,   389,  2111,   390,   391,  1049,
    3367,   392,   808,   393,  1134,   674,   675,   676,  1141,   798,
    1009,   701,  1143,  2967,   800,   801,   678,   679,   680,  1953,
      78,  2832,  1954,  1489,   702,  1490,  2106,  1491,  1492,  1493,
    1494,  1495,  1631,   684,  1110,  1310,  1311,  2833,  1313,    82,
    1314,   397,  3507,  1921,  1354,  1939,  1940
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -4053
static const int yypact[] =
{
   -4053,   422,  7641, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, 20592, -4053,
   -4053, -4053, -4053, -4053, 91296,   345, -4053, -4053, -4053, 57696,
   -4053, -4053, -4053,   217, 62976, -4053, 66336,   738, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, 70176, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, 50004,  1101, -4053,
     376, -4053, -4053, -4053, -4053, -4053, -4053, -4053,   -89,  4634,
   -4053, -4053, 66816, -4053,   120, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, 67296,   382, -4053,   462,  1018, -4053,    97, 11065,
   -4053, -4053, 58656, 63936, -4053, -4053, 70656,   767,   182,  1888,
   10606,   -89, 20109, 71136, -4053,  1887, -4053, 47083, -4053, -4053,
   -4053, 63456, -4053, -4053, -4053, -4053,   978, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, 77376,  2399,   728, 47572, -4053,
   -4053, -4053, -4053, 77376, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, 71616, -4053,   843,   637, 77856, 78336,
   60576, -4053,  1129, -4053, 77376,   248, 49523, -4053, 78816, -4053,
   -4053,   867, -4053, 72096, -4053, -4053, -4053, -4053,   728, -4053,
   50004, 44654, 72096,   192,   784, -4053, -4053, 79296, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053,  1826,   975, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,   382,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,   557,
   -4053,   663,  1150,  1237,  1059, -4053, -4053, -4053, 18851, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, 92727,  1717, -4053, -4053,
   -4053,  1081, -4053,  1124, -4053, -4053, -4053,   804, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053,  1060, -4053, -4053, -4053, -4053,
    1617, 91773, 70176, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, 58176, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053,   160, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, 70176, 70176, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, 70176,  1244, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053,   392,  1442, -4053, -4053, 50004,  2475,
    2475,  1696, 92727, -4053, -4053, -4053, 50966, 77376, 77376,  1445,
   77376,  1663, 50966, 77376, 77376,  1505, 40733, -4053, 77376, 77376,
   77376, 77376, 72096, 77376,  1458, 77376, 77376, 79776, 77376,  1585,
   -4053,  1834,    92, -4053, -4053, -4053, 77376,  9162,  2399, -4053,
   -4053, 77376,  1462, 50966, 77376,  1433,  1515, 77376, -4053, 77376,
    1769,  1591, 77376,  1712, 41226,  1606, 77376, 77376, 77376, 77376,
   -4053, -4053,  1603, 77376, 77376, -4053, 80256,   902,  1842,  1780,
     595, -4053, -4053,  1962,  1548, -4053, -4053,  1988, 70176, -4053,
   67776, -4053, -4053, -4053,  2048, -4053, 72096, -4053, -4053, -4053,
   -4053, 61056,  1888, -4053, -4053, 51447, 77376,  1827, -4053, 80736,
   -4053,  1903, 51928, 81216, -4053, 41719,  1964, 81696, 82176, -4053,
   -4053, 82656, -4053, 83136,  1705, 83616, -4053, 84096, -4053,  1831,
   84576, -4053,  8718, -4053,  1604,  2091,  1646,  1235, 70176, 70176,
    1931, 36368,   382, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053,   320,  1243, 48061,   883, 48550, -4053, -4053,   897,  1001,
    1250,   320,  2080,  2080,   229, 70176, -4053, -4053,  1243, -4053,
     203,   -37,  1651,  1651,  1651,  1862,   359, -4053,  1651, 77376,
   -4053, -4053, -4053, -4053, 72096, 48061, 48550, -4053,  1697,  2399,
      63,  2092, 77376, -4053, 77376, -4053, 77376, 77376, -4053, -4053,
   -4053,  2110,  1720,  1958, -4053,  1737, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053,  1904,  1920,  1926,   106,  2399,  1836, -4053,
   -4053,  1952, 25496,   800, 70176,  2399, 49039, 72576, 89376,   311,
   61056,  2399, 85056,  1792,    92,  1971, -4053,   460, -4053,  2199,
    1833,  2035,   -22,    92, 38304, -4053,  1830,   925, 72096, 93204,
   -4053, -4053, -4053, 85536,  1930, -4053,   155,  2106, 25994, -4053,
   77376,  1841, -4053,  1852,  1855,  1868, -4053, 77376,  1005,  1005,
    2241,  1005,  1204,  1572, -4053,  1877, -4053,   784,   -89,  1878,
   -4053, -4053, -4053,  1912, -4053,  1867,  1890, -4053,   421,  2149,
   -4053, -4053, -4053, -4053,  1982,  1993,  2000,  2011,  1933,  2024,
     260, -4053, -4053, -4053, -4053,  2216, -4053, -4053, -4053, -4053,
   -4053, -4053,  2352,  2341, 58656, 58656,   556,   579,   128,   220,
   -4053, -4053, -4053,  2222, -4053, -4053,  2204, 77376,  2058, 77376,
   -4053, -4053, -4053, 86016, -4053, -4053,  2475,  1912,  1976, -4053,
     178, -4053,   925, -4053,   323,   386,   473,  1314,  1989,  1417,
   -4053,   361,  2034,  2089,  1995,   447,  1892,   260, -4053, 77376,
   77376, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
    2010, -4053, -4053,  2018,  1550,  1378,  6070,   729,  2576,  1755,
     555,  2201,  1555,  2333,  1744,  3036, 77376,  2037,  2313,   446,
   -4053,   593, -4053,  2145,  2273,   615, 50966,  2111, -4053, 77376,
   -4053, -4053, -4053, 50966, -4053,  2296, 42212, -4053, 77376, -4053,
   -4053, -4053, -4053,  2237, 77376, -4053, -4053,  2366, 77376, -4053,
    1651,   249,  2141,  2512, 54333, 77376,  2183,  2549,  2202, -4053,
   -4053,  2183, -4053, -4053, 77376, 77376,  2176,  1598,  2183,  2568,
    2575,  2254,  2358,   677,  1201,    75,  2482,  2183, 77376, 77376,
   77376, 77376,  2559, 50966, 77376, -4053,  2374, 73056, -4053,  2233,
    1962, -4053, -4053, -4053, -4053, -4053,  1200,  2271, -4053, -4053,
   -4053, -4053,  2535,  1976,   112,  2542,  2253,  2546, -4053,  2300,
    2550,  1995,  2572,  2285, -4053, 86496, 86976,  2582,  2010, 77376,
    2588,  2285,  2589,  2476,  2596,   112,  2597, -4053,  1091,  2604,
    2495,  2622,  1540,  2285, 61536,  2626,    67, -4053, 10613,  8718,
   -4053, 18192,  1421, -4053, -4053, -4053, -4053, -4053, -4053, 29480,
     620,  2424, -4053, -4053,   784, -4053, -4053,  1654, -4053, 46594,
   -4053,  1931,  1243, -4053, 70176,  1243, 70176,   229,  1243, 70176,
    1243, 70176,   229,  1243, 70176, 70176, 70176,  1243, -4053, -4053,
    1395,  1756, -4053, -4053, -4053, -4053, -4053, 70176,  2357, 77376,
   77376, -4053, -4053, -4053, 64416, 77376, 64896, -4053,   427, -4053,
     119, 70176, -4053, 70176, -4053,  2399, -4053, -4053,  2091, 54333,
    2752, 77376,  2641,  2641,  2641, -4053, -4053, -4053,  2586, 77376,
    2646,  2658, 64416, 77376, -4053, 87456,  2389, -4053, -4053, -4053,
   -4053,  1685,  2555,   433,  2688, 29480,  2390,   351,   351,  2395,
   -4053, -4053, -4053,   491,  2400,  2401, -4053,   239,   239,  2556,
    2403,  2406, -4053,   511,  2411, -4053,  2812,   565,  2423,  2426,
    2429,  2041,   351, 29480, -4053,  2432,   239,  2433,  2434,  2436,
    2834,  2438, -4053,  2845,  2446,   276,   360,  2447,  2451, -4053,
    2403, -4053,   402,  2452,  2453,  2454,  2456,  2459,  2460,  2461,
   29480, 29480, -4053, 24500, -4053,  2399, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053,    98, -4053,   690,  4289, -4053, -4053,  2627,
   29480, -4053, -4053,    57, -4053,   705, -4053, -4053,   925, -4053,
   -4053,  1383, -4053, -4053, -4053, -4053,  1648,  1648,   162, -4053,
   66816, 66816, -4053, -4053,   937,  2421, -4053,  1026, -4053, -4053,
   -4053, -4053, -4053, -4053, 59136,  2859, -4053,   797,   593,  1403,
    2804, 45616, 46105,  2703,  2703,  2689, -4053, -4053, 77376, -4053,
   -4053, 29480, 43692, -4053,   925,   126,  2704, 77376, -4053, 38788,
   -4053, -4053, -4053,  1690, -4053, -4053, -4053,   382, -4053, 10808,
   -4053,  1694,  1841, 77376, 77376,  2866, -4053, -4053,  1852, -4053,
   -4053,  1237,  1237, 29480,  1237,   899,  1153, 26492, 29480,  2756,
    2653,   125,  1256,  2762, -4053,  1204,  1572, -4053, -4053,  1912,
    2490,  1754, -4053, 56256, 92250, 92250,  2726, -4053, -4053,   794,
      40,  2600,  2693,  2080,   688,  1724, -4053, -4053,  2487, -4053,
    2813, 66816,  2543, 58656, -4053, -4053, 77376, -4053, -4053, 73536,
   -4053, -4053, -4053,  1629,  2491, -4053,  2511, 77376,  2987, -4053,
    1724,  1724, -4053, -4053,  2503, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, 92727,  2507, 77376, -4053,  2508,  2509, -4053,
   93204, 44173,  1558,   925,  2581,  2583, 50004,  2514,  2584,  2587,
   89856, -4053, -4053, -4053, -4053,  1346,   787,   589,  2592,   552,
   -4053, 77376,  2692,   260,  2630, -4053,  2593,  2595,  2711,   260,
     866, 90336, -4053, -4053, -4053, -4053, -4053,  2361, 22546, -4053,
   -4053, -4053,  2599,  2594, 59616,  2889,  2705,  1163,  1045,   459,
   77376,  2782,  2603,  2605,  2536,  1477,  2534, -4053,  2699,  2598,
    2601, 53371,  2706, 42705,  2869,  2614, -4053,   599,  2619,  2620,
     260, -4053,  2930,   260,   260,  1394,  2931,  2624,   207,  1282,
    2183,  2534,  1355, -4053,  2560,  2632,  1423, -4053,  2733,    93,
    1333,  2534,  2635,  2637,  2536,  2536, 77376, 77376, 77376, 77376,
   77376,  2643,  2644,  2671, 68256,  2645, 89376, -4053, -4053,  2648,
    1676,  2534,  1418, -4053,  1360, -4053, -4053,    92, -4053, 77376,
   -4053, 77376,  1976, 54333,  2744,  1995,   260, 77376, 77376,  2010,
     929,  1231,  2745, 77376,  2815,  2612, -4053, -4053,  2183, -4053,
   44173,  2176, -4053,  2590, -4053,  2628, -4053,  2628,  2628,  2591,
    2591,  2602, -4053, -4053,  2041,  2628,  2591, -4053, 55295, -4053,
    1497,  1662, -4053,  2978,  2988, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053,  1251, -4053,  1710, -4053, -4053, -4053,
    2999, -4053, -4053, 54333, 77376, -4053,  2916,  2650, 50004, -4053,
    2647, -4053, 77376,   179,  2399,  2636, 77376,  2814, 77376, 77376,
   77376, 77376, -4053, -4053,   756,    16, -4053, 68256, -4053,  1355,
    2998,   -54,  1651,  2886, -4053, 77376,  2607,  3007,  2844, -4053,
   -4053,  2616,  2080, -4053,  2233, -4053,  1925, -4053,  2737, -4053,
   33450,  2663, 50966,   112, -4053, -4053, -4053, -4053, 54333, 77376,
   87936, 50966,   112, 77376, 77376,  2918,  2680,  2921,  2682, 42705,
     112,    69, 77376, 77376, 77376, 77376, -4053, 77376, -4053, -4053,
   -4053, -4053, 77376, 77376, 77376, 68256,  2923,  2924,   112, 77376,
   77376, -4053, -4053, 13086,  1557, -4053,  8718, -4053, 10808,  1722,
    2703, -4053,  1244, 77376,  1375,  1931, 65376, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, 70176, -4053, 70176,   229, -4053,
   -4053, 70176, -4053, 70176,   229, -4053, 70176, -4053, -4053, -4053,
   70176, 77376,  3125,  2638, -4053,  1383, -4053, 77376,  1729, -4053,
   -4053,  1739,    77, 77376,    95, 50966, 77376,  2817, 77376, 77376,
   77376, 77376,  2710,  2421,  1206, -4053,  2684, 37820,  2767, -4053,
     169, 72096,  2827, -4053, -4053, -4053, -4053, -4053,  1766,  1453,
     745, -4053, -4053, -4053, -4053, -4053, -4053, 64896, 63456,  2919,
     127, 77376, -4053, 29480, 24998, -4053, -4053, -4053,  2649, 10808,
    2687, 29480, -4053, -4053, 29480,  2080,  2080, 29480, -4053, -4053,
   -4053, -4053,   961,  2080, -4053, 29480, 29480,  2080,  2080,  2628,
    2628, -4053,  5311, 29480, -4053, 42705, 29480, 30974, 22047, 29480,
    2717,  2673,  2080, -4053,  2080, -4053, 29480, 24002, -4053, 29480,
    2862, 29480,  1403,  2864, 29480,  1403,  3071,  3071,  1543,  4918,
    2660, -4053,  2768,  2080, -4053,  2080,   610,   165, 54333, 29480,
   50004,  2736,   139, 29480,  2666,  2072, -4053, 29480,   176, -4053,
    2667, 29480,  2740, 29480, 29480, 29480, 29480, 29480, 29480, 29480,
   29480, 29480, -4053, 31970,   265, -4053,   -47,  1507, 65856, 25496,
    2946, -4053, 21548, -4053,   292, 70176, -4053, -4053,   925, -4053,
   -4053, -4053, -4053, -4053,  1629,  2669, -4053,  2690, -4053, -4053,
   -4053, -4053, -4053, 77376,  2859, -4053, -4053,  2741, -4053, -4053,
   -4053, -4053,   783, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
    2672, -4053, -4053, -4053, -4053,  2672, -4053, -4053,  2703,  2677,
    3331, -4053, -4053, -4053, -4053,  2940,  2941,   112, 92727, -4053,
   77376,   167, -4053, -4053, -4053,  2694, -4053, 77376,   155, 68736,
   -4053, 25994, -4053,  1816,  2403, -4053,  2926, -4053,  2691, -4053,
    7920,  2926, -4053, -4053,   205,  2856,  2863,  2863, -4053,  2696,
   10808, -4053,  1906, 10808,  1955, -4053, -4053, -4053, -4053, -4053,
   -4053,  1185, -4053,  2756,  1256,  1941, -4053,  1912, -4053, -4053,
   19550, -4053, 21069, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053,  2700, -4053, -4053, -4053, -4053,   260,  2707,  3158,
   -4053, 58656, -4053, -4053, -4053,  3125, -4053,  1988, -4053,  1988,
    3183, -4053, 70176, -4053, -4053, -4053, -4053,  1090, -4053,  8718,
   -4053,  8718, -4053,  2708,  1828,  2770,  2774,  2807, 77376, 77376,
   -4053, 50004, 77376, 77376, 77376, -4053,  3049,   924, 63456,  2820,
   62016, -4053, -4053,  2713, 77376,  2757,  2944,  2945,  2716, -4053,
   -4053, 77376, -4053,  2894, 77376, 29480,  2900, 77376,  1368,  2901,
   -4053,   950, 77376, 77376,  2893, -4053, -4053, -4053, 61056, -4053,
   -4053, -4053,  2887, -4053, -4053, 55295, -4053, -4053,  1844, -4053,
   54814, 52409, -4053, -4053,   935, 77376, 77376, 77376,  1036, -4053,
   -4053, 54333, -4053, 77376, 77376, 77376, 69216, 88416, 88896,  1181,
    1255, 77376, 69696, -4053, 77376, 77376, 77376, 50004, -4053, 77376,
    2902,   676, -4053,  3131,  2796, 77376, 77376,  2725,  1859,  2799,
   -4053, 77376, 77376,  3853, -4053, 77376, 77376, -4053, -4053,   260,
   -4053, -4053, -4053, -4053, -4053, 77376, 77376,   260, 77376,   260,
     927, -4053, 50485, 77376, -4053, -4053, -4053, 77376, 77376, 77376,
   77376, 77376, -4053, -4053,   884,   898,  2865,  2868,  2870, 77376,
   77376, 77376, -4053, -4053,  2837, -4053, 77376,  3853, 77376, 77376,
    2809,  2818,    56,  2875, -4053, -4053, -4053, -4053, -4053, -4053,
    2976,  3137, 77376,  2983,  2985,  2794,  2802,  2989,  1514, 77376,
   77376, 77376, 77376, 77376, 77376,  2993,  1514,  2928,    58,  2754,
    1869, -4053,  2775, -4053, 29480,  3156, 54333,  2765,  2766,  2835,
   -4053,  2838,  2080, -4053,  1874, -4053,   756,  1782, -4053,   436,
   10148,  3047, 77376,  1880, -4053,  2785, 77376, 10148, -4053,  1731,
   63456, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
    3052, -4053,  2399,  2176,  2176,  2176,  2176, -4053, -4053, -4053,
    2953,  1546, -4053,  2777, 77376,  2885, 10148, -4053,  1355,  3072,
   77376, 60096,  1999,  3174,  2399,  2956, -4053, 23031,  3644,  2958,
   61056, 73056, -4053,  2791,  3050,  3051,  3069, -4053, 32966, 74016,
    2787,  2099, -4053, 74016, 74496, -4053,  2792,   925, 26990,  2767,
    1976, -4053,  3185, -4053,  3087,   112,  1995, -4053,  2285, -4053,
   77376, 77376, 77376, 77376,  2010, -4053, -4053,  2285,  2972,   112,
     112, -4053,  2973,   112,  2285,  2907,  3082, 61056, -4053,    67,
   -4053, -4053, -4053, -4053, -4053, 29480, -4053, -4053,  2821,  1925,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, 70176,  1988, -4053,  1896, -4053, 77376, -4053,  3059,  3073,
    3074,  2285,  2847, 77376,  2822, -4053,  2285,   260,  2285,  2421,
    2421,  2285, 74976,  3228,  3093, -4053,  1900, -4053, -4053, 25496,
   -4053,    65, -4053,   479,   568,  3031, -4053, -4053, -4053, -4053,
   54333, -4053, -4053, -4053, -4053, -4053, 77376,   180,  3002,  2826,
   74976,  3209,   112, -4053,  1905, -4053,  1571, -4053,  1635, 29480,
   29480,   110, -4053,  8343,  1914,  2831,  2833,  1918, -4053, -4053,
   -4053, -4053, -4053, -4053,  2836,  3111, -4053, -4053,  2840,  1949,
    1961,  2841,  2846, -4053, -4053,  3984,  2848,  9182,  2849, 30974,
   30974,  2190, -4053, -4053, 30974,  2850, -4053,  1980,  9158,  2842,
    2851,  2855, -4053,  2857,  2858,  9610, 27488, 29480, 27488, 27488,
    9728,  2842,  2860,  1986, 50004, 10057,  1997, -4053, 29480, 50004,
    4720, 29480, -4053, 29480, 77376,  2861,  2871, -4053, -4053,  5311,
   -4053,  2874, -4053, 30974, 30974,  5453, 24500, -4053, -4053,  3114,
   -4053, -4053,  2331, -4053,  2867, -4053, -4053,  5877,   196, 29480,
    2666, 29480,  2934, 42705,  9947, 29480,  4955,  6064,  6064,   590,
     590,    94,    94,    94,  1489,  1507, -4053, -4053, -4053,  2873,
    2438, 29480, -4053,  2084,  2100, 77376,  6840, 10999, -4053, -4053,
   -4053, 33450,  2882, 29480, 29480, 29480,  2876,  3013,  3275, 10808,
     572, -4053,  3277, -4053, -4053, -4053,   187,  3183,  1629, -4053,
      92,  2080,   610, 46594, -4053, -4053, -4053, 29480, -4053, -4053,
   -4053, -4053, -4053,  2025, 38788,  2663, 25994,   925,  1852, -4053,
   -4053, -4053, -4053, -4053, -4053, 29480, -4053, -4053,   559,  2046,
   29480,  1906, -4053, -4053, 77376,  2827,  2827, 29480, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053,  -152, -4053, -4053, -4053, -4053,
   -4053, -4053,  2881, -4053,  2877, -4053,  2879, -4053, -4053, -4053,
   -4053,   133,  2891,  2890,  2896,  1521, -4053, -4053, 77376, 77376,
   77376, -4053, -4053, -4053, -4053, -4053, -4053,  3088, -4053, 77376,
   77376,  3044, 77376,  3042,  3048, 29480,  1270, 77376,  2898,  2899,
    2903, 77376,   112, -4053, -4053, 10808, -4053, -4053,  2943,  2964,
   77376,  2733, -4053,  3144, -4053, -4053, -4053, -4053,  3084, -4053,
   -4053,  1710, -4053, 52409, 54814, -4053, 54814, -4053,  1710,  1391,
   -4053,  2285, -4053, -4053,   786, -4053, -4053, -4053, -4053, -4053,
    3192,   112,  3195,   112, 77376, 77376, 77376, 77376, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053,  2049, -4053,  1070, -4053, -4053,
   -4053, -4053, -4053, 77376,  1479, -4053,   622, 54333, -4053, 53852,
   77376, -4053, -4053,  3129, -4053, -4053, -4053,  3063, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053,  1974, -4053,  3068, 77376,
    2965, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   50004, 50004, 50004,  2064, -4053, -4053,  2399, -4053, -4053, -4053,
    2986, -4053, -4053, -4053,  3130,  3132,  3134,  2991,  2995,  2996,
    3001, -4053,  3006,  3009,  3010, -4053, -4053, -4053, 77376, -4053,
   -4053, -4053, 77376, 77376, -4053, -4053, -4053,  1514, 54333,  3149,
    1514,  1514, 77376, 77376,  1514, -4053, -4053, -4053,  3153,  3162,
    3163,  3175,  3177,  3178,  1514, -4053, -4053, -4053, -4053,   249,
   50004, -4053,  2709, -4053,  2048, 40240,  5509,  2947,  2766,  2948,
    2080, 35884,  1136,  3152,  2951, -4053,  1576,  3172,  2971,  2971,
    2971,  2971,  2971,  2971,  2971, -4053,   928, -4053,  3138, 77376,
     475, 77376,  2080, -4053, -4053,  3022, -4053, -4053, 50004, 40240,
    1651,   179,  3099,  1399,  3299, -4053, -4053, -4053, -4053, -4053,
   77376, 77376,   756,  2399,  2065, -4053, 54333, 77376, 70176,  1826,
    2975, 77376,  2977,  2970, -4053, -4053, -4053, -4053,  2079, -4053,
   54333,   -28,  3151,  3154,  1826,  3053, 77376, -4053,  2082,    50,
   -4053,  2399, 61056, 52890, -4053,  3382, -4053, -4053,   736,  3243,
   -4053, 77376, -4053, -4053, 37336, 34902,  2099,  2980, 77376, -4053,
    2979, 33450,  3215,  3155, -4053, 33450,  3155,  1437,  3155,  3216,
   -4053, 39272, -4053,  2992, 21548,  1631,  3164, 10808, -4053,   112,
   54333, 77376, -4053,   112,  3043,   112,  3045,   112,   112, 77376,
   -4053, -4053, 77376, -4053, 77376, 68256,   112, -4053, 10808, 77376,
    3274, -4053, -4053, -4053, -4053,  3113,  3115,  3116, 77376,  2285,
   50966, -4053,  3004, 77376,  1209, -4053, -4053,  3167, -4053,  1826,
   77376,   925,   201, -4053, -4053, -4053, -4053,  3294,  3296, -4053,
   -4053, -4053, 77376, 64416,   118, 77376, -4053, -4053, -4053, -4053,
    3016,  2086, 10475, 29480, -4053,  3303, 54333, -4053, -4053, -4053,
   -4053, -4053, 29480, -4053, -4053, -4053, -4053, -4053, 29480, -4053,
   29480,  3291, -4053,  3431,  3431, 54333, 30974,  1309,  2433, 30974,
   30974, 30974, 30974, 30974, 30974, 30974, 30974, 30974, 32468,   418,
   -4053, -4053, 29480, 29480,  3298,  3291, -4053, -4053,  1325,  1325,
   54333,  3018,  2842,  3019,  3020, 29480, -4053, -4053,  2104, 50004,
   -4053, 29480,  9081,  2133,  3062, 10758,   925,  5641, -4053,  3391,
    2399, 29480,  2067,  2324, 29480,  2144, 29480,  3300, -4053, -4053,
   -4053,  3024, -4053, -4053, 54333, 29480, 30974, 30974,  6712, -4053,
    8190, 29480,  3025,  8607, 24500, -4053,   728,   728,   728,   728,
   -4053, 77376, 77376,  2787, 29480,  3301,   -58,   -58,  3026,  3013,
   39756, -4053, 29480,  1459, 27986,  3028, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053,  3032, -4053,  3054, -4053, -4053,   593,  3030, -4053, -4053,
    5189,   133,  3055, 77376, -4053,  2767, -4053, -4053, -4053,  3039,
   -4053,  2046, -4053, -4053, -4053,  6116,  3213,  2421, -4053, -4053,
   -4053,  2080,  3058, -4053,  1988,   187, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053,  2971,  2285,  2285,   835,  2285,  3316,
     835,  6169, -4053, -4053, 33934, 77376, 77376,  2148, -4053, -4053,
   77376, -4053,  1989, -4053, -4053,  3293,  1692, -4053, -4053, -4053,
    3112,   928,   941,  2536,   216, -4053,  3118, 77376, -4053, 77376,
   -4053, -4053, -4053, -4053, -4053, -4053, 50004, 40240, 50004, -4053,
    3122,  3128,   923,   101,  3135,  3136,  3061,  3070,  3076, -4053,
     320,  2399, -4053, -4053,  2399,  2285,  2399, -4053, -4053, -4053,
   -4053, 50485, -4053, -4053, 77376,  3339,    87,  1596, 77376, 77376,
   77376, 77376, 77376, 77376, 77376,  2733, -4053, -4053, -4053,  3077,
    1514, -4053, -4053,  3309,  3315, -4053,  1514,  1514,  1514,  1514,
    1514,  1514, -4053,    41,  2153, -4053, 35387, -4053, -4053,  2549,
    2549,   811, -4053,  2549, -4053,  2549, -4053, -4053,  2775,  3039,
    2080,  1724, -4053, -4053, -4053, -4053, -4053, -4053,  1165,  2080,
    2081,  3085, -4053, 36852, -4053, -4053, -4053,  2171,   610, 77376,
    2971, -4053,  2363,  2003,  2464,  2540, 75456, 75936, 76416,  3086,
   77376, 30974, -4053,  1217,   698, -4053,  3317, 77376,  3123, -4053,
   -4053, -4053,  3089, -4053,  2285, 77376, 77376,  2285, -4053, 54333,
   -4053, -4053,  3479,  1235, 77376,  3121,  3092,  3372, -4053,  3098,
    3100, -4053, -4053, 77376, -4053,  3138,  1646,  3140, 62496,  1999,
   -4053,  3351, 60096, -4053, 77376, -4053, -4053, -4053,  3460,  3187,
    3145,  2399,  2757, -4053, 52409, 29480, 29480, -4053,  3110, -4053,
    3124,  3733, -4053,  2176, -4053, -4053, -4053, -4053, -4053, -4053,
    3184, 77376,  3533, -4053, -4053, 74016,  3127, 77376,  2099, 33450,
   -4053, -4053,  2686, -4053, 33450,  3349, -4053, 33450, 77376,  3139,
   77376,   809, 77376, -4053,  3120,   112, -4053, 77376, -4053, 77376,
   -4053, -4053,   112,   112, -4053,  3229, -4053, -4053,  1826, 77376,
   77376, 77376,  2285, -4053,   260, -4053,  3392, 74976, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053,   127,  3403, -4053, -4053, -4053,
   -4053, 29480, 10808, -4053,  3133, 10808,  6184, 10808,  3298, -4053,
    2895,  3404, -4053,  1318,  3141,  2895,  2083,  2083,   124,   124,
     116,   116,   116,  3431,   418, 10808, 10808, -4053, -4053, -4053,
   -4053,  3146, -4053, -4053, -4053,  2842, -4053, 29978, -4053, -4053,
    3165,  3166,  3147, -4053, 29480, 30476,  3142, 55295, -4053, -4053,
     610,  3071, 30974, 30974,  1117, -4053,  1517, 29480, 54333,  2170,
    1117,  2346,  2819, 29480, 29480,  8735,   333, 29480,  6752, 77376,
   77376, 77376, 77376, -4053, -4053, 10808,  3510,  3400, 29480,  3148,
   -4053,  3150,  3013, -4053, 90816, -4053, -4053, 10808, -4053, -4053,
   29480, -4053,  3013,   187,   890,  2399, -4053, -4053,   784, -4053,
   -4053, 42705, -4053, -4053, -4053, -4053,  8718, -4053, -4053, -4053,
     320, -4053, -4053, -4053,  3206, 63456,  3412,  1165, 29480,  2187,
   -4053,  3171, 76896, 23516,  2191,  2197,  3123, -4053,  2514, -4053,
    3211, -4053,  3335, -4053, -4053,  3340,   320, 77376, -4053, 54333,
     112,   112, -4053, -4053,  3169, 77376, 77376,  2080,  2080, 54333,
    3160, -4053,  2080,  2080,  3161, -4053, 77376, 77376, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, 77376, 77376, 77376,
   77376,  3448, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
    3395, -4053,  1514,  1514, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053,  2183,  3481, -4053, 50004, -4053, 57216, -4053, -4053, -4053,
    2399,  2399,  3348, 45135,  2399,  2399, -4053,  1252,  3487, -4053,
    3417,   619,  3173,   134,  3444, -4053,  1804, 36852, 36852, 36852,
   36852, 36852, -4053, -4053,  3449,   320, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, 29480,  1064,  2895, -4053, -4053, -4053, -4053,  3123,  1651,
    3223, 50004,  2285,  2285,  3225,  1826,   329, 77376,  3480,  3217,
   -4053,  2399, -4053, -4053, -4053,   611, -4053,  2200, -4053, -4053,
   -4053,  3214,  3154,  1439,  3182,  1999, -4053, -4053,   948, 77376,
   -4053,   945, -4053,  3451,  3186, -4053, 10808, 10808,  2399, 55776,
    3382, -4053, 77376,  3425, 77376, -4053, -4053, 77376,  2207, -4053,
   29480,  3188, -4053, -4053, 33450,  2686,  2210, 77376,  2223, 54333,
    3013, -4053,   112, -4053,   112,   112, -4053, -4053, 77376,  2285,
    2285,  2285, -4053,  3354, -4053,   112, 74976, 10808, -4053, -4053,
   -4053, 30974,  3459, -4053,  3189, 54333, -4053,  3190,  2238,  2245,
   -4053, -4053, -4053,  6947,  3231, 10808,  3286,  3193,  3194, -4053,
     919,   919,  1517,  2248, -4053, 30974, 30974,  1117,  1117, 29480,
    1117, -4053, -4053, -4053, -4053, -4053, 29480, 29480,  3227,  3013,
    3013, -4053,  3355, -4053,  3197, -4053, -4053,  1724, -4053, -4053,
   -4053, -4053,   610, -4053,  3198, -4053, -4053, 74976,  3374, 74976,
   -4053,  6983,  3123, 33934, 43198, 77376, -4053,  1038,  1038,  3338,
    3123,  3223, -4053, -4053, -4053, -4053, -4053,  3254, -4053, -4053,
   40240, -4053, -4053, 34418, 42705, -4053,   923,  3205,  3207,   101,
   -4053, -4053,  1230,   852,  3239,  2285,  3488,  1514, -4053, -4053,
    2754,  2399, -4053, -4053,  2256, -4053, -4053, -4053, 77376, -4053,
    3092, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, 50966,
    3603,  3603, -4053,  1820,  1820, -4053, -4053, -4053, 77376,  1165,
   -4053,  7079,  3393, -4053,  3223,  3420,  3465, -4053,  2270, -4053,
   77376,  3145, 60096,  3138, -4053,   352,  3218,  3507, -4053, -4053,
    3545, -4053, 62496,  3389,  3187,   795,   795, 77376,  3154,  3341,
   -4053,  3342, -4053,  3586,  3396,  3588, 77376, 33934, -4053, 54814,
   -4053,  2276, -4053, -4053,  2882, 77376,   436, -4053,  3240,  2277,
   -4053, 10808, 77376, -4053, -4053, -4053,  2282, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053,   118,   660, 30974, 54333,  2286, 29480,
   -4053, 29480, -4053, -4053, -4053,   406, -4053, -4053, -4053,   919,
     919,  1117,  2842, 10808, 77376, -4053, -4053, -4053,  3606,  3397,
    3013, -4053, -4053, -4053, -4053,  1209,   835,   118, 76896,  3223,
   -4053,  3230, -4053, -4053,  2046,  2046, 77376,  3223,  1165, 29480,
   -4053, -4053, 54333,  1995,   588, -4053, 54333, 54333, -4053, 77376,
   77376, 77376, 77376, 77376, -4053, -4053, -4053, -4053, 57216,  3092,
    3603,   625, -4053, -4053, -4053,  3511, -4053, -4053,   626,  3407,
    3312, -4053, 50004,  3521, -4053, -4053, -4053, -4053, -4053, 29480,
    3383, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053,  2290,  3187, -4053, -4053,  3409, -4053,  3413,
   -4053,  2294, -4053, -4053,  3733, 55776,  3551, -4053, -4053,  2151,
    3661, -4053,  2302, -4053, -4053,   660,  2321, -4053,  2328,  2342,
    3292, -4053,  3242, -4053,  3641, 29480,  1343, -4053, -4053,  3524,
   -4053,  1038,  3289, 42705, -4053, -4053,  1651,  1165, -4053, 10808,
    2348, -4053, -4053, -4053,  3394,  2349,  2360,  3252,  3290,  3252,
   -4053,  2285, -4053, -4053, -4053, -4053,  3562, -4053, -4053, -4053,
     198, -4053,  3434,  3436, 77376, -4053, 77376,  3657,  7342, 50966,
     928, -4053, -4053, -4053, -4053,  3302, 33934,  3382, -4053,   212,
   -4053, -4053, -4053, 77376, -4053, -4053, -4053, -4053, -4053, 77376,
    3266,  2842, 28484, 28484,  3269, 74976,  2046,  3272,  1165,  3273,
    3420, -4053, 50966, -4053, -4053, -4053, 77376,  3401,   814,   814,
    3589, -4053,  3327, -4053, -4053, -4053,   923, -4053,  3276,  2536,
    3187, -4053, -4053, -4053, -4053,  1484, -4053, -4053, -4053, 31472,
    3402,   917,  8219, -4053, -4053, -4053, -4053,   118, -4053, 29480,
   -4053, -4053,  3407,  1995, -4053,  3217, -4053,  3692, -4053,   772,
   -4053, -4053,  3160, 56736, -4053,  2882, -4053,  1216, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053,  3683, -4053, -4053, -4053, -4053,
   -4053, -4053,  7767,  1165, -4053,  3579, -4053, -4053, -4053, -4053,
    2370, -4053, -4053, -4053, -4053, -4053, -4053, -4053,  1240, -4053,
   -4053,  1599,  1868, 28982, -4053, -4053,  3433, -4053, 56736, -4053,
    1216, -4053, 50966, -4053, -4053,  3297, 56736,  2376, -4053
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -4053, -4053,  3435, -4053, -1140,   -17,  2051, -1006, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053,  1336, -4053, -4053,   -84,  1172,  2274,  1022,
   -4053, -1297, -4053, -4053,  -850,   164,  -976, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053,   931,  1457,   908, -1256, -4053, -1663,
   -4053, -4053,   388, -4053, -4053, -4053,   790,  -275, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053,   -38, -4053, -4053,  -428, -1738,
    -114, -4053, -4053, -4053, -4053,   250,  -321, -1543, -4053, -2820,
   -4053,   -79, -4053, -4053, -4053,  -322, -1616,   960,  -954, -1332,
    1241,  -562, -4053,  -220, -4053,  -588,  -508,  -505,  -550, -4053,
   -3331, -3657, -3324, -2810, -4053, -4053, -4053,   278, -4053, -1733,
   -4053, -4053,  1998, -1586, -4053,  -990, -4053, -4053, -4053, -3436,
   -4053,  1566,  -301, -4053,   -41, -4053, -4053, -4053, -4053, -4053,
   -4053, -3393, -4053, -1651, -4053,   419, -2854,   909, -4053, -4053,
   -4053,  2028, -4053, -4053, -4053, -4053, -1762, -4053, -4053, -1718,
   -4053,  1426,   801, -4053, -4053, -4053,  -551,  -611,  -602, -4053,
   -3620,    17,    19, -4053, -4053, -4053, -4053, -1196, -4053,   819,
   -2931, -1133, -4053, -4053,   856, -4053, -4053, -4053,  -515,  -184,
    2057, -4053,  -440, -4053, -4053, -4053,  -183, -4053, -4053, -4053,
   -4053, -4053, -4053, -1868,  2933, -1100, -4053, -4053, -4053, -4053,
   -2196, -4053,  3697,   -29,  1382, -1717, -4053,  -200,  -107,  2522,
   -1330, -2553,   254,  -313, -4053, -1918, -4053, -4053, -4053, -2470,
   -4053, -4053, -4053, -4053, -3247, -1716, -4053, -4053, -4053,   325,
   -4053, -3858, -3598, -3799, -3225, -4053, -4053, -1263, -4053, -4053,
   -4053, -1565,  1587, -1645, -4053, -2218,   326, -3444,  -995, -3015,
   -4053, -3358,  -384, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -1272,  -856, -4053, -4053,  3000, -4053, -3330, -4053, -4053, -4053,
   -4053,  1278, -4053,  -280, -4053, -4053, -4053, -4053, -4053, -4053,
    -502,  -576, -4053, -4053, -4053,   185, -4053, -4053, -4053, -4053,
    1357, -1153,  -959,  2872, -1715,  -216, -4053, -4053, -4053, -4053,
   -2853, -4053, -4053, -4053, -4053, -4053, -4053, -4053, -1198, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053,  1742,  1738,  -120,  -214,
   -4053, -4053, -1449, -4053,  -798, -4053,  1985, -4053, -4053, -4053,
   -4053, -4053,   189,   356,   -76, -4053, -4053,   733, -2384,   -74,
   -4053, -4053, -4053, -4053,  -269,   -71, -4053,  1130, -4053, -4053,
   -2046, -4053,   244,  1254,  2609,  1359,   -72,    -9,  -245,  -251,
    -208, -4053,  2878,  2368, -4053, -4053,  -175,  1533, -4053, -1049,
    -338, -4053,  1121,  -906,  1715,  2351,  2353, -4053,  1118, -4053,
   -4053,  1132, -4053, -4053, -4053,  -898,  1732, -4053,  2367,  1752,
   -4053,  1781,  1195, -2396,  1444, -2383,   826,  -242,    -1,  -127,
    2908,  3064, -4053, -3916,  1170, -3367,   404,  3176, -2055, -1752,
   -4053, -4053, -1339,  9251, -4053, -4053, -4053, 11660, 13455, -4053,
   -4053, 13934, 14645, -4053, -1231,   689, 14774,  3319, -1376, -1748,
   -1507, 14135,  1526, -1195, -1833, -4053, -4053, -4053,  -218,   701,
     -96, -4053, -4053, -4053,  -406, -2658,  -405, -4053, -4053, -4053,
    -409, -4052,  1686, -4053,  -821, -4053, 15746,  1168, -4053,   -43,
   -2529, -2626, -1365, -1884, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -1516, -3052,  -771,  1247, -4053, -4053,  1337, -4053, -4053,
   -4053, -1458, -1113, -2001,  1253, -2027, -4053, -1055,  1370,  1873,
   -1024,  2047,  2016, 13457,  -125, -2281, -1500, -1421, -4053,  -801,
   -4053,    59,  2780,  -158,   287,   194,   -61, -2891, -4053, -4053,
     300, -4053, -4053, -4053,  3336,   864, -4053,  2720, -4053,  1475,
    2113, -4053, -4053,  1750,  -936,    70, -4053,  -378, -4053,  -141,
   -4053, -4053, -4053,   143, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053, -4053, -4053,  2404, -4053, -4053, -1433, -4053, -4053, -4053,
   -4053, -4053,  3619,  -308, -4053,  3056,  -292, -4053, -4053, -4053,
   -4053, -4053, -4053, -4053, -4053, -4053,  2409,  1784, -4053,  2883,
   -4053, -4053, -4053,   -44,  2615, -4053, -4053, -4053, -1167,  -582,
    2880,  2884,  1745, -4053, -4053, -4053, -4053, -4053, -4053, -4053,
   -4053,  1757, -4053, -4053,  1227, -2034,  1758, -4053, -4053,   631,
   -4053, -4053,   256, -4053,   639, -4053,  2505, -4053, -4053, -4053,
     664, -4053, -4053, -4053,  -595, 10766,    43,    99,   166,   210,
   -4053,  5894,  8526,   -81,  2425,   -24,  8488, 13407,   298, -4053,
    3607,  1760,  1443,  -996, -4053,   146,  2054,   507, -4053, -1108,
      23,    -2, -4053,  2640,  -648, -1150,  2715,  -726, -1859, -4053,
    4022, -4053, -3033, -4053, -1000,  3065, -1194
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -2403
static const yytype_int16 yytable[] =
{
      80,  1065,   343,  1505,   344,  1171,   348,   346,  1236,   968,
    1015,  1628,   893,  1073,  1988,  1138,  1890,   356,  1882,  1362,
    1363,  1154,  1577,   356,  1367,    79,  1575,   881,  1961,  1643,
     968,  2338,  1930,  2311,  1706,   877,   799,  2515,  1758,  1896,
    2279,  2549,  1526,  1171,  1747,   942,  2435,  2585,  1647,  1846,
    1911,  1268,  1222,  1048,   395,  1118,   356,  2553,  1080,  1288,
     395,    74,  1999,   990,   976,  2926,  2443,  3194,  2320,   349,
    2045,  2382,  2383,  3401,  1081,  1518,  2154,  2376,  2018,  2019,
    2766,   799,  2217,  2219,  2220,  2485,  1821,   683,   840,  1781,
    3584,  1825,  2885,  2887,  1171,  2462,  1045,  2034,  1831,  3311,
    2463,   356,  1075,  1016,  1273,  1053,  3437,  1848,  3439,  2175,
    1596,  1281,  3116,  2309,  2782,  2464,  2465,  2466,  2467,   929,
    2627,   394,  1122,  1626,  3178,  1067,  3752,   394,  3541,  3308,
    3130,  3132,  1036,  3766,  3496,  3138,  2371,  3940,   965,   852,
    1873,  2319,  1323,  2545,  2792,  1076,  2260,  4040,  1945,   799,
     886,  2211,  2211,  1920,  2815,  3943,   349,   904,  1676,   965,
     394,  1915,  3913,  3366,   692,  2787,  1569,  1698,  3496,   356,
    3900,  3056,  2113,  1654,  1572,  4048,  2012,  2013,  1604,  1605,
    1512,  1113,  2068,  1845,   982,  2154,  3513,  3514,  3515,  3516,
    3517,  3518,  3677,  2831,  1874,  3316,  1874,  2835,  3317,  3318,
     416,  2031,   692,  2994,  3225,   394,  1312,  2071,  1748,  3319,
    3320,  3321,  3225,  3322,  3323,  1135,   796,   850,  3324,  3325,
    3326,  2483,   885,   892,  3306,  3307,   967,   399,  3922,  -342,
    3015,  3575,  2062,   892,  1617,   681,  2322,  1064,  4286,  1874,
    1262,  3956,   261,  3958,  1350,  1874,   685,   967,  4214,  4215,
    3145,  2702,  3147, -2401, -2401, -2401, -2401,  1618,   130,   131,
   -2401,   796,  2601,   321, -1577,  4134,  1775,   342, -2401,  2582,
    2490, -1577,   355,   394,   892,  3183,  1070,   416,   355,  -127,
    2155,   897,   343,   797,   344,  3017,   348,   346,  -127,  4282,
    1378,    45,   416,  -127,  2718,    37,    38,    39,    40,  3565,
     841,    43,    44,  1397,  1619,   356,    45,  2578,  2702,  3818,
    3203,   355,  4403,   969, -1333, -1333, -1333, -1333,  2697,  1358,
    1922, -1333,   347,  2098,    37,    38,    39,    40,   797,   796,
    3802,    44,   416,  1393,   969,  2218,  2740,  2459,  2407,  1932,
     356,    43,   395,  1565,  1074,   813,    45,  1020,  3031,   349,
    1769, -1376, -1376, -1376, -1376,  3361,   355,  4445, -1376,   402,
    2621,  3327,  1188,  4099,  2736,  1758,  1980, -1683, -1683, -1683,
   -1683,  2737,   934,  2194, -1683,  2104,  1498,   395,   357,  2602,
    3028,  1540,   814,  1541,  4388,  1171,    37,    38,    39,    40,
    3784,  4100,   416,    44,  2751,  1762,   797,  2285, -2402, -2402,
   -2402, -2402,  1765,  1007,   794, -2402,    45,  3192,  1567,   394,
    1007,  2460,  1007, -2402,   809,   803,   810,  1123,  4051,  2719,
    1055,  4481,     3,  2720,   355,  2045, -1366, -1366, -1366, -1366,
    1098,  3803, -1593, -1366,  2496, -1376, -1376, -1376, -1376, -1593,
    1050,  1021, -1376,  1875,   394,  1875,  1586,  3728,  2491,   794,
    2018,  2019,  1856,  1189,  1908,  2741,  1656,  2034,  2721,  3819,
     803, -2399, -2399, -2399, -2399,  1359,  3184,  1350, -2399, -2129,
    3866,  2579,  1109,  4404,  2337,   686, -2399, -1361, -1361, -1361,
   -1361,  4274,  1389,  2101, -1361, -1366,  3793,  3328,  1875,  4245,
    3018,  2583,  1509,  3840,  1875,  1350,  1006,  2417,  4401,  2995,
    2580,  2156,  2413,  1006,  1137,  1006,  3225,  1011, -1366, -1366,
   -1366, -1366,  4376,   881,  1011, -1366,  1011,   794,  2484,  4467,
    1081,  3760,   261,  2146,  2147,  2377,  3496,  2131,   803,   898,
    3785,  2143,  2143,  1934,  1607,  1610, -1361,  3329, -1829,  3576,
    4114,  1639,  1680,   321,  1107,  1116,  1117,   342, -2398, -2398,
   -2398, -2398,  2603,  2435,   813, -2398,  2012,  2013,  2703,  1657,
     355,  2329,  2099, -2398,  2031,  1379, -1994, -1994, -1994, -1994,
    2604, -1577,  1910, -1994,  1884,  2630,  3383,  1828,  2367,  2722,
    2369, -1994,  4153,  1914,  1613,  2433, -1346, -1346, -1346, -1346,
    4166,   814,  2091, -1346,  4138,   355,   682,  3181,  4318,   246,
    2063,   696,   347,   696,  2406,  3611,  3980,   899,  1976,   900,
    4311,  1366,  1114,   696,  3237,  3286,  1542,  2521,  2114,  3234,
    3235,  3236,  3237,  3637,  1981,  2574,  2527,  3786,  3330,  2410,
    3787,  1981,  1884,  3031,  2535,  2536,   886,  2872,  2429,   696,
   -1373, -1373, -1373, -1373,  1158,  1681,  2154, -1373,  4389,   696,
    2765,  3733,  2548,  2490,  1124, -2129,  1115,  3875,   357,   696,
     696,  1776,  1777,   696,  2126,  2884,  3398,  2233,  3399,  2203,
     696,  2738,  2784,  2290,   970,  2515,  1651,  2204,  2068,  2295,
   -2401,  1351,  2300,  1587,  4209,  1366,  3227,  1520,  3741,  3185,
     811,  3266,  4217,  1149,  1056,   970,  1065,  4381,   962,   963,
    -127,  -127,  1658,  2071,  1736,  1178,  2099,  2800,   885, -2129,
    3535,   696,  4300,  1620,  1621, -1170,  2444,  3422,  2337,  4287,
    2357,  3463,  3464,  2360,  2361,  3598,  3341,  1126,  1331,  3602,
    4255,  2354,  1226,  2285,  3335,  4256,  4334,  1576,  1122, -1593,
    2281,  2017,  2868, -1829,  2564,  1737,  2040,   356,  3225,  1264,
    2567,   356,   703,   962,  1595,  2557,   892,   892,  4420,  3346,
    1659,  2843,  4257,  1915,  2041,    37,    38,    39,    40,  1053,
    2282,  4243,    44,  1109,  2892,  1755,  2414,  2817,  2042,  2817,
      37,    38,    39,    40,  1278,  4129,  2439,    44,   395, -1170,
     847,  1365,  1531,  1332, -1683,  1338,  1532,  1343,  2653,  2654,
   -1829,  3458,  3856,  1347,  3461,  3462,  1217,  3494,  3465,  1087,
    4264,  2007,   992,   962,   963, -1829,  2920,  1682,  3472,   215,
    3423,  1326,  1606,  1321,  1253, -2402,  1838,  1338,  1343,  1088,
    2040,  4122,  2330,  4475,  4103,  4104,  4105,  4106,  4107,  1089,
    4357,  3494,  2662,   845,  2331,  1609,  1219,  2350,  2041,   223,
    1095,   394,  2311, -1366,  4337,   394,  3536,  1369,    37,    38,
      39,    40,  2044,  1188,  1366,    44,  2286,  1839,    35,   416,
    1068,  4335,    37,    38,    39,    40,    41,    42,    43,    44,
    3186,  3896,  1171,    45,   234,  3582,  1350,   993, -2399,  3349,
    4301,  2870,  1521,  2007,  4265,  2332,   237,  1738,  2493,  1270,
     904,  2780,  2371,  2283, -1361,  1096,  1070,   796,  2440,   696,
    4333,  3232,  3233,  3234,  3235,  3236,  3237,  4130,  2515,  1756,
    2556,  1369,  3586,  2273,  1336,  3584,  1341,  1069, -2403,  1977,
      80,   349,  1064,  3858, -1170, -1366,  1545,  1090,  2274,  2287,
    4266,  4426,  2477, -1680,  1508,  2589,  2590,  4267,  1516,  1522,
    4352,  3187,  4322,  4457,  1189,    79,  1371,  1373,  1109,  4309,
     892,  3750,   416,  3424,  1389,    37,    38,    39,    40,  4338,
    2214,    43,    44,   209,   797, -2398,    45,  4268,  2128,  2974,
    1254,  1739,  1502,  2223,  3402,  2975,  2224,  1377,   356,  4314,
    4315,    74,  3425, -1994,   896,  2275,  3587,  1070,  1746,  4402,
    1098,  1091,   355,  2921,  1399,  1317,   355,  3225,  1351,   892,
     967,  2276,   967,  2023,   967,  1394,  2478,  3897,  3188,  1840,
     967,  1348,  1349,  1499,  3338,  1536, -1170,  1511,  1270,  1513,
    4339,  1351,    35,  2534,  2215,  1255,    37,    38,    39,    40,
      41,    42, -1333,    44,   967,   967,  4269,  4119,  1161,  1162,
    1163,  2296,  1164,  1165,  1166,  1167,  1168,  1169,   994,   995,
   -1170,  1724,  1793, -1170,  3519,  3761,  1092, -1373,  1171,  2516,
    1725,  2520,  1119,  4143,  4021,  3313,  4435,  3314,  2225,  3520,
    2526,  4144,  2976,  2129,  4025,  2088,  2089,  2090,  2091,  2216,
    1701,  4458,   394,  2441,  1109,   794,   692,   969,  1757,   969,
    2362,   969,  3741,  1841,  1559,  3035,   803,   969,  1071,  3521,
     956,  3522,   683,   683,  4024,  1531, -1333,  1630,  2182,  1532,
    4427,  2120,  2282,  1599,   956,  3852,   804,  2560,  3588,  4221,
     957,   969,   969,  2297,  4139,  2874,   805,  2638,  4447,  1628,
    1514,  2277,  1629,  1070,   957,   696,  4140,  2796,  2774, -1781,
     983,  4418,  3797,  3232,  3233,  3234,  3235,  3236,  3237,   967,
    3403,  2124,   416, -1812,  1154,    37,    38,    39,    40,  3496,
    3853,    43,    44,  1397,  1619,  3975,    45,  2616,  1622,  2656,
    1599,  2121,  3523,   991,  1098,  3404,  3589,  3227,  2322,  2981,
    4428,  1726,  2065,   696,   696,  2479,  2327,  2418,  1560,  3494,
    3519,  2639,  2067,  3949,  2183,  2068,  2480,  2102,  3953,  4270,
     696,  3955,  3946,  4429,  1171,  1858,   967,  2875,  1065,  1779,
    3393,  2363,  1007,  2364,  4230,  2977,  1007,  2797,   956,  3762,
    2071,  4145,  1496,  2278,   806,  2072,  1094,  2820,  2311,  2979,
    1898,  4218,  3524,   355,   979,  3521,   969,  3525,   957,  3228,
    1884,  1626,  3633,  3798,  2978,  3782,  2640,  2419,  3763,  2641,
     681,   681,  3148,  3143,  3831,  1627,  4448, -1830,  2980,  3142,
    3834,  3835,  3836,  3837,  3838,  3839,  1919,  3066,  3067,  3068,
    3069,  1899,  3526,  3150,  3151,  2771,  1058,  3153,  2515,  1497,
     962,  1595,  2515,  3157,  3527,  1248,  1979,  3749,  1842,  4141,
    1095,  1043,  1270,   969,  4247,  2849,    80,    80, -1173,    80,
    2176,  2177,  3960,  2181,  3314,  1006,  3649,  1843,  3397,  1006,
    1865,  4231,   349,  2462,  1249,  2248,  1011,  1270,  2463,  2765,
    1011,    79,    79,  2169,    79, -1781,  3964,  3799,  3965,  3347,
    1122,  1081,  3584,  2464,  2465,  2466,  2467,  2951,  3856, -1812,
     698,  2642,  1599,  1076,  1076,  1096,  1076,  1884,  1097,   349,
     704,  4196,  4197,   807,  2074,  1250,  3196,    74,    74,  2954,
      74,   848,  1866,  1985,  3528,  2850,  2215,  2957,  4112,  2959,
    2420,  1005, -1173,  3525,  4027,  2075,  2076,  3139,   967, -1781,
    1042,  2951,  2005,  3625,  1261,   696,   844,   696,  4345,  4312,
    1828,  3894,   157, -1812,  3135,  2105,  2273,  4317,  2328,  1951,
     895,  2021,  3232,  3233,  3234,  3235,  3236,  3237,  3526,  3857,
    2060,  2421,  1565,  4174, -1333,  1531,  1566,  2439,  3566,  1532,
    3527,  2216,  1952,  1900,  2079, -1333,  4093,  2017, -1333,  1646,
   -1333,  2048,   696,  4350,  2643,   696,   696,  2080,  1317,  2378,
    1098,  2153,   813, -1830,  2058,   416,  2118,  2119,   682,  1867,
     970,  3895,   970,  2061,  2662,  2662,   861,   416,   682,  2662,
     956,   356,   696,  2066,  1565,   969,   176,   956,  2275,  3858,
    1710,  1066,  1017,  2103,  4205,   815,  4207,  1567,  2857,   814,
     957,  1095,   970,   970,  2276,  1865,  4094,   957,    37,    38,
      39,    40,  3661,   849,  3662,    44,  1868, -1830,  2662,  2662,
    3528,  3982,  1270,  3983,  2185,  2133, -1860,  1901,   931,  1270,
    1270,   863,   356,   356,   356,  2217,  1098, -1173,  1711,  3387,
    1568,   696,   193,   696,    37,    38,    39,    40,  -795,  1567,
    1599,    44,  4307,  1099,  1599,  1599,  1096,  2559,  2325,  2440,
    3035,  3772,  1074,  1074,  2186,  1074,  2135,  2230,  4163,  3417,
     395,   395,  1100,   813,  1077,  2153,  2904,  2362,  2267,  1018,
     692,   692,   356,  2422,  3418,   394,   967,  2068,  2268,   356,
     967,   967,  1568,  1620,  1621,   356,  2186,  1084,  1869,    37,
      38,    39,    40,  2269,  2829,  2068,    44,  3171,  2136,  2326,
     814,   683,  2071,  2187,  1712,  2068,  3388,   682,   215,   395,
    2086,  2087,  2088,  2089,  2090,  2091,  2252,  2905,  2226, -1173,
    2071,   682,   682,  3663,  2277,  1616,   394,   394,   394,   215,
    2071,   796, -2193,  3664,  1867,  2187,  4078,  4079,   223,   157,
    2906,  1098,  3984,  2244,  2246,  3408,  2334,  3410,  4135,  1713,
    3109,  1714,  2222, -1173,  1349,  1644, -1173,  2423,     8,   223,
     870,  2370,   871,   969,   682,  3123,   232,   969,   969,  2368,
     157,   692,  2236,   234,  2868,  2593,   394,  2154,  3636,  2243,
    2245,  1868,   796,   394,  1645,   237,  1599,  4136,  2363,   394,
    2364,  2907,  1599,  3124,   234,  1716,  1119,  3156,   797,  4229,
    1724,   416, -1860,  4372,  1125,  3658,  2339,  2516,  3604,  2869,
    4028,  1884,  1136,   176,  3637,    45,  2278,  3126,   246,  1708,
    2379,  2402,   967,  2765,  2375,  2270,   355,  4373,   967,  3678,
    1718,  2403,  1065,  1599,  2441,  1884,  1599,  1599,  3546,   246,
    3783,  3788,  2374,  4479,   176,   796,  4480,  2455,  1709,   681,
   -1182,  2340,  2341,  2442,  2523,  2404, -1860,  2339,  1648,  2400,
    3873, -1182,  1905,  1869,  1720, -1182,  2515,   356,   122,   967,
    1617,  2515,   967,   967,  2515,  2075,  2076,   355,   355,   355,
    3357,  3396,  1906,  2143,  2337, -2403,   126,  1649,  2401,  1599,
   -1214,   209,  1248,  1618, -1214,  2040,  3310,  1704,  2618,  4436,
     193,  1150,  2340,  2341,  3829,    43,  1326, -1182,  2765,   969,
      45,  3336,   797,  2041,  2457,   969,  1650,  3128,  3820,   794,
    3420,  3544,  4417,  2870,  2079,   967, -1182,   355,  1157,   861,
     803,  2486,  2468,  3005,   355,  2337,   682,  1152,  3821,  4253,
     355,   696,  3494,   696,  1007,   215,   696,  1180,   696,  3421,
    2781,   696,   696,   696,  2606, -1214,   969,  1955,  1186,   969,
     969,  2509,  1250,  3646,   696,  1007,  1081,  3292,  1187, -1182,
     794,   394,  3679,  3680,  3071,   223,   215, -1182,   696,  3072,
     696,  4234,   856,  3613,   863,   696,  1651,  3616,  3400,  3618,
    2617,  3620,  3621,  2017,  1221,  2261,  1741,  4035, -1214,  2255,
    3626,  2339,  1171,   232,  3509,  3251,   223,  3253,  3254,  3072,
     234,    80,   969,  2612,    80,  2613,   349,  2615,  2614,  3709,
    1705,  2502,   237,  3161,  -159,  1742,  1916,   796,  2256,  2311,
    1917,  4283,  3037,   794,   232,  1224,    79,  1006,  3647,    79,
    1007,   234,  3920,  1228,   803,  3998,  2340,  2341,  1011,  -159,
    2516,  1225,  3999,   237,  1743,   246,  2688,  2257,  1006,  2691,
    2624,  2626,   861,    37,    38,    39,    40,  2040,  1064,  1011,
      44,  2634,    74,  2109,  2637,    74,  2110,  3350,  1237,  2337,
     349,  -789,  2649,  2650,  3038,  2041,  4437,  1684, -1182,  2700,
     130,   131,  1243,  1685,   797,  2667,  2669,  1251,  2107,  2042,
    2086,  2087,  2088,  2089,  2090,  2091,  2683,   696,   696,   356,
    2086,  2087,  2088,  2089,  2090,  2091,  1229,   863,  1230,  1651,
    2646,  3031,   355,   870,   682,   871,  2802,  3370,   682,   682,
    1252,  2662,  1686,  1006,  2662,  2662,  2662,  2662,  2662,  2662,
    2662,  2662,  2662,  2662,  1011,   937,  1556,  1257,  1545,    37,
      38,    39,    40,  3774,  3775,  1260,    44,  3035,  3039,  3040,
     416,  -362,  1916,  2399,  3062,  2707,  2552,   938,  2851,  1275,
    2854,  3041,  3198,   157,  2635,  2636,  2555,  1279,    37,    38,
      39,    40,  2648,  1687,  1068,    44,  2651,  2652,  1289,   937,
    1688,  2662,  2662,  1689,  1298, -1215,  1732,   356,   939, -1215,
    2339,  2673,  1556,  2674,  1304, -1170,  3542,  1721,   696,  1731,
     682,   938,   932,   394,  1745,   794,  1751,   157,   209,    35,
    2238,  2515,  2695,  3042,  2696,  1733,   803,    41,    42,  1734,
    2772,  1531,  2040, -1683,   395,  1532,  3199,  1232,  2845,  1233,
    3200,  1069,   939,  1746,  1690,  2340,  2341,   176,  1319,   356,
    2041,   356,  1399,  1360,  1735,  3225,   870,  1925,   871,  1926,
   -1215,   901,  1316,   416,  2044,  2794,    45,   873,  1399,   796,
     682,  3225,  3702,  2236,  2029,  2030,   682,   875,  2337,  3847,
    2153,  4240,  3642,  1758,  3879,  2004,   395,   246,   395,  3780,
    1364,   176,  1322,  2167,  2017,  2168,  2261,  2170,  1691,  2171,
     356,   394,  1375, -1215,  3350,  1387,  3043,  1337,  3044,  1342,
    3772,  1070,  2017,  1651,  1646,  1662,  1381,   682,   215,  1356,
     682,   682,    35,   416,  1386,  2554,  2931,  2555,  1388,   683,
      41,    42,  2575,  1692,  2576,  1390,   797,    45,  3350,  1372,
    1374,  1389,  2577,   967,  2576,  1630,  1663,    80,   223,    80,
    1599,  1391,  3579,   394,  1392,   394,  2917,  3729,  3731,  2207,
    2208,  3122,  1693,  1065,   355,  2709,  1694,  2710,  1395,  2609,
    1629,  2610,    79,   682,    79,  1399,   356,  1517,  3225,   215,
    1396,  3850,  3851,   234,  4203,  3854,   967,  3855,  2711,  2808,
    2809,  1695,  3778,  3432,  4149,   237,  1513,  3867,  3868,  3869,
    3870,  3871,  1519,  1664,   394,  1525,  1622,  4102,    74,   223,
      74,   356,  1109,  1523,  3772,  3869,  3870,  3871,  1524,  2793,
    2516,  1884,  1071,   215,  2516,  1530,  2662,  3123,   246,  1539,
     969,  2837,  1546,  2610,  1665,  3227,  1339,   232, -1238, -1238,
    1344,  1345,  1346,  4003,   234,  3063,  1553,  2882,   940,  2883,
    1357,  3227,   355,   223,  1554,  3124,   237,   794,  1556,  3963,
     796,  4327,  2928,  4329,  2929,  1563,  3966,  3967,   803,  1154,
    3125,  1557,  3023,   969,  3024,  1584,  2017,   681,  2261,  3126,
     394,   232,  1599,  3057,  1578,  3058,  2712,  3941,   234,   941,
    1599,  2713,  1599,  1627,  2504,  2505,  2714,  3228,  1585,  3163,
     237,  2576,  3127,  3179,   355,  3180,   355,  1580,  3197,  1399,
    2555,  1588,  3225,  3228,  1589,   394,  3007,  3207,   967,  2555,
    1600,  3210,  3315,  2555,  3007,  1590,   967,   797,   967,  3703,
    1666,  1399,  1591,   246,  3225,  1593,   796,  3226,    37,    38,
      39,    40,   696,  1592,   696,    44,  2207,  2813,   696,    45,
     696,  4005,  3214,   696,  2555,   355,  1594,   696,  3227,  1667,
    1601,  1065,  2107,   209,  3215,  1603,  2555,  1668,  3091,  3092,
    3065,   796,  1633,  1669,    37,    38,    39,    40,  1641,  3128,
    1670,    44,  1127,  3241,  1632,  2555,  3849,  1662,  1671,  3257,
    1635,  2555,  3095,  1646,  1128,  1129,  1672,  1678,  1270,  3115,
    3260,  3034,  3261,   797,  1673,   969,  1661,  2662,  2662,  3296,
    2715,  3297,  1701,   969,  1130,   969,  3920,  1131,  1663,  2716,
    3228,  4090,  1703,  3772,  3277,  3298,  3278,  3299,  3342,  1740,
    3343,   355,  3352,  3353,  4058,  4059,  3358,  3359,   797,    37,
      38,    39,    40,  1753,  3876,  1270,    44,  3279,   794,  4083,
    3863,  3864,  3415,  1674,  3416,  1744,  3229,  3230,  3231,   803,
    3232,  3233,  3234,  3235,  3236,  3237,   355,  3440,  3552,  3441,
    3553,  3301,  3302, -2403, -2403,  1664,  3232,  3233,  3234,  3235,
    3236,  3237,  3563,  2516,  3564,  3573,  3201,  3574,  1936,  3650,
    1938,  2555,  3227,  1942,  1754,  1944,  3350,  1759,  1947,  1948,
    1949,  1761,  1562,  3258,  1564,  1955,  1665,  3686,  3263,  3687,
    1599,  1956,  2764,  1763,  3227,    37,    38,    39,    40,  1766,
    4178,  2238,    44,   356,   794,  1983,  1771,  1984,   356,  1132,
   -1337, -1337, -1337, -1337,  3252,   803,  3693, -1337,  3694,  1773,
    4149,  1109,    81,  1780,  3972,  3881,   967,  3705,  1783,  2555,
    3280,  3776,  1651,  2576,  3228,  3281,  3843,  1822,  3844,   794,
    1643,  1993,  1994,  3275,  3867,  3868,  3869,  3870,  3871,  1133,
     803,  1684,  3872,  4004,  1824,  2610,  3228,  1685,  1828,  3229,
    3230,  3231,  1832,  3232,  3233,  3234,  3235,  3236,  3237,  -176,
    4042,   682,  4043,  4033,  4049,  1834,  2576,  2058,  2060,  1836,
    4050,  4080,  2576,  4131,  1847,  4132,  4168,  1854,  4169,  4170,
    4160,  2707,  1884,  4165,  1935,  3553,  1686,  1937,   396,  4173,
    1941,  3883,  1943,  1870,   396,  1946,  4167,   394,  3553,  1950,
    3295,   827,   394,   969,   682,   209,  4434,  2299,   682,  1668,
    1862,  4180,  2509,  4181,  2826,  1669,  1616,  1872,  4182,   696,
    2555,  4188,  1670,  2610,  1877,  1878,  4239,   396,  1879,  4237,
    1746,  4238,  1881, -1344, -1344, -1344, -1344,  1687,  1672,  3282,
   -1344,  1270,  1880,  4251,  1688,  4252,  1673,  1689,  3283,  4284,
    4291,  4285,  1884,   796,  1883,  4293,  2662,  3553,   796,  4297,
    1884,  2610,   887,  4351,  1889,  2123,  1599,  4355,  2516,  4356,
    1892,  1893,   396,  2516,  1894,  4364,  2516,  1884,  1895,  1897,
    2662,  2662,  4296,  3229,  3230,  3231,  1902,  3232,  3233,  3234,
    3235,  3236,  3237,  1903,  4365,  1674,  2610,  2236,  1690,  3477,
    3337,  4366,   967,  3261,  1904,  3229,  3230,  3231,  1909,  3232,
    3233,  3234,  3235,  3236,  3237,  4367,  1923,  2555,  3122,  1012,
     797,  4382,  4384,  2610,  2610,   797,  1012,  4320,  1012,  1957,
    1989,  4325,  4326,  4385,  1991,  2610,   682,  1995,  1997,   669,
     396,  1156,  3478,  4477,   682,  4478,   682,  1176,   355,  4488,
    1998,  4478,  1691,   355,  3603,  1185,  3606, -1335, -1335, -1335,
   -1335,  2003,  2011,  1193, -1335,  4034,  3479,  2014,  1220,   356,
     356,   356,  2015,  2016,  1399,   246,  2020,  3225,  2022, -1338,
   -1338, -1338, -1338,  2025,  3123,  3480, -1338,  1692,  4294,   969,
   -1336, -1336, -1336, -1336,  4006,  2026,  2123, -1336,  2027,  1283,
    1171,  2028,  3481,  1291,  2033,  2035,  2036,  3556,  2037,  3476,
    2038,  4083,  3124,  1303,  3433,  4115,  1729,  3482,  2039,  2046,
    1694,  4310,  4324,  2047,  2049,  2050,  2051,  3125,  2052,   356,
    4321,  2053,  2054,  2055,  3443,  2096,  3126,  2127,  2138,  1350,
    2148,   794,  2158,  3594,  2174,  1730,   794,  2455,  1566,  1568,
    1399,  2662,   803,  3225,  2201,  2206,   881,   803,  2213,  3127,
    1098,  2221,  2227,  2229,  2231,  3007,  2239,   356,  3007,  3007,
    2240,  2242,  3007,   394,   394,   394,   396,  3557,  2247,  2249,
   -2345,  2251,  3007,  2258,  3950,  2259,  2262,  1779,  2261,  2263,
    2289,  2291,  3570,  3497,  2284,  2292,  1368,  2293,  3483,  3506,
    2294,  2315,  2322,  2324,  2334,  2335,  3484,  2336,  2337,  2343,
    2344,   396,  3593,  1384,  2351,  2316,  2352,  2349,  1599,  1065,
    2345,  2355,  2356,  2346,  2358,  2365,  2366,  3497,  2391,   796,
     796,   796,  2372,   394,  2373,  1724,  3128,  2380,  3485,  2381,
     349,  3551,  2412,  2424,  1506,  2389,  2390,  2396,   696,  1955,
    2398,  2427,  1599,  2426,   967,   349,  2436,  3227,  2007,  3501,
    3504,  1529,  2434,  2017,   682,  2437,  2446,   858,  1726,  3578,
    1270,   394,  2452,  2472,  2023,   349,  2489,  3640,  2494,  2497,
    2456,  3538,  2509,  4273,  1558,  2499,  2509,  2500,   967,   796,
    2501,  3719,  3720,  3721,  3722,  2507,   797,   797,   797,  2518,
    2530,  1684,  2531,  2532,  2533,  2546,  2547,  1685,  3951,  2571,
    2587,  2595,  2592,  2572,  2599,  2607,  2620,  2671,   892,  3228,
    4306,  2629,  2630,  2516,   355,   355,   355,   796,  2672,  2068,
    4454,  4451,  2684,  3227,  2689,  2693,  2701,  2694,  2706,  2723,
     349,   969,  2725,  2751,  2767,  2770,  1686,  2773,  3688,  2768,
    2775,  2778,  2779,  2786,   892,  2803,   797,  2804,  4212,  2562,
    1069,  2563,  2822,  2113,  2840,  2565,  2795,  2566,   356,  2847,
    2568,  2807,  2838,  2819,  2569,   969,  2839,  2852,  4224,  2857,
    2821,  2836,  3685,  2863,   355,  2855,  2859,  2860,  2861,  2866,
    2873,  2878,  2880,  1171,   797,  3228,  1684,  1687,  2923,  2919,
    2927,  2930,  1685,  2988,  1688,  2982,  2996,  1689,  2983,  3350,
    2984,  2992,  2516,  1171,  2997,  2998,  3002,   794,   794,   794,
    2993,  3000,   355,  3001,  3003,  3016,  3020,  3004,   803,   803,
     803,  3014,  4223,  3027,  3025,  3030,  3031,  3032,  3700,  3055,
    3033,  1686,  3811,  3315,  3059,  2238,  3064,  3070,   887,  3073,
     682,  3077,  3094,  3078,  3096,  2058,  3108,  3111,  1690,  3112,
    3113,  3114,  3121,  3140,  3134,  1849,  1851,  1852,  1154,  3141,
    3149,  3152,   394,  3154,  3155,  1891,  3165,   794,  3229,  3230,
    3231,  3739,  3232,  3233,  3234,  3235,  3236,  3237,   803,  3168,
    3166,  3167,  1687,  3159,  3177,  4464,  2621,  3170,  3189,  1688,
    3193,  1366,  1689,  3195,  3208,  2917,  3209,  3794,  3212,  3211,
    3247,  3276,  1691,  3213,  3216,   794,  2516,  2555,  3304,  3217,
    3310,  3219,  3222,  3240,  3246,   356,   803,   356,   796,  3271,
    3248,  3249,  4380,  3256,  3269,  3312,  3291,  -833,  3365,  3284,
    4464,  3374,  3377,  3379,  3270,  3294,  3380,  1692,  4464,  3309,
     356,  1974,  3364,  1690,  3229,  3230,  3231,  3363,  3232,  3233,
    3234,  3235,  3236,  3237,  3368,  1916,  3390,  1990,  3389,  3369,
    3384,  3385,  3394,  3395,  3407,  3386,  1749,  3409,  3431,  2000,
    1694,  1506,  3430,  3434,  3436,  3497,  2067,  3460,  3444,  2068,
    3755,  3466,  3445,  3448,  3446,   797,  3447,  3449,  3450,  3812,
    3467,  3468,  3813,  3451,  3814,  1750,  2069,  1691,  3452,  1506,
    1599,  3453,  3454,  3469,  2071,  3470,  3471,  3499,   396,  2072,
    2224,  3500,   396,   355,  3508,  3510,  1146,  4379,  3007,   394,
    3511,   394,  1146,  3539,  3007,  3007,  3007,  3007,  3007,  3007,
    3532,  3543,  1692,  3545,  1270,  3562,   967,  3558,  3567,  3591,
    3561,  3597,  3568,  3595,   394,  3571,  3599,  3607,  3612,   967,
    3101,  3600,  1171,  1146,  3610,  3617,  3628,  3619,  3639,  1599,
    3629,  3506,  3630,  3631,  3643,  1694,  3644,  3653,  1662,  3634,
    3878,  3880,  3882,  3884,  2226,   796,  2004,   796,  3243,  3225,
    3242,  3682,  3683,  3684,  3695,  2062,  3708,  3707,  3716,  3732,
    1695,  3742,   682,  3745,  1265,   967,  3726,  3743,  3765,  1663,
     796,  3751,  3754,  3744,  3748,  1146,   794,  3756,  4398,  1348,
    1349,  3779,  1146,  3781,  3795,  2516,  3593,   803,  3862,  3789,
    3796,  3817,  3504,   969,  3808,  4038,   682,  3806,  3807,  3933,
    2173,  3877,    81,  3809,  2073,  2149,   969,  3832,  2074,  3810,
    3830,  4423,   797,  3833,   797,   696,  3865,  3905,  3891,  3898,
    2509,  3901,  3583,  3907,  3908,  2509,  1664,  2576,  2509,  2075,
    2076,  3910,  4036,  1155,  3924,  3911,  3928,   797,  1174,  3915,
     355,  3929,   355,  2077,  3931,  3938,  3942,  1184,  3944,   349,
    3954,   696,   969,  3962,  3973,  3968,  3939,  1665,  4055,  3947,
    3976,  3981,  3990,  3991,  4016,   355,  3978,  4017,  4037,  4039,
    4044,  3957,  1231,  3985,  3989,  2078,  1238,  3996,  2079,  3986,
    3992,  4019,  4052,  4020,  4053,  3102,  1247,  1599,  4060,  4054,
    4076,  2080,  1146,  4077,  2081,  4066,  4069,  4088,  1012,  4081,
    4095,  3857,  1012,  4101,  4098,  4116,  4108,  4120,  4146,  4124,
    4155,  4485,  4126,  4133,  4137,  4172,  4176,  4184,  4147,   396,
    4162,  4177,  4179,   967,  4185,  4194,  4186,  4187,  1146,  4198,
    4200,  4204,  4206,   794,  4216,   794,  4219,  4226,  4232,  4227,
    4233,  4241,  3897,  4248,   803,  4250,   803,  4110,  4260,  4261,
    4259,  4263,  4277,  2663,  4279,  4275,  4276,  4278,   794,  4289,
    4305,  1070,  4313,  4336,  2082,  4340,  4344,  2333,  4346,   803,
    4353,  4349,  4031,  4032,  4354,  4359,  4363,  4369,  4368,  4370,
    1147,  4375,  3101,  1151,    80,  4377,   209,  1910,  4322,  4386,
    1668,  4387,  4390,  3476,  4392,  4396,  1669,  4030,  3734,  1182,
    1662,  4399,  4416,  1670,  4419,  4388,  4421,  4389,  4433,    79,
     969,  1746,  2742,   356,  4425,  4446,  4456,  2388,  4473,  1672,
    4476,  4482,  1227,  1079,  3061,  3339,  2145,  1673,  2397,  4486,
    2922,  1663,  3405,  2236,  3792,  4235,  4082,  1245,  2409,  3473,
    4332,  4262,  3926,  4113,  4272,    74,  3382,  3164,  4422,   967,
    2083,  2084,  2085,  4210,  2086,  2087,  2088,  2089,  2090,  2091,
    3007,  3007,  2776,  4121,  4453,  4393,  1146,  4391,  2777,  4431,
     356,  3101,  3927,  1146,  1270,   967,  1674,  2488,  4086,  4087,
    3104,  3583,  4091,  4092,  2871,  4288,  4063,  4064,  1664,  1662,
    3815,  4067,  4068,  2469,  1819,  3506,  3506,  3506,  3506,  3506,
    3438,  2826,  3036,  3548,  4455,  4487,  4483,  3540,  4097,  4096,
    3487,  4432,  4225,  2451,  4383,   987,  4228,   394,  1975,  1665,
    1663,  3974,  4308,  1146,   669,   669,   349,  3934,  2886,  2528,
    3935,  4358,  1271,  4439,  4484,  4254,   969,  2790,  2537,  4128,
    2789,  2561,  3914,  3641,  3344,  1527,  3348,  3102,  3160,  2812,
    2544,  2172,  2198,  2197,   682,  3360,  3504,  3504,  3504,  3504,
    3504,  1924,   969,  3356,   967,  2811,  4148,   682,  1552,  2806,
    2202,  2539,  2785,   796,   394,  2509,  3303,  1664,    81,    81,
    2543,    81,  3117,  3605,  4164,  3345,  1535,  3912,  3699,  1146,
    1267,  4298,  3689,  4407,  4415,  4408,  3351,  3289,  3204,  3182,
    2558,  3287,  2750,  4192,  1112,  3592,  3110,  2503,  1665,  2581,
    1864,  2823,  2586,   682,  2588,  4406,  1082,  2591,  2205,  2212,
    1315,  2814,  2830,  1986,  3334,  3758,  2827,  1611,  2828,  4026,
     796,  1612,  2112,  2933,  3759,  3747,  3102,  1105,  2209,  2573,
     797,  2834,  2934,  2935,  2936,  3162,  1506,  1506,   209,  1819,
    1640,   969,  3103,  1913,    83,     0,     0,     0,  1669,  1355,
       0,     0,     0,     0,     0,  1670,     0,     0,   355,     0,
       0,     0,     0,  1746,     0,  1146,     0,     0,     0,     0,
    4202,  1672,     0,     0,     0,     0,  2937,     0,  3497,  1673,
       0,     0,     0,     0,     0,     0,     0,   797,     0,  2067,
       0,     0,  2068,  1146,     0,  3007,     0,     0,     0,  4236,
       0,     0,     0,  1599,     0,     0,  4201,     0,     0,  2069,
       0,     0,  1699,  1700,     0,   355,     0,  2071,     0,     0,
    1146,  1146,  2072,  1146,     0,  2938,     0,   209,  1674,     0,
       0,  1668,  3104,     0,     0,     0,  2095,  1669,     0,   967,
    1146,     0,     0,     0,  1670,     0,     0,     0,     0,     0,
       0,   794,  1746,     0,     0,     0,     0,     0,  4299,     0,
    1672,   682,   803,     0,  2939,  2749,     0,     0,  1673,     0,
       0,  1774,     0,     0,     0,     0,     0,  2134,     0,     0,
    2940,  2941,  2942,  2943,  2944,     0,  2945,  1826,  1827,     0,
    2769,  1146,   396,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1853,  3223,  3224,     0,   794,     0,
    3239,   356,  4472,     0,     0,     0,     0,  1674,  2946,   803,
       0,  3104,     0,  1146,     0,     0,   969,  1146,  1146,     0,
       0,     0,     0,     0,  2788,     0,  2791,     0,  1886,  1888,
       0,     0,     0,   396,   396,   396,     0,  2073,     0,  3272,
    3273,  2074,     0,     0,     0,     0,  1270,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2238,  2075,  2076,     0,     0,     0,     0,     0,     0,
       0,     0,  4371,     0,     0,     0,  2077,   682,     0,     0,
       0,  2947,     0,   396,     0,     0,     0,     0,     0,     0,
     396,  1819,     0,     0,     0,     0,   396,     0,     0,     0,
    1012,     0,     0,   682,     0,   394,     0,  2948,  2078,     0,
       0,  2079,     0,     0,  2949,     0,     0,  2950,     0,     0,
       0,  1012,     0,     0,  2080,     0,     0,  2081,  1819,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4441,
       0,  4442,  2891,  4444,  4443,     0,     0,     0,     0,     0,
       0,  1819,     0,     0,     0,  2663,  2663,     0,  4360,     0,
    2663,   796,     0,     0,     0,     0,     0,     0,     0,     0,
      35,  4441,     0,  4442,     0,  4444,  4443,     0,    41,    42,
       0,     0,     0,     0,  2067,     0,     0,  2068,     0,     0,
       0,  2912,   682,   669,     0,     0,  1012,  2082,     0,  2663,
    2663,     0,     0,     0,  2069,     0,   349,  2070,     0,     0,
    1803,     0,  2071,  1819,  4441,     0,  4442,  2072,  4444,  4443,
       0,     0,     0,     0,     0,     0,     0,     0,   797,     0,
    2432,     0,     0,     0,     0,     0,     0,     0,  4471,     0,
       0,  4466,     0,     0,     0,  4361,     0,     0,  1819,     0,
       0,     0,     0,     0,     0,     0,   355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4465,     0,     0,     0,
       0,     0,     0,  1819,     0,     0,     0,     0,   396,     0,
       0,   349,     0,  2083,  2084,  2085,  4466,  2086,  2087,  2088,
    2089,  2090,  2091,     0,  4466,     0,     0,     0,     0,  3218,
       0,     0,  4462,     0,     0,     0,     0,     0,     0,     0,
       0,  4465,     0,  3060,     0,     0,     0,     0,     0,  4465,
    1146,     0,  1146,     0,     0,     0,     0,     0,  1819,     0,
       0,  1146,     0,     0,  2395,     0,     0,     0,     0,     0,
       0,     0,  2073,     0,     0,     0,  2074,  4462,     0,   794,
       0,     0,     0,  1814,     0,  4462,     0,     0,     0,     0,
     803,     0,     0,    81,     0,  1987,    81,  2075,  2076,     0,
       0,     0,     0,     0,     0,     0,     0,   682,     0,     0,
       0,  2077,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3169,
       0,     0,     0,  2078,     0,  1146,  2079,     0,     0,     0,
       0,     0,  2458,     0,     0,     0,     0,     0,     0,  2080,
       0,     0,  2081,     0,     0,     0,     0,  2395,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1146,  1146,     0,     0,     0,     0,     0,
       0,  1146,     0,     0,  1146,     0,     0,  1146,     0,     0,
       0,     0,  2647,     0,     0,  1146,  1146,     0,     0,  2384,
    2385,  2386,  2387,  1146,     0,     0,  1146,  1146,  1146,  1146,
       0,     0,     0,     0,     0,  2395,  1146,  1146,     0,  1146,
       0,  1146,  2082,     0,  1146,     0,     0,     0,  1814,     0,
    2415,  2416,     0,     0,     0,     0,  2425,     0,  1819,  1146,
     396,     0,     0,  1146,     0,     0,     0,  1146,     0,     0,
       0,  1146,     0,  1146,  1146,  1146,  1146,  1146,  1146,  1146,
    1146,  1146,   816,  1146,     0,     0,     0,     0,     0,  1146,
       0,     0,  1146,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3660,     0,     0,  3665,  3666,  3667,  3668,  3669,
    3670,  3671,  3672,  3673,  3674,     0,     0,     0,     0,     0,
       0,  2473,  2474,  2475,  2476,     0,     0,     0,  2083,  2084,
    2085,     0,  2086,  2087,  2088,  2089,  2090,  2091,     0,   817,
       0,     0,  3300,     0,     0,     0,   682,     0,   396,     0,
       0,     0,     0,     0,     0,  2067,     0,     0,  2068,   818,
       0,  1146,  3711,  3712,     0,   819,     0,  1987,     0,     0,
       0,     0,     0,     0,     0,  2069,     0,     0,     0,     0,
     820,     0,     0,  2071,     0,     0,  2132,     0,  2072,     0,
       0,     0,     0,  2550,     0,     0,     0,     0,     0,     0,
     396,  1506,   396,     0,     0,     0,     0,     0,   821,     0,
       0,     0,     0,   822,     0,  3375,  3376,     0,  3378,   823,
       0,     0,     0,     0,     0,     0,     0,  2348,     0,     0,
       0,     0,     0,     0,   824,     0,     0,     0,     0,    81,
       0,    81,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   396,     0,     0,     0,     0,     0,     0,   825,     0,
       0,     0,  2663,     0,     0,  2663,  2663,  2663,  2663,  2663,
    2663,  2663,  2663,  2663,  2663,  1146,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2411,
       0,     0,     0,     0,     0,  1819,     0,     0,     0,     0,
    1819,  1819,     0,     0,     0,     0,  1987,     0,     0,     0,
    1814,  1819,     0,  2073,   826,  3435,     0,  2074,     0,     0,
       0,     0,  2663,  2663,     0,     0,     0,   396,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2075,  2076,
       0,   827,     0,     0,     0,     0,     0,  1814,     0,  2448,
       0,     0,  2077,  2067,     0,     0,  2068,     0,     0,     0,
       0,   669,   396,     0,     0,   828,     0,     0,     0,     0,
    1814,   829,     0,  2069,     0,     0,     0,   830,     0,     0,
     831,  2071,     0,     0,  2078,     0,  2072,  2079,  2841,     0,
    2067,     0,  2844,  2068,     0,     0,     0,  3893,     0,     0,
    2080,     0,     0,  2081,  2522,     0,   832,     0,   833,     0,
       0,     0,   834,     0,  2864,  3534,     0,  3537,  2071,     0,
     835,     0,  2876,  2072,  1146,   836,  1819,     0,     0,     0,
       0,     0,  1814,     0,     0,   837,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2890,     0,   838,     0,  1814,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2913,     0,  1814,  3547,     0,
       0,     0,     0,  2082,     0,     0,     0,     0,  3560,     0,
       0,     0,  2932,     0,     0,  2952,     0,  1819,     0,     0,
       0,     0,  1814,  3572,     0,     0,     0,     0,  1146,     0,
       0,     0,     0,  2968,     0,     0,     0,     0,  1146,     0,
    2972,  2073,     0,     0,     0,  2074,     0,     0,     0,  2985,
       0,     0,     0,     0,     0,     0,  2989,     0,     0,     0,
       0,     0,     0,     0,  3632,     0,  2075,  2076,     0,     0,
       0,     0,     0,     0,     0,  1146,  3622,  1814,  2073,  3623,
    2077,     0,  2074,     0,     0,     0,     0,  2663,  3645,  2083,
    2084,  2085,     0,  2086,  2087,  2088,  2089,  2090,  2091,     0,
       0,     0,     0,  2075,  2076,  3264,     0,     0,  4000,  4001,
       0,     0,  2078,     0,     0,  2079,     0,  2077,     0,  1146,
    1506,     0,     0,     0,  2698,     0,     0,     0,  2080,     0,
    1819,  2081,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1146,
    1146,     0,  2079,     0,  2067,     0,     0,  2068,     0,     0,
       0,     0,     0,     0,     0,  2080,     0,     0,     0,     0,
       0,     0,     0,     0,  2069,     0,     0,     0,  2955,  1146,
    1146,     0,  2071,     0,  1146,     0,     0,  2072,     0,     0,
       0,     0,     0,     0,     0,     0,  1146,  1146,  1146,  1146,
       0,  2082,     0,     0,   396,     0,     0,     0,  1146,   396,
       0,  1146,     0,  1146,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1146,  1146,  2999,  1146,     0,  3723,  3724,
       0,     0,  3008,  3009,  3010,  3011,  3012,  3013,  2082,  1146,
       0,  1146,     0,     0,     0,  1146,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1146,     0,     0,     0,     0,     0,  1814,  2663,  2663,
       0,  1146,     0,  1146,  1146,  1146,  2067,     0,     0,  2068,
       0,     0,     0,     0,     0,     0,     0,  2083,  2084,  2085,
       0,  2086,  2087,  2088,  2089,  2090,  2091,  1146,     0,     0,
       0,  2692,     0,  3080,  2071,     0,  1146,     0,     0,  2072,
       0,     0,  2073,     0,     0,  1146,  2074,     0,     0,     0,
    1146,     0,     0,     0,  2083,  2084,  2085,  1146,  2086,  2087,
    2088,  2089,  2090,  2091,     0,     0,     0,  2075,  2076,     0,
       0,     0,     0,  3144,     0,  3146,     0,     0,     0,     0,
       0,  2077,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1146,     0,  2893,     0,     0,
       0,     0,     0,  2078,     0,     0,  2079,  4175,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2080,
       0,     0,  2081,  1819,  1819,     0,  1819,     0,     0,     0,
       0,  4189,  4190,     0,     0,     0,     0,     0,  2067,     0,
       0,  2068,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3902,  3903,     0,  2073,     0,  3874,     0,  2074,     0,
       0,     0,     0,     0,     0,     0,  2071,  1819,     0,  1819,
       0,  2072,     0,     0,  3899,     0,     0,     0,     0,  2075,
    2076,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3906,  2082,  2077,  2067,     0,     0,  2068,     0,     0,
     396,   396,   396,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3029,     0,  2069,     0,     0,     0,  3371,     0,
       0,     0,  2071,     0,  1814,  2078,     0,  2072,  2079,  1814,
    1814,     0,     0,     0,     0,     0,     0,     0,  1819,     0,
    1814,  2080,     0,     0,     0,  3969,  3970,  3971,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3274,
     396,     0,     0,     0,  3488,  1819,     0,  2663,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2083,  2084,
    2085,     0,  2086,  2087,  2088,  2089,  2090,  2091,     0,     0,
    3746,  2663,  2663,     0,     0,     0, -2403,     0,   396,  1819,
    2074,     0,  4295,  3419,     0,     0,     0,     0,     0,     0,
    3429,     0,     0,     0,  2082,     0,  1819,     0,     0,     0,
       0,  2075,  2076,     0,     0,     0,  2067,     0,     0,  2068,
    1819,     0,     0,     0,     0, -2403,     0,     0,     0,     0,
       0,     0,     0,  1819,     0,     0,  2069,     0,     0,     0,
       0,     0,  2073,     0,  2071,  1814,  2074,     0,     0,  2072,
       0,  1146,     0,     0,     0,  1146,  4012,  4013,  4014,  4015,
    2079,     0,  3456,     0,  1146,     0,     0,  2075,  2076,     0,
    1819,     0,     0,  2080,     0,     0,  3190,     0,     0,     0,
       0,  2077,     0,     0,     0,     0,     0,     0,     0,     0,
    2083,  2084,  2085,     0,  2086,  2087,  2088,  2089,  2090,  2091,
    1146,     0,     0,     0,     0,     0,  1814,     0,     0,     0,
       0,     0,     0,  2078,     0,     0,  2079,     0,     0,     0,
       0,     0,     0,  4072,  4073,     0,  4075,     0,     0,  2080,
       0,     0,  2081,  1146,     0,     0,  1819,     0,     0,     0,
       0,     0,  1146,     0,     0,     0, -2403,     0,  1146,     0,
    1146,     0,  2663,     0,     0,  1819,  1146,     0,     0,  1146,
    1146,  1146,  1146,  1146,  1146,  1146,  1146,  1146,  1146,     0,
       0,     0,  1146,  1146,  2073,     0,     0,     0,  2074,     0,
    1819,     0,     0,     0,     0,  1146,     0,     0,     0,   396,
       0,  1146,     0,     0,     0,     0,     0,     0,     0,  2075,
    2076,  1146,  2082,     0,  1146,     0,  1146,     0,     0,     0,
       0,     0,     0,  2077,  1819,  1146,  1146,  1146,     0,  1814,
       0,  1146,     0,     0,  1146,  2395,     0,     0,     0,     0,
       0,     0,     0,     0,  1146,     0,  2086,  2087,  2088,  2089,
    2090,  2091,  1146,  3635,  1146,  2078,     0,     0,  2079,     0,
       0,     0,  2067,  4159,     0,  2068,     0,     0,     0,     0,
       0,  2080,     0,  4159,  2081,  3648,     0,     0,     0,     0,
       0,     0,     0,   677,     0,     0,     0,     0,   695,  4154,
    2071,     0,     0,     0,     0,  2072,     0,     0,  2083,  2084,
    2085,     0,  2086,  2087,  2088,  2089,  2090,  2091,     0,     0,
       0,     0,  3498,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1146,     0,   695,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2082,     0,   695,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   396,  1819,   396,     0,
       0,     0,     0,     0,     0,   978,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   980,
       0,   396,     0,  3285,     0,     0,     0,   988,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   998,  3426,   978,  3428,     0,     0,  1019,     0,
       0,     0,     0,     0,     0,     0,     0,  1047,     0,     0,
   -2403,     0,     0,     0,  2074,  1052,  1047,     0,     0,     0,
    2083,  2084,  2085,     0,  2086,  2087,  2088,  2089,  2090,  2091,
       0,     0,     0,     0,  3698,  2075,  2076,     0,     0,  2067,
       0,     0,  2068,     0,     0,  4244,     0,     0,     0, -2403,
       0,  1146,     0,     0,     0,  1684,     0,     0,     0,     0,
    3777,  1685,     0,     0,  3459,     0,     0,  2071,  4292,  1819,
       0,     0,  2072,     0,  1506,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2079,  1710,     0,     0,     0,     0,
       0,  2067,  1814,  1814,  2068,  1814,     0,  2080,     0,     0,
    1686,     0,     0,     0,  1819,  1146,  1146,     0,     0,     0,
       0,  2069,     0,     0,     0,     0,     0,     0,  3822,  2071,
    3824,     0,     0,     0,  2072,     0,     0,     0,     0,  1146,
       0,     0,     0,  1711,  1146,     0,  1814,  1146,  1814,  4331,
       0,     0,  3554,     0,  2067,     0,     0,  2068,     0,     0,
       0,  1687,     0,  4316,     0,     0,  2893,     0,  1688,  2067,
       0,  1689,  2068,     0,  2069,     0,     0,     0,     0,     0,
   -2403,     0,  2071,     0,     0,     0,     0,  2072,     0,  2069,
       0,  1146,     0,     0,     0,     0,     0,  2071,     0,     0,
       0,     0,  2072,     0,     0,     0,     0,  2073,     0,     0,
       0,  2074,     0,     0,     0,     0,  3614,  1814,     0,  1712,
       0,     0,  1690,     0,     0,     0,     0,  1146,     0,     0,
       0,     0,  2075,  2076,  1146,  1146,     0,  1819,     0,     0,
       0,     0,  1146,  1146,  1814,     0,  2077,  1146,  1819,     0,
       0,     0,     0,  1146,  1146,     0,     0,  1146,     0,  2073,
       0,     0,     0,  2074,  1713,     0,  1714,     0,  1146,     0,
    2086,  2087,  2088,  2089,  2090,  2091,  1715,     0,  1814,     0,
    1146,  2079,  3654,     0,  2075,  2076,     0,     0,     0,     0,
       0,     0,     0,     0,  2080,  1814,    81,     0,  2077,     0,
       0,  3659,     0,     0,     0,     0,     0,     0,  1146,  1814,
    1716,  1692,  2073,     0,     0,     0,  2074,     0,     0,     0,
       0,     0,  1814,     0,     0,     0,  3681,  2073,     0,  1819,
    2078,  2074,     0,  2079,     0,     0,     0,  2075,  2076,  1819,
    1717,     0,     0,     0,  1694,  1718,  2080,     0,     0,  2081,
       0,  2077,  2075,  2076,     0,     0,     0,     0,     0,  1814,
    1987,     0,     0,     0,     0,     0,  2077,  2082,     0,  1719,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1720,
       0,     0,     0,  2078,   396,     0,  2079,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2078,  2080,
       0,  2079,  2081,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2080,     0,     0,  2081,     0,  2082,
       0,     0,     0,     0,     0,  1814,     0,     0,     0,     0,
       0,  1146,   695,     0,     0,     0,     0,     0,     0,     0,
       0,   396,     0,     0,  1814,     0,     0,     0,     0,     0,
       0,     0,     0,     0, -2403, -2403,     0,  2086,  2087,  2088,
    2089,  2090,  2091,     0,     0,     0,     0,     0,     0,  1814,
       0,     0,  2082,     0,     0,  4061,     0,     0,     0,  1819,
       0,     0,     0,     0,     0,     0,  4070,  2082,     0,     0,
    1146,     0,     0,     0,  1146,     0,     0,     0,     0,  1819,
       0,     0,     0,  1814,     0,  2083,  2084,  2085,     0,  2086,
    2087,  2088,  2089,  2090,  2091,     0,     0,     0,     0,  3753,
       0,  1146,     0,     0,     0,  1819,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1146,  1146,     0,     0,  1146,
       0,     0,     0,     0,     0,     0,  1146,  1146,  2083,  2084,
    2085,     0,  2086,  2087,  2088,  2089,  2090,  2091,     0,     0,
       0,     0,  3767,  2083,  2084,  2085,     0,  2086,  2087,  2088,
    2089,  2090,  2091,  1146,     0,     0,     0,  3979,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1819,     0,     0,  1146,     0,  4046,  4046,     0,     0,     0,
    1142,  1148,   695,     0,  1148,  3904,  1142,   677,  1047,     0,
    1173,     0,   677,     0,  1047,     0,  1047,     0,     0,     0,
    1148,   677,  1047,     0,     0,     0,  1814,     0,     0,  1146,
    1195,     0,     0,     0,     0,  1047,     0,  1142,     0,     0,
       0,   695,  4074,  1148,     0,     0,   677,     0,  1173,     0,
     677,  1240,     0,     0,     0,     0,     0,     0,  1148,     0,
     677,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1146,     0,  1819,
    1047,     0,     0,     0,     0,  1269,     0,  2067,     0,  1142,
    2068,     0,     0,   695,     0,     0,  1142,     0,     0,  1173,
       0,     0,     0,     0,     0,     0,  1146,  1819,     0,  1146,
       0,  1146,     0,     0,  1148,  2071,     0,     0,     0,     0,
    2072,     0,     0,     0,     0,  1330,     0,  2067,     0,     0,
    2068,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2069,  1814,  1146,
       0,     0,  1819,     0,     0,  2071,  1819,  1819,     0,     0,
    2072,     0,     0,  1047,     0,     0,     0,     0,  1047,     0,
       0,     0,     0,     0,  1987,     0,     0,     0,     0,     0,
    1047,  1385,   396,  1814,     0,     0,     0,     0,     0,  1146,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1488,     0,  3713,     0,
     695,  1047,     0,     0,  1269,  1819,     0,     0,     0,  4362,
       0,     0,     0,     0,     0,     0,     0,     0,  1047,     0,
       0,     0,  1047,     0,     0,  1146,     0,  1538,     0,     0,
       0,     0,  1488,     0,     0, -2403,     0,     0,     0,  2074,
       0,  1047,     0,     0,     0,  4057,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4065,     0,     0,  4213,     0,
    2075,  2076,     0,     0,     0,     0,     0,     0,     0,  1146,
       0,     0,     0,     0, -2403,  2073,  1146,     0, -1915,  2074,
       0,     0,     0,     0,     0,     0,     0,     0,   677,   677,
       0,     0,  1146,  1146,     0,     0,  1814,     0,     0,     0,
    2075,  2076,  1146,     0,     0,     0,     0,  1814,     0,  2079,
       0,     0,  2067,     0,  2077,  2068,     0,     0,     0,     0,
       0,     0,  2080,     0,     0,     0,     0, -1915,     0,  1146,
       0,     0,  2069,  1148,  1148,     0,     0,     0, -1915,  1146,
    2071,     0, -1915,     0,     0,  2072,  2078, -1915,  2067,  2079,
       0,  2068, -1915,     0,     0, -1915,     0, -1915,     0,  4280,
       0,     0,  2080,     0,     0,  2081,     0,     0,  2069,     0,
    1142,     0,     0,     0,     0,     0,  2071,  1142,     0,     0,
    1173,  2072,     0,     0, -1915,     0,     0,     0,  1814,     0,
       0,     0,  1148,  1146,     0, -2403,     0,     0,  1814,     0,
       0,     0,  1146, -1915,     0,     0,     0,     0,  1148,  1148,
       0,     0,     0,     0,     0,  3554,     0,     0,     0,     0,
       0,  4046,  1047,  1047,  1047,  1148,     0,  1142,     0,     0,
       0,  1861,     0,     0,     0,  2082,     0,     0,     0,     0,
       0,  1987,     0,  4328,  2067,  4330, -1915,  2068,     0,     0,
       0,     0,     0,     0, -1915,     0,     0,     0,     0,  1148,
    1148,     0,     0,     0,  2069,     0,     0,     0,     0,     0,
    2073,     0,  2071,     0,  2074,     0,     0,  2072,  1269,     0,
       0,     0,     0,     0,     0,  2086,  2087,  2088,  2089,  2090,
    2091,     0,     0,  1488,     0,  2075,  2076, -1915,     0,     0,
       0,     0,     0,  1269,     0,     0,  2073,     0,     0,  2077,
    2074,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2083,  2084,  2085,     0,  2086,  2087,  2088,  2089,  2090,
    2091,  2075,  2076,  1960,  1960,  4011,     0,     0,  1047,     0,
     978,  2078,   983,     0,  2079,  2077,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2080,  1814,  4395,
    2081,     0,     0,  1996,     0, -1915,  1047,     0,     0,  2002,
       0,     0,     0,     0,     0,     0,     0,  2078,     0,  1488,
    2079,     0,     0,     0,  1814,     0, -1915,     0, -1915, -1915,
       0,     0,     0,  2080,     0,     0,  2081,     0,     0,  4424,
       0,     0,  2073,     0,     0,     0,  2074,  1488,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   -1915,     0,     0, -1915, -1915,     0, -1915,  2075,  2076,     0,
    2082,     0,     0,  1987,  1488,  1488,     0,  1488,     0,     0,
       0,  2077,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1488,     0,     0,     0,     0,  1814,
       0,     0,     0,     0,     0,     0,  2082,     0,     0,     0,
       0,     0,     0,  2078,   695,   695,  2079,     0,  1987,     0,
       0,     0,  1987,  1987,     0,     0,     0,     0,  1269,  2080,
       0,     0,  2081,     0,     0,  1269,  1269,     0,     0,     0,
       0,     0,  1047,     0,     0,  1488,     0,  2067,     0,     0,
    2068,  2159,     0,  2166,     0,     0,  2083,  2084,  2085,     0,
    2086,  2087,  2088,  2089,  2090,  2091,     0,  2069,     0,     0,
    4183,     0,     0,     0,     0,  2071,     0,  1488,     0,     0,
    2072,  1488,  1488,     0,     0,     0,     0,     0,  1814,     0,
       0,     0,  2083,  2084,  2085,     0,  2086,  2087,  2088,  2089,
    2090,  2091,  2082,     0,     0,     0,  4208,     0,     0,     0,
       0,     0,     0,     0,     0,   695,  1814,   677,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1814,     0,     0,     0,  1814,  1814,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2083,  2084,
    2085,     0,  2086,  2087,  2088,  2089,  2090,  2091,  2321,     0,
       0,     0,  4246,     0,  1047,  2073,     0,     0,     0,  2074,
       0,     0,     0,     0,     0,     0,     0,  1173,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2075,  2076,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2077,     0,     0,     0,     0,     0,
    1148,  1148,  1148,  1148,  1047,     0,     0,     0,   677,     0,
       0,     0,     0,     0,     0,     0,     4,     0,     0,     0,
       0,     0,     0,  2408,     0,  1047,  2078,     0,     0,  2079,
       0,  1148,  1148,     0,     0,     0,     5,  1148,     0,     0,
       0,     0,  2080,     0,     0,  2081,     6,     7,     0,     0,
       0,     0,     8,     0,     9,    10,     0,     0,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,     0,    36,     0,    37,    38,    39,    40,
      41,    42,    43,    44,     0,     0,   677,    45,     0,     0,
       0,     0,  1148,  1148,  1148,  1148,     0,     0,     0,     0,
       0,   677,     0,     0,     0,  2082,     0,     0,     0,  2408,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2517,     0,  1142,     0,     0,     0,
       0,     0,     0,   695,    46,  1142,     0,     0,     0,     0,
       0,     0,     0,  1173,     0,     0,     0,     0,  1047,     0,
       0,     0,     0,     0,     0,     0,     0,  1047,     0,   677,
       0,     0,     0,  1148,  1148,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1047,     0,     0,
    1330,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2083,  2084,  2085,     0,  2086,  2087,  2088,  2089,  2090,
    2091,     0,     0,     0,     0,  4397,    47,     0,     0,     0,
       0,  1960,  2067,     0,     0,  2068,     0,     0,     0,  1142,
       0,    48,     0,  1047,  1047,     0,     0,     0,     0,     0,
       0,  2598,  2069,     0,     0,  1047,     0,     0,     0,     0,
    2071,    49,     0,     0,     0,  2072,     0,     0,     0,     0,
       0,   978,   978,     0,     0,  2623,     0,  1488,  1488,     0,
       0,     0,     0,    50,     0,  1488,     0,     0,  1488,     0,
       0,  1488,     0,     0,     0,     0,     0,     0,     0,  1488,
    1488,     0,     0,     0,     0,     0,     0,  1488,     0,  1173,
    1488,  1488,  1488,  1488,     0,     0,    51,     0,     0,    52,
    1488,  1488,     0,  1488,     0,  1488,     0,     0,  1488,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      53,     0,     0,  1488,     0,     0,     0,  1488,     0,     0,
       0,  1488,     0,     0,     0,  1488,     0,  1488,  1488,  1488,
    1488,  1488,  1488,  1488,  1488,  1488,     0,  1488,     0,     0,
       0,     0,  1047,  1488,     0,     0,  1488,     0,     0,     0,
       0,     0,     0,     0,     0,  2067,     0,     0,  2068,     0,
    2073,     0,     0,     0,  2074,     0,     0,  1047,     0,     0,
       0,     0,     0,     0,     0,  2069,     0,     0,     0,  2796,
       0,    54,     0,  2071,     0,  2075,  2076,     0,  2072,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2077,
       0,     0,     0,     0,  2166,     0,     0,     0,     0,     0,
       0,  1047,     0,  1047,     0,  1488,     0,     0,     0,     0,
       0,     0,     0,    55,     0,     0,     0,     0,     0,     0,
       0,  2078,     0,     0,  2079,     0,    56,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2080,     0,    57,
    2081,     0,     0,     0,     0,     0,     0,     0,     0,  2797,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    58,   677,     0,     0,     0,     0,
      59,     0,     0,     0,    60,    61,    62,    63,    64,     0,
       0,    65,    66,    67,    68,     0,    69,    70,    71,    72,
      73,     0,   677,     0,     0,     0,   677,   695,     0,     0,
       0,     0,   978,  2073,   978,     0,     0,  2074,     0,     0,
    2082,     0,     0,     0,     0,     0,     0,     0,   677,  1488,
       0,     0,     0,     0,     0,     0,   677,     0,  2075,  2076,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2077,     0,     0,     0,     0,     0,     0,   677,
       0,  2321,     0,     0,     0,     0,     0,  2894,     0,     0,
       0,     0,  2903,     0,     0,     0,     0,     0,  1047,   677,
       0,     0,     0,     0,  2078,     0,     0,  2079,     0,  2925,
    2925,     0,     0,     0,     0,   695,   677,     0,     0,   677,
    2080,     0,     0,  2081,     0,     0,  2083,  2084,  2085,  1148,
    2086,  2087,  2088,  2089,  2090,  2091,     0,   677,     0,     0,
    4474,     0,     0,     0,   677,  2067,     0,     0,  2068,     0,
       0,     0,     0,   677,     0,     0,     0,     0,     0,     0,
     677,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2071,  2067,     0,  1148,  2068,  2072,     0,
       0,     0,     0,  1148,  1148,  1148,  1148,  1148,  1148,     0,
       0,     0,     0,  2082,  2069,     0,     0,     0,  1488,     0,
       0,     0,  2071,     0,     0,     0,     0,  2072,     0,     0,
       0,     0,     0,     0,     0,     0,  2925,     0,     0,     0,
    1047,     0,     0,     0,   978,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2798,     0,     0,     0,     0,     0,  3076,     0,
       0,     0,     0,     0,  1148,  3090,     0,     0,     0,     0,
       0,     0,     0,     0,  1269,  1861,  3714,     0,     0,     0,
       0,     0,  2517,  3120,     0,     0,     0,  3120,  3133,  2083,
    2084,  2085,  1488,  2086,  2087,  2088,  2089,  2090,  2091,     0,
       0,     0,     0,     0,  1148,  2925,  1148,  2925,  2067,     0,
       0,  2068,     0, -2403,     0,     0,     0,  2074,     0,     0,
    4449,  1269,     0,     0,     0,     0,     0,     0,  2069,  1488,
       0,  3206,     0,     0,     0,     0,  2071,     0,  2075,  2076,
       0,  2072,  2073,     0,     0,     0,  2074,     0,     0,     0,
    1960,     0, -2403,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   677,  2075,  2076,     0,
       0,     0,     0,  1488,     0,     0,     0,     0,     0,     0,
       0,  2077,     0,     0,     0,     0,     0,  2079,     0,     0,
       0,     0,     0,     0,   677,     0,     0,     0,     0,     0,
    2080,     0,     0,  1488,  1488,     0,     0,     0,     0,     0,
       0,     0,     0,  2078,     0,     0,  2079,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2080,
       0,     0,  2081,  1488,  1488,     0,     0,     0,  1488,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4450,     0,
    1488,  1488,  1488,  1488,     0,     0,     0,     0,     0,     0,
       0,     0,  1488,     0,     0,  1488,  2073,  1488,  3268,     0,
    2074,     0,     0, -2403,     0,     0,     0,  1488,  1488,     0,
    1488,     0,     0,     0,     0,   802,     0,     0,     0,     0,
       0,  2075,  2076,  1488,     0,  1488,     0,  1173,     0,  1488,
       0,     0,  2082,     0,     0,  2077,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1488,     0,     0,     0,  1047,
       0,     0,     0,     0,     0,  2517,     0,  1488,  1488,  1488,
     802,     0,     0,     0,     0,     0,     0,  2078,     0,     0,
    2079,     0,     0,     0,     0,     0,     0,  1269,     0,     0,
       0,  1488,     0,  2080,     0,     0,  2081,     0,  2166,     0,
    1488,     0,     0,  2086,  2087,  2088,  2089,  2090,  2091,  1488,
       0,     0,  2067,     0,  1488,  2068,     0,  1010,  1047,     0,
       0,  1488,     0,     0,  1010,     0,  1010,     0,  2083,  2084,
    2085,     0,  2086,  2087,  2088,  2089,  2090,  2091,   802,     0,
    2071,     0,     0,     4,     0,  2072,     0,     0,     0,     0,
       0,     0,   677,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     5,     0,     0,  2082,     0,     0,  1488,
       0,  2925,     0,     6,     7,  1960,     0,     0,     0,     0,
       0,     9,    10,     0,     0,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
       0,     0,     0,    37,    38,    39,    40,    41,    42,    43,
      44,     0,     0,     0,    45,     0,     0,     0,     0,     0,
       0,     0,     0,  3717,     0,     0,     0,   677,     0,     0,
    2067,     0,     0,  2068,   677,     0,     0,     0,     0,     0,
       0,     0,  2083,  2084,  2085,     0,  2086,  2087,  2088,  2089,
    2090,  2091,     0,     0,     0,     0,     0,     0,  2071,     0,
   -2403,    46,     0,  2072,  2074,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2075,  2076,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   677,     0,     0, -2403,
       0,     0,     0,     0,     0,     0,  2925,  2925,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    47,  2079,  3505,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2080,    48,     0,
       0,  4009,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    49,     0,
       0,     0,     0,     0,  1960,  1047,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1047,     0,     0, -2403,     0,
      50,     0,  2074,     0,     0,     0,     0,     0,     0,     0,
    1047,     0,     0,     0,     0,     0,  1269,     0,     0,     0,
       0,     0,     0,  2075,  2076,   695,     0,     0,     0,  3120,
   -2403,     0,  3596,    51,     0,  2517,    52, -2403,     0,  2517,
       0,     0,     0,     0,     0,  3609,     0,     0,  1488,     0,
       0,     0,     0,     0,     0,     0,     0,    53,     0,     0,
       0,     0,     0,  1047,     0,     0,  1047,     0,     0,   677,
       0,     0,  2079,  3627,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1142,  2080,     0,   677,     0,     0,
       0,     0,     0,     0,  2598,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1047,     0,   677,
       0,     0,     0,     0,     0,     0,     0,  1488,     0,     0,
    2086,  2087,  2088,  2089,  2090,  2091,  1488,     0,    54,     0,
       0,     0,  1488,     0,  1488,     0,     0,     0,     0,     0,
    1488,     0,     0,  1488,  1488,  1488,  1488,  1488,  1488,  1488,
    1488,  1488,  1488,     0,     0,     0,  1488,  1488, -2403,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1488,
      55,     0,     0,     0,     0,  1488,     0,     0,     0,     0,
       0,     0,     0,    56,     0,  1488,  2067,     0,  1488,  2068,
    1488,     0,     0,     0,     0,     0,    57,     0,     0,  1488,
    1488,  1488,     0,     0,     0,  1488,  2069,     0,  1488,     0,
       0,     0,     0,     0,  2071,  1047,  1047,     0,  1488,  2072,
       0,    58,     0,     0,  3736,     0,  1488,    59,  1488,     0,
       0,    60,    61,    62,    63,    64,     0,     0,    65,    66,
    1308,     0,     0,     0,     0,    71,  1309,     0,  2086,  2087,
    2088,  2089,  2090,  2091,     0,     0,     0,  2166,     0,     0,
       0,     0,     0,  2067,     0,     0,  2068,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1196,     0,     0,  2069,     0,     0,     0,  2067,     0,     0,
    2068,  2071,     0,     0,     0,     0,  2072,     0,  3773,  1960,
    1960,     0,     0,     0,   677,     0,     0,  2069,     0,     0,
       0,     0,  1197,     0,     0,  2071,   802,     0,     0,     0,
    2072,     0,     0,  3791,  1144,  1198,     0,     0,     0,     0,
    1144,     0,     0,  1199,     0,     0,     0,  1200,     0,     0,
       0,     0,     0,     0,  2073,     0,     0,     0,  2074,     0,
       0,     0,     0,     0,     0,     0,     0,  1201,     0,     0,
       0,  1144,   677,     0,   677,     0,     0,     0,     0,  2075,
    2076,     0,     0,     0,     0,     0,     0,     0,  1202,     0,
       0,     0,     0,  2077,     0,     0,     0,     0,     0,     0,
    1269,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3242,     0,     0,     0,     0,  3243,     0,     0,     0,     0,
       0,  1203,     0,  1144,     0,  2078,     0,  3505,  2079,     0,
    1144,  2073,     0,  1047,     0,  2074,     0,     0,     0,     0,
       0,  2080,  1204,     0,  2081,  1488,     0,     0,     0,     0,
       0,  1047,     0,     0,     0,  2073,  2075,  2076,     0,  2074,
       0,     0,  3690,     0,     0,     0,  1205,     0,  1047,     0,
    2077,     0,     0,     0,     0,     0,     0,  3076,     0,     0,
    2075,  2076,  3921,     0,     0,     0,  2321,     0,  3627,     0,
       0,     0,     0,     0,  2077,     0,     0,     0,     0,  1488,
    1488,     0,  2078,     0,     0,  2079,     0,     0,     0,     0,
       0,     0,     0,     0,  2082,     0,     0,     0,  2080,  3120,
       0,  2081,  1206,  2517,     0,     0,  2078,  3691,  2517,  2079,
       0,  2517,  3076,     0,  3959,     0,     0,     0,     0,     0,
    1144,  2925,  2080,  2925,     0,  2081,  1010,     0,     0,   827,
    1010,     0,     0,     0,     0,     0,     0,     0,  3220,     0,
       0,   677,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1207,     0,  1488,  1144,  1208,     0,  1209,
       0,     0,     0,     0,     0,  1210,     0,     0,     0,     0,
       0,  2082,     0,     0,     0,     0,     0,     0,     0,     0,
    2083,  2084,  2085,     0,  2086,  2087,  2088,  2089,  2090,  2091,
       0,  1488,     0,     0,  1211,  2082,  1212,     0,  1488,  1488,
    1213,     0,     0,     0,     0,     0,  1488,  1488,  1214,     0,
       0,  1488,     0,  1215,     0,     0,     0,  1488,  1488,     0,
       0,  1488,     0,  1047,  1047,  1047,  1047,     0,     0,     0,
       0,     0,  1488,     0,     0,  1216,     0,     0,  4023,     0,
       0,     0,     0,     0,  1488,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1173,     0,  2083,  2084,  2085,
       0,  2086,  2087,  2088,  2089,  2090,  2091,     0,     0,   978,
       0,     0,  1488,     0,     0,     0,  1148,  1148,     0,     0,
       0,  2083,  2084,  2085,     0,  2086,  2087,  2088,  2089,  2090,
    2091,  4056,     0,     0,  1144,     0,     0,     0,     0,   677,
       0,  1144,     0,     0,     0,  2067,     0,     0,  2068,     0,
     677,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1817,  1148,     0,  2069,     0,     0,  3250,     0,
       0,     0,     0,  2071,     0,     0,     0,     0,  2072,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1269,  1144,     0,     0,     0,     0,     0,  1960,     0,     0,
    1816,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3505,  3505,  3505,  3505,  3505,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1488,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1144,     0,     0,
       0,     0,     0,  2067,     0,     0,  2068,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2069,     0,     0,  1047,     0,  4158,     0,
       0,  2071,     0,     0,  1488,     0,  2072,     0,  2517,     0,
       0,  3959,     0,  2073,     0,     0,     0,  2074,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1817,     0,     0,
     677,     0,     0,     0,     0,  1488,     0,     0,  2075,  2076,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2077,  1144,     0,     0,     0,     0,     0,  1488,
    1488,     0,     0,  1488,     0,  1816,     0,     0,     0,     0,
    1488,  1488,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1144,     0,     0,  2078,     0,     0,  2079,     0,     0,
       0,   677,     0,   677,     0,     0,     0,  3773,  1173,  1148,
    2080,     0,     0,  2081,     0,     0,     0,     0,  1144,  1144,
       0,  1144,     0,     0,     0,  3255,     0,  1142,  1173,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1144,     0,
       0,  2073,     0,     0,     0,  2074,     0,     0,     0,     0,
       0,     0,  1960,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1142,     0,     0,  2075,  2076,     0,     0,
       0,     0,  1047,     0,     0,     0,     0,     0,     0,     0,
    2077,     0,     0,  2082,  2925,     0,  2321,     0,     0,  1144,
     802,     0,     0,     0,     0,     0,  3921,     0,     0,     0,
       0,  1047,  2067,     0,     0,  2068,     0,     0,     0,     0,
    1148,  3773,  2078,     0,     0,  2079,     0,     0,     0,     0,
       0,  1144,  2069,     0,     0,  1144,  1144,     0,  2080,     0,
    2071,  2081,     0,     0,     0,  2072,     0,     0,     0,     0,
    1488,     0,     0,  1488,     0,  1488,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4304,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2083,
    2084,  2085,  1148,  2086,  2087,  2088,  2089,  2090,  2091,     0,
    1047,     0,     0,  1488,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1148,  1148,  1148,  1148,     0,     0,  1817,
       0,  2082,  1269,     0,   802,     0,     0,     0,  1010,     0,
       0,     0,  2067,     0,     0,  2068,     0,     0,     0,     0,
       0,     0,     0,  1488,     0,     0,     0,     0,     0,  1010,
       0,     0,  2069,     0,     0,  3259,  1817,  1816,     0,     0,
    2071,     0,     0,     0,     0,  2072,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1817,
    2073,     0,     0,     0,  2074,     0,     0,     0,     0,  1488,
       0,     0,     0,     0,  2314,     0,     0,  1173,     0,     0,
       0,     0,     0,     0,     0,  2075,  2076,  2083,  2084,  2085,
       0,  2086,  2087,  2088,  2089,  2090,  2091,  1816,     0,  2077,
       0,     0,     0,     0,  1010,     0,     0,     0,     0,     0,
    1148,     0,     0,  1142,  3049,     0,     0,     0,     0,     0,
    3773,  1817,     0,     0,     0,     0,     0,  4158,     0,     0,
       0,  2078,     0,  4304,  2079,     0,  1488,  1488,  1817,   677,
       0,     0,     0,     0,     0,     0,  1142,  2080,     0,     0,
    1148,     0,     0,     0,     0,     0,  1817,     0,     0,  1816,
       0,     0,     0,     0,     0,     0,     0,     0,  2933,     0,
    2073,     0,     0,  1488,  2074,     0,  1816,  2934,  2935,  2936,
       0,  1817,     0,  1488,     0,     0,   802,     0,     0,     0,
       0,     0,     0,     0,  1816,  2075,  2076,  4463,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2077,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1816,
    2082,  2937,     0,     0,     0,     0,     0,     0,  1144,     0,
    1144,     0,     0,     0,     0,     0,  1817,  1488,     0,  1144,
       0,  2078,  4463,     0,  2079,     0,  1142,     0,     0,     0,
    4463,     0,     0,     0,     0,     0,     0,  2080,     0,     0,
    2081,     0,     0,     0,     0,  3050,     0,     0,     0,     0,
    2938,     0,     0,     0,  1816,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2083,  2084,  2085,  2939,
    2086,  2087,  2088,  2089,  2090,  2091,     0,     0,     0,     0,
       0,     0,     0,  1144,     0,  2940,  2941,  2942,  2943,  2944,
    2082,  2945,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1806,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1144,  1144,  2946,     0,     0,     0,     0,     0,  1144,
       0,     0,  1144,     0,     0,  1144,     0,     0,     0,     0,
       0,     0,     0,  1144,  1144,     0,     0,     0,     0,     0,
       0,  1144,     0,     0,  1144,  1144,  1144,  1144,     0,  3051,
       0,     0,     0,     0,  1144,  1144,     0,  1144,     0,  1144,
       0,     0,  1144,     0,     0,     0,  2083,  2084,  2085,     0,
    2086,  2087,  2088,  2089,  2090,  2091,  1817,  1144,   802,     0,
    2067,  1144,     0,  2068,     0,  1144,  2947,     0,  3052,  1144,
       0,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,
    2069,  1144,     0,     0,     0,     0,     0,  1144,  2071,     0,
    1144,     0,  2948,  2072,  1816,     0,     0,     0,     0,  2949,
       0,     0,  2950,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     4,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2762,     0,
    1806,     0,     0,     0,     0,     0,     0,     0,     5,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     6,     7,
       0,     0,     0,     0,     0,     0,     9,    10,     0,  1144,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,     0,     0,     0,    37,    38,
      39,    40,    41,    42,    43,    44,     0,     0,     0,    45,
       0,     0,     0,     0,   905,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   906,     0,  2073,     0,
       0,     0,  2074,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   907,     0,     0,     0,
       0,     0,     0,  2075,  2076,     0,    46,     0,     0,   802,
       0,     0,     0,     0,     0,     0,     0,  2077,     0,     0,
       0,   908,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1144,     0,     0,     0,     0,     0,     0,
       0,   909,     0,     0,     0,     0,     0,     0,     0,  2078,
       0,     0,  2079,  1817,     0,     0,     0,     0,  1817,  1817,
       0,     0,   910,     0,     0,  2080,     0,     0,  2081,  1817,
       0,     0,     0,     0,     0,     0,     0,     0,    47,     0,
       0,     0,     0,     0,     0,   802,     0,     0,     0,     0,
     911,  2881,     0,    48,     0,   912,  2314,  2888,     0,     0,
       0,   913,     0,  2067,     0,     0,  2068,  1816,     0,     0,
       0,     0,     0,    49,     0,     0,   914,     0,     0,     0,
     802,     0,     0,  2069,     0,     0,  3697,     0,     0,     0,
       0,  2071,     0,     0,     0,    50,  2072,     0,  2082,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1806,  2067,     0,     0,  2068,     0,     0,     0,
       0,     0,     0,     0,  3651,     0,     0,     0,    51,     0,
       0,    52,     0,  2069,     0,     0,     0,     0,     0,     0,
       0,  2071,  1144,     0,  1817,     0,  2072,     0,     0,  1806,
       0,     0,    53,     0,     0,     0,   915,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   916,     0,     0,     0,
       0,     0,  1806,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1816,   827,  2083,  2084,  2085,     0,  2086,  2087,
    2088,  2089,  2090,  2091,     0,  1008,     0,     0,     0,     0,
       0,     0,  1008,     0,  1008,  1817,     0,   917,     0,     0,
       0,   918,     0,   919,     0,     0,  1144,     0,     0,   920,
       0,  2073,   921,    54,     0,  2074,  1144,     0,     0,     0,
       0,     0,     0,     0,  1806,     0,     0,     0,     0,     0,
       0,     0,     0,  2314,     0,     0,  2075,  2076,   922,     0,
     923,  1806,     0,     0,   924,     0,     0,     0,     0,     0,
    2077,     0,   925,  1144,     0,    55,     0,   926,     0,  1806,
       0,  2073,     0,     0,     0,  2074,     0,   927,    56,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   928,
       0,    57,  2078,     0,  1806,  2079,  2075,  2076,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1144,  2080,     0,
    2077,  2081,     0,     0,     0,     0,    58,     0,  1817,     0,
       0,     0,    59,     0,     0,     0,    60,    61,    62,    63,
      64,     0,     0,    65,    66,  1308,  1912,  1144,  1144,     0,
      71,     0,  2078,     0,     0,  2079,     0,     0,     0,  1806,
       0,     0,     0,     0,     0,     0,  1816,     0,  2080,     0,
       0,  2081,     0,     0,     0,     0,     0,  1144,  1144,     0,
       0,     0,  1144,     0,     0,     0,     0, -1917,     0,     0,
       0,  2082,     0,   853,  1144,  1144,  1144,  1144,     0,     0,
       0,     0,   802,     0,     0,   854,  1144,   802,     0,  1144,
       0,  1144,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1144,  1144,     0,  1144,   855,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0, -1917,  1144,     0,  1144,
       0,  2082,     0,  1144,     0,     0,   856, -1917,     0,     0,
    -629, -1917,     0,     0,     0,     0, -1917,     0,     0,  1144,
       0, -1917,     0,     0, -1917,     0, -1917,     0,     0,  1144,
     857,  1144,  1144,  1144,     0,     0,   858,  2083,  2084,  2085,
       0,  2086,  2087,  2088,  2089,  2090,  2091,     0,     0,     0,
       0,   859,     0, -1917,     0,  1144,     0,     0,     0,     0,
       0,     0,     0,     0,  1144,     0,     0,     0,     0,  2762,
    2762,  2762, -1917,  1144,     0,     0,     0,     0,  1144,   860,
       0,     0,     0,     0,     0,  1144,   861,  2083,  2084,  2085,
     862,  2086,  2087,  2088,  2089,  2090,  2091,     0,     0,     0,
       0,     0,     0,     0,     0,  -789,     0,     0,     0,  1806,
       0,     0,     0,     0,     0, -1917,     0,     0,     0,     0,
       0,     0,     0, -1917,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1144,     0,     0,     0,     0,     0,     0,
       0,   863,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1817,  1817,     0,  1817,     0, -1917,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   864,     0,     0,   865,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2314,
    2888,     0,  2888,     0,     0,  1817,     0,  1817,     0,     0,
       0,   983,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0, -1917,     0,   866,     0,   802,   802,
     802,     0,   867,  1816,     0,  1816,     0,     0,  -362,     0,
       0,   868,     0,     0,     0, -1917,     0, -1917, -1917,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1817,  -362,     0,   869,
     870,     0,   871,   872,     0,     0,     0,     0,     0, -1917,
       0,   873, -1917, -1917,     0, -1917,   874,     0,   802,     0,
       0,   875,     0,  1817,     0,     0,   876,     0,     0,     0,
       0,     0,     0,     0,  1816,     0,     0,     0,  -362,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   802,  1817,     0,     0,
       0,  2888,     0,     0,     0,     0,  1806,     0,     0,     0,
       0,  1806,  1806,     0,  1817,     0,     0,     0,     0,     0,
       0,     0,  1806,     0,     0,     0,     0,     0,  1817,     0,
       0,     0,  1140,     0,     0,  2888,     0,     0,  1140,     0,
       0,  1817,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1816,     0,     0,     0,     0,     0,     0,  1144,
       0,     0,     0,  1144,     0,     0,  1816,     0,     0,  1140,
       0,     0,  1144,     0,     0,     0,     0,     0,  1817,  2888,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1144,     0,
    2762,     0,     0,     0,     0,     0,  1816,     0,     0,     0,
       0,  1140,     0,     0,     0,     0,     0,     0,  1140,     0,
       0,     0,     0,     0,     0,     0,     0,  1806,     0,     0,
       0,  1144,     0,     0,  1817,     0,     0,     0,     0,     0,
    1144,     0,     0,     0,     0,     0,  1144,     0,  1144,     0,
       0,     0,     0,  1817,  1144,     0,     0,  1144,  1144,  1144,
    1144,  1144,  1144,  1144,  1144,  1144,  1144,     0,     0,     0,
    1144,  1144,  1816,     0,     0,     0,     0,     0,  1817,     0,
       0,     0,     0,  1144,     0,     0,     0,   802,  1806,  1144,
       0,  1816,     0,     0,     0,     0,     0,     0,     0,  1144,
       0,     0,  1144,     0,  1144,     0,     0,     0,     0,     0,
       0,     0,  1817,  1144,  1144,  1144,  1816,     0,     0,  1144,
       0,     0,  1144,     0,     0,     0,     0,     0,  1140,     0,
       0,     0,  1144,     0,  1008,     0,     0,     0,  1008,     0,
    1144,     0,  1144,     0,     0,     0,     0,     0,     0,     0,
    1816,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1140,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2762,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1806,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1144,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   802,  1817,   802,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   802,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2888,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1140,     0,     0,     0,     0,     0,     0,  1140,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1815,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1144,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1140,
       0,     0,     0,     0,     0,     0,     0,  1817,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1817,  1144,  1144,  1816,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1140,     0,  1144,     0,     0,
       0,     0,  1144,     0,     0,  1144,     0,     0,     0,     0,
    2314,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1806,  1806,     0,  1806,     0,  1144,
       0,     0,     0,     0,     0,  1815,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1140,     0,     0,     0,  1144,     0,     0,  1806,     0,
    1806,     0,  1144,  1144,     0,  1817,     0,     0,     0,     0,
    1144,  1144,     0,     0,     0,  1144,  1817,     0,     0,  1140,
       0,  1144,  1144,     0,     0,  1144,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1144,     0,     0,     0,
       0,     0,     0,  1816,     0,     0,  1140,  1140,  1144,  1140,
       0,     0,     0,     0,  1816,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1140,     0,     0,  1806,
       0,     0,     0,     0,  2762,     0,  1144,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2762,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1806,  1817,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1817,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1140,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1806,     0,     0,     0,     0,  1816,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1816,     0,  1806,     0,  1140,
       0,     0,   802,  1140,  1140,     0,     0,     0,     0,     0,
       0,  1806,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1806,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1144,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   802,
       0,  1806,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1815,     0,     0,
       0,     0,     0,     0,     0,     0,  1008,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1817,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1008,  1144,     0,
       0,     0,  1144,     0,  1815,     0,     0,  1817,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1806,     0,     0,
       0,     0,     0,     0,     0,  4152,     0,  1815,     0,  1144,
       0,     0,     0,  1817,     0,     0,  1806,     0,     0,     0,
       0,     0,     0,     0,     0,  1816,     0,     0,     0,     0,
       0,     0,     0,  1144,  1144,     0,     0,  1144,     0,     0,
       0,  1806,     0,     0,  1144,  1144,     0,     0,     0,     0,
       0,  1816,  1008,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1815,
       0,  1144,     0,     0,     0,  1806,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1815,     0,  1817,     0,
       0,  1144,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1815,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2888,  1144,     0,  1815,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1144,  1140,  1817,  1140,     0,
       0,     0,     0,     0,  1815,     0,     0,  1140,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1144,  1817,     0,  1144,  1806,  1144,
       0,     0,     0,     0,     0,  2888,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1816,     0,     0,     0,  1144,     0,     0,
    1817,     0,     0,     0,  1817,  1817,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1140,     0,     0,     0,     0,     0,     0,     0,     0,
     802,     0,     0,     0,     0,     0,     0,  1144,  1816,     0,
       0,     0,  1816,  1816,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1140,
    1140,     0,     0,  1817,     0,     0,     0,  1140,     0,     0,
    1140,     0,     0,  1140,     0,     0,     0,     0,     0,     0,
    1806,  1140,  1140,  1144,     0,     0,     0,     0,     0,  1140,
       0,     0,  1140,  1140,  1140,  1140,     0,     0,     0,     0,
       0,  4152,  1140,  1140,     0,  1140,     0,  1140,     0,     0,
    1140,     0,     0,     0,     0,  1806,     0,     0,     0,     0,
       0,     0,     0,     0,  1815,  1140,     0,  1144,     0,  1140,
       0,     0,     0,  1140,  1144,     0,     0,  1140,     0,  1140,
    1140,  1140,  1140,  1140,  1140,  1140,  1140,  1140,     0,  1140,
    1144,  1144,     0,     0,     0,  1140,     0,     0,  1140,     0,
    1144,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1808,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1144,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1144,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1140,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1806,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1806,
       0,  1144,     0,     0,     0,     0,     0,     0,     0,     0,
    1144,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1808,
    1806,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1806,  1140,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1815,     0,     0,     0,     0,  1815,  1815,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1815,     0,     0,
       0,     4,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     5,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     6,     7,     0,     0,     0,     0,     0,     0,     9,
      10,     0,     0,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,     0,     0,
       0,    37,    38,    39,    40,    41,    42,    43,    44,     0,
       0,     0,    45,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1140,     0,  1815,     0,     0,     0,     0,     0,     0,     0,
    1806,     0,     0,     0,     0,     0,     0,     0,     0,    46,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1806,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1815,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1140,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1140,     0,     0,     0,     0,     0,
       0,    47,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1808,     0,     0,     0,     0,    48,     0,     0,     0,
       0,  1806,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1140,     0,     0,     0,     0,    49,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1808,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    50,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1808,     0,     0,     0,  1140,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1815,     0,     0,     0,
       0,    51,     0,     0,    52,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1140,  1140,     0,     0,     0,
    1806,     0,     0,     0,     0,    53,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1808,     0,  1140,  1140,     0,  1806,     0,
    1140,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1808,     0,  1140,  1140,  1140,  1140,     0,     0,     0,     0,
       0,     0,     0,     0,  1140,     0,     0,  1140,  1808,  1140,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1140,
    1140,     0,  1140,  1806,     0,     0,    54,  1806,  1806,     0,
       0,     0,     0,  1808,     0,  1140,     0,  1140,     0,     0,
       0,  1140,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1140,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1140,    55,  1140,
    1140,  1140,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    56,     0,     0,     0,     0,     0,     0,  1808,     0,
       0,     0,     0,  1140,    57,     0,     0,     0,     0,     0,
       0,     0,  1140,   699,     0,     0,     0,     0,     0,     0,
       0,  1140,     0,   699,     0,     0,  1140,     0,     0,    58,
       0,     0,     0,  1140,     0,    59,     0,     0,     0,    60,
      61,    62,    63,    64,     0,     0,    65,    66,  1308,  2551,
       0,     0,     0,    71,     0,     0,     0,     0,     0,   699,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     891,     0,     0,   699,     0,     0,     0,     0,     0,     0,
     891,  1140,     0,     0,   699,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   699,     0,     0,     0,  1815,
    1815,     0,  1815,     0,     0,     0,     0,     0,     0,     0,
       0,   891,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1815,  1063,  1815,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1808,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1815,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1815,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1815,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1815,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1815,     0,     0,  1108,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1815,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1140,     0,     0,
       0,  1140,     0,     0,     0,     0,     0,     0,     0,     0,
    1140,     0,     0,     0,     0,     0,  1815,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1140,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1808,     0,     0,     0,  1140,
    1808,  1808,  1815,     0,     0,     0,     0,     0,  1140,     0,
       0,  1808,     0,     0,  1140,     0,  1140,     0,     0,     0,
       0,  1815,  1140,     0,     0,  1140,  1140,  1140,  1140,  1140,
    1140,  1140,  1140,  1140,  1140,     0,     0,     0,  1140,  1140,
       0,     0,     0,     0,     0,     0,  1815,     0,     0,     0,
       0,  1140,     0,     0,     0,     0,     0,  1140,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1140,     0,     0,
    1140,     0,  1140,     0,     0,     0,     0,     0,     0,     0,
    1815,  1140,  1140,  1140,     0,     0,     0,  1140,     0,     0,
    1140,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1140,     0,     0,     0,     0,     0,     0,     0,  1140,     0,
    1140,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1808,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   891,   891,     0,     0,     0,     0,     0,
    1140,     0,     0,     0,     0,     0,     0,  1808,     0,     0,
    1108,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1815,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1145,     0,     0,     0,     0,     0,  1145,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1145,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1808,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1175,  1140,  1177,     0,
    1179,     0,  1181,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1815,     0,     0,     0,     0,
       0,  1223,  1145,     0,     0,     0,     0,     0,     0,  1145,
       0,     0,     0,     0,     0,  1241,  1242,     0,     0,     0,
    1244,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1815,  1140,  1140,     0,     0,  1108,     0,   891,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1274,     0,  1140,     0,     0,     0,     0,
    1140,     0,     0,  1140,     0,  1293,     0,     0,  1295,     0,
    1297,     0,  1300,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   699,   891,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     699,     0,   699,     0,     0,     0,     0,  1140,     0,     0,
       0,     0,   699,     0,     0,     0,     0,     0,     0,  1145,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   699,   699,     0,     0,     0,     0,     0,  1382,
       0,  1383,     0,  1140,     0,     0,     0,     0,     0,     0,
    1140,  1140,     0,  1815,     0,  1145,     0,     0,  1140,  1140,
       0,     0,     0,  1140,  1815,     0,     0,     0,     0,  1140,
    1140,  1108,     0,  1140,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1140,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1140,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1063,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1140,     0,     0,     0,     0,     0,
       0,     0,     0,  1808,  1808,     0,  1808,     0,     0,     0,
       0,     0,     0,     0,     0,  1815,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1815,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1634,     0,  1636,  1808,     0,  1808,
    1638,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1145,     0,     0,     0,     0,     0,     0,
    1145,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1818,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1752,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1764,  1140,  1808,     0,
    1145,     0,     0,     0,     0,  1770,     0,     0,     0,     0,
       0,  1772,     0,     0,     0,     0,     0,     0,     0,  1809,
       0,     0,  1820,     0,     0,  1808,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1815,     0,     0,     0,     0,
       0,  1857,     0,     0,     0,     0,  1140,     0,     0,  1808,
    1140,     0,     0,     0,     0,  1815,  1145,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1808,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1140,     0,     0,
    1808,  1815,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1808,     0,     0,     0,     0,     0,     0,
       0,  1140,  1140,     0,     0,  1140,     0,     0,     0,     0,
       0,     0,  1140,  1140,     0,     0,  1818,     0,     0,     0,
       0,   699,     0,   699,     0,     0,   699,     0,   699,     0,
    1808,   699,   699,   699,     0,     0,     0,     0,     0,  1140,
       0,     0,  1145,     0,   699,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1815,     0,   699,  1140,
     699,     0,     0,     0,  1809,     0,     0,     0,     0,     0,
    1145,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1140,  1808,  1145,  1145,     0,
    1145,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1808,     0,  1145,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1808,     0,     0,  1140,     0,  1815,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1145,     0,
       0,     0,  1140,  1815,  1808,  1140,     0,  1140,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1145,     0,     0,     0,  1145,  1145,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1140,     0,     0,  1815,     0,
       0,     0,  1815,  1815,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1063,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1140,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1818,     0,
       0,  1815,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2234,     0,     0,  2234,     0,     0,     0,
       0,  1140,     0,     0,  2241,     0,     0,  1808,     0,     0,
       0,     0,     0,     0,     0,  1818,     0,     0,     0,     0,
       0,     0,  2250,     0,     0,     0,  1809,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1818,     0,
       0,     0,     0,     0,     0,  1140,     0,     0,  2288,     0,
       0,     0,  1140,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1809,     0,     0,     0,     0,  1140,  1140,
       0,     0,     0,     0,     0,     0,     0,     0,  1140,     0,
       0,     0,     0,     0,     0,     0,  1809,  1476,  1811,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1818,     0,     0,     0,     0,  1140,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1140,     0,  1818,     0,     0,
       0,     0,     0,  1549,     0,     0,     0,     0,     0,  1808,
       0,     0,     0,     0,     0,  1818,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1809,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1818,     0,     0,     0,  1808,  1809,     0,     0,     0,  1140,
       0,     0,     0,     0,     0,     0,     0,     0,  1140,     0,
       0,     0,     0,  1809,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1145,  1809,  1145,
       0,  2449,     0,     0,     0,  1818,     0,     0,  1145,     0,
       0,     0,     0,  2471,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1811,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1809,     0,     0,     0,  2525,     0,     0,
       0,  2529,     0,     0,     0,     0,     0,     0,     0,     0,
    2538,     0,  2540,     0,  2541,     0,     0,  1808,     0,  2542,
       0,     0,     0,     0,     0,     0,     0,     0,  1808,     0,
       0,     0,  1145,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   699,     0,   699,     0,     0,     0,   699,     0,
     699,     0,     0,   699,     0,     0,     0,   699,  2570,     0,
    1145,  1145,     0,     0,     0,     0,     0,     0,  1145,     0,
       0,  1145,     0,     0,  1145,     0,     0,     0,     0,     0,
       0,     0,  1145,  1145,     0,     0,     0,     0,     0,     0,
    1145,     0,     0,  1145,  1145,  1145,  1145,     0,     0,  1808,
       0,     0,     0,  1145,  1145,     0,  1145,     0,  1145,  1808,
       0,  1145,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1818,  1145,     0,     0,     0,
    1145,     0,     0,     0,  1145,     0,     0,     0,  1145,     0,
    1145,  1145,  1145,  1145,  1145,  1145,  1145,  1145,  1145,     0,
    1145,     0,     0,     0,     0,     0,  1145,     0,     0,  1145,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1809,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2009,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2763,     0,     0,     0,     0,     0,  2032,     0,
       0,     0,     0,     0,     0,  1811,     0,     0,  1145,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2056,  2057,     0,  2059,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1811,     0,     0,  2097,     0,     0,     0,  1808,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1811,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1808,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2150,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1145,     0,     0,     0,     0,  1811,  2180,  1108,
       0,     0,  2190,  2193,     0,     0,     0,     0,     0,     0,
       0,     0,  1818,     0,  1811,     0,  2842,  1818,  1818,     0,
    1808,  2846,     0,     0,     0,     0,     0,     0,  1818,     0,
       0,  2856,  1811,     0,     0,     0,     0,     0,  2862,     0,
       0,     0,     0,     0,  2867,     0,     0,     0,     0,     0,
    2877,     0,     0,     0,     0,  2879,     0,  1811,     0,     0,
    1809,     0,     0,     0,     0,  1809,  1809,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1809,     0,     0,     0,
       0,  2895,  2896,  2899,  2901,     0,     0,     0,  2908,  2911,
       0,     0,     0,  2914,     0,     0,  2918,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1808,
       0,     0,  1811,  2953,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2956,     0,  2958,     0,     0,     0,     0,
       0,     0,     0,     0,  2969,  2970,  2971,  1808,  2973,     0,
       0,  1145,     0,  1818,     0,     0,     0,  2986,  2987,     0,
       0,     0,     0,     0,     0,  2990,  2991,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1812,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1808,     0,     0,     0,  1808,  1808,     0,     0,
       0,  1809,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1818,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1145,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1145,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1809,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1145,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1813,     0,
       0,     0,  1811,     0,     0,     0,  1145,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1818,     0,     0,
       0,     0,     0,     0,  1812,     0,     0,     0,  1108,     0,
       0,     0,     0,     0,     0,     0,  1145,  1145,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1809,  1145,  1145,     0,     0,
       0,  1145,     0,  3191,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1145,  1145,  1145,  1145,     0,     0,     0,
       0,     0,     0,     0,     0,  1145,     0,     0,  1145,     0,
    1145,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1145,  1145,     0,  1145,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1145,     0,  1145,     0,
       0,     0,  1145,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2633,     0,  1145,     0,
       0,     0,     0,  1813,     0,     0,     0,     0,  1145,     0,
    1145,  1145,  1145,     0,     0,     0,     0,     0,  2655,     0,
       0,  2657,     0,     0,  2668,     0,     0,     0,     0,     0,
       0,  2675,  2680,     0,  1145,     0,  2685,     0,     0,  2690,
       0,     0,     0,  1145,     0,     0,     0,     0,     0,     0,
       0,     0,  1145,     0,  2699,     0,     0,  1145,  2705,     0,
       0,     0,  2717,     0,  1145,     0,  2724,     0,  2726,  2727,
    2728,  2729,  2730,  2731,  2732,  2733,  2734,     0,  2735,     0,
       0,     0,     0,     0,  1476,     0,     0,  2759,     0,  1811,
       0,     0,     0,     0,  1811,  1811,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1811,     0,     0,     0,     0,
       0,     0,  1145,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1812,     0,     0,     0,
    1818,  1818,     0,  1818,     0,     0,  3372,  3373,     0,     0,
       0,     0,     0,     0,     0,     0,  1549,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1812,     0,     0,     0,  3392,     0,     0,
       0,     0,     0,     0,  1818,     0,  1818,     0,  1809,  1809,
       0,  1809,     0,     0,     0,     0,  1812,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3411,  3412,  3413,  3414,     0,     0,     0,     0,     0,
    1811,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1809,     0,  1809,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1818,     0,     0,  1812,     0,
       0,     0,     0,     0,     0,  1813,     0,     0,     0,     0,
    2865,     0,     0,     0,     0,  1812,     0,     0,     0,     0,
       0,  1811,  1818,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1812,     0,  3455,     0,     0,     0,     0,
    3457,     0,  1813,  1809,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1818,     0,  1812,     0,
       0,     0,     0,     0,     0,  1813,     0,     0,     0,     0,
    1809,     0,     0,  1818,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1818,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1818,     0,     0,     0,  1809,     0,     0,     0,     0,     0,
       0,     0,     0,  1812,     0,     0,     0,     0,  1145,     0,
       0,  1809,  1145,     0,  3555,   891,     0,  1813,     0,     0,
       0,  1145,     0,     0,  1811,  1809,     0,  1818,     0,     0,
       0,     0,     0,     0,  1813,     0,     0,     0,  1809,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3026,
       0,   891,  1813,     0,     0,     0,     0,  1145,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1809,     0,  1813,  3615,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1145,  3624,     0,  1818,     0,     0,     0,     0,     0,  1145,
       0,     0,     0,     0,     0,  1145,     0,  1145,     0,     0,
       0,     0,  1818,  1145,     0,     0,  1145,  1145,  1145,  1145,
    1145,  1145,  1145,  1145,  1145,  1145,     0,     0,     0,  1145,
    1145,     0,  1813,  3137,     0,     0,     0,  1818,     0,     0,
       0,  1809,  1145,     0,     0,     0,     0,     0,  1145,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1145,     0,
    1809,  1145,     0,  1145,     0,     0,     0,     0,     0,     0,
    3158,  1818,  1145,  1145,  1145,     0,     0,     0,  1145,     0,
       0,  1145,     0,     0,     0,  1809,     0,     0,     0,     0,
       0,  1145,     0,  1812,     0,     0,     0,     0,     0,  1145,
       0,  1145,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1476,     0,     0,     0,     0,  1809,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3202,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1145,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2680,     0,  2680,  2680,     0,     0,  1811,  1811,     0,
    1811,     0,     0,  3262,  1818,     0,  3265,     0,  3267,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1813,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3288,     0,  3290,     0,     0,     0,
    3293,  1811,     0,  1811,  3790,     0,     0,     0,     0,     0,
       0,     0,  1809,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2759,  2759,
    2759,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3816,     0,     0,     0,     0,  3823,     0,  3825,  3826,
    3827,  3828,  3340,     0,     0,     0,     0,     0,     0,     0,
       0,  1549,     0,     0,     0,     0,     0,     0,  1145,     0,
    2180,     0,  1811,     0,     0,  3355,     0,     0,     0,     0,
       0,     0,  2193,     0,     0,     0,  1818,     0,     0,     0,
    1812,     0,     0,     0,     0,  1812,  1812,     0,     0,  1811,
       0,     0,     0,     0,     0,     0,  1812,     0,     0,     0,
       0,     0,     0,  3886,  3888,  3890,     0,  3892,     0,     0,
       0,  1818,  1145,  1145,     0,     0,     0,     0,     0,     0,
    3381,     0,     0,  1811,  1809,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1145,     0,     0,     0,
    1811,  1145,     0,     0,  1145,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1811,     0,     0,     0,     0,  1809,
       0,     0,     0,     0,     0,     0,     0,  1811,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3392,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1145,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3961,
       0,     0,     0,     0,  1811,     0,     0,     0,     0,  1813,
       0,  1812,     0,     0,  1813,  1813,     0,     0,     0,     0,
       0,     0,     0,     0,  1145,  1813,     0,     0,     0,     0,
       0,  1145,  1145,     0,  1818,     0,     0,     0,     0,  1145,
    1145,     0,     0,     0,  1145,  1818,     0,     0,     0,     0,
    1145,  1145,     0,     0,  1145,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1145,     0,     0,     0,     0,
    1811,     0,  1812,     0,     0,     0,     0,  1145,     0,     0,
       0,     0,  1809,     0,     0,     0,     0,     0,     0,  1811,
       0,     0,     0,  1809,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1145,     0,     0,     0,     0,
       0,     0,     0,     0,  1811,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1818,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1818,     0,     0,     0,
    1813,     0,     0,     0,     0,     0,     0,     0,  1811,     0,
       0,     0,  2093,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1809,     0,     0,     0,     0,     0,
       0,     0,     0,  4062,  1809,  1812,     0,     0,     0,     0,
       0,     0,     0,     0,  4071,     0,     0,     0,     0,  2759,
       0,  1813,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2093,     0,     0,  1145,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3652,     0,
       0,     0,     0,     0,     0,     0,  1818,  3655,     0,     0,
       0,  1811,     0,  3656,     0,  3657,     0,  1145,     0,     0,
       0,  1145,     0,     0,  4123,     0,  1818,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3675,  3676,     0,
       0,     0,     0,     0,  1813,     0,  4142,     0,  1145,     0,
       0,     0,  1818,     0,     0,     0,  2685,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3701,     0,     0,  3704,
       0,  3706,  1145,  1145,  1809,     0,  1145,     0,     0,     0,
    3710,     0,     0,  1145,  1145,  4171,  3715,     0,     0,  3718,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3725,
    1809,     0,     0,     0,     0,     0,     0,  3737,     0,  2759,
    1145,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1818,     0,     0,
    1145,     0,     0,  1811,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1145,     0,  1811,     0,
       0,     0,     0,     0,     0,  1809,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1812,  1812,
       0,  1812,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1145,     0,  1818,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1812,     0,  1812,     0,     0,     0,     0,     0,
       0,     0,     0,  1145,  1818,     0,  1145,     0,  1145,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1809,     0,     0,     0,     0,     0,
       0,     0,  3392,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1145,     0,     0,  1818,
       0,  1811,  1809,  1818,  1818,     0,     0,     0,     0,     0,
       0,     0,  1811,  1812,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1813,  1813,     0,
    1813,     0,     0,     0,  2093,     0,  1145,     0,     0,     0,
    1812,     0,     0,     0,     0,     0,     0,  1809,     0,     0,
       0,  1809,  1809,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1818,     0,     0,     0,     0,     0,     0,     0,
       0,  1813,     0,  1813,  1812,     0,     0,     0,     0,     0,
    3936,  3937,  1145,     0,     0,     0,     0,     0,     0,     0,
       0,  1812,     0,  1811,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1811,     0,  1812,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1812,     0,
       0,     0,     0,     0,     0,  2093,  1145,     0,     0,     0,
       0,     0,     0,  1145,     0,     0,     0,     0,     0,     0,
       0,     0,  1813,     0,     0,     0,     0,     0,  2093,  1145,
    1145,     0,     0,  2664,     0,  1812,  3977,     0,     0,  1145,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1813,
       0,  4394,  2093,  2093,     0,  2093,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1145,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1145,     0,     0,  3993,
    3995,     0,     0,  1813,     0,     0,     0,     0,     0,     0,
       0,     0,  4002,  2093,     0,     0,     0,     0,  4007,  4008,
    1813,  1812,  4010,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2759,  1813,     0,     0,     0,     0,     0,
    1812,     0,     0,     0,     0,  2759,     0,  1813,     0,     0,
    1145,     0,     0,     0,     0,     0,     0,     0,     0,  1145,
       0,     0,     0,  1811,     0,  1812,  2093,     0,     0,     0,
       0,     0,     0,  4041,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1813,     0,     0,     0,     0,  1811,
       0,     0,     0,     0,     0,     0,  2093,     0,     0,  1812,
       0,     0,     0,     0,     0,     0,  2093,     0,     0,  2093,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1813,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1811,     0,     0,     0,     0,  1813,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1813,     0,  4111,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1813,     0,
       0,     0,  1812,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1811,     0,  4161,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1811,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4191,     0,     0,     0,     0,     0,
       0,     0,  4193,     0,     0,     0,  1811,     0,     0,     0,
    1811,  1811,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1812,     0,     0,     0,     0,     0,
       0,  1813,     0,     0,     0,     0,     0,     4,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     5,     0,  1812,
       0,     0,     0,     0,     0,     0,     0,     6,     7,     0,
       0,     0,     0,     0,     0,     9,    10,     0,     0,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,     0,     0,     0,    37,    38,    39,
      40,    41,    42,    43,    44,     0,     0,     0,    45,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1813,  2685,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    46,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1812,     0,     0,     0,     0,     0,  1813,     0,
       0,     0,     0,  1812,  4319,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2093,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4348,     0,     0,    47,     0,     0,
       0,  2093,     0,  2093,     0,  2664,  2664,  3238,     0,     0,
    2664,     0,    48,     0,  2093,     0,     0,     0,     0,     0,
       0,  2093,     0,     0,     0,     0,  2093,     0,     0,     0,
       0,  2093,    49,     0,  1812,     0,  2093,     0,     0,     0,
       0,     0,     0,     0,  1812,  2093,     0,     0,     0,  2664,
    2664,  2093,     0,     0,    50,     0,     0,     0,     0,     0,
       0,     0,     0,  2093,     0,     0,     0,     0,     0,     0,
    2093,  1813,  2093,  2093,  2093,  2093,  2093,  2093,  2093,  2093,
    2093,  2093,  1813,     0,     0,     0,     0,    51,     0,     0,
      52,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2093,     0,  4412,  4412,     0,
       0,    53,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4412,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4452,     0,     0,     0,     0,     0,
       0,     0,     0,  1813,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1813,     0,     0,     0,     0,     0,     0,
       0,     0,    54,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1812,     0,     0,     0,  4412,     0,
       0,  2093,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    55,     0,     0,     0,     0,     0,
    1812,     0,     0,     0,     0,     0,     0,    56,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      57,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    58,     0,     0,     0,     0,
       0,    59,     0,     0,     0,    60,    61,    62,    63,    64,
       0,     0,    65,    66,  1308,     0,     0,     0,     0,    71,
       0,     0,     0,     0,     0,  1812,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1813,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1813,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2093,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1812,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1812,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1813,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    85,     0,     0,     0,     0,     0,
      89,     0,     0,     0,    93,     0,    94,  1812,    96,    97,
       0,  1812,  1812,     0,     0,     0,     0,     0,     0,   106,
       0,     0,     0,  2093,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   119,   120,     0,     0,
       0,     0,     0,     0,  2093,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1813,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   128,     0,     0,     0,     0,     0,  2093,     0,
       0,  1813,   129,     0,   130,   131,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1078,  3238,
    3238,     0,  2664,     0,     0,  2664,  2664,  2664,  2664,  2664,
    2664,  2664,  2664,  2664,  2664,  3238,     0,     0,   141,     0,
     142,   143,     0,     0,     0,   145,  1813,   146,     0,     0,
    1813,  1813,     0,     0,     0,     0,     0,   148,  2093,   149,
       0,  2093,     0,  2093,     0,     0,     0,     0,  3238,  3238,
       0,     0,     0,     0,     0,     0,   152,     0,   153,     0,
       0,   156,  2664,  2664,  2093,     0,  2093,   157,     0,  2093,
       0,     0,     0,   158,     0,   159,     0,     0,     0,   160,
       0,     0,     0,     0,     0,   161,     0,     0,     0,     0,
       0,     0,   163,     0,   165,     0,     0,     0,     0,   167,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   171,     0,     0,  2093,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2093,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   176,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2093,     0,     0,
       0,     0,     0,     0,     0,   185,   186,     0,     0,     0,
       0,   187,     0,     0,     0,     0,     0,     0,     0,     0,
     188,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   193,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   204,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   206,     0,     0,     0,   207,     0,
     208,     0,     0,     0,     0,   209,     0,     0,     0,     0,
     210,     0,     0,   212,     0,     0,     0,   214,     0,     0,
       0,     0,     0,   215,     0,     0,     0,     0,     0,     0,
     216,     0,     0,   218,     0,     0,     0,     0,     0,     0,
     221,     0,     0,     0,     0,     0,     0,  2664,     0,     0,
       0,     0,     0,   223,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     228,     0,   229,     0,     0,     0,     0,     0,     0,   231,
       0,   232,     0,     0,   233,     0,     0,     0,   234,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     237,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   246,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2093,     0,
       0,  2093,  2093,  2093,     0,     0,  3238,     0,     0,     0,
       0,  3238,  3238,  3238,  3238,  3238,  3238,  3238,  3238,  3238,
    3238,  2093,  2093,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2093,  2664,  2664,
    2093,     0,  2093,     0,     0,     0,  2093,  3238,  3238,     0,
       0,  2093,     0,     0,  2093,     0,     0,     0,     0,     0,
       0,  2093,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2093,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    86,    87,    88,     0,
      90,    91,    92,     0,     0,     0,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,     0,     0,
       0,   107,   108,   109,   110,     0,   111,   112,   113,   114,
     115,     0,   116,   117,   118,     0,     0,     0,     0,     0,
     121,   122,     0,     0,     0,     0,   123,     0,     0,     0,
       0,     0,     0,     0,     0,   124,     0,   125,     0,   126,
       0,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,  3238,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   133,     0,     0,     0,   135,   136,
     137,   138,   139,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2093,  2093,   140,     0,     0,     0,     0,     0,
       0,   144,     0,     0,     0,     0,     0,     0,   147,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   150,     0,     0,     0,     0,     0,   151,     0,
       0,     0,     0,  2093,     0,     0,     0,  2664,   154,   155,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2093,
       0,  2093,     0,     0,     0,     0,  3238,  3238,  2093,     0,
       0,  2664,  2664,  2093,  2093,   162,  2093,     0,     0,     0,
       0,     0,   164,     0,     0,   166,     0,     0,     0,     0,
     168,     0,     0,     0,     0,     0,   169,     0,   170,     0,
       0,     0,     0,     0,   172,     0,     0,  2093,     0,     0,
       0,     0,     0,   173,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   174,   175,     0,     0,
       0,     0,     0,   177,     0,   178,     0,     0,   179,   180,
       0,   181,     0,     0,     0,     0,     0,     0,     0,   182,
     183,     0,   184,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   189,   190,   191,     0,     0,  2093,     0,     0,
       0,     0,   192,     0,     0,     0,     0,   194,     0,     0,
     195,     0,   196,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   197,   198,   199,   200,   201,
       0,     0,     0,     0,     0,     0,     0,     0,   202,     0,
     203,     0,     0,     0,     0,     0,     0,  2093,     0,     0,
       0,     0,   205,     0,     0,     0,     0,     0,     0,     0,
       0,  3238,  2664,     0,     0,     0,     0,     0,     0,     0,
     211,     0,     0,   213,     0,  3238,  3238,  2093,     0,  2093,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     217,     0,     0,   219,     0,   220,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   222,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,     0,     0,     0,   226,     0,   227,     0,     0,
       0,     0,     0,     0,     0,   230,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,     0,
       0,   236,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   238,   239,   240,   241,   242,
     243,   244,   245,     0,     0,     0,     0,     0,     0,     0,
       0,  3238,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2816,
       0,     0,     0,     0,     0,  2093,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2093,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   705,    86,    87,    88,   403,    90,
      91,    92,   404,     0,   405,    95,     0,     0,    98,    99,
     100,   101,   102,   103,   706,   104,   105,   406,   707,     0,
     107,   108,   109,   110,   708,   709,   112,   113,   114,   115,
       0,   116,   710,   711,   407,   408,     0,     0,  2093,   409,
     410,     0,     0,     0,     0,   411,     0,     0,     0,     0,
       0,     0,     0,     0,   412,     0,   413,     0,   414,   415,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,  2093,     0,
     417,   418,   419,   420,   421,   422,   423,   424,   712,   425,
     426,   427,   713,   714,   715,   716,   717,   718,   719,   428,
     429,   720,   430,   133,   431,   432,   433,   135,   136,   137,
     138,   139,   721,   434,   435,   436,   437,   438,   722,   723,
     439,   440,   724,   140,   442,   725,   443,   444,   445,   446,
     144,   726,   727,   447,   448,   449,   450,   147,   451,   728,
     729,   453,   454,   455,   456,   457,   458,   730,   459,   460,
     461,   150,   462,   731,   732,   733,   734,   151,   735,   736,
     737,   463,   464,   465,   466,   467,   468,   154,   155,   469,
     738,   470,   739,   471,   472,   473,   474,   475,   740,   476,
     477,   478,   741,   742,   479,   480,   481,   482,   483,   743,
     484,   485,   486,   744,   487,   488,   745,   489,   490,   491,
     492,   164,   493,   494,   166,   746,   495,   747,   496,   168,
     497,   748,   498,   749,   499,   169,   750,   170,   500,   501,
     502,   751,   503,   172,   752,   504,   753,   505,   506,   507,
     508,   509,   173,   510,   511,   512,   754,   513,   514,   515,
     516,   517,   518,   755,   519,   174,   175,   756,   520,   521,
     522,   757,   177,   758,   178,   759,   523,   179,   180,   524,
     181,   525,   526,   527,   528,   529,   530,   760,   182,   183,
     531,   184,   761,   532,   533,   534,   762,   763,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   189,   190,   191,   548,   549,   550,   551,   552,   553,
     554,   192,   555,   764,   556,   557,   194,   558,   765,   195,
     559,   196,   560,   561,   562,   766,   563,   767,   768,   564,
     565,   566,   769,   770,   197,   198,   199,   200,   201,   567,
     568,   569,   570,   571,   572,   771,   573,   202,   574,   203,
     575,   576,   577,   772,   578,   579,   580,   581,   582,   583,
     584,   205,   585,   586,   587,   773,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   774,   598,   599,   211,
     600,   601,   213,   602,   603,   604,   605,   606,   607,   608,
     609,   775,   610,   611,   612,   613,   614,   776,   615,   217,
     616,   617,   219,   618,   220,   777,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   222,   629,   778,   630,
     631,   779,   632,   633,   634,   635,   636,   637,   780,   224,
     225,   781,   782,   639,   226,   640,   227,   783,   641,   642,
     643,   644,   645,   646,   784,   785,   647,   648,   649,   650,
     786,   787,   651,   652,   653,   654,   788,   235,   789,   656,
     236,   657,   658,   659,   790,   791,   660,   792,   793,   661,
     662,   663,   664,   665,   238,   239,   240,   241,   242,   243,
     244,   245,   666,   667,   668,    85,     0,     0,    86,    87,
      88,    89,    90,    91,    92,    93,     0,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   932,   104,   105,
     106,     0,     0,   107,   108,   109,   110,     0,   111,   112,
     113,   114,   115,     0,   116,   117,   118,   119,   120,     0,
       0,     0,   121,   122,     0,     0,     0,     0,   123,     0,
       0,     0,     0,     0,     0,     0,     0,   124,     0,   125,
       0,   126,   127,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   128,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   129,     0,   130,   131,     0,     0,     0,
       0,     0,     0,     0,     0,   132,   133,     0,     0,   134,
     135,   136,   137,   138,   139,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   140,     0,     0,   141,
       0,   142,   143,   144,     0,     0,   145,     0,   146,     0,
     147,     0,     0,     0,     0,     0,     0,     0,   148,     0,
     149,     0,     0,     0,   150,     0,     0,     0,     0,     0,
     151,     0,     0,     0,     0,     0,     0,   152,     0,   153,
     154,   155,   156,     0,     0,     0,     0,     0,   157,     0,
       0,     0,     0,     0,   158,     0,   159,     0,     0,     0,
     160,     0,     0,     0,     0,     0,   161,   162,     0,     0,
       0,     0,     0,   163,   164,   165,     0,   166,     0,     0,
     167,     0,   168,     0,     0,     0,     0,     0,   169,     0,
     170,     0,     0,     0,   171,     0,   172,     0,     0,     0,
       0,     0,     0,     0,     0,   173,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   174,   175,
       0,     0,   176,     0,     0,   177,     0,   178,     0,     0,
     179,   180,     0,   181,     0,     0,     0,     0,     0,     0,
       0,   182,   183,     0,   184,     0,   185,   186,     0,     0,
       0,     0,   187,     0,     0,     0,     0,     0,     0,     0,
       0,   188,     0,     0,   189,   190,   191,     0,     0,     0,
       0,     0,     0,     0,   192,     0,     0,     0,   193,   194,
       0,     0,   195,     0,   196,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   197,   198,   199,
     200,   201,     0,     0,     0,     0,     0,     0,     0,     0,
     202,     0,   203,     0,   204,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   205,   206,     0,     0,     0,   207,
       0,   208,     0,     0,     0,     0,   209,     0,     0,     0,
       0,   210,   211,     0,   212,   213,     0,     0,   214,     0,
       0,     0,     0,     0,   215,     0,     0,     0,     0,     0,
       0,   216,   217,     0,   218,   219,     0,   220,     0,     0,
       0,   221,     0,     0,     0,     0,     0,     0,     0,   222,
       0,     0,     0,     0,   223,     0,     0,     0,     0,     0,
       0,     0,   224,   225,     0,     0,     0,   226,     0,   227,
       0,   228,     0,   229,     0,     0,     0,   230,     0,     0,
     231,     0,   232,     0,     0,   233,     0,     0,     0,   234,
     235,     0,     0,   236,     0,     0,     0,     0,     0,     0,
       0,   237,     0,     0,     0,     0,     0,   238,   239,   240,
     241,   242,   243,   244,   245,    86,    87,    88,     0,    90,
      91,    92,     0,     0,     0,    95,     0,     0,    98,    99,
     100,   101,   102,   103,   246,   104,   105,     0,  -124,     0,
     107,   108,   109,   110,     0,   111,   112,   113,   114,   115,
       0,   116,   117,   118,     0,     0,     0,     0,     0,   121,
     122,     0,     0,     0,     0,   123,     0,     0,     0,     0,
       0,     0,     0,     0,   124,     0,   125,     0,   126,     0,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   133,     0,     0,     0,   135,   136,   137,
     138,   139,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   140,     0,     0,     0,     0,     0,     0,
     144,     0,     0,     0,     0,     0,     0,   147,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   150,     0,     0,     0,     0,     0,   151,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   154,   155,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   162,     0,     0,     0,     0,     0,
       0,   164,     0,     0,   166,     0,     0,     0,     0,   168,
       0,     0,     0,     0,     0,   169,     0,   170,     0,     0,
       0,     0,     0,   172,     0,     0,     0,     0,     0,     0,
       0,     0,   173,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,     0,     0,     0,
       0,     0,   177,     0,   178,     0,     0,   179,   180,     0,
     181,     0,     0,     0,     0,     0,     0,     0,   182,   183,
       0,   184,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   189,   190,   191,     0,     0,     0,     0,     0,     0,
       0,   192,     0,     0,     0,     0,   194,     0,     0,   195,
       0,   196,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   197,   198,   199,   200,   201,     0,
       0,     0,     0,     0,     0,     0,     0,   202,     0,   203,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   205,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
       0,     0,   213,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   217,
       0,     0,   219,     0,   220,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   222,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   224,
     225,     0,     0,     0,   226,     0,   227,     0,     0,     0,
       0,     0,     0,     0,   230,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   235,     0,     0,
     236,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   238,   239,   240,   241,   242,   243,
     244,   245,     0,   705,    86,    87,    88,   403,    90,    91,
      92,   404,     0,   405,    95,     0,     0,    98,    99,   100,
     101,   102,   103,   706,   104,   105,   406,   707,  2818,   107,
     108,   109,   110,   708,   709,   112,   113,   114,   115,     0,
     116,   710,   711,   407,   408,     0,     0,     0,   409,   410,
       0,     0,     0,     0,   411,     0,     0,     0,     0,     0,
       0,     0,     0,   412,     0,   413,     0,   414,   415,    35,
     416,     0,     0,    37,    38,    39,    40,    41,    42,    43,
      44,  1397,  1398,  1399,    45,  1400,     0,     0,     0,   417,
     418,   419,   420,   421,   422,   423,   424,  2753,   425,   426,
     427,     0,     0,     0,     0,  1401,     0,     0,   428,   429,
       0,   430,   133,   431,   432,   433,   135,  1402,   137,  1403,
    1404,     0,   434,   435,   436,   437,   438,  1405,  1406,   439,
     440,  1407,  1408,   442,     0,   443,   444,   445,   446,  1409,
       0,     0,   447,   448,   449,   450,   147,   451,   452,     0,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     150,   462,     0,  1410,  1411,  1412,  1413,  1414,  1415,  1416,
     463,   464,   465,   466,   467,   468,  1417,  1418,   469,     0,
     470,     0,   471,   472,   473,   474,   475,     0,   476,   477,
     478,  2754,     0,   479,   480,  1419,   482,   483,     0,   484,
     485,   486,     0,   487,   488,     0,   489,   490,   491,   492,
    1420,   493,   494,  1421,  1422,   495,     0,   496,  1423,   497,
       0,   498,     0,   499,   169,     0,   170,   500,   501,   502,
       0,   503,  1424,     0,   504,     0,   505,   506,   507,   508,
     509,   173,   510,   511,   512,     0,   513,   514,   515,   516,
     517,   518,     0,   519,   174,   175,     0,   520,   521,   522,
    1425,  1426,     0,  1427,     0,   523,   179,   180,   524,   181,
     525,   526,   527,   528,   529,   530,     0,  1428,   183,   531,
     184,     0,   532,   533,   534,  1429,  1430,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
    1431,   190,  1432,   548,   549,   550,   551,   552,   553,   554,
     192,   555,  1433,   556,   557,   194,   558,  1434,  1435,   559,
    1436,   560,   561,   562,     0,   563,     0,     0,  1437,   565,
     566,     0,     0,   197,   198,   199,   200,  1438,   567,   568,
     569,   570,   571,   572,     0,   573,  1439,   574,   203,   575,
     576,   577,     0,   578,   579,   580,   581,   582,   583,   584,
    1440,   585,   586,   587,     0,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,     0,   598,   599,   211,   600,
     601,  1441,   602,   603,   604,   605,   606,   607,   608,   609,
       0,   610,   611,   612,   613,   614,  1442,   615,   217,   616,
     617,   219,   618,  1443,     0,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,  1444,   629,     0,   630,   631,
       0,   632,   633,   634,   635,   636,   637,     0,  1445,  1446,
       0,     0,   639,  1447,   640,  1448,  1449,   641,   642,   643,
     644,   645,   646,     0,  1450,   647,   648,   649,   650,  1451,
       0,   651,   652,   653,   654,   655,  1452,  2755,   656,   236,
     657,   658,   659,     0,     0,   660,     0,     0,   661,   662,
     663,   664,   665,   238,  1453,  1454,  1455,  1456,  1457,  1458,
    1459,   666,   667,   668,     0,     0,     0,     0,     0,     0,
       0,  1460,  1461,  2756,     0,     0,     0,     0,     0,     0,
    1463,  2757,   705,    86,    87,    88,   403,    90,    91,    92,
     404,     0,   405,    95,     0,     0,    98,    99,   100,   101,
     102,   103,   706,   104,   105,   406,   707,     0,   107,   108,
     109,   110,   708,   709,   112,   113,   114,   115,     0,   116,
     710,   711,   407,   408,     0,     0,     0,   409,   410,     0,
       0,     0,     0,   411,     0,     0,     0,     0,     0,     0,
       0,     0,   412,     0,   413,     0,   414,   415,    35,   416,
       0,     0,    37,    38,    39,    40,    41,    42,    43,    44,
    1397,  1398,  1399,    45,  1400,     0,     0,     0,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   427,
       0,     0,     0,     0,  1401,     0,     0,   428,   429,     0,
     430,   133,   431,   432,   433,   135,  1402,   137,  1403,  1404,
       0,   434,   435,   436,   437,   438,  1405,  1406,   439,   440,
    1407,  1408,   442,     0,   443,   444,   445,   446,  1409,     0,
       0,   447,   448,   449,   450,   147,   451,   452,     0,   453,
     454,   455,   456,   457,   458,     0,   459,   460,   461,   150,
     462,     0,  1410,  1411,  1412,  1413,  1414,  1415,  1416,   463,
     464,   465,   466,   467,   468,  1417,  1418,   469,     0,   470,
       0,   471,   472,   473,   474,   475,     0,   476,   477,   478,
       0,     0,   479,   480,  1419,   482,   483,     0,   484,   485,
     486,     0,   487,   488,     0,   489,   490,   491,   492,  1420,
     493,   494,  1421,  1422,   495,     0,   496,  1423,   497,     0,
     498,     0,   499,   169,     0,   170,   500,   501,   502,     0,
     503,  1424,     0,   504,     0,   505,   506,   507,   508,   509,
     173,   510,   511,   512,     0,   513,   514,   515,   516,   517,
     518,     0,   519,   174,   175,     0,   520,   521,   522,  1425,
    1426,     0,  1427,     0,   523,   179,   180,   524,   181,   525,
     526,   527,   528,   529,   530,     0,  1428,   183,   531,   184,
       0,   532,   533,   534,  1429,  1430,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,  1431,
     190,  1432,   548,   549,   550,   551,   552,   553,   554,   192,
     555,  1433,   556,   557,   194,   558,  1434,  1435,   559,  1436,
     560,   561,   562,     0,   563,     0,     0,  1437,   565,   566,
       0,     0,   197,   198,   199,   200,  1438,   567,   568,   569,
     570,   571,   572,     0,   573,  1439,   574,   203,   575,   576,
     577,     0,   578,   579,   580,   581,   582,   583,   584,  1440,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,     0,   598,   599,   211,   600,   601,
    1441,   602,   603,   604,   605,   606,   607,   608,   609,     0,
     610,   611,   612,   613,   614,  1442,   615,   217,   616,   617,
     219,   618,  1443,     0,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,  1444,   629,     0,   630,   631,     0,
     632,   633,   634,   635,   636,   637,     0,  1445,  1446,     0,
       0,   639,  1447,   640,  1448,  1449,   641,   642,   643,   644,
     645,   646,     0,  1450,   647,   648,   649,   650,  1451,     0,
     651,   652,   653,   654,   655,  1452,     0,   656,   236,   657,
     658,   659,     0,     0,   660,     0,     0,   661,   662,   663,
     664,   665,   238,  1453,  1454,  1455,  1456,  1457,  1458,  1459,
     666,   667,   668,     0,     0,     0,     0,     0,     0,     0,
    1460,  1461,     0,     0,     0,     0,     0,     0,     0,  1463,
    2666,   705,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,   706,   104,   105,   406,   707,     0,   107,   108,   109,
     110,   708,   709,   112,   113,   114,   115,     0,   116,   710,
     711,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
     133,   431,   432,   433,     0,  1784,   137,  1785,  1786,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,  1787,
    1788,   442,     0,   443,   444,   445,   446,     0,     0,     0,
     447,   448,   449,   450,   147,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   150,   462,
       0,     0,     0,     0,   151,     0,     0,     0,   463,   464,
     465,   466,   467,   468,  1789,  1790,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,  1419,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,     0,   493,
     494,     0,     0,   495,     0,   496,  1791,   497,     0,   498,
       0,   499,   169,     0,   170,   500,   501,   502,     0,   503,
       0,     0,   504,     0,   505,   506,   507,   508,   509,   173,
     510,   511,   512,  2302,   513,   514,   515,   516,   517,   518,
       0,   519,   174,  2303,     0,   520,   521,   522,  1425,  1792,
       0,  1793,     0,   523,   179,   180,   524,   181,   525,   526,
     527,   528,   529,   530,     0,     0,   183,   531,   184,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,  1794,   190,
    1795,   548,   549,   550,   551,   552,   553,   554,     0,   555,
       0,   556,   557,   194,   558,     0,     0,   559,  1796,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,  2304,   198,   199,   200,     0,   567,   568,   569,   570,
     571,   572,     0,   573,     0,   574,     0,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,  1797,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,   211,   600,   601,     0,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,  2305,   616,   617,   219,
     618,  1799,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,     0,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,  1800,  1801,     0,     0,
     639,     0,   640,     0,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,     0,  1802,  2306,   656,   236,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,     0,     0,     0,     0,     0,     0,     0,     0,   666,
     667,   668,     0,     0,     0,     0,   705,    86,    87,    88,
     403,    90,    91,    92,   404,     0,   405,    95,     0,  2307,
      98,    99,   100,   101,   102,   103,   706,   104,   105,   406,
     707,     0,   107,   108,   109,   110,   708,   709,   112,   113,
     114,   115,     0,   116,   710,   711,   407,   408,     0,     0,
       0,   409,   410,     0,     0,     0,     0,   411,     0,     0,
       0,     0,     0,     0,     0,     0,   412,     0,   413,     0,
     414,   415,    35,     0,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   427,     0,     0,     0,     0,     0,     0,
       0,   428,   429,     0,   430,   133,   431,   432,   433,     0,
    1784,   137,  1785,  1786,     0,   434,   435,   436,   437,   438,
       0,     0,   439,   440,  1787,  1788,   442,     0,   443,   444,
     445,   446,     0,     0,     0,   447,   448,   449,   450,   147,
     451,   452,     0,   453,   454,   455,   456,   457,   458,     0,
     459,   460,   461,   150,   462,     0,     0,     0,     0,   151,
       0,     0,     0,   463,   464,   465,   466,   467,   468,  1789,
    1790,   469,     0,   470,     0,   471,   472,   473,   474,   475,
       0,   476,   477,   478,     0,     0,   479,   480,  1419,   482,
     483,     0,   484,   485,   486,     0,   487,   488,     0,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,     0,
     496,  1791,   497,     0,   498,     0,   499,   169,     0,   170,
     500,   501,   502,     0,   503,     0,     0,   504,     0,   505,
     506,   507,   508,   509,   173,   510,   511,   512,  2302,   513,
     514,   515,   516,   517,   518,     0,   519,   174,  2303,     0,
     520,   521,   522,  1425,  1792,     0,  1793,     0,   523,   179,
     180,   524,   181,   525,   526,   527,   528,   529,   530,     0,
       0,   183,   531,   184,     0,   532,   533,   534,     0,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,  1794,   190,  1795,   548,   549,   550,   551,
     552,   553,   554,     0,   555,     0,   556,   557,   194,   558,
       0,     0,   559,  1796,   560,   561,   562,     0,   563,     0,
       0,   564,   565,   566,     0,     0,  2304,   198,   199,   200,
       0,   567,   568,   569,   570,   571,   572,     0,   573,     0,
     574,     0,   575,   576,   577,     0,   578,   579,   580,   581,
     582,   583,   584,  1797,   585,   586,   587,     0,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,     0,   598,
     599,   211,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,     0,   610,   611,   612,   613,   614,     0,
     615,  2305,   616,   617,   219,   618,  1799,     0,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,     0,   629,
       0,   630,   631,     0,   632,   633,   634,   635,   636,   637,
       0,  1800,  1801,     0,     0,   639,     0,   640,     0,     0,
     641,   642,   643,   644,   645,   646,     0,     0,   647,   648,
     649,   650,     0,     0,   651,   652,   653,   654,     0,  1802,
    2306,   656,   236,   657,   658,   659,     0,     0,   660,     0,
       0,   661,   662,   663,   664,   665,     0,     0,     0,     0,
       0,     0,     0,     0,   666,   667,   668,     0,     0,     0,
       0,     0,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,  3097,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,  4045,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,     0,     0,     0,     0,     0,   705,    86,    87,
      88,   403,    90,    91,    92,   404,  1531,   405,    95,     0,
    1532,    98,    99,   100,   101,   102,   103,   706,   104,   105,
     406,   707,     0,   107,   108,   109,   110,   708,   709,   112,
     113,   114,   115,     0,   116,   710,   711,   407,   408,     0,
       0,     0,   409,   410,     0,     0,     0,     0,   411,     0,
       0,     0,     0,     0,     0,     0,     0,   412,     0,   413,
       0,   414,   415,    35,   416,     0,     0,    37,    38,    39,
      40,    41,    42,    43,    44,  1397,  1398,  1399,    45,  1400,
       0,     0,     0,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   427,     0,     0,     0,     0,  1401,
       0,     0,   428,   429,     0,   430,   133,   431,   432,   433,
     135,  1402,   137,  1403,  1404,  2676,   434,   435,   436,   437,
     438,  1405,  1406,   439,   440,  1407,  1408,   442,     0,   443,
     444,   445,   446,  1409,     0,     0,   447,   448,   449,   450,
     147,   451,   452,     0,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   150,   462,     0,  1410,  1411,  1412,
    1413,  1414,  1415,  1416,   463,   464,   465,   466,   467,   468,
    1417,  1418,   469,     0,   470,     0,   471,   472,   473,   474,
     475,     0,   476,   477,   478,     0,     0,   479,   480,  1419,
     482,   483,     0,   484,   485,   486,     0,   487,   488,     0,
     489,   490,   491,   492,  1420,   493,   494,  1421,  1422,   495,
       0,   496,  1423,   497,     0,   498,     0,   499,   169,  2677,
     170,   500,   501,   502,     0,   503,  1424,     0,   504,     0,
     505,   506,   507,   508,   509,   173,   510,   511,   512,     0,
     513,   514,   515,   516,   517,   518,     0,   519,   174,   175,
       0,   520,   521,   522,  1425,  1426,     0,  1427,     0,   523,
     179,   180,   524,   181,   525,   526,   527,   528,   529,   530,
    2678,  1428,   183,   531,   184,     0,   532,   533,   534,  1429,
    1430,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,  1431,   190,  1432,   548,   549,   550,
     551,   552,   553,   554,   192,   555,  1433,   556,   557,   194,
     558,  1434,  1435,   559,  1436,   560,   561,   562,     0,   563,
       0,     0,  1437,   565,   566,     0,     0,   197,   198,   199,
     200,  1438,   567,   568,   569,   570,   571,   572,     0,   573,
    1439,   574,   203,   575,   576,   577,     0,   578,   579,   580,
     581,   582,   583,   584,  1440,   585,   586,   587,     0,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,     0,
     598,   599,   211,   600,   601,  1441,   602,   603,   604,   605,
     606,   607,   608,   609,     0,   610,   611,   612,   613,   614,
    1442,   615,   217,   616,   617,   219,   618,  1443,     0,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,  1444,
     629,     0,   630,   631,     0,   632,   633,   634,   635,   636,
     637,     0,  1445,  1446,     0,  2679,   639,  1447,   640,  1448,
    1449,   641,   642,   643,   644,   645,   646,     0,  1450,   647,
     648,   649,   650,  1451,     0,   651,   652,   653,   654,   655,
    1452,     0,   656,   236,   657,   658,   659,     0,     0,   660,
       0,     0,   661,   662,   663,   664,   665,   238,  1453,  1454,
    1455,  1456,  1457,  1458,  1459,   666,   667,   668,     0,     0,
       0,     0,     0,     0,     0,  1460,  1461,     0,     0,     0,
       0,     0,     0,     0,  1463,   705,    86,    87,    88,   403,
      90,    91,    92,   404,     0,   405,    95,     0,     0,    98,
      99,   100,   101,   102,   103,   706,   104,   105,   406,   707,
       0,   107,   108,   109,   110,   708,   709,   112,   113,   114,
     115,     0,   116,   710,   711,   407,   408,     0,     0,     0,
     409,   410,     0,     0,     0,     0,   411,     0,     0,     0,
       0,     0,     0,     0,     0,   412,     0,   413,     0,   414,
     415,    35,   416,     0,     0,    37,    38,    39,    40,    41,
      42,    43,    44,  1397,  1398,  1399,    45,  1400,     0,     0,
       0,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   427,     0,     0,     0,     0,  1401,     0,     0,
     428,   429,     0,   430,   133,   431,   432,   433,   135,  1402,
     137,  1403,  1404,     0,   434,   435,   436,   437,   438,  1405,
    1406,   439,   440,  1407,  1408,   442,     0,   443,   444,   445,
     446,  1409,     0,     0,   447,   448,   449,   450,   147,   451,
     452,     0,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   150,   462,     0,  1410,  1411,  1412,  1413,  1414,
    1415,  1416,   463,   464,   465,   466,   467,   468,  1417,  1418,
     469,     0,   470,     0,   471,   472,   473,   474,   475,     0,
     476,   477,   478,     0,     0,   479,   480,  1419,   482,   483,
       0,   484,   485,   486,     0,   487,   488,     0,   489,   490,
     491,   492,  1420,   493,   494,  1421,  1422,   495,     0,   496,
    1423,   497,     0,   498,     0,   499,   169,     0,   170,   500,
     501,   502,     0,   503,  1424,     0,   504,     0,   505,   506,
     507,   508,   509,   173,   510,   511,   512,     0,   513,   514,
     515,   516,   517,   518,     0,   519,   174,   175,     0,   520,
     521,   522,  1425,  1426,     0,  1427,     0,   523,   179,   180,
     524,   181,   525,   526,   527,   528,   529,   530,     0,  1428,
     183,   531,   184,     0,   532,   533,   534,  1429,  1430,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,  1431,   190,  1432,   548,   549,   550,   551,   552,
     553,   554,   192,   555,  1433,   556,   557,   194,   558,  1434,
    1435,   559,  1436,   560,   561,   562,     0,   563,     0,     0,
    1437,   565,   566,     0,     0,   197,   198,   199,   200,  1438,
     567,   568,   569,   570,   571,   572,     0,   573,  1439,   574,
     203,   575,   576,   577,     0,   578,   579,   580,   581,   582,
     583,   584,  1440,   585,   586,   587,     0,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,     0,   598,   599,
     211,   600,   601,  1441,   602,   603,   604,   605,   606,   607,
     608,   609,   215,   610,   611,   612,   613,   614,  1442,   615,
     217,   616,   617,   219,   618,  1443,     0,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,  1444,   629,     0,
     630,   631,   223,   632,   633,   634,   635,   636,   637,     0,
    1445,  1446,     0,     0,   639,  1447,   640,  1448,  1449,   641,
     642,   643,   644,   645,   646,     0,  1450,   647,   648,   649,
     650,  1451,     0,   651,   652,   653,   654,  1324,  1452,     0,
     656,   236,   657,   658,   659,     0,     0,   660,     0,   237,
     661,   662,   663,   664,   665,   238,  1453,  1454,  1455,  1456,
    1457,  1458,  1459,   666,   667,   668,     0,     0,     0,     0,
       0,     0,     0,  1460,  1461,     0,     0,     0,     0,     0,
       0,     0,  1463,   705,    86,    87,    88,   403,    90,    91,
      92,   404,     0,   405,    95,     0,     0,    98,    99,   100,
     101,   102,   103,   706,   104,   105,   406,   707,     0,   107,
     108,   109,   110,   708,   709,   112,   113,   114,   115,     0,
     116,   710,   711,   407,   408,     0,     0,     0,   409,   410,
       0,     0,     0,     0,   411,     0,     0,     0,     0,     0,
       0,     0,     0,   412,     0,   413,     0,   414,   415,    35,
     416,     0,     0,    37,    38,    39,    40,    41,    42,    43,
      44,  1397,  1398,  1399,    45,  1400,     0,     0,     0,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     427,     0,     0,     0,     0,  1401,     0,     0,   428,   429,
       0,   430,   133,   431,   432,   433,   135,  1402,   137,  1403,
    1404,     0,   434,   435,   436,   437,   438,  1405,  1406,   439,
     440,  1407,  1408,   442,     0,   443,   444,   445,   446,  1409,
       0,     0,   447,   448,   449,   450,   147,   451,   452,     0,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     150,   462,     0,  1410,  1411,  1412,  1413,  1414,  1415,  1416,
     463,   464,   465,   466,   467,   468,  1417,  1418,   469,     0,
     470,     0,   471,   472,   473,   474,   475,     0,   476,   477,
     478,     0,     0,   479,   480,  1419,   482,   483,     0,   484,
     485,   486,     0,   487,   488,     0,   489,   490,   491,   492,
    1420,   493,   494,  1421,  1422,   495,     0,   496,  1423,   497,
       0,   498,     0,   499,   169,     0,   170,   500,   501,   502,
       0,   503,  1424,     0,   504,     0,   505,   506,   507,   508,
     509,   173,   510,   511,   512,     0,   513,   514,   515,   516,
     517,   518,     0,   519,   174,   175,     0,   520,   521,   522,
    1425,  1426,     0,  1427,     0,   523,   179,   180,   524,   181,
     525,   526,   527,   528,   529,   530,     0,  1428,   183,   531,
     184,     0,   532,   533,   534,  1429,  1430,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
    1431,   190,  1432,   548,   549,   550,   551,   552,   553,   554,
     192,   555,  1433,   556,   557,   194,   558,  1434,  1435,   559,
    1436,   560,   561,   562,     0,   563,     0,     0,  1437,   565,
     566,     0,     0,   197,   198,   199,   200,  1438,   567,   568,
     569,   570,   571,   572,     0,   573,  1439,   574,   203,   575,
     576,   577,     0,   578,   579,   580,   581,   582,   583,   584,
    1440,   585,   586,   587,     0,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,     0,   598,   599,   211,   600,
     601,  1441,   602,   603,   604,   605,   606,   607,   608,   609,
       0,   610,   611,   612,   613,   614,  1442,   615,   217,   616,
     617,   219,   618,  1443,     0,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,  1444,   629,     0,   630,   631,
       0,   632,   633,   634,   635,   636,   637,     0,  1445,  1446,
       0,     0,   639,  1447,   640,  1448,  1449,   641,   642,   643,
     644,   645,   646,     0,  1450,   647,   648,   649,   650,  1451,
       0,   651,   652,   653,   654,   655,  1452,     0,   656,   236,
     657,   658,   659,     0,     0,   660,     0,     0,   661,   662,
     663,   664,   665,   238,  1453,  1454,  1455,  1456,  1457,  1458,
    1459,   666,   667,   668,     0,     0,     0,     0,     0,     0,
       0,  1460,  1461,     0,     0,     0,     0,     0,  2004,  2625,
    1463,   705,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,   706,   104,   105,   406,   707,     0,   107,   108,   109,
     110,   708,   709,   112,   113,   114,   115,     0,   116,   710,
     711,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,   416,     0,
       0,    37,    38,    39,    40,    41,    42,    43,    44,  1397,
    1398,  1399,    45,  1400,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,  1401,     0,     0,   428,   429,     0,   430,
     133,   431,   432,   433,   135,  1402,   137,  1403,  1404,     0,
     434,   435,   436,   437,   438,  1405,  1406,   439,   440,  1407,
    1408,   442,     0,   443,   444,   445,   446,  1409,     0,     0,
     447,   448,   449,   450,   147,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   150,   462,
       0,  1410,  1411,  1412,  1413,  1414,  1415,  1416,   463,   464,
     465,   466,   467,   468,  1417,  1418,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,  1419,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,  1420,   493,
     494,  1421,  1422,   495,     0,   496,  1423,   497,     0,   498,
       0,   499,   169,     0,   170,   500,   501,   502,     0,   503,
    1424,     0,   504,     0,   505,   506,   507,   508,   509,   173,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,   174,   175,     0,   520,   521,   522,  1425,  1426,
       0,  1427,     0,   523,   179,   180,   524,   181,   525,   526,
     527,   528,   529,   530,     0,  1428,   183,   531,   184,     0,
     532,   533,   534,  1429,  1430,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,  1431,   190,
    1432,   548,   549,   550,   551,   552,   553,   554,   192,   555,
    1433,   556,   557,   194,   558,  1434,  1435,   559,  1436,   560,
     561,   562,     0,   563,     0,     0,  1437,   565,   566,     0,
       0,   197,   198,   199,   200,  1438,   567,   568,   569,   570,
     571,   572,     0,   573,  1439,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,  1440,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,   211,   600,   601,  1441,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,  1442,   615,   217,   616,   617,   219,
     618,  1443,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,  1444,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,  1445,  1446,     0,     0,
     639,  1447,   640,  1448,  1449,   641,   642,   643,   644,   645,
     646,     0,  1450,   647,   648,   649,   650,  1451,     0,   651,
     652,   653,   654,   655,  1452,     0,   656,   236,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,  1453,  1454,  1455,  1456,  1457,  1458,  1459,   666,
     667,   668,     0,     0,     0,     0,     0,     0,     0,  1460,
    1461,  1462,     0,     0,     0,     0,     0,     0,  1463,   705,
      86,    87,    88,   403,    90,    91,    92,   404,     0,   405,
      95,     0,     0,    98,    99,   100,   101,   102,   103,   706,
     104,   105,   406,   707,     0,   107,   108,   109,   110,   708,
     709,   112,   113,   114,   115,     0,   116,   710,   711,   407,
     408,     0,     0,     0,   409,   410,     0,     0,     0,     0,
     411,     0,     0,     0,     0,     0,     0,     0,     0,   412,
       0,   413,     0,   414,   415,    35,   416,     0,     0,    37,
      38,    39,    40,    41,    42,    43,    44,  1397,  1398,  1399,
      45,  1400,     0,     0,     0,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   427,     0,     0,     0,
       0,  1401,     0,     0,   428,   429,     0,   430,   133,   431,
     432,   433,   135,  1402,   137,  1403,  1404,     0,   434,   435,
     436,   437,   438,  1405,  1406,   439,   440,  1407,  1408,   442,
       0,   443,   444,   445,   446,  1409,     0,     0,   447,   448,
     449,   450,   147,   451,   452,     0,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   150,   462,     0,  1410,
    1411,  1412,  1413,  1414,  1415,  1416,   463,   464,   465,   466,
     467,   468,  1417,  1418,   469,  1548,   470,     0,   471,   472,
     473,   474,   475,     0,   476,   477,   478,     0,     0,   479,
     480,  1419,   482,   483,     0,   484,   485,   486,     0,   487,
     488,     0,   489,   490,   491,   492,  1420,   493,   494,  1421,
    1422,   495,     0,   496,  1423,   497,     0,   498,     0,   499,
     169,     0,   170,   500,   501,   502,     0,   503,  1424,     0,
     504,     0,   505,   506,   507,   508,   509,   173,   510,   511,
     512,     0,   513,   514,   515,   516,   517,   518,     0,   519,
     174,   175,     0,   520,   521,   522,  1425,  1426,     0,  1427,
       0,   523,   179,   180,   524,   181,   525,   526,   527,   528,
     529,   530,     0,  1428,   183,   531,   184,     0,   532,   533,
     534,  1429,  1430,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,  1431,   190,  1432,   548,
     549,   550,   551,   552,   553,   554,   192,   555,  1433,   556,
     557,   194,   558,  1434,  1435,   559,  1436,   560,   561,   562,
       0,   563,     0,     0,  1437,   565,   566,     0,     0,   197,
     198,   199,   200,  1438,   567,   568,   569,   570,   571,   572,
       0,   573,  1439,   574,   203,   575,   576,   577,     0,   578,
     579,   580,   581,   582,   583,   584,  1440,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,     0,   598,   599,   211,   600,   601,  1441,   602,   603,
     604,   605,   606,   607,   608,   609,     0,   610,   611,   612,
     613,   614,  1442,   615,   217,   616,   617,   219,   618,  1443,
       0,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,  1444,   629,     0,   630,   631,     0,   632,   633,   634,
     635,   636,   637,     0,  1445,  1446,     0,     0,   639,  1447,
     640,  1448,  1449,   641,   642,   643,   644,   645,   646,     0,
    1450,   647,   648,   649,   650,  1451,     0,   651,   652,   653,
     654,   655,  1452,     0,   656,   236,   657,   658,   659,     0,
       0,   660,     0,     0,   661,   662,   663,   664,   665,   238,
    1453,  1454,  1455,  1456,  1457,  1458,  1459,   666,   667,   668,
       0,     0,     0,     0,     0,     0,     0,  1460,  1461,     0,
       0,     0,     0,     0,     0,     0,  1463,   705,    86,    87,
      88,   403,    90,    91,    92,   404,     0,   405,    95,     0,
       0,    98,    99,   100,   101,   102,   103,   706,   104,   105,
     406,   707,     0,   107,   108,   109,   110,   708,   709,   112,
     113,   114,   115,     0,   116,   710,   711,   407,   408,     0,
       0,     0,   409,   410,     0,     0,     0,     0,   411,     0,
       0,     0,     0,     0,     0,     0,     0,   412,     0,   413,
       0,   414,   415,    35,   416,     0,     0,    37,    38,    39,
      40,    41,    42,    43,    44,  1397,  1398,  1399,    45,  1400,
       0,     0,     0,   417,   418,   419,   420,   421,   422,   423,
     424,  2188,   425,   426,   427,     0,     0,     0,     0,  1401,
       0,     0,   428,   429,     0,   430,   133,   431,   432,   433,
     135,  1402,   137,  1403,  1404,     0,   434,   435,   436,   437,
     438,  1405,  1406,   439,   440,  1407,  1408,   442,     0,   443,
     444,   445,   446,  1409,     0,     0,   447,   448,   449,   450,
     147,   451,   452,     0,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   150,   462,     0,  1410,  1411,  1412,
    1413,  1414,  1415,  1416,   463,   464,   465,   466,   467,   468,
    1417,  1418,   469,     0,   470,     0,   471,   472,   473,   474,
     475,     0,   476,   477,   478,     0,     0,   479,   480,  1419,
     482,   483,     0,   484,   485,   486,     0,   487,   488,     0,
     489,   490,   491,   492,  1420,   493,   494,  1421,  1422,   495,
       0,   496,  1423,   497,     0,   498,     0,   499,   169,     0,
     170,   500,   501,   502,     0,   503,  1424,     0,   504,     0,
     505,   506,   507,   508,   509,   173,   510,   511,   512,     0,
     513,   514,   515,   516,   517,   518,     0,   519,   174,   175,
       0,   520,   521,   522,  1425,  1426,     0,  1427,     0,   523,
     179,   180,   524,   181,   525,   526,   527,   528,   529,   530,
       0,  1428,   183,   531,   184,     0,   532,   533,   534,  1429,
    1430,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,  1431,   190,  1432,   548,   549,   550,
     551,   552,   553,   554,   192,   555,  1433,   556,   557,   194,
     558,  1434,  1435,   559,  1436,   560,   561,   562,     0,   563,
       0,     0,  1437,   565,   566,     0,     0,   197,   198,   199,
     200,  1438,   567,   568,   569,   570,   571,   572,     0,   573,
    1439,   574,   203,   575,   576,   577,     0,   578,   579,   580,
     581,   582,   583,   584,  1440,   585,   586,   587,     0,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,     0,
     598,   599,   211,   600,   601,  1441,   602,   603,   604,   605,
     606,   607,   608,   609,     0,   610,   611,   612,   613,   614,
    1442,   615,   217,   616,   617,   219,   618,  1443,     0,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,  1444,
     629,     0,   630,   631,     0,   632,   633,   634,   635,   636,
     637,     0,  1445,  1446,     0,     0,   639,  1447,   640,  1448,
    1449,   641,   642,   643,   644,   645,   646,     0,  1450,   647,
     648,   649,   650,  1451,     0,   651,   652,   653,   654,   655,
    1452,     0,   656,   236,   657,   658,   659,     0,     0,   660,
       0,     0,   661,   662,   663,   664,   665,   238,  1453,  1454,
    1455,  1456,  1457,  1458,  1459,   666,   667,   668,     0,     0,
       0,     0,     0,     0,     0,  1460,  1461,     0,     0,     0,
       0,     0,     0,     0,  1463,   705,    86,    87,    88,   403,
      90,    91,    92,   404,     0,   405,    95,     0,     0,    98,
      99,   100,   101,   102,   103,   706,   104,   105,   406,   707,
       0,   107,   108,   109,   110,   708,   709,   112,   113,   114,
     115,     0,   116,   710,   711,   407,   408,     0,     0,     0,
     409,   410,     0,     0,     0,     0,   411,     0,     0,     0,
       0,     0,     0,     0,     0,   412,     0,   413,     0,   414,
     415,    35,   416,     0,     0,    37,    38,    39,    40,    41,
      42,    43,    44,  1397,  1398,  1399,    45,  1400,     0,     0,
       0,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   427,     0,     0,     0,     0,  1401,     0,     0,
     428,   429,     0,   430,   133,   431,   432,   433,   135,  1402,
     137,  1403,  1404,     0,   434,   435,   436,   437,   438,  1405,
    1406,   439,   440,  1407,  1408,   442,     0,   443,   444,   445,
     446,  1409,     0,     0,   447,   448,   449,   450,   147,   451,
     452,     0,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   150,   462,  3136,  1410,  1411,  1412,  1413,  1414,
    1415,  1416,   463,   464,   465,   466,   467,   468,  1417,  1418,
     469,     0,   470,     0,   471,   472,   473,   474,   475,     0,
     476,   477,   478,     0,     0,   479,   480,  1419,   482,   483,
       0,   484,   485,   486,     0,   487,   488,     0,   489,   490,
     491,   492,  1420,   493,   494,  1421,  1422,   495,     0,   496,
    1423,   497,     0,   498,     0,   499,   169,     0,   170,   500,
     501,   502,     0,   503,  1424,     0,   504,     0,   505,   506,
     507,   508,   509,   173,   510,   511,   512,     0,   513,   514,
     515,   516,   517,   518,     0,   519,   174,   175,     0,   520,
     521,   522,  1425,  1426,     0,  1427,     0,   523,   179,   180,
     524,   181,   525,   526,   527,   528,   529,   530,     0,  1428,
     183,   531,   184,     0,   532,   533,   534,  1429,  1430,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,  1431,   190,  1432,   548,   549,   550,   551,   552,
     553,   554,   192,   555,  1433,   556,   557,   194,   558,  1434,
    1435,   559,  1436,   560,   561,   562,     0,   563,     0,     0,
    1437,   565,   566,     0,     0,   197,   198,   199,   200,  1438,
     567,   568,   569,   570,   571,   572,     0,   573,  1439,   574,
     203,   575,   576,   577,     0,   578,   579,   580,   581,   582,
     583,   584,  1440,   585,   586,   587,     0,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,     0,   598,   599,
     211,   600,   601,  1441,   602,   603,   604,   605,   606,   607,
     608,   609,     0,   610,   611,   612,   613,   614,  1442,   615,
     217,   616,   617,   219,   618,  1443,     0,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,  1444,   629,     0,
     630,   631,     0,   632,   633,   634,   635,   636,   637,     0,
    1445,  1446,     0,     0,   639,  1447,   640,  1448,  1449,   641,
     642,   643,   644,   645,   646,     0,  1450,   647,   648,   649,
     650,  1451,     0,   651,   652,   653,   654,   655,  1452,     0,
     656,   236,   657,   658,   659,     0,     0,   660,     0,     0,
     661,   662,   663,   664,   665,   238,  1453,  1454,  1455,  1456,
    1457,  1458,  1459,   666,   667,   668,     0,     0,     0,     0,
       0,     0,     0,  1460,  1461,     0,     0,     0,     0,     0,
       0,     0,  1463,   705,    86,    87,    88,   403,    90,    91,
      92,   404,     0,   405,    95,     0,     0,    98,    99,   100,
     101,   102,   103,   706,   104,   105,   406,   707,     0,   107,
     108,   109,   110,   708,   709,   112,   113,   114,   115,     0,
     116,   710,   711,   407,   408,     0,     0,     0,   409,   410,
       0,     0,     0,     0,   411,     0,     0,     0,     0,     0,
       0,     0,     0,   412,     0,   413,     0,   414,   415,    35,
     416,     0,     0,    37,    38,    39,    40,    41,    42,    43,
      44,  1397,  1398,  1399,    45,  1400,     0,     0,     0,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     427,     0,     0,     0,     0,  1401,     0,     0,   428,   429,
       0,   430,   133,   431,   432,   433,   135,  1402,   137,  1403,
    1404,     0,   434,   435,   436,   437,   438,  1405,  1406,   439,
     440,  1407,  1408,   442,     0,   443,   444,   445,   446,  1409,
       0,     0,   447,   448,   449,   450,   147,   451,   452,     0,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     150,   462,     0,  1410,  1411,  1412,  1413,  1414,  1415,  1416,
     463,   464,   465,   466,   467,   468,  1417,  1418,   469,     0,
     470,     0,   471,   472,   473,   474,   475,     0,   476,   477,
     478,     0,     0,   479,   480,  1419,   482,   483,     0,   484,
     485,   486,     0,   487,   488,     0,   489,   490,   491,   492,
    1420,   493,   494,  1421,  1422,   495,     0,   496,  1423,   497,
       0,   498,     0,   499,   169,  2677,   170,   500,   501,   502,
       0,   503,  1424,     0,   504,     0,   505,   506,   507,   508,
     509,   173,   510,   511,   512,     0,   513,   514,   515,   516,
     517,   518,     0,   519,   174,   175,     0,   520,   521,   522,
    1425,  1426,     0,  1427,     0,   523,   179,   180,   524,   181,
     525,   526,   527,   528,   529,   530,     0,  1428,   183,   531,
     184,     0,   532,   533,   534,  1429,  1430,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
    1431,   190,  1432,   548,   549,   550,   551,   552,   553,   554,
     192,   555,  1433,   556,   557,   194,   558,  1434,  1435,   559,
    1436,   560,   561,   562,     0,   563,     0,     0,  1437,   565,
     566,     0,     0,   197,   198,   199,   200,  1438,   567,   568,
     569,   570,   571,   572,     0,   573,  1439,   574,   203,   575,
     576,   577,     0,   578,   579,   580,   581,   582,   583,   584,
    1440,   585,   586,   587,     0,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,     0,   598,   599,   211,   600,
     601,  1441,   602,   603,   604,   605,   606,   607,   608,   609,
       0,   610,   611,   612,   613,   614,  1442,   615,   217,   616,
     617,   219,   618,  1443,     0,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,  1444,   629,     0,   630,   631,
       0,   632,   633,   634,   635,   636,   637,     0,  1445,  1446,
       0,     0,   639,  1447,   640,  1448,  1449,   641,   642,   643,
     644,   645,   646,     0,  1450,   647,   648,   649,   650,  1451,
       0,   651,   652,   653,   654,   655,  1452,     0,   656,   236,
     657,   658,   659,     0,     0,   660,     0,     0,   661,   662,
     663,   664,   665,   238,  1453,  1454,  1455,  1456,  1457,  1458,
    1459,   666,   667,   668,     0,     0,     0,     0,     0,     0,
       0,  1460,  1461,     0,     0,     0,     0,     0,     0,     0,
    1463,   705,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,   706,   104,   105,   406,   707,     0,   107,   108,   109,
     110,   708,   709,   112,   113,   114,   115,     0,   116,   710,
     711,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,   416,     0,
       0,    37,    38,    39,    40,    41,    42,    43,    44,  1397,
    1398,  1399,    45,  1400,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,  1401,     0,     0,   428,   429,     0,   430,
     133,   431,   432,   433,   135,  1402,   137,  1403,  1404,     0,
     434,   435,   436,   437,   438,  1405,  1406,   439,   440,  1407,
    1408,   442,     0,   443,   444,   445,   446,  1409,     0,     0,
     447,   448,   449,   450,   147,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   150,   462,
       0,  1410,  1411,  1412,  1413,  1414,  1415,  1416,   463,   464,
     465,   466,   467,   468,  1417,  1418,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,  1419,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,  1420,   493,
     494,  1421,  1422,   495,     0,   496,  1423,   497,     0,   498,
       0,   499,   169,     0,   170,   500,   501,   502,     0,   503,
    1424,     0,   504,     0,   505,   506,   507,   508,   509,   173,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,   174,   175,     0,   520,   521,   522,  1425,  1426,
       0,  1427,     0,   523,   179,   180,   524,   181,   525,   526,
     527,   528,   529,   530,     0,  1428,   183,   531,   184,     0,
     532,   533,   534,  1429,  1430,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,  1431,   190,
    1432,   548,   549,   550,   551,   552,   553,   554,   192,   555,
    1433,   556,   557,   194,   558,  1434,  1435,   559,  1436,   560,
     561,   562,     0,   563,     0,     0,  1437,   565,   566,     0,
       0,   197,   198,   199,   200,  1438,   567,   568,   569,   570,
     571,   572,     0,   573,  1439,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,  1440,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,   211,   600,   601,  1441,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,  1442,   615,   217,   616,   617,   219,
     618,  1443,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,  1444,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,  1445,  1446,     0,     0,
     639,  1447,   640,  1448,  1449,   641,   642,   643,   644,   645,
     646,     0,  1450,   647,   648,   649,   650,  1451,     0,   651,
     652,   653,   654,   655,  1452,  3740,   656,   236,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,  1453,  1454,  1455,  1456,  1457,  1458,  1459,   666,
     667,   668,     0,     0,     0,     0,     0,     0,     0,  1460,
    1461,     0,     0,     0,     0,     0,     0,     0,  1463,   705,
      86,    87,    88,   403,    90,    91,    92,   404,     0,   405,
      95,     0,     0,    98,    99,   100,   101,   102,   103,   706,
     104,   105,   406,   707,     0,   107,   108,   109,   110,   708,
     709,   112,   113,   114,   115,     0,   116,   710,   711,   407,
     408,     0,     0,     0,   409,   410,     0,     0,     0,     0,
     411,     0,     0,     0,     0,     0,     0,     0,     0,   412,
       0,   413,     0,   414,   415,    35,   416,     0,     0,    37,
      38,    39,    40,    41,    42,    43,    44,  1397,  1398,  1399,
      45,  1400,     0,     0,     0,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   427,     0,     0,     0,
       0,  1401,     0,     0,   428,   429,     0,   430,   133,   431,
     432,   433,  4409,  1402,   137,  1403,  1404,     0,   434,   435,
     436,   437,   438,  1405,  1406,   439,   440,  1407,  1408,   442,
       0,   443,   444,   445,   446,  1409,     0,     0,   447,   448,
     449,   450,   147,   451,   452,     0,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   150,   462,  4410,  1410,
    1411,  1412,  1413,  1414,  1415,  1416,   463,   464,   465,   466,
     467,   468,  1417,  1418,   469,     0,   470,     0,   471,   472,
     473,   474,   475,     0,   476,   477,   478,     0,     0,   479,
     480,  1419,   482,   483,     0,   484,   485,   486,     0,   487,
     488,     0,   489,   490,   491,   492,  1420,   493,   494,  1421,
    1422,   495,     0,   496,  1423,   497,     0,   498,     0,   499,
     169,     0,   170,   500,   501,   502,     0,   503,  1424,     0,
     504,     0,   505,   506,   507,   508,   509,   173,   510,   511,
     512,     0,   513,   514,   515,   516,   517,   518,     0,   519,
     174,   175,     0,   520,   521,   522,  1425,  1426,     0,  1427,
       0,   523,   179,   180,   524,   181,   525,   526,   527,   528,
     529,   530,     0,  1428,   183,   531,   184,     0,   532,   533,
     534,  1429,  1430,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,  1431,   190,  1432,   548,
     549,   550,   551,   552,   553,   554,   192,   555,  1433,   556,
     557,   194,   558,  1434,  1435,   559,  1436,   560,   561,   562,
       0,   563,     0,     0,  1437,   565,   566,     0,     0,   197,
     198,   199,   200,  1438,   567,   568,   569,   570,   571,   572,
       0,   573,  1439,   574,   203,   575,   576,   577,     0,   578,
     579,   580,   581,   582,   583,   584,  1440,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,     0,   598,   599,   211,   600,   601,  1441,   602,   603,
     604,   605,   606,   607,   608,   609,     0,   610,   611,   612,
     613,   614,  1442,   615,   217,   616,   617,   219,   618,  1443,
       0,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,  1444,   629,     0,   630,   631,     0,   632,   633,   634,
     635,   636,   637,     0,  1445,  1446,     0,     0,   639,  1447,
     640,  1448,  1449,   641,   642,   643,  4411,   645,   646,     0,
    1450,   647,   648,   649,   650,  1451,     0,   651,   652,   653,
     654,   655,  1452,     0,   656,   236,   657,   658,   659,     0,
       0,   660,     0,     0,   661,   662,   663,   664,   665,   238,
    1453,  1454,  1455,  1456,  1457,  1458,  1459,   666,   667,   668,
       0,     0,     0,     0,     0,     0,     0,  1460,  1461,     0,
       0,     0,     0,     0,     0,     0,  1463,   705,    86,    87,
      88,   403,    90,    91,    92,   404,     0,   405,    95,     0,
       0,    98,    99,   100,   101,   102,   103,   706,   104,   105,
     406,   707,     0,   107,   108,   109,   110,   708,   709,   112,
     113,   114,   115,     0,   116,   710,   711,   407,   408,     0,
       0,     0,   409,   410,     0,     0,     0,     0,   411,     0,
       0,     0,     0,     0,     0,     0,     0,   412,     0,   413,
       0,   414,   415,    35,   416,     0,     0,    37,    38,    39,
      40,    41,    42,    43,    44,  1397,  1398,  1399,    45,  1400,
       0,     0,     0,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   427,     0,     0,     0,     0,  1401,
       0,     0,   428,   429,     0,   430,   133,   431,   432,   433,
     135,  1402,   137,  1403,  1404,     0,   434,   435,   436,   437,
     438,  1405,  1406,   439,   440,  1407,  1408,   442,     0,   443,
     444,   445,   446,  1409,     0,     0,   447,   448,   449,   450,
     147,   451,   452,     0,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   150,   462,  4410,  1410,  1411,  1412,
    1413,  1414,  1415,  1416,   463,   464,   465,   466,   467,   468,
    1417,  1418,   469,     0,   470,     0,   471,   472,   473,   474,
     475,     0,   476,   477,   478,     0,     0,   479,   480,  1419,
     482,   483,     0,   484,   485,   486,     0,   487,   488,     0,
     489,   490,   491,   492,  1420,   493,   494,  1421,  1422,   495,
       0,   496,  1423,   497,     0,   498,     0,   499,   169,     0,
     170,   500,   501,   502,     0,   503,  1424,     0,   504,     0,
     505,   506,   507,   508,   509,   173,   510,   511,   512,     0,
     513,   514,   515,   516,   517,   518,     0,   519,   174,   175,
       0,   520,   521,   522,  1425,  1426,     0,  1427,     0,   523,
     179,   180,   524,   181,   525,   526,   527,   528,   529,   530,
       0,  1428,   183,   531,   184,     0,   532,   533,   534,  1429,
    1430,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,  1431,   190,  1432,   548,   549,   550,
     551,   552,   553,   554,   192,   555,  1433,   556,   557,   194,
     558,  1434,  1435,   559,  1436,   560,   561,   562,     0,   563,
       0,     0,  1437,   565,   566,     0,     0,   197,   198,   199,
     200,  1438,   567,   568,   569,   570,   571,   572,     0,   573,
    1439,   574,   203,   575,   576,   577,     0,   578,   579,   580,
     581,   582,   583,   584,  1440,   585,   586,   587,     0,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,     0,
     598,   599,   211,   600,   601,  1441,   602,   603,   604,   605,
     606,   607,   608,   609,     0,   610,   611,   612,   613,   614,
    1442,   615,   217,   616,   617,   219,   618,  1443,     0,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,  1444,
     629,     0,   630,   631,     0,   632,   633,   634,   635,   636,
     637,     0,  1445,  1446,     0,     0,   639,  1447,   640,  1448,
    1449,   641,   642,   643,  4411,   645,   646,     0,  1450,   647,
     648,   649,   650,  1451,     0,   651,   652,   653,   654,   655,
    1452,     0,   656,   236,   657,   658,   659,     0,     0,   660,
       0,     0,   661,   662,   663,   664,   665,   238,  1453,  1454,
    1455,  1456,  1457,  1458,  1459,   666,   667,   668,     0,     0,
       0,     0,     0,     0,     0,  1460,  1461,     0,     0,     0,
       0,     0,     0,     0,  1463,   705,    86,    87,    88,   403,
      90,    91,    92,   404,     0,   405,    95,     0,     0,    98,
      99,   100,   101,   102,   103,   706,   104,   105,   406,   707,
       0,   107,   108,   109,   110,   708,   709,   112,   113,   114,
     115,     0,   116,   710,   711,   407,   408,     0,     0,     0,
     409,   410,     0,     0,     0,     0,   411,     0,     0,     0,
       0,     0,     0,     0,     0,   412,     0,   413,     0,   414,
     415,    35,   416,     0,     0,    37,    38,    39,    40,    41,
      42,    43,    44,  1397,  1398,  1399,    45,  1400,     0,     0,
       0,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   427,     0,     0,     0,     0,  1401,     0,     0,
     428,   429,     0,   430,   133,   431,   432,   433,   135,  1402,
     137,  1403,  1404,     0,   434,   435,   436,   437,   438,  1405,
    1406,   439,   440,  1407,  1408,   442,     0,   443,   444,   445,
     446,  1409,     0,     0,   447,   448,   449,   450,   147,   451,
     452,     0,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   150,   462,     0,  1410,  1411,  1412,  1413,  1414,
    1415,  1416,   463,   464,   465,   466,   467,   468,  1417,  1418,
     469,     0,   470,     0,   471,   472,   473,   474,   475,     0,
     476,   477,   478,     0,     0,   479,   480,  1419,   482,   483,
       0,   484,   485,   486,     0,   487,   488,     0,   489,   490,
     491,   492,  1420,   493,   494,  1421,  1422,   495,     0,   496,
    1423,   497,     0,   498,     0,   499,   169,     0,   170,   500,
     501,   502,     0,   503,  1424,     0,   504,     0,   505,   506,
     507,   508,   509,   173,   510,   511,   512,     0,   513,   514,
     515,   516,   517,   518,     0,   519,   174,   175,     0,   520,
     521,   522,  1425,  1426,     0,  1427,     0,   523,   179,   180,
     524,   181,   525,   526,   527,   528,   529,   530,     0,  1428,
     183,   531,   184,     0,   532,   533,   534,  1429,  1430,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,  1431,   190,  1432,   548,   549,   550,   551,   552,
     553,   554,   192,   555,  1433,   556,   557,   194,   558,  1434,
    1435,   559,  1436,   560,   561,   562,     0,   563,     0,     0,
    1437,   565,   566,     0,     0,   197,   198,   199,   200,  1438,
     567,   568,   569,   570,   571,   572,     0,   573,  1439,   574,
     203,   575,   576,   577,     0,   578,   579,   580,   581,   582,
     583,   584,  1440,   585,   586,   587,     0,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,     0,   598,   599,
     211,   600,   601,  1441,   602,   603,   604,   605,   606,   607,
     608,   609,     0,   610,   611,   612,   613,   614,  1442,   615,
     217,   616,   617,   219,   618,  1443,     0,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,  1444,   629,     0,
     630,   631,     0,   632,   633,   634,   635,   636,   637,     0,
    1445,  1446,     0,     0,   639,  1447,   640,  1448,  1449,   641,
     642,   643,   644,   645,   646,     0,  1450,   647,   648,   649,
     650,  1451,     0,   651,   652,   653,   654,   655,  1452,     0,
     656,   236,   657,   658,   659,     0,     0,   660,     0,     0,
     661,   662,   663,   664,   665,   238,  1453,  1454,  1455,  1456,
    1457,  1458,  1459,   666,   667,   668,     0,     0,     0,     0,
       0,     0,     0,  1460,  1461,     0,     0,     0,     0,     0,
       0,     0,  1463,   705,    86,    87,    88,   403,    90,    91,
      92,   404,     0,   405,    95,     0,     0,    98,    99,   100,
     101,   102,   103,   706,   104,   105,   406,   707,     0,   107,
     108,   109,   110,   708,   709,   112,   113,   114,   115,     0,
     116,   710,   711,   407,   408,     0,     0,     0,   409,   410,
       0,     0,     0,     0,   411,     0,     0,     0,     0,     0,
       0,     0,     0,   412,     0,   413,     0,   414,   415,    35,
     416,     0,     0,    37,    38,    39,    40,    41,    42,    43,
      44,  1397,  1398,  1399,    45,  1400,     0,     0,     0,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     427,     0,     0,     0,     0,  1401,     0,     0,   428,   429,
       0,   430,   133,   431,   432,   433,   135,  1402,   137,  1403,
    1404,     0,   434,   435,   436,   437,   438,  1405,  1406,   439,
     440,  1407,  1408,   442,     0,   443,   444,   445,   446,  1409,
       0,     0,   447,   448,   449,   450,   147,   451,   452,     0,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     150,   462,     0,  1410,  1411,  1412,  1413,  1414,  1415,  1416,
     463,   464,   465,   466,   467,   468,  1417,  1418,   469,     0,
     470,     0,   471,   472,   473,   474,   475,     0,   476,   477,
     478,     0,     0,   479,   480,  1419,   482,   483,     0,   484,
     485,   486,     0,   487,   488,     0,   489,   490,   491,   492,
    1420,   493,   494,  1421,  1422,   495,     0,   496,  1423,   497,
       0,   498,     0,   499,   169,     0,   170,   500,   501,   502,
       0,   503,  1424,     0,   504,     0,   505,   506,   507,   508,
     509,   173,   510,   511,   512,     0,   513,   514,   515,   516,
     517,   518,     0,   519,   174,   175,     0,   520,   521,   522,
    1425,  1426,     0,  1427,     0,   523,   179,   180,   524,   181,
     525,   526,   527,   528,   529,   530,     0,  1428,   183,   531,
     184,     0,   532,   533,   534,  1429,  1430,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
    1431,   190,  1432,   548,   549,   550,   551,   552,   553,   554,
     192,   555,  1433,   556,   557,   194,   558,  1434,  1435,   559,
    1436,   560,   561,   562,     0,   563,     0,     0,  1437,   565,
     566,     0,     0,   197,   198,   199,   200,  1438,   567,   568,
     569,   570,   571,   572,     0,   573,  1439,   574,   203,   575,
     576,   577,     0,   578,   579,   580,   581,   582,   583,   584,
    1440,   585,   586,   587,     0,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,     0,   598,   599,   211,   600,
     601,  1441,   602,   603,   604,   605,   606,   607,   608,   609,
       0,   610,   611,   612,   613,   614,  1442,   615,   217,   616,
     617,   219,   618,  1443,     0,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,  1444,   629,     0,   630,   631,
       0,   632,   633,   634,   635,   636,   637,     0,  1445,  1446,
       0,     0,   639,  1447,   640,  1448,  1449,   641,   642,   643,
     644,   645,   646,     0,  1450,   647,   648,   649,   650,  1451,
       0,   651,   652,   653,   654,   655,  1452,     0,   656,   236,
     657,   658,   659,     0,     0,   660,     0,     0,   661,   662,
     663,   664,   665,  3987,  1453,  1454,  1455,  1456,  1457,  1458,
    1459,   666,   667,   668,     0,     0,     0,     0,     0,     0,
       0,  1460,  1461,     0,     0,     0,     0,     0,     0,     0,
    1463,   705,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,   706,   104,   105,   406,   707,     0,   107,   108,   109,
     110,   708,   709,   112,   113,   114,   115,     0,   116,   710,
     711,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,   416,     0,
       0,    37,    38,    39,    40,    41,    42,    43,    44,  1397,
    1398,  1399,    45,  1400,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,  1401,     0,     0,   428,   429,     0,   430,
     133,   431,   432,   433,   135,  1402,   137,  1403,  1404,     0,
     434,   435,   436,   437,   438,  1405,  1406,   439,   440,  1407,
    1408,   442,     0,   443,   444,   445,   446,  1409,     0,     0,
     447,   448,   449,   450,   147,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   150,   462,
       0,  1410,  1411,  1412,  1413,  1414,  1415,  1416,   463,   464,
     465,   466,   467,   468,  1417,  1418,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,  1419,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,  1420,   493,
     494,  1421,  1422,   495,     0,   496,  1423,   497,     0,   498,
       0,   499,   169,     0,   170,   500,   501,   502,     0,   503,
    1424,     0,   504,     0,   505,   506,   507,   508,   509,   173,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,   174,   175,     0,   520,   521,   522,  1425,  1426,
       0,  1427,     0,   523,   179,   180,   524,   181,   525,   526,
     527,   528,   529,   530,     0,  1428,   183,   531,   184,     0,
     532,   533,   534,  1429,  1430,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,  1431,   190,
    1432,   548,  3994,   550,   551,   552,   553,   554,   192,   555,
    1433,   556,   557,   194,   558,  1434,  1435,   559,  1436,   560,
     561,   562,     0,   563,     0,     0,  1437,   565,   566,     0,
       0,   197,   198,   199,   200,  1438,   567,   568,   569,   570,
     571,   572,     0,   573,  1439,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,  1440,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,   211,   600,   601,  1441,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,  1442,   615,   217,   616,   617,   219,
     618,  1443,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,  1444,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,  1445,  1446,     0,     0,
     639,  1447,   640,  1448,  1449,   641,   642,   643,   644,   645,
     646,     0,  1450,   647,   648,   649,   650,  1451,     0,   651,
     652,   653,   654,   655,  1452,     0,   656,   236,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,  1453,  1454,  1455,  1456,  1457,  1458,  1459,   666,
     667,   668,     0,     0,     0,     0,     0,     0,     0,  1460,
    1461,     0,     0,     0,     0,     0,     0,     0,  1463,   705,
      86,    87,    88,   403,    90,    91,    92,   404,     0,   405,
      95,     0,     0,    98,    99,   100,   101,   102,   103,   706,
     104,   105,   406,   707,     0,   107,   108,   109,   110,   708,
     709,   112,   113,   114,   115,     0,   116,   710,   711,   407,
     408,     0,     0,     0,   409,   410,     0,     0,     0,     0,
     411,     0,     0,     0,     0,     0,     0,     0,     0,   412,
       0,   413,     0,   414,   415,    35,   416,     0,     0,    37,
      38,    39,    40,    41,    42,    43,    44,  1397,  1398,  1399,
      45,  1400,     0,     0,     0,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   427,     0,     0,     0,
       0,  1401,     0,     0,   428,   429,     0,   430,   133,   431,
     432,   433,   135,  1402,   137,  1403,  1404,     0,   434,   435,
     436,   437,   438,  1405,  1406,   439,   440,  1407,  1408,   442,
       0,   443,   444,   445,   446,  1409,     0,     0,   447,   448,
     449,   450,   147,   451,   452,     0,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   150,   462,     0,  1410,
    1411,  1412,  1413,  1414,  1415,  1416,   463,   464,   465,   466,
     467,   468,  1417,  1418,   469,     0,   470,     0,   471,   472,
     473,   474,   475,     0,   476,   477,   478,     0,     0,   479,
     480,  1419,   482,   483,     0,   484,   485,   486,     0,   487,
     488,     0,   489,   490,   491,   492,  1420,   493,   494,  1421,
    1422,   495,     0,   496,  1423,   497,     0,   498,     0,   499,
     169,     0,   170,   500,   501,   502,     0,   503,  1424,     0,
     504,     0,   505,   506,   507,   508,   509,   173,   510,   511,
     512,     0,   513,   514,   515,   516,   517,   518,     0,   519,
     174,   175,     0,   520,   521,   522,  1425,  1426,     0,  1427,
       0,   523,   179,   180,   524,   181,   525,   526,   527,   528,
     529,   530,     0,  1428,   183,   531,   184,     0,   532,   533,
     534,  1429,  1430,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,  1431,   190,  1432,   548,
     549,   550,   551,   552,   553,   554,   192,   555,     0,   556,
     557,   194,   558,  1434,  1435,   559,  1436,   560,   561,   562,
       0,   563,     0,     0,  1437,   565,   566,     0,     0,   197,
     198,   199,   200,  1438,   567,   568,   569,   570,   571,   572,
       0,   573,  1439,   574,   203,   575,   576,   577,     0,   578,
     579,   580,   581,   582,   583,   584,  1440,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,     0,   598,   599,   211,   600,   601,  1441,   602,   603,
     604,   605,   606,   607,   608,   609,     0,   610,   611,   612,
     613,   614,  1442,   615,   217,   616,   617,   219,   618,  1443,
       0,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,  1444,   629,     0,   630,   631,     0,   632,   633,   634,
     635,   636,   637,     0,  1445,  1446,     0,     0,   639,  1447,
     640,  1448,  1449,   641,   642,   643,   644,   645,   646,     0,
       0,   647,   648,   649,   650,  1451,     0,   651,   652,   653,
     654,   655,  1452,     0,   656,   236,   657,   658,   659,     0,
       0,   660,     0,     0,   661,   662,   663,   664,   665,   238,
    1453,  1454,  1455,  1456,  1457,  1458,  1459,   666,   667,   668,
       0,     0,     0,     0,     0,     0,     0,  2659,  2660,     0,
       0,     0,     0,     0,     0,     0,  1463,   705,    86,    87,
      88,   403,    90,    91,    92,   404,     0,   405,    95,     0,
       0,    98,    99,   100,   101,   102,   103,   706,   104,   105,
     406,   707,     0,   107,   108,   109,   110,   708,   709,   112,
     113,   114,   115,     0,   116,   710,   711,   407,   408,     0,
       0,     0,   409,   410,     0,     0,     0,     0,   411,     0,
       0,     0,     0,     0,     0,     0,     0,   412,     0,   413,
       0,   414,   415,    35,   416,     0,     0,    37,    38,    39,
      40,    41,    42,    43,    44,  1397,  1398,  1399,    45,  1400,
       0,     0,     0,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   427,     0,     0,     0,     0,  1401,
       0,     0,   428,   429,     0,   430,   133,   431,   432,   433,
   -2403,  1402,   137,  1403,  1404,     0,   434,   435,   436,   437,
     438,  1405,  1406,   439,   440,  1407,  1408,   442,     0,   443,
     444,   445,   446,  1409,     0,     0,   447,   448,   449,   450,
     147,   451,   452,     0,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   150,   462,  4410,  1410,  1411,  1412,
    1413,  1414,  1415,  1416,   463,   464,   465,   466,   467,   468,
    1417,  1418,   469,     0,   470,     0,   471,   472,   473,   474,
     475,     0,   476,   477,   478,     0,     0,   479,   480,  1419,
     482,   483,     0,   484,   485,   486,     0,   487,   488,     0,
     489,   490,   491,   492,  1420,   493,   494,  1421,  1422,   495,
       0,   496,  1423,   497,     0,   498,     0,   499,   169,     0,
     170,   500,   501,   502,     0,   503,  1424,     0,   504,     0,
     505,   506,   507,   508,   509,     0,   510,   511,   512,     0,
     513,   514,   515,   516,   517,   518,     0,   519,   174,   175,
       0,   520,   521,   522,  1425,  1426,     0,  1427,     0,   523,
     179,   180,   524,   181,   525,   526,   527,   528,   529,   530,
       0,  1428,   183,   531,     0,     0,   532,   533,   534,  1429,
    1430,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,  1431,   190,  1432,   548,   549,   550,
     551,   552,   553,   554,   192,   555,     0,   556,   557,   194,
     558,  1434,  1435,   559,  1436,   560,   561,   562,     0,   563,
       0,     0,  1437,   565,   566,     0,     0,   197,   198,   199,
     200,  1438,   567,   568,   569,   570,   571,   572,     0,   573,
    1439,   574,   203,   575,   576,   577,     0,   578,   579,   580,
     581,   582,   583,   584,  1440,   585,   586,   587,     0,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,     0,
     598,   599,   211,   600,   601,  1441,   602,   603,   604,   605,
     606,   607,   608,   609,     0,   610,   611,   612,   613,   614,
    1442,   615,   217,   616,   617,     0,   618,  1443,     0,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,  1444,
     629,     0,   630,   631,     0,   632,   633,   634,   635,   636,
     637,     0,  1445,  1446,     0,     0,   639,  1447,   640,  1448,
    1449,   641,   642,   643,  4411,   645,   646,     0,  1450,   647,
     648,   649,   650,  1451,     0,   651,   652,   653,   654,   655,
    1452,     0,   656,   236,   657,   658,   659,     0,     0,   660,
       0,     0,   661,   662,   663,   664,   665,   238,  1453,  1454,
    1455,  1456,  1457,  1458,  1459,   666,   667,   668,     0,     0,
       0,     0,     0,     0,     0,  1460,  1461,     0,     0,     0,
       0,     0,     0,     0,  1463,   705,    86,    87,    88,   403,
      90,    91,    92,   404,     0,   405,    95,     0,     0,    98,
      99,   100,   101,   102,   103,   706,   104,   105,   406,   707,
       0,   107,   108,   109,   110,   708,   709,   112,   113,   114,
     115,     0,   116,   710,   711,   407,   408,     0,     0,     0,
     409,   410,     0,     0,     0,     0,   411,     0,     0,     0,
       0,     0,     0,     0,     0,   412,     0,   413,     0,   414,
     415,    35,   416,     0,     0,    37,    38,    39,    40,    41,
      42,    43,    44,  1397,  1398,  1399,    45,  1400,     0,     0,
       0,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   427,     0,     0,     0,     0,  1401,     0,     0,
     428,   429,     0,   430,   133,   431,   432,   433,     0,  1402,
     137,  1403,  1404,     0,   434,   435,   436,   437,   438,  1405,
    1406,   439,   440,  1407,  1408,   442,     0,   443,   444,   445,
     446,  1409,     0,     0,   447,   448,   449,   450,   147,   451,
     452,     0,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   150,   462,     0,  1410,  1411,  1412,  1413,  1414,
    1415,  1416,   463,   464,   465,   466,   467,   468,  1417,  1418,
     469,     0,   470,     0,   471,   472,   473,   474,   475,     0,
     476,   477,   478,     0,     0,   479,   480,  1419,   482,   483,
       0,   484,   485,   486,     0,   487,     0,     0,   489,   490,
     491,   492,  1420,   493,   494,  1421,  1422,   495,     0,   496,
    1423,   497,     0,   498,     0,   499,   169,     0,   170,   500,
     501,   502,     0,   503,  1424,     0,   504,     0,   505,   506,
     507,   508,   509,     0,   510,   511,   512,     0,   513,   514,
     515,   516,   517,   518,     0,   519,   174,   175,     0,   520,
     521,   522,  1425,  1426,     0,  1427,     0,   523,   179,   180,
     524,   181,   525,   526,   527,   528,   529,   530,     0,  1428,
     183,   531,     0,     0,   532,   533,   534,  1429,  1430,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,  1431,   190,  1432,   548,   549,   550,   551,   552,
     553,   554,   192,   555,     0,   556,   557,   194,   558,  1434,
    1435,   559,  1436,   560,   561,   562,     0,   563,     0,     0,
    1437,   565,   566,     0,     0,   197,   198,   199,   200,  1438,
     567,   568,   569,   570,   571,   572,     0,   573,  1439,   574,
     203,   575,   576,   577,     0,   578,   579,   580,   581,   582,
     583,   584,  1440,   585,   586,   587,     0,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,     0,   598,   599,
     211,   600,   601,  1441,   602,   603,   604,   605,   606,   607,
     608,   609,     0,   610,   611,   612,   613,   614,  1442,   615,
     217,   616,   617,     0,   618,  1443,     0,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,  1444,   629,     0,
     630,   631,     0,   632,   633,   634,   635,   636,   637,     0,
    1445,  1446,     0,     0,   639,  1447,   640,  1448,  1449,   641,
     642,   643,   644,   645,   646,     0,  1450,   647,   648,   649,
     650,  1451,     0,   651,   652,   653,   654,   655,  1452,     0,
     656,   236,   657,   658,   659,     0,     0,   660,     0,     0,
     661,   662,   663,   664,   665,   238,  1453,  1454,  1455,  1456,
    1457,  1458,  1459,   666,   667,   668,     0,     0,     0,     0,
       0,     0,     0,  1460,  1461,     0,     0,     0,     0,     0,
       0,     0,  1463,   705,    86,    87,    88,   403,    90,    91,
      92,   404,     0,   405,    95,     0,     0,    98,    99,   100,
     101,   102,   103,   706,   104,   105,   406,   707,     0,   107,
     108,   109,   110,   708,   709,   112,   113,   114,   115,     0,
     116,   710,   711,   407,   408,     0,     0,     0,   409,   410,
       0,     0,     0,     0,   411,     0,     0,     0,     0,     0,
       0,     0,     0,   412,     0,   413,     0,   414,   415,    35,
     416,     0,     0,    37,    38,    39,    40,    41,    42,    43,
      44,  1397,  1398,  1399,    45,  1400,     0,     0,     0,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     427,     0,     0,     0,     0,  1401,     0,     0,   428,   429,
       0,   430,   133,   431,   432,   433,     0,  1402,   137,  1403,
    1404,     0,   434,   435,   436,   437,   438,  1405,  1406,   439,
     440,  1407,  1408,   442,     0,   443,   444,   445,   446,  1409,
       0,     0,   447,   448,   449,   450,   147,   451,   452,     0,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     150,   462,     0,  1410,  1411,  1412,  1413,  1414,  1415,  1416,
     463,   464,   465,   466,   467,   468,  1417,  1418,   469,     0,
     470,     0,   471,   472,   473,   474,   475,     0,   476,   477,
     478,     0,     0,   479,   480,  1419,   482,   483,     0,   484,
     485,   486,     0,   487,     0,     0,   489,   490,   491,   492,
    1420,   493,   494,  1421,  1422,   495,     0,   496,  1423,   497,
       0,   498,     0,   499,   169,     0,   170,   500,   501,   502,
       0,   503,  1424,     0,   504,     0,   505,   506,   507,   508,
     509,     0,   510,   511,   512,     0,   513,   514,   515,   516,
     517,   518,     0,   519,   174,   175,     0,   520,   521,   522,
    1425,  1426,     0,  1427,     0,   523,   179,   180,   524,   181,
     525,   526,   527,   528,   529,   530,     0,  1428,   183,   531,
       0,     0,   532,   533,   534,  1429,  1430,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
    1431,   190,  1432,   548,   549,   550,   551,   552,   553,   554,
     192,   555,     0,   556,   557,   194,   558,  1434,  1435,   559,
    1436,   560,   561,   562,     0,   563,     0,     0,  1437,   565,
     566,     0,     0,   197,   198,   199,   200,  1438,   567,   568,
     569,   570,   571,   572,     0,   573,  1439,   574,   203,   575,
     576,   577,     0,   578,   579,   580,   581,   582,   583,   584,
    1440,   585,   586,   587,     0,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,     0,   598,   599,   211,   600,
     601,  1441,   602,   603,   604,   605,   606,   607,   608,   609,
       0,   610,   611,   612,   613,   614,  1442,   615,   217,   616,
     617,     0,   618,  1443,     0,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,  1444,   629,     0,   630,   631,
       0,   632,   633,   634,   635,   636,   637,     0,  1445,  1446,
       0,     0,   639,  1447,   640,  1448,  1449,   641,   642,   643,
     644,   645,   646,     0,     0,   647,   648,   649,   650,  1451,
       0,   651,   652,   653,   654,   655,  1452,     0,   656,   236,
     657,   658,   659,     0,     0,   660,     0,     0,   661,   662,
     663,   664,   665,   238,  1453,  1454,  1455,  1456,  1457,  1458,
    1459,   666,   667,   668,     0,     0,     0,     0,     0,     0,
       0,  2659,  2660,     0,     0,     0,     0,     0,     0,     0,
    1463,   705,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,   706,   104,   105,   406,   707,     0,   107,   108,   109,
     110,   708,   709,   112,   113,   114,   115,     0,   116,   710,
     711,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
     133,   431,   432,   433,   135,   136,   137,   138,   139,     0,
     434,   435,   436,   437,   438,     0,  1406,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,  1409,     0,     0,
     447,   448,   449,   450,   147,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   150,   462,
       0,  1410,  1411,  1412,  1413,  1414,  1415,  1416,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,  1421,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,   169,     0,   170,   500,   501,   502,     0,   503,
    1424,     0,   504,     0,   505,   506,   507,   508,   509,   173,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,   174,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,   179,   180,   524,   181,   525,   526,
     527,   528,   529,   530,     0,  1428,   183,   531,   184,     0,
     532,   533,   534,  1429,  1430,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,   190,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,   194,   558,     0,  1435,   559,   196,   560,
     561,   562,     0,   563,     0,  1044,   564,   565,   566,     0,
       0,   197,   198,   199,   200,  1438,   567,   568,   569,   570,
     571,   572,     0,   573,  1439,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,   211,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,   215,   610,
     611,   612,   613,   614,  1442,   615,   217,   616,   617,   219,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,  1444,   629,     0,   630,   631,   223,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,  1447,   640,  1448,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,  1451,     0,   651,
     652,   653,   654,  1324,   235,     0,   656,   236,   657,   658,
     659,     0,     0,   660,     0,   237,   661,   662,   663,   664,
     665,   238,  1453,  1454,  1455,  1456,  1457,  1458,  1459,   666,
     667,   668,     0,     0,     0,   705,    86,    87,    88,   403,
      90,    91,    92,   404,     0,   405,    95,     0,  2508,    98,
      99,   100,   101,   102,   103,   706,   104,   105,   406,   707,
       0,   107,   108,   109,   110,   708,   709,   112,   113,   114,
     115,     0,   116,   710,   711,   407,   408,     0,     0,     0,
     409,   410,     0,     0,     0,     0,   411,     0,     0,     0,
       0,     0,     0,     0,     0,   412,     0,   413,     0,   414,
     415,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   427,     0,     0,     0,     0,     0,     0,     0,
     428,   429,     0,   430,   133,   431,   432,   433,   135,   136,
     137,   138,   139,     0,   434,   435,   436,   437,   438,     0,
    1406,   439,   440,   441,   140,   442,     0,   443,   444,   445,
     446,  1409,     0,     0,   447,   448,   449,   450,   147,   451,
     452,     0,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   150,   462,     0,  1410,  1411,  1412,  1413,  1414,
    1415,  1416,   463,   464,   465,   466,   467,   468,   154,   155,
     469,     0,   470,     0,   471,   472,   473,   474,   475,     0,
     476,   477,   478,     0,     0,   479,   480,   481,   482,   483,
       0,   484,   485,   486,     0,   487,   488,     0,   489,   490,
     491,   492,   164,   493,   494,  1421,     0,   495,     0,   496,
     168,   497,     0,   498,     0,   499,   169,     0,   170,   500,
     501,   502,     0,   503,  1424,     0,   504,     0,   505,   506,
     507,   508,   509,   173,   510,   511,   512,     0,   513,   514,
     515,   516,   517,   518,     0,   519,   174,   175,     0,   520,
     521,   522,     0,   177,     0,   178,     0,   523,   179,   180,
     524,   181,   525,   526,   527,   528,   529,   530,     0,  1428,
     183,   531,   184,     0,   532,   533,   534,  1429,  1430,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   189,   190,   191,   548,   549,   550,   551,   552,
     553,   554,   192,   555,     0,   556,   557,   194,   558,     0,
    1435,   559,   196,   560,   561,   562,     0,   563,     0,  1044,
     564,   565,   566,     0,     0,   197,   198,   199,   200,  1438,
     567,   568,   569,   570,   571,   572,     0,   573,  1439,   574,
     203,   575,   576,   577,     0,   578,   579,   580,   581,   582,
     583,   584,   205,   585,   586,   587,     0,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,     0,   598,   599,
     211,   600,   601,   213,   602,   603,   604,   605,   606,   607,
     608,   609,     0,   610,   611,   612,   613,   614,  1442,   615,
     217,   616,   617,   219,   618,   220,     0,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,  1444,   629,     0,
     630,   631,     0,   632,   633,   634,   635,   636,   637,     0,
     224,   225,     0,     0,   639,  1447,   640,  1448,     0,   641,
     642,   643,   644,   645,   646,     0,     0,   647,   648,   649,
     650,  1451,     0,   651,   652,   653,   654,   655,   235,     0,
     656,   236,   657,   658,   659,     0,     0,   660,     0,     0,
     661,   662,   663,   664,   665,   238,  1453,  1454,  1455,  1456,
    1457,  1458,  1459,   666,   667,   668,     0,     0,     0,   705,
      86,    87,    88,   403,    90,    91,    92,   404,     0,   405,
      95,     0,  2508,    98,    99,   100,   101,   102,   103,   706,
     104,   105,   406,   707,     0,   107,   108,   109,   110,   708,
     709,   112,   113,   114,   115,     0,   116,   710,   711,   407,
     408,     0,     0,     0,   409,   410,     0,     0,     0,     0,
     411,     0,     0,     0,     0,     0,     0,     0,     0,   412,
       0,   413,     0,   414,   415,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   427,     0,     0,     0,
       0,     0,     0,     0,   428,   429,     0,   430,   133,   431,
     432,   433,   135,   136,   137,   138,   139,     0,   434,   435,
     436,   437,   438,     0,  1406,   439,   440,   441,   140,   442,
       0,   443,   444,   445,   446,  1409,     0,     0,   447,   448,
     449,   450,   147,   451,   452,     0,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   150,   462,     0,  1410,
    1411,  1412,  1413,  1414,  1415,  1416,   463,   464,   465,   466,
     467,   468,   154,   155,   469,     0,   470,     0,   471,   472,
     473,   474,   475,     0,   476,   477,   478,     0,     0,   479,
     480,   481,   482,   483,     0,   484,   485,   486,     0,   487,
     488,     0,   489,   490,   491,   492,   164,   493,   494,  1421,
       0,   495,     0,   496,   168,   497,     0,   498,     0,   499,
     169,     0,   170,   500,   501,   502,     0,   503,  1424,     0,
     504,     0,   505,   506,   507,   508,   509,   173,   510,   511,
     512,     0,   513,   514,   515,   516,   517,   518,     0,   519,
     174,   175,     0,   520,   521,   522,     0,   177,     0,   178,
       0,   523,   179,   180,   524,   181,   525,   526,   527,   528,
     529,   530,     0,  1428,   183,   531,   184,     0,   532,   533,
     534,  1429,  1430,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   189,   190,   191,   548,
     549,   550,   551,   552,   553,   554,   192,   555,     0,   556,
     557,   194,   558,     0,  1435,   559,   196,   560,   561,   562,
       0,   563,     0,     0,   564,   565,   566,     0,     0,   197,
     198,   199,   200,  1438,   567,   568,   569,   570,   571,   572,
       0,   573,  1439,   574,   203,   575,   576,   577,     0,   578,
     579,   580,   581,   582,   583,   584,   205,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,     0,   598,   599,   211,   600,   601,   213,   602,   603,
     604,   605,   606,   607,   608,   609,     0,   610,   611,   612,
     613,   614,  1442,   615,   217,   616,   617,   219,   618,   220,
       0,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,  1444,   629,     0,   630,   631,     0,   632,   633,   634,
     635,   636,   637,     0,   224,   225,     0,     0,   639,  1447,
     640,  1448,     0,   641,   642,   643,   644,   645,   646,     0,
       0,   647,   648,   649,   650,  1451,     0,   651,   652,   653,
     654,   655,   235,     0,   656,   236,   657,   658,   659,     0,
       0,   660,     0,     0,   661,   662,   663,   664,   665,   238,
    1453,  1454,  1455,  1456,  1457,  1458,  1459,   666,   667,   668,
       0,     0,     0,   705,    86,    87,    88,   403,    90,    91,
      92,   404,     0,   405,    95,     0,  3768,    98,    99,   100,
     101,   102,   103,   706,   104,   105,   406,   707,     0,   107,
     108,   109,   110,   708,   709,   112,   113,   114,   115,     0,
     116,   710,   711,   407,   408,     0,     0,     0,   409,   410,
       0,     0,     0,     0,   411,     0,     0,     0,     0,     0,
       0,     0,     0,   412,     0,   413,     0,   414,   415,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     427,     0,     0,     0,     0,     0,     0,     0,   428,   429,
       0,   430,   133,   431,   432,   433,   135,   136,   137,   138,
     139,     0,   434,   435,   436,   437,   438,     0,     0,   439,
     440,   441,   140,   442,     0,   443,   444,   445,   446,   144,
       0,     0,   447,   448,   449,   450,   147,   451,   452,     0,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     150,   462,     0,     0,     0,     0,   151,     0,     0,     0,
     463,   464,   465,   466,   467,   468,   154,   155,   469,     0,
     470,     0,   471,   472,   473,   474,   475,     0,   476,   477,
     478,     0,     0,   479,   480,   481,   482,   483,     0,   484,
     485,   486,     0,   487,   488,     0,   489,   490,   491,   492,
     164,   493,   494,   166,     0,   495,     0,   496,   168,   497,
       0,   498,     0,   499,   169,     0,   170,   500,   501,   502,
       0,   503,   172,     0,   504,     0,   505,   506,   507,   508,
     509,   173,   510,   511,   512,     0,   513,   514,   515,   516,
     517,   518,     0,   519,   174,   175,     0,   520,   521,   522,
       0,   177,     0,   178,     0,   523,   179,   180,   524,   181,
     525,   526,   527,   528,   529,   530,     0,   182,   183,   531,
     184,     0,   532,   533,   534,     0,     0,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     189,   190,   191,   548,   549,   550,   551,   552,   553,   554,
     192,   555,     0,   556,   557,   194,   558,     0,   195,   559,
     196,   560,   561,   562,     0,   563,     0,     0,   564,   565,
     566,     0,     0,   197,   198,   199,   200,   201,   567,   568,
     569,   570,   571,   572,     0,   573,   202,   574,   203,   575,
     576,   577,     0,   578,   579,   580,   581,   582,   583,   584,
     205,   585,   586,   587,     0,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,     0,   598,   599,   211,   600,
     601,   213,   602,   603,   604,   605,   606,   607,   608,   609,
       0,   610,   611,   612,   613,   614,     0,   615,   217,   616,
     617,   219,   618,   220,     0,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   222,   629,     0,   630,   631,
       0,   632,   633,   634,   635,   636,   637,     0,   224,   225,
       0,     0,   639,   226,   640,   227,     0,   641,   642,   643,
     644,   645,   646,     0,     0,   647,   648,   649,   650,     0,
       0,   651,   652,   653,   654,   655,   235,     0,   656,   236,
     657,   658,   659,     0,     0,   660,     0,     0,   661,   662,
     663,   664,   665,   238,   239,   240,   241,   242,   243,   244,
     245,   666,   667,   668,     0,     0,     0,     0,    86,    87,
      88,   403,    90,    91,    92,   404,     0,   405,    95,     0,
    4222,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     406,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,   115,     0,   116,     0,     0,   407,   408,     0,
       0,     0,   409,   410,     0,     0,     0,     0,   411,     0,
       0,     0,     0,     0,     0,     0,     0,   412,     0,   413,
       0,   414,   415,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   427,     0,     0,     0,     0,     0,
    3118,     0,   428,   429,     0,   430,     0,   431,   432,   433,
     135,   136,     0,   138,   139,     0,   434,   435,   436,   437,
     438,     0,     0,   439,   440,   441,   140,   442,     0,   443,
     444,   445,   446,   144,     0,     0,   447,   448,   449,   450,
       0,   451,   452,     0,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461, -1270,   462,     0,     0,     0,     0,
       0,     0,     0,     0,   463,   464,   465,   466,   467,   468,
     154,   155,   469,     0,   470,     0,   471,   472,   473,   474,
     475,     0,   476,   477,   478,     0,     0,   479,   480,   481,
     482,   483,     0,   484,   485,   486,     0,   487,   488,     0,
     489,   490,   491,   492,   164,   493,   494,   166,     0,   495,
       0,   496,   168,   497,     0,   498,     0,   499,     0,     0,
   -1270,   500,   501,   502,     0,   503,   172,     0,   504,     0,
     505,   506,   507,   508,   509,     0,   510,   511,   512,     0,
     513,   514,   515,   516,   517,   518,     0,   519, -1270,   175,
       0,   520,   521,   522,     0,   177,     0,   178,     0,   523,
       0,     0,   524, -1270,   525,   526,   527,   528,   529,   530,
       0,   182, -1270,   531,     0,     0,   532,   533,   534,     0,
       0,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   189, -1270,   191,   548,   549,   550,
     551,   552,   553,   554,   192,   555,     0,   556,   557,     0,
     558,     0,   195,   559,   196,   560,   561,   562,     0,   563,
       0,     0,   564,   565,   566,     0,     0,   197,     0,     0,
       0,   201,   567,   568,   569,   570,   571,   572,     0,   573,
     202,   574,   203,   575,   576,   577,     0,   578,   579,   580,
     581,   582,   583,   584,   205,   585,   586,   587,     0,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,     0,
     598,   599, -1270,   600,   601,   213,   602,   603,   604,   605,
     606,   607,   608,   609,     0,   610,   611,   612,   613,   614,
       0,   615,   217,   616,   617,     0,   618,   220,     0,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   222,
     629,     0,   630,   631,     0,   632,   633,   634,   635,   636,
     637,     0,   224,   225,     0,     0,   639,   226,   640,   227,
       0,   641,   642,   643,   644,   645,   646,     0,     0,   647,
     648,   649,   650,     0,     0,   651,   652,   653,   654,   655,
     235,     0,   656,     0,   657,   658,   659,     0,     0,   660,
       0,     0,   661,   662,   663,   664,   665,   238,   239,   240,
     241,   242,   243,   244,   245,   666,   667,   668,     0,     0,
       0,     0,     0,    86,    87,    88,   403,    90,    91,    92,
     404,     0,   405,    95,     0,  1556,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   406,     0,     0,   107,   108,
     109,   110,     0,     0,   112,   113,   114,   115,     0,   116,
       0,     0,   407,   408,     0,     0,     0,   409,   410,     0,
       0,     0,     0,   411,     0,     0,     0,     0,     0,     0,
       0,     0,   412,     0,   413,     0,   414,   415,    35,   416,
       0,     0,    37,    38,    39,    40,    41,    42,    43,    44,
       0,     0,     0,    45,     0,     0,     0,     0,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   427,
       0,     0,     0,     0,     0,     0,     0,   428,   429,     0,
     430,     0,   431,   432,   433,   135,   136,     0,   138,   139,
       0,   434,   435,   436,   437,   438,     0,     0,   439,   440,
     441,   140,   442,     0,   443,   444,   445,   446,   144,     0,
       0,   447,   448,   449,   450,     0,   451,   452,     0,   453,
     454,   455,   456,   457,   458,     0,   459,   460,   461,     0,
     462,     0,     0,     0,     0,     0,     0,     0,     0,   463,
     464,   465,   466,   467,   468,   154,   155,   469,     0,   470,
       0,   471,   472,   473,   474,   475,     0,   476,   477,   478,
       0,     0,   479,   480,   481,   482,   483,     0,   484,   485,
     486,     0,   487,   488,     0,   489,   490,   491,   492,   164,
     493,   494,   166,  1927,   495,     0,   496,   168,   497,     0,
     498,     0,   499,     0,     0,     0,   500,   501,   502,     0,
     503,   172,     0,   504,     0,   505,   506,   507,   508,   509,
       0,   510,   511,   512,     0,   513,   514,   515,   516,   517,
     518,     0,   519,     0,   175,     0,   520,   521,   522,     0,
     177,     0,   178,     0,   523,     0,     0,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   182,     0,   531,     0,
       0,   532,   533,   534,     0,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   189,
       0,   191,   548,   549,   550,   551,   552,   553,   554,   192,
     555,     0,   556,   557,     0,   558,     0,   195,   559,   196,
     560,   561,   562,     0,   563,  1928,     0,   564,   565,   566,
       0,     0,   197,     0,     0,     0,   201,   567,   568,   569,
     570,   571,   572,     0,   573,   202,   574,   203,   575,   576,
     577,     0,   578,   579,   580,   581,   582,   583,   584,   205,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,     0,   598,   599,     0,   600,   601,
     213,   602,   603,   604,   605,   606,   607,   608,   609,     0,
     610,   611,   612,   613,   614,     0,   615,   217,   616,   617,
       0,   618,   220,     0,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   222,   629,     0,   630,   631,     0,
     632,   633,   634,   635,   636,   637,     0,   224,   225,     0,
       0,   639,   226,   640,   227,  1929,   641,   642,   643,   644,
     645,   646,     0,     0,   647,   648,   649,   650,     0,     0,
     651,   652,   653,   654,   655,   235,     0,   656,     0,   657,
     658,   659,     0,     0,   660,     0,     0,   661,   662,   663,
     664,   665,   238,   239,   240,   241,   242,   243,   244,   245,
     666,   667,   668,     0,     0,     0,     0,     0,     0,     0,
     962,  1595,  3845,     0,     0,     0,     0,     0,     0,  3846,
      86,    87,    88,   403,    90,    91,    92,   404,     0,   405,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   406,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,   115,     0,   116,     0,     0,   407,
     408,     0,     0,     0,   409,   410,     0,     0,     0,     0,
     411,     0,     0,     0,     0,     0,     0,     0,     0,   412,
       0,   413,     0,   414,   415,    35,     0,     0,     0,    37,
      38,    39,    40,    41,    42,     0,    44,     0,     0,     0,
      45,     0,     0,     0,     0,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   427,     0,     0,     0,
       0,     0,     0,     0,   428,   429,     0,   430,     0,   431,
     432,   433,   135,   136,     0,   138,   139,     0,   434,   435,
     436,   437,   438,     0,     0,   439,   440,   441,   140,   442,
       0,   443,   444,   445,   446,   144,     0,     0,   447,   448,
     449,   450,     0,   451,   452,     0,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,     0,   462,     0,     0,
       0,     0,     0,     0,     0,     0,   463,   464,   465,   466,
     467,   468,   154,   155,   469,     0,   470,     0,   471,   472,
     473,   474,   475,     0,   476,   477,   478,     0,     0,   479,
     480,   481,   482,   483,     0,   484,   485,   486,     0,   487,
     488,     0,   489,   490,   491,   492,   164,   493,   494,   166,
       0,   495,     0,   496,   168,   497,     0,   498,     0,   499,
       0,     0,     0,   500,   501,   502,     0,   503,   172,     0,
     504,     0,   505,   506,   507,   508,   509,     0,   510,   511,
     512,     0,   513,   514,   515,   516,   517,   518,     0,   519,
       0,   175,     0,   520,   521,   522,     0,   177,     0,   178,
       0,   523,     0,     0,   524,     0,   525,   526,   527,   528,
     529,   530,     0,   182,     0,   531,     0,     0,   532,   533,
     534,     0,     0,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   189,     0,   191,   548,
     549,   550,   551,   552,   553,   554,   192,   555,     0,   556,
     557,     0,   558,     0,   195,   559,   196,   560,   561,   562,
       0,   563,     0,     0,   564,   565,   566,     0,     0,   197,
       0,     0,     0,   201,   567,   568,   569,   570,   571,   572,
       0,   573,   202,   574,   203,   575,   576,   577,     0,   578,
     579,   580,   581,   582,   583,   584,   205,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,     0,   598,   599,     0,   600,   601,   213,   602,   603,
     604,   605,   606,   607,   608,   609,     0,   610,   611,   612,
     613,   614,     0,   615,   217,   616,   617,     0,   618,   220,
       0,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   222,   629,     0,   630,   631,     0,   632,   633,   634,
     635,   636,   637,     0,   224,   225,     0,     0,   639,   226,
     640,   227,     0,   641,   642,   643,   644,   645,   646,     0,
       0,   647,   648,   649,   650,     0,     0,   651,   652,   653,
     654,   655,   235,     0,   656,     0,   657,   658,   659,     0,
       0,   660,     0,     0,   661,   662,   663,   664,   665,   238,
     239,   240,   241,   242,   243,   244,   245,   666,   667,   668,
       0,     0,     0,     0,    86,    87,    88,   403,    90,    91,
      92,   404,     0,   405,    95,  3502,  3503,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   406,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,   115,     0,
     116,     0,     0,   407,   408,     0,     0,     0,   409,   410,
       0,     0,     0,     0,   411,     0,     0,     0,     0,     0,
       0,     0,     0,   412,     0,   413,     0,   414,   415,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     427,   130,   131,     0,     0,     0,     0,     0,   428,   429,
       0,   430,     0,   431,   432,   433,   135,   136,     0,   138,
     139,     0,   434,   435,   436,   437,   438,     0,     0,   439,
     440,   441,   140,   442,     0,   443,   444,   445,   446,   144,
       0,     0,   447,   448,   449,   450,     0,   451,   452,     0,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
       0,   462,     0,     0,     0,     0,     0,     0,     0,     0,
     463,   464,   465,   466,   467,   468,   154,   155,   469,     0,
     470,     0,   471,   472,   473,   474,   475,     0,   476,   477,
     478,     0,     0,   479,   480,   481,   482,   483,     0,   484,
     485,   486,     0,   487,   488,     0,   489,   490,   491,   492,
     164,   493,   494,   166,     0,   495,     0,   496,   168,   497,
       0,   498,     0,   499,     0,     0,     0,   500,   501,   502,
       0,   503,   172,     0,   504,     0,   505,   506,   507,   508,
     509,     0,   510,   511,   512,     0,   513,   514,   515,   516,
     517,   518,     0,   519,     0,   175,     0,   520,   521,   522,
       0,   177,     0,   178,     0,   523,     0,     0,   524,     0,
     525,   526,   527,   528,   529,   530,     0,   182,     0,   531,
       0,     0,   532,   533,   534,     0,     0,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     189,     0,   191,   548,   549,   550,   551,   552,   553,   554,
     192,   555,     0,   556,   557,     0,   558,     0,   195,   559,
     196,   560,   561,   562,     0,   563,     0,     0,   564,   565,
     566,     0,     0,   197,     0,     0,     0,   201,   567,   568,
     569,   570,   571,   572,     0,   573,   202,   574,   203,   575,
     576,   577,     0,   578,   579,   580,   581,   582,   583,   584,
     205,   585,   586,   587,     0,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,     0,   598,   599,     0,   600,
     601,   213,   602,   603,   604,   605,   606,   607,   608,   609,
     215,   610,   611,   612,   613,   614,     0,   615,   217,   616,
     617,     0,   618,   220,     0,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   222,   629,     0,   630,   631,
     223,   632,   633,   634,   635,   636,   637,     0,   224,   225,
       0,     0,   639,   226,   640,   227,     0,   641,   642,   643,
     644,   645,   646,     0,     0,   647,   648,   649,   650,     0,
       0,   651,   652,   653,   654,  1324,   235,     0,   656,  1325,
     657,   658,   659,     0,     0,   660,     0,   237,   661,   662,
     663,   664,   665,   238,   239,   240,   241,   242,   243,   244,
     245,   666,   667,   668,     0,     0,     0,     0,    86,    87,
      88,   403,    90,    91,    92,   404,     0,   405,    95,     0,
     246,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     406,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,   115,     0,   116,     0,     0,   407,   408,     0,
       0,     0,   409,   410,     0,     0,     0,     0,   411,     0,
       0,     0,     0,     0,     0,     0,     0,   412,     0,   413,
       0,   414,   415,    35,     0,     0,     0,    37,    38,    39,
      40,    41,    42,     0,    44,     0,     0,     0,    45,     0,
       0,     0,     0,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   427,     0,     0,     0,     0,     0,
       0,     0,   428,   429,     0,   430,     0,   431,   432,   433,
     135,   136,     0,   138,   139,     0,   434,   435,   436,   437,
     438,     0,     0,   439,   440,   441,   140,   442,     0,   443,
     444,   445,   446,   144,     0,     0,   447,   448,   449,   450,
       0,   451,   452,     0,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,     0,   462,     0,     0,     0,     0,
       0,     0,     0,     0,   463,   464,   465,   466,   467,   468,
     154,   155,   469,     0,   470,     0,   471,   472,   473,   474,
     475,     0,   476,   477,   478,     0,     0,   479,   480,   481,
     482,   483,     0,   484,   485,   486,     0,   487,   488,     0,
     489,   490,   491,   492,   164,   493,   494,   166,     0,   495,
       0,   496,   168,   497,     0,   498,     0,   499,     0,     0,
       0,   500,   501,   502,     0,   503,   172,     0,   504,     0,
     505,   506,   507,   508,   509,     0,   510,   511,   512,     0,
     513,   514,   515,   516,   517,   518,     0,   519,     0,   175,
       0,   520,   521,   522,     0,   177,     0,   178,     0,   523,
       0,     0,   524,     0,   525,   526,   527,   528,   529,   530,
       0,   182,     0,   531,     0,     0,   532,   533,   534,     0,
       0,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   189,     0,   191,   548,   549,   550,
     551,   552,   553,   554,   192,   555,     0,   556,   557,     0,
     558,     0,   195,   559,   196,   560,   561,   562,     0,   563,
       0,     0,   564,   565,   566,     0,     0,   197,     0,     0,
       0,   201,   567,   568,   569,   570,   571,   572,     0,   573,
     202,   574,   203,   575,   576,   577,     0,   578,   579,   580,
     581,   582,   583,   584,   205,   585,   586,   587,     0,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,     0,
     598,   599,     0,   600,   601,   213,   602,   603,   604,   605,
     606,   607,   608,   609,     0,   610,   611,   612,   613,   614,
       0,   615,   217,   616,   617,     0,   618,   220,     0,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   222,
     629,     0,   630,   631,     0,   632,   633,   634,   635,   636,
     637,     0,   224,   225,     0,     0,   639,   226,   640,   227,
       0,   641,   642,   643,   644,   645,   646,     0,     0,   647,
     648,   649,   650,     0,     0,   651,   652,   653,   654,   655,
     235,     0,   656,     0,   657,   658,   659,     0,     0,   660,
       0,     0,   661,   662,   663,   664,   665,   238,   239,   240,
     241,   242,   243,   244,   245,   666,   667,   668,     0,     0,
       0,     0,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,  3503,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,   416,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,   215,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,   223,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,  1324,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,   237,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,     0,     0,     0,     0,    86,    87,    88,   403,
      90,    91,    92,   404,     0,   405,    95,     0,   246,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   406,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
     115,     0,   116,     0,     0,   407,   408,     0,     0,     0,
     409,   410,     0,     0,     0,     0,   411,     0,     0,     0,
       0,     0,     0,     0,     0,   412,     0,   413,     0,   414,
     415,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   427,     0,     0,     0,     0,     0,     0,     0,
     428,   429,     0,   430,     0,   431,   432,   433,   135,   136,
       0,   138,   139,     0,   434,   435,   436,   437,   438,     0,
       0,   439,   440,   441,   140,   442,     0,   443,   444,   445,
     446,   144,     0,     0,   447,   448,   449,   450,     0,   451,
     452,     0,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,     0,   462,     0,     0,     0,     0,     0,     0,
       0,     0,   463,   464,   465,   466,   467,   468,   154,   155,
     469,     0,   470,     0,   471,   472,   473,   474,   475,     0,
     476,   477,   478,     0,     0,   479,   480,   481,   482,   483,
       0,   484,   485,   486,     0,   487,   488,     0,   489,   490,
     491,   492,   164,   493,   494,   166,     0,   495,     0,   496,
     168,   497,     0,   498,     0,   499,     0,     0,     0,   500,
     501,   502,     0,   503,   172,     0,   504,     0,   505,   506,
     507,   508,   509,     0,   510,   511,   512,     0,   513,   514,
     515,   516,   517,   518,     0,   519,     0,   175,     0,   520,
     521,   522,     0,   177,     0,   178,     0,   523,     0,     0,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   182,
       0,   531,     0,     0,   532,   533,   534,     0,     0,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   189,     0,   191,   548,   549,   550,   551,   552,
     553,   554,   192,   555,     0,   556,   557,     0,   558,     0,
     195,   559,   196,   560,   561,   562,     0,   563,     0,     0,
     564,   565,   566,     0,     0,   197,     0,     0,     0,   201,
     567,   568,   569,   570,   571,   572,     0,   573,   202,   574,
     203,   575,   576,   577,     0,   578,   579,   580,   581,   582,
     583,   584,   205,   585,   586,   587,     0,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,     0,   598,   599,
       0,   600,   601,   213,   602,   603,   604,   605,   606,   607,
     608,   609,   215,   610,   611,   612,   613,   614,     0,   615,
     217,   616,   617,     0,   618,   220,     0,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   222,   629,     0,
     630,   631,   223,   632,   633,   634,   635,   636,   637,     0,
     224,   225,     0,     0,   639,   226,   640,   227,     0,   641,
     642,   643,   644,   645,   646,     0,     0,   647,   648,   649,
     650,     0,     0,   651,   652,   653,   654,  1324,   235,     0,
     656,     0,   657,   658,   659,     0,     0,   660,     0,   237,
     661,   662,   663,   664,   665,   238,   239,   240,   241,   242,
     243,   244,   245,   666,   667,   668,     0,     0,     0,     0,
      86,    87,    88,   403,    90,    91,    92,   404,     0,   405,
      95,     0,   246,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   406,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,   115,     0,   116,     0,     0,   407,
     408,     0,     0,     0,   409,   410,     0,     0,     0,     0,
     411,     0,     0,     0,     0,     0,     0,     0,     0,   412,
       0,   413,     0,   414,   415,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   427,     0,     0,     0,
       0,     0,     0,     0,   428,   429,     0,   430,     0,   431,
     432,   433,   135,   136,     0,   138,   139,     0,   434,   435,
     436,   437,   438,     0,     0,   439,   440,   441,   140,   442,
       0,   443,   444,   445,   446,   144,     0,     0,   447,   448,
     449,   450,     0,   451,   452,     0,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,     0,   462,     0,     0,
       0,     0,     0,     0,     0,     0,   463,   464,   465,   466,
     467,   468,   154,   155,   469,     0,   470,     0,   471,   472,
     473,   474,   475,     0,   476,   477,   478,     0,     0,   479,
     480,   481,   482,   483,     0,   484,   485,   486,     0,   487,
     488,     0,   489,   490,   491,   492,   164,   493,   494,   166,
       0,   495,     0,   496,   168,   497,     0,   498,     0,   499,
       0,     0,     0,   500,   501,   502,     0,   503,   172,     0,
     504,     0,   505,   506,   507,   508,   509,     0,   510,   511,
     512,     0,   513,   514,   515,   516,   517,   518,     0,   519,
       0,   175,     0,   520,   521,   522,     0,   177,     0,   178,
       0,   523,     0,     0,   524,     0,   525,   526,   527,   528,
     529,   530,     0,   182,     0,   531,     0,     0,   532,   533,
     534,     0,     0,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   189,     0,   191,   548,
     549,   550,   551,   552,   553,   554,   192,   555,     0,   556,
     557,     0,   558,     0,   195,   559,   196,   560,   561,   562,
       0,   563,     0,     0,   564,   565,   566,     0,     0,   197,
       0,     0,     0,   201,   567,   568,   569,   570,   571,   572,
       0,   573,   202,   574,   203,   575,   576,   577,     0,   578,
     579,   580,   581,   582,   583,   584,   205,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,     0,   598,   599,     0,   600,   601,   213,   602,   603,
     604,   605,   606,   607,   608,   609,     0,   610,   611,   612,
     613,   614,     0,   615,   217,   616,   617,     0,   618,   220,
       0,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   222,   629,     0,   630,   631,     0,   632,   633,   634,
     635,   636,   637,     0,   224,   225,     0,     0,   639,   226,
     640,   227,     0,   641,   642,   643,   644,   645,   646,     0,
       0,   647,   648,   649,   650,     0,     0,   651,   652,   653,
     654,   655,   235,     0,   656,     0,   657,   658,   659,     0,
       0,   660,     0,     0,   661,   662,   663,   664,   665,   238,
     239,   240,   241,   242,   243,   244,   245,   666,   667,   668,
       0,     0,     0,     0,    86,    87,    88,   403,    90,    91,
      92,   404,     0,   405,    95,     0,  1528,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   406,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,   115,     0,
     116,     0,     0,   407,   408,     0,     0,     0,   409,   410,
       0,     0,     0,     0,   411,     0,     0,     0,     0,     0,
       0,     0,     0,   412,     0,   413,     0,   414,   415,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     427,     0,     0,     0,     0,     0,     0,     0,   428,   429,
       0,   430,     0,   431,   432,   433,   135,   136,     0,   138,
     139,     0,   434,   435,   436,   437,   438,     0,     0,   439,
     440,   441,   140,   442,     0,   443,   444,   445,   446,   144,
       0,     0,   447,   448,   449,   450,     0,   451,   452,     0,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
       0,   462,     0,     0,     0,     0,     0,     0,     0,     0,
     463,   464,   465,   466,   467,   468,   154,   155,   469,     0,
     470,     0,   471,   472,   473,   474,   475,     0,   476,   477,
     478,     0,     0,   479,   480,   481,   482,   483,     0,   484,
     485,   486,     0,   487,   488,     0,   489,   490,   491,   492,
     164,   493,   494,   166,     0,   495,     0,   496,   168,   497,
       0,   498,     0,   499,     0,     0,     0,   500,   501,   502,
       0,   503,   172,     0,   504,     0,   505,   506,   507,   508,
     509,     0,   510,   511,   512,     0,   513,   514,   515,   516,
     517,   518,     0,   519,     0,   175,     0,   520,   521,   522,
       0,   177,     0,   178,     0,   523,     0,     0,   524,     0,
     525,   526,   527,   528,   529,   530,     0,   182,     0,   531,
       0,     0,   532,   533,   534,     0,     0,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     189,     0,   191,   548,   549,   550,   551,   552,   553,   554,
     192,   555,     0,   556,   557,     0,   558,     0,   195,   559,
     196,   560,   561,   562,     0,   563,     0,     0,   564,   565,
     566,     0,     0,   197,     0,     0,     0,   201,   567,   568,
     569,   570,   571,   572,     0,   573,   202,   574,   203,   575,
     576,   577,     0,   578,   579,   580,   581,   582,   583,   584,
     205,   585,   586,   587,     0,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,     0,   598,   599,     0,   600,
     601,   213,   602,   603,   604,   605,   606,   607,   608,   609,
       0,   610,   611,   612,   613,   614,     0,   615,   217,   616,
     617,     0,   618,   220,     0,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   222,   629,     0,   630,   631,
       0,   632,   633,   634,   635,   636,   637,     0,   224,   225,
       0,     0,   639,   226,   640,   227,     0,   641,   642,   643,
     644,   645,   646,     0,     0,   647,   648,   649,   650,     0,
       0,   651,   652,   653,   654,   655,   235,     0,   656,     0,
     657,   658,   659,     0,     0,   660,     0,     0,   661,   662,
     663,   664,   665,   238,   239,   240,   241,   242,   243,   244,
     245,   666,   667,   668,     0,     0,     0,     0,    86,    87,
      88,   403,    90,    91,    92,   404,     0,   405,    95,     0,
    2160,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     406,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,   115,     0,   116,     0,     0,   407,   408,     0,
       0,     0,   409,   410,     0,     0,     0,     0,   411,     0,
       0,     0,     0,     0,     0,     0,     0,   412,     0,   413,
       0,   414,   415,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   427,     0,     0,     0,     0,     0,
       0,     0,   428,   429,     0,   430,     0,   431,   432,   433,
     135,   136,     0,   138,   139,     0,   434,   435,   436,   437,
     438,     0,     0,   439,   440,   441,   140,   442,     0,   443,
     444,   445,   446,   144,     0,     0,   447,   448,   449,   450,
       0,   451,   452,     0,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,     0,   462,     0,     0,     0,     0,
       0,     0,     0,     0,   463,   464,   465,   466,   467,   468,
     154,   155,   469,     0,   470,     0,   471,   472,   473,   474,
     475,     0,   476,   477,   478,     0,     0,   479,   480,   481,
     482,   483,     0,   484,   485,   486,     0,   487,   488,     0,
     489,   490,   491,   492,   164,   493,   494,   166,     0,   495,
       0,   496,   168,   497,     0,   498,     0,   499,     0,     0,
       0,   500,   501,   502,     0,   503,   172,     0,   504,     0,
     505,   506,   507,   508,   509,     0,   510,   511,   512,     0,
     513,   514,   515,   516,   517,   518,     0,   519,     0,   175,
       0,   520,   521,   522,     0,   177,     0,   178,     0,   523,
       0,     0,   524,     0,   525,   526,   527,   528,   529,   530,
       0,   182,     0,   531,     0,     0,   532,   533,   534,     0,
       0,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   189,     0,   191,   548,   549,   550,
     551,   552,   553,   554,   192,   555,     0,   556,   557,     0,
     558,     0,   195,   559,   196,   560,   561,   562,     0,   563,
       0,     0,   564,   565,   566,     0,     0,   197,     0,     0,
       0,   201,   567,   568,   569,   570,   571,   572,     0,   573,
     202,   574,   203,   575,   576,   577,     0,   578,   579,   580,
     581,   582,   583,   584,   205,   585,   586,   587,     0,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,     0,
     598,   599,     0,   600,   601,   213,   602,   603,   604,   605,
     606,   607,   608,   609,     0,   610,   611,   612,   613,   614,
       0,   615,   217,   616,   617,     0,   618,   220,     0,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   222,
     629,     0,   630,   631,     0,   632,   633,   634,   635,   636,
     637,     0,   224,   225,     0,     0,   639,   226,   640,   227,
       0,   641,   642,   643,   644,   645,   646,     0,     0,   647,
     648,   649,   650,     0,     0,   651,   652,   653,   654,   655,
     235,     0,   656,     0,   657,   658,   659,     0,     0,   660,
       0,     0,   661,   662,   663,   664,   665,   238,   239,   240,
     241,   242,   243,   244,   245,   666,   667,   668,     0,     0,
       0,     0,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,  3608,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,     0,     0,     0,   705,    86,    87,    88,   403,
      90,    91,    92,   404,     0,   405,    95,     0,  3734,    98,
      99,   100,   101,   102,   103,   706,   104,   105,   406,   707,
       0,   107,   108,   109,   110,   708,   709,   112,   113,   114,
     115,     0,   116,   710,   711,   407,   408,     0,     0,     0,
     409,   410,     0,     0,     0,     0,   411,     0,     0,     0,
       0,     0,     0,     0,     0,   412,     0,   413,     0,   414,
     415,    35,   416,     0,     0,    37,    38,    39,    40,    41,
      42,    43,    44,     0,     0,  1158,    45,     0,     0,     0,
       0,   417,   418,   419,   420,   421,   422,   423,   424,   712,
     425,   426,   427,   713,   714,   715,   716,   717,   718,   719,
     428,   429,   720,   430,   133,   431,   432,   433,     0,  1784,
     137,  1785,  1786,   721,   434,   435,   436,   437,   438,   722,
     723,   439,   440,  1787,  1788,   442,   725,   443,   444,   445,
     446,     0,   726,   727,   447,   448,   449,   450,   147,   451,
     452,   729,   453,   454,   455,   456,   457,   458,   730,   459,
     460,   461,   150,   462,     0,   732,   733,   734,   151,   735,
     736,   737,   463,   464,   465,   466,   467,   468,  1789,  1790,
     469,   738,   470,   739,   471,   472,   473,   474,   475,   740,
     476,   477,   478,   741,   742,   479,   480,  1419,   482,   483,
     743,   484,   485,   486,   744,   487,   488,   745,   489,   490,
     491,   492,     0,   493,   494,     0,   746,   495,   747,   496,
    1791,   497,   748,   498,   749,   499,   169,   750,   170,   500,
     501,   502,   751,   503,     0,   752,   504,   753,   505,   506,
     507,   508,   509,   173,   510,   511,   512,   754,   513,   514,
     515,   516,   517,   518,   755,   519,   174,     0,     0,   520,
     521,   522,  1425,  1792,   758,  1793,   759,   523,   179,   180,
     524,   181,   525,   526,   527,   528,   529,   530,   760,     0,
     183,   531,   184,   761,   532,   533,   534,   762,   763,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,  1794,   190,  1795,   548,   549,   550,   551,   552,
     553,   554,     0,   555,   764,   556,   557,   194,   558,   765,
       0,   559,  1796,   560,   561,   562,   766,   563,   767,   768,
    3489,   565,   566,   769,   770,     0,   198,   199,   200,     0,
     567,   568,   569,   570,   571,   572,   771,   573,     0,   574,
       0,   575,   576,   577,   772,   578,   579,   580,   581,   582,
     583,   584,  1797,   585,   586,   587,   773,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   774,   598,   599,
     211,   600,   601,     0,   602,   603,   604,   605,   606,   607,
     608,   609,   775,   610,   611,   612,   613,   614,   776,   615,
    2305,   616,   617,   219,   618,  1799,   777,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,     0,   629,   778,
     630,   631,   779,   632,   633,   634,   635,   636,   637,   780,
    1800,  1801,     0,   782,   639,     0,   640,     0,   783,   641,
     642,   643,   644,   645,   646,     0,   785,   647,   648,   649,
     650,   786,   787,   651,   652,   653,   654,     0,  1802,   789,
     656,   236,   657,   658,   659,   790,   791,   660,   792,   793,
     661,   662,   663,   664,   665,     0,     0,     0,     0,     0,
       0,     0,     0,   666,   667,   668,     0,     0,     0,  1161,
    1162,  1163,     0,  3490,  3491,  1166,  1167,  1168,  1169,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,  1158,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,  1159,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
    1160,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,     0,
       0,     0,  1161,  1162,  1163,     0,  1164,  1165,  1166,  1167,
    1168,  1169,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,  1158,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,  1234,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,  1235,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,     0,     0,     0,  1161,  1162,  1163,     0,  1164,
    1165,  1166,  1167,  1168,  1169,    86,    87,    88,   403,    90,
      91,    92,   404,     0,   405,    95,     0,     0,    98,    99,
     100,   101,   102,   103,     0,   104,   105,   406,     0,     0,
     107,   108,   109,   110,     0,     0,   112,   113,   114,   115,
       0,   116,     0,     0,   407,   408,     0,     0,     0,   409,
     410,     0,     0,     0,     0,   411,     0,     0,     0,     0,
       0,     0,     0,     0,   412,     0,   413,     0,   414,   415,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,  1158,     0,     0,     0,     0,     0,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   427,     0,     0,     0,     0,     0,     0,     0,   428,
     429,     0,   430,     0,   431,   432,   433,   135,   136,     0,
     138,   139,     0,   434,   435,   436,   437,   438,     0,     0,
     439,   440,   441,   140,   442,     0,   443,  1285,   445,   446,
     144,     0,     0,   447,   448,   449,   450,     0,   451,   452,
       0,   453,   454,   455,   456,   457,   458,     0,   459,   460,
     461,     0,   462,     0,     0,     0,     0,     0,     0,     0,
       0,   463,   464,   465,   466,   467,   468,   154,   155,   469,
       0,   470,     0,   471,   472,   473,   474,   475,     0,   476,
     477,   478,     0,     0,   479,   480,   481,   482,   483,     0,
     484,   485,   486,     0,   487,   488,     0,   489,   490,   491,
     492,   164,   493,   494,   166,     0,  1286,     0,   496,   168,
     497,     0,   498,     0,   499,     0,     0,     0,   500,   501,
     502,     0,   503,   172,     0,   504,     0,   505,   506,   507,
     508,  1287,     0,   510,   511,   512,     0,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   175,     0,   520,   521,
     522,     0,   177,     0,   178,     0,   523,     0,     0,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   182,     0,
     531,     0,     0,   532,   533,   534,     0,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   189,     0,   191,   548,   549,   550,   551,   552,   553,
     554,   192,   555,     0,   556,   557,     0,   558,     0,   195,
     559,   196,   560,   561,   562,     0,   563,     0,     0,   564,
     565,   566,     0,     0,   197,     0,     0,     0,   201,   567,
     568,   569,   570,   571,   572,     0,   573,   202,   574,   203,
     575,   576,   577,     0,   578,   579,   580,   581,   582,   583,
     584,   205,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,     0,   598,   599,     0,
     600,   601,   213,   602,   603,   604,   605,   606,   607,   608,
     609,     0,   610,   611,   612,   613,   614,     0,   615,   217,
     616,   617,     0,   618,   220,     0,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   222,   629,     0,   630,
     631,     0,   632,   633,   634,   635,   636,   637,     0,   224,
     225,     0,     0,   639,   226,   640,   227,     0,   641,   642,
     643,   644,   645,   646,     0,     0,   647,   648,   649,   650,
       0,     0,   651,   652,   653,   654,   655,   235,     0,   656,
       0,   657,   658,   659,     0,     0,   660,     0,     0,   661,
     662,   663,   664,   665,   238,   239,   240,   241,   242,   243,
     244,   245,   666,   667,   668,     0,     0,     0,  1161,  1162,
    1163,     0,  1164,  1165,  1166,  1167,  1168,  1169,    86,    87,
      88,   403,    90,    91,    92,   404,     0,   405,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     406,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,   115,     0,   116,     0,     0,   407,   408,     0,
       0,     0,   409,   410,     0,     0,     0,     0,   411,     0,
       0,     0,     0,     0,     0,     0,     0,   412,     0,   413,
       0,   414,   415,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,  1158,     0,     0,
       0,     0,     0,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   427,     0,     0,     0,     0,     0,
       0,     0,   428,   429,     0,   430,     0,   431,   432,   433,
     135,   136,     0,   138,   139,     0,   434,   435,   436,   437,
     438,     0,     0,   439,   440,   441,   140,   442,     0,   443,
    1767,   445,   446,   144,     0,     0,   447,   448,   449,   450,
       0,   451,   452,     0,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,     0,   462,     0,     0,     0,     0,
       0,     0,     0,     0,   463,   464,   465,   466,   467,   468,
     154,   155,   469,     0,   470,     0,   471,   472,   473,   474,
     475,     0,   476,   477,   478,     0,     0,   479,   480,   481,
     482,   483,     0,   484,   485,   486,     0,   487,   488,     0,
     489,   490,   491,   492,   164,   493,   494,   166,     0,  1768,
       0,   496,   168,   497,     0,   498,     0,   499,     0,     0,
       0,   500,   501,   502,     0,   503,   172,     0,   504,     0,
     505,   506,   507,   508,   509,     0,   510,   511,   512,     0,
     513,   514,   515,   516,   517,   518,     0,   519,     0,   175,
       0,   520,   521,   522,     0,   177,     0,   178,     0,   523,
       0,     0,   524,     0,   525,   526,   527,   528,   529,   530,
       0,   182,     0,   531,     0,     0,   532,   533,   534,     0,
       0,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   189,     0,   191,   548,   549,   550,
     551,   552,   553,   554,   192,   555,     0,   556,   557,     0,
     558,     0,   195,   559,   196,   560,   561,   562,     0,   563,
       0,     0,   564,   565,   566,     0,     0,   197,     0,     0,
       0,   201,   567,   568,   569,   570,   571,   572,     0,   573,
     202,   574,   203,   575,   576,   577,     0,   578,   579,   580,
     581,   582,   583,   584,   205,   585,   586,   587,     0,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,     0,
     598,   599,     0,   600,   601,   213,   602,   603,   604,   605,
     606,   607,   608,   609,     0,   610,   611,   612,   613,   614,
       0,   615,   217,   616,   617,     0,   618,   220,     0,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   222,
     629,     0,   630,   631,     0,   632,   633,   634,   635,   636,
     637,     0,   224,   225,     0,     0,   639,   226,   640,   227,
       0,   641,   642,   643,   644,   645,   646,     0,     0,   647,
     648,   649,   650,     0,     0,   651,   652,   653,   654,   655,
     235,     0,   656,     0,   657,   658,   659,     0,     0,   660,
       0,     0,   661,   662,   663,   664,   665,   238,   239,   240,
     241,   242,   243,   244,   245,   666,   667,   668,     0,     0,
       0,  1161,  1162,  1163,     0,  1164,  1165,  1166,  1167,  1168,
    1169,    86,    87,    88,   403,    90,    91,    92,   404,     0,
     405,    95,     0,     0,    98,    99,   100,   101,   102,   103,
       0,   104,   105,   406,     0,     0,   107,   108,   109,   110,
       0,     0,   112,   113,   114,   115,     0,   116,     0,     0,
     407,   408,     0,     0,     0,   409,   410,     0,     0,     0,
       0,   411,     0,     0,     0,     0,     0,     0,     0,     0,
     412,     0,   413,     0,   414,   415,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
    1158,     0,     0,     0,     0,     0,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,     0,     0,
       0,     0,     0,     0,     0,   428,   429,     0,   430,     0,
     431,   432,   433,   135,   136,     0,   138,   139,     0,   434,
     435,   436,   437,   438,     0,     0,   439,   440,   441,   140,
     442,     0,   443,   444,   445,   446,   144,     0,     0,   447,
     448,   449,   450,     0,   451,   452,     0,   453,   454,   455,
     456,   457,   458,     0,   459,   460,   461,     0,   462,     0,
       0,     0,     0,     0,     0,     0,     0,   463,   464,   465,
     466,   467,   468,   154,   155,   469,     0,   470,     0,   471,
     472,   473,   474,   475,     0,   476,   477,   478,     0,     0,
     479,   480,   481,   482,   483,     0,   484,   485,   486,     0,
     487,   488,     0,   489,   490,   491,   492,   164,   493,   494,
     166,     0,   495,     0,   496,   168,   497,     0,   498,     0,
     499,     0,     0,     0,   500,   501,   502,     0,   503,   172,
       0,   504,     0,   505,   506,   507,   508,   509,     0,   510,
     511,   512,     0,   513,   514,   515,   516,   517,   518,     0,
     519,     0,   175,     0,   520,   521,   522,     0,   177,     0,
     178,     0,   523,     0,     0,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   182,     0,   531,     0,     0,   532,
     533,   534,     0,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   189,     0,   191,
     548,   549,   550,   551,   552,   553,   554,   192,   555,     0,
     556,   557,     0,   558,     0,   195,   559,   196,   560,   561,
     562,     0,   563,     0,     0,   564,   565,   566,     0,     0,
     197,     0,     0,     0,   201,   567,   568,   569,   570,   571,
     572,     0,   573,   202,   574,   203,   575,   576,   577,     0,
     578,   579,   580,   581,   582,   583,   584,   205,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,     0,   598,   599,     0,   600,   601,   213,   602,
     603,   604,   605,   606,   607,   608,   609,     0,   610,   611,
     612,   613,   614,     0,   615,   217,   616,   617,     0,   618,
     220,     0,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   222,   629,     0,   630,   631,     0,   632,   633,
     634,   635,   636,   637,     0,   224,   225,     0,     0,   639,
     226,   640,   227,     0,   641,   642,   643,   644,   645,   646,
       0,     0,   647,   648,   649,   650,     0,     0,   651,   652,
     653,   654,   655,   235,     0,   656,     0,   657,   658,   659,
       0,     0,   660,     0,     0,   661,   662,   663,   664,   665,
     238,   239,   240,   241,   242,   243,   244,   245,   666,   667,
     668,     0,     0,     0,  1161,  1162,  1163,     0,  1164,  1165,
    1166,  1167,  1168,  1169,    86,    87,    88,   403,    90,    91,
      92,   404,     0,   405,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   406,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,   115,     0,
     116,     0,     0,   407,   408,     0,     0,     0,   409,   410,
       0,     0,     0,     0,   411,     0,     0,     0,     0,     0,
       0,     0,     0,   412,     0,   413,     0,   414,   415,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,  1158,     0,     0,     0,     0,     0,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     427,     0,     0,     0,     0,     0,     0,     0,   428,   429,
       0,   430,     0,   431,   432,   433,   135,   136,     0,   138,
     139,     0,   434,   435,   436,   437,   438,     0,     0,   439,
     440,   441,   140,   442,     0,   443,   444,   445,   446,   144,
       0,     0,   447,   448,   449,   450,     0,   451,   452,     0,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
       0,   462,     0,     0,     0,     0,     0,     0,     0,     0,
     463,   464,   465,   466,   467,   468,   154,   155,   469,     0,
     470,     0,   471,   472,   473,   474,   475,     0,   476,   477,
     478,     0,     0,   479,   480,   481,   482,   483,     0,   484,
     485,   486,     0,   487,   488,     0,   489,   490,   491,   492,
     164,   493,   494,   166,     0,   495,     0,   496,   168,   497,
       0,   498,     0,   499,     0,     0,     0,   500,   501,   502,
       0,   503,   172,     0,   504,     0,   505,   506,   507,   508,
     509,     0,   510,   511,   512,     0,   513,   514,   515,   516,
     517,   518,     0,   519,     0,   175,     0,   520,   521,   522,
       0,   177,     0,   178,     0,   523,     0,     0,   524,     0,
     525,   526,   527,   528,   529,   530,     0,   182,     0,   531,
       0,     0,   532,   533,   534,     0,     0,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     189,     0,   191,   548,   549,   550,   551,   552,   553,   554,
     192,   555,     0,   556,   557,     0,   558,     0,   195,   559,
     196,   560,   561,   562,     0,   563,     0,     0,  4211,   565,
     566,     0,     0,   197,     0,     0,     0,   201,   567,   568,
     569,   570,   571,   572,     0,   573,   202,   574,   203,   575,
     576,   577,     0,   578,   579,   580,   581,   582,   583,   584,
     205,   585,   586,   587,     0,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,     0,   598,   599,     0,   600,
     601,   213,   602,   603,   604,   605,   606,   607,   608,   609,
       0,   610,   611,   612,   613,   614,     0,   615,   217,   616,
     617,     0,   618,   220,     0,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   222,   629,     0,   630,   631,
       0,   632,   633,   634,   635,   636,   637,     0,   224,   225,
       0,     0,   639,   226,   640,   227,     0,   641,   642,   643,
     644,   645,   646,     0,     0,   647,   648,   649,   650,     0,
       0,   651,   652,   653,   654,   655,   235,     0,   656,     0,
     657,   658,   659,     0,     0,   660,     0,     0,   661,   662,
     663,   664,   665,   238,   239,   240,   241,   242,   243,   244,
     245,   666,   667,   668,     0,     0,     0,  1161,  1162,  1163,
       0,  1164,  1165,  1166,  1167,  1168,  1169,   705,    86,    87,
      88,   403,    90,    91,    92,   404,     0,   405,    95,     0,
       0,    98,    99,   100,   101,   102,   103,   706,   104,   105,
     406,   707,     0,   107,   108,   109,   110,   708,   709,   112,
     113,   114,   115,     0,   116,   710,   711,   407,   408,     0,
       0,     0,   409,   410,     0,     0,     0,     0,   411,     0,
       0,     0,     0,     0,     0,     0,     0,   412,     0,   413,
       0,   414,   415,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   417,   418,   419,   420,   421,   422,   423,
     424,   712,   425,   426,   427,   713,   714,   715,   716,   717,
     718,   719,   428,   429,   720,   430,   133,   431,   432,   433,
     135,   136,   137,   138,   139,   721,   434,   435,   436,   437,
     438,   722,   723,   439,   440,   724,   140,   442,   725,   443,
     444,   445,   446,   144,   726,   727,   447,   448,   449,   450,
     147,   451,   728,   729,   453,   454,   455,   456,   457,   458,
     730,   459,   460,   461,   150,   462,   731,   732,   733,   734,
     151,   735,   736,   737,   463,   464,   465,   466,   467,   468,
     154,   155,   469,   738,   470,   739,   471,   472,   473,   474,
     475,   740,   476,   477,   478,   741,   742,   479,   480,   481,
     482,   483,   743,   484,   485,   486,   744,   487,   488,   745,
     489,   490,   491,   492,   164,   493,   494,   166,   746,   495,
     747,   496,   168,   497,   748,   498,   749,   499,   169,   750,
     170,   500,   501,   502,   751,   503,   172,   752,   504,   753,
     505,   506,   507,   508,   509,   173,   510,   511,   512,   754,
     513,   514,   515,   516,   517,   518,   755,   519,   174,   175,
     756,   520,   521,   522,   757,   177,   758,   178,   759,   523,
     179,   180,   524,   181,   525,   526,   527,   528,   529,   530,
     760,   182,   183,   531,   184,   761,   532,   533,   534,   762,
     763,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   189,   190,   191,   548,   549,   550,
     551,   552,   553,   554,   192,   555,   764,   556,   557,   194,
     558,   765,   195,   559,   196,   560,   561,   562,   766,   563,
     767,   768,   564,   565,   566,   769,   770,   197,   198,   199,
     200,   201,   567,   568,   569,   570,   571,   572,   771,   573,
     202,   574,   203,   575,   576,   577,   772,   578,   579,   580,
     581,   582,   583,   584,   205,   585,   586,   587,   773,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   774,
     598,   599,   211,   600,   601,   213,   602,   603,   604,   605,
     606,   607,   608,   609,   775,   610,   611,   612,   613,   614,
     776,   615,   217,   616,   617,   219,   618,   220,   777,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   222,
     629,   778,   630,   631,   779,   632,   633,   634,   635,   636,
     637,   780,   224,   225,   781,   782,   639,   226,   640,   227,
     783,   641,   642,   643,   644,   645,   646,   784,   785,   647,
     648,   649,   650,   786,   787,   651,   652,   653,   654,   788,
     235,   789,   656,   236,   657,   658,   659,   790,   791,   660,
     792,   793,   661,   662,   663,   664,   665,   238,   239,   240,
     241,   242,   243,   244,   245,   666,   667,   668,   705,    86,
      87,    88,   403,    90,    91,    92,   404,  2151,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,   706,   104,
     105,   406,   707,     0,   107,   108,   109,   110,   708,   709,
     112,   113,   114,   115,     0,   116,   710,   711,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,   133,   431,   432,
     433,     0,  1784,   137,  1785,  1786,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,  1787,  1788,   442,     0,
     443,   444,   445,   446,     0,     0,     0,   447,   448,   449,
     450,   147,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   150,   462,     0,     0,     0,
       0,   151,     0,     0,     0,   463,   464,   465,   466,   467,
     468,  1789,  1790,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
    1419,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,     0,   496,  1791,   497,     0,   498,     0,   499,   169,
       0,   170,   500,   501,   502,     0,   503,     0,     0,   504,
       0,   505,   506,   507,   508,   509,   173,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,   174,
       0,     0,   520,   521,   522,  1425,  1792,     0,  1793,     0,
     523,   179,   180,   524,   181,   525,   526,   527,   528,   529,
     530,     0,     0,   183,   531,   184,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,  1794,   190,  1795,   548,   549,
     550,   551,   552,   553,   554,     0,   555,     0,   556,   557,
     194,   558,     0,     0,   559,  1796,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,     0,   198,
     199,   200,     0,   567,   568,   569,   570,   571,   572,     0,
     573,     0,   574,     0,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,  1797,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,   211,   600,   601,     0,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,  1798,   616,   617,   219,   618,  1799,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
       0,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,  1800,  1801,     0,     0,   639,     0,   640,
       0,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
       0,  1802,     0,   656,   236,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,     0,     0,
       0,     0,     0,     0,     0,     0,   666,   667,   668,     0,
      86,    87,    88,   403,    90,    91,    92,   404,  2253,   405,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   406,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,   115,     0,   116,     0,     0,   407,
     408,     0,     0,     0,   409,   410,     0,     0,     0,     0,
     411,     0,     0,     0,     0,     0,     0,     0,     0,   412,
       0,   413,     0,   414,   415,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   427,     0,     0,     0,
       0,     0,     0,     0,   428,   429,     0,   430,     0,   431,
     432,   433,   135,   136,     0,   138,   139,     0,   434,   435,
     436,   437,   438,     0,     0,   439,   440,   441,   140,   442,
       0,   443,   444,   445,   446,   144,     0,     0,   447,   448,
     449,   450,     0,   451,   452,     0,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,     0,   462,     0,     0,
       0,     0,     0,     0,     0,     0,   463,   464,   465,   466,
     467,   468,   154,   155,   469,     0,   470,     0,   471,   472,
     473,   474,   475,     0,   476,   477,   478,     0,     0,   479,
     480,   481,   482,   483,     0,   484,   485,   486,     0,   487,
     488,     0,   489,   490,   491,   492,   164,   493,   494,   166,
       0,   495,     0,   496,   168,   497,     0,   498,     0,   499,
       0,     0,     0,   500,   501,   502,     0,   503,   172,     0,
     504,     0,   505,   506,   507,   508,   509,     0,   510,   511,
     512,     0,   513,   514,   515,   516,   517,   518,     0,   519,
       0,   175,     0,   520,   521,   522,     0,   177,     0,   178,
       0,   523,     0,     0,   524,     0,   525,   526,   527,   528,
     529,   530,     0,   182,     0,   531,     0,     0,   532,   533,
     534,     0,     0,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   189,     0,   191,   548,
     549,   550,   551,   552,   553,   554,   192,   555,     0,   556,
     557,     0,   558,     0,   195,   559,   196,   560,   561,   562,
       0,   563,     0,     0,   564,   565,   566,     0,     0,   197,
       0,     0,     0,   201,   567,   568,   569,   570,   571,   572,
       0,   573,   202,   574,   203,   575,   576,   577,     0,   578,
     579,   580,   581,   582,   583,   584,   205,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,     0,   598,   599,     0,   600,   601,   213,   602,   603,
     604,   605,   606,   607,   608,   609,     0,   610,   611,   612,
     613,   614,     0,   615,   217,   616,   617,     0,   618,   220,
       0,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   222,   629,     0,   630,   631,     0,   632,   633,   634,
     635,   636,   637,     0,   224,   225,     0,     0,   639,   226,
     640,   227,     0,   641,   642,   643,   644,   645,   646,     0,
       0,   647,   648,   649,   650,     0,     0,   651,   652,   653,
     654,   655,   235,     0,   656,     0,   657,   658,   659,     0,
       0,   660,     0,     0,   661,   662,   663,   664,   665,   238,
     239,   240,   241,   242,   243,   244,   245,   666,   667,   668,
       0,    86,    87,    88,   403,    90,    91,    92,   404,  1051,
     405,    95,     0,     0,    98,    99,   100,   101,   102,   103,
       0,   104,   105,   406,     0,     0,   107,   108,   109,   110,
       0,     0,   112,   113,   114,   115,     0,   116,     0,     0,
     407,   408,     0,     0,     0,   409,   410,     0,     0,     0,
       0,   411,     0,     0,     0,     0,     0,     0,     0,     0,
     412,     0,   413,     0,   414,   415,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,     0,     0,
       0,     0,     0,     0,     0,   428,   429,     0,   430,     0,
     431,   432,   433,   135,   136,     0,   138,   139,     0,   434,
     435,   436,   437,   438,     0,     0,   439,   440,   441,   140,
     442,     0,   443,   444,   445,   446,   144,     0,     0,   447,
     448,   449,   450,     0,   451,   452,     0,   453,   454,   455,
     456,   457,   458,     0,   459,   460,   461,     0,   462,     0,
       0,     0,     0,     0,     0,     0,     0,   463,   464,   465,
     466,   467,   468,   154,   155,   469,     0,   470,     0,   471,
     472,   473,   474,   475,     0,   476,   477,   478,     0,     0,
     479,   480,   481,   482,   483,     0,   484,   485,   486,     0,
     487,   488,     0,   489,   490,   491,   492,   164,   493,   494,
     166,     0,   495,     0,   496,   168,   497,     0,   498,     0,
     499,     0,     0,     0,   500,   501,   502,     0,   503,   172,
       0,   504,     0,   505,   506,   507,   508,   509,     0,   510,
     511,   512,     0,   513,   514,   515,   516,   517,   518,     0,
     519,     0,   175,     0,   520,   521,   522,     0,   177,     0,
     178,     0,   523,     0,     0,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   182,     0,   531,     0,     0,   532,
     533,   534,     0,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   189,     0,   191,
     548,   549,   550,   551,   552,   553,   554,   192,   555,     0,
     556,   557,     0,   558,     0,   195,   559,   196,   560,   561,
     562,     0,   563,     0,     0,   564,   565,   566,     0,     0,
     197,     0,     0,     0,   201,   567,   568,   569,   570,   571,
     572,     0,   573,   202,   574,   203,   575,   576,   577,     0,
     578,   579,   580,   581,   582,   583,   584,   205,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,     0,   598,   599,     0,   600,   601,   213,   602,
     603,   604,   605,   606,   607,   608,   609,     0,   610,   611,
     612,   613,   614,     0,   615,   217,   616,   617,     0,   618,
     220,     0,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   222,   629,     0,   630,   631,     0,   632,   633,
     634,   635,   636,   637,     0,   224,   225,     0,     0,   639,
     226,   640,   227,     0,   641,   642,   643,   644,   645,   646,
       0,     0,   647,   648,   649,   650,     0,     0,   651,   652,
     653,   654,   655,   235,     0,   656,     0,   657,   658,   659,
       0,     0,   660,     0,     0,   661,   662,   663,   664,   665,
     238,   239,   240,   241,   242,   243,   244,   245,   666,   667,
     668,     0,    86,    87,    88,   403,    90,    91,    92,   404,
    4089,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,   416,     0,
       0,    37,    38,    39,    40,    41,    42,    43,    44,     0,
       0,     0,    45,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,  2139,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,  1927,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,  1928,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,  1929,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,     0,     0,     0,     0,     0,     0,     0,   962,
    1595,    86,    87,    88,   403,    90,    91,    92,   404,     0,
     405,    95,     0,     0,    98,    99,   100,   101,   102,   103,
       0,   104,   105,   406,     0,     0,   107,   108,   109,   110,
       0,     0,   112,   113,   114,   115,     0,   116,     0,     0,
     407,   408,     0,     0,     0,   409,   410,     0,     0,     0,
       0,   411,     0,     0,     0,     0,     0,     0,     0,     0,
     412,     0,   413,     0,   414,   415,    35,   416,     0,     0,
      37,    38,    39,    40,    41,    42,    43,    44,     0,     0,
       0,    45,     0,     0,     0,     0,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,     0,     0,
       0,     0,     0,     0,     0,   428,   429,     0,   430,     0,
     431,   432,   433,   135,   136,     0,   138,   139,     0,   434,
     435,   436,   437,   438,     0,     0,   439,   440,   441,   140,
     442,     0,   443,   444,   445,   446,   144,     0,     0,   447,
     448,   449,   450,     0,   451,   452,     0,   453,   454,   455,
     456,   457,   458,     0,   459,   460,   461,     0,   462,     0,
       0,     0,     0,     0,     0,     0,     0,   463,   464,   465,
     466,   467,   468,   154,   155,   469,  2144,   470,     0,   471,
     472,   473,   474,   475,     0,   476,   477,   478,     0,     0,
     479,   480,   481,   482,   483,     0,   484,   485,   486,     0,
     487,   488,     0,   489,   490,   491,   492,   164,   493,   494,
     166,  1927,   495,     0,   496,   168,   497,     0,   498,     0,
     499,     0,     0,     0,   500,   501,   502,     0,   503,   172,
       0,   504,     0,   505,   506,   507,   508,   509,     0,   510,
     511,   512,     0,   513,   514,   515,   516,   517,   518,     0,
     519,     0,   175,     0,   520,   521,   522,     0,   177,     0,
     178,     0,   523,     0,     0,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   182,     0,   531,     0,     0,   532,
     533,   534,     0,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   189,     0,   191,
     548,   549,   550,   551,   552,   553,   554,   192,   555,     0,
     556,   557,     0,   558,     0,   195,   559,   196,   560,   561,
     562,     0,   563,  1928,     0,   564,   565,   566,     0,     0,
     197,     0,     0,     0,   201,   567,   568,   569,   570,   571,
     572,     0,   573,   202,   574,   203,   575,   576,   577,     0,
     578,   579,   580,   581,   582,   583,   584,   205,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,     0,   598,   599,     0,   600,   601,   213,   602,
     603,   604,   605,   606,   607,   608,   609,     0,   610,   611,
     612,   613,   614,     0,   615,   217,   616,   617,     0,   618,
     220,     0,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   222,   629,     0,   630,   631,     0,   632,   633,
     634,   635,   636,   637,     0,   224,   225,     0,     0,   639,
     226,   640,   227,  1929,   641,   642,   643,   644,   645,   646,
       0,     0,   647,   648,   649,   650,     0,     0,   651,   652,
     653,   654,   655,   235,     0,   656,     0,   657,   658,   659,
       0,     0,   660,     0,     0,   661,   662,   663,   664,   665,
     238,   239,   240,   241,   242,   243,   244,   245,   666,   667,
     668,     0,     0,     0,     0,     0,     0,     0,   962,  1595,
      86,    87,    88,   403,    90,    91,    92,   404,     0,   405,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   406,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,   115,     0,   116,     0,     0,   407,
     408,     0,     0,     0,   409,   410,     0,     0,     0,     0,
     411,     0,     0,     0,     0,     0,     0,     0,     0,   412,
       0,   413,     0,   414,   415,    35,   416,     0,     0,    37,
      38,    39,    40,    41,    42,    43,    44,     0,     0,     0,
      45,     0,     0,     0,     0,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   427,     0,     0,     0,
       0,     0,     0,     0,   428,   429,     0,   430,     0,   431,
     432,   433,   135,   136,     0,   138,   139,     0,   434,   435,
     436,   437,   438,     0,     0,   439,   440,   441,   140,   442,
       0,   443,   444,   445,   446,   144,     0,     0,   447,   448,
     449,   450,     0,   451,   452,     0,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,     0,   462,     0,     0,
       0,     0,     0,     0,     0,     0,   463,   464,   465,   466,
     467,   468,   154,   155,   469,     0,   470,     0,   471,   472,
     473,   474,   475,     0,   476,   477,   478,     0,     0,   479,
     480,   481,   482,   483,     0,   484,   485,   486,     0,   487,
     488,     0,   489,   490,   491,   492,   164,   493,   494,   166,
    1927,   495,     0,   496,   168,   497,     0,   498,     0,   499,
       0,     0,     0,   500,   501,   502,     0,   503,   172,     0,
     504,     0,   505,   506,   507,   508,   509,     0,   510,   511,
     512,     0,   513,   514,   515,   516,   517,   518,     0,   519,
       0,   175,     0,   520,   521,   522,     0,   177,     0,   178,
       0,   523,     0,     0,   524,     0,   525,   526,   527,   528,
     529,   530,     0,   182,     0,   531,     0,     0,   532,   533,
     534,     0,     0,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   189,     0,   191,   548,
     549,   550,   551,   552,   553,   554,   192,   555,     0,   556,
     557,     0,   558,     0,   195,   559,   196,   560,   561,   562,
       0,   563,  1928,     0,   564,   565,   566,     0,     0,   197,
       0,     0,     0,   201,   567,   568,   569,   570,   571,   572,
       0,   573,   202,   574,   203,   575,   576,   577,     0,   578,
     579,   580,   581,   582,   583,   584,   205,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,     0,   598,   599,     0,   600,   601,   213,   602,   603,
     604,   605,   606,   607,   608,   609,     0,   610,   611,   612,
     613,   614,     0,   615,   217,   616,   617,     0,   618,   220,
       0,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   222,   629,     0,   630,   631,     0,   632,   633,   634,
     635,   636,   637,     0,   224,   225,     0,     0,   639,   226,
     640,   227,  1929,   641,   642,   643,   644,   645,   646,     0,
       0,   647,   648,   649,   650,     0,     0,   651,   652,   653,
     654,   655,   235,     0,   656,     0,   657,   658,   659,     0,
       0,   660,     0,     0,   661,   662,   663,   664,   665,   238,
     239,   240,   241,   242,   243,   244,   245,   666,   667,   668,
       0,     0,     0,     0,     0,     0,     0,   962,  1595,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,   416,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,    45,
       0,     0,     0,     0,   417,   951,   419,   420,   421,   422,
     423,   424,   952,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   953,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   954,   168,   497,     0,   498,     0,   955,     0,
     956,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
     957,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   958,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   959,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   960,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   961,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,     0,
       0,     0,     0,     0,     0,     0,   962,   963,    86,    87,
      88,   403,    90,    91,    92,   404,     0,   405,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     406,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,   115,     0,   116,     0,     0,   407,   408,     0,
       0,     0,   409,   410,     0,     0,     0,     0,   411,     0,
       0,     0,     0,     0,     0,     0,     0,   412,     0,   413,
       0,   414,   415,    35,   416,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,    45,     0,
       0,     0,     0,   417,   951,   419,   420,   421,   422,   423,
     424,   952,   425,   426,   427,     0,     0,     0,     0,     0,
       0,     0,   428,   429,     0,   430,     0,   985,   432,   433,
     135,   136,     0,   138,   139,     0,   434,   435,   436,   437,
     438,     0,     0,   439,   440,   441,   140,   442,     0,   443,
     444,   445,   446,   144,     0,     0,   447,   448,   449,   450,
       0,   451,   452,     0,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,     0,   462,     0,     0,     0,     0,
       0,     0,     0,     0,   463,   464,   465,   466,   467,   468,
     154,   155,   469,     0,   470,     0,   471,   472,   473,   474,
     475,     0,   476,   477,   478,     0,     0,   479,   480,   481,
     482,   483,     0,   484,   485,   486,     0,   487,   488,     0,
     489,   490,   491,   492,   164,   493,   494,   166,     0,   495,
       0,   954,   168,   497,     0,   498,     0,   986,     0,   956,
       0,   500,   501,   502,     0,   503,   172,     0,   504,     0,
     505,   506,   507,   508,   509,     0,   510,   511,   512,   957,
     513,   514,   515,   516,   517,   518,     0,   519,     0,   175,
       0,   520,   521,   522,     0,   177,     0,   178,     0,   523,
       0,     0,   524,     0,   525,   526,   527,   958,   529,   530,
       0,   182,     0,   531,     0,     0,   532,   533,   534,     0,
       0,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   189,     0,   191,   959,   549,   550,
     551,   552,   553,   554,   192,   555,     0,   556,   557,     0,
     558,     0,   195,   559,   196,   560,   561,   562,     0,   563,
       0,     0,   564,   565,   566,     0,     0,   197,     0,     0,
       0,   201,   567,   568,   569,   570,   571,   572,     0,   573,
     202,   574,   203,   575,   576,   577,     0,   960,   579,   580,
     581,   582,   583,   584,   205,   585,   586,   587,     0,   588,
     961,   590,   591,   592,   593,   594,   595,   596,   597,     0,
     598,   599,     0,   600,   601,   213,   602,   603,   604,   605,
     606,   607,   608,   609,     0,   610,   611,   612,   613,   614,
       0,   615,   217,   616,   617,     0,   618,   220,     0,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   222,
     629,     0,   630,   631,     0,   632,   633,   634,   635,   636,
     637,     0,   224,   225,     0,     0,   639,   226,   640,   227,
       0,   641,   642,   643,   644,   645,   646,     0,     0,   647,
     648,   649,   650,     0,     0,   651,   652,   653,   654,   655,
     235,     0,   656,     0,   657,   658,   659,     0,     0,   660,
       0,     0,   661,   662,   663,   664,   665,   238,   239,   240,
     241,   242,   243,   244,   245,   666,   667,   668,     0,     0,
       0,     0,     0,     0,     0,   962,   963,    86,    87,    88,
     403,    90,    91,    92,   404,     0,   405,    95,     0,     0,
      98,    99,   100,   101,   102,   103,     0,   104,   105,   406,
       0,     0,   107,   108,   109,   110,     0,     0,   112,   113,
     114,   115,     0,   116,     0,     0,   407,   408,     0,     0,
       0,   409,   410,     0,     0,     0,     0,   411,     0,     0,
       0,     0,     0,     0,     0,     0,   412,     0,   413,     0,
     414,   415,    35,   416,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,    45,     0,     0,
       0,     0,   417,   418,   419,   420,   421,   422,   423,   424,
    1335,   425,   426,   427,     0,     0,     0,     0,     0,     0,
       0,   428,   429,     0,   430,     0,   431,   432,   433,   135,
     136,     0,   138,   139,     0,   434,   435,   436,   437,   438,
       0,     0,   439,   440,   441,   140,   442,     0,   443,   444,
     445,   446,   144,     0,     0,   447,   448,   449,   450,     0,
     451,   452,     0,   453,   454,   455,   456,   457,   458,     0,
     459,   460,   461,     0,   462,     0,     0,     0,     0,     0,
       0,     0,     0,   463,   464,   465,   466,   467,   468,   154,
     155,   469,     0,   470,     0,   471,   472,   473,   474,   475,
       0,   476,   477,   478,     0,     0,   479,   480,   481,   482,
     483,     0,   484,   485,   486,     0,   487,   488,     0,   489,
     490,   491,   492,   164,   493,   494,   166,     0,   495,     0,
     496,   168,   497,     0,   498,     0,   499,     0,   956,     0,
     500,   501,   502,     0,   503,   172,     0,   504,     0,   505,
     506,   507,   508,   509,     0,   510,   511,   512,   957,   513,
     514,   515,   516,   517,   518,     0,   519,     0,   175,     0,
     520,   521,   522,     0,   177,     0,   178,     0,   523,     0,
       0,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     182,     0,   531,     0,     0,   532,   533,   534,     0,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   189,     0,   191,   548,   549,   550,   551,
     552,   553,   554,   192,   555,     0,   556,   557,     0,   558,
       0,   195,   559,   196,   560,   561,   562,     0,   563,     0,
       0,   564,   565,   566,     0,     0,   197,     0,     0,     0,
     201,   567,   568,   569,   570,   571,   572,     0,   573,   202,
     574,   203,   575,   576,   577,     0,   578,   579,   580,   581,
     582,   583,   584,   205,   585,   586,   587,     0,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,     0,   598,
     599,     0,   600,   601,   213,   602,   603,   604,   605,   606,
     607,   608,   609,     0,   610,   611,   612,   613,   614,     0,
     615,   217,   616,   617,     0,   618,   220,     0,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   222,   629,
       0,   630,   631,     0,   632,   633,   634,   635,   636,   637,
       0,   224,   225,     0,     0,   639,   226,   640,   227,     0,
     641,   642,   643,   644,   645,   646,     0,     0,   647,   648,
     649,   650,     0,     0,   651,   652,   653,   654,   655,   235,
       0,   656,     0,   657,   658,   659,     0,     0,   660,     0,
       0,   661,   662,   663,   664,   665,   238,   239,   240,   241,
     242,   243,   244,   245,   666,   667,   668,     0,     0,     0,
       0,     0,     0,     0,   962,   963,    86,    87,    88,   403,
      90,    91,    92,   404,     0,   405,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   406,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
     115,     0,   116,     0,     0,   407,   408,     0,     0,     0,
     409,   410,     0,     0,     0,     0,   411,     0,     0,     0,
       0,     0,     0,     0,     0,   412,     0,   413,     0,   414,
     415,    35,   416,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,    45,     0,     0,     0,
       0,   417,   418,   419,   420,   421,   422,   423,   424,  1340,
     425,   426,   427,     0,     0,     0,     0,     0,     0,     0,
     428,   429,     0,   430,     0,   431,   432,   433,   135,   136,
       0,   138,   139,     0,   434,   435,   436,   437,   438,     0,
       0,   439,   440,   441,   140,   442,     0,   443,   444,   445,
     446,   144,     0,     0,   447,   448,   449,   450,     0,   451,
     452,     0,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,     0,   462,     0,     0,     0,     0,     0,     0,
       0,     0,   463,   464,   465,   466,   467,   468,   154,   155,
     469,     0,   470,     0,   471,   472,   473,   474,   475,     0,
     476,   477,   478,     0,     0,   479,   480,   481,   482,   483,
       0,   484,   485,   486,     0,   487,   488,     0,   489,   490,
     491,   492,   164,   493,   494,   166,     0,   495,     0,   496,
     168,   497,     0,   498,     0,   499,     0,   956,     0,   500,
     501,   502,     0,   503,   172,     0,   504,     0,   505,   506,
     507,   508,   509,     0,   510,   511,   512,   957,   513,   514,
     515,   516,   517,   518,     0,   519,     0,   175,     0,   520,
     521,   522,     0,   177,     0,   178,     0,   523,     0,     0,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   182,
       0,   531,     0,     0,   532,   533,   534,     0,     0,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   189,     0,   191,   548,   549,   550,   551,   552,
     553,   554,   192,   555,     0,   556,   557,     0,   558,     0,
     195,   559,   196,   560,   561,   562,     0,   563,     0,     0,
     564,   565,   566,     0,     0,   197,     0,     0,     0,   201,
     567,   568,   569,   570,   571,   572,     0,   573,   202,   574,
     203,   575,   576,   577,     0,   578,   579,   580,   581,   582,
     583,   584,   205,   585,   586,   587,     0,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,     0,   598,   599,
       0,   600,   601,   213,   602,   603,   604,   605,   606,   607,
     608,   609,     0,   610,   611,   612,   613,   614,     0,   615,
     217,   616,   617,     0,   618,   220,     0,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   222,   629,     0,
     630,   631,     0,   632,   633,   634,   635,   636,   637,     0,
     224,   225,     0,     0,   639,   226,   640,   227,     0,   641,
     642,   643,   644,   645,   646,     0,     0,   647,   648,   649,
     650,     0,     0,   651,   652,   653,   654,   655,   235,     0,
     656,     0,   657,   658,   659,     0,     0,   660,     0,     0,
     661,   662,   663,   664,   665,   238,   239,   240,   241,   242,
     243,   244,   245,   666,   667,   668,     0,     0,     0,     0,
       0,     0,     0,   962,   963,    86,    87,    88,   403,    90,
      91,    92,   404,     0,   405,    95,     0,     0,    98,    99,
     100,   101,   102,   103,     0,   104,   105,   406,     0,     0,
     107,   108,   109,   110,     0,     0,   112,   113,   114,   115,
       0,   116,     0,     0,   407,   408,     0,     0,     0,   409,
     410,     0,     0,     0,     0,   411,     0,     0,     0,     0,
       0,     0,     0,     0,   412,     0,   413,     0,   414,   415,
      35,   416,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   427,     0,     0,     0,     0,     0,     0,     0,   428,
     429,     0,   430,     0,   431,   432,   433,   135,   136,     0,
     138,   139,     0,   434,   435,   436,   437,   438,     0,     0,
     439,   440,   441,   140,   442,     0,   443,   444,   445,   446,
     144,     0,     0,   447,   448,   449,   450,     0,   451,   452,
       0,   453,   454,   455,   456,   457,   458,     0,   459,   460,
     461,     0,   462,     0,     0,     0,     0,     0,     0,     0,
       0,   463,   464,   465,   466,   467,   468,   154,   155,   469,
     690,   470,     0,   471,   472,   473,   474,   475,     0,   476,
     477,   478,     0,     0,   479,   480,   481,   482,   483,     0,
     484,   485,   486,     0,   487,   488,     0,   489,   490,   491,
     492,   164,   493,   494,   166,     0,   495,     0,   496,   168,
     497,     0,   498,     0,   499,     0,     0,     0,   500,   501,
     502,     0,   503,   172,     0,   504,     0,   505,   506,   507,
     508,   509,     0,   510,   511,   512,     0,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   175,     0,   520,   521,
     522,     0,   177,     0,   178,     0,   523,     0,     0,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   182,     0,
     531,     0,     0,   532,   533,   534,     0,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   189,     0,   191,   548,   549,   550,   551,   552,   553,
     554,   192,   555,     0,   556,   557,     0,   558,     0,   195,
     559,   196,   560,   561,   562,     0,   563,     0,     0,   564,
     565,   566,     0,     0,   197,     0,     0,     0,   201,   567,
     568,   569,   570,   571,   572,     0,   573,   202,   574,   203,
     575,   576,   577,     0,   578,   579,   580,   581,   582,   583,
     584,   205,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,     0,   598,   599,     0,
     600,   601,   213,   602,   603,   604,   605,   606,   607,   608,
     609,     0,   610,   611,   612,   613,   614,     0,   615,   217,
     616,   617,     0,   618,   220,     0,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   222,   629,     0,   630,
     631,     0,   632,   633,   634,   635,   636,   637,     0,   224,
     225,  1500,     0,   639,   226,   640,   227,     0,   641,   642,
     643,   644,   645,   646,     0,     0,   647,   648,   649,   650,
       0,     0,   651,   652,   653,   654,   655,   235,     0,   656,
       0,   657,   658,   659,     0,     0,   660,     0,     0,   661,
     662,   663,   664,   665,   238,   239,   240,   241,   242,   243,
     244,   245,   666,   667,   668,     0,     0,  1023,  1501,    86,
      87,    88,   403,    90,    91,    92,   404,  1024,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,  1025,   440,  1000,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,  1026,     0,  1027,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,  1028,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,  1029,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,  1030,   601,   213,   602,   603,   604,
    1031,   606,   607,   608,   609,     0,   610,   611,   612,   613,
    1032,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,  1033,   225,     0,     0,  1034,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
    1004,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,  1035,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,   705,
      86,    87,    88,   403,    90,    91,    92,   404,     0,   405,
      95,     0,     0,    98,    99,   100,   101,   102,   103,   706,
     104,   105,   406,   707,     0,   107,   108,   109,   110,   708,
     709,   112,   113,   114,   115,     0,   116,   710,   711,   407,
     408,     0,     0,     0,   409,   410,     0,     0,     0,     0,
     411,     0,     0,     0,     0,     0,     0,     0,     0,   412,
       0,   413,     0,   414,   415,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   417,   418,   419,   420,   421,
     422,   423,   424,   712,   425,   426,   427,   713,   714,   715,
     716,   717,   718,   719,   428,   429,   720,   430,   133,   431,
     432,   433,   135,   136,   137,   138,   139,   721,   434,   435,
     436,   437,   438,   722,   723,   439,   440,   724,   140,   442,
     725,   443,   444,   445,   446,   144,   726,   727,   447,   448,
     449,   450,   147,   451,   728,   729,   453,   454,   455,   456,
     457,   458,   730,   459,   460,   461,   150,   462,   731,   732,
     733,   734,   151,   735,   736,   737,   463,   464,   465,   466,
     467,   468,   154,   155,   469,   738,   470,   739,   471,   472,
     473,   474,   475,   740,   476,   477,   478,   741,   742,   479,
     480,   481,   482,   483,   743,   484,   485,   486,   744,   487,
     488,   745,   489,   490,   491,   492,   164,   493,   494,   166,
     746,   495,   747,   496,   168,   497,   748,   498,   749,   499,
     169,   750,   170,   500,   501,   502,   751,   503,   172,   752,
     504,   753,   505,   506,   507,   508,   509,   173,   510,   511,
     512,   754,   513,   514,   515,   516,   517,   518,   755,   519,
     174,   175,   756,   520,   521,   522,   757,   177,   758,   178,
     759,   523,   179,   180,   524,   181,   525,   526,   527,   528,
     529,   530,   760,   182,   183,   531,   184,   761,   532,   533,
     534,   762,   763,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   189,   190,   191,   548,
     549,   550,   551,   552,   553,   554,   192,   555,   764,   556,
     557,   194,   558,   765,   195,   559,   196,   560,   561,   562,
     766,   563,   767,   768,   564,   565,   566,   769,   770,   197,
     198,   199,   200,   201,   567,   568,   569,   570,   571,   572,
     771,   573,   202,   574,   203,   575,   576,   577,   772,   578,
     579,   580,   581,   582,   583,   584,   205,   585,   586,   587,
     773,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   774,   598,   599,   211,   600,   601,   213,   602,   603,
     604,   605,   606,   607,   608,   609,   775,   610,   611,   612,
     613,   614,   776,   615,   217,   616,   617,   219,   618,   220,
     777,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   222,   629,   778,   630,   631,   779,   632,   633,   634,
     635,   636,   637,   780,   224,   225,   781,   782,   639,   226,
     640,   227,   783,   641,   642,   643,   644,   645,   646,   784,
     785,   647,   648,   649,   650,   786,   787,   651,   652,   653,
     654,   788,   235,   789,   656,   236,   657,   658,   659,   790,
     791,   660,   792,   793,   661,   662,   663,   664,   665,   238,
     239,   240,   241,   242,   243,   244,   245,   666,   667,   668,
     705,    86,    87,    88,   403,    90,    91,    92,   404,     0,
     405,    95,     0,     0,    98,    99,   100,   101,   102,   103,
     706,   104,   105,   406,   707,     0,   107,   108,   109,   110,
     708,   709,   112,   113,   114,   115,     0,   116,   710,   711,
     407,   408,     0,     0,     0,   409,   410,     0,     0,     0,
       0,   411,     0,     0,     0,     0,     0,     0,     0,     0,
     412,     0,   413,     0,   414,   415,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   417,   418,   419,   420,
    2960,   422,   423,   424,   712,   425,   426,   427,   713,   714,
     715,   716,   717,   718,   719,   428,   429,   720,   430,   133,
     431,   432,   433,   135,   136,   137,   138,   139,   721,   434,
     435,   436,   437,   438,   722,   723,   439,   440,   724,   140,
     442,   725,   443,   444,   445,   446,   144,   726,   727,   447,
     448,   449,   450,   147,   451,   728,   729,   453,   454,   455,
     456,   457,   458,   730,   459,   460,   461,   150,   462,   731,
     732,   733,   734,   151,   735,   736,   737,   463,   464,   465,
     466,   467,   468,   154,   155,   469,   738,   470,   739,   471,
     472,   473,   474,   475,   740,   476,   477,   478,   741,   742,
     479,   480,   481,  2961,   483,   743,   484,   485,   486,   744,
     487,   488,   745,   489,   490,   491,   492,   164,   493,   494,
     166,   746,   495,   747,   496,   168,   497,   748,   498,   749,
     499,   169,   750,   170,   500,   501,   502,   751,   503,   172,
     752,   504,   753,   505,   506,   507,   508,   509,   173,   510,
     511,   512,   754,   513,   514,   515,   516,   517,   518,   755,
     519,   174,   175,   756,   520,   521,   522,   757,   177,   758,
     178,   759,   523,   179,   180,   524,   181,   525,   526,   527,
     528,   529,   530,   760,   182,   183,   531,   184,   761,   532,
     533,   534,   762,   763,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   189,   190,   191,
     548,   549,   550,   551,   552,   553,   554,   192,   555,   764,
     556,   557,   194,   558,   765,   195,   559,   196,   560,   561,
     562,   766,   563,   767,   768,   564,   565,   566,   769,   770,
     197,   198,   199,   200,   201,   567,   568,   569,   570,   571,
     572,   771,   573,   202,   574,   203,   575,   576,   577,   772,
     578,   579,   580,   581,   582,   583,   584,   205,   585,   586,
     587,   773,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   774,   598,   599,   211,   600,   601,   213,   602,
     603,   604,   605,   606,   607,   608,   609,   775,   610,   611,
     612,   613,   614,   776,  2962,   217,   616,   617,   219,   618,
     220,   777,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   222,   629,   778,   630,   631,   779,   632,   633,
     634,   635,   636,   637,   780,   224,   225,   781,   782,   639,
     226,   640,   227,   783,   641,   642,   643,   644,   645,   646,
     784,   785,   647,   648,   649,   650,   786,   787,   651,   652,
     653,   654,   788,   235,   789,   656,   236,   657,   658,   659,
     790,   791,   660,   792,   793,   661,   662,   663,   664,   665,
     238,   239,   240,   241,   242,   243,   244,   245,   666,   667,
     668,   705,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,   706,   104,   105,   406,   707,     0,   107,   108,   109,
     110,   708,   709,   112,   113,   114,   115,     0,   116,   710,
     711,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
     133,   431,   432,   433,   135,   136,   137,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,   147,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   150,   462,
       0,     0,     0,     0,   151,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,   169,     0,   170,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,   173,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,   174,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,   179,   180,   524,   181,   525,   526,
     527,   528,   529,   530,     0,   182,   183,   531,   184,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,   190,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,   194,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,   198,   199,   200,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,   211,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,   219,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,   236,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,   705,    86,    87,    88,   403,    90,    91,    92,
     404,     0,   405,    95,     0,     0,    98,    99,   100,   101,
     102,   103,   706,   104,   105,   406,   707,     0,   107,   108,
     109,   110,   708,   709,   112,   113,   114,   115,     0,   116,
     710,   711,   407,   408,     0,     0,     0,   409,   410,     0,
       0,     0,     0,   411,     0,     0,     0,     0,     0,     0,
       0,     0,   412,     0,   413,     0,   414,   415,    35,     0,
       0,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   427,
       0,     0,     0,     0,     0,     0,     0,   428,   429,     0,
     430,   133,   431,   432,   433,   135,   136,   137,   138,   139,
       0,   434,   435,   436,   437,   438,     0,     0,   439,   440,
     441,   140,   442,     0,   443,   444,   445,   446,   144,     0,
       0,   447,   448,   449,   450,   147,   451,   452,     0,   453,
     454,   455,   456,   457,   458,     0,   459,   460,   461,   150,
     462,     0,     0,     0,     0,   151,     0,     0,     0,   463,
     464,   465,   466,   467,   468,   154,   155,   469,     0,   470,
       0,   471,   472,   473,   474,   475,     0,   476,   477,   478,
       0,     0,   479,   480,   481,   482,   483,     0,   484,   485,
     486,     0,   487,   488,     0,   489,   490,   491,   492,   164,
     493,   494,   166,     0,   495,     0,   496,   168,   497,     0,
     498,     0,   499,   169,     0,   170,   500,   501,   502,     0,
     503,   172,     0,   504,     0,   505,   506,   507,   508,  1272,
     173,   510,   511,   512,     0,   513,   514,   515,   516,   517,
     518,     0,   519,   174,   175,     0,   520,   521,   522,     0,
     177,     0,   178,     0,   523,   179,   180,   524,   181,   525,
     526,   527,   528,   529,   530,     0,   182,   183,   531,   184,
       0,   532,   533,   534,     0,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   189,
     190,   191,   548,   549,   550,   551,   552,   553,   554,   192,
     555,     0,   556,   557,   194,   558,     0,   195,   559,   196,
     560,   561,   562,     0,   563,     0,     0,   564,   565,   566,
       0,     0,   197,   198,   199,   200,   201,   567,   568,   569,
     570,   571,   572,     0,   573,   202,   574,   203,   575,   576,
     577,     0,   578,   579,   580,   581,   582,   583,   584,   205,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,     0,   598,   599,   211,   600,   601,
     213,   602,   603,   604,   605,   606,   607,   608,   609,     0,
     610,   611,   612,   613,   614,     0,   615,   217,   616,   617,
     219,   618,   220,     0,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   222,   629,     0,   630,   631,     0,
     632,   633,   634,   635,   636,   637,     0,   224,   225,     0,
       0,   639,   226,   640,   227,     0,   641,   642,   643,   644,
     645,   646,     0,     0,   647,   648,   649,   650,     0,     0,
     651,   652,   653,   654,   655,   235,     0,   656,   236,   657,
     658,   659,     0,     0,   660,     0,     0,   661,   662,   663,
     664,   665,   238,   239,   240,   241,   242,   243,   244,   245,
     666,   667,   668,   705,    86,    87,    88,   403,    90,    91,
      92,   404,     0,   405,    95,     0,     0,    98,    99,   100,
     101,   102,   103,   706,   104,   105,   406,   707,     0,   107,
     108,   109,   110,   708,   709,   112,   113,   114,   115,     0,
     116,   710,   711,   407,   408,     0,     0,     0,   409,   410,
       0,     0,     0,     0,   411,     0,     0,     0,     0,     0,
       0,     0,     0,   412,     0,   413,     0,   414,   415,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     427,     0,     0,     0,     0,     0,     0,     0,   428,   429,
       0,   430,   133,   431,   432,   433,   135,   136,   137,   138,
     139,     0,   434,   435,   436,   437,   438,     0,     0,   439,
     440,   441,   140,   442,     0,   443,   444,   445,   446,   144,
       0,     0,   447,   448,   449,   450,   147,   451,   452,     0,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     150,   462,     0,     0,     0,     0,   151,     0,     0,     0,
     463,   464,   465,   466,   467,   468,   154,   155,   469,     0,
     470,     0,   471,   472,   473,   474,   475,     0,   476,   477,
     478,     0,     0,   479,   480,   481,   482,   483,     0,   484,
     485,   486,     0,   487,   488,     0,   489,   490,   491,   492,
     164,   493,   494,   166,     0,   495,     0,   496,   168,   497,
       0,   498,     0,   499,   169,     0,   170,   500,   501,   502,
       0,   503,   172,     0,   504,     0,   505,   506,   507,   508,
    1280,   173,   510,   511,   512,     0,   513,   514,   515,   516,
     517,   518,     0,   519,   174,   175,     0,   520,   521,   522,
       0,   177,     0,   178,     0,   523,   179,   180,   524,   181,
     525,   526,   527,   528,   529,   530,     0,   182,   183,   531,
     184,     0,   532,   533,   534,     0,     0,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     189,   190,   191,   548,   549,   550,   551,   552,   553,   554,
     192,   555,     0,   556,   557,   194,   558,     0,   195,   559,
     196,   560,   561,   562,     0,   563,     0,     0,   564,   565,
     566,     0,     0,   197,   198,   199,   200,   201,   567,   568,
     569,   570,   571,   572,     0,   573,   202,   574,   203,   575,
     576,   577,     0,   578,   579,   580,   581,   582,   583,   584,
     205,   585,   586,   587,     0,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,     0,   598,   599,   211,   600,
     601,   213,   602,   603,   604,   605,   606,   607,   608,   609,
       0,   610,   611,   612,   613,   614,     0,   615,   217,   616,
     617,   219,   618,   220,     0,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   222,   629,     0,   630,   631,
       0,   632,   633,   634,   635,   636,   637,     0,   224,   225,
       0,     0,   639,   226,   640,   227,     0,   641,   642,   643,
     644,   645,   646,     0,     0,   647,   648,   649,   650,     0,
       0,   651,   652,   653,   654,   655,   235,     0,   656,   236,
     657,   658,   659,     0,     0,   660,     0,     0,   661,   662,
     663,   664,   665,   238,   239,   240,   241,   242,   243,   244,
     245,   666,   667,   668,   705,    86,    87,    88,   403,    90,
      91,    92,   404,     0,   405,    95,     0,     0,    98,    99,
     100,   101,   102,   103,   706,   104,   105,   406,   707,     0,
     107,   108,   109,   110,   708,   709,   112,   113,   114,   115,
       0,   116,   710,   711,   407,   408,     0,     0,     0,   409,
     410,     0,     0,     0,     0,   411,     0,     0,     0,     0,
       0,     0,     0,     0,   412,     0,   413,     0,   414,   415,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   427,     0,     0,     0,     0,     0,     0,     0,   428,
     429,     0,   430,   133,   431,   432,   433,     0,  1784,   137,
    1785,  1786,     0,   434,   435,   436,   437,   438,     0,     0,
     439,   440,  1787,  1788,   442,     0,   443,   444,   445,   446,
       0,     0,     0,   447,   448,   449,   450,   147,   451,   452,
       0,   453,   454,   455,   456,   457,   458,     0,   459,   460,
     461,   150,   462,     0,     0,     0,     0,   151,     0,     0,
       0,   463,   464,   465,   466,   467,   468,  1789,  1790,   469,
       0,   470,     0,   471,   472,   473,   474,   475,     0,   476,
     477,   478,     0,     0,   479,   480,  1419,   482,   483,     0,
     484,   485,   486,     0,   487,   488,     0,   489,   490,   491,
     492,     0,   493,   494,     0,     0,   495,     0,   496,  1791,
     497,     0,   498,     0,   499,   169,     0,   170,   500,   501,
     502,     0,   503,     0,     0,   504,     0,   505,   506,   507,
     508,   509,   173,   510,   511,   512,  2302,   513,   514,   515,
     516,   517,   518,     0,   519,   174,  2303,     0,   520,   521,
     522,  1425,  1792,     0,  1793,     0,   523,   179,   180,   524,
     181,   525,   526,   527,   528,   529,   530,     0,     0,   183,
     531,   184,     0,   532,   533,   534,     0,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,  1794,   190,  1795,   548,   549,   550,   551,   552,   553,
     554,     0,   555,     0,   556,   557,   194,   558,     0,     0,
     559,  1796,   560,   561,   562,     0,   563,     0,     0,   564,
     565,   566,     0,     0,  2304,   198,   199,   200,     0,   567,
     568,   569,   570,   571,   572,     0,   573,     0,   574,     0,
     575,   576,   577,     0,   578,   579,   580,   581,   582,   583,
     584,  1797,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,     0,   598,   599,   211,
     600,   601,     0,   602,   603,   604,   605,   606,   607,   608,
     609,     0,   610,   611,   612,   613,   614,     0,   615,  2305,
     616,   617,   219,   618,  1799,     0,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,     0,   629,     0,   630,
     631,     0,   632,   633,   634,   635,   636,   637,     0,  1800,
    1801,     0,     0,   639,     0,   640,     0,     0,   641,   642,
     643,   644,   645,   646,     0,     0,   647,   648,   649,   650,
       0,     0,   651,   652,   653,   654,     0,  1802,  2306,   656,
     236,   657,   658,   659,     0,     0,   660,     0,     0,   661,
     662,   663,   664,   665,     0,     0,     0,     0,     0,     0,
       0,     0,   666,   667,   668,   705,    86,    87,    88,   403,
      90,    91,    92,   404,     0,   405,    95,     0,     0,    98,
      99,   100,   101,   102,   103,   706,   104,   105,   406,   707,
       0,   107,   108,   109,   110,   708,   709,   112,   113,   114,
     115,     0,   116,   710,   711,   407,   408,     0,     0,     0,
     409,   410,     0,     0,     0,     0,   411,     0,     0,     0,
       0,     0,     0,     0,     0,   412,     0,   413,     0,   414,
     415,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   427,     0,     0,     0,     0,     0,     0,     0,
     428,   429,     0,   430,   133,   431,   432,   433,     0,  1784,
     137,  1785,  1786,     0,   434,   435,   436,   437,   438,     0,
       0,   439,   440,  1787,  1788,   442,     0,   443,   444,   445,
     446,     0,     0,     0,   447,   448,   449,   450,   147,   451,
     452,     0,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   150,   462,     0,     0,     0,     0,   151,     0,
       0,     0,   463,   464,   465,   466,   467,   468,  1789,  1790,
     469,     0,   470,     0,   471,   472,   473,   474,   475,     0,
     476,   477,   478,     0,     0,   479,   480,  1419,   482,   483,
       0,   484,   485,   486,     0,   487,   488,     0,   489,   490,
     491,   492,     0,   493,   494,     0,     0,   495,     0,   496,
    1791,   497,     0,   498,     0,   499,   169,     0,   170,   500,
     501,   502,     0,   503,     0,     0,   504,     0,   505,   506,
     507,   508,   509,   173,   510,   511,   512,     0,   513,   514,
     515,   516,   517,   518,     0,   519,   174,     0,     0,   520,
     521,   522,  1425,  1792,     0,  1793,     0,   523,   179,   180,
     524,   181,   525,   526,   527,   528,   529,   530,     0,     0,
     183,   531,   184,     0,   532,   533,   534,     0,     0,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,  1794,   190,  1795,   548,   549,   550,   551,   552,
     553,   554,     0,   555,     0,   556,   557,   194,   558,  2294,
       0,   559,  1796,   560,   561,   562,     0,   563,     0,     0,
     564,   565,   566,     0,     0,     0,   198,   199,   200,     0,
     567,   568,   569,   570,   571,   572,     0,   573,     0,   574,
       0,   575,   576,   577,     0,   578,   579,   580,   581,   582,
     583,   584,  1797,   585,   586,   587,     0,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,     0,   598,   599,
     211,   600,   601,     0,   602,   603,   604,   605,   606,   607,
     608,   609,     0,   610,   611,   612,   613,   614,     0,   615,
    2305,   616,   617,   219,   618,  1799,     0,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,     0,   629,     0,
     630,   631,  3580,   632,   633,   634,   635,   636,   637,     0,
    1800,  1801,     0,     0,   639,     0,   640,     0,     0,   641,
     642,   643,   644,   645,   646,     0,     0,   647,   648,   649,
     650,     0,     0,   651,   652,   653,   654,     0,  1802,     0,
     656,   236,   657,   658,   659,     0,     0,   660,     0,     0,
     661,   662,   663,   664,   665,     0,     0,     0,     0,     0,
       0,     0,     0,   666,   667,   668,   705,    86,    87,    88,
     403,    90,    91,    92,   404,     0,   405,    95,     0,     0,
      98,    99,   100,   101,   102,   103,   706,   104,   105,   406,
     707,     0,   107,   108,   109,   110,   708,   709,   112,   113,
     114,   115,     0,   116,   710,   711,   407,   408,     0,     0,
       0,   409,   410,     0,     0,     0,     0,   411,     0,     0,
       0,     0,     0,     0,     0,     0,   412,     0,   413,     0,
     414,   415,    35,     0,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   427,     0,     0,     0,     0,     0,     0,
       0,   428,   429,     0,   430,   133,   431,   432,   433,     0,
    1784,   137,  1785,  1786,     0,   434,   435,   436,   437,   438,
       0,     0,   439,   440,  1787,  1788,   442,     0,   443,   444,
     445,   446,     0,     0,     0,   447,   448,   449,   450,   147,
     451,   452,     0,   453,   454,   455,   456,   457,   458,     0,
     459,   460,   461,   150,   462,     0,     0,     0,     0,   151,
       0,     0,     0,   463,   464,   465,   466,   467,   468,  1789,
    1790,   469,     0,   470,     0,   471,   472,   473,   474,   475,
       0,   476,   477,   478,     0,     0,   479,   480,  1419,   482,
     483,     0,   484,   485,   486,     0,   487,   488,     0,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,     0,
     496,  1791,   497,     0,   498,     0,   499,   169,     0,   170,
     500,   501,   502,     0,   503,     0,     0,   504,     0,   505,
     506,   507,   508,   509,   173,   510,   511,   512,     0,   513,
     514,   515,   516,   517,   518,     0,   519,   174,     0,     0,
     520,   521,   522,  1425,  1792,     0,  1793,     0,   523,   179,
     180,   524,   181,   525,   526,   527,   528,   529,   530,     0,
       0,   183,   531,   184,     0,   532,   533,   534,     0,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,  1794,   190,  1795,   548,   549,   550,   551,
     552,   553,   554,  2347,   555,     0,   556,   557,   194,   558,
       0,     0,   559,  1796,   560,   561,   562,     0,   563,     0,
       0,   564,   565,   566,     0,     0,     0,   198,   199,   200,
       0,   567,   568,   569,   570,   571,   572,     0,   573,     0,
     574,     0,   575,   576,   577,     0,   578,   579,   580,   581,
     582,   583,   584,  1797,   585,   586,   587,     0,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,     0,   598,
     599,   211,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,     0,   610,   611,   612,   613,   614,     0,
     615,  1798,   616,   617,   219,   618,  1799,     0,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,     0,   629,
       0,   630,   631,     0,   632,   633,   634,   635,   636,   637,
       0,  1800,  1801,     0,     0,   639,     0,   640,     0,     0,
     641,   642,   643,   644,   645,   646,     0,     0,   647,   648,
     649,   650,     0,     0,   651,   652,   653,   654,     0,  1802,
       0,   656,   236,   657,   658,   659,     0,     0,   660,     0,
       0,   661,   662,   663,   664,   665,     0,     0,     0,     0,
       0,     0,     0,     0,   666,   667,   668,   705,    86,    87,
      88,   403,    90,    91,    92,   404,     0,   405,    95,     0,
       0,    98,    99,   100,   101,   102,   103,   706,   104,   105,
     406,   707,     0,   107,   108,   109,   110,   708,   709,   112,
     113,   114,   115,     0,   116,   710,   711,   407,   408,     0,
       0,     0,   409,   410,     0,     0,     0,     0,   411,     0,
       0,     0,     0,     0,     0,     0,     0,   412,     0,   413,
       0,   414,   415,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   427,     0,     0,     0,     0,     0,
       0,     0,   428,   429,     0,   430,   133,   431,   432,   433,
       0,  1784,   137,  1785,  1786,     0,   434,   435,   436,   437,
     438,     0,     0,   439,   440,  1787,  1788,   442,     0,   443,
     444,   445,   446,     0,     0,     0,   447,   448,   449,   450,
     147,   451,   452,     0,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   150,   462,     0,     0,     0,     0,
     151,     0,     0,     0,   463,   464,   465,   466,   467,   468,
    1789,  1790,   469,     0,   470,     0,   471,   472,   473,   474,
     475,     0,   476,   477,   478,     0,     0,   479,   480,  1419,
     482,   483,     0,   484,   485,   486,     0,   487,   488,     0,
     489,   490,   491,   492,     0,   493,   494,     0,     0,   495,
       0,   496,  1791,   497,     0,   498,     0,   499,   169,     0,
     170,   500,   501,   502,     0,   503,     0,     0,   504,     0,
     505,   506,   507,   508,   509,   173,   510,   511,   512,     0,
     513,   514,   515,   516,   517,   518,     0,   519,   174,     0,
       0,   520,   521,   522,  1425,  1792,     0,  1793,     0,   523,
     179,   180,   524,   181,   525,   526,   527,   528,   529,   530,
       0,     0,   183,   531,   184,     0,   532,   533,   534,     0,
       0,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,  1794,   190,  1795,   548,   549,   550,
     551,   552,   553,   554,  3427,   555,     0,   556,   557,   194,
     558,     0,     0,   559,  1796,   560,   561,   562,     0,   563,
       0,     0,   564,   565,   566,     0,     0,     0,   198,   199,
     200,     0,   567,   568,   569,   570,   571,   572,     0,   573,
       0,   574,     0,   575,   576,   577,     0,   578,   579,   580,
     581,   582,   583,   584,  1797,   585,   586,   587,     0,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,     0,
     598,   599,   211,   600,   601,     0,   602,   603,   604,   605,
     606,   607,   608,   609,     0,   610,   611,   612,   613,   614,
       0,   615,  1798,   616,   617,   219,   618,  1799,     0,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,     0,
     629,     0,   630,   631,     0,   632,   633,   634,   635,   636,
     637,     0,  1800,  1801,     0,     0,   639,     0,   640,     0,
       0,   641,   642,   643,   644,   645,   646,     0,     0,   647,
     648,   649,   650,     0,     0,   651,   652,   653,   654,     0,
    1802,     0,   656,   236,   657,   658,   659,     0,     0,   660,
       0,     0,   661,   662,   663,   664,   665,     0,     0,     0,
       0,     0,     0,     0,     0,   666,   667,   668,   705,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,   706,   104,
     105,   406,   707,     0,   107,   108,   109,   110,   708,   709,
     112,   113,   114,   115,     0,   116,   710,   711,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,   133,   431,   432,
     433,     0,  1784,   137,  1785,  1786,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,  1787,  1788,   442,     0,
     443,   444,   445,   446,     0,     0,     0,   447,   448,   449,
     450,   147,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   150,   462,     0,     0,     0,
       0,   151,     0,     0,     0,   463,   464,   465,   466,   467,
     468,  1789,  1790,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
    1419,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,     0,   496,  1791,   497,     0,   498,     0,   499,   169,
       0,   170,   500,   501,   502,     0,   503,     0,     0,   504,
       0,   505,   506,   507,   508,   509,   173,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,   174,
       0,     0,   520,   521,   522,  1425,  1792,     0,  1793,     0,
     523,   179,   180,   524,   181,   525,   526,   527,   528,   529,
     530,     0,     0,   183,   531,   184,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,  1794,   190,  1795,   548,   549,
     550,   551,   552,   553,   554,     0,   555,     0,   556,   557,
     194,   558,     0,     0,   559,  1796,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,     0,   198,
     199,   200,     0,   567,   568,   569,   570,   571,   572,     0,
     573,     0,   574,     0,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,  1797,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,   211,   600,   601,     0,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,  1798,   616,   617,   219,   618,  1799,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
       0,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,  1800,  1801,     0,     0,   639,     0,   640,
       0,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
       0,  1802,     0,   656,   236,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,     0,     0,
       0,     0,     0,     0,     0,     0,   666,   667,   668,   705,
      86,    87,    88,   403,    90,    91,    92,   404,     0,   405,
      95,     0,     0,    98,    99,   100,   101,   102,   103,   706,
     104,   105,   406,   707,     0,   107,   108,   109,   110,   708,
     709,   112,   113,   114,   115,     0,   116,   710,   711,   407,
     408,     0,     0,     0,   409,   410,     0,     0,     0,     0,
     411,     0,     0,     0,     0,     0,     0,     0,     0,   412,
       0,   413,     0,   414,   415,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   427,     0,     0,     0,
       0,     0,     0,     0,   428,   429,     0,   430,   133,   431,
     432,   433,     0,  1784,   137,  1785,  1786,     0,   434,   435,
     436,   437,   438,     0,     0,   439,   440,  1787,  1788,   442,
       0,   443,   444,   445,   446,     0,     0,     0,   447,   448,
     449,   450,   147,   451,   452,     0,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   150,   462,     0,     0,
       0,     0,   151,     0,     0,     0,   463,   464,   465,   466,
     467,   468,  1789,  1790,   469,     0,   470,     0,   471,   472,
     473,   474,   475,     0,   476,   477,   478,     0,     0,   479,
     480,  1419,   482,   483,     0,   484,   485,   486,     0,   487,
     488,     0,   489,   490,   491,   492,     0,   493,   494,     0,
       0,   495,     0,   496,  1791,   497,     0,   498,     0,   499,
     169,     0,   170,   500,   501,   502,     0,   503,     0,     0,
     504,     0,   505,   506,   507,   508,   509,   173,   510,   511,
     512,     0,   513,   514,   515,   516,   517,   518,     0,   519,
     174,     0,     0,   520,   521,   522,  1425,  1792,     0,  1793,
       0,   523,   179,   180,   524,   181,   525,   526,   527,   528,
     529,   530,     0,     0,   183,   531,   184,     0,   532,   533,
     534,     0,     0,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,  1794,   190,  1795,   548,
     549,   550,   551,   552,   553,   554,     0,   555,     0,   556,
     557,   194,   558,     0,     0,   559,  1796,   560,   561,   562,
       0,   563,     0,     0,   564,   565,   566,     0,     0,     0,
     198,   199,   200,     0,   567,   568,   569,   570,   571,   572,
       0,   573,     0,   574,     0,   575,   576,   577,     0,   578,
     579,   580,   581,   582,   583,   584,  1797,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,     0,   598,   599,   211,   600,   601,     0,   602,   603,
     604,   605,   606,   607,   608,   609,     0,   610,   611,   612,
     613,   614,     0,   615,  2305,   616,   617,   219,   618,  1799,
       0,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,     0,   629,     0,   630,   631,     0,   632,   633,   634,
     635,   636,   637,     0,  1800,  1801,     0,     0,   639,     0,
     640,     0,     0,   641,   642,   643,   644,   645,   646,     0,
       0,   647,   648,   649,   650,     0,     0,   651,   652,   653,
     654,     0,  1802,     0,   656,   236,   657,   658,   659,     0,
       0,   660,     0,     0,   661,   662,   663,   664,   665,     0,
       0,     0,     0,     0,     0,     0,     0,   666,   667,   668,
     705,    86,    87,    88,   403,    90,    91,    92,   404,     0,
     405,    95,     0,     0,    98,    99,   100,   101,   102,   103,
     706,   104,   105,   406,   707,     0,   107,   108,   109,   110,
     708,   709,   112,   113,   114,   115,     0,   116,   710,   711,
     407,   408,     0,     0,     0,   409,   410,     0,     0,     0,
       0,   411,     0,     0,     0,     0,     0,     0,     0,     0,
     412,     0,   413,     0,   414,   415,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,     0,     0,
       0,     0,     0,     0,     0,   428,   429,     0,   430,   133,
     431,   432,   433,     0,  1784,   137,  1785,  1786,     0,   434,
     435,   436,   437,   438,     0,     0,   439,   440,  1787,  1788,
     442,     0,   443,   444,   445,   446,     0,     0,     0,   447,
     448,   449,   450,   147,   451,   452,     0,   453,   454,   455,
     456,   457,   458,     0,   459,   460,   461,   150,   462,     0,
       0,     0,     0,   151,     0,     0,     0,   463,   464,   465,
     466,   467,   468,  1789,  1790,   469,     0,   470,     0,   471,
     472,   473,   474,   475,     0,   476,   477,   478,     0,     0,
     479,   480,  1419,   482,   483,     0,   484,   485,   486,     0,
     487,   488,     0,   489,   490,   491,   492,     0,   493,   494,
       0,     0,   495,     0,   496,  1791,   497,     0,   498,     0,
     499,   169,     0,   170,   500,   501,   502,     0,   503,     0,
       0,   504,     0,   505,   506,   507,   508,   509,   173,   510,
     511,   512,     0,   513,   514,   515,   516,   517,   518,     0,
     519,   174,     0,     0,   520,   521,   522,  1425,  1792,     0,
    1793,     0,   523,   179,   180,   524,   181,   525,   526,   527,
     528,   529,   530,     0,     0,   183,   531,   184,     0,   532,
     533,   534,     0,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,  1794,   190,  1795,
     548,   549,   550,   551,   552,   553,   554,     0,   555,     0,
     556,   557,   194,   558,     0,     0,   559,  1796,   560,   561,
     562,     0,   563,     0,     0,   564,   565,   566,     0,     0,
       0,   198,   199,   200,     0,   567,   568,   569,   570,   571,
     572,     0,   573,     0,   574,     0,   575,   576,   577,     0,
     578,   579,   580,   581,   582,   583,   584,  1797,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,     0,   598,   599,   211,   600,   601,     0,   602,
     603,   604,   605,   606,   607,   608,   609,     0,   610,   611,
     612,   613,   614,     0,   615,     0,   616,   617,   219,   618,
    1799,     0,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,     0,   629,     0,   630,   631,     0,   632,   633,
     634,   635,   636,   637,     0,  1800,  1801,     0,     0,   639,
       0,   640,     0,     0,   641,   642,   643,   644,   645,   646,
       0,     0,   647,   648,   649,   650,     0,     0,   651,   652,
     653,   654,     0,  1802,     0,   656,   236,   657,   658,   659,
       0,     0,   660,     0,     0,   661,   662,   663,   664,   665,
       0,     0,     0,     0,     0,     0,     0,     0,   666,   667,
     668,   705,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,   706,   104,   105,   406,   707,     0,   107,   108,   109,
     110,   708,   709,   112,   113,   114,   115,     0,   116,   710,
     711,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
     133,   431,   432,   433,     0,     0,   137,     0,     0,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,     0,
       0,   442,     0,   443,   444,   445,   446,     0,     0,     0,
     447,   448,   449,   450,   147,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   150,   462,
       0,     0,     0,     0,   151,     0,     0,     0,   463,   464,
     465,   466,   467,   468,     0,     0,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,     0,   493,
     494,     0,     0,   495,     0,   496,     0,   497,     0,   498,
       0,   499,   169,     0,   170,   500,   501,   502,     0,   503,
       0,     0,   504,     0,   505,   506,   507,   508,   509,   173,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,   174,     0,     0,   520,   521,   522,     0,     0,
       0,     0,     0,   523,   179,   180,   524,   181,   525,   526,
     527,   528,   529,   530,     0,     0,   183,   531,   184,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,     0,   190,
       0,   548,   549,   550,   551,   552,   553,   554,     0,   555,
       0,   556,   557,   194,   558,     0,     0,   559,     0,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,     0,   198,   199,   200,     0,   567,   568,   569,   570,
     571,   572,     0,   573,     0,   574,     0,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,     0,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,   211,   600,   601,     0,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,     0,   616,   617,   219,
     618,     0,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,     0,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,     0,     0,     0,     0,
     639,     0,   640,     0,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,     0,     0,     0,   656,   236,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,     0,     0,     0,     0,     0,     0,     0,     0,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,   712,   425,   426,   427,   713,
     714,   715,   716,   717,   718,   719,   428,   429,   720,   430,
     133,   431,   432,   433,   135,   136,   137,   138,   139,   721,
     434,   435,   436,   437,   438,   722,   723,   439,   440,     0,
     140,   442,   725,   443,   444,   445,   446,   144,   726,   727,
     447,   448,   449,   450,   147,   451,   728,   729,   453,   454,
     455,   456,   457,   458,   730,   459,   460,   461,   150,   462,
       0,   732,   733,   734,   151,   735,   736,   737,   463,   464,
     465,   466,     0,   468,   154,   155,   469,   738,   470,   739,
     471,   472,   473,   474,   475,   740,   476,   477,   478,   741,
     742,   479,   480,   481,   482,   483,   743,   484,   485,   486,
     744,   487,   488,   745,   489,   490,   491,   492,   164,   493,
     494,   166,   746,   495,   747,   496,   168,   497,   748,   498,
     749,   499,   169,   750,   170,   500,   501,   502,   751,   503,
     172,   752,   504,   753,   505,   506,     0,   508,   509,   173,
     510,   511,   512,   754,   513,   514,   515,   516,   517,   518,
     755,   519,   174,   175,     0,   520,   521,   522,     0,   177,
     758,   178,   759,   523,   179,   180,   524,   181,   525,   526,
     527,   528,   529,   530,   760,   182,   183,   531,   184,   761,
     532,   533,   534,   762,   763,   535,   536,   537,   538,   539,
     540,     0,   542,   543,     0,   545,   546,   547,   189,   190,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
     764,   556,   557,   194,   558,   765,   195,   559,   196,   560,
     561,   562,   766,   563,   767,   768,   564,   565,   566,   769,
     770,   197,   198,   199,   200,   201,   567,   568,   569,   570,
     571,   572,   771,   573,   202,   574,   203,   575,   576,   577,
     772,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,   773,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   774,   598,   599,   211,   600,   601,   213,
     602,   603,   604,   605,   606,   607,     0,   609,   775,   610,
     611,   612,   613,   614,   776,   615,   217,   616,   617,   219,
     618,   220,   777,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,   778,   630,   631,   779,   632,
     633,   634,   635,   636,   637,   780,   224,   225,     0,   782,
     639,   226,   640,   227,   783,   641,   642,   643,   644,   645,
     646,     0,   785,   647,   648,   649,   650,   786,   787,   651,
     652,   653,   654,     0,   235,   789,   656,   236,   657,   658,
     659,   790,   791,   660,   792,   793,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,     0,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,    37,    38,    39,    40,    41,    42,    43,    44,  1397,
    4459,     0,    45,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,    37,    38,    39,    40,    41,    42,     0,    44,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,  1927,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,  1928,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,  1929,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,   416,     0,
       0,    37,    38,    39,    40,    41,    42,     0,    44,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,   638,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,   416,     0,
       0,    37,    38,    39,    40,    41,    42,     0,    44,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,  1111,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,   416,     0,
       0,    37,    38,    39,    40,    41,    42,     0,    44,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,    37,    38,    39,    40,    41,    42,     0,    44,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,  2125,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,  2273,   443,   444,   445,   446,   144,     0,  2317,
     447,   448,   449,   450,     0,   451,   452,  2274,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,  2318,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
    2276,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
    2277,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,  2278,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,  2273,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,  2274,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,  2318,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
    2276,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,  3081,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
    2277,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,  2278,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,  1013,   423,   424,   971,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,   972,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,  1014,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,   973,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,   974,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,    37,    38,    39,    40,    41,    42,     0,    44,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,    37,    38,    39,    40,    41,    42,     0,    44,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,  1907,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,   971,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,   972,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,  2853,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,   973,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,   974,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,  2273,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,  2274,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,  2318,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
    2276,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
    2277,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,  2278,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,   416,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,   688,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
     689,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,   690,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,   971,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,   972,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,   973,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,   974,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
     888,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,   416,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,   889,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   890,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,  1962,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,  1963,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
    1964,   499,     0,     0,     0,  1965,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,  1966,
    1967,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,  1968,   606,   607,   608,   609,     0,  1969,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,  1970,   632,
    1971,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,   972,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,   973,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,   974,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,   130,
     131,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,  1325,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
    1951,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,  2235,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,   416,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,  2743,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,  2744,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,  2745,   632,
     633,  2746,   635,  2747,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,   416,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,   697,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,   416,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,   690,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,   416,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,   843,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,   416,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,  1263,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,  2392,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,  2393,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,   130,
     131,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,  2897,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,  2898,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,  2909,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,  2910,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,   416,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,   416,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   894,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,   416,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     935,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,   416,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     989,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,  1044,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,  1503,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
    1859,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
    1951,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,  2235,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,  3118,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,  3131,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,  3173,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,  3885,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,  3887,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,  3889,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,  4045,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   997,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,   999,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,  1000,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,     0,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,  1001,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,  1002,   225,     0,     0,
    1003,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,  1004,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,  1038,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,  1000,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,     0,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,  1039,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,  1040,   225,     0,     0,
    1041,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,  1004,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,  1060,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,  1183,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,  1246,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,  1277,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,  1282,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,  1290,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,  1292,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,  1294,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,  1296,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,  1299,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,  1301,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,  1302,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,  1305,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
    1514,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,  1025,   440,  1000,
     140,  1515,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,     0,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,  1029,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,  1030,   601,   213,
     602,   603,   604,  1031,   606,   607,   608,   609,     0,   610,
     611,   612,   613,  1507,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,  1033,   225,     0,     0,
    1034,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,  1004,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
    1035,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,  1537,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,     0,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,  1637,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,  1885,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,  1887,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,  2001,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,  2524,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,  2900,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,  2902,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,  1025,   440,  1000,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,     0,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,  1029,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,  1030,   601,   213,
     602,   603,   604,  1031,   606,   607,   608,   609,     0,   610,
     611,   612,   613,  1507,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,  1033,   225,     0,     0,
    1034,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,  1004,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
    1035,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,  1025,   440,  1000,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,     0,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,  1029,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,  1030,   601,   213,
     602,   603,   604,  1031,   606,   607,   608,   609,     0,   610,
     611,   612,   613,  1507,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
    2264,   634,   635,   636,   637,     0,  1033,   225,     0,     0,
    1034,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,  1004,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
    1035,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,  1025,   440,  1000,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,     0,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,  1029,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,  1030,   601,   213,
     602,   603,   604,  2298,   606,   607,   608,   609,     0,   610,
     611,   612,   613,  1507,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,  1033,   225,     0,     0,
    1034,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,  1004,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
    1035,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
       0,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,     0,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
       0,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,    86,    87,    88,     0,    90,    91,    92,     0,
       0,     0,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,     0,     0,     0,   107,   108,   109,
     110,     0,   111,   112,   113,   114,   115, -2157,   116,   117,
     118,     0,     0,     0,     0,     0,   121,   122,     0,     0,
       0,     0,   123,     0,     0,     0,     0,     0,     0,     0,
       0,   124,     0,   125,     0,   126,   127,    35,     0,   398,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     133,     0,     0,     0,   135,   136,   137,   138,   139,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     140,     0,     0,     0,     0,     0,     0,   144,     0,     0,
       0,     0,     0,     0,   147,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   150,     0,
       0,     0,     0,     0,   151,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   154,   155,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   162,     0,     0,     0,     0,     0,     0,   164,     0,
       0,   166,     0,     0,     0,     0,   168,     0,     0,     0,
       0,     0,   169,     0,   170,     0,     0,     0,     0,     0,
     172,     0,     0,     0,     0,     0,     0,     0,     0,   173,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   174,   175,     0,     0,     0,     0,     0,   177,
       0,   178,     0,     0,   179,   180,     0,   181,     0,     0,
       0,     0,     0,     0,     0,   182,   183,     0,   184,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   189,   190,
     191,     0,     0,     0,     0,     0,     0,     0,   192,     0,
       0,     0,     0,   194,     0,     0,   195,     0,   196,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   197,   198,   199,   200,   201,     0,     0,     0,     0,
       0,     0,     0,     0,   202,     0,   203,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   205,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   211,     0,     0,   213,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   217,     0,     0,   219,
       0,   220,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   222,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   224,   225,     0,     0,
       0,   226,     0,   227,     0,     0,     0,     0,     0,     0,
       0,   230,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,     0,     0,   236,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   238,   239,   240,   241,   242,   243,   244,   245,    86,
      87,    88,     0,    90,    91,    92,     0,     0,     0,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,     0,     0,     0,   107,   108,   109,   110,     0,   111,
     112,   113,   114,   115, -2158,   116,   117,   118,     0,     0,
       0,     0,     0,   121,   122,     0,     0,     0,     0,   123,
       0,     0,     0,     0,     0,     0,     0,     0,   124,     0,
     125,     0,   126,   127,    35,     0,  1106,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   133,     0,     0,
       0,   135,   136,   137,   138,   139,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   140,     0,     0,
       0,     0,     0,     0,   144,     0,     0,     0,     0,     0,
       0,   147,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   150,     0,     0,     0,     0,
       0,   151,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   154,   155,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   162,     0,
       0,     0,     0,     0,     0,   164,     0,     0,   166,     0,
       0,     0,     0,   168,     0,     0,     0,     0,     0,   169,
       0,   170,     0,     0,     0,     0,     0,   172,     0,     0,
       0,     0,     0,     0,     0,     0,   173,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,     0,     0,     0,     0,     0,   177,     0,   178,     0,
       0,   179,   180,     0,   181,     0,     0,     0,     0,     0,
       0,     0,   182,   183,     0,   184,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   189,   190,   191,     0,     0,
       0,     0,     0,     0,     0,   192,     0,     0,     0,     0,
     194,     0,     0,   195,     0,   196,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   197,   198,
     199,   200,   201,     0,     0,     0,     0,     0,     0,     0,
       0,   202,     0,   203,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   205,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,     0,     0,   213,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   217,     0,     0,   219,     0,   220,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     222,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   224,   225,     0,     0,     0,   226,     0,
     227,     0,     0,     0,     0,     0,     0,     0,   230,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   235,     0,     0,   236,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   238,   239,
     240,   241,   242,   243,   244,   245,    86,    87,    88,     0,
      90,    91,    92,     0,     0,     0,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,     0,     0,
       0,   107,   108,   109,   110,     0,   111,   112,   113,   114,
     115,     0,   116,   117,   118,     0,     0,     0,     0,     0,
     121,   122,     0,     0,     0,     0,   123,     0,     0,     0,
       0,     0,     0,     0,     0,   124,     0,   125,     0,   126,
       0,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   133,     0,     0,     0,   135,   136,
     137,   138,   139,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   140,     0,     0,     0,     0,     0,
       0,   144,     0,     0,     0,     0,     0,     0,   147,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   150,     0,     0,     0,     0,     0,   151,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   154,   155,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   162,     0,     0,     0,     0,
       0,     0,   164,     0,     0,   166,     0,     0,     0,     0,
     168,     0,     0,     0,     0,     0,   169,     0,   170,     0,
       0,     0,     0,     0,   172,     0,     0,     0,     0,     0,
       0,     0,     0,   173,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   174,   175,     0,     0,
       0,     0,     0,   177,     0,   178,     0,     0,   179,   180,
       0,   181,     0,     0,     0,     0,     0,     0,     0,   182,
     183,     0,   184,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   189,   190,   191,     0,     0,     0,     0,     0,
       0,     0,   192,     0,     0,     0,     0,   194,     0,     0,
     195,     0,   196,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   197,   198,   199,   200,   201,
       0,     0,     0,     0,     0,     0,     0,     0,   202,     0,
     203,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   205,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     211,     0,     0,   213,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     217,     0,     0,   219,     0,   220,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   222,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,     0,     0,     0,   226,     0,   227,     0,     0,
       0,     0,     0,     0,     0,   230,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,     0,
       0,   236,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   238,   239,   240,   241,   242,
     243,   244,   245,    86,    87,    88,     0,    90,    91,    92,
       0,     0,     0,    95,     0,     0,    98,    99,   100,   101,
     102,   103,     0,   104,   105,     0,     0,     0,   107,   108,
     109,   110,     0,   111,   112,   113,   114,   115,     0,   116,
     117,   118,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    35,     0,
       0,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   133,     0,     0,     0,   135,   136,   137,   138,   139,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   140,     0,     0,     0,     0,     0,     0,   144,     0,
       0,     0,     0,     0,     0,   147,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   150,
       0,     0,     0,     0,     0,   151,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   154,   155,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   162,     0,     0,     0,     0,     0,     0,   164,
       0,     0,   166,     0,     0,     0,     0,   168,     0,     0,
       0,     0,     0,   169,     0,   170,     0,     0,     0,     0,
       0,   172,     0,     0,     0,     0,     0,     0,     0,     0,
     173,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,     0,     0,     0,     0,     0,
     177,     0,   178,     0,     0,   179,   180,     0,   181,     0,
       0,     0,     0,     0,     0,     0,   182,   183,     0,   184,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   189,
     190,   191,     0,     0,     0,     0,     0,     0,     0,   192,
       0,     0,     0,     0,   194,     0,     0,   195,     0,   196,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   197,   198,   199,   200,   201,     0,     0,     0,
       0,     0,     0,     0,     0,   202,     0,   203,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   205,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,     0,     0,
     213,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   217,     0,     0,
     219,     0,   220,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   222,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   224,   225,     0,
       0,     0,   226,     0,   227,     0,     0,     0,     0,     0,
       0,     0,   230,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,     0,     0,   236,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   238,   239,   240,   241,   242,   243,   244,   245,
      86,    87,    88,     0,    90,    91,    92,     0,     0,     0,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,     0,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,   115,     0,   116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   133,     0,
       0,     0,   135,   136,   137,   138,   139,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   140,     0,
       0,     0,     0,     0,     0,   144,     0,     0,     0,     0,
       0,     0,   147,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   150,     0,     0,     0,
       0,     0,   151,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   154,   155,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   164,     0,     0,   166,
       0,     0,     0,     0,   168,     0,     0,     0,     0,     0,
     169,     0,   170,     0,     0,     0,     0,     0,   172,     0,
       0,     0,     0,     0,     0,     0,     0,   173,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     174,   175,     0,     0,     0,     0,     0,   177,     0,   178,
       0,     0,   179,   180,     0,   181,     0,     0,     0,     0,
       0,     0,     0,   182,   183,     0,   184,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   189,   190,   191,     0,
       0,     0,     0,     0,     0,     0,   192,     0,     0,     0,
       0,   194,     0,     0,   195,     0,   196,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   197,
     198,   199,   200,   201,     0,     0,     0,     0,     0,     0,
       0,     0,   202,     0,   203,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   205,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   211,     0,     0,   213,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   217,     0,     0,   219,     0,   220,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   222,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   224,   225,     0,     0,     0,   226,
       0,   227,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,     0,     0,   236,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   238,
     239,   240,   241,   242,   243,   244,   245
};

static const yytype_int16 yycheck[] =
{
       2,   246,    78,  1027,    78,   826,    78,    78,   864,   167,
     210,  1119,   153,   351,  1379,   816,  1288,    78,  1281,   973,
     974,   822,  1077,    84,   978,     2,  1075,   152,  1360,  1142,
     188,  1694,  1329,  1678,  1174,   149,   117,  1870,  1191,  1295,
    1656,  1909,  1042,   864,  1184,   165,  1798,  1965,  1148,  1245,
    1306,   901,   853,   228,    78,   703,   117,  1916,   366,   915,
      84,     2,  1392,   204,   171,  2346,  1814,  2620,  1684,    78,
    1446,  1734,  1735,  2893,   366,  1034,  1534,  1728,  1417,  1418,
    2114,   162,  1589,  1590,  1591,  1847,  1226,    89,   132,  1222,
    3105,  1231,  2310,  2311,   915,  1833,   223,  1436,  1238,  2757,
    1833,   162,   353,   210,   905,   232,  2960,  1247,  2962,  1558,
    1100,   912,  2508,  1678,  2160,  1833,  1833,  1833,  1833,   160,
    2004,    78,   704,  1119,  2594,   339,  3351,    84,  3059,  2755,
    2513,  2514,   216,  3380,  3025,  2519,  1722,  3581,   167,   148,
    1273,  1684,   940,  1905,  2171,   353,  1646,  3767,  1342,   230,
     152,  1584,  1585,  1320,  2209,  3591,   165,   159,  1153,   188,
     117,  1311,  3555,    30,    94,  2166,  1072,  1157,  3059,   230,
    3528,  2452,    10,  1149,  1072,  3773,  1407,  1408,  1114,  1115,
    1030,    21,    88,   108,   186,  1643,  3039,  3040,  3041,  3042,
    3043,  3044,  3244,  2248,   127,     8,   127,  2252,    11,    12,
      72,  1432,   132,   147,    88,   162,   932,   113,  1184,    22,
      23,    24,    88,    26,    27,   810,   117,   120,    31,    32,
      33,   205,   152,   153,  2753,  2754,   167,    84,  3559,   188,
    2426,   181,   134,   163,    14,    89,   143,   246,  4154,   127,
     888,  3608,    78,  3610,   266,   127,    29,   188,  4047,  4048,
    2531,   112,  2533,    75,    76,    77,    78,    37,   103,   104,
      82,   162,    93,    78,    99,  3922,  1220,    78,    90,   174,
     324,   106,    78,   230,   204,   210,   334,    72,    84,    72,
     154,    99,   358,   117,   358,   227,   358,   358,    81,  4147,
     227,    86,    72,    86,   118,    75,    76,    77,    78,   327,
     180,    81,    82,    83,    84,   366,    86,   230,   112,   222,
     200,   117,   100,   167,    75,    76,    77,    78,  2066,   356,
    1320,    82,    78,   266,    75,    76,    77,    78,   162,   230,
     229,    82,    72,   227,   188,   295,   383,   158,  1759,  1329,
     401,    81,   366,   218,   353,   434,    86,    99,   500,   358,
    1206,    75,    76,    77,    78,   507,   162,  4409,    82,    14,
     233,   174,   270,   229,    99,  1518,   247,    75,    76,    77,
      78,   106,   162,  1568,    82,  1488,  1024,   401,    78,   210,
    2435,   226,   471,   228,   186,  1206,    75,    76,    77,    78,
     174,   257,    72,    82,   227,  1196,   230,   181,    75,    76,
      77,    78,  1203,   209,   117,    82,    86,   227,   283,   366,
     216,   232,   218,    90,    38,   117,    40,    25,  3776,   243,
     228,  4473,     0,   247,   230,  1801,    75,    76,    77,    78,
     390,   330,    99,    82,  1855,    75,    76,    77,    78,   106,
     230,   193,    82,   376,   401,   376,    25,   505,   502,   162,
    1789,  1790,  1253,   361,  1304,   502,    95,  1796,   282,   372,
     162,    75,    76,    77,    78,   502,   401,   266,    82,   266,
    3503,   394,   402,   261,   502,   258,    90,    75,    76,    77,
      78,  4138,   504,  1483,    82,   134,  3417,   300,   376,  4109,
     432,   396,   181,   452,   376,   266,   209,  1769,  4356,   443,
     423,   375,  1765,   216,   812,   218,    88,   209,    75,    76,
      77,    78,  4311,   638,   216,    82,   218,   230,   502,  4435,
     812,  3374,   358,  1523,  1524,   432,  3417,  1517,   230,   347,
     314,  1521,  1522,  1331,  1116,  1117,   134,   350,   227,   489,
    3898,  1136,    95,   358,   401,   686,   687,   358,    75,    76,
      77,    78,   383,  2305,   434,    82,  1787,  1788,   419,   198,
     366,   102,   505,    90,  1795,   502,    75,    76,    77,    78,
     401,   406,   505,    82,   505,   465,  2857,   502,  1718,   403,
    1720,    90,  3940,  1309,   456,  1781,    75,    76,    77,    78,
    3957,   471,   498,    82,  3925,   401,    89,  2598,  4218,   502,
     502,    94,   358,    96,  1757,  3134,  3658,   425,   181,   427,
    4208,   505,   452,   106,   498,   419,   461,  1873,   456,   495,
     496,   497,   498,   505,   505,  1957,  1882,   411,   441,  1762,
     414,   505,   505,   500,  1890,  1891,   638,  2288,  1778,   132,
      75,    76,    77,    78,    85,   198,  2104,    82,   450,   142,
    2108,  3309,  1908,   324,   262,   452,   496,  3510,   358,   152,
     153,   412,   413,   156,  1514,  2310,  2884,  1603,  2886,  1575,
     163,   406,   505,  1663,   167,  2508,   469,  1575,    88,  1669,
     502,   452,  1677,   262,  4042,   505,   268,   227,  3314,   210,
     314,  2692,  4050,   818,   502,   188,   941,  4317,   493,   494,
     493,   494,   341,   113,   149,   832,   505,   502,   638,   506,
     235,   204,   306,   493,   494,   158,  1816,    95,   502,  4155,
    1710,  3002,  3003,  1713,  1714,  3121,  2781,   808,   942,  3125,
    4123,  1707,   857,   181,  2768,   383,   111,  1075,  1320,   406,
     151,   502,   306,   432,  1938,   190,   470,   808,    88,   890,
    1944,   812,    14,   493,   494,  1922,   686,   687,  4378,  2786,
     399,  2261,   410,  1913,   488,    75,    76,    77,    78,   896,
     181,  4101,    82,   703,  2317,   329,  1766,  2210,   502,  2212,
      75,    76,    77,    78,   909,   174,   176,    82,   812,   232,
     328,   432,   500,   951,   502,   953,   504,   955,  2029,  2030,
     489,  2997,   183,   961,  3000,  3001,   847,  3025,  3004,     5,
    4134,   460,   175,   493,   494,   504,   140,   370,  3014,   392,
     198,   941,   266,   937,   229,   502,   149,   985,   986,    25,
     470,   502,   373,  4453,  3867,  3868,  3869,  3870,  3871,    35,
    4284,  3059,  2037,   461,   385,   266,   848,  1703,   488,   422,
     240,   808,  2497,   502,   228,   812,   381,   984,    75,    76,
      77,    78,   502,   270,   505,    82,   314,   190,    71,    72,
     207,   246,    75,    76,    77,    78,    79,    80,    81,    82,
     401,   183,  1703,    86,   457,  3103,   266,   250,   502,   330,
     484,   455,   432,   460,    99,   436,   469,   342,  1852,   901,
     902,  2157,  2488,   314,   502,   295,   334,   808,   298,   402,
    4240,   493,   494,   495,   496,   497,   498,   306,  2751,   473,
    1920,  1048,   186,   136,   953,  3940,   955,   264,   268,   502,
     932,   940,   941,   314,   377,   502,  1056,   133,   151,   387,
     145,   127,   186,   328,  1028,  1969,  1970,   152,  1032,   489,
    4274,   383,   364,   181,   361,   932,   985,   986,   888,  4206,
     890,  3345,    72,   341,   504,    75,    76,    77,    78,   343,
     176,    81,    82,   374,   808,   502,    86,   182,   181,    95,
     385,   426,  1026,   295,   198,   101,   298,   989,  1049,  4214,
    4215,   932,   370,   502,   227,   208,   260,   334,   399,  4357,
     390,   197,   808,   327,    85,   935,   812,    88,   452,   939,
     951,   224,   953,   502,   955,  1017,   260,   319,   450,   342,
     961,   962,   963,  1025,  2772,  1049,   469,  1029,  1030,  1031,
     404,   452,    71,  1889,   240,   440,    75,    76,    77,    78,
      79,    80,   107,    82,   985,   986,   251,  3901,   489,   490,
     491,   185,   493,   494,   495,   496,   497,   498,   421,   422,
     503,   332,   265,   506,   136,   230,   262,   502,  1889,  1870,
     341,  1872,   452,   128,  3732,   503,  4400,   505,   390,   151,
    1881,   136,   198,   286,  3742,   495,   496,   497,   498,   295,
     502,   319,  1049,   483,  1024,   808,  1026,   951,   505,   953,
     173,   955,  3728,   426,    99,  2444,   808,   961,   445,   181,
     227,   183,  1114,  1115,  3740,   500,   181,  1119,   219,   504,
     306,   184,   181,  1100,   227,   314,    25,  1925,   392,  4060,
     247,   985,   986,   267,   186,   185,    35,   176,   221,  2247,
     114,   354,  1119,   334,   247,   638,   198,   109,  2148,   266,
     422,  4376,   229,   493,   494,   495,   496,   497,   498,  1100,
     374,   135,    72,   266,  1965,    75,    76,    77,    78,  4060,
     359,    81,    82,    83,    84,  3645,    86,   432,  1119,  2035,
    1157,   244,   254,   340,   390,   399,   450,   268,   143,  2385,
     376,   462,   502,   686,   687,   439,   151,   268,   193,  3417,
     136,   240,    85,  3599,   305,    88,   450,   502,  3604,   414,
     703,  3607,  3595,   399,  2035,  1256,  1157,   267,  1463,  1221,
    2871,   294,  1028,   296,   372,   341,  1032,   189,   227,   394,
     113,   286,   432,   446,   133,   118,   176,  2227,  2883,   341,
     149,  4051,   314,  1049,   266,   181,  1100,   319,   247,   330,
     505,  2247,  3170,   330,   370,   314,   295,   328,   423,   298,
    1114,  1115,  2534,  2526,  3460,  1119,   349,   266,   370,  2525,
    3466,  3467,  3468,  3469,  3470,  3471,  1319,  2473,  2474,  2475,
    2476,   190,   354,  2539,  2540,   502,   502,  2543,  3121,   489,
     493,   494,  3125,  2549,   366,   393,  1368,  3343,    97,   351,
     240,   434,  1304,  1157,  4114,   381,  1308,  1309,   158,  1311,
    1561,  1562,   503,  1564,   505,  1028,  3200,   116,  2883,  1032,
     120,   469,  1331,  3061,   422,  1633,  1028,  1329,  3061,  2787,
    1032,  1308,  1309,  1547,  1311,   452,  3617,   414,  3619,  2788,
    1922,  1633,  4357,  3061,  3061,  3061,  3061,  2353,   183,   452,
      96,   390,  1329,  1561,  1562,   295,  1564,   505,   298,  1368,
     106,  4019,  4020,   262,   247,   463,  2622,  1308,  1309,  2359,
    1311,   353,   172,  1375,   446,   451,   240,  2367,   314,  2369,
     149,   209,   232,   319,   494,   268,   269,  2520,  1329,   506,
     218,  2397,  1401,  3155,   887,   888,   142,   890,  4252,  4209,
     502,   184,   186,   506,  2517,    22,   136,  4217,  1688,    14,
     156,  1420,   493,   494,   495,   496,   497,   498,   354,   254,
    1463,   190,   218,  3976,   489,   500,   222,   176,  3091,   504,
     366,   295,    37,   342,   317,   500,   184,   502,   503,   504,
     505,  1450,   935,  4263,   483,   938,   939,   330,  1378,  1729,
     390,  1532,   434,   452,  1463,    72,  1500,  1501,   951,   259,
     953,   244,   955,  1465,  2659,  2660,   231,    72,   961,  2664,
     227,  1532,   965,  1475,   218,  1329,   260,   227,   208,   314,
     125,   506,   353,  1485,  4037,   128,  4039,   283,   452,   471,
     247,   240,   985,   986,   224,   120,   244,   247,    75,    76,
      77,    78,   193,   146,   195,    82,   306,   506,  2703,  2704,
     446,   193,  1514,   195,   361,  1517,   266,   426,   161,  1521,
    1522,   286,  1583,  1584,  1585,  3032,   390,   377,   173,  2861,
     326,  1024,   316,  1026,    75,    76,    77,    78,   502,   283,
    1517,    82,  4200,   483,  1521,  1522,   295,   172,   385,   298,
    2889,  3384,  1561,  1562,   401,  1564,   153,  1601,  3954,   489,
    1584,  1585,   502,   434,   505,  1646,   385,   173,   222,   212,
    1500,  1501,  1633,   342,   504,  1532,  1517,    88,   232,  1640,
    1521,  1522,   326,   493,   494,  1646,   401,   506,   388,    75,
      76,    77,    78,   247,  2242,    88,    82,  2587,   195,   436,
     471,  1603,   113,   450,   249,    88,  2862,  1100,   392,  1633,
     493,   494,   495,   496,   497,   498,  1640,   436,  1595,   469,
     113,  1114,  1115,   314,   354,  1118,  1583,  1584,  1585,   392,
     113,  1532,   508,   324,   259,   450,  3832,  3833,   422,   186,
     385,   390,   324,  1620,  1621,  2901,   252,  2903,   209,   294,
    2500,   296,  1593,   503,  1595,   341,   506,   426,    41,   422,
     425,   306,   427,  1517,  1157,   228,   450,  1521,  1522,   387,
     186,  1601,  1613,   457,   306,   469,  1633,  3135,   469,  1620,
    1621,   306,  1583,  1640,   370,   469,  1663,   248,   294,  1646,
     296,   436,  1669,   256,   457,   340,   452,  2547,  1532,   469,
     332,    72,   452,   360,   262,  3221,   424,  2508,   271,   341,
    3744,   505,    16,   260,   505,    86,   446,   280,   502,   341,
     387,   361,  1663,  3181,  1726,   379,  1532,   384,  1669,  3245,
     375,   371,  1977,  1710,   483,   505,  1713,  1714,  3070,   502,
    3403,  3404,   319,   503,   260,  1646,   506,  1828,   370,  1603,
     207,   469,   470,   502,  1879,   395,   506,   424,   341,   341,
    3508,   218,   222,   388,   409,   222,  3599,  1828,    51,  1710,
      14,  3604,  1713,  1714,  3607,   268,   269,  1583,  1584,  1585,
    2804,  2881,   242,  2773,   502,   268,    69,   370,   370,  1766,
     218,   374,   393,    37,   222,   470,   337,   247,  1998,   315,
     316,   356,   469,   470,  3455,    81,  1926,   264,  3266,  1663,
      86,  2770,  1646,   488,  1831,  1669,   399,   380,   222,  1532,
     341,   422,  4375,   455,   317,  1766,   283,  1633,   323,   231,
    1532,  1848,  1834,   319,  1640,   502,  1329,   174,   242,  4120,
    1646,  1334,  4060,  1336,  1650,   392,  1339,   389,  1341,   370,
    2158,  1344,  1345,  1346,  1981,   283,  1710,  1350,   273,  1713,
    1714,  1870,   463,  3193,  1357,  1671,  2158,  2723,    34,   326,
    1583,  1828,  3248,  3249,   328,   422,   392,   334,  1371,   333,
    1373,  4077,   151,  3139,   286,  1378,   469,  3143,   497,  3145,
    1997,  3147,  3148,   502,   432,   504,   341,  3756,   326,   341,
    3156,   424,  2723,   450,   328,  2676,   422,  2678,  2679,   333,
     457,  1913,  1766,  1989,  1916,  1989,  1925,  1989,  1989,  3284,
     370,  1862,   469,  2571,   374,   370,   505,  1828,   370,  3574,
     509,  4149,   150,  1646,   450,   502,  1913,  1650,  3194,  1916,
    1746,   457,  3558,   174,  1646,  3697,   469,   470,  1650,   399,
    2751,   436,  3700,   469,   399,   502,  2052,   399,  1671,  2055,
    2003,  2004,   231,    75,    76,    77,    78,   470,  1977,  1671,
      82,  2014,  1913,   325,  2017,  1916,   328,  2798,   372,   502,
    1989,   250,  2025,  2026,   202,   488,   502,    95,   445,  2070,
     103,   104,   389,   101,  1828,  2038,  2039,   155,  1491,   502,
     493,   494,   495,   496,   497,   498,  2049,  1500,  1501,  2070,
     493,   494,   495,   496,   497,   498,   425,   286,   427,   469,
    2022,   500,  1828,   425,  1517,   427,  2184,   506,  1521,  1522,
     250,  3226,   140,  1746,  3229,  3230,  3231,  3232,  3233,  3234,
    3235,  3236,  3237,  3238,  1746,   158,   503,    85,  2168,    75,
      76,    77,    78,  3385,  3386,   507,    82,  3396,   276,   277,
      72,   463,   505,   387,   333,  2074,   509,   180,  2268,   242,
    2270,   289,   501,   186,  2015,  2016,   505,   174,    75,    76,
      77,    78,  2023,   191,   207,    82,  2027,  2028,   124,   158,
     198,  3286,  3287,   201,   389,   218,   341,  2158,   211,   222,
     424,  2042,   503,  2044,   273,   506,  3060,  1176,  1601,  1178,
    1603,   180,   508,  2070,   370,  1828,  1185,   186,   374,    71,
    1613,  3954,  2063,   341,  2065,   370,  1828,    79,    80,   374,
    2132,   500,   470,   502,  2158,   504,   501,   425,  2263,   427,
     505,   264,   211,   399,   252,   469,   470,   260,   502,  2210,
     488,  2212,    85,   502,   399,    88,   425,   503,   427,   505,
     283,   273,    71,    72,   502,  2174,    86,   436,    85,  2070,
    1663,    88,   105,  2114,   133,   134,  1669,   446,   502,  3476,
    2261,  4099,  3182,  3336,   181,   500,  2210,   502,  2212,   497,
     328,   260,   938,   503,   502,   505,   504,   503,   306,   505,
    2261,  2158,   505,   326,  3025,   485,   424,   953,   426,   955,
    4043,   334,   502,   469,   504,   126,   124,  1710,   392,   965,
    1713,  1714,    71,    72,   114,   503,  2351,   505,   270,  2231,
      79,    80,   503,   341,   505,   331,  2070,    86,  3059,   985,
     986,   504,   503,  2184,   505,  2247,   157,  2249,   422,  2251,
    2227,   331,  3102,  2210,   328,  2212,  2337,  3306,  3307,   505,
     506,   162,   370,  2508,  2070,   193,   374,   195,   432,   503,
    2247,   505,  2249,  1766,  2251,    85,  2337,   485,    88,   392,
     328,  3479,  3480,   457,  4032,  3483,  2227,  3485,   216,   383,
     384,   399,  3392,   319,  3939,   469,  2298,   493,   494,   495,
     496,   497,   331,   214,  2261,   270,  2247,   503,  2249,   422,
    2251,  2372,  2242,   114,  4147,   495,   496,   497,   485,   503,
    3121,   505,   445,   392,  3125,   495,  3521,   228,   502,   399,
    2184,   503,   226,   505,   245,   268,   954,   450,   383,   384,
     958,   959,   960,  3708,   457,  2459,   505,   503,   461,   505,
     968,   268,  2158,   422,   502,   256,   469,  2070,   503,  3615,
    2261,  4229,   503,  4231,   505,   124,  3622,  3623,  2070,  3170,
     271,   503,   503,  2227,   505,   508,   502,  2231,   504,   280,
    2337,   450,  2359,   503,   506,   505,   314,  3583,   457,   502,
    2367,   319,  2369,  2247,   469,   470,   324,   330,   508,   503,
     469,   505,   303,   503,  2210,   505,  2212,   495,   503,    85,
     505,   262,    88,   330,   432,  2372,  2418,   503,  2359,   505,
     204,   503,  2760,   505,  2426,   432,  2367,  2261,  2369,   105,
     341,    85,   432,   502,    88,   502,  2337,   247,    75,    76,
      77,    78,  1935,   432,  1937,    82,   505,   506,  1941,    86,
    1943,   105,   503,  1946,   505,  2261,   432,  1950,   268,   370,
     108,  2706,  1955,   374,   503,   124,   505,   378,   469,   470,
    2472,  2372,   268,   384,    75,    76,    77,    78,   502,   380,
     391,    82,     7,   503,   262,   505,  3476,   126,   399,   503,
     432,   505,  2494,   504,    19,    20,   407,   502,  2500,  2508,
     503,  2442,   505,  2337,   415,  2359,   472,  3702,  3703,   425,
     438,   427,   502,  2367,    39,  2369,  4132,    42,   157,   447,
     330,  3853,   504,  4356,   193,   425,   195,   427,   503,   328,
     505,  2337,   486,   487,  3790,  3791,  2805,  2806,  2372,    75,
      76,    77,    78,   506,   181,  2547,    82,   216,  2261,  3846,
     469,   470,   503,   464,   505,   222,   489,   490,   491,  2261,
     493,   494,   495,   496,   497,   498,  2372,   503,   503,   505,
     505,  2746,  2747,   490,   491,   214,   493,   494,   495,   496,
     497,   498,   503,  3384,   505,   503,  2629,   505,  1334,   503,
    1336,   505,   268,  1339,   281,  1341,  3417,   452,  1344,  1345,
    1346,   328,  1069,  2684,  1071,  2098,   245,   503,  2689,   505,
    2587,  1357,  2105,   502,   268,    75,    76,    77,    78,   323,
    3985,  2114,    82,  2684,  2337,  1371,   389,  1373,  2689,   154,
      75,    76,    77,    78,  2677,  2337,   503,    82,   505,   273,
    4285,  2571,     2,   502,  3634,   181,  2587,   503,   136,   505,
     319,   503,   469,   505,   330,   324,   503,   108,   505,  2372,
    3773,  1383,  1384,  2706,   493,   494,   495,   496,   497,   194,
    2372,    95,   501,   503,   472,   505,   330,   101,   502,   489,
     490,   491,   114,   493,   494,   495,   496,   497,   498,   114,
     503,  2184,   505,  3748,   503,   441,   505,  2706,  2741,   341,
     503,  3841,   505,   503,   222,   505,  3962,   148,  3964,  3965,
     503,  2720,   505,   503,  1332,   505,   140,  1335,    78,  3975,
    1338,   181,  1340,   452,    84,  1343,   503,  2684,   505,  1347,
    2739,   357,  2689,  2587,  2227,   374,  4399,   376,  2231,   378,
     507,   503,  2751,   505,  2237,   384,  2239,   212,   503,  2242,
     505,   503,   391,   505,   212,   502,  4088,   117,   212,   503,
     399,   505,   212,    75,    76,    77,    78,   191,   407,   438,
      82,  2773,   472,   503,   198,   505,   415,   201,   447,   503,
     503,   505,   505,  2684,   212,   503,  3981,   505,  2689,   503,
     505,   505,   152,   503,   212,   505,  2773,   503,  3599,   505,
     212,   212,   162,  3604,   328,   503,  3607,   505,   212,   212,
    4005,  4006,  4177,   489,   490,   491,   212,   493,   494,   495,
     496,   497,   498,   328,   503,   464,   505,  2768,   252,   120,
    2771,   503,  2773,   505,   212,   489,   490,   491,   212,   493,
     494,   495,   496,   497,   498,   503,   422,   505,   162,   209,
    2684,   503,   503,   505,   505,  2689,   216,  4222,   218,   502,
     108,  4226,  4227,   503,   223,   505,  2359,   281,   222,    89,
     230,   824,   163,   503,  2367,   505,  2369,   830,  2684,   503,
     222,   505,   306,  2689,  3126,   838,  3128,    75,    76,    77,
      78,   502,   502,   846,    82,  3751,   187,   502,   851,  2960,
    2961,  2962,   502,   502,    85,   502,   350,    88,   502,    75,
      76,    77,    78,   502,   228,   206,    82,   341,  4174,  2773,
      75,    76,    77,    78,   105,   502,   505,    82,   502,   913,
    3751,   502,   223,   917,   502,   502,   502,  3078,   502,  3020,
     502,  4238,   256,   927,  2946,  3899,   370,   238,   502,   502,
     374,  4207,  4224,   502,   502,   502,   502,   271,   502,  3020,
    4223,   502,   502,   502,  2966,   338,   280,   108,   164,   266,
     281,  2684,   268,  3114,   108,   399,  2689,  3058,   222,   326,
      85,  4176,  2684,    88,   222,   495,  3111,  2689,   262,   303,
     390,   298,   505,   180,   451,  2997,   505,  3058,  3000,  3001,
     489,    14,  3004,  2960,  2961,  2962,   366,  3079,   505,   502,
     502,   502,  3014,   432,   328,   432,   432,  3019,   504,   432,
     328,   391,  3094,  3025,   432,   432,   979,   432,   319,  3031,
     319,   432,   143,   328,   252,   432,   327,   432,   502,   505,
     341,   401,  3114,   996,   175,   451,   432,   341,  3025,  3294,
     452,   432,   432,   452,   124,   124,   432,  3059,   387,  2960,
    2961,  2962,   502,  3020,   432,   332,   380,   432,   359,   432,
    3079,  3073,   328,   328,  1027,   432,   432,   432,  2571,  2572,
     432,   469,  3059,   268,  3025,  3094,   108,   268,   460,  3030,
    3031,  1044,   502,   502,  2587,   107,    97,   181,   462,  3101,
    3102,  3058,   452,   289,   502,  3114,   108,  3179,   222,   502,
     463,  3052,  3121,  4137,  1067,   108,  3125,   273,  3059,  3020,
     504,  3296,  3297,  3298,  3299,   388,  2960,  2961,  2962,   466,
     212,    95,   452,   212,   452,   212,   212,   101,   452,    14,
     323,   457,   432,   505,   377,   318,   227,   430,  3078,   330,
    4199,   502,   465,  3954,  2960,  2961,  2962,  3058,   485,    88,
    4423,  4417,   300,   268,   300,   505,   430,   399,   502,   502,
    3179,  3025,   432,   227,   505,   434,   140,   505,  3259,   489,
     503,   241,   241,   489,  3114,   329,  3020,   324,  4044,  1935,
     264,  1937,    34,    10,   387,  1941,   505,  1943,  3259,   150,
    1946,   505,   432,   503,  1950,  3059,   432,   387,  4064,   452,
     503,   503,  3255,   319,  3020,   502,   272,   272,   502,   319,
     319,   328,   335,  4044,  3058,   330,    95,   191,   432,   327,
     505,   432,   101,   396,   198,   370,   361,   201,   370,  4060,
     370,   432,  4043,  4064,   268,   108,   452,  2960,  2961,  2962,
     432,   268,  3058,   268,   452,   327,   502,   268,  2960,  2961,
    2962,   268,  4063,   107,   489,   500,   500,   432,  3270,   222,
     432,   140,  3430,  3611,   489,  2768,   224,   324,   638,   502,
    2773,   396,   108,   211,   328,  3294,   328,   496,   252,   239,
     239,   222,   505,   108,   502,  1248,  1249,  1250,  4099,   212,
     328,   328,  3259,   396,   222,  1289,   247,  3020,   489,   490,
     491,  3313,   493,   494,   495,   496,   497,   498,  3020,   472,
     247,   247,   191,   502,    96,  4433,   233,   505,   297,   198,
     328,   505,   201,   124,   503,  3416,   503,  3418,   227,   503,
     485,   227,   306,   503,   503,  3058,  4147,   505,   466,   503,
     337,   503,   503,   503,   503,  3416,  3058,  3418,  3259,   485,
     503,   503,  4316,   503,   503,    90,   432,    90,   489,   502,
    4478,   283,   328,   331,   503,   502,   328,   341,  4486,   503,
    3441,  1365,   505,   252,   489,   490,   491,   506,   493,   494,
     495,   496,   497,   498,   503,   505,   432,  1381,   455,   503,
     502,   502,   258,   319,   212,   502,   370,   212,   345,  1393,
     374,  1364,   283,   345,   449,  3417,    85,   268,   432,    88,
    3361,   268,   292,   432,   292,  3259,   292,   432,   432,  3431,
     268,   268,  3434,   432,  3436,   399,   105,   306,   432,  1392,
    3417,   432,   432,   268,   113,   268,   268,   500,   808,   118,
     298,   503,   812,  3259,   503,   283,   816,  4313,  3460,  3416,
     489,  3418,   822,   441,  3466,  3467,  3468,  3469,  3470,  3471,
     332,   372,   341,   174,  3476,   505,  3417,   502,   327,   236,
     503,   502,   328,   503,  3441,   432,   271,   271,   324,  3430,
     108,   336,  4313,   853,   502,   452,   222,   452,   331,  3476,
     387,  3503,   387,   387,   210,   374,   210,   204,   126,   505,
    3512,  3513,  3514,  3515,  3491,  3416,   500,  3418,   227,    88,
     222,   503,   503,   503,   462,   134,   502,   227,   503,   503,
     399,   503,  3025,   503,   894,  3476,   235,   505,   222,   157,
    3441,   502,   329,   489,   489,   905,  3259,   489,  4349,  3490,
    3491,   258,   912,   441,   432,  4356,  3628,  3259,  3499,   441,
     432,   222,  3503,  3417,   503,  3765,  3059,   432,   432,  3571,
    1554,  3512,   932,   503,   243,  1528,  3430,   268,   247,   503,
     503,  4382,  3416,   268,  3418,  3078,   501,   108,   502,   272,
    3599,   502,   469,   472,   222,  3604,   214,   505,  3607,   268,
     269,   503,  3760,   823,   253,   505,   146,  3441,   828,   469,
    3416,   424,  3418,   282,   469,   505,   432,   837,    85,  3628,
     271,  3114,  3476,   503,   232,   396,   502,   245,  3786,   502,
     227,   227,   467,   467,   124,  3441,   503,   237,   432,   227,
     469,   502,   862,   502,  3687,   314,   866,   505,   317,   503,
     503,   503,   441,   503,   319,   273,   876,  3634,   489,   319,
     212,   330,  1022,   268,   333,   505,   505,   319,  1028,   188,
     183,   254,  1032,   229,   501,   452,   227,   452,   227,   199,
     255,  4482,   465,   469,   502,   331,   227,   456,   502,  1049,
     502,   502,   502,  3634,   408,   468,   503,   503,  1058,   344,
     503,   503,   328,  3416,   366,  3418,   452,   502,   469,   502,
     222,   108,   319,   293,  3416,   250,  3418,  3875,   211,   174,
     502,   332,   136,  2037,   136,   384,   384,   331,  3441,   489,
     124,   334,   502,   222,   403,   328,   424,  1690,   217,  3441,
     331,   358,  3744,  3745,   331,   194,    85,   505,   456,   108,
     817,   227,   108,   820,  3756,   466,   374,   505,   364,   469,
     378,   199,   328,  3844,   328,   108,   384,  3744,   502,   836,
     126,   469,   503,   391,   502,   186,   503,   450,   502,  3756,
    3634,   399,  2096,  3844,   383,   383,    94,  1740,   105,   407,
     211,   358,   859,   358,  2458,  2773,  1522,   415,  1747,   502,
    2343,   157,  2894,  3744,  3416,  4080,  3844,   874,  1761,  3019,
    4238,  4132,  3562,  3892,  4136,  3756,  2856,  2576,  4380,  3760,
     489,   490,   491,  4043,   493,   494,   495,   496,   497,   498,
    3832,  3833,   501,  3905,  4422,  4343,  1196,  4342,   507,  4389,
    3901,   108,  3564,  1203,  3846,  3786,   464,  1849,  3850,  3851,
     468,   469,  3854,  3855,  2288,  4156,  3797,  3798,   214,   126,
    3441,  3802,  3803,  1835,  1224,  3867,  3868,  3869,  3870,  3871,
    2961,  3364,  2446,  3072,  4425,  4486,  4478,  3058,  3861,  3860,
    3024,  4396,  4066,  1826,  4324,   188,  4069,  3844,  1366,   245,
     157,  3637,  4205,  1253,  1114,  1115,  3905,  3572,  2311,  1883,
    3574,  4285,   902,  4405,  4480,  4121,  3760,  2169,  1892,  3911,
    2168,  1926,  3556,  3180,  2784,  1043,  2795,   273,  2559,  2204,
    1904,  1553,  1571,  1570,  3417,  2807,  3867,  3868,  3869,  3870,
    3871,  1322,  3786,  2801,  3875,  2203,  3938,  3430,  1060,  2187,
    1573,  1894,  2161,  3844,  3901,  3954,  2751,   214,  1308,  1309,
    1903,  1311,  2508,  3127,  3955,  2785,  1048,  3553,  3269,  1319,
     896,  4179,  3261,  4369,  4373,  4370,  2798,  2720,  2631,  2599,
    1923,  2718,  2099,  4016,   638,  3111,  2501,  1864,   245,  1963,
    1260,  2231,  1966,  3476,  1968,  4363,   367,  1971,  1579,  1585,
     934,  2207,  2247,  1378,  2767,  3364,  2239,  1117,  2240,  3743,
    3901,  1117,  1497,   150,  3365,  3341,   273,   400,  1583,  1955,
    3844,  2251,   159,   160,   161,  2572,  1969,  1970,   374,  1379,
    1137,  3875,   378,  1308,     2,    -1,    -1,    -1,   384,   964,
      -1,    -1,    -1,    -1,    -1,   391,    -1,    -1,  3844,    -1,
      -1,    -1,    -1,   399,    -1,  1405,    -1,    -1,    -1,    -1,
    4027,   407,    -1,    -1,    -1,    -1,   203,    -1,  4060,   415,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3901,    -1,    85,
      -1,    -1,    88,  1433,    -1,  4077,    -1,    -1,    -1,  4081,
      -1,    -1,    -1,  4060,    -1,    -1,  4027,    -1,    -1,   105,
      -1,    -1,  1159,  1160,    -1,  3901,    -1,   113,    -1,    -1,
    1460,  1461,   118,  1463,    -1,   252,    -1,   374,   464,    -1,
      -1,   378,   468,    -1,    -1,    -1,  1476,   384,    -1,  4060,
    1480,    -1,    -1,    -1,   391,    -1,    -1,    -1,    -1,    -1,
      -1,  3844,   399,    -1,    -1,    -1,    -1,    -1,  4181,    -1,
     407,  3634,  3844,    -1,   291,  2098,    -1,    -1,   415,    -1,
      -1,  1218,    -1,    -1,    -1,    -1,    -1,  1517,    -1,    -1,
     307,   308,   309,   310,   311,    -1,   313,  1234,  1235,    -1,
    2123,  1531,  1532,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1251,  2659,  2660,    -1,  3901,    -1,
    2664,  4252,  4437,    -1,    -1,    -1,    -1,   464,   345,  3901,
      -1,   468,    -1,  1563,    -1,    -1,  4060,  1567,  1568,    -1,
      -1,    -1,    -1,    -1,  2167,    -1,  2169,    -1,  1285,  1286,
      -1,    -1,    -1,  1583,  1584,  1585,    -1,   243,    -1,  2703,
    2704,   247,    -1,    -1,    -1,    -1,  4238,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3744,   268,   269,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4305,    -1,    -1,    -1,   282,  3760,    -1,    -1,
      -1,   418,    -1,  1633,    -1,    -1,    -1,    -1,    -1,    -1,
    1640,  1641,    -1,    -1,    -1,    -1,  1646,    -1,    -1,    -1,
    1650,    -1,    -1,  3786,    -1,  4252,    -1,   444,   314,    -1,
      -1,   317,    -1,    -1,   451,    -1,    -1,   454,    -1,    -1,
      -1,  1671,    -1,    -1,   330,    -1,    -1,   333,  1678,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4405,
      -1,  4405,  2316,  4405,  4405,    -1,    -1,    -1,    -1,    -1,
      -1,  1701,    -1,    -1,    -1,  2659,  2660,    -1,  4289,    -1,
    2664,  4252,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      71,  4437,    -1,  4437,    -1,  4437,  4437,    -1,    79,    80,
      -1,    -1,    -1,    -1,    85,    -1,    -1,    88,    -1,    -1,
      -1,  2334,  3875,  1603,    -1,    -1,  1746,   403,    -1,  2703,
    2704,    -1,    -1,    -1,   105,    -1,  4405,   108,    -1,    -1,
    1224,    -1,   113,  1763,  4480,    -1,  4480,   118,  4480,  4480,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4252,    -1,
    1780,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4437,    -1,
      -1,  4433,    -1,    -1,    -1,  4289,    -1,    -1,  1798,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4252,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4433,    -1,    -1,    -1,
      -1,    -1,    -1,  1823,    -1,    -1,    -1,    -1,  1828,    -1,
      -1,  4480,    -1,   489,   490,   491,  4478,   493,   494,   495,
     496,   497,   498,    -1,  4486,    -1,    -1,    -1,    -1,   505,
      -1,    -1,  4433,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4478,    -1,  2456,    -1,    -1,    -1,    -1,    -1,  4486,
    1870,    -1,  1872,    -1,    -1,    -1,    -1,    -1,  1878,    -1,
      -1,  1881,    -1,    -1,  1744,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   243,    -1,    -1,    -1,   247,  4478,    -1,  4252,
      -1,    -1,    -1,  1224,    -1,  4486,    -1,    -1,    -1,    -1,
    4252,    -1,    -1,  1913,    -1,  1379,  1916,   268,   269,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4060,    -1,    -1,
      -1,   282,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2583,
      -1,    -1,    -1,   314,    -1,  1965,   317,    -1,    -1,    -1,
      -1,    -1,  1832,    -1,    -1,    -1,    -1,    -1,    -1,   330,
      -1,    -1,   333,    -1,    -1,    -1,    -1,  1847,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2003,  2004,    -1,    -1,    -1,    -1,    -1,
      -1,  2011,    -1,    -1,  2014,    -1,    -1,  2017,    -1,    -1,
      -1,    -1,  2022,    -1,    -1,  2025,  2026,    -1,    -1,  1736,
    1737,  1738,  1739,  2033,    -1,    -1,  2036,  2037,  2038,  2039,
      -1,    -1,    -1,    -1,    -1,  1905,  2046,  2047,    -1,  2049,
      -1,  2051,   403,    -1,  2054,    -1,    -1,    -1,  1379,    -1,
    1767,  1768,    -1,    -1,    -1,    -1,  1773,    -1,  2068,  2069,
    2070,    -1,    -1,  2073,    -1,    -1,    -1,  2077,    -1,    -1,
      -1,  2081,    -1,  2083,  2084,  2085,  2086,  2087,  2088,  2089,
    2090,  2091,    98,  2093,    -1,    -1,    -1,    -1,    -1,  2099,
      -1,    -1,  2102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3226,    -1,    -1,  3229,  3230,  3231,  3232,  3233,
    3234,  3235,  3236,  3237,  3238,    -1,    -1,    -1,    -1,    -1,
      -1,  1838,  1839,  1840,  1841,    -1,    -1,    -1,   489,   490,
     491,    -1,   493,   494,   495,   496,   497,   498,    -1,   155,
      -1,    -1,  2745,    -1,    -1,    -1,  4289,    -1,  2158,    -1,
      -1,    -1,    -1,    -1,    -1,    85,    -1,    -1,    88,   175,
      -1,  2171,  3286,  3287,    -1,   181,    -1,  1641,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   105,    -1,    -1,    -1,    -1,
     196,    -1,    -1,   113,    -1,    -1,  1517,    -1,   118,    -1,
      -1,    -1,    -1,  1910,    -1,    -1,    -1,    -1,    -1,    -1,
    2210,  2804,  2212,    -1,    -1,    -1,    -1,    -1,   224,    -1,
      -1,    -1,    -1,   229,    -1,  2849,  2850,    -1,  2852,   235,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1701,    -1,    -1,
      -1,    -1,    -1,    -1,   250,    -1,    -1,    -1,    -1,  2249,
      -1,  2251,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2261,    -1,    -1,    -1,    -1,    -1,    -1,   274,    -1,
      -1,    -1,  3226,    -1,    -1,  3229,  3230,  3231,  3232,  3233,
    3234,  3235,  3236,  3237,  3238,  2285,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1763,
      -1,    -1,    -1,    -1,    -1,  2305,    -1,    -1,    -1,    -1,
    2310,  2311,    -1,    -1,    -1,    -1,  1780,    -1,    -1,    -1,
    1641,  2321,    -1,   243,   330,  2949,    -1,   247,    -1,    -1,
      -1,    -1,  3286,  3287,    -1,    -1,    -1,  2337,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   268,   269,
      -1,   357,    -1,    -1,    -1,    -1,    -1,  1678,    -1,  1823,
      -1,    -1,   282,    85,    -1,    -1,    88,    -1,    -1,    -1,
      -1,  2231,  2372,    -1,    -1,   381,    -1,    -1,    -1,    -1,
    1701,   387,    -1,   105,    -1,    -1,    -1,   393,    -1,    -1,
     396,   113,    -1,    -1,   314,    -1,   118,   317,  2258,    -1,
      85,    -1,  2262,    88,    -1,    -1,    -1,  3521,    -1,    -1,
     330,    -1,    -1,   333,  1878,    -1,   422,    -1,   424,    -1,
      -1,    -1,   428,    -1,  2284,  3049,    -1,  3051,   113,    -1,
     436,    -1,  2292,   118,  2434,   441,  2436,    -1,    -1,    -1,
      -1,    -1,  1763,    -1,    -1,   451,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2315,    -1,   463,    -1,  1780,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2335,    -1,  1798,  3071,    -1,
      -1,    -1,    -1,   403,    -1,    -1,    -1,    -1,  3081,    -1,
      -1,    -1,  2352,    -1,    -1,  2355,    -1,  2497,    -1,    -1,
      -1,    -1,  1823,  3096,    -1,    -1,    -1,    -1,  2508,    -1,
      -1,    -1,    -1,  2373,    -1,    -1,    -1,    -1,  2518,    -1,
    2380,   243,    -1,    -1,    -1,   247,    -1,    -1,    -1,  2389,
      -1,    -1,    -1,    -1,    -1,    -1,  2396,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3168,    -1,   268,   269,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2555,  3149,  1878,   243,  3152,
     282,    -1,   247,    -1,    -1,    -1,    -1,  3521,  3192,   489,
     490,   491,    -1,   493,   494,   495,   496,   497,   498,    -1,
      -1,    -1,    -1,   268,   269,   505,    -1,    -1,  3702,  3703,
      -1,    -1,   314,    -1,    -1,   317,    -1,   282,    -1,  2599,
    3193,    -1,    -1,    -1,  2068,    -1,    -1,    -1,   330,    -1,
    2610,   333,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2629,
    2630,    -1,   317,    -1,    85,    -1,    -1,    88,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   330,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   105,    -1,    -1,    -1,  2365,  2659,
    2660,    -1,   113,    -1,  2664,    -1,    -1,   118,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2676,  2677,  2678,  2679,
      -1,   403,    -1,    -1,  2684,    -1,    -1,    -1,  2688,  2689,
      -1,  2691,    -1,  2693,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2703,  2704,  2412,  2706,    -1,  3301,  3302,
      -1,    -1,  2419,  2420,  2421,  2422,  2423,  2424,   403,  2719,
      -1,  2721,    -1,    -1,    -1,  2725,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2741,    -1,    -1,    -1,    -1,    -1,  2068,  3702,  3703,
      -1,  2751,    -1,  2753,  2754,  2755,    85,    -1,    -1,    88,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,   491,
      -1,   493,   494,   495,   496,   497,   498,  2777,    -1,    -1,
      -1,   503,    -1,  2490,   113,    -1,  2786,    -1,    -1,   118,
      -1,    -1,   243,    -1,    -1,  2795,   247,    -1,    -1,    -1,
    2800,    -1,    -1,    -1,   489,   490,   491,  2807,   493,   494,
     495,   496,   497,   498,    -1,    -1,    -1,   268,   269,    -1,
      -1,    -1,    -1,  2530,    -1,  2532,    -1,    -1,    -1,    -1,
      -1,   282,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2855,    -1,  2321,    -1,    -1,
      -1,    -1,    -1,   314,    -1,    -1,   317,  3981,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   330,
      -1,    -1,   333,  2883,  2884,    -1,  2886,    -1,    -1,    -1,
      -1,  4005,  4006,    -1,    -1,    -1,    -1,    -1,    85,    -1,
      -1,    88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3535,  3536,    -1,   243,    -1,  3509,    -1,   247,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   113,  2927,    -1,  2929,
      -1,   118,    -1,    -1,  3527,    -1,    -1,    -1,    -1,   268,
     269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3544,   403,   282,    85,    -1,    -1,    88,    -1,    -1,
    2960,  2961,  2962,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2436,    -1,   105,    -1,    -1,    -1,  2838,    -1,
      -1,    -1,   113,    -1,  2305,   314,    -1,   118,   317,  2310,
    2311,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2998,    -1,
    2321,   330,    -1,    -1,    -1,  3629,  3630,  3631,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   206,
    3020,    -1,    -1,    -1,  3024,  3025,    -1,  3981,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,
     491,    -1,   493,   494,   495,   496,   497,   498,    -1,    -1,
     501,  4005,  4006,    -1,    -1,    -1,   243,    -1,  3058,  3059,
     247,    -1,  4176,  2923,    -1,    -1,    -1,    -1,    -1,    -1,
    2930,    -1,    -1,    -1,   403,    -1,  3076,    -1,    -1,    -1,
      -1,   268,   269,    -1,    -1,    -1,    85,    -1,    -1,    88,
    3090,    -1,    -1,    -1,    -1,   282,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3103,    -1,    -1,   105,    -1,    -1,    -1,
      -1,    -1,   243,    -1,   113,  2436,   247,    -1,    -1,   118,
      -1,  3121,    -1,    -1,    -1,  3125,  3719,  3720,  3721,  3722,
     317,    -1,  2992,    -1,  3134,    -1,    -1,   268,   269,    -1,
    3140,    -1,    -1,   330,    -1,    -1,  2610,    -1,    -1,    -1,
      -1,   282,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     489,   490,   491,    -1,   493,   494,   495,   496,   497,   498,
    3170,    -1,    -1,    -1,    -1,    -1,  2497,    -1,    -1,    -1,
      -1,    -1,    -1,   314,    -1,    -1,   317,    -1,    -1,    -1,
      -1,    -1,    -1,  3817,  3818,    -1,  3820,    -1,    -1,   330,
      -1,    -1,   333,  3203,    -1,    -1,  3206,    -1,    -1,    -1,
      -1,    -1,  3212,    -1,    -1,    -1,   403,    -1,  3218,    -1,
    3220,    -1,  4176,    -1,    -1,  3225,  3226,    -1,    -1,  3229,
    3230,  3231,  3232,  3233,  3234,  3235,  3236,  3237,  3238,    -1,
      -1,    -1,  3242,  3243,   243,    -1,    -1,    -1,   247,    -1,
    3250,    -1,    -1,    -1,    -1,  3255,    -1,    -1,    -1,  3259,
      -1,  3261,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   268,
     269,  3271,   403,    -1,  3274,    -1,  3276,    -1,    -1,    -1,
      -1,    -1,    -1,   282,  3284,  3285,  3286,  3287,    -1,  2610,
      -1,  3291,    -1,    -1,  3294,  3155,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3304,    -1,   493,   494,   495,   496,
     497,   498,  3312,  3173,  3314,   314,    -1,    -1,   317,    -1,
      -1,    -1,    85,  3947,    -1,    88,    -1,    -1,    -1,    -1,
      -1,   330,    -1,  3957,   333,  3195,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    89,    -1,    -1,    -1,    -1,    94,  3942,
     113,    -1,    -1,    -1,    -1,   118,    -1,    -1,   489,   490,
     491,    -1,   493,   494,   495,   496,   497,   498,    -1,    -1,
      -1,    -1,   503,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3384,    -1,   132,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   403,    -1,   152,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3416,  3417,  3418,    -1,
      -1,    -1,    -1,    -1,    -1,   171,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   185,
      -1,  3441,    -1,   206,    -1,    -1,    -1,   193,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   208,  2927,   210,  2929,    -1,    -1,   214,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   223,    -1,    -1,
     243,    -1,    -1,    -1,   247,   231,   232,    -1,    -1,    -1,
     489,   490,   491,    -1,   493,   494,   495,   496,   497,   498,
      -1,    -1,    -1,    -1,   503,   268,   269,    -1,    -1,    85,
      -1,    -1,    88,    -1,    -1,  4108,    -1,    -1,    -1,   282,
      -1,  3521,    -1,    -1,    -1,    95,    -1,    -1,    -1,    -1,
    3390,   101,    -1,    -1,  2998,    -1,    -1,   113,  4162,  3539,
      -1,    -1,   118,    -1,  4137,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   317,   125,    -1,    -1,    -1,    -1,
      -1,    85,  2883,  2884,    88,  2886,    -1,   330,    -1,    -1,
     140,    -1,    -1,    -1,  3574,  3575,  3576,    -1,    -1,    -1,
      -1,   105,    -1,    -1,    -1,    -1,    -1,    -1,  3448,   113,
    3450,    -1,    -1,    -1,   118,    -1,    -1,    -1,    -1,  3599,
      -1,    -1,    -1,   173,  3604,    -1,  2927,  3607,  2929,  4233,
      -1,    -1,  3076,    -1,    85,    -1,    -1,    88,    -1,    -1,
      -1,   191,    -1,  4216,    -1,    -1,  3090,    -1,   198,    85,
      -1,   201,    88,    -1,   105,    -1,    -1,    -1,    -1,    -1,
     403,    -1,   113,    -1,    -1,    -1,    -1,   118,    -1,   105,
      -1,  3651,    -1,    -1,    -1,    -1,    -1,   113,    -1,    -1,
      -1,    -1,   118,    -1,    -1,    -1,    -1,   243,    -1,    -1,
      -1,   247,    -1,    -1,    -1,    -1,  3140,  2998,    -1,   249,
      -1,    -1,   252,    -1,    -1,    -1,    -1,  3687,    -1,    -1,
      -1,    -1,   268,   269,  3694,  3695,    -1,  3697,    -1,    -1,
      -1,    -1,  3702,  3703,  3025,    -1,   282,  3707,  3708,    -1,
      -1,    -1,    -1,  3713,  3714,    -1,    -1,  3717,    -1,   243,
      -1,    -1,    -1,   247,   294,    -1,   296,    -1,  3728,    -1,
     493,   494,   495,   496,   497,   498,   306,    -1,  3059,    -1,
    3740,   317,  3206,    -1,   268,   269,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   330,  3076,  3756,    -1,   282,    -1,
      -1,  3225,    -1,    -1,    -1,    -1,    -1,    -1,  3768,  3090,
     340,   341,   243,    -1,    -1,    -1,   247,    -1,    -1,    -1,
      -1,    -1,  3103,    -1,    -1,    -1,  3250,   243,    -1,  3789,
     314,   247,    -1,   317,    -1,    -1,    -1,   268,   269,  3799,
     370,    -1,    -1,    -1,   374,   375,   330,    -1,    -1,   333,
      -1,   282,   268,   269,    -1,    -1,    -1,    -1,    -1,  3140,
    3284,    -1,    -1,    -1,    -1,    -1,   282,   403,    -1,   399,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   409,
      -1,    -1,    -1,   314,  3844,    -1,   317,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   314,   330,
      -1,   317,   333,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   330,    -1,    -1,   333,    -1,   403,
      -1,    -1,    -1,    -1,    -1,  3206,    -1,    -1,    -1,    -1,
      -1,  3891,   638,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3901,    -1,    -1,  3225,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   490,   491,    -1,   493,   494,   495,
     496,   497,   498,    -1,    -1,    -1,    -1,    -1,    -1,  3250,
      -1,    -1,   403,    -1,    -1,  3795,    -1,    -1,    -1,  3939,
      -1,    -1,    -1,    -1,    -1,    -1,  3806,   403,    -1,    -1,
    3950,    -1,    -1,    -1,  3954,    -1,    -1,    -1,    -1,  3959,
      -1,    -1,    -1,  3284,    -1,   489,   490,   491,    -1,   493,
     494,   495,   496,   497,   498,    -1,    -1,    -1,    -1,   503,
      -1,  3981,    -1,    -1,    -1,  3985,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4005,  4006,    -1,    -1,  4009,
      -1,    -1,    -1,    -1,    -1,    -1,  4016,  4017,   489,   490,
     491,    -1,   493,   494,   495,   496,   497,   498,    -1,    -1,
      -1,    -1,   503,   489,   490,   491,    -1,   493,   494,   495,
     496,   497,   498,  4043,    -1,    -1,    -1,   503,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4060,    -1,    -1,  4063,    -1,  3772,  3773,    -1,    -1,    -1,
     816,   817,   818,    -1,   820,  3539,   822,   823,   824,    -1,
     826,    -1,   828,    -1,   830,    -1,   832,    -1,    -1,    -1,
     836,   837,   838,    -1,    -1,    -1,  3417,    -1,    -1,  4099,
     846,    -1,    -1,    -1,    -1,   851,    -1,   853,    -1,    -1,
      -1,   857,  3819,   859,    -1,    -1,   862,    -1,   864,    -1,
     866,   867,    -1,    -1,    -1,    -1,    -1,    -1,   874,    -1,
     876,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4147,    -1,  4149,
     896,    -1,    -1,    -1,    -1,   901,    -1,    85,    -1,   905,
      88,    -1,    -1,   909,    -1,    -1,   912,    -1,    -1,   915,
      -1,    -1,    -1,    -1,    -1,    -1,  4176,  4177,    -1,  4179,
      -1,  4181,    -1,    -1,   930,   113,    -1,    -1,    -1,    -1,
     118,    -1,    -1,    -1,    -1,   941,    -1,    85,    -1,    -1,
      88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,  3539,  4219,
      -1,    -1,  4222,    -1,    -1,   113,  4226,  4227,    -1,    -1,
     118,    -1,    -1,   979,    -1,    -1,    -1,    -1,   984,    -1,
      -1,    -1,    -1,    -1,  3708,    -1,    -1,    -1,    -1,    -1,
     996,   997,  4252,  3574,    -1,    -1,    -1,    -1,    -1,  4259,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1022,    -1,   206,    -1,
    1026,  1027,    -1,    -1,  1030,  4285,    -1,    -1,    -1,  4289,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1044,    -1,
      -1,    -1,  1048,    -1,    -1,  4305,    -1,  1053,    -1,    -1,
      -1,    -1,  1058,    -1,    -1,   243,    -1,    -1,    -1,   247,
      -1,  1067,    -1,    -1,    -1,  3789,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3799,    -1,    -1,  4045,    -1,
     268,   269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4349,
      -1,    -1,    -1,    -1,   282,   243,  4356,    -1,   158,   247,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1114,  1115,
      -1,    -1,  4372,  4373,    -1,    -1,  3697,    -1,    -1,    -1,
     268,   269,  4382,    -1,    -1,    -1,    -1,  3708,    -1,   317,
      -1,    -1,    85,    -1,   282,    88,    -1,    -1,    -1,    -1,
      -1,    -1,   330,    -1,    -1,    -1,    -1,   207,    -1,  4409,
      -1,    -1,   105,  1159,  1160,    -1,    -1,    -1,   218,  4419,
     113,    -1,   222,    -1,    -1,   118,   314,   227,    85,   317,
      -1,    88,   232,    -1,    -1,   235,    -1,   237,    -1,  4146,
      -1,    -1,   330,    -1,    -1,   333,    -1,    -1,   105,    -1,
    1196,    -1,    -1,    -1,    -1,    -1,   113,  1203,    -1,    -1,
    1206,   118,    -1,    -1,   264,    -1,    -1,    -1,  3789,    -1,
      -1,    -1,  1218,  4473,    -1,   403,    -1,    -1,  3799,    -1,
      -1,    -1,  4482,   283,    -1,    -1,    -1,    -1,  1234,  1235,
      -1,    -1,    -1,    -1,    -1,  3959,    -1,    -1,    -1,    -1,
      -1,  4208,  1248,  1249,  1250,  1251,    -1,  1253,    -1,    -1,
      -1,  1257,    -1,    -1,    -1,   403,    -1,    -1,    -1,    -1,
      -1,  3985,    -1,  4230,    85,  4232,   326,    88,    -1,    -1,
      -1,    -1,    -1,    -1,   334,    -1,    -1,    -1,    -1,  1285,
    1286,    -1,    -1,    -1,   105,    -1,    -1,    -1,    -1,    -1,
     243,    -1,   113,    -1,   247,    -1,    -1,   118,  1304,    -1,
      -1,    -1,    -1,    -1,    -1,   493,   494,   495,   496,   497,
     498,    -1,    -1,  1319,    -1,   268,   269,   377,    -1,    -1,
      -1,    -1,    -1,  1329,    -1,    -1,   243,    -1,    -1,   282,
     247,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   489,   490,   491,    -1,   493,   494,   495,   496,   497,
     498,   268,   269,  1359,  1360,   503,    -1,    -1,  1364,    -1,
    1366,   314,   422,    -1,   317,   282,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   330,  3959,  4346,
     333,    -1,    -1,  1389,    -1,   445,  1392,    -1,    -1,  1395,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   314,    -1,  1405,
     317,    -1,    -1,    -1,  3985,    -1,   466,    -1,   468,   469,
      -1,    -1,    -1,   330,    -1,    -1,   333,    -1,    -1,  4386,
      -1,    -1,   243,    -1,    -1,    -1,   247,  1433,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     500,    -1,    -1,   503,   504,    -1,   506,   268,   269,    -1,
     403,    -1,    -1,  4177,  1460,  1461,    -1,  1463,    -1,    -1,
      -1,   282,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1480,    -1,    -1,    -1,    -1,  4060,
      -1,    -1,    -1,    -1,    -1,    -1,   403,    -1,    -1,    -1,
      -1,    -1,    -1,   314,  1500,  1501,   317,    -1,  4222,    -1,
      -1,    -1,  4226,  4227,    -1,    -1,    -1,    -1,  1514,   330,
      -1,    -1,   333,    -1,    -1,  1521,  1522,    -1,    -1,    -1,
      -1,    -1,  1528,    -1,    -1,  1531,    -1,    85,    -1,    -1,
      88,  1537,    -1,  1539,    -1,    -1,   489,   490,   491,    -1,
     493,   494,   495,   496,   497,   498,    -1,   105,    -1,    -1,
     503,    -1,    -1,    -1,    -1,   113,    -1,  1563,    -1,    -1,
     118,  1567,  1568,    -1,    -1,    -1,    -1,    -1,  4149,    -1,
      -1,    -1,   489,   490,   491,    -1,   493,   494,   495,   496,
     497,   498,   403,    -1,    -1,    -1,   503,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1601,  4177,  1603,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4222,    -1,    -1,    -1,  4226,  4227,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,
     491,    -1,   493,   494,   495,   496,   497,   498,  1684,    -1,
      -1,    -1,   503,    -1,  1690,   243,    -1,    -1,    -1,   247,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1703,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     268,   269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   282,    -1,    -1,    -1,    -1,    -1,
    1736,  1737,  1738,  1739,  1740,    -1,    -1,    -1,  1744,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     5,    -1,    -1,    -1,
      -1,    -1,    -1,  1759,    -1,  1761,   314,    -1,    -1,   317,
      -1,  1767,  1768,    -1,    -1,    -1,    25,  1773,    -1,    -1,
      -1,    -1,   330,    -1,    -1,   333,    35,    36,    -1,    -1,
      -1,    -1,    41,    -1,    43,    44,    -1,    -1,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    -1,    73,    -1,    75,    76,    77,    78,
      79,    80,    81,    82,    -1,    -1,  1832,    86,    -1,    -1,
      -1,    -1,  1838,  1839,  1840,  1841,    -1,    -1,    -1,    -1,
      -1,  1847,    -1,    -1,    -1,   403,    -1,    -1,    -1,  1855,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1870,    -1,  1872,    -1,    -1,    -1,
      -1,    -1,    -1,  1879,   133,  1881,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1889,    -1,    -1,    -1,    -1,  1894,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1903,    -1,  1905,
      -1,    -1,    -1,  1909,  1910,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1923,    -1,    -1,
    1926,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   489,   490,   491,    -1,   493,   494,   495,   496,   497,
     498,    -1,    -1,    -1,    -1,   503,   205,    -1,    -1,    -1,
      -1,  1957,    85,    -1,    -1,    88,    -1,    -1,    -1,  1965,
      -1,   220,    -1,  1969,  1970,    -1,    -1,    -1,    -1,    -1,
      -1,  1977,   105,    -1,    -1,  1981,    -1,    -1,    -1,    -1,
     113,   240,    -1,    -1,    -1,   118,    -1,    -1,    -1,    -1,
      -1,  1997,  1998,    -1,    -1,  2001,    -1,  2003,  2004,    -1,
      -1,    -1,    -1,   262,    -1,  2011,    -1,    -1,  2014,    -1,
      -1,  2017,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2025,
    2026,    -1,    -1,    -1,    -1,    -1,    -1,  2033,    -1,  2035,
    2036,  2037,  2038,  2039,    -1,    -1,   295,    -1,    -1,   298,
    2046,  2047,    -1,  2049,    -1,  2051,    -1,    -1,  2054,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     319,    -1,    -1,  2069,    -1,    -1,    -1,  2073,    -1,    -1,
      -1,  2077,    -1,    -1,    -1,  2081,    -1,  2083,  2084,  2085,
    2086,  2087,  2088,  2089,  2090,  2091,    -1,  2093,    -1,    -1,
      -1,    -1,  2098,  2099,    -1,    -1,  2102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    85,    -1,    -1,    88,    -1,
     243,    -1,    -1,    -1,   247,    -1,    -1,  2123,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,
      -1,   390,    -1,   113,    -1,   268,   269,    -1,   118,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   282,
      -1,    -1,    -1,    -1,  2160,    -1,    -1,    -1,    -1,    -1,
      -1,  2167,    -1,  2169,    -1,  2171,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   432,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   314,    -1,    -1,   317,    -1,   445,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   330,    -1,   458,
     333,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   189,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   483,  2231,    -1,    -1,    -1,    -1,
     489,    -1,    -1,    -1,   493,   494,   495,   496,   497,    -1,
      -1,   500,   501,   502,   503,    -1,   505,   506,   507,   508,
     509,    -1,  2258,    -1,    -1,    -1,  2262,  2263,    -1,    -1,
      -1,    -1,  2268,   243,  2270,    -1,    -1,   247,    -1,    -1,
     403,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2284,  2285,
      -1,    -1,    -1,    -1,    -1,    -1,  2292,    -1,   268,   269,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   282,    -1,    -1,    -1,    -1,    -1,    -1,  2315,
      -1,  2317,    -1,    -1,    -1,    -1,    -1,  2323,    -1,    -1,
      -1,    -1,  2328,    -1,    -1,    -1,    -1,    -1,  2334,  2335,
      -1,    -1,    -1,    -1,   314,    -1,    -1,   317,    -1,  2345,
    2346,    -1,    -1,    -1,    -1,  2351,  2352,    -1,    -1,  2355,
     330,    -1,    -1,   333,    -1,    -1,   489,   490,   491,  2365,
     493,   494,   495,   496,   497,   498,    -1,  2373,    -1,    -1,
     503,    -1,    -1,    -1,  2380,    85,    -1,    -1,    88,    -1,
      -1,    -1,    -1,  2389,    -1,    -1,    -1,    -1,    -1,    -1,
    2396,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   113,    85,    -1,  2412,    88,   118,    -1,
      -1,    -1,    -1,  2419,  2420,  2421,  2422,  2423,  2424,    -1,
      -1,    -1,    -1,   403,   105,    -1,    -1,    -1,  2434,    -1,
      -1,    -1,   113,    -1,    -1,    -1,    -1,   118,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2452,    -1,    -1,    -1,
    2456,    -1,    -1,    -1,  2460,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   452,    -1,    -1,    -1,    -1,    -1,  2484,    -1,
      -1,    -1,    -1,    -1,  2490,  2491,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2500,  2501,   206,    -1,    -1,    -1,
      -1,    -1,  2508,  2509,    -1,    -1,    -1,  2513,  2514,   489,
     490,   491,  2518,   493,   494,   495,   496,   497,   498,    -1,
      -1,    -1,    -1,    -1,  2530,  2531,  2532,  2533,    85,    -1,
      -1,    88,    -1,   243,    -1,    -1,    -1,   247,    -1,    -1,
     221,  2547,    -1,    -1,    -1,    -1,    -1,    -1,   105,  2555,
      -1,   108,    -1,    -1,    -1,    -1,   113,    -1,   268,   269,
      -1,   118,   243,    -1,    -1,    -1,   247,    -1,    -1,    -1,
    2576,    -1,   282,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2592,   268,   269,    -1,
      -1,    -1,    -1,  2599,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   282,    -1,    -1,    -1,    -1,    -1,   317,    -1,    -1,
      -1,    -1,    -1,    -1,  2620,    -1,    -1,    -1,    -1,    -1,
     330,    -1,    -1,  2629,  2630,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   314,    -1,    -1,   317,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   330,
      -1,    -1,   333,  2659,  2660,    -1,    -1,    -1,  2664,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   349,    -1,
    2676,  2677,  2678,  2679,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2688,    -1,    -1,  2691,   243,  2693,  2694,    -1,
     247,    -1,    -1,   403,    -1,    -1,    -1,  2703,  2704,    -1,
    2706,    -1,    -1,    -1,    -1,   117,    -1,    -1,    -1,    -1,
      -1,   268,   269,  2719,    -1,  2721,    -1,  2723,    -1,  2725,
      -1,    -1,   403,    -1,    -1,   282,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2741,    -1,    -1,    -1,  2745,
      -1,    -1,    -1,    -1,    -1,  2751,    -1,  2753,  2754,  2755,
     162,    -1,    -1,    -1,    -1,    -1,    -1,   314,    -1,    -1,
     317,    -1,    -1,    -1,    -1,    -1,    -1,  2773,    -1,    -1,
      -1,  2777,    -1,   330,    -1,    -1,   333,    -1,  2784,    -1,
    2786,    -1,    -1,   493,   494,   495,   496,   497,   498,  2795,
      -1,    -1,    85,    -1,  2800,    88,    -1,   209,  2804,    -1,
      -1,  2807,    -1,    -1,   216,    -1,   218,    -1,   489,   490,
     491,    -1,   493,   494,   495,   496,   497,   498,   230,    -1,
     113,    -1,    -1,     5,    -1,   118,    -1,    -1,    -1,    -1,
      -1,    -1,  2838,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    25,    -1,    -1,   403,    -1,    -1,  2855,
      -1,  2857,    -1,    35,    36,  2861,    -1,    -1,    -1,    -1,
      -1,    43,    44,    -1,    -1,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    -1,    -1,    75,    76,    77,    78,    79,    80,    81,
      82,    -1,    -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   206,    -1,    -1,    -1,  2923,    -1,    -1,
      85,    -1,    -1,    88,  2930,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   489,   490,   491,    -1,   493,   494,   495,   496,
     497,   498,    -1,    -1,    -1,    -1,    -1,    -1,   113,    -1,
     243,   133,    -1,   118,   247,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   268,   269,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2992,    -1,    -1,   282,
      -1,    -1,    -1,    -1,    -1,    -1,  3002,  3003,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   205,   317,  3031,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   330,   220,    -1,
      -1,   206,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   240,    -1,
      -1,    -1,    -1,    -1,  3070,  3071,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3081,    -1,    -1,   243,    -1,
     262,    -1,   247,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3096,    -1,    -1,    -1,    -1,    -1,  3102,    -1,    -1,    -1,
      -1,    -1,    -1,   268,   269,  3111,    -1,    -1,    -1,  3115,
     403,    -1,  3118,   295,    -1,  3121,   298,   282,    -1,  3125,
      -1,    -1,    -1,    -1,    -1,  3131,    -1,    -1,  3134,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   319,    -1,    -1,
      -1,    -1,    -1,  3149,    -1,    -1,  3152,    -1,    -1,  3155,
      -1,    -1,   317,  3159,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3170,   330,    -1,  3173,    -1,    -1,
      -1,    -1,    -1,    -1,  3180,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3193,    -1,  3195,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3203,    -1,    -1,
     493,   494,   495,   496,   497,   498,  3212,    -1,   390,    -1,
      -1,    -1,  3218,    -1,  3220,    -1,    -1,    -1,    -1,    -1,
    3226,    -1,    -1,  3229,  3230,  3231,  3232,  3233,  3234,  3235,
    3236,  3237,  3238,    -1,    -1,    -1,  3242,  3243,   403,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3255,
     432,    -1,    -1,    -1,    -1,  3261,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   445,    -1,  3271,    85,    -1,  3274,    88,
    3276,    -1,    -1,    -1,    -1,    -1,   458,    -1,    -1,  3285,
    3286,  3287,    -1,    -1,    -1,  3291,   105,    -1,  3294,    -1,
      -1,    -1,    -1,    -1,   113,  3301,  3302,    -1,  3304,   118,
      -1,   483,    -1,    -1,  3310,    -1,  3312,   489,  3314,    -1,
      -1,   493,   494,   495,   496,   497,    -1,    -1,   500,   501,
     502,    -1,    -1,    -1,    -1,   507,   508,    -1,   493,   494,
     495,   496,   497,   498,    -1,    -1,    -1,  3343,    -1,    -1,
      -1,    -1,    -1,    85,    -1,    -1,    88,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      98,    -1,    -1,   105,    -1,    -1,    -1,    85,    -1,    -1,
      88,   113,    -1,    -1,    -1,    -1,   118,    -1,  3384,  3385,
    3386,    -1,    -1,    -1,  3390,    -1,    -1,   105,    -1,    -1,
      -1,    -1,   130,    -1,    -1,   113,   808,    -1,    -1,    -1,
     118,    -1,    -1,  3409,   816,   143,    -1,    -1,    -1,    -1,
     822,    -1,    -1,   151,    -1,    -1,    -1,   155,    -1,    -1,
      -1,    -1,    -1,    -1,   243,    -1,    -1,    -1,   247,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,    -1,    -1,
      -1,   853,  3448,    -1,  3450,    -1,    -1,    -1,    -1,   268,
     269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   196,    -1,
      -1,    -1,    -1,   282,    -1,    -1,    -1,    -1,    -1,    -1,
    3476,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     222,    -1,    -1,    -1,    -1,   227,    -1,    -1,    -1,    -1,
      -1,   229,    -1,   905,    -1,   314,    -1,  3503,   317,    -1,
     912,   243,    -1,  3509,    -1,   247,    -1,    -1,    -1,    -1,
      -1,   330,   250,    -1,   333,  3521,    -1,    -1,    -1,    -1,
      -1,  3527,    -1,    -1,    -1,   243,   268,   269,    -1,   247,
      -1,    -1,   351,    -1,    -1,    -1,   274,    -1,  3544,    -1,
     282,    -1,    -1,    -1,    -1,    -1,    -1,  3553,    -1,    -1,
     268,   269,  3558,    -1,    -1,    -1,  3562,    -1,  3564,    -1,
      -1,    -1,    -1,    -1,   282,    -1,    -1,    -1,    -1,  3575,
    3576,    -1,   314,    -1,    -1,   317,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   403,    -1,    -1,    -1,   330,  3595,
      -1,   333,   330,  3599,    -1,    -1,   314,   416,  3604,   317,
      -1,  3607,  3608,    -1,  3610,    -1,    -1,    -1,    -1,    -1,
    1022,  3617,   330,  3619,    -1,   333,  1028,    -1,    -1,   357,
    1032,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   346,    -1,
      -1,  3637,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   381,    -1,  3651,  1058,   385,    -1,   387,
      -1,    -1,    -1,    -1,    -1,   393,    -1,    -1,    -1,    -1,
      -1,   403,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     489,   490,   491,    -1,   493,   494,   495,   496,   497,   498,
      -1,  3687,    -1,    -1,   422,   403,   424,    -1,  3694,  3695,
     428,    -1,    -1,    -1,    -1,    -1,  3702,  3703,   436,    -1,
      -1,  3707,    -1,   441,    -1,    -1,    -1,  3713,  3714,    -1,
      -1,  3717,    -1,  3719,  3720,  3721,  3722,    -1,    -1,    -1,
      -1,    -1,  3728,    -1,    -1,   463,    -1,    -1,  3734,    -1,
      -1,    -1,    -1,    -1,  3740,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3751,    -1,   489,   490,   491,
      -1,   493,   494,   495,   496,   497,   498,    -1,    -1,  3765,
      -1,    -1,  3768,    -1,    -1,    -1,  3772,  3773,    -1,    -1,
      -1,   489,   490,   491,    -1,   493,   494,   495,   496,   497,
     498,  3787,    -1,    -1,  1196,    -1,    -1,    -1,    -1,  3795,
      -1,  1203,    -1,    -1,    -1,    85,    -1,    -1,    88,    -1,
    3806,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1224,  3819,    -1,   105,    -1,    -1,   108,    -1,
      -1,    -1,    -1,   113,    -1,    -1,    -1,    -1,   118,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3846,  1253,    -1,    -1,    -1,    -1,    -1,  3853,    -1,    -1,
    1224,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3867,  3868,  3869,  3870,  3871,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3891,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1319,    -1,    -1,
      -1,    -1,    -1,    85,    -1,    -1,    88,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   105,    -1,    -1,  3942,    -1,  3944,    -1,
      -1,   113,    -1,    -1,  3950,    -1,   118,    -1,  3954,    -1,
      -1,  3957,    -1,   243,    -1,    -1,    -1,   247,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1379,    -1,    -1,
    3976,    -1,    -1,    -1,    -1,  3981,    -1,    -1,   268,   269,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   282,  1405,    -1,    -1,    -1,    -1,    -1,  4005,
    4006,    -1,    -1,  4009,    -1,  1379,    -1,    -1,    -1,    -1,
    4016,  4017,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1433,    -1,    -1,   314,    -1,    -1,   317,    -1,    -1,
      -1,  4037,    -1,  4039,    -1,    -1,    -1,  4043,  4044,  4045,
     330,    -1,    -1,   333,    -1,    -1,    -1,    -1,  1460,  1461,
      -1,  1463,    -1,    -1,    -1,   227,    -1,  4063,  4064,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1480,    -1,
      -1,   243,    -1,    -1,    -1,   247,    -1,    -1,    -1,    -1,
      -1,    -1,  4088,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4099,    -1,    -1,   268,   269,    -1,    -1,
      -1,    -1,  4108,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     282,    -1,    -1,   403,  4120,    -1,  4122,    -1,    -1,  1531,
    1532,    -1,    -1,    -1,    -1,    -1,  4132,    -1,    -1,    -1,
      -1,  4137,    85,    -1,    -1,    88,    -1,    -1,    -1,    -1,
    4146,  4147,   314,    -1,    -1,   317,    -1,    -1,    -1,    -1,
      -1,  1563,   105,    -1,    -1,  1567,  1568,    -1,   330,    -1,
     113,   333,    -1,    -1,    -1,   118,    -1,    -1,    -1,    -1,
    4176,    -1,    -1,  4179,    -1,  4181,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4194,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,
     490,   491,  4208,   493,   494,   495,   496,   497,   498,    -1,
    4216,    -1,    -1,  4219,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4229,  4230,  4231,  4232,    -1,    -1,  1641,
      -1,   403,  4238,    -1,  1646,    -1,    -1,    -1,  1650,    -1,
      -1,    -1,    85,    -1,    -1,    88,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4259,    -1,    -1,    -1,    -1,    -1,  1671,
      -1,    -1,   105,    -1,    -1,   108,  1678,  1641,    -1,    -1,
     113,    -1,    -1,    -1,    -1,   118,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1701,
     243,    -1,    -1,    -1,   247,    -1,    -1,    -1,    -1,  4305,
      -1,    -1,    -1,    -1,  1678,    -1,    -1,  4313,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   268,   269,   489,   490,   491,
      -1,   493,   494,   495,   496,   497,   498,  1701,    -1,   282,
      -1,    -1,    -1,    -1,  1746,    -1,    -1,    -1,    -1,    -1,
    4346,    -1,    -1,  4349,    96,    -1,    -1,    -1,    -1,    -1,
    4356,  1763,    -1,    -1,    -1,    -1,    -1,  4363,    -1,    -1,
      -1,   314,    -1,  4369,   317,    -1,  4372,  4373,  1780,  4375,
      -1,    -1,    -1,    -1,    -1,    -1,  4382,   330,    -1,    -1,
    4386,    -1,    -1,    -1,    -1,    -1,  1798,    -1,    -1,  1763,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   150,    -1,
     243,    -1,    -1,  4409,   247,    -1,  1780,   159,   160,   161,
      -1,  1823,    -1,  4419,    -1,    -1,  1828,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1798,   268,   269,  4433,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   282,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1823,
     403,   203,    -1,    -1,    -1,    -1,    -1,    -1,  1870,    -1,
    1872,    -1,    -1,    -1,    -1,    -1,  1878,  4473,    -1,  1881,
      -1,   314,  4478,    -1,   317,    -1,  4482,    -1,    -1,    -1,
    4486,    -1,    -1,    -1,    -1,    -1,    -1,   330,    -1,    -1,
     333,    -1,    -1,    -1,    -1,   247,    -1,    -1,    -1,    -1,
     252,    -1,    -1,    -1,  1878,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   489,   490,   491,   291,
     493,   494,   495,   496,   497,   498,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1965,    -1,   307,   308,   309,   310,   311,
     403,   313,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1224,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2003,  2004,   345,    -1,    -1,    -1,    -1,    -1,  2011,
      -1,    -1,  2014,    -1,    -1,  2017,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2025,  2026,    -1,    -1,    -1,    -1,    -1,
      -1,  2033,    -1,    -1,  2036,  2037,  2038,  2039,    -1,   381,
      -1,    -1,    -1,    -1,  2046,  2047,    -1,  2049,    -1,  2051,
      -1,    -1,  2054,    -1,    -1,    -1,   489,   490,   491,    -1,
     493,   494,   495,   496,   497,   498,  2068,  2069,  2070,    -1,
      85,  2073,    -1,    88,    -1,  2077,   418,    -1,   420,  2081,
      -1,  2083,  2084,  2085,  2086,  2087,  2088,  2089,  2090,  2091,
     105,  2093,    -1,    -1,    -1,    -1,    -1,  2099,   113,    -1,
    2102,    -1,   444,   118,  2068,    -1,    -1,    -1,    -1,   451,
      -1,    -1,   454,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     5,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2102,    -1,
    1379,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,    36,
      -1,    -1,    -1,    -1,    -1,    -1,    43,    44,    -1,  2171,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    -1,    -1,    -1,    75,    76,
      77,    78,    79,    80,    81,    82,    -1,    -1,    -1,    86,
      -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,    -1,   243,    -1,
      -1,    -1,   247,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,
      -1,    -1,    -1,   268,   269,    -1,   133,    -1,    -1,  2261,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   282,    -1,    -1,
      -1,   155,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2285,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   175,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   314,
      -1,    -1,   317,  2305,    -1,    -1,    -1,    -1,  2310,  2311,
      -1,    -1,   196,    -1,    -1,   330,    -1,    -1,   333,  2321,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   205,    -1,
      -1,    -1,    -1,    -1,    -1,  2337,    -1,    -1,    -1,    -1,
     224,  2305,    -1,   220,    -1,   229,  2310,  2311,    -1,    -1,
      -1,   235,    -1,    85,    -1,    -1,    88,  2321,    -1,    -1,
      -1,    -1,    -1,   240,    -1,    -1,   250,    -1,    -1,    -1,
    2372,    -1,    -1,   105,    -1,    -1,   108,    -1,    -1,    -1,
      -1,   113,    -1,    -1,    -1,   262,   118,    -1,   403,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1641,    85,    -1,    -1,    88,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   429,    -1,    -1,    -1,   295,    -1,
      -1,   298,    -1,   105,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   113,  2434,    -1,  2436,    -1,   118,    -1,    -1,  1678,
      -1,    -1,   319,    -1,    -1,    -1,   330,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   340,    -1,    -1,    -1,
      -1,    -1,  1701,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2436,   357,   489,   490,   491,    -1,   493,   494,
     495,   496,   497,   498,    -1,   209,    -1,    -1,    -1,    -1,
      -1,    -1,   216,    -1,   218,  2497,    -1,   381,    -1,    -1,
      -1,   385,    -1,   387,    -1,    -1,  2508,    -1,    -1,   393,
      -1,   243,   396,   390,    -1,   247,  2518,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1763,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2497,    -1,    -1,   268,   269,   422,    -1,
     424,  1780,    -1,    -1,   428,    -1,    -1,    -1,    -1,    -1,
     282,    -1,   436,  2555,    -1,   432,    -1,   441,    -1,  1798,
      -1,   243,    -1,    -1,    -1,   247,    -1,   451,   445,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   463,
      -1,   458,   314,    -1,  1823,   317,   268,   269,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2599,   330,    -1,
     282,   333,    -1,    -1,    -1,    -1,   483,    -1,  2610,    -1,
      -1,    -1,   489,    -1,    -1,    -1,   493,   494,   495,   496,
     497,    -1,    -1,   500,   501,   502,   503,  2629,  2630,    -1,
     507,    -1,   314,    -1,    -1,   317,    -1,    -1,    -1,  1878,
      -1,    -1,    -1,    -1,    -1,    -1,  2610,    -1,   330,    -1,
      -1,   333,    -1,    -1,    -1,    -1,    -1,  2659,  2660,    -1,
      -1,    -1,  2664,    -1,    -1,    -1,    -1,   158,    -1,    -1,
      -1,   403,    -1,    98,  2676,  2677,  2678,  2679,    -1,    -1,
      -1,    -1,  2684,    -1,    -1,   110,  2688,  2689,    -1,  2691,
      -1,  2693,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2703,  2704,    -1,  2706,   130,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   207,  2719,    -1,  2721,
      -1,   403,    -1,  2725,    -1,    -1,   151,   218,    -1,    -1,
     155,   222,    -1,    -1,    -1,    -1,   227,    -1,    -1,  2741,
      -1,   232,    -1,    -1,   235,    -1,   237,    -1,    -1,  2751,
     175,  2753,  2754,  2755,    -1,    -1,   181,   489,   490,   491,
      -1,   493,   494,   495,   496,   497,   498,    -1,    -1,    -1,
      -1,   196,    -1,   264,    -1,  2777,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2786,    -1,    -1,    -1,    -1,  2753,
    2754,  2755,   283,  2795,    -1,    -1,    -1,    -1,  2800,   224,
      -1,    -1,    -1,    -1,    -1,  2807,   231,   489,   490,   491,
     235,   493,   494,   495,   496,   497,   498,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   250,    -1,    -1,    -1,  2068,
      -1,    -1,    -1,    -1,    -1,   326,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   334,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2855,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   286,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2883,  2884,    -1,  2886,    -1,   377,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   330,    -1,    -1,   333,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2883,
    2884,    -1,  2886,    -1,    -1,  2927,    -1,  2929,    -1,    -1,
      -1,   422,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   445,    -1,   381,    -1,  2960,  2961,
    2962,    -1,   387,  2927,    -1,  2929,    -1,    -1,   393,    -1,
      -1,   396,    -1,    -1,    -1,   466,    -1,   468,   469,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2998,   422,    -1,   424,
     425,    -1,   427,   428,    -1,    -1,    -1,    -1,    -1,   500,
      -1,   436,   503,   504,    -1,   506,   441,    -1,  3020,    -1,
      -1,   446,    -1,  3025,    -1,    -1,   451,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2998,    -1,    -1,    -1,   463,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3058,  3059,    -1,    -1,
      -1,  3025,    -1,    -1,    -1,    -1,  2305,    -1,    -1,    -1,
      -1,  2310,  2311,    -1,  3076,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2321,    -1,    -1,    -1,    -1,    -1,  3090,    -1,
      -1,    -1,   816,    -1,    -1,  3059,    -1,    -1,   822,    -1,
      -1,  3103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3076,    -1,    -1,    -1,    -1,    -1,    -1,  3121,
      -1,    -1,    -1,  3125,    -1,    -1,  3090,    -1,    -1,   853,
      -1,    -1,  3134,    -1,    -1,    -1,    -1,    -1,  3140,  3103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3170,    -1,
    3134,    -1,    -1,    -1,    -1,    -1,  3140,    -1,    -1,    -1,
      -1,   905,    -1,    -1,    -1,    -1,    -1,    -1,   912,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2436,    -1,    -1,
      -1,  3203,    -1,    -1,  3206,    -1,    -1,    -1,    -1,    -1,
    3212,    -1,    -1,    -1,    -1,    -1,  3218,    -1,  3220,    -1,
      -1,    -1,    -1,  3225,  3226,    -1,    -1,  3229,  3230,  3231,
    3232,  3233,  3234,  3235,  3236,  3237,  3238,    -1,    -1,    -1,
    3242,  3243,  3206,    -1,    -1,    -1,    -1,    -1,  3250,    -1,
      -1,    -1,    -1,  3255,    -1,    -1,    -1,  3259,  2497,  3261,
      -1,  3225,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3271,
      -1,    -1,  3274,    -1,  3276,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3284,  3285,  3286,  3287,  3250,    -1,    -1,  3291,
      -1,    -1,  3294,    -1,    -1,    -1,    -1,    -1,  1022,    -1,
      -1,    -1,  3304,    -1,  1028,    -1,    -1,    -1,  1032,    -1,
    3312,    -1,  3314,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3284,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1058,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3314,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2610,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3384,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3416,  3417,  3418,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3441,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3417,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1196,    -1,    -1,    -1,    -1,    -1,    -1,  1203,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1224,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3521,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1253,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3539,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3574,  3575,  3576,  3539,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1319,    -1,  3599,    -1,    -1,
      -1,    -1,  3604,    -1,    -1,  3607,    -1,    -1,    -1,    -1,
    3574,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2883,  2884,    -1,  2886,    -1,  3651,
      -1,    -1,    -1,    -1,    -1,  1379,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1405,    -1,    -1,    -1,  3687,    -1,    -1,  2927,    -1,
    2929,    -1,  3694,  3695,    -1,  3697,    -1,    -1,    -1,    -1,
    3702,  3703,    -1,    -1,    -1,  3707,  3708,    -1,    -1,  1433,
      -1,  3713,  3714,    -1,    -1,  3717,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3728,    -1,    -1,    -1,
      -1,    -1,    -1,  3697,    -1,    -1,  1460,  1461,  3740,  1463,
      -1,    -1,    -1,    -1,  3708,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1480,    -1,    -1,  2998,
      -1,    -1,    -1,    -1,  3728,    -1,  3768,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3740,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3025,  3789,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3799,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1531,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3059,    -1,    -1,    -1,    -1,  3789,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3799,    -1,  3076,    -1,  1563,
      -1,    -1,  3844,  1567,  1568,    -1,    -1,    -1,    -1,    -1,
      -1,  3090,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3891,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3901,
      -1,  3140,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1641,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1650,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3939,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1671,  3950,    -1,
      -1,    -1,  3954,    -1,  1678,    -1,    -1,  3959,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3206,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3939,    -1,  1701,    -1,  3981,
      -1,    -1,    -1,  3985,    -1,    -1,  3225,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3959,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4005,  4006,    -1,    -1,  4009,    -1,    -1,
      -1,  3250,    -1,    -1,  4016,  4017,    -1,    -1,    -1,    -1,
      -1,  3985,  1746,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1763,
      -1,  4043,    -1,    -1,    -1,  3284,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1780,    -1,  4060,    -1,
      -1,  4063,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1798,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4060,  4099,    -1,  1823,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4147,  1870,  4149,  1872,    -1,
      -1,    -1,    -1,    -1,  1878,    -1,    -1,  1881,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4176,  4177,    -1,  4179,  3417,  4181,
      -1,    -1,    -1,    -1,    -1,  4149,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4177,    -1,    -1,    -1,  4219,    -1,    -1,
    4222,    -1,    -1,    -1,  4226,  4227,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1965,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4252,    -1,    -1,    -1,    -1,    -1,    -1,  4259,  4222,    -1,
      -1,    -1,  4226,  4227,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2003,
    2004,    -1,    -1,  4285,    -1,    -1,    -1,  2011,    -1,    -1,
    2014,    -1,    -1,  2017,    -1,    -1,    -1,    -1,    -1,    -1,
    3539,  2025,  2026,  4305,    -1,    -1,    -1,    -1,    -1,  2033,
      -1,    -1,  2036,  2037,  2038,  2039,    -1,    -1,    -1,    -1,
      -1,  4285,  2046,  2047,    -1,  2049,    -1,  2051,    -1,    -1,
    2054,    -1,    -1,    -1,    -1,  3574,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2068,  2069,    -1,  4349,    -1,  2073,
      -1,    -1,    -1,  2077,  4356,    -1,    -1,  2081,    -1,  2083,
    2084,  2085,  2086,  2087,  2088,  2089,  2090,  2091,    -1,  2093,
    4372,  4373,    -1,    -1,    -1,  2099,    -1,    -1,  2102,    -1,
    4382,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1224,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4409,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4419,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2171,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3697,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3708,
      -1,  4473,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4482,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1379,
    3789,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3799,  2285,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2305,    -1,    -1,    -1,    -1,  2310,  2311,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2321,    -1,    -1,
      -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    35,    36,    -1,    -1,    -1,    -1,    -1,    -1,    43,
      44,    -1,    -1,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    -1,
      -1,    75,    76,    77,    78,    79,    80,    81,    82,    -1,
      -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2434,    -1,  2436,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3959,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   133,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3985,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2497,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2508,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2518,    -1,    -1,    -1,    -1,    -1,
      -1,   205,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1641,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,
      -1,  4060,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2555,    -1,    -1,    -1,    -1,   240,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1678,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   262,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1701,    -1,    -1,    -1,  2599,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2610,    -1,    -1,    -1,
      -1,   295,    -1,    -1,   298,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2629,  2630,    -1,    -1,    -1,
    4149,    -1,    -1,    -1,    -1,   319,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1763,    -1,  2659,  2660,    -1,  4177,    -1,
    2664,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1780,    -1,  2676,  2677,  2678,  2679,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2688,    -1,    -1,  2691,  1798,  2693,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2703,
    2704,    -1,  2706,  4222,    -1,    -1,   390,  4226,  4227,    -1,
      -1,    -1,    -1,  1823,    -1,  2719,    -1,  2721,    -1,    -1,
      -1,  2725,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2741,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2751,   432,  2753,
    2754,  2755,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   445,    -1,    -1,    -1,    -1,    -1,    -1,  1878,    -1,
      -1,    -1,    -1,  2777,   458,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2786,    96,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2795,    -1,   106,    -1,    -1,  2800,    -1,    -1,   483,
      -1,    -1,    -1,  2807,    -1,   489,    -1,    -1,    -1,   493,
     494,   495,   496,   497,    -1,    -1,   500,   501,   502,   503,
      -1,    -1,    -1,   507,    -1,    -1,    -1,    -1,    -1,   142,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     153,    -1,    -1,   156,    -1,    -1,    -1,    -1,    -1,    -1,
     163,  2855,    -1,    -1,   167,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   188,    -1,    -1,    -1,  2883,
    2884,    -1,  2886,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   204,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2927,   237,  2929,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2068,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2998,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3025,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3059,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3076,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3090,    -1,    -1,   402,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3121,    -1,    -1,
      -1,  3125,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3134,    -1,    -1,    -1,    -1,    -1,  3140,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3170,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2305,    -1,    -1,    -1,  3203,
    2310,  2311,  3206,    -1,    -1,    -1,    -1,    -1,  3212,    -1,
      -1,  2321,    -1,    -1,  3218,    -1,  3220,    -1,    -1,    -1,
      -1,  3225,  3226,    -1,    -1,  3229,  3230,  3231,  3232,  3233,
    3234,  3235,  3236,  3237,  3238,    -1,    -1,    -1,  3242,  3243,
      -1,    -1,    -1,    -1,    -1,    -1,  3250,    -1,    -1,    -1,
      -1,  3255,    -1,    -1,    -1,    -1,    -1,  3261,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3271,    -1,    -1,
    3274,    -1,  3276,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3284,  3285,  3286,  3287,    -1,    -1,    -1,  3291,    -1,    -1,
    3294,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3304,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3312,    -1,
    3314,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2436,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   686,   687,    -1,    -1,    -1,    -1,    -1,
    3384,    -1,    -1,    -1,    -1,    -1,    -1,  2497,    -1,    -1,
     703,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3417,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   816,    -1,    -1,    -1,    -1,    -1,   822,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     853,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2610,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   829,  3521,   831,    -1,
     833,    -1,   835,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3539,    -1,    -1,    -1,    -1,
      -1,   854,   905,    -1,    -1,    -1,    -1,    -1,    -1,   912,
      -1,    -1,    -1,    -1,    -1,   868,   869,    -1,    -1,    -1,
     873,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3574,  3575,  3576,    -1,    -1,   888,    -1,   890,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   906,    -1,  3599,    -1,    -1,    -1,    -1,
    3604,    -1,    -1,  3607,    -1,   918,    -1,    -1,   921,    -1,
     923,    -1,   925,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   938,   939,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     953,    -1,   955,    -1,    -1,    -1,    -1,  3651,    -1,    -1,
      -1,    -1,   965,    -1,    -1,    -1,    -1,    -1,    -1,  1022,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   985,   986,    -1,    -1,    -1,    -1,    -1,   992,
      -1,   994,    -1,  3687,    -1,    -1,    -1,    -1,    -1,    -1,
    3694,  3695,    -1,  3697,    -1,  1058,    -1,    -1,  3702,  3703,
      -1,    -1,    -1,  3707,  3708,    -1,    -1,    -1,    -1,  3713,
    3714,  1024,    -1,  3717,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3728,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3740,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1060,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3768,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2883,  2884,    -1,  2886,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3789,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3799,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1127,    -1,  1129,  2927,    -1,  2929,
    1133,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1196,    -1,    -1,    -1,    -1,    -1,    -1,
    1203,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1224,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1186,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1199,  3891,  2998,    -1,
    1253,    -1,    -1,    -1,    -1,  1208,    -1,    -1,    -1,    -1,
      -1,  1214,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1224,
      -1,    -1,  1225,    -1,    -1,  3025,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3939,    -1,    -1,    -1,    -1,
      -1,  1254,    -1,    -1,    -1,    -1,  3950,    -1,    -1,  3059,
    3954,    -1,    -1,    -1,    -1,  3959,  1319,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3076,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3981,    -1,    -1,
    3090,  3985,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4005,  4006,    -1,    -1,  4009,    -1,    -1,    -1,    -1,
      -1,    -1,  4016,  4017,    -1,    -1,  1379,    -1,    -1,    -1,
      -1,  1334,    -1,  1336,    -1,    -1,  1339,    -1,  1341,    -1,
    3140,  1344,  1345,  1346,    -1,    -1,    -1,    -1,    -1,  4043,
      -1,    -1,  1405,    -1,  1357,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4060,    -1,  1371,  4063,
    1373,    -1,    -1,    -1,  1379,    -1,    -1,    -1,    -1,    -1,
    1433,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4099,  3206,  1460,  1461,    -1,
    1463,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3225,    -1,  1480,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3250,    -1,    -1,  4147,    -1,  4149,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1531,    -1,
      -1,    -1,  4176,  4177,  3284,  4179,    -1,  4181,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1563,    -1,    -1,    -1,  1567,  1568,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4219,    -1,    -1,  4222,    -1,
      -1,    -1,  4226,  4227,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1553,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4259,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1641,    -1,
      -1,  4285,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1606,    -1,    -1,  1609,    -1,    -1,    -1,
      -1,  4305,    -1,    -1,  1617,    -1,    -1,  3417,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1678,    -1,    -1,    -1,    -1,
      -1,    -1,  1635,    -1,    -1,    -1,  1641,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1701,    -1,
      -1,    -1,    -1,    -1,    -1,  4349,    -1,    -1,  1661,    -1,
      -1,    -1,  4356,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1678,    -1,    -1,    -1,    -1,  4372,  4373,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4382,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1701,  1022,  1224,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1763,    -1,    -1,    -1,    -1,  4409,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4419,    -1,  1780,    -1,    -1,
      -1,    -1,    -1,  1058,    -1,    -1,    -1,    -1,    -1,  3539,
      -1,    -1,    -1,    -1,    -1,  1798,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1763,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1823,    -1,    -1,    -1,  3574,  1780,    -1,    -1,    -1,  4473,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4482,    -1,
      -1,    -1,    -1,  1798,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1870,  1823,  1872,
      -1,  1824,    -1,    -1,    -1,  1878,    -1,    -1,  1881,    -1,
      -1,    -1,    -1,  1836,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1379,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1878,    -1,    -1,    -1,  1880,    -1,    -1,
      -1,  1884,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1893,    -1,  1895,    -1,  1897,    -1,    -1,  3697,    -1,  1902,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3708,    -1,
      -1,    -1,  1965,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1935,    -1,  1937,    -1,    -1,    -1,  1941,    -1,
    1943,    -1,    -1,  1946,    -1,    -1,    -1,  1950,  1951,    -1,
    2003,  2004,    -1,    -1,    -1,    -1,    -1,    -1,  2011,    -1,
      -1,  2014,    -1,    -1,  2017,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2025,  2026,    -1,    -1,    -1,    -1,    -1,    -1,
    2033,    -1,    -1,  2036,  2037,  2038,  2039,    -1,    -1,  3789,
      -1,    -1,    -1,  2046,  2047,    -1,  2049,    -1,  2051,  3799,
      -1,  2054,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2068,  2069,    -1,    -1,    -1,
    2073,    -1,    -1,    -1,  2077,    -1,    -1,    -1,  2081,    -1,
    2083,  2084,  2085,  2086,  2087,  2088,  2089,  2090,  2091,    -1,
    2093,    -1,    -1,    -1,    -1,    -1,  2099,    -1,    -1,  2102,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2068,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1405,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2105,    -1,    -1,    -1,    -1,    -1,  1433,    -1,
      -1,    -1,    -1,    -1,    -1,  1641,    -1,    -1,  2171,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1460,  1461,    -1,  1463,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1678,    -1,    -1,  1480,    -1,    -1,    -1,  3959,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1701,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3985,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1531,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2285,    -1,    -1,    -1,    -1,  1763,  1563,  2242,
      -1,    -1,  1567,  1568,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2305,    -1,  1780,    -1,  2259,  2310,  2311,    -1,
    4060,  2264,    -1,    -1,    -1,    -1,    -1,    -1,  2321,    -1,
      -1,  2274,  1798,    -1,    -1,    -1,    -1,    -1,  2281,    -1,
      -1,    -1,    -1,    -1,  2287,    -1,    -1,    -1,    -1,    -1,
    2293,    -1,    -1,    -1,    -1,  2298,    -1,  1823,    -1,    -1,
    2305,    -1,    -1,    -1,    -1,  2310,  2311,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2321,    -1,    -1,    -1,
      -1,  2324,  2325,  2326,  2327,    -1,    -1,    -1,  2331,  2332,
      -1,    -1,    -1,  2336,    -1,    -1,  2339,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4149,
      -1,    -1,  1878,  2356,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2366,    -1,  2368,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2377,  2378,  2379,  4177,  2381,    -1,
      -1,  2434,    -1,  2436,    -1,    -1,    -1,  2390,  2391,    -1,
      -1,    -1,    -1,    -1,    -1,  2398,  2399,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1224,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4222,    -1,    -1,    -1,  4226,  4227,    -1,    -1,
      -1,  2436,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2497,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2508,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2518,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2497,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2555,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1224,    -1,
      -1,    -1,  2068,    -1,    -1,    -1,  2599,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2610,    -1,    -1,
      -1,    -1,    -1,    -1,  1379,    -1,    -1,    -1,  2571,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2629,  2630,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2610,  2659,  2660,    -1,    -1,
      -1,  2664,    -1,  2616,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2676,  2677,  2678,  2679,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2688,    -1,    -1,  2691,    -1,
    2693,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2703,  2704,    -1,  2706,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2719,    -1,  2721,    -1,
      -1,    -1,  2725,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2011,    -1,  2741,    -1,
      -1,    -1,    -1,  1379,    -1,    -1,    -1,    -1,  2751,    -1,
    2753,  2754,  2755,    -1,    -1,    -1,    -1,    -1,  2033,    -1,
      -1,  2036,    -1,    -1,  2039,    -1,    -1,    -1,    -1,    -1,
      -1,  2046,  2047,    -1,  2777,    -1,  2051,    -1,    -1,  2054,
      -1,    -1,    -1,  2786,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2795,    -1,  2069,    -1,    -1,  2800,  2073,    -1,
      -1,    -1,  2077,    -1,  2807,    -1,  2081,    -1,  2083,  2084,
    2085,  2086,  2087,  2088,  2089,  2090,  2091,    -1,  2093,    -1,
      -1,    -1,    -1,    -1,  2099,    -1,    -1,  2102,    -1,  2305,
      -1,    -1,    -1,    -1,  2310,  2311,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2321,    -1,    -1,    -1,    -1,
      -1,    -1,  2855,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1641,    -1,    -1,    -1,
    2883,  2884,    -1,  2886,    -1,    -1,  2839,  2840,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2171,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1678,    -1,    -1,    -1,  2870,    -1,    -1,
      -1,    -1,    -1,    -1,  2927,    -1,  2929,    -1,  2883,  2884,
      -1,  2886,    -1,    -1,    -1,    -1,  1701,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2904,  2905,  2906,  2907,    -1,    -1,    -1,    -1,    -1,
    2436,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2927,    -1,  2929,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2998,    -1,    -1,  1763,    -1,
      -1,    -1,    -1,    -1,    -1,  1641,    -1,    -1,    -1,    -1,
    2285,    -1,    -1,    -1,    -1,  1780,    -1,    -1,    -1,    -1,
      -1,  2497,  3025,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1798,    -1,  2988,    -1,    -1,    -1,    -1,
    2993,    -1,  1678,  2998,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3059,    -1,  1823,    -1,
      -1,    -1,    -1,    -1,    -1,  1701,    -1,    -1,    -1,    -1,
    3025,    -1,    -1,  3076,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3090,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3103,    -1,    -1,    -1,  3059,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1878,    -1,    -1,    -1,    -1,  3121,    -1,
      -1,  3076,  3125,    -1,  3077,  3078,    -1,  1763,    -1,    -1,
      -1,  3134,    -1,    -1,  2610,  3090,    -1,  3140,    -1,    -1,
      -1,    -1,    -1,    -1,  1780,    -1,    -1,    -1,  3103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2434,
      -1,  3114,  1798,    -1,    -1,    -1,    -1,  3170,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3140,    -1,  1823,  3141,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3203,  3154,    -1,  3206,    -1,    -1,    -1,    -1,    -1,  3212,
      -1,    -1,    -1,    -1,    -1,  3218,    -1,  3220,    -1,    -1,
      -1,    -1,  3225,  3226,    -1,    -1,  3229,  3230,  3231,  3232,
    3233,  3234,  3235,  3236,  3237,  3238,    -1,    -1,    -1,  3242,
    3243,    -1,  1878,  2518,    -1,    -1,    -1,  3250,    -1,    -1,
      -1,  3206,  3255,    -1,    -1,    -1,    -1,    -1,  3261,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3271,    -1,
    3225,  3274,    -1,  3276,    -1,    -1,    -1,    -1,    -1,    -1,
    2555,  3284,  3285,  3286,  3287,    -1,    -1,    -1,  3291,    -1,
      -1,  3294,    -1,    -1,    -1,  3250,    -1,    -1,    -1,    -1,
      -1,  3304,    -1,  2068,    -1,    -1,    -1,    -1,    -1,  3312,
      -1,  3314,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2599,    -1,    -1,    -1,    -1,  3284,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2630,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3384,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2676,    -1,  2678,  2679,    -1,    -1,  2883,  2884,    -1,
    2886,    -1,    -1,  2688,  3417,    -1,  2691,    -1,  2693,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2068,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2719,    -1,  2721,    -1,    -1,    -1,
    2725,  2927,    -1,  2929,  3407,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3417,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2753,  2754,
    2755,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3444,    -1,    -1,    -1,    -1,  3449,    -1,  3451,  3452,
    3453,  3454,  2777,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2786,    -1,    -1,    -1,    -1,    -1,    -1,  3521,    -1,
    2795,    -1,  2998,    -1,    -1,  2800,    -1,    -1,    -1,    -1,
      -1,    -1,  2807,    -1,    -1,    -1,  3539,    -1,    -1,    -1,
    2305,    -1,    -1,    -1,    -1,  2310,  2311,    -1,    -1,  3025,
      -1,    -1,    -1,    -1,    -1,    -1,  2321,    -1,    -1,    -1,
      -1,    -1,    -1,  3516,  3517,  3518,    -1,  3520,    -1,    -1,
      -1,  3574,  3575,  3576,    -1,    -1,    -1,    -1,    -1,    -1,
    2855,    -1,    -1,  3059,  3539,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3599,    -1,    -1,    -1,
    3076,  3604,    -1,    -1,  3607,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3090,    -1,    -1,    -1,    -1,  3574,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3591,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3651,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3612,
      -1,    -1,    -1,    -1,  3140,    -1,    -1,    -1,    -1,  2305,
      -1,  2436,    -1,    -1,  2310,  2311,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3687,  2321,    -1,    -1,    -1,    -1,
      -1,  3694,  3695,    -1,  3697,    -1,    -1,    -1,    -1,  3702,
    3703,    -1,    -1,    -1,  3707,  3708,    -1,    -1,    -1,    -1,
    3713,  3714,    -1,    -1,  3717,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3728,    -1,    -1,    -1,    -1,
    3206,    -1,  2497,    -1,    -1,    -1,    -1,  3740,    -1,    -1,
      -1,    -1,  3697,    -1,    -1,    -1,    -1,    -1,    -1,  3225,
      -1,    -1,    -1,  3708,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3768,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3250,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3789,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3799,    -1,    -1,    -1,
    2436,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3284,    -1,
      -1,    -1,  1476,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3789,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3796,  3799,  2610,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3807,    -1,    -1,    -1,    -1,  3134,
      -1,  2497,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1549,    -1,    -1,  3891,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3203,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3939,  3212,    -1,    -1,
      -1,  3417,    -1,  3218,    -1,  3220,    -1,  3950,    -1,    -1,
      -1,  3954,    -1,    -1,  3907,    -1,  3959,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3242,  3243,    -1,
      -1,    -1,    -1,    -1,  2610,    -1,  3929,    -1,  3981,    -1,
      -1,    -1,  3985,    -1,    -1,    -1,  3261,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3271,    -1,    -1,  3274,
      -1,  3276,  4005,  4006,  3959,    -1,  4009,    -1,    -1,    -1,
    3285,    -1,    -1,  4016,  4017,  3968,  3291,    -1,    -1,  3294,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3304,
    3985,    -1,    -1,    -1,    -1,    -1,    -1,  3312,    -1,  3314,
    4043,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4060,    -1,    -1,
    4063,    -1,    -1,  3539,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4099,    -1,  3574,    -1,
      -1,    -1,    -1,    -1,    -1,  4060,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2883,  2884,
      -1,  2886,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4147,    -1,  4149,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2927,    -1,  2929,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4176,  4177,    -1,  4179,    -1,  4181,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4149,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4155,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4219,    -1,    -1,  4222,
      -1,  3697,  4177,  4226,  4227,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3708,  2998,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2883,  2884,    -1,
    2886,    -1,    -1,    -1,  1918,    -1,  4259,    -1,    -1,    -1,
    3025,    -1,    -1,    -1,    -1,    -1,    -1,  4222,    -1,    -1,
      -1,  4226,  4227,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4285,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2927,    -1,  2929,  3059,    -1,    -1,    -1,    -1,    -1,
    3575,  3576,  4305,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3076,    -1,  3789,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3799,    -1,  3090,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3103,    -1,
      -1,    -1,    -1,    -1,    -1,  2009,  4349,    -1,    -1,    -1,
      -1,    -1,    -1,  4356,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2998,    -1,    -1,    -1,    -1,    -1,  2032,  4372,
    4373,    -1,    -1,  2037,    -1,  3140,  3651,    -1,    -1,  4382,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3025,
      -1,  4344,  2056,  2057,    -1,  2059,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4409,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4419,    -1,    -1,  3694,
    3695,    -1,    -1,  3059,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3707,  2097,    -1,    -1,    -1,    -1,  3713,  3714,
    3076,  3206,  3717,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3728,  3090,    -1,    -1,    -1,    -1,    -1,
    3225,    -1,    -1,    -1,    -1,  3740,    -1,  3103,    -1,    -1,
    4473,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4482,
      -1,    -1,    -1,  3959,    -1,  3250,  2150,    -1,    -1,    -1,
      -1,    -1,    -1,  3768,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3140,    -1,    -1,    -1,    -1,  3985,
      -1,    -1,    -1,    -1,    -1,    -1,  2180,    -1,    -1,  3284,
      -1,    -1,    -1,    -1,    -1,    -1,  2190,    -1,    -1,  2193,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3206,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4060,    -1,    -1,    -1,    -1,  3225,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3250,    -1,  3891,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3284,    -1,
      -1,    -1,  3417,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4149,    -1,  3950,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4009,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4017,    -1,    -1,    -1,  4222,    -1,    -1,    -1,
    4226,  4227,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3539,    -1,    -1,    -1,    -1,    -1,
      -1,  3417,    -1,    -1,    -1,    -1,    -1,     5,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    25,    -1,  3574,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,    36,    -1,
      -1,    -1,    -1,    -1,    -1,    43,    44,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    -1,    -1,    75,    76,    77,
      78,    79,    80,    81,    82,    -1,    -1,    -1,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3539,  4179,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   133,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3697,    -1,    -1,    -1,    -1,    -1,  3574,    -1,
      -1,    -1,    -1,  3708,  4219,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2633,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4259,    -1,    -1,   205,    -1,    -1,
      -1,  2655,    -1,  2657,    -1,  2659,  2660,  2661,    -1,    -1,
    2664,    -1,   220,    -1,  2668,    -1,    -1,    -1,    -1,    -1,
      -1,  2675,    -1,    -1,    -1,    -1,  2680,    -1,    -1,    -1,
      -1,  2685,   240,    -1,  3789,    -1,  2690,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3799,  2699,    -1,    -1,    -1,  2703,
    2704,  2705,    -1,    -1,   262,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2717,    -1,    -1,    -1,    -1,    -1,    -1,
    2724,  3697,  2726,  2727,  2728,  2729,  2730,  2731,  2732,  2733,
    2734,  2735,  3708,    -1,    -1,    -1,    -1,   295,    -1,    -1,
     298,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2759,    -1,  4372,  4373,    -1,
      -1,   319,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4409,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4419,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3789,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3799,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   390,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3959,    -1,    -1,    -1,  4473,    -1,
      -1,  2865,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   432,    -1,    -1,    -1,    -1,    -1,
    3985,    -1,    -1,    -1,    -1,    -1,    -1,   445,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     458,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   483,    -1,    -1,    -1,    -1,
      -1,   489,    -1,    -1,    -1,   493,   494,   495,   496,   497,
      -1,    -1,   500,   501,   502,    -1,    -1,    -1,    -1,   507,
      -1,    -1,    -1,    -1,    -1,  4060,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3959,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3985,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3026,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4149,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4060,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
       9,    -1,    -1,    -1,    13,    -1,    15,  4222,    17,    18,
      -1,  4226,  4227,    -1,    -1,    -1,    -1,    -1,    -1,    28,
      -1,    -1,    -1,  3137,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    45,    46,    -1,    -1,
      -1,    -1,    -1,    -1,  3158,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4149,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    91,    -1,    -1,    -1,    -1,    -1,  3202,    -1,
      -1,  4177,   101,    -1,   103,   104,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   117,  3223,
    3224,    -1,  3226,    -1,    -1,  3229,  3230,  3231,  3232,  3233,
    3234,  3235,  3236,  3237,  3238,  3239,    -1,    -1,   137,    -1,
     139,   140,    -1,    -1,    -1,   144,  4222,   146,    -1,    -1,
    4226,  4227,    -1,    -1,    -1,    -1,    -1,   156,  3262,   158,
      -1,  3265,    -1,  3267,    -1,    -1,    -1,    -1,  3272,  3273,
      -1,    -1,    -1,    -1,    -1,    -1,   175,    -1,   177,    -1,
      -1,   180,  3286,  3287,  3288,    -1,  3290,   186,    -1,  3293,
      -1,    -1,    -1,   192,    -1,   194,    -1,    -1,    -1,   198,
      -1,    -1,    -1,    -1,    -1,   204,    -1,    -1,    -1,    -1,
      -1,    -1,   211,    -1,   213,    -1,    -1,    -1,    -1,   218,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   232,    -1,    -1,  3340,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3355,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   260,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3381,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   284,   285,    -1,    -1,    -1,
      -1,   290,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     299,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   316,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   352,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   363,    -1,    -1,    -1,   367,    -1,
     369,    -1,    -1,    -1,    -1,   374,    -1,    -1,    -1,    -1,
     379,    -1,    -1,   382,    -1,    -1,    -1,   386,    -1,    -1,
      -1,    -1,    -1,   392,    -1,    -1,    -1,    -1,    -1,    -1,
     399,    -1,    -1,   402,    -1,    -1,    -1,    -1,    -1,    -1,
     409,    -1,    -1,    -1,    -1,    -1,    -1,  3521,    -1,    -1,
      -1,    -1,    -1,   422,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     439,    -1,   441,    -1,    -1,    -1,    -1,    -1,    -1,   448,
      -1,   450,    -1,    -1,   453,    -1,    -1,    -1,   457,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     469,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   502,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3652,    -1,
      -1,  3655,  3656,  3657,    -1,    -1,  3660,    -1,    -1,    -1,
      -1,  3665,  3666,  3667,  3668,  3669,  3670,  3671,  3672,  3673,
    3674,  3675,  3676,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3701,  3702,  3703,
    3704,    -1,  3706,    -1,    -1,    -1,  3710,  3711,  3712,    -1,
      -1,  3715,    -1,    -1,  3718,    -1,    -1,    -1,    -1,    -1,
      -1,  3725,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3737,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     6,     7,     8,    -1,
      10,    11,    12,    -1,    -1,    -1,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    -1,    -1,
      -1,    31,    32,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    -1,    -1,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      -1,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3893,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   114,    -1,    -1,    -1,   118,   119,
     120,   121,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3936,  3937,   134,    -1,    -1,    -1,    -1,    -1,
      -1,   141,    -1,    -1,    -1,    -1,    -1,    -1,   148,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   162,    -1,    -1,    -1,    -1,    -1,   168,    -1,
      -1,    -1,    -1,  3977,    -1,    -1,    -1,  3981,   178,   179,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3993,
      -1,  3995,    -1,    -1,    -1,    -1,  4000,  4001,  4002,    -1,
      -1,  4005,  4006,  4007,  4008,   205,  4010,    -1,    -1,    -1,
      -1,    -1,   212,    -1,    -1,   215,    -1,    -1,    -1,    -1,
     220,    -1,    -1,    -1,    -1,    -1,   226,    -1,   228,    -1,
      -1,    -1,    -1,    -1,   234,    -1,    -1,  4041,    -1,    -1,
      -1,    -1,    -1,   243,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   256,   257,    -1,    -1,
      -1,    -1,    -1,   263,    -1,   265,    -1,    -1,   268,   269,
      -1,   271,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   279,
     280,    -1,   282,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   302,   303,   304,    -1,    -1,  4111,    -1,    -1,
      -1,    -1,   312,    -1,    -1,    -1,    -1,   317,    -1,    -1,
     320,    -1,   322,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   335,   336,   337,   338,   339,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   348,    -1,
     350,    -1,    -1,    -1,    -1,    -1,    -1,  4161,    -1,    -1,
      -1,    -1,   362,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4175,  4176,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     380,    -1,    -1,   383,    -1,  4189,  4190,  4191,    -1,  4193,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     400,    -1,    -1,   403,    -1,   405,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     430,   431,    -1,    -1,    -1,   435,    -1,   437,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   445,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   458,    -1,
      -1,   461,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   475,   476,   477,   478,   479,
     480,   481,   482,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   509,
      -1,    -1,    -1,    -1,    -1,  4319,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4348,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    43,    44,    45,    46,    -1,    -1,  4412,    50,
      51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,
      71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4452,    -1,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     3,    -1,    -1,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,   508,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    42,    43,    44,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   101,    -1,   103,   104,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,   122,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   134,    -1,    -1,   137,
      -1,   139,   140,   141,    -1,    -1,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   156,    -1,
     158,    -1,    -1,    -1,   162,    -1,    -1,    -1,    -1,    -1,
     168,    -1,    -1,    -1,    -1,    -1,    -1,   175,    -1,   177,
     178,   179,   180,    -1,    -1,    -1,    -1,    -1,   186,    -1,
      -1,    -1,    -1,    -1,   192,    -1,   194,    -1,    -1,    -1,
     198,    -1,    -1,    -1,    -1,    -1,   204,   205,    -1,    -1,
      -1,    -1,    -1,   211,   212,   213,    -1,   215,    -1,    -1,
     218,    -1,   220,    -1,    -1,    -1,    -1,    -1,   226,    -1,
     228,    -1,    -1,    -1,   232,    -1,   234,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   243,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   256,   257,
      -1,    -1,   260,    -1,    -1,   263,    -1,   265,    -1,    -1,
     268,   269,    -1,   271,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   279,   280,    -1,   282,    -1,   284,   285,    -1,    -1,
      -1,    -1,   290,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   299,    -1,    -1,   302,   303,   304,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   312,    -1,    -1,    -1,   316,   317,
      -1,    -1,   320,    -1,   322,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   335,   336,   337,
     338,   339,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     348,    -1,   350,    -1,   352,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   362,   363,    -1,    -1,    -1,   367,
      -1,   369,    -1,    -1,    -1,    -1,   374,    -1,    -1,    -1,
      -1,   379,   380,    -1,   382,   383,    -1,    -1,   386,    -1,
      -1,    -1,    -1,    -1,   392,    -1,    -1,    -1,    -1,    -1,
      -1,   399,   400,    -1,   402,   403,    -1,   405,    -1,    -1,
      -1,   409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,
      -1,    -1,    -1,    -1,   422,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   430,   431,    -1,    -1,    -1,   435,    -1,   437,
      -1,   439,    -1,   441,    -1,    -1,    -1,   445,    -1,    -1,
     448,    -1,   450,    -1,    -1,   453,    -1,    -1,    -1,   457,
     458,    -1,    -1,   461,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   469,    -1,    -1,    -1,    -1,    -1,   475,   476,   477,
     478,   479,   480,   481,   482,     6,     7,     8,    -1,    10,
      11,    12,    -1,    -1,    -1,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,   502,    26,    27,    -1,   506,    -1,
      31,    32,    33,    34,    -1,    36,    37,    38,    39,    40,
      -1,    42,    43,    44,    -1,    -1,    -1,    -1,    -1,    50,
      51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,    -1,
      71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   114,    -1,    -1,    -1,   118,   119,   120,
     121,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   134,    -1,    -1,    -1,    -1,    -1,    -1,
     141,    -1,    -1,    -1,    -1,    -1,    -1,   148,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   162,    -1,    -1,    -1,    -1,    -1,   168,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   178,   179,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   205,    -1,    -1,    -1,    -1,    -1,
      -1,   212,    -1,    -1,   215,    -1,    -1,    -1,    -1,   220,
      -1,    -1,    -1,    -1,    -1,   226,    -1,   228,    -1,    -1,
      -1,    -1,    -1,   234,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   243,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   256,   257,    -1,    -1,    -1,
      -1,    -1,   263,    -1,   265,    -1,    -1,   268,   269,    -1,
     271,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   279,   280,
      -1,   282,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   302,   303,   304,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   312,    -1,    -1,    -1,    -1,   317,    -1,    -1,   320,
      -1,   322,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   335,   336,   337,   338,   339,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   348,    -1,   350,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   362,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   380,
      -1,    -1,   383,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   400,
      -1,    -1,   403,    -1,   405,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   417,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   430,
     431,    -1,    -1,    -1,   435,    -1,   437,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   445,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   458,    -1,    -1,
     461,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   475,   476,   477,   478,   479,   480,
     481,   482,    -1,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,   509,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    43,    44,    45,    46,    -1,    -1,    -1,    50,    51,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,
      72,    -1,    -1,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,    -1,    -1,    -1,   107,    -1,    -1,   110,   111,
      -1,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,    -1,   137,   138,   139,   140,   141,
      -1,    -1,   144,   145,   146,   147,   148,   149,   150,    -1,
     152,   153,   154,   155,   156,   157,    -1,   159,   160,   161,
     162,   163,    -1,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,    -1,   184,   185,   186,   187,   188,    -1,   190,   191,
     192,   193,    -1,   195,   196,   197,   198,   199,    -1,   201,
     202,   203,    -1,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,    -1,   219,   220,   221,
      -1,   223,    -1,   225,   226,    -1,   228,   229,   230,   231,
      -1,   233,   234,    -1,   236,    -1,   238,   239,   240,   241,
     242,   243,   244,   245,   246,    -1,   248,   249,   250,   251,
     252,   253,    -1,   255,   256,   257,    -1,   259,   260,   261,
     262,   263,    -1,   265,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,    -1,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,    -1,   327,    -1,    -1,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,    -1,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,    -1,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,    -1,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,    -1,   420,   421,
      -1,   423,   424,   425,   426,   427,   428,    -1,   430,   431,
      -1,    -1,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
      -1,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,    -1,    -1,   467,    -1,    -1,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   493,   494,   495,    -1,    -1,    -1,    -1,    -1,    -1,
     502,   503,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      43,    44,    45,    46,    -1,    -1,    -1,    50,    51,    -1,
      -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,    72,
      -1,    -1,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    -1,    -1,    -1,    91,    92,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
      -1,    -1,    -1,    -1,   107,    -1,    -1,   110,   111,    -1,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,    -1,   137,   138,   139,   140,   141,    -1,
      -1,   144,   145,   146,   147,   148,   149,   150,    -1,   152,
     153,   154,   155,   156,   157,    -1,   159,   160,   161,   162,
     163,    -1,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,    -1,   182,
      -1,   184,   185,   186,   187,   188,    -1,   190,   191,   192,
      -1,    -1,   195,   196,   197,   198,   199,    -1,   201,   202,
     203,    -1,   205,   206,    -1,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,    -1,   219,   220,   221,    -1,
     223,    -1,   225,   226,    -1,   228,   229,   230,   231,    -1,
     233,   234,    -1,   236,    -1,   238,   239,   240,   241,   242,
     243,   244,   245,   246,    -1,   248,   249,   250,   251,   252,
     253,    -1,   255,   256,   257,    -1,   259,   260,   261,   262,
     263,    -1,   265,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
      -1,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,    -1,   327,    -1,    -1,   330,   331,   332,
      -1,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,    -1,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,    -1,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,    -1,   420,   421,    -1,
     423,   424,   425,   426,   427,   428,    -1,   430,   431,    -1,
      -1,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,    -1,   446,   447,   448,   449,   450,   451,    -1,
     453,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     493,   494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   502,
     503,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,    -1,    -1,    -1,
     144,   145,   146,   147,   148,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,   162,   163,
      -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,    -1,   213,
     214,    -1,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,   226,    -1,   228,   229,   230,   231,    -1,   233,
      -1,    -1,   236,    -1,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
      -1,   255,   256,   257,    -1,   259,   260,   261,   262,   263,
      -1,   265,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,    -1,   280,   281,   282,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
      -1,   315,   316,   317,   318,    -1,    -1,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,    -1,   347,    -1,   349,    -1,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,   403,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,    -1,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,    -1,   436,    -1,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,    -1,   458,   459,   460,   461,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   483,
     484,   485,    -1,    -1,    -1,    -1,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,   503,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    45,    46,    -1,    -1,
      -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,
      69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,   113,   114,   115,   116,   117,    -1,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,   128,
      -1,    -1,   131,   132,   133,   134,   135,    -1,   137,   138,
     139,   140,    -1,    -1,    -1,   144,   145,   146,   147,   148,
     149,   150,    -1,   152,   153,   154,   155,   156,   157,    -1,
     159,   160,   161,   162,   163,    -1,    -1,    -1,    -1,   168,
      -1,    -1,    -1,   172,   173,   174,   175,   176,   177,   178,
     179,   180,    -1,   182,    -1,   184,   185,   186,   187,   188,
      -1,   190,   191,   192,    -1,    -1,   195,   196,   197,   198,
     199,    -1,   201,   202,   203,    -1,   205,   206,    -1,   208,
     209,   210,   211,    -1,   213,   214,    -1,    -1,   217,    -1,
     219,   220,   221,    -1,   223,    -1,   225,   226,    -1,   228,
     229,   230,   231,    -1,   233,    -1,    -1,   236,    -1,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,    -1,   255,   256,   257,    -1,
     259,   260,   261,   262,   263,    -1,   265,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
      -1,   280,   281,   282,    -1,   284,   285,   286,    -1,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,    -1,   315,   316,   317,   318,
      -1,    -1,   321,   322,   323,   324,   325,    -1,   327,    -1,
      -1,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,    -1,   347,    -1,
     349,    -1,   351,   352,   353,    -1,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,    -1,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,   404,   405,    -1,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,    -1,   418,
      -1,   420,   421,    -1,   423,   424,   425,   426,   427,   428,
      -1,   430,   431,    -1,    -1,   434,    -1,   436,    -1,    -1,
     439,   440,   441,   442,   443,   444,    -1,    -1,   447,   448,
     449,   450,    -1,    -1,   453,   454,   455,   456,    -1,   458,
     459,   460,   461,   462,   463,   464,    -1,    -1,   467,    -1,
      -1,   470,   471,   472,   473,   474,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   483,   484,   485,    -1,    -1,    -1,
      -1,    -1,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,   503,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,   452,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,    -1,    -1,    -1,    -1,    -1,     5,     6,     7,
       8,     9,    10,    11,    12,    13,   500,    15,    16,    -1,
     504,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    43,    44,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    72,    -1,    -1,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,   107,
      -1,    -1,   110,   111,    -1,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,    -1,   137,
     138,   139,   140,   141,    -1,    -1,   144,   145,   146,   147,
     148,   149,   150,    -1,   152,   153,   154,   155,   156,   157,
      -1,   159,   160,   161,   162,   163,    -1,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
      -1,   219,   220,   221,    -1,   223,    -1,   225,   226,   227,
     228,   229,   230,   231,    -1,   233,   234,    -1,   236,    -1,
     238,   239,   240,   241,   242,   243,   244,   245,   246,    -1,
     248,   249,   250,   251,   252,   253,    -1,   255,   256,   257,
      -1,   259,   260,   261,   262,   263,    -1,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,    -1,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,    -1,   327,
      -1,    -1,   330,   331,   332,    -1,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,    -1,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,    -1,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,    -1,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,    -1,   420,   421,    -1,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,    -1,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,    -1,   453,   454,   455,   456,   457,
     458,    -1,   460,   461,   462,   463,   464,    -1,    -1,   467,
      -1,    -1,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   493,   494,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   502,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    72,    -1,    -1,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,   107,    -1,    -1,
     110,   111,    -1,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,    -1,   137,   138,   139,
     140,   141,    -1,    -1,   144,   145,   146,   147,   148,   149,
     150,    -1,   152,   153,   154,   155,   156,   157,    -1,   159,
     160,   161,   162,   163,    -1,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,    -1,   184,   185,   186,   187,   188,    -1,
     190,   191,   192,    -1,    -1,   195,   196,   197,   198,   199,
      -1,   201,   202,   203,    -1,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,    -1,   219,
     220,   221,    -1,   223,    -1,   225,   226,    -1,   228,   229,
     230,   231,    -1,   233,   234,    -1,   236,    -1,   238,   239,
     240,   241,   242,   243,   244,   245,   246,    -1,   248,   249,
     250,   251,   252,   253,    -1,   255,   256,   257,    -1,   259,
     260,   261,   262,   263,    -1,   265,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,    -1,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,    -1,   327,    -1,    -1,
     330,   331,   332,    -1,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,    -1,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,    -1,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,    -1,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,    -1,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,    -1,   453,   454,   455,   456,   457,   458,    -1,
     460,   461,   462,   463,   464,    -1,    -1,   467,    -1,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   493,   494,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   502,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    43,    44,    45,    46,    -1,    -1,    -1,    50,    51,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,
      72,    -1,    -1,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,   107,    -1,    -1,   110,   111,
      -1,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,    -1,   137,   138,   139,   140,   141,
      -1,    -1,   144,   145,   146,   147,   148,   149,   150,    -1,
     152,   153,   154,   155,   156,   157,    -1,   159,   160,   161,
     162,   163,    -1,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,    -1,   184,   185,   186,   187,   188,    -1,   190,   191,
     192,    -1,    -1,   195,   196,   197,   198,   199,    -1,   201,
     202,   203,    -1,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,    -1,   219,   220,   221,
      -1,   223,    -1,   225,   226,    -1,   228,   229,   230,   231,
      -1,   233,   234,    -1,   236,    -1,   238,   239,   240,   241,
     242,   243,   244,   245,   246,    -1,   248,   249,   250,   251,
     252,   253,    -1,   255,   256,   257,    -1,   259,   260,   261,
     262,   263,    -1,   265,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,    -1,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,    -1,   327,    -1,    -1,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,    -1,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,    -1,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,    -1,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,    -1,   420,   421,
      -1,   423,   424,   425,   426,   427,   428,    -1,   430,   431,
      -1,    -1,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
      -1,   453,   454,   455,   456,   457,   458,    -1,   460,   461,
     462,   463,   464,    -1,    -1,   467,    -1,    -1,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   493,   494,    -1,    -1,    -1,    -1,    -1,   500,   501,
     502,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,   107,    -1,    -1,   110,   111,    -1,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,   148,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,   162,   163,
      -1,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,   226,    -1,   228,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,   243,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,   256,   257,    -1,   259,   260,   261,   262,   263,
      -1,   265,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,    -1,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,   451,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,   461,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,
     494,   495,    -1,    -1,    -1,    -1,    -1,    -1,   502,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    43,    44,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    72,    -1,    -1,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,   107,    -1,    -1,   110,   111,    -1,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
      -1,   137,   138,   139,   140,   141,    -1,    -1,   144,   145,
     146,   147,   148,   149,   150,    -1,   152,   153,   154,   155,
     156,   157,    -1,   159,   160,   161,   162,   163,    -1,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,    -1,   219,   220,   221,    -1,   223,    -1,   225,
     226,    -1,   228,   229,   230,   231,    -1,   233,   234,    -1,
     236,    -1,   238,   239,   240,   241,   242,   243,   244,   245,
     246,    -1,   248,   249,   250,   251,   252,   253,    -1,   255,
     256,   257,    -1,   259,   260,   261,   262,   263,    -1,   265,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,    -1,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
      -1,   327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,    -1,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,    -1,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,    -1,   420,   421,    -1,   423,   424,   425,
     426,   427,   428,    -1,   430,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,    -1,
     446,   447,   448,   449,   450,   451,    -1,   453,   454,   455,
     456,   457,   458,    -1,   460,   461,   462,   463,   464,    -1,
      -1,   467,    -1,    -1,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,   494,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   502,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    43,    44,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    72,    -1,    -1,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,    -1,    -1,    -1,   107,
      -1,    -1,   110,   111,    -1,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,    -1,   137,
     138,   139,   140,   141,    -1,    -1,   144,   145,   146,   147,
     148,   149,   150,    -1,   152,   153,   154,   155,   156,   157,
      -1,   159,   160,   161,   162,   163,    -1,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
      -1,   219,   220,   221,    -1,   223,    -1,   225,   226,    -1,
     228,   229,   230,   231,    -1,   233,   234,    -1,   236,    -1,
     238,   239,   240,   241,   242,   243,   244,   245,   246,    -1,
     248,   249,   250,   251,   252,   253,    -1,   255,   256,   257,
      -1,   259,   260,   261,   262,   263,    -1,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,    -1,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,    -1,   327,
      -1,    -1,   330,   331,   332,    -1,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,    -1,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,    -1,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,    -1,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,    -1,   420,   421,    -1,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,    -1,    -1,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,    -1,   453,   454,   455,   456,   457,
     458,    -1,   460,   461,   462,   463,   464,    -1,    -1,   467,
      -1,    -1,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   493,   494,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   502,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    72,    -1,    -1,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,   107,    -1,    -1,
     110,   111,    -1,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,    -1,   137,   138,   139,
     140,   141,    -1,    -1,   144,   145,   146,   147,   148,   149,
     150,    -1,   152,   153,   154,   155,   156,   157,    -1,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,    -1,   184,   185,   186,   187,   188,    -1,
     190,   191,   192,    -1,    -1,   195,   196,   197,   198,   199,
      -1,   201,   202,   203,    -1,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,    -1,   219,
     220,   221,    -1,   223,    -1,   225,   226,    -1,   228,   229,
     230,   231,    -1,   233,   234,    -1,   236,    -1,   238,   239,
     240,   241,   242,   243,   244,   245,   246,    -1,   248,   249,
     250,   251,   252,   253,    -1,   255,   256,   257,    -1,   259,
     260,   261,   262,   263,    -1,   265,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,    -1,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,    -1,   327,    -1,    -1,
     330,   331,   332,    -1,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,    -1,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,    -1,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,    -1,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,    -1,
     420,   421,    -1,   423,   424,   425,   426,   427,   428,    -1,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,    -1,   453,   454,   455,   456,   457,   458,    -1,
     460,   461,   462,   463,   464,    -1,    -1,   467,    -1,    -1,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   493,   494,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   502,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    43,    44,    45,    46,    -1,    -1,    -1,    50,    51,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,
      72,    -1,    -1,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,   107,    -1,    -1,   110,   111,
      -1,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,    -1,   137,   138,   139,   140,   141,
      -1,    -1,   144,   145,   146,   147,   148,   149,   150,    -1,
     152,   153,   154,   155,   156,   157,    -1,   159,   160,   161,
     162,   163,    -1,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,    -1,   184,   185,   186,   187,   188,    -1,   190,   191,
     192,    -1,    -1,   195,   196,   197,   198,   199,    -1,   201,
     202,   203,    -1,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,    -1,   219,   220,   221,
      -1,   223,    -1,   225,   226,   227,   228,   229,   230,   231,
      -1,   233,   234,    -1,   236,    -1,   238,   239,   240,   241,
     242,   243,   244,   245,   246,    -1,   248,   249,   250,   251,
     252,   253,    -1,   255,   256,   257,    -1,   259,   260,   261,
     262,   263,    -1,   265,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,    -1,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,    -1,   327,    -1,    -1,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,    -1,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,    -1,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,    -1,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,    -1,   420,   421,
      -1,   423,   424,   425,   426,   427,   428,    -1,   430,   431,
      -1,    -1,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
      -1,   453,   454,   455,   456,   457,   458,    -1,   460,   461,
     462,   463,   464,    -1,    -1,   467,    -1,    -1,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   493,   494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     502,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,   107,    -1,    -1,   110,   111,    -1,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,   148,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,   162,   163,
      -1,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,   226,    -1,   228,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,   243,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,   256,   257,    -1,   259,   260,   261,   262,   263,
      -1,   265,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,    -1,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,   451,    -1,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,
     494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   502,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    43,    44,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    72,    -1,    -1,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,   107,    -1,    -1,   110,   111,    -1,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
      -1,   137,   138,   139,   140,   141,    -1,    -1,   144,   145,
     146,   147,   148,   149,   150,    -1,   152,   153,   154,   155,
     156,   157,    -1,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,    -1,   219,   220,   221,    -1,   223,    -1,   225,
     226,    -1,   228,   229,   230,   231,    -1,   233,   234,    -1,
     236,    -1,   238,   239,   240,   241,   242,   243,   244,   245,
     246,    -1,   248,   249,   250,   251,   252,   253,    -1,   255,
     256,   257,    -1,   259,   260,   261,   262,   263,    -1,   265,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,    -1,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
      -1,   327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,    -1,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,    -1,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,    -1,   420,   421,    -1,   423,   424,   425,
     426,   427,   428,    -1,   430,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,    -1,
     446,   447,   448,   449,   450,   451,    -1,   453,   454,   455,
     456,   457,   458,    -1,   460,   461,   462,   463,   464,    -1,
      -1,   467,    -1,    -1,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,   494,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   502,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    43,    44,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    72,    -1,    -1,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,   107,
      -1,    -1,   110,   111,    -1,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,    -1,   137,
     138,   139,   140,   141,    -1,    -1,   144,   145,   146,   147,
     148,   149,   150,    -1,   152,   153,   154,   155,   156,   157,
      -1,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
      -1,   219,   220,   221,    -1,   223,    -1,   225,   226,    -1,
     228,   229,   230,   231,    -1,   233,   234,    -1,   236,    -1,
     238,   239,   240,   241,   242,   243,   244,   245,   246,    -1,
     248,   249,   250,   251,   252,   253,    -1,   255,   256,   257,
      -1,   259,   260,   261,   262,   263,    -1,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,    -1,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,    -1,   327,
      -1,    -1,   330,   331,   332,    -1,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,    -1,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,    -1,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,    -1,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,    -1,   420,   421,    -1,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,    -1,    -1,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,    -1,   453,   454,   455,   456,   457,
     458,    -1,   460,   461,   462,   463,   464,    -1,    -1,   467,
      -1,    -1,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   493,   494,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   502,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    72,    -1,    -1,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,   107,    -1,    -1,
     110,   111,    -1,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,    -1,   137,   138,   139,
     140,   141,    -1,    -1,   144,   145,   146,   147,   148,   149,
     150,    -1,   152,   153,   154,   155,   156,   157,    -1,   159,
     160,   161,   162,   163,    -1,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,    -1,   184,   185,   186,   187,   188,    -1,
     190,   191,   192,    -1,    -1,   195,   196,   197,   198,   199,
      -1,   201,   202,   203,    -1,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,    -1,   219,
     220,   221,    -1,   223,    -1,   225,   226,    -1,   228,   229,
     230,   231,    -1,   233,   234,    -1,   236,    -1,   238,   239,
     240,   241,   242,   243,   244,   245,   246,    -1,   248,   249,
     250,   251,   252,   253,    -1,   255,   256,   257,    -1,   259,
     260,   261,   262,   263,    -1,   265,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,    -1,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,    -1,   327,    -1,    -1,
     330,   331,   332,    -1,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,    -1,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,    -1,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,    -1,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,    -1,
     420,   421,    -1,   423,   424,   425,   426,   427,   428,    -1,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,    -1,   453,   454,   455,   456,   457,   458,    -1,
     460,   461,   462,   463,   464,    -1,    -1,   467,    -1,    -1,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   493,   494,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   502,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    43,    44,    45,    46,    -1,    -1,    -1,    50,    51,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,
      72,    -1,    -1,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,   107,    -1,    -1,   110,   111,
      -1,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,    -1,   137,   138,   139,   140,   141,
      -1,    -1,   144,   145,   146,   147,   148,   149,   150,    -1,
     152,   153,   154,   155,   156,   157,    -1,   159,   160,   161,
     162,   163,    -1,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,    -1,   184,   185,   186,   187,   188,    -1,   190,   191,
     192,    -1,    -1,   195,   196,   197,   198,   199,    -1,   201,
     202,   203,    -1,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,    -1,   219,   220,   221,
      -1,   223,    -1,   225,   226,    -1,   228,   229,   230,   231,
      -1,   233,   234,    -1,   236,    -1,   238,   239,   240,   241,
     242,   243,   244,   245,   246,    -1,   248,   249,   250,   251,
     252,   253,    -1,   255,   256,   257,    -1,   259,   260,   261,
     262,   263,    -1,   265,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,    -1,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,    -1,   327,    -1,    -1,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,    -1,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,    -1,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,    -1,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,    -1,   420,   421,
      -1,   423,   424,   425,   426,   427,   428,    -1,   430,   431,
      -1,    -1,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
      -1,   453,   454,   455,   456,   457,   458,    -1,   460,   461,
     462,   463,   464,    -1,    -1,   467,    -1,    -1,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   493,   494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     502,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,   107,    -1,    -1,   110,   111,    -1,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,   148,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,   162,   163,
      -1,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,   226,    -1,   228,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,   243,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,   256,   257,    -1,   259,   260,   261,   262,   263,
      -1,   265,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,    -1,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,   451,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,   461,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,
     494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   502,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    43,    44,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    72,    -1,    -1,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,   107,    -1,    -1,   110,   111,    -1,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
      -1,   137,   138,   139,   140,   141,    -1,    -1,   144,   145,
     146,   147,   148,   149,   150,    -1,   152,   153,   154,   155,
     156,   157,    -1,   159,   160,   161,   162,   163,    -1,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,    -1,   219,   220,   221,    -1,   223,    -1,   225,
     226,    -1,   228,   229,   230,   231,    -1,   233,   234,    -1,
     236,    -1,   238,   239,   240,   241,   242,   243,   244,   245,
     246,    -1,   248,   249,   250,   251,   252,   253,    -1,   255,
     256,   257,    -1,   259,   260,   261,   262,   263,    -1,   265,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,    -1,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,    -1,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
      -1,   327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,    -1,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,    -1,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,    -1,   420,   421,    -1,   423,   424,   425,
     426,   427,   428,    -1,   430,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,    -1,
      -1,   447,   448,   449,   450,   451,    -1,   453,   454,   455,
     456,   457,   458,    -1,   460,   461,   462,   463,   464,    -1,
      -1,   467,    -1,    -1,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,   494,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   502,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    43,    44,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    72,    -1,    -1,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,   107,
      -1,    -1,   110,   111,    -1,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,    -1,   137,
     138,   139,   140,   141,    -1,    -1,   144,   145,   146,   147,
     148,   149,   150,    -1,   152,   153,   154,   155,   156,   157,
      -1,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
      -1,   219,   220,   221,    -1,   223,    -1,   225,   226,    -1,
     228,   229,   230,   231,    -1,   233,   234,    -1,   236,    -1,
     238,   239,   240,   241,   242,    -1,   244,   245,   246,    -1,
     248,   249,   250,   251,   252,   253,    -1,   255,   256,   257,
      -1,   259,   260,   261,   262,   263,    -1,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,    -1,    -1,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,    -1,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,    -1,   327,
      -1,    -1,   330,   331,   332,    -1,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,    -1,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,    -1,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,    -1,   404,   405,    -1,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,    -1,   420,   421,    -1,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,    -1,    -1,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,    -1,   453,   454,   455,   456,   457,
     458,    -1,   460,   461,   462,   463,   464,    -1,    -1,   467,
      -1,    -1,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   493,   494,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   502,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    72,    -1,    -1,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,   107,    -1,    -1,
     110,   111,    -1,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,    -1,   137,   138,   139,
     140,   141,    -1,    -1,   144,   145,   146,   147,   148,   149,
     150,    -1,   152,   153,   154,   155,   156,   157,    -1,   159,
     160,   161,   162,   163,    -1,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,    -1,   184,   185,   186,   187,   188,    -1,
     190,   191,   192,    -1,    -1,   195,   196,   197,   198,   199,
      -1,   201,   202,   203,    -1,   205,    -1,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,    -1,   219,
     220,   221,    -1,   223,    -1,   225,   226,    -1,   228,   229,
     230,   231,    -1,   233,   234,    -1,   236,    -1,   238,   239,
     240,   241,   242,    -1,   244,   245,   246,    -1,   248,   249,
     250,   251,   252,   253,    -1,   255,   256,   257,    -1,   259,
     260,   261,   262,   263,    -1,   265,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,    -1,    -1,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,    -1,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,    -1,   327,    -1,    -1,
     330,   331,   332,    -1,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,    -1,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,    -1,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,   404,   405,    -1,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,    -1,
     420,   421,    -1,   423,   424,   425,   426,   427,   428,    -1,
     430,   431,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,    -1,   453,   454,   455,   456,   457,   458,    -1,
     460,   461,   462,   463,   464,    -1,    -1,   467,    -1,    -1,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   493,   494,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   502,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    43,    44,    45,    46,    -1,    -1,    -1,    50,    51,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,
      72,    -1,    -1,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,   107,    -1,    -1,   110,   111,
      -1,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,    -1,   137,   138,   139,   140,   141,
      -1,    -1,   144,   145,   146,   147,   148,   149,   150,    -1,
     152,   153,   154,   155,   156,   157,    -1,   159,   160,   161,
     162,   163,    -1,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,    -1,   184,   185,   186,   187,   188,    -1,   190,   191,
     192,    -1,    -1,   195,   196,   197,   198,   199,    -1,   201,
     202,   203,    -1,   205,    -1,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,    -1,   219,   220,   221,
      -1,   223,    -1,   225,   226,    -1,   228,   229,   230,   231,
      -1,   233,   234,    -1,   236,    -1,   238,   239,   240,   241,
     242,    -1,   244,   245,   246,    -1,   248,   249,   250,   251,
     252,   253,    -1,   255,   256,   257,    -1,   259,   260,   261,
     262,   263,    -1,   265,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
      -1,    -1,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,    -1,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,    -1,   327,    -1,    -1,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,    -1,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,    -1,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,    -1,   404,   405,    -1,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,    -1,   420,   421,
      -1,   423,   424,   425,   426,   427,   428,    -1,   430,   431,
      -1,    -1,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,    -1,    -1,   447,   448,   449,   450,   451,
      -1,   453,   454,   455,   456,   457,   458,    -1,   460,   461,
     462,   463,   464,    -1,    -1,   467,    -1,    -1,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   493,   494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     502,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,   148,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,   162,   163,
      -1,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,   226,    -1,   228,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,   243,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,   256,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,    -1,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,   451,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,   461,   462,   463,
     464,    -1,    -1,   467,    -1,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,    -1,    -1,    -1,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,   502,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,   134,   135,    -1,   137,   138,   139,
     140,   141,    -1,    -1,   144,   145,   146,   147,   148,   149,
     150,    -1,   152,   153,   154,   155,   156,   157,    -1,   159,
     160,   161,   162,   163,    -1,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,    -1,   184,   185,   186,   187,   188,    -1,
     190,   191,   192,    -1,    -1,   195,   196,   197,   198,   199,
      -1,   201,   202,   203,    -1,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,    -1,   217,    -1,   219,
     220,   221,    -1,   223,    -1,   225,   226,    -1,   228,   229,
     230,   231,    -1,   233,   234,    -1,   236,    -1,   238,   239,
     240,   241,   242,   243,   244,   245,   246,    -1,   248,   249,
     250,   251,   252,   253,    -1,   255,   256,   257,    -1,   259,
     260,   261,    -1,   263,    -1,   265,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,    -1,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,    -1,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,    -1,   327,    -1,   329,
     330,   331,   332,    -1,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,    -1,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,    -1,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,    -1,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,    -1,
     420,   421,    -1,   423,   424,   425,   426,   427,   428,    -1,
     430,   431,    -1,    -1,   434,   435,   436,   437,    -1,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,   453,   454,   455,   456,   457,   458,    -1,
     460,   461,   462,   463,   464,    -1,    -1,   467,    -1,    -1,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,    -1,    -1,    -1,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,   502,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    43,    44,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,   135,
      -1,   137,   138,   139,   140,   141,    -1,    -1,   144,   145,
     146,   147,   148,   149,   150,    -1,   152,   153,   154,   155,
     156,   157,    -1,   159,   160,   161,   162,   163,    -1,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
      -1,   217,    -1,   219,   220,   221,    -1,   223,    -1,   225,
     226,    -1,   228,   229,   230,   231,    -1,   233,   234,    -1,
     236,    -1,   238,   239,   240,   241,   242,   243,   244,   245,
     246,    -1,   248,   249,   250,   251,   252,   253,    -1,   255,
     256,   257,    -1,   259,   260,   261,    -1,   263,    -1,   265,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,    -1,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,    -1,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
      -1,   327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,    -1,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,    -1,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,    -1,   420,   421,    -1,   423,   424,   425,
     426,   427,   428,    -1,   430,   431,    -1,    -1,   434,   435,
     436,   437,    -1,   439,   440,   441,   442,   443,   444,    -1,
      -1,   447,   448,   449,   450,   451,    -1,   453,   454,   455,
     456,   457,   458,    -1,   460,   461,   462,   463,   464,    -1,
      -1,   467,    -1,    -1,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
      -1,    -1,    -1,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,   502,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    43,    44,    45,    46,    -1,    -1,    -1,    50,    51,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,   128,    -1,    -1,   131,
     132,   133,   134,   135,    -1,   137,   138,   139,   140,   141,
      -1,    -1,   144,   145,   146,   147,   148,   149,   150,    -1,
     152,   153,   154,   155,   156,   157,    -1,   159,   160,   161,
     162,   163,    -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,    -1,   184,   185,   186,   187,   188,    -1,   190,   191,
     192,    -1,    -1,   195,   196,   197,   198,   199,    -1,   201,
     202,   203,    -1,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,    -1,   217,    -1,   219,   220,   221,
      -1,   223,    -1,   225,   226,    -1,   228,   229,   230,   231,
      -1,   233,   234,    -1,   236,    -1,   238,   239,   240,   241,
     242,   243,   244,   245,   246,    -1,   248,   249,   250,   251,
     252,   253,    -1,   255,   256,   257,    -1,   259,   260,   261,
      -1,   263,    -1,   265,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,    -1,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,    -1,   327,    -1,    -1,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,    -1,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,    -1,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,   403,   404,   405,    -1,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,    -1,   420,   421,
      -1,   423,   424,   425,   426,   427,   428,    -1,   430,   431,
      -1,    -1,   434,   435,   436,   437,    -1,   439,   440,   441,
     442,   443,   444,    -1,    -1,   447,   448,   449,   450,    -1,
      -1,   453,   454,   455,   456,   457,   458,    -1,   460,   461,
     462,   463,   464,    -1,    -1,   467,    -1,    -1,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,    -1,    -1,    -1,    -1,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
     502,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
     108,    -1,   110,   111,    -1,   113,    -1,   115,   116,   117,
     118,   119,    -1,   121,   122,    -1,   124,   125,   126,   127,
     128,    -1,    -1,   131,   132,   133,   134,   135,    -1,   137,
     138,   139,   140,   141,    -1,    -1,   144,   145,   146,   147,
      -1,   149,   150,    -1,   152,   153,   154,   155,   156,   157,
      -1,   159,   160,   161,   162,   163,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,    -1,   217,
      -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,    -1,
     228,   229,   230,   231,    -1,   233,   234,    -1,   236,    -1,
     238,   239,   240,   241,   242,    -1,   244,   245,   246,    -1,
     248,   249,   250,   251,   252,   253,    -1,   255,   256,   257,
      -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,   267,
      -1,    -1,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,    -1,    -1,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,    -1,   315,   316,    -1,
     318,    -1,   320,   321,   322,   323,   324,   325,    -1,   327,
      -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,    -1,
      -1,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,    -1,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,    -1,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,    -1,   404,   405,    -1,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,    -1,   420,   421,    -1,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,    -1,    -1,   434,   435,   436,   437,
      -1,   439,   440,   441,   442,   443,   444,    -1,    -1,   447,
     448,   449,   450,    -1,    -1,   453,   454,   455,   456,   457,
     458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,   467,
      -1,    -1,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,    -1,    -1,
      -1,    -1,    -1,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,   503,    19,    20,    21,    22,
      23,    24,    -1,    26,    27,    28,    -1,    -1,    31,    32,
      33,    34,    -1,    -1,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,
      -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,    72,
      -1,    -1,    75,    76,    77,    78,    79,    80,    81,    82,
      -1,    -1,    -1,    86,    -1,    -1,    -1,    -1,    91,    92,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,
     113,    -1,   115,   116,   117,   118,   119,    -1,   121,   122,
      -1,   124,   125,   126,   127,   128,    -1,    -1,   131,   132,
     133,   134,   135,    -1,   137,   138,   139,   140,   141,    -1,
      -1,   144,   145,   146,   147,    -1,   149,   150,    -1,   152,
     153,   154,   155,   156,   157,    -1,   159,   160,   161,    -1,
     163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,
     173,   174,   175,   176,   177,   178,   179,   180,    -1,   182,
      -1,   184,   185,   186,   187,   188,    -1,   190,   191,   192,
      -1,    -1,   195,   196,   197,   198,   199,    -1,   201,   202,
     203,    -1,   205,   206,    -1,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,    -1,   219,   220,   221,    -1,
     223,    -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,
     233,   234,    -1,   236,    -1,   238,   239,   240,   241,   242,
      -1,   244,   245,   246,    -1,   248,   249,   250,   251,   252,
     253,    -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,
     263,    -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,    -1,   279,    -1,   281,    -1,
      -1,   284,   285,   286,    -1,    -1,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
      -1,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,    -1,   315,   316,    -1,   318,    -1,   320,   321,   322,
     323,   324,   325,    -1,   327,   328,    -1,   330,   331,   332,
      -1,    -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,    -1,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,    -1,   399,   400,   401,   402,
      -1,   404,   405,    -1,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,    -1,   420,   421,    -1,
     423,   424,   425,   426,   427,   428,    -1,   430,   431,    -1,
      -1,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,
     453,   454,   455,   456,   457,   458,    -1,   460,    -1,   462,
     463,   464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     493,   494,   495,    -1,    -1,    -1,    -1,    -1,    -1,   502,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    -1,    -1,    -1,
      86,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,
     116,   117,   118,   119,    -1,   121,   122,    -1,   124,   125,
     126,   127,   128,    -1,    -1,   131,   132,   133,   134,   135,
      -1,   137,   138,   139,   140,   141,    -1,    -1,   144,   145,
     146,   147,    -1,   149,   150,    -1,   152,   153,   154,   155,
     156,   157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
      -1,   217,    -1,   219,   220,   221,    -1,   223,    -1,   225,
      -1,    -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,
     236,    -1,   238,   239,   240,   241,   242,    -1,   244,   245,
     246,    -1,   248,   249,   250,   251,   252,   253,    -1,   255,
      -1,   257,    -1,   259,   260,   261,    -1,   263,    -1,   265,
      -1,   267,    -1,    -1,   270,    -1,   272,   273,   274,   275,
     276,   277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,    -1,   315,
     316,    -1,   318,    -1,   320,   321,   322,   323,   324,   325,
      -1,   327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,
      -1,    -1,    -1,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,    -1,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,    -1,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,    -1,   399,   400,   401,   402,    -1,   404,   405,
      -1,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,    -1,   420,   421,    -1,   423,   424,   425,
     426,   427,   428,    -1,   430,   431,    -1,    -1,   434,   435,
     436,   437,    -1,   439,   440,   441,   442,   443,   444,    -1,
      -1,   447,   448,   449,   450,    -1,    -1,   453,   454,   455,
     456,   457,   458,    -1,   460,    -1,   462,   463,   464,    -1,
      -1,   467,    -1,    -1,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
      -1,    -1,    -1,    -1,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,   501,   502,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    45,    46,    -1,    -1,    -1,    50,    51,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,   104,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,   113,    -1,   115,   116,   117,   118,   119,    -1,   121,
     122,    -1,   124,   125,   126,   127,   128,    -1,    -1,   131,
     132,   133,   134,   135,    -1,   137,   138,   139,   140,   141,
      -1,    -1,   144,   145,   146,   147,    -1,   149,   150,    -1,
     152,   153,   154,   155,   156,   157,    -1,   159,   160,   161,
      -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,    -1,   184,   185,   186,   187,   188,    -1,   190,   191,
     192,    -1,    -1,   195,   196,   197,   198,   199,    -1,   201,
     202,   203,    -1,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,    -1,   217,    -1,   219,   220,   221,
      -1,   223,    -1,   225,    -1,    -1,    -1,   229,   230,   231,
      -1,   233,   234,    -1,   236,    -1,   238,   239,   240,   241,
     242,    -1,   244,   245,   246,    -1,   248,   249,   250,   251,
     252,   253,    -1,   255,    -1,   257,    -1,   259,   260,   261,
      -1,   263,    -1,   265,    -1,   267,    -1,    -1,   270,    -1,
     272,   273,   274,   275,   276,   277,    -1,   279,    -1,   281,
      -1,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,    -1,   315,   316,    -1,   318,    -1,   320,   321,
     322,   323,   324,   325,    -1,   327,    -1,    -1,   330,   331,
     332,    -1,    -1,   335,    -1,    -1,    -1,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,    -1,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,    -1,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,    -1,   404,   405,    -1,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,    -1,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,   431,
      -1,    -1,   434,   435,   436,   437,    -1,   439,   440,   441,
     442,   443,   444,    -1,    -1,   447,   448,   449,   450,    -1,
      -1,   453,   454,   455,   456,   457,   458,    -1,   460,   461,
     462,   463,   464,    -1,    -1,   467,    -1,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,    -1,    -1,    -1,    -1,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
     502,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    -1,    -1,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    -1,    -1,    -1,    86,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,   117,
     118,   119,    -1,   121,   122,    -1,   124,   125,   126,   127,
     128,    -1,    -1,   131,   132,   133,   134,   135,    -1,   137,
     138,   139,   140,   141,    -1,    -1,   144,   145,   146,   147,
      -1,   149,   150,    -1,   152,   153,   154,   155,   156,   157,
      -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,    -1,   217,
      -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,    -1,
      -1,   229,   230,   231,    -1,   233,   234,    -1,   236,    -1,
     238,   239,   240,   241,   242,    -1,   244,   245,   246,    -1,
     248,   249,   250,   251,   252,   253,    -1,   255,    -1,   257,
      -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,   267,
      -1,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
      -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,    -1,   315,   316,    -1,
     318,    -1,   320,   321,   322,   323,   324,   325,    -1,   327,
      -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,    -1,
      -1,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,    -1,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,    -1,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,    -1,   404,   405,    -1,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,    -1,   420,   421,    -1,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,    -1,    -1,   434,   435,   436,   437,
      -1,   439,   440,   441,   442,   443,   444,    -1,    -1,   447,
     448,   449,   450,    -1,    -1,   453,   454,   455,   456,   457,
     458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,   467,
      -1,    -1,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,    -1,    -1,
      -1,    -1,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,   502,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,    -1,    -1,    -1,    -1,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,   502,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,   113,    -1,   115,   116,   117,   118,   119,
      -1,   121,   122,    -1,   124,   125,   126,   127,   128,    -1,
      -1,   131,   132,   133,   134,   135,    -1,   137,   138,   139,
     140,   141,    -1,    -1,   144,   145,   146,   147,    -1,   149,
     150,    -1,   152,   153,   154,   155,   156,   157,    -1,   159,
     160,   161,    -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,    -1,   184,   185,   186,   187,   188,    -1,
     190,   191,   192,    -1,    -1,   195,   196,   197,   198,   199,
      -1,   201,   202,   203,    -1,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,    -1,   217,    -1,   219,
     220,   221,    -1,   223,    -1,   225,    -1,    -1,    -1,   229,
     230,   231,    -1,   233,   234,    -1,   236,    -1,   238,   239,
     240,   241,   242,    -1,   244,   245,   246,    -1,   248,   249,
     250,   251,   252,   253,    -1,   255,    -1,   257,    -1,   259,
     260,   261,    -1,   263,    -1,   265,    -1,   267,    -1,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,    -1,   279,
      -1,   281,    -1,    -1,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,    -1,   315,   316,    -1,   318,    -1,
     320,   321,   322,   323,   324,   325,    -1,   327,    -1,    -1,
     330,   331,   332,    -1,    -1,   335,    -1,    -1,    -1,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,    -1,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,    -1,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,    -1,   404,   405,    -1,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,    -1,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,   431,    -1,    -1,   434,   435,   436,   437,    -1,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,    -1,    -1,   453,   454,   455,   456,   457,   458,    -1,
     460,    -1,   462,   463,   464,    -1,    -1,   467,    -1,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,    -1,    -1,    -1,    -1,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,   502,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,
     116,   117,   118,   119,    -1,   121,   122,    -1,   124,   125,
     126,   127,   128,    -1,    -1,   131,   132,   133,   134,   135,
      -1,   137,   138,   139,   140,   141,    -1,    -1,   144,   145,
     146,   147,    -1,   149,   150,    -1,   152,   153,   154,   155,
     156,   157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
      -1,   217,    -1,   219,   220,   221,    -1,   223,    -1,   225,
      -1,    -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,
     236,    -1,   238,   239,   240,   241,   242,    -1,   244,   245,
     246,    -1,   248,   249,   250,   251,   252,   253,    -1,   255,
      -1,   257,    -1,   259,   260,   261,    -1,   263,    -1,   265,
      -1,   267,    -1,    -1,   270,    -1,   272,   273,   274,   275,
     276,   277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,    -1,   315,
     316,    -1,   318,    -1,   320,   321,   322,   323,   324,   325,
      -1,   327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,
      -1,    -1,    -1,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,    -1,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,    -1,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,    -1,   399,   400,   401,   402,    -1,   404,   405,
      -1,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,    -1,   420,   421,    -1,   423,   424,   425,
     426,   427,   428,    -1,   430,   431,    -1,    -1,   434,   435,
     436,   437,    -1,   439,   440,   441,   442,   443,   444,    -1,
      -1,   447,   448,   449,   450,    -1,    -1,   453,   454,   455,
     456,   457,   458,    -1,   460,    -1,   462,   463,   464,    -1,
      -1,   467,    -1,    -1,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
      -1,    -1,    -1,    -1,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,   502,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    45,    46,    -1,    -1,    -1,    50,    51,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,   113,    -1,   115,   116,   117,   118,   119,    -1,   121,
     122,    -1,   124,   125,   126,   127,   128,    -1,    -1,   131,
     132,   133,   134,   135,    -1,   137,   138,   139,   140,   141,
      -1,    -1,   144,   145,   146,   147,    -1,   149,   150,    -1,
     152,   153,   154,   155,   156,   157,    -1,   159,   160,   161,
      -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,    -1,   184,   185,   186,   187,   188,    -1,   190,   191,
     192,    -1,    -1,   195,   196,   197,   198,   199,    -1,   201,
     202,   203,    -1,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,    -1,   217,    -1,   219,   220,   221,
      -1,   223,    -1,   225,    -1,    -1,    -1,   229,   230,   231,
      -1,   233,   234,    -1,   236,    -1,   238,   239,   240,   241,
     242,    -1,   244,   245,   246,    -1,   248,   249,   250,   251,
     252,   253,    -1,   255,    -1,   257,    -1,   259,   260,   261,
      -1,   263,    -1,   265,    -1,   267,    -1,    -1,   270,    -1,
     272,   273,   274,   275,   276,   277,    -1,   279,    -1,   281,
      -1,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,    -1,   315,   316,    -1,   318,    -1,   320,   321,
     322,   323,   324,   325,    -1,   327,    -1,    -1,   330,   331,
     332,    -1,    -1,   335,    -1,    -1,    -1,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,    -1,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,    -1,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,    -1,   404,   405,    -1,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,    -1,   420,   421,
      -1,   423,   424,   425,   426,   427,   428,    -1,   430,   431,
      -1,    -1,   434,   435,   436,   437,    -1,   439,   440,   441,
     442,   443,   444,    -1,    -1,   447,   448,   449,   450,    -1,
      -1,   453,   454,   455,   456,   457,   458,    -1,   460,    -1,
     462,   463,   464,    -1,    -1,   467,    -1,    -1,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,    -1,    -1,    -1,    -1,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
     502,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,   117,
     118,   119,    -1,   121,   122,    -1,   124,   125,   126,   127,
     128,    -1,    -1,   131,   132,   133,   134,   135,    -1,   137,
     138,   139,   140,   141,    -1,    -1,   144,   145,   146,   147,
      -1,   149,   150,    -1,   152,   153,   154,   155,   156,   157,
      -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,    -1,   217,
      -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,    -1,
      -1,   229,   230,   231,    -1,   233,   234,    -1,   236,    -1,
     238,   239,   240,   241,   242,    -1,   244,   245,   246,    -1,
     248,   249,   250,   251,   252,   253,    -1,   255,    -1,   257,
      -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,   267,
      -1,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
      -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,    -1,   315,   316,    -1,
     318,    -1,   320,   321,   322,   323,   324,   325,    -1,   327,
      -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,    -1,
      -1,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,    -1,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,    -1,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,    -1,   404,   405,    -1,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,    -1,   420,   421,    -1,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,    -1,    -1,   434,   435,   436,   437,
      -1,   439,   440,   441,   442,   443,   444,    -1,    -1,   447,
     448,   449,   450,    -1,    -1,   453,   454,   455,   456,   457,
     458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,   467,
      -1,    -1,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,    -1,    -1,
      -1,    -1,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,   502,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,    -1,    -1,    -1,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,   502,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    72,    -1,    -1,    75,    76,    77,    78,    79,
      80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,    -1,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,    -1,   213,   214,    -1,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,    -1,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,   345,   346,   347,    -1,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,    -1,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,   433,   434,    -1,   436,    -1,   438,   439,
     440,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   483,   484,   485,    -1,    -1,    -1,   489,
     490,   491,    -1,   493,   494,   495,   496,   497,   498,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    85,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,    -1,
      -1,    -1,   489,   490,   491,    -1,   493,   494,   495,   496,
     497,   498,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    85,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,    -1,    -1,    -1,   489,   490,   491,    -1,   493,
     494,   495,   496,   497,   498,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    -1,    26,    27,    28,    -1,    -1,
      31,    32,    33,    34,    -1,    -1,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    45,    46,    -1,    -1,    -1,    50,
      51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,
      71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,
      -1,    -1,    -1,    -1,    85,    -1,    -1,    -1,    -1,    -1,
      91,    92,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,    -1,   113,    -1,   115,   116,   117,   118,   119,    -1,
     121,   122,    -1,   124,   125,   126,   127,   128,    -1,    -1,
     131,   132,   133,   134,   135,    -1,   137,   138,   139,   140,
     141,    -1,    -1,   144,   145,   146,   147,    -1,   149,   150,
      -1,   152,   153,   154,   155,   156,   157,    -1,   159,   160,
     161,    -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   172,   173,   174,   175,   176,   177,   178,   179,   180,
      -1,   182,    -1,   184,   185,   186,   187,   188,    -1,   190,
     191,   192,    -1,    -1,   195,   196,   197,   198,   199,    -1,
     201,   202,   203,    -1,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,    -1,   217,    -1,   219,   220,
     221,    -1,   223,    -1,   225,    -1,    -1,    -1,   229,   230,
     231,    -1,   233,   234,    -1,   236,    -1,   238,   239,   240,
     241,   242,    -1,   244,   245,   246,    -1,   248,   249,   250,
     251,   252,   253,    -1,   255,    -1,   257,    -1,   259,   260,
     261,    -1,   263,    -1,   265,    -1,   267,    -1,    -1,   270,
      -1,   272,   273,   274,   275,   276,   277,    -1,   279,    -1,
     281,    -1,    -1,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,    -1,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,    -1,   315,   316,    -1,   318,    -1,   320,
     321,   322,   323,   324,   325,    -1,   327,    -1,    -1,   330,
     331,   332,    -1,    -1,   335,    -1,    -1,    -1,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,    -1,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,    -1,   404,   405,    -1,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,    -1,   420,
     421,    -1,   423,   424,   425,   426,   427,   428,    -1,   430,
     431,    -1,    -1,   434,   435,   436,   437,    -1,   439,   440,
     441,   442,   443,   444,    -1,    -1,   447,   448,   449,   450,
      -1,    -1,   453,   454,   455,   456,   457,   458,    -1,   460,
      -1,   462,   463,   464,    -1,    -1,   467,    -1,    -1,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,    -1,    -1,    -1,   489,   490,
     491,    -1,   493,   494,   495,   496,   497,   498,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    85,    -1,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,   117,
     118,   119,    -1,   121,   122,    -1,   124,   125,   126,   127,
     128,    -1,    -1,   131,   132,   133,   134,   135,    -1,   137,
     138,   139,   140,   141,    -1,    -1,   144,   145,   146,   147,
      -1,   149,   150,    -1,   152,   153,   154,   155,   156,   157,
      -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,    -1,   217,
      -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,    -1,
      -1,   229,   230,   231,    -1,   233,   234,    -1,   236,    -1,
     238,   239,   240,   241,   242,    -1,   244,   245,   246,    -1,
     248,   249,   250,   251,   252,   253,    -1,   255,    -1,   257,
      -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,   267,
      -1,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
      -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,    -1,   315,   316,    -1,
     318,    -1,   320,   321,   322,   323,   324,   325,    -1,   327,
      -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,    -1,
      -1,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,    -1,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,    -1,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,    -1,   404,   405,    -1,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,    -1,   420,   421,    -1,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,    -1,    -1,   434,   435,   436,   437,
      -1,   439,   440,   441,   442,   443,   444,    -1,    -1,   447,
     448,   449,   450,    -1,    -1,   453,   454,   455,   456,   457,
     458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,   467,
      -1,    -1,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,    -1,    -1,
      -1,   489,   490,   491,    -1,   493,   494,   495,   496,   497,
     498,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      -1,    26,    27,    28,    -1,    -1,    31,    32,    33,    34,
      -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,
      -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,
      85,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,    -1,
     115,   116,   117,   118,   119,    -1,   121,   122,    -1,   124,
     125,   126,   127,   128,    -1,    -1,   131,   132,   133,   134,
     135,    -1,   137,   138,   139,   140,   141,    -1,    -1,   144,
     145,   146,   147,    -1,   149,   150,    -1,   152,   153,   154,
     155,   156,   157,    -1,   159,   160,   161,    -1,   163,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,
     175,   176,   177,   178,   179,   180,    -1,   182,    -1,   184,
     185,   186,   187,   188,    -1,   190,   191,   192,    -1,    -1,
     195,   196,   197,   198,   199,    -1,   201,   202,   203,    -1,
     205,   206,    -1,   208,   209,   210,   211,   212,   213,   214,
     215,    -1,   217,    -1,   219,   220,   221,    -1,   223,    -1,
     225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,   234,
      -1,   236,    -1,   238,   239,   240,   241,   242,    -1,   244,
     245,   246,    -1,   248,   249,   250,   251,   252,   253,    -1,
     255,    -1,   257,    -1,   259,   260,   261,    -1,   263,    -1,
     265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,   274,
     275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,   284,
     285,   286,    -1,    -1,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,    -1,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,    -1,
     315,   316,    -1,   318,    -1,   320,   321,   322,   323,   324,
     325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,    -1,
     335,    -1,    -1,    -1,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,    -1,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,    -1,   404,
     405,    -1,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,    -1,   420,   421,    -1,   423,   424,
     425,   426,   427,   428,    -1,   430,   431,    -1,    -1,   434,
     435,   436,   437,    -1,   439,   440,   441,   442,   443,   444,
      -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,   454,
     455,   456,   457,   458,    -1,   460,    -1,   462,   463,   464,
      -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,    -1,    -1,    -1,   489,   490,   491,    -1,   493,   494,
     495,   496,   497,   498,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    45,    46,    -1,    -1,    -1,    50,    51,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      -1,    -1,    -1,    85,    -1,    -1,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,   113,    -1,   115,   116,   117,   118,   119,    -1,   121,
     122,    -1,   124,   125,   126,   127,   128,    -1,    -1,   131,
     132,   133,   134,   135,    -1,   137,   138,   139,   140,   141,
      -1,    -1,   144,   145,   146,   147,    -1,   149,   150,    -1,
     152,   153,   154,   155,   156,   157,    -1,   159,   160,   161,
      -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,    -1,   184,   185,   186,   187,   188,    -1,   190,   191,
     192,    -1,    -1,   195,   196,   197,   198,   199,    -1,   201,
     202,   203,    -1,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,    -1,   217,    -1,   219,   220,   221,
      -1,   223,    -1,   225,    -1,    -1,    -1,   229,   230,   231,
      -1,   233,   234,    -1,   236,    -1,   238,   239,   240,   241,
     242,    -1,   244,   245,   246,    -1,   248,   249,   250,   251,
     252,   253,    -1,   255,    -1,   257,    -1,   259,   260,   261,
      -1,   263,    -1,   265,    -1,   267,    -1,    -1,   270,    -1,
     272,   273,   274,   275,   276,   277,    -1,   279,    -1,   281,
      -1,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,    -1,   315,   316,    -1,   318,    -1,   320,   321,
     322,   323,   324,   325,    -1,   327,    -1,    -1,   330,   331,
     332,    -1,    -1,   335,    -1,    -1,    -1,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,    -1,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,    -1,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,    -1,   404,   405,    -1,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,    -1,   420,   421,
      -1,   423,   424,   425,   426,   427,   428,    -1,   430,   431,
      -1,    -1,   434,   435,   436,   437,    -1,   439,   440,   441,
     442,   443,   444,    -1,    -1,   447,   448,   449,   450,    -1,
      -1,   453,   454,   455,   456,   457,   458,    -1,   460,    -1,
     462,   463,   464,    -1,    -1,   467,    -1,    -1,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,    -1,    -1,    -1,   489,   490,   491,
      -1,   493,   494,   495,   496,   497,   498,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    43,    44,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,     5,     6,
       7,     8,     9,    10,    11,    12,    13,   495,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    43,    44,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,   114,   115,   116,
     117,    -1,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,    -1,    -1,    -1,   144,   145,   146,
     147,   148,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,   162,   163,    -1,    -1,    -1,
      -1,   168,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,    -1,   213,   214,    -1,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,   226,
      -1,   228,   229,   230,   231,    -1,   233,    -1,    -1,   236,
      -1,   238,   239,   240,   241,   242,   243,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,    -1,   265,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,    -1,    -1,   280,   281,   282,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,    -1,   313,    -1,   315,   316,
     317,   318,    -1,    -1,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,    -1,   336,
     337,   338,    -1,   340,   341,   342,   343,   344,   345,    -1,
     347,    -1,   349,    -1,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,   403,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
      -1,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,    -1,   436,
      -1,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
      -1,   458,    -1,   460,   461,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   483,   484,   485,    -1,
       6,     7,     8,     9,    10,    11,    12,    13,   495,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,
     116,   117,   118,   119,    -1,   121,   122,    -1,   124,   125,
     126,   127,   128,    -1,    -1,   131,   132,   133,   134,   135,
      -1,   137,   138,   139,   140,   141,    -1,    -1,   144,   145,
     146,   147,    -1,   149,   150,    -1,   152,   153,   154,   155,
     156,   157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
      -1,   217,    -1,   219,   220,   221,    -1,   223,    -1,   225,
      -1,    -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,
     236,    -1,   238,   239,   240,   241,   242,    -1,   244,   245,
     246,    -1,   248,   249,   250,   251,   252,   253,    -1,   255,
      -1,   257,    -1,   259,   260,   261,    -1,   263,    -1,   265,
      -1,   267,    -1,    -1,   270,    -1,   272,   273,   274,   275,
     276,   277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,    -1,   315,
     316,    -1,   318,    -1,   320,   321,   322,   323,   324,   325,
      -1,   327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,
      -1,    -1,    -1,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,    -1,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,    -1,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,    -1,   399,   400,   401,   402,    -1,   404,   405,
      -1,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,    -1,   420,   421,    -1,   423,   424,   425,
     426,   427,   428,    -1,   430,   431,    -1,    -1,   434,   435,
     436,   437,    -1,   439,   440,   441,   442,   443,   444,    -1,
      -1,   447,   448,   449,   450,    -1,    -1,   453,   454,   455,
     456,   457,   458,    -1,   460,    -1,   462,   463,   464,    -1,
      -1,   467,    -1,    -1,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
      -1,     6,     7,     8,     9,    10,    11,    12,    13,   495,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      -1,    26,    27,    28,    -1,    -1,    31,    32,    33,    34,
      -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,
      -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,    -1,
     115,   116,   117,   118,   119,    -1,   121,   122,    -1,   124,
     125,   126,   127,   128,    -1,    -1,   131,   132,   133,   134,
     135,    -1,   137,   138,   139,   140,   141,    -1,    -1,   144,
     145,   146,   147,    -1,   149,   150,    -1,   152,   153,   154,
     155,   156,   157,    -1,   159,   160,   161,    -1,   163,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,
     175,   176,   177,   178,   179,   180,    -1,   182,    -1,   184,
     185,   186,   187,   188,    -1,   190,   191,   192,    -1,    -1,
     195,   196,   197,   198,   199,    -1,   201,   202,   203,    -1,
     205,   206,    -1,   208,   209,   210,   211,   212,   213,   214,
     215,    -1,   217,    -1,   219,   220,   221,    -1,   223,    -1,
     225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,   234,
      -1,   236,    -1,   238,   239,   240,   241,   242,    -1,   244,
     245,   246,    -1,   248,   249,   250,   251,   252,   253,    -1,
     255,    -1,   257,    -1,   259,   260,   261,    -1,   263,    -1,
     265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,   274,
     275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,   284,
     285,   286,    -1,    -1,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,    -1,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,    -1,
     315,   316,    -1,   318,    -1,   320,   321,   322,   323,   324,
     325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,    -1,
     335,    -1,    -1,    -1,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,    -1,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,    -1,   404,
     405,    -1,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,    -1,   420,   421,    -1,   423,   424,
     425,   426,   427,   428,    -1,   430,   431,    -1,    -1,   434,
     435,   436,   437,    -1,   439,   440,   441,   442,   443,   444,
      -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,   454,
     455,   456,   457,   458,    -1,   460,    -1,   462,   463,   464,
      -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,    -1,     6,     7,     8,     9,    10,    11,    12,    13,
     495,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    75,    76,    77,    78,    79,    80,    81,    82,    -1,
      -1,    -1,    86,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,   328,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,
     494,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      -1,    26,    27,    28,    -1,    -1,    31,    32,    33,    34,
      -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,
      -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    -1,    67,    -1,    69,    70,    71,    72,    -1,    -1,
      75,    76,    77,    78,    79,    80,    81,    82,    -1,    -1,
      -1,    86,    -1,    -1,    -1,    -1,    91,    92,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,    -1,
     115,   116,   117,   118,   119,    -1,   121,   122,    -1,   124,
     125,   126,   127,   128,    -1,    -1,   131,   132,   133,   134,
     135,    -1,   137,   138,   139,   140,   141,    -1,    -1,   144,
     145,   146,   147,    -1,   149,   150,    -1,   152,   153,   154,
     155,   156,   157,    -1,   159,   160,   161,    -1,   163,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,    -1,   184,
     185,   186,   187,   188,    -1,   190,   191,   192,    -1,    -1,
     195,   196,   197,   198,   199,    -1,   201,   202,   203,    -1,
     205,   206,    -1,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,    -1,   219,   220,   221,    -1,   223,    -1,
     225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,   234,
      -1,   236,    -1,   238,   239,   240,   241,   242,    -1,   244,
     245,   246,    -1,   248,   249,   250,   251,   252,   253,    -1,
     255,    -1,   257,    -1,   259,   260,   261,    -1,   263,    -1,
     265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,   274,
     275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,   284,
     285,   286,    -1,    -1,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,    -1,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,    -1,
     315,   316,    -1,   318,    -1,   320,   321,   322,   323,   324,
     325,    -1,   327,   328,    -1,   330,   331,   332,    -1,    -1,
     335,    -1,    -1,    -1,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,    -1,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,    -1,   404,
     405,    -1,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,    -1,   420,   421,    -1,   423,   424,
     425,   426,   427,   428,    -1,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
      -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,   454,
     455,   456,   457,   458,    -1,   460,    -1,   462,   463,   464,
      -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,   494,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    72,    -1,    -1,    75,
      76,    77,    78,    79,    80,    81,    82,    -1,    -1,    -1,
      86,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,
     116,   117,   118,   119,    -1,   121,   122,    -1,   124,   125,
     126,   127,   128,    -1,    -1,   131,   132,   133,   134,   135,
      -1,   137,   138,   139,   140,   141,    -1,    -1,   144,   145,
     146,   147,    -1,   149,   150,    -1,   152,   153,   154,   155,
     156,   157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,    -1,   219,   220,   221,    -1,   223,    -1,   225,
      -1,    -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,
     236,    -1,   238,   239,   240,   241,   242,    -1,   244,   245,
     246,    -1,   248,   249,   250,   251,   252,   253,    -1,   255,
      -1,   257,    -1,   259,   260,   261,    -1,   263,    -1,   265,
      -1,   267,    -1,    -1,   270,    -1,   272,   273,   274,   275,
     276,   277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,    -1,   315,
     316,    -1,   318,    -1,   320,   321,   322,   323,   324,   325,
      -1,   327,   328,    -1,   330,   331,   332,    -1,    -1,   335,
      -1,    -1,    -1,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,    -1,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,    -1,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,    -1,   399,   400,   401,   402,    -1,   404,   405,
      -1,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,    -1,   420,   421,    -1,   423,   424,   425,
     426,   427,   428,    -1,   430,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,    -1,
      -1,   447,   448,   449,   450,    -1,    -1,   453,   454,   455,
     456,   457,   458,    -1,   460,    -1,   462,   463,   464,    -1,
      -1,   467,    -1,    -1,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,   494,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    72,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    86,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
     227,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   493,   494,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    72,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    86,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,   117,
     118,   119,    -1,   121,   122,    -1,   124,   125,   126,   127,
     128,    -1,    -1,   131,   132,   133,   134,   135,    -1,   137,
     138,   139,   140,   141,    -1,    -1,   144,   145,   146,   147,
      -1,   149,   150,    -1,   152,   153,   154,   155,   156,   157,
      -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,    -1,   217,
      -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,   227,
      -1,   229,   230,   231,    -1,   233,   234,    -1,   236,    -1,
     238,   239,   240,   241,   242,    -1,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,    -1,   255,    -1,   257,
      -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,   267,
      -1,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
      -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,    -1,   315,   316,    -1,
     318,    -1,   320,   321,   322,   323,   324,   325,    -1,   327,
      -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,    -1,
      -1,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,    -1,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,    -1,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,    -1,   404,   405,    -1,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,    -1,   420,   421,    -1,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,    -1,    -1,   434,   435,   436,   437,
      -1,   439,   440,   441,   442,   443,   444,    -1,    -1,   447,
     448,   449,   450,    -1,    -1,   453,   454,   455,   456,   457,
     458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,   467,
      -1,    -1,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   493,   494,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    -1,    26,    27,    28,
      -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    45,    46,    -1,    -1,
      -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,
      69,    70,    71,    72,    -1,    -1,    -1,    -1,    -1,    -1,
      79,    80,    -1,    -1,    -1,    -1,    -1,    86,    -1,    -1,
      -1,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,   113,    -1,   115,   116,   117,   118,
     119,    -1,   121,   122,    -1,   124,   125,   126,   127,   128,
      -1,    -1,   131,   132,   133,   134,   135,    -1,   137,   138,
     139,   140,   141,    -1,    -1,   144,   145,   146,   147,    -1,
     149,   150,    -1,   152,   153,   154,   155,   156,   157,    -1,
     159,   160,   161,    -1,   163,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   172,   173,   174,   175,   176,   177,   178,
     179,   180,    -1,   182,    -1,   184,   185,   186,   187,   188,
      -1,   190,   191,   192,    -1,    -1,   195,   196,   197,   198,
     199,    -1,   201,   202,   203,    -1,   205,   206,    -1,   208,
     209,   210,   211,   212,   213,   214,   215,    -1,   217,    -1,
     219,   220,   221,    -1,   223,    -1,   225,    -1,   227,    -1,
     229,   230,   231,    -1,   233,   234,    -1,   236,    -1,   238,
     239,   240,   241,   242,    -1,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,    -1,   255,    -1,   257,    -1,
     259,   260,   261,    -1,   263,    -1,   265,    -1,   267,    -1,
      -1,   270,    -1,   272,   273,   274,   275,   276,   277,    -1,
     279,    -1,   281,    -1,    -1,   284,   285,   286,    -1,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,    -1,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,    -1,   315,   316,    -1,   318,
      -1,   320,   321,   322,   323,   324,   325,    -1,   327,    -1,
      -1,   330,   331,   332,    -1,    -1,   335,    -1,    -1,    -1,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,    -1,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,    -1,   404,   405,    -1,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
      -1,   420,   421,    -1,   423,   424,   425,   426,   427,   428,
      -1,   430,   431,    -1,    -1,   434,   435,   436,   437,    -1,
     439,   440,   441,   442,   443,   444,    -1,    -1,   447,   448,
     449,   450,    -1,    -1,   453,   454,   455,   456,   457,   458,
      -1,   460,    -1,   462,   463,   464,    -1,    -1,   467,    -1,
      -1,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   493,   494,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    72,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    -1,    86,    -1,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,   113,    -1,   115,   116,   117,   118,   119,
      -1,   121,   122,    -1,   124,   125,   126,   127,   128,    -1,
      -1,   131,   132,   133,   134,   135,    -1,   137,   138,   139,
     140,   141,    -1,    -1,   144,   145,   146,   147,    -1,   149,
     150,    -1,   152,   153,   154,   155,   156,   157,    -1,   159,
     160,   161,    -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,    -1,   184,   185,   186,   187,   188,    -1,
     190,   191,   192,    -1,    -1,   195,   196,   197,   198,   199,
      -1,   201,   202,   203,    -1,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,    -1,   217,    -1,   219,
     220,   221,    -1,   223,    -1,   225,    -1,   227,    -1,   229,
     230,   231,    -1,   233,   234,    -1,   236,    -1,   238,   239,
     240,   241,   242,    -1,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,    -1,   255,    -1,   257,    -1,   259,
     260,   261,    -1,   263,    -1,   265,    -1,   267,    -1,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,    -1,   279,
      -1,   281,    -1,    -1,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,    -1,   315,   316,    -1,   318,    -1,
     320,   321,   322,   323,   324,   325,    -1,   327,    -1,    -1,
     330,   331,   332,    -1,    -1,   335,    -1,    -1,    -1,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,    -1,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,    -1,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,    -1,   404,   405,    -1,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,    -1,
     420,   421,    -1,   423,   424,   425,   426,   427,   428,    -1,
     430,   431,    -1,    -1,   434,   435,   436,   437,    -1,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,    -1,    -1,   453,   454,   455,   456,   457,   458,    -1,
     460,    -1,   462,   463,   464,    -1,    -1,   467,    -1,    -1,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   493,   494,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    -1,    26,    27,    28,    -1,    -1,
      31,    32,    33,    34,    -1,    -1,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    45,    46,    -1,    -1,    -1,    50,
      51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,
      71,    72,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      91,    92,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,    -1,   113,    -1,   115,   116,   117,   118,   119,    -1,
     121,   122,    -1,   124,   125,   126,   127,   128,    -1,    -1,
     131,   132,   133,   134,   135,    -1,   137,   138,   139,   140,
     141,    -1,    -1,   144,   145,   146,   147,    -1,   149,   150,
      -1,   152,   153,   154,   155,   156,   157,    -1,   159,   160,
     161,    -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,    -1,   184,   185,   186,   187,   188,    -1,   190,
     191,   192,    -1,    -1,   195,   196,   197,   198,   199,    -1,
     201,   202,   203,    -1,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,    -1,   217,    -1,   219,   220,
     221,    -1,   223,    -1,   225,    -1,    -1,    -1,   229,   230,
     231,    -1,   233,   234,    -1,   236,    -1,   238,   239,   240,
     241,   242,    -1,   244,   245,   246,    -1,   248,   249,   250,
     251,   252,   253,    -1,   255,    -1,   257,    -1,   259,   260,
     261,    -1,   263,    -1,   265,    -1,   267,    -1,    -1,   270,
      -1,   272,   273,   274,   275,   276,   277,    -1,   279,    -1,
     281,    -1,    -1,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,    -1,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,    -1,   315,   316,    -1,   318,    -1,   320,
     321,   322,   323,   324,   325,    -1,   327,    -1,    -1,   330,
     331,   332,    -1,    -1,   335,    -1,    -1,    -1,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,    -1,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,    -1,   404,   405,    -1,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,    -1,   420,
     421,    -1,   423,   424,   425,   426,   427,   428,    -1,   430,
     431,   432,    -1,   434,   435,   436,   437,    -1,   439,   440,
     441,   442,   443,   444,    -1,    -1,   447,   448,   449,   450,
      -1,    -1,   453,   454,   455,   456,   457,   458,    -1,   460,
      -1,   462,   463,   464,    -1,    -1,   467,    -1,    -1,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,    -1,    -1,     4,   489,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    43,    44,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    43,    44,
      45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,
      -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,   148,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,   162,   163,
      -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,   226,    -1,   228,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,   243,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,   256,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,   403,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,   461,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      43,    44,    45,    46,    -1,    -1,    -1,    50,    51,    -1,
      -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,   128,    -1,    -1,   131,   132,
     133,   134,   135,    -1,   137,   138,   139,   140,   141,    -1,
      -1,   144,   145,   146,   147,   148,   149,   150,    -1,   152,
     153,   154,   155,   156,   157,    -1,   159,   160,   161,   162,
     163,    -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,   172,
     173,   174,   175,   176,   177,   178,   179,   180,    -1,   182,
      -1,   184,   185,   186,   187,   188,    -1,   190,   191,   192,
      -1,    -1,   195,   196,   197,   198,   199,    -1,   201,   202,
     203,    -1,   205,   206,    -1,   208,   209,   210,   211,   212,
     213,   214,   215,    -1,   217,    -1,   219,   220,   221,    -1,
     223,    -1,   225,   226,    -1,   228,   229,   230,   231,    -1,
     233,   234,    -1,   236,    -1,   238,   239,   240,   241,   242,
     243,   244,   245,   246,    -1,   248,   249,   250,   251,   252,
     253,    -1,   255,   256,   257,    -1,   259,   260,   261,    -1,
     263,    -1,   265,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
      -1,   284,   285,   286,    -1,    -1,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,    -1,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,   325,    -1,   327,    -1,    -1,   330,   331,   332,
      -1,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,    -1,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,    -1,   399,   400,   401,   402,
     403,   404,   405,    -1,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,    -1,   420,   421,    -1,
     423,   424,   425,   426,   427,   428,    -1,   430,   431,    -1,
      -1,   434,   435,   436,   437,    -1,   439,   440,   441,   442,
     443,   444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,
     453,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    43,    44,    45,    46,    -1,    -1,    -1,    50,    51,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,   128,    -1,    -1,   131,
     132,   133,   134,   135,    -1,   137,   138,   139,   140,   141,
      -1,    -1,   144,   145,   146,   147,   148,   149,   150,    -1,
     152,   153,   154,   155,   156,   157,    -1,   159,   160,   161,
     162,   163,    -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,    -1,   184,   185,   186,   187,   188,    -1,   190,   191,
     192,    -1,    -1,   195,   196,   197,   198,   199,    -1,   201,
     202,   203,    -1,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,    -1,   217,    -1,   219,   220,   221,
      -1,   223,    -1,   225,   226,    -1,   228,   229,   230,   231,
      -1,   233,   234,    -1,   236,    -1,   238,   239,   240,   241,
     242,   243,   244,   245,   246,    -1,   248,   249,   250,   251,
     252,   253,    -1,   255,   256,   257,    -1,   259,   260,   261,
      -1,   263,    -1,   265,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,    -1,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,    -1,   327,    -1,    -1,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,    -1,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,    -1,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,   403,   404,   405,    -1,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,    -1,   420,   421,
      -1,   423,   424,   425,   426,   427,   428,    -1,   430,   431,
      -1,    -1,   434,   435,   436,   437,    -1,   439,   440,   441,
     442,   443,   444,    -1,    -1,   447,   448,   449,   450,    -1,
      -1,   453,   454,   455,   456,   457,   458,    -1,   460,   461,
     462,   463,   464,    -1,    -1,   467,    -1,    -1,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    43,    44,    45,    46,    -1,    -1,    -1,    50,
      51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,
      71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      91,    92,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,    -1,   113,   114,   115,   116,   117,    -1,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,   128,    -1,    -1,
     131,   132,   133,   134,   135,    -1,   137,   138,   139,   140,
      -1,    -1,    -1,   144,   145,   146,   147,   148,   149,   150,
      -1,   152,   153,   154,   155,   156,   157,    -1,   159,   160,
     161,   162,   163,    -1,    -1,    -1,    -1,   168,    -1,    -1,
      -1,   172,   173,   174,   175,   176,   177,   178,   179,   180,
      -1,   182,    -1,   184,   185,   186,   187,   188,    -1,   190,
     191,   192,    -1,    -1,   195,   196,   197,   198,   199,    -1,
     201,   202,   203,    -1,   205,   206,    -1,   208,   209,   210,
     211,    -1,   213,   214,    -1,    -1,   217,    -1,   219,   220,
     221,    -1,   223,    -1,   225,   226,    -1,   228,   229,   230,
     231,    -1,   233,    -1,    -1,   236,    -1,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,    -1,   255,   256,   257,    -1,   259,   260,
     261,   262,   263,    -1,   265,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,    -1,   280,
     281,   282,    -1,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,    -1,   313,    -1,   315,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,    -1,   327,    -1,    -1,   330,
     331,   332,    -1,    -1,   335,   336,   337,   338,    -1,   340,
     341,   342,   343,   344,   345,    -1,   347,    -1,   349,    -1,
     351,   352,   353,    -1,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,    -1,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,   403,   404,   405,    -1,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,    -1,   418,    -1,   420,
     421,    -1,   423,   424,   425,   426,   427,   428,    -1,   430,
     431,    -1,    -1,   434,    -1,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,    -1,    -1,   447,   448,   449,   450,
      -1,    -1,   453,   454,   455,   456,    -1,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,   467,    -1,    -1,   470,
     471,   472,   473,   474,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   483,   484,   485,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,   128,    -1,
      -1,   131,   132,   133,   134,   135,    -1,   137,   138,   139,
     140,    -1,    -1,    -1,   144,   145,   146,   147,   148,   149,
     150,    -1,   152,   153,   154,   155,   156,   157,    -1,   159,
     160,   161,   162,   163,    -1,    -1,    -1,    -1,   168,    -1,
      -1,    -1,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,    -1,   184,   185,   186,   187,   188,    -1,
     190,   191,   192,    -1,    -1,   195,   196,   197,   198,   199,
      -1,   201,   202,   203,    -1,   205,   206,    -1,   208,   209,
     210,   211,    -1,   213,   214,    -1,    -1,   217,    -1,   219,
     220,   221,    -1,   223,    -1,   225,   226,    -1,   228,   229,
     230,   231,    -1,   233,    -1,    -1,   236,    -1,   238,   239,
     240,   241,   242,   243,   244,   245,   246,    -1,   248,   249,
     250,   251,   252,   253,    -1,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,    -1,   265,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,    -1,
     280,   281,   282,    -1,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,    -1,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,    -1,   327,    -1,    -1,
     330,   331,   332,    -1,    -1,    -1,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,   345,    -1,   347,    -1,   349,
      -1,   351,   352,   353,    -1,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,   404,   405,    -1,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,    -1,   418,    -1,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,   431,    -1,    -1,   434,    -1,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,    -1,    -1,   453,   454,   455,   456,    -1,   458,    -1,
     460,   461,   462,   463,   464,    -1,    -1,   467,    -1,    -1,
     470,   471,   472,   473,   474,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   483,   484,   485,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    45,    46,    -1,    -1,
      -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,
      69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,   113,   114,   115,   116,   117,    -1,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,   128,
      -1,    -1,   131,   132,   133,   134,   135,    -1,   137,   138,
     139,   140,    -1,    -1,    -1,   144,   145,   146,   147,   148,
     149,   150,    -1,   152,   153,   154,   155,   156,   157,    -1,
     159,   160,   161,   162,   163,    -1,    -1,    -1,    -1,   168,
      -1,    -1,    -1,   172,   173,   174,   175,   176,   177,   178,
     179,   180,    -1,   182,    -1,   184,   185,   186,   187,   188,
      -1,   190,   191,   192,    -1,    -1,   195,   196,   197,   198,
     199,    -1,   201,   202,   203,    -1,   205,   206,    -1,   208,
     209,   210,   211,    -1,   213,   214,    -1,    -1,   217,    -1,
     219,   220,   221,    -1,   223,    -1,   225,   226,    -1,   228,
     229,   230,   231,    -1,   233,    -1,    -1,   236,    -1,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,   248,
     249,   250,   251,   252,   253,    -1,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,    -1,   265,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
      -1,   280,   281,   282,    -1,   284,   285,   286,    -1,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,    -1,   315,   316,   317,   318,
      -1,    -1,   321,   322,   323,   324,   325,    -1,   327,    -1,
      -1,   330,   331,   332,    -1,    -1,    -1,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,    -1,   347,    -1,
     349,    -1,   351,   352,   353,    -1,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,    -1,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,   404,   405,    -1,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,    -1,   418,
      -1,   420,   421,    -1,   423,   424,   425,   426,   427,   428,
      -1,   430,   431,    -1,    -1,   434,    -1,   436,    -1,    -1,
     439,   440,   441,   442,   443,   444,    -1,    -1,   447,   448,
     449,   450,    -1,    -1,   453,   454,   455,   456,    -1,   458,
      -1,   460,   461,   462,   463,   464,    -1,    -1,   467,    -1,
      -1,   470,   471,   472,   473,   474,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   483,   484,   485,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    43,    44,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
     128,    -1,    -1,   131,   132,   133,   134,   135,    -1,   137,
     138,   139,   140,    -1,    -1,    -1,   144,   145,   146,   147,
     148,   149,   150,    -1,   152,   153,   154,   155,   156,   157,
      -1,   159,   160,   161,   162,   163,    -1,    -1,    -1,    -1,
     168,    -1,    -1,    -1,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,    -1,
     208,   209,   210,   211,    -1,   213,   214,    -1,    -1,   217,
      -1,   219,   220,   221,    -1,   223,    -1,   225,   226,    -1,
     228,   229,   230,   231,    -1,   233,    -1,    -1,   236,    -1,
     238,   239,   240,   241,   242,   243,   244,   245,   246,    -1,
     248,   249,   250,   251,   252,   253,    -1,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,    -1,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,    -1,   280,   281,   282,    -1,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,    -1,   315,   316,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,    -1,   327,
      -1,    -1,   330,   331,   332,    -1,    -1,    -1,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,    -1,   347,
      -1,   349,    -1,   351,   352,   353,    -1,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,   403,   404,   405,    -1,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,    -1,
     418,    -1,   420,   421,    -1,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,    -1,    -1,   434,    -1,   436,    -1,
      -1,   439,   440,   441,   442,   443,   444,    -1,    -1,   447,
     448,   449,   450,    -1,    -1,   453,   454,   455,   456,    -1,
     458,    -1,   460,   461,   462,   463,   464,    -1,    -1,   467,
      -1,    -1,   470,   471,   472,   473,   474,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   483,   484,   485,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    43,    44,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,   114,   115,   116,
     117,    -1,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,    -1,    -1,    -1,   144,   145,   146,
     147,   148,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,   162,   163,    -1,    -1,    -1,
      -1,   168,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,    -1,   213,   214,    -1,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,   226,
      -1,   228,   229,   230,   231,    -1,   233,    -1,    -1,   236,
      -1,   238,   239,   240,   241,   242,   243,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,    -1,   265,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,    -1,    -1,   280,   281,   282,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,    -1,   313,    -1,   315,   316,
     317,   318,    -1,    -1,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,    -1,   336,
     337,   338,    -1,   340,   341,   342,   343,   344,   345,    -1,
     347,    -1,   349,    -1,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,   403,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
      -1,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,    -1,   436,
      -1,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
      -1,   458,    -1,   460,   461,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   483,   484,   485,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    43,    44,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,   128,    -1,    -1,   131,   132,   133,   134,   135,
      -1,   137,   138,   139,   140,    -1,    -1,    -1,   144,   145,
     146,   147,   148,   149,   150,    -1,   152,   153,   154,   155,
     156,   157,    -1,   159,   160,   161,   162,   163,    -1,    -1,
      -1,    -1,   168,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,    -1,   208,   209,   210,   211,    -1,   213,   214,    -1,
      -1,   217,    -1,   219,   220,   221,    -1,   223,    -1,   225,
     226,    -1,   228,   229,   230,   231,    -1,   233,    -1,    -1,
     236,    -1,   238,   239,   240,   241,   242,   243,   244,   245,
     246,    -1,   248,   249,   250,   251,   252,   253,    -1,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,    -1,   265,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,    -1,    -1,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,    -1,   315,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
      -1,   327,    -1,    -1,   330,   331,   332,    -1,    -1,    -1,
     336,   337,   338,    -1,   340,   341,   342,   343,   344,   345,
      -1,   347,    -1,   349,    -1,   351,   352,   353,    -1,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,    -1,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,    -1,   399,   400,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,    -1,   418,    -1,   420,   421,    -1,   423,   424,   425,
     426,   427,   428,    -1,   430,   431,    -1,    -1,   434,    -1,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,    -1,
      -1,   447,   448,   449,   450,    -1,    -1,   453,   454,   455,
     456,    -1,   458,    -1,   460,   461,   462,   463,   464,    -1,
      -1,   467,    -1,    -1,   470,   471,   472,   473,   474,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   483,   484,   485,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    43,    44,
      45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,
      -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,
     115,   116,   117,    -1,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,   128,    -1,    -1,   131,   132,   133,   134,
     135,    -1,   137,   138,   139,   140,    -1,    -1,    -1,   144,
     145,   146,   147,   148,   149,   150,    -1,   152,   153,   154,
     155,   156,   157,    -1,   159,   160,   161,   162,   163,    -1,
      -1,    -1,    -1,   168,    -1,    -1,    -1,   172,   173,   174,
     175,   176,   177,   178,   179,   180,    -1,   182,    -1,   184,
     185,   186,   187,   188,    -1,   190,   191,   192,    -1,    -1,
     195,   196,   197,   198,   199,    -1,   201,   202,   203,    -1,
     205,   206,    -1,   208,   209,   210,   211,    -1,   213,   214,
      -1,    -1,   217,    -1,   219,   220,   221,    -1,   223,    -1,
     225,   226,    -1,   228,   229,   230,   231,    -1,   233,    -1,
      -1,   236,    -1,   238,   239,   240,   241,   242,   243,   244,
     245,   246,    -1,   248,   249,   250,   251,   252,   253,    -1,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,    -1,
     265,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,    -1,   280,   281,   282,    -1,   284,
     285,   286,    -1,    -1,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,    -1,   313,    -1,
     315,   316,   317,   318,    -1,    -1,   321,   322,   323,   324,
     325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,    -1,
      -1,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,    -1,   347,    -1,   349,    -1,   351,   352,   353,    -1,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,    -1,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,    -1,   399,    -1,   401,   402,   403,   404,
     405,    -1,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,    -1,   418,    -1,   420,   421,    -1,   423,   424,
     425,   426,   427,   428,    -1,   430,   431,    -1,    -1,   434,
      -1,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
      -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,   454,
     455,   456,    -1,   458,    -1,   460,   461,   462,   463,   464,
      -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,   474,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   483,   484,
     485,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
     114,   115,   116,   117,    -1,    -1,   120,    -1,    -1,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,    -1,
      -1,   135,    -1,   137,   138,   139,   140,    -1,    -1,    -1,
     144,   145,   146,   147,   148,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,   162,   163,
      -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,    -1,    -1,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,    -1,   213,
     214,    -1,    -1,   217,    -1,   219,    -1,   221,    -1,   223,
      -1,   225,   226,    -1,   228,   229,   230,   231,    -1,   233,
      -1,    -1,   236,    -1,   238,   239,   240,   241,   242,   243,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,   256,    -1,    -1,   259,   260,   261,    -1,    -1,
      -1,    -1,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,    -1,   280,   281,   282,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,    -1,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
      -1,   315,   316,   317,   318,    -1,    -1,   321,    -1,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,    -1,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,    -1,   347,    -1,   349,    -1,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,    -1,   401,   402,   403,
     404,    -1,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,    -1,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,    -1,    -1,    -1,    -1,
     434,    -1,   436,    -1,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,    -1,    -1,    -1,   460,   461,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,    -1,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
      -1,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,    -1,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,    -1,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,    -1,   259,   260,   261,    -1,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,    -1,   296,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,    -1,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,    -1,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,    -1,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,    -1,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    -1,    86,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,   328,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,   432,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
     224,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
     224,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,   282,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,   232,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,   232,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
     224,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
     164,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
     224,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
     104,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,   461,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,   451,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
     104,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,   451,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,   451,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,   329,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      74,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,   108,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,   108,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,   235,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,   452,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,    -1,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,    -1,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,    -1,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,   108,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,    -1,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,    -1,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,    -1,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,    -1,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
      -1,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,    -1,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
      -1,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,     6,     7,     8,    -1,    10,    11,    12,    -1,
      -1,    -1,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    -1,    -1,    -1,    31,    32,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    -1,    -1,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    73,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     114,    -1,    -1,    -1,   118,   119,   120,   121,   122,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     134,    -1,    -1,    -1,    -1,    -1,    -1,   141,    -1,    -1,
      -1,    -1,    -1,    -1,   148,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   162,    -1,
      -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   178,   179,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   205,    -1,    -1,    -1,    -1,    -1,    -1,   212,    -1,
      -1,   215,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,
      -1,    -1,   226,    -1,   228,    -1,    -1,    -1,    -1,    -1,
     234,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   243,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   256,   257,    -1,    -1,    -1,    -1,    -1,   263,
      -1,   265,    -1,    -1,   268,   269,    -1,   271,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   279,   280,    -1,   282,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   302,   303,
     304,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   312,    -1,
      -1,    -1,    -1,   317,    -1,    -1,   320,    -1,   322,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   335,   336,   337,   338,   339,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   348,    -1,   350,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   362,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   380,    -1,    -1,   383,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   400,    -1,    -1,   403,
      -1,   405,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   417,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   430,   431,    -1,    -1,
      -1,   435,    -1,   437,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   445,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   458,    -1,    -1,   461,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   475,   476,   477,   478,   479,   480,   481,   482,     6,
       7,     8,    -1,    10,    11,    12,    -1,    -1,    -1,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    -1,    -1,    -1,    31,    32,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    -1,    -1,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    73,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,    -1,
      -1,   118,   119,   120,   121,   122,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   134,    -1,    -1,
      -1,    -1,    -1,    -1,   141,    -1,    -1,    -1,    -1,    -1,
      -1,   148,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   162,    -1,    -1,    -1,    -1,
      -1,   168,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   178,   179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   205,    -1,
      -1,    -1,    -1,    -1,    -1,   212,    -1,    -1,   215,    -1,
      -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,   226,
      -1,   228,    -1,    -1,    -1,    -1,    -1,   234,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   243,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   256,
     257,    -1,    -1,    -1,    -1,    -1,   263,    -1,   265,    -1,
      -1,   268,   269,    -1,   271,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   279,   280,    -1,   282,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   302,   303,   304,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   312,    -1,    -1,    -1,    -1,
     317,    -1,    -1,   320,    -1,   322,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   335,   336,
     337,   338,   339,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   348,    -1,   350,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   362,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   380,    -1,    -1,   383,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   400,    -1,    -1,   403,    -1,   405,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     417,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   430,   431,    -1,    -1,    -1,   435,    -1,
     437,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   445,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   458,    -1,    -1,   461,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   475,   476,
     477,   478,   479,   480,   481,   482,     6,     7,     8,    -1,
      10,    11,    12,    -1,    -1,    -1,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    -1,    -1,
      -1,    31,    32,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    -1,    -1,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      -1,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   114,    -1,    -1,    -1,   118,   119,
     120,   121,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   134,    -1,    -1,    -1,    -1,    -1,
      -1,   141,    -1,    -1,    -1,    -1,    -1,    -1,   148,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   162,    -1,    -1,    -1,    -1,    -1,   168,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   178,   179,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   205,    -1,    -1,    -1,    -1,
      -1,    -1,   212,    -1,    -1,   215,    -1,    -1,    -1,    -1,
     220,    -1,    -1,    -1,    -1,    -1,   226,    -1,   228,    -1,
      -1,    -1,    -1,    -1,   234,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   243,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   256,   257,    -1,    -1,
      -1,    -1,    -1,   263,    -1,   265,    -1,    -1,   268,   269,
      -1,   271,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   279,
     280,    -1,   282,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   302,   303,   304,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   312,    -1,    -1,    -1,    -1,   317,    -1,    -1,
     320,    -1,   322,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   335,   336,   337,   338,   339,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   348,    -1,
     350,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   362,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     380,    -1,    -1,   383,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     400,    -1,    -1,   403,    -1,   405,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     430,   431,    -1,    -1,    -1,   435,    -1,   437,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   445,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   458,    -1,
      -1,   461,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   475,   476,   477,   478,   479,
     480,   481,   482,     6,     7,     8,    -1,    10,    11,    12,
      -1,    -1,    -1,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    -1,    26,    27,    -1,    -1,    -1,    31,    32,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    42,
      43,    44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    71,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   114,    -1,    -1,    -1,   118,   119,   120,   121,   122,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   134,    -1,    -1,    -1,    -1,    -1,    -1,   141,    -1,
      -1,    -1,    -1,    -1,    -1,   148,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   162,
      -1,    -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   178,   179,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   205,    -1,    -1,    -1,    -1,    -1,    -1,   212,
      -1,    -1,   215,    -1,    -1,    -1,    -1,   220,    -1,    -1,
      -1,    -1,    -1,   226,    -1,   228,    -1,    -1,    -1,    -1,
      -1,   234,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     243,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   256,   257,    -1,    -1,    -1,    -1,    -1,
     263,    -1,   265,    -1,    -1,   268,   269,    -1,   271,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   279,   280,    -1,   282,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   302,
     303,   304,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   312,
      -1,    -1,    -1,    -1,   317,    -1,    -1,   320,    -1,   322,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   335,   336,   337,   338,   339,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   348,    -1,   350,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   362,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   380,    -1,    -1,
     383,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   400,    -1,    -1,
     403,    -1,   405,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   417,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   430,   431,    -1,
      -1,    -1,   435,    -1,   437,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   445,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   458,    -1,    -1,   461,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   475,   476,   477,   478,   479,   480,   481,   482,
       6,     7,     8,    -1,    10,    11,    12,    -1,    -1,    -1,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    -1,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,
      -1,    -1,   118,   119,   120,   121,   122,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   134,    -1,
      -1,    -1,    -1,    -1,    -1,   141,    -1,    -1,    -1,    -1,
      -1,    -1,   148,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   162,    -1,    -1,    -1,
      -1,    -1,   168,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   178,   179,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   212,    -1,    -1,   215,
      -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,
     226,    -1,   228,    -1,    -1,    -1,    -1,    -1,   234,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   243,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     256,   257,    -1,    -1,    -1,    -1,    -1,   263,    -1,   265,
      -1,    -1,   268,   269,    -1,   271,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   279,   280,    -1,   282,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   302,   303,   304,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   312,    -1,    -1,    -1,
      -1,   317,    -1,    -1,   320,    -1,   322,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   335,
     336,   337,   338,   339,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   348,    -1,   350,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   362,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   380,    -1,    -1,   383,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   400,    -1,    -1,   403,    -1,   405,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   417,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   430,   431,    -1,    -1,    -1,   435,
      -1,   437,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   458,    -1,    -1,   461,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   475,
     476,   477,   478,   479,   480,   481,   482
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,   511,  1018,     0,     5,    25,    35,    36,    41,    43,
      44,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    73,    75,    76,    77,
      78,    79,    80,    81,    82,    86,   133,   205,   220,   240,
     262,   295,   298,   319,   390,   432,   445,   458,   483,   489,
     493,   494,   495,   496,   497,   500,   501,   502,   503,   505,
     506,   507,   508,   509,  1011,  1019,  1047,  1049,  1140,  1150,
    1151,  1153,  1159,  1160,  1048,     3,     6,     7,     8,     9,
      10,    11,    12,    13,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    26,    27,    28,    31,    32,    33,
      34,    36,    37,    38,    39,    40,    42,    43,    44,    45,
      46,    50,    51,    56,    65,    67,    69,    70,    91,   101,
     103,   104,   113,   114,   117,   118,   119,   120,   121,   122,
     134,   137,   139,   140,   141,   144,   146,   148,   156,   158,
     162,   168,   175,   177,   178,   179,   180,   186,   192,   194,
     198,   204,   205,   211,   212,   213,   215,   218,   220,   226,
     228,   232,   234,   243,   256,   257,   260,   263,   265,   268,
     269,   271,   279,   280,   282,   284,   285,   290,   299,   302,
     303,   304,   312,   316,   317,   320,   322,   335,   336,   337,
     338,   339,   348,   350,   352,   362,   363,   367,   369,   374,
     379,   380,   382,   383,   386,   392,   399,   400,   402,   403,
     405,   409,   417,   422,   430,   431,   435,   437,   439,   441,
     445,   448,   450,   453,   457,   458,   461,   469,   475,   476,
     477,   478,   479,   480,   481,   482,   502,   512,   513,   519,
     520,   522,   523,   524,   525,   526,   527,   528,   530,   531,
     535,   545,   547,   548,   551,   552,   553,   563,   564,   579,
     619,   620,   627,   633,   635,   637,   638,   639,   640,   649,
     653,   654,   655,   657,   658,   659,   673,   674,   675,   676,
     687,   693,   694,   697,   698,   699,   700,   701,   706,   708,
     711,   715,   716,   726,   727,   730,   735,   745,   764,   767,
     768,   769,   772,   775,   777,   779,   782,   785,   786,   787,
     794,   795,   797,   798,   799,   804,   806,   807,   811,   812,
     815,   816,   817,   819,   820,   821,   822,   824,   827,   828,
     833,   839,   842,   844,   849,   851,   855,   862,   866,   867,
     868,   869,   870,   871,   900,  1015,  1016,  1020,  1022,  1023,
    1040,  1041,  1042,  1043,  1054,  1056,  1060,  1061,  1062,  1063,
    1064,  1066,  1068,  1070,  1071,  1072,  1073,  1075,  1080,  1081,
    1085,  1086,  1095,  1097,  1098,  1099,  1102,  1107,  1110,  1115,
    1117,  1118,  1121,  1123,  1126,  1135,  1153,  1161,    73,  1043,
    1051,  1052,    14,     9,    13,    15,    28,    45,    46,    50,
      51,    56,    65,    67,    69,    70,    72,    91,    92,    93,
      94,    95,    96,    97,    98,   100,   101,   102,   110,   111,
     113,   115,   116,   117,   124,   125,   126,   127,   128,   131,
     132,   133,   135,   137,   138,   139,   140,   144,   145,   146,
     147,   149,   150,   152,   153,   154,   155,   156,   157,   159,
     160,   161,   163,   172,   173,   174,   175,   176,   177,   180,
     182,   184,   185,   186,   187,   188,   190,   191,   192,   195,
     196,   197,   198,   199,   201,   202,   203,   205,   206,   208,
     209,   210,   211,   213,   214,   217,   219,   221,   223,   225,
     229,   230,   231,   233,   236,   238,   239,   240,   241,   242,
     244,   245,   246,   248,   249,   250,   251,   252,   253,   255,
     259,   260,   261,   267,   270,   272,   273,   274,   275,   276,
     277,   281,   284,   285,   286,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   305,   306,
     307,   308,   309,   310,   311,   313,   315,   316,   318,   321,
     323,   324,   325,   327,   330,   331,   332,   340,   341,   342,
     343,   344,   345,   347,   349,   351,   352,   353,   355,   356,
     357,   358,   359,   360,   361,   363,   364,   365,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   378,   379,
     381,   382,   384,   385,   386,   387,   388,   389,   390,   391,
     393,   394,   395,   396,   397,   399,   401,   402,   404,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   418,
     420,   421,   423,   424,   425,   426,   427,   428,   432,   434,
     436,   439,   440,   441,   442,   443,   444,   447,   448,   449,
     450,   453,   454,   455,   456,   457,   460,   462,   463,   464,
     467,   470,   471,   472,   473,   474,   483,   484,   485,  1012,
    1014,  1015,  1033,  1034,  1125,  1126,  1127,  1131,  1136,  1137,
    1138,  1145,  1147,  1151,  1153,    29,   258,  1096,    99,   164,
     181,  1004,  1035,  1082,  1083,  1131,  1147,    99,   863,  1003,
    1035,  1131,  1144,    14,   863,     5,    25,    29,    35,    36,
      43,    44,    99,   103,   104,   105,   106,   107,   108,   109,
     112,   123,   129,   130,   133,   136,   142,   143,   150,   151,
     158,   164,   165,   166,   167,   169,   170,   171,   181,   183,
     189,   193,   194,   200,   204,   207,   216,   218,   222,   224,
     227,   232,   235,   237,   247,   254,   258,   262,   264,   266,
     278,   283,   287,   288,   314,   319,   326,   328,   329,   333,
     334,   346,   354,   366,   377,   392,   398,   406,   419,   422,
     429,   432,   433,   438,   445,   446,   451,   452,   457,   459,
     465,   466,   468,   469,  1014,  1017,  1127,  1128,  1129,  1133,
    1134,  1135,  1136,  1138,    25,    35,   133,   262,  1122,    38,
      40,   314,  1055,   434,   471,   800,    98,   155,   175,   181,
     196,   224,   229,   235,   250,   274,   330,   357,   381,   387,
     393,   396,   422,   424,   428,   436,   441,   451,   463,   634,
    1083,   180,   800,    99,   863,   461,   829,   328,   353,   800,
     120,   570,   867,    98,   110,   130,   151,   175,   181,   196,
     224,   231,   235,   286,   330,   333,   381,   387,   396,   424,
     425,   427,   428,   436,   441,   446,   451,   580,   690,   736,
     746,  1004,  1024,  1025,  1026,  1035,  1151,  1153,    14,    99,
     352,  1003,  1035,  1039,   410,   863,   227,    99,   347,   425,
     427,   273,   773,   774,  1151,    98,   110,   130,   155,   175,
     196,   224,   229,   235,   250,   330,   340,   381,   385,   387,
     393,   396,   422,   424,   428,   436,   441,   451,   463,   634,
     702,   800,   508,  1065,  1129,   244,  1039,   158,   180,   211,
     461,   502,   828,   834,   842,   844,   849,   855,   862,   866,
    1020,    92,    99,   115,   219,   225,   227,   247,   275,   305,
     355,   368,   493,   494,   712,   713,   863,  1011,  1013,  1145,
    1147,    99,   158,   366,   392,   717,   718,   719,  1131,   266,
    1131,  1008,  1151,   422,   876,   115,   225,   712,  1131,   434,
    1039,   340,   175,   250,   421,   422,   780,   386,  1131,    99,
     133,   397,   430,   434,   457,   537,  1014,  1015,  1125,  1130,
    1136,  1138,  1153,    96,   232,   717,   718,   353,   800,  1131,
      99,   193,   878,     4,    14,   131,   150,   152,   286,   301,
     381,   387,   397,   430,   434,   474,   536,   537,    99,   397,
     430,   434,   537,   434,   329,   909,  1001,  1131,   876,  1119,
    1129,   495,  1131,   909,   911,   228,   502,   830,   502,   997,
     365,   872,   873,  1003,   867,   868,   506,   829,   207,   264,
     334,   445,   879,   880,   867,   869,   870,   505,   117,   512,
    1063,  1066,  1062,  1058,   506,  1067,  1069,     5,    25,    35,
     133,   197,   262,  1074,   176,   240,   295,   298,   390,   483,
     502,   939,   940,  1046,  1050,  1140,    73,  1043,  1003,  1035,
    1154,   181,  1024,    21,   452,   496,  1039,  1039,  1154,   452,
    1087,  1088,  1089,    25,   262,   262,  1133,     7,    19,    20,
      39,    42,   154,   194,  1124,  1124,    16,  1063,  1009,  1016,
    1125,  1128,  1131,  1132,  1136,  1137,  1153,   704,  1131,  1004,
     356,   704,   174,   725,  1009,  1012,  1001,   323,    85,   138,
     217,   489,   490,   491,   493,   494,   495,   496,   497,   498,
     771,   964,   965,  1131,  1012,  1003,  1001,  1003,   909,  1003,
     389,  1003,   704,   292,  1012,  1001,   273,    34,   270,   361,
     801,   802,   803,  1001,  1007,  1131,    98,   130,   143,   151,
     155,   175,   196,   229,   250,   274,   330,   381,   385,   387,
     393,   422,   424,   428,   436,   441,   463,   634,   709,  1151,
    1001,   432,  1009,  1003,   502,   436,  1004,   704,   174,   425,
     427,  1012,   425,   427,   138,   217,   771,   372,  1012,   532,
    1131,  1003,  1003,   389,  1003,   704,   292,  1012,   393,   422,
     463,   155,   250,   229,   385,   440,   628,    85,  1027,  1028,
     507,  1147,  1154,    99,  1039,  1153,   864,   911,   544,  1131,
    1151,   774,   242,  1009,  1003,   242,   778,   242,  1004,   174,
     242,  1009,   242,  1002,  1003,   138,   217,   242,   771,   124,
     242,  1002,   242,  1003,   242,  1003,   242,  1003,   389,   242,
    1003,   242,   292,  1002,   273,   242,   703,   704,   502,   508,
    1155,  1156,  1157,  1158,  1160,  1065,    71,  1035,  1084,   502,
     843,   580,   863,   834,   457,   461,   828,   835,   836,   837,
    1131,   829,  1013,   713,   714,    99,   713,   863,  1013,   714,
      99,   713,   863,  1013,   714,   714,   714,  1013,  1011,  1011,
     266,   452,  1089,  1090,  1164,  1165,   863,   714,   356,   502,
     502,   598,   598,   598,   328,   432,   505,   598,  1001,   909,
     910,   713,   863,   713,   863,   505,   796,  1151,   227,   502,
     840,   124,  1003,  1003,  1001,  1131,   114,   485,   270,   504,
     331,   331,   328,   227,  1151,   432,   328,    83,    84,    85,
      87,   107,   119,   121,   122,   129,   130,   133,   134,   141,
     165,   166,   167,   168,   169,   170,   171,   178,   179,   197,
     212,   215,   216,   220,   234,   262,   263,   265,   279,   287,
     288,   302,   304,   314,   319,   320,   322,   330,   339,   348,
     362,   383,   398,   405,   417,   430,   431,   435,   437,   438,
     446,   451,   458,   476,   477,   478,   479,   480,   481,   482,
     493,   494,   495,   502,   867,   920,   923,   926,   927,   928,
     930,   931,   932,   933,   936,   937,   941,   943,   944,   962,
     966,   985,   990,   998,   999,  1009,  1010,  1011,  1131,  1143,
    1145,  1147,  1148,  1149,  1150,  1151,   432,   489,  1154,  1151,
     432,   489,  1083,    99,   549,  1000,  1001,   397,   536,   181,
     543,  1151,   544,  1151,   114,   135,   536,   485,   802,   331,
     227,   432,   489,   114,   485,   270,  1164,   803,   502,  1001,
     495,   500,   504,   991,   992,   910,  1135,   108,  1131,   399,
     226,   228,   461,   825,   826,   828,   226,   831,   181,   941,
     995,   996,   872,   505,   502,   832,   503,   503,  1001,    99,
     193,   877,   877,   124,   877,   218,   222,   283,   326,   883,
     885,   886,   895,   897,   898,   879,   880,   997,   506,  1057,
     495,  1076,  1077,  1079,   508,   508,    25,   262,   262,   432,
     432,   432,   432,   502,   432,   494,   625,  1013,  1044,  1150,
     204,   108,  1031,   124,  1034,  1034,   266,  1089,  1091,   266,
    1089,  1090,  1091,   456,  1100,  1101,  1147,    14,    37,    84,
     493,   494,  1011,  1092,  1093,  1094,  1143,  1145,  1149,  1150,
    1151,  1152,   262,   268,  1003,   432,  1003,     6,  1003,  1124,
    1079,   502,   681,   992,   341,   370,   504,   705,   341,   370,
     399,   469,   514,   545,   546,   731,    95,   198,   341,   399,
     556,   472,   126,   157,   214,   245,   341,   370,   378,   384,
     391,   399,   407,   415,   464,   546,   758,   765,   502,   747,
      95,   198,   370,   529,    95,   101,   140,   191,   198,   201,
     252,   306,   341,   370,   374,   399,   554,   555,   625,   704,
     704,   502,   770,   504,   247,   370,   514,   521,   341,   370,
     125,   173,   249,   294,   296,   306,   340,   370,   375,   399,
     409,   554,   622,   623,   332,   341,   462,   643,   651,   370,
     399,   554,   341,   370,   374,   399,   149,   190,   342,   426,
     328,   341,   370,   399,   222,   370,   399,   514,   546,   370,
     399,   554,  1003,   506,   281,   329,   473,   505,   801,   452,
     823,   328,  1009,   502,  1003,  1009,   323,   138,   217,   771,
    1003,   389,  1003,   273,   704,   598,   412,   413,   566,  1151,
     502,   681,   682,   136,   119,   121,   122,   133,   134,   178,
     179,   220,   263,   265,   302,   304,   322,   362,   400,   405,
     430,   431,   458,   917,   919,   921,   923,   925,   927,   928,
     929,   931,   932,   936,   937,  1125,  1132,  1136,  1137,  1153,
    1003,   514,   108,   818,   472,   514,   704,   704,   502,   677,
     580,   514,   114,   533,   441,   650,   341,   636,   149,   190,
     342,   426,    97,   116,   660,   108,   677,   222,   514,  1001,
     614,  1001,  1001,   704,   148,   737,  1009,  1003,   634,    74,
    1029,  1131,   507,  1030,  1027,   120,   172,   259,   306,   388,
     452,   850,   212,   681,   127,   376,   557,   212,   502,   212,
     472,   212,   747,   212,   505,   242,   704,   242,   704,   212,
     770,  1002,   212,   212,   328,   212,   557,   212,   149,   190,
     342,   426,   212,   328,   212,   222,   242,   242,   544,   212,
     505,   557,   503,  1156,  1157,  1155,   505,   509,   941,   969,
    1088,  1163,  1164,   422,   864,   503,   505,   216,   328,   438,
     541,   544,   625,   838,   834,   714,   863,   714,   863,  1165,
    1166,   714,   863,   714,   863,  1166,   714,   863,   863,   863,
     714,    14,    37,  1139,  1142,  1147,   863,   502,   599,   600,
    1131,   599,    99,   175,   224,   229,   273,   274,   387,   393,
     422,   424,   720,  1000,  1002,   719,   181,   502,   845,   866,
     247,   505,   852,   863,   863,  1151,  1084,   917,   972,   108,
    1002,   223,   781,   781,   781,   281,  1131,   222,   222,   720,
    1002,   386,  1131,   502,   500,   867,   973,   460,   934,   941,
     989,   502,   934,   934,   502,   502,   502,   502,   922,   922,
     350,   867,   502,   502,   924,   502,   502,   502,   502,   133,
     134,   934,   941,   502,   922,   502,   502,   502,   502,   502,
     470,   488,   502,   938,   502,   938,   502,   502,   867,   502,
     502,   502,   502,   502,   502,   502,   941,   941,   867,   941,
     969,  1151,   134,   502,   935,   502,  1151,    85,    88,   105,
     108,   113,   118,   243,   247,   268,   269,   282,   314,   317,
     330,   333,   403,   489,   490,   491,   493,   494,   495,   496,
     497,   498,   964,   966,   968,  1153,   338,   941,   266,   505,
     874,  1164,   502,  1151,   992,    22,  1146,  1147,   993,   325,
     328,  1116,  1116,    10,   456,  1103,  1104,  1106,  1083,  1083,
     184,   244,   550,   505,   135,   181,   544,   108,   181,   286,
     542,   625,   937,  1151,  1153,   153,   195,   950,   164,   181,
     538,   539,   541,   625,   181,   538,  1164,  1164,   281,  1001,
     941,   495,  1006,  1133,   991,   154,   375,   707,   268,  1131,
     502,   856,   857,   858,   859,   860,  1131,   503,   505,   829,
     503,   505,   873,  1002,   108,   832,   869,   869,   881,   882,
     941,   869,   219,   305,   892,   361,   401,   450,    99,   887,
     941,   888,   890,   941,   943,   895,   896,   886,   885,   883,
     884,   222,   898,   883,   895,  1076,   495,   505,   506,  1134,
    1053,  1056,  1053,   262,   176,   240,   295,   940,   295,   940,
     940,   298,  1011,   295,   298,   390,  1150,   505,  1045,   180,
    1083,   451,  1032,  1034,  1003,    37,  1011,  1105,  1147,   505,
     489,  1003,    14,  1011,  1150,  1011,  1150,   505,  1063,   502,
    1003,   502,  1135,   495,   972,   341,   370,   399,   432,   432,
    1006,   504,   432,   432,   424,   536,   813,   222,   232,   247,
     379,   732,   733,   136,   151,   208,   224,   354,   446,   596,
     597,   151,   181,   314,   432,   181,   314,   387,  1003,   328,
     625,   391,   432,   432,   319,   625,   185,   267,   387,   376,
     758,   766,   247,   257,   335,   400,   459,   503,   748,   751,
     752,   753,   755,   917,  1132,   432,   451,   143,   208,   587,
     596,  1131,   143,   783,   328,   385,   436,   151,   783,   102,
     373,   385,   436,  1001,   252,   432,   432,   502,   559,   424,
     469,   470,   559,   505,   341,   452,   452,   312,   917,   341,
     771,   175,   432,   516,   546,   432,   432,   625,   124,   624,
     625,   625,   173,   294,   296,   124,   432,   514,   387,   514,
     306,   623,   502,   432,   319,  1151,   643,   432,   783,   387,
     432,   432,   559,   559,   704,   704,   704,   704,  1001,   432,
     432,   387,   171,   451,   656,  1012,   432,   516,   432,   387,
     341,   370,   361,   371,   395,   540,   801,  1007,  1131,  1001,
     681,   917,   328,   747,   625,   704,   704,   770,   268,   328,
     149,   190,   342,   426,   328,   704,   268,   469,   571,   514,
     683,   684,  1153,   677,   502,   919,   108,   107,   918,   176,
     298,   483,   502,   939,   705,   922,    97,   808,   917,  1003,
     515,   690,   452,   678,   679,  1133,   463,   515,  1012,   158,
     232,   534,   579,   619,   659,   715,   735,   804,  1151,   651,
     652,  1003,   289,   704,   704,   704,   704,   186,   260,   439,
     450,   661,   662,   205,   502,   656,   515,   621,   622,   108,
     324,   502,   615,   598,   222,   738,  1007,   502,   749,   108,
     273,   504,  1011,  1030,   469,   470,   865,   388,   502,   867,
     902,   903,   904,   909,   912,   944,  1009,  1131,   466,   914,
    1009,   557,   917,  1004,   242,  1003,  1009,   557,  1002,  1003,
     212,   452,   212,   452,   771,   557,   557,  1002,  1003,  1001,
    1003,  1003,  1003,  1001,  1002,   656,   212,   212,   557,   703,
     704,   503,   509,  1158,   503,   505,  1164,  1088,  1001,   172,
     834,   836,   863,   863,  1166,   863,   863,  1166,   863,   863,
    1003,    14,   505,  1146,   599,   503,   505,   503,   230,   394,
     423,  1002,   174,   396,   724,   725,  1002,   323,  1002,  1000,
    1000,  1002,   432,   469,   728,   457,   846,   847,  1131,   377,
     848,    93,   210,   383,   401,   853,   909,   318,   854,   503,
     505,   841,   844,   849,   855,   866,   432,   718,   717,   718,
     227,   233,   729,  1131,   969,   501,   969,   973,   974,   502,
     465,   986,   987,   941,   969,  1011,  1011,   969,   176,   240,
     295,   298,   390,   483,   975,   976,  1151,  1153,  1011,   969,
     969,  1011,  1011,   934,   934,   941,   771,   941,   977,   493,
     494,   942,   943,   962,   966,   979,   503,   969,   941,   969,
     980,   430,   485,  1011,  1011,   941,   123,   227,   278,   433,
     941,   969,   983,   969,   300,   941,   948,   949,   950,   300,
     941,   950,   503,   505,   399,  1011,  1011,   939,   917,   941,
    1133,   430,   112,   419,   994,   941,   502,   867,   984,   193,
     195,   216,   314,   319,   324,   438,   447,   941,   118,   243,
     247,   282,   403,   502,   941,   432,   941,   941,   941,   941,
     941,   941,   941,   941,   941,   941,    99,   106,   406,   963,
     383,   502,   962,   231,   286,   422,   425,   427,   875,  1001,
     999,   227,   901,    99,   193,   459,   495,   503,   753,   941,
     970,   971,  1132,  1003,  1147,   991,  1105,   505,   489,  1001,
     434,   502,  1151,   505,  1164,   503,   501,   507,   241,   241,
     557,  1063,   860,   861,   505,   901,   489,   993,  1001,   826,
     827,  1001,   995,   503,   867,   505,   109,   189,   452,   743,
     502,   889,  1013,   329,   324,   899,   899,   505,   383,   384,
     891,   896,   884,   506,  1077,   918,   509,  1056,   509,   503,
     625,   503,    34,  1033,  1108,  1109,  1147,  1101,  1106,  1154,
    1092,   918,  1141,  1157,  1141,   918,   503,   503,   432,   432,
     387,  1012,  1003,  1006,  1012,  1004,  1003,   150,   814,   381,
     451,   717,   387,   232,   717,   502,  1003,   452,   739,   272,
     272,   502,  1003,   319,  1012,   941,   319,  1003,   306,   341,
     455,   631,   643,   319,   185,   267,  1012,  1003,   328,  1003,
     335,  1132,   503,   505,   753,   755,   752,   755,  1132,   705,
    1012,  1002,   587,   917,  1131,  1003,  1003,    99,   451,  1003,
     242,  1003,   242,  1131,   385,   436,   385,   436,  1003,    99,
     451,  1003,  1001,  1012,  1003,   561,   562,  1133,  1003,   327,
     140,   327,   555,   432,  1005,  1131,  1005,   505,   503,   505,
     432,  1004,  1012,   150,   159,   160,   161,   203,   252,   291,
     307,   308,   309,   310,   311,   313,   345,   418,   444,   451,
     454,   517,  1012,  1003,   625,   704,  1003,   625,  1003,   625,
      95,   198,   399,   644,   645,   646,   647,  1133,  1012,  1003,
    1003,  1003,  1012,  1003,    95,   101,   198,   341,   370,   341,
     370,   677,   370,   370,   370,  1012,  1003,  1003,   396,  1012,
    1003,  1003,   432,   432,   147,   443,   361,   268,   108,   704,
     268,   268,   452,   452,   268,   319,   710,  1151,   704,   704,
     704,   704,   704,   704,   268,   710,   327,   227,   432,   565,
     502,   567,   568,   503,   505,   489,   941,   107,   918,   917,
     500,   500,   432,   432,  1011,   922,   661,   150,   202,   276,
     277,   289,   341,   424,   426,   809,   589,   631,   632,    96,
     247,   381,   420,   517,   518,   222,  1005,   503,   505,   489,
    1001,   533,   333,   580,   224,  1151,   677,   677,   677,   677,
     324,   328,   333,   502,   915,   916,  1131,   396,   211,  1021,
     704,   282,   581,   583,   585,   587,   593,   596,   616,   617,
    1131,   469,   470,   610,   108,  1151,   328,   503,   750,   751,
     756,   108,   273,   378,   468,   757,   758,   759,   328,   544,
    1029,   496,   239,   239,   222,   867,   903,   904,   108,   905,
    1131,   505,   162,   228,   256,   271,   280,   303,   380,   906,
     905,   108,   905,  1131,   502,   992,   164,   941,   848,   681,
     108,   212,   557,   747,   704,  1005,   704,  1005,   770,   328,
     557,   557,   328,   557,   396,   222,   544,   557,   941,   502,
     865,  1154,  1142,   503,   600,   247,   247,   247,   472,  1002,
     505,   625,   626,   235,   721,   722,  1012,    96,   729,   503,
     505,   993,   998,   210,   401,   210,   401,   383,   450,   297,
     917,  1003,   227,   328,   721,   124,   557,   503,   501,   501,
     505,   969,   941,   200,   987,   988,   108,   503,   503,   503,
     503,   503,   227,   503,   503,   503,   503,   503,   505,   503,
     346,   978,   503,   942,   942,    88,   247,   268,   330,   489,
     490,   491,   493,   494,   495,   496,   497,   498,   966,   942,
     503,   503,   222,   227,   981,   982,   503,   485,   503,   503,
     108,   983,   969,   983,   983,   227,   503,   503,  1133,   108,
     503,   505,   941,  1133,   505,   941,   993,   941,  1131,   503,
     503,   485,   942,   942,   206,   969,   227,   193,   195,   216,
     319,   324,   438,   447,   502,   206,   419,   994,   941,   984,
     941,   432,   771,   941,   502,   867,   425,   427,   425,   427,
    1001,   876,   876,   902,   466,   913,   970,   970,   971,   503,
     337,   955,    90,   503,   505,   880,     8,    11,    12,    22,
      23,    24,    26,    27,    31,    32,    33,   174,   300,   350,
     441,  1111,  1112,  1114,  1104,  1105,   802,  1011,   939,   539,
     941,   918,   503,   505,   857,   914,   995,   832,   882,   330,
     964,   967,   486,   487,   744,   941,   891,  1000,   854,   854,
     888,   507,  1059,   506,   505,   489,    30,  1120,   503,   503,
     506,  1012,  1003,  1003,   283,  1002,  1002,   328,  1002,   331,
     328,   941,   597,  1005,   502,   502,   502,   599,   557,   455,
     432,   629,  1003,   643,   258,   319,   705,   751,   755,   755,
     497,   589,   198,   374,   399,   556,   784,   212,   557,   212,
     557,  1003,  1003,  1003,  1003,   503,   505,   489,   504,  1012,
     341,   370,    95,   198,   341,   370,   917,   312,   917,  1012,
     283,   345,   319,  1151,   345,  1002,   449,   646,   647,   646,
     503,   505,   648,  1151,   432,   292,   292,   292,   432,   432,
     432,   432,   432,   432,   432,  1003,  1012,  1003,   710,   917,
     268,   710,   710,  1005,  1005,   710,   268,   268,   268,   268,
     268,   268,   710,   566,   574,   575,  1133,   120,   163,   187,
     206,   223,   238,   319,   327,   359,   569,   684,  1153,   330,
     493,   494,   625,   680,   755,   967,  1017,  1151,   503,   500,
     503,  1011,   501,   502,  1011,  1131,  1151,  1162,   503,   328,
     283,   489,   810,   810,   810,   810,   810,   810,   810,   136,
     151,   181,   183,   254,   314,   319,   354,   366,   446,   590,
     591,   592,   332,   641,  1002,   235,   381,  1002,  1011,   441,
     679,   680,   598,   372,   422,   174,   599,  1001,   662,   685,
     686,  1151,   503,   505,   917,  1003,  1039,   866,   502,   582,
    1001,   503,   505,   503,   505,   327,   559,   327,   328,   611,
     866,   432,  1001,   503,   505,   181,   489,   760,  1151,   544,
     422,   754,   755,   469,   759,   761,   186,   260,   392,   450,
     792,   236,  1025,   866,  1039,   503,  1131,   502,   903,   271,
     336,   907,   903,   907,   271,   906,   907,   271,   502,  1131,
     502,   970,   324,   557,   917,  1003,   557,   452,   557,   452,
     557,   557,  1001,  1001,  1003,   656,   557,  1131,   222,   387,
     387,   387,  1002,   725,   505,  1012,   469,   505,   723,   331,
     866,   847,  1164,   210,   210,  1002,   720,   557,  1012,   973,
     503,   429,   941,   204,   917,   941,   941,   941,   981,   917,
     942,   193,   195,   314,   324,   942,   942,   942,   942,   942,
     942,   942,   942,   942,   942,   941,   941,   982,   981,   938,
     938,   917,   503,   503,   503,   969,   503,   505,  1133,   949,
     351,   416,   951,   503,   505,   462,   945,   108,   503,   935,
    1151,   941,   105,   105,   941,   503,   941,   227,   502,   972,
     941,   942,   942,   206,   206,   941,   503,   206,   941,   876,
     876,   876,   876,  1001,  1001,   941,   235,   893,   505,   879,
     880,   879,   503,   955,   502,   956,  1131,   941,   955,  1151,
     459,   971,   503,   505,   489,   503,   501,  1120,   489,   860,
     848,   502,   744,   503,   329,  1011,   489,  1078,  1109,  1114,
     810,   230,   394,   423,   734,   222,   734,   503,   502,   602,
     603,   741,   944,  1131,   599,   599,   503,  1012,   705,   258,
     497,   441,   314,   559,   174,   314,   411,   414,   559,   441,
    1003,  1131,   562,   680,  1133,   432,   432,   229,   330,   414,
     688,   689,   229,   330,   695,   696,   432,   432,   503,   503,
     503,  1013,  1151,  1151,  1151,   645,  1003,   222,   222,   372,
     222,   242,  1012,  1003,  1012,  1003,  1003,  1003,  1003,   643,
     503,   710,   268,   268,   710,   710,   710,   710,   710,   710,
     452,   572,   573,   503,   505,   495,   502,   541,   576,   625,
     818,   818,   314,   359,   818,   818,   183,   254,   314,   670,
     671,   672,  1011,   469,   470,   501,  1162,   493,   494,   495,
     496,   497,   501,   939,  1001,   810,   181,  1011,  1151,   181,
    1151,   181,  1151,   181,  1151,   181,  1003,   181,  1003,   181,
    1003,   502,  1003,   942,   184,   244,   183,   319,   272,  1001,
     761,   502,  1002,  1002,   917,   108,  1001,   472,   222,   663,
     503,   505,   916,   641,   843,   469,   618,   584,   586,   588,
     596,  1131,   610,   594,   253,   609,   585,   617,   146,   424,
     612,   469,   805,  1151,   739,   756,   941,   941,   505,   502,
     757,   677,   432,   629,    85,  1036,   905,   502,  1002,   903,
     328,   452,   908,   903,   271,   903,   915,   502,   915,  1131,
     503,  1003,   503,   557,  1005,  1005,   557,   557,   396,  1002,
    1002,  1002,   625,   232,   722,   729,   227,   941,   503,   503,
     982,   227,   193,   195,   324,   502,   503,   475,   947,   969,
     467,   467,   503,   941,   306,   941,   505,   946,   919,   939,
     942,   942,   941,   972,   503,   105,   105,   941,   941,   206,
     941,   503,  1001,  1001,  1001,  1001,   124,   237,   894,   503,
     503,   955,   957,  1131,   971,   955,  1112,   494,  1105,  1113,
    1150,  1151,  1151,   997,   771,  1158,  1013,   432,   717,   227,
     670,   941,   503,   505,   469,   452,   704,   742,   742,   503,
     503,   761,   441,   319,   319,  1013,  1131,   917,   557,   557,
     489,  1012,  1003,  1011,  1011,   917,   505,  1011,  1011,   505,
    1012,  1003,  1002,  1002,   704,  1002,   212,   268,   710,   710,
     514,   188,   575,   541,   577,   578,  1151,  1151,   319,   495,
     599,  1151,  1151,   184,   244,   183,   672,   671,   501,   229,
     257,   229,   503,  1162,  1162,  1162,  1162,  1162,   227,   669,
    1013,   941,   314,   591,   761,   598,   452,   613,   642,   646,
     452,   866,   502,  1003,   199,   664,   465,   666,  1151,   174,
     306,   503,   505,   469,   611,   209,   248,   502,   610,   186,
     198,   351,  1003,   128,   136,   286,   227,   502,  1151,   753,
     762,   763,  1132,   761,  1001,   255,   630,  1037,  1131,  1002,
     503,   941,   502,   903,   908,   503,   915,   503,   557,   557,
     557,  1003,   331,   557,   721,   942,   227,   502,   972,   502,
     503,   505,   503,   503,   456,   408,   503,   503,   503,   942,
     942,   941,   969,   941,   468,   952,   955,   955,   344,   958,
     503,  1011,  1150,   939,   503,   721,   328,   721,   503,   761,
     603,   330,   771,   704,   743,   743,   366,   761,   613,   452,
     558,   680,   502,  1009,   771,   689,   502,   502,   696,   469,
     372,   469,   469,   222,   710,   567,  1151,   503,   505,   599,
     725,   108,   776,   776,  1001,   670,   503,   613,   293,   601,
     250,   503,   505,  1005,   805,   641,   383,   410,   665,   502,
     211,   174,   586,   332,   612,    99,   145,   152,   182,   251,
     414,   595,   595,  1000,   611,   384,   384,   136,   331,   136,
     704,   740,   741,   755,   503,   505,   913,   629,   632,   489,
    1038,   503,  1002,   503,   557,   942,   972,   503,   948,   969,
     306,   484,   953,   954,  1131,   124,   879,   955,   723,   734,
     557,   742,   613,   502,   744,   744,  1001,   613,   670,   941,
     972,   747,   364,   692,   770,   972,   972,   703,   704,   703,
     704,  1002,   578,   776,   111,   246,   222,   228,   343,   404,
     328,   605,   606,   607,   424,   646,   217,   691,   941,   358,
     589,   503,   612,   331,   331,   503,   505,   757,   762,   194,
    1011,  1145,  1153,    85,   503,   503,   503,   503,   456,   505,
     108,   969,   360,   384,   959,   227,   743,   466,   604,   771,
     598,   670,   503,   692,   503,   503,   469,   199,   186,   450,
     328,   607,   328,   606,  1003,   704,   108,   503,  1009,   469,
     560,   741,   761,   100,   261,   793,  1037,   954,   956,   118,
     164,   442,   941,   960,   961,   960,   503,   721,   744,   502,
     670,   503,   601,  1009,   704,   383,   127,   306,   376,   399,
     608,   608,   688,   502,   559,   612,   315,   502,   788,   790,
     795,   844,   849,   855,   866,   961,   383,   221,   349,   221,
     349,   557,   941,   605,   747,   666,    94,   181,   319,    84,
     667,   668,  1011,  1131,  1149,  1150,  1151,   913,   789,   790,
     791,   867,   868,   105,   503,   670,   211,   503,   505,   503,
     506,   961,   358,   668,   791,  1009,   502,   667,   503
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[2];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;

#if YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 1;
#endif

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:

/* Line 1455 of yacc.c  */
#line 1344 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 4:

/* Line 1455 of yacc.c  */
#line 1346 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 5:

/* Line 1455 of yacc.c  */
#line 1348 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 6:

/* Line 1455 of yacc.c  */
#line 1350 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 7:

/* Line 1455 of yacc.c  */
#line 1352 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 8:

/* Line 1455 of yacc.c  */
#line 1354 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 9:

/* Line 1455 of yacc.c  */
#line 1356 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 1358 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 1360 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 1362 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 1364 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 1366 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 1368 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 1370 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 1372 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 1374 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 1376 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 1378 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 1380 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 1382 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 1384 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 1386 "preproc.y"
    {
		if (INFORMIX_MODE)
		{
			if (pg_strcasecmp((yyvsp[(1) - (1)].str)+strlen("close "), "database") == 0)
			{
				if (connection)
					mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in CLOSE DATABASE statement");

				fprintf(yyout, "{ ECPGdisconnect(__LINE__, \"CURRENT\");");
				whenever_action(2);
				free((yyvsp[(1) - (1)].str));
				break;
			}
		}

		output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal);
	;}
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 1404 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 1406 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 1408 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 1410 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 1412 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 1414 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 1416 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 1418 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 1420 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 1422 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 1424 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 1426 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 1428 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 1430 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 1432 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 1434 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 1436 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 1438 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 1440 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 1442 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 1444 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 1446 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 1448 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 1450 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 1452 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 1454 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 1456 "preproc.y"
    {
		output_deallocate_prepare_statement((yyvsp[(1) - (1)].str));
	;}
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 1460 "preproc.y"
    { output_simple_statement((yyvsp[(1) - (1)].str)); ;}
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 1462 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 1464 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 1, ECPGst_prepnormal); ;}
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 1466 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 1, ECPGst_normal); ;}
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 1468 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 1470 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 1472 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 1474 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 1476 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 1478 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 1480 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 1482 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 1484 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 1486 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 1488 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 1490 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 1492 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 1494 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 1496 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 1498 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 1500 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 1502 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 1504 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 1, ECPGst_execute); ;}
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 1506 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 1508 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 1, ECPGst_normal); ;}
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 1510 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 1512 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 1514 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 1516 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 1, ECPGst_prepnormal); ;}
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 1518 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 1520 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 1522 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 1524 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 1526 "preproc.y"
    {
		if ((yyvsp[(1) - (1)].prep).type == NULL || strlen((yyvsp[(1) - (1)].prep).type) == 0)
			output_prepare_statement((yyvsp[(1) - (1)].prep).name, (yyvsp[(1) - (1)].prep).stmt);
		else	
			output_statement(cat_str(5, make_str("prepare"), (yyvsp[(1) - (1)].prep).name, (yyvsp[(1) - (1)].prep).type, make_str("as"), (yyvsp[(1) - (1)].prep).stmt), 0, ECPGst_normal);
	;}
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 1533 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 1535 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 1537 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 1539 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 1541 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 1543 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 1545 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 1547 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 1549 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 1551 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 1, ECPGst_prepnormal); ;}
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 1553 "preproc.y"
    {
		fprintf(yyout, "{ ECPGtrans(__LINE__, %s, \"%s\");", connection ? connection : "NULL", (yyvsp[(1) - (1)].str));
		whenever_action(2);
		free((yyvsp[(1) - (1)].str));
	;}
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 1559 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 1561 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 1563 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 1, ECPGst_prepnormal); ;}
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 1565 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 1567 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 1569 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 1571 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 1573 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 1575 "preproc.y"
    {
		fprintf(yyout,"ECPGallocate_desc(__LINE__, %s);",(yyvsp[(1) - (1)].str));
		whenever_action(0);
		free((yyvsp[(1) - (1)].str));
	;}
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 1581 "preproc.y"
    {
		if (connection)
			mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in CONNECT statement");

		fprintf(yyout, "{ ECPGconnect(__LINE__, %d, %s, %d); ", compat, (yyvsp[(1) - (1)].str), autocommit);
		reset_variables();
		whenever_action(2);
		free((yyvsp[(1) - (1)].str));
	;}
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 1591 "preproc.y"
    {
		output_simple_statement((yyvsp[(1) - (1)].str));
	;}
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 1595 "preproc.y"
    {
		fprintf(yyout,"ECPGdeallocate_desc(__LINE__, %s);",(yyvsp[(1) - (1)].str));
		whenever_action(0);
		free((yyvsp[(1) - (1)].str));
	;}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 1601 "preproc.y"
    {
		output_simple_statement((yyvsp[(1) - (1)].str));
	;}
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 1605 "preproc.y"
    {
		fprintf(yyout, "{ ECPGdescribe(__LINE__, %d, %s,", compat, (yyvsp[(1) - (1)].str));
		dump_variables(argsresult, 1);
		fputs("ECPGt_EORT);", yyout);
		fprintf(yyout, "}");
		output_line_number();

		free((yyvsp[(1) - (1)].str));
	;}
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 1615 "preproc.y"
    {
		if (connection)
			mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in DISCONNECT statement");

		fprintf(yyout, "{ ECPGdisconnect(__LINE__, %s);",
				(yyvsp[(1) - (1)].str) ? (yyvsp[(1) - (1)].str) : "\"CURRENT\"");
		whenever_action(2);
		free((yyvsp[(1) - (1)].str));
	;}
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 1624 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_exec_immediate); ;}
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 1626 "preproc.y"
    {
		const char *con = connection ? connection : "NULL";

		if (!strcmp((yyvsp[(1) - (1)].str), "all"))
			fprintf(yyout, "{ ECPGdeallocate_all(__LINE__, %d, %s);", compat, con);
		else if ((yyvsp[(1) - (1)].str)[0] == ':') 
			fprintf(yyout, "{ ECPGdeallocate(__LINE__, %d, %s, %s);", compat, con, (yyvsp[(1) - (1)].str)+1);
		else
			fprintf(yyout, "{ ECPGdeallocate(__LINE__, %d, %s, \"%s\");", compat, con, (yyvsp[(1) - (1)].str));

		whenever_action(2);
		free((yyvsp[(1) - (1)].str));
	;}
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 1640 "preproc.y"
    {
		lookup_descriptor((yyvsp[(1) - (1)].descriptor).name, connection);
		output_get_descr((yyvsp[(1) - (1)].descriptor).name, (yyvsp[(1) - (1)].descriptor).str);
		free((yyvsp[(1) - (1)].descriptor).name);
		free((yyvsp[(1) - (1)].descriptor).str);
	;}
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 1647 "preproc.y"
    {
		lookup_descriptor((yyvsp[(1) - (1)].str), connection);
		output_get_descr_header((yyvsp[(1) - (1)].str));
		free((yyvsp[(1) - (1)].str));
	;}
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 1653 "preproc.y"
    {
		struct cursor *ptr;

		if ((ptr = add_additional_variables((yyvsp[(1) - (1)].str), true)) != NULL)
		{
			connection = ptr->connection ? mm_strdup(ptr->connection) : NULL;
			output_statement(mm_strdup(ptr->command), 0, ECPGst_normal);
			ptr->opened = true;
		}
	;}
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 1664 "preproc.y"
    {
		fprintf(yyout, "{ ECPGsetcommit(__LINE__, \"%s\", %s);", (yyvsp[(1) - (1)].str), connection ? connection : "NULL");
		whenever_action(2);
		free((yyvsp[(1) - (1)].str));
	;}
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 1670 "preproc.y"
    {
		if (connection)
			mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in SET CONNECTION statement");

		fprintf(yyout, "{ ECPGsetconn(__LINE__, %s);", (yyvsp[(1) - (1)].str));
		whenever_action(2);
		free((yyvsp[(1) - (1)].str));
	;}
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 1679 "preproc.y"
    {
		lookup_descriptor((yyvsp[(1) - (1)].descriptor).name, connection);
		output_set_descr((yyvsp[(1) - (1)].descriptor).name, (yyvsp[(1) - (1)].descriptor).str);
		free((yyvsp[(1) - (1)].descriptor).name);
		free((yyvsp[(1) - (1)].descriptor).str);
	;}
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 1686 "preproc.y"
    {
		lookup_descriptor((yyvsp[(1) - (1)].str), connection);
		output_set_descr_header((yyvsp[(1) - (1)].str));
		free((yyvsp[(1) - (1)].str));
	;}
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 1692 "preproc.y"
    {
		if (connection)
			mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in TYPE statement");

		fprintf(yyout, "%s", (yyvsp[(1) - (1)].str));
		free((yyvsp[(1) - (1)].str));
		output_line_number();
	;}
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 1701 "preproc.y"
    {
		if (connection)
			mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in VAR statement");

		output_simple_statement((yyvsp[(1) - (1)].str));
	;}
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 1708 "preproc.y"
    {
		if (connection)
			mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in WHENEVER statement");

		output_simple_statement((yyvsp[(1) - (1)].str));
	;}
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 1715 "preproc.y"
    { (yyval.str) = NULL; ;}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 1721 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("create role"),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 1729 "preproc.y"
    { 
 (yyval.str) = make_str("with");
;}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 1733 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 1740 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 1744 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 1751 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 1755 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 1762 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("password"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 1766 "preproc.y"
    { 
 (yyval.str) = make_str("password null");
;}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 1770 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("encrypted password"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 1774 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("unencrypted password"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 1778 "preproc.y"
    { 
 (yyval.str) = make_str("superuser");
;}
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 1782 "preproc.y"
    { 
 (yyval.str) = make_str("nosuperuser");
;}
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 1786 "preproc.y"
    { 
 (yyval.str) = make_str("inherit");
;}
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 1790 "preproc.y"
    { 
 (yyval.str) = make_str("noinherit");
;}
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 1794 "preproc.y"
    { 
 (yyval.str) = make_str("createdb");
;}
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 1798 "preproc.y"
    { 
 (yyval.str) = make_str("nocreatedb");
;}
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 1802 "preproc.y"
    { 
 (yyval.str) = make_str("createrole");
;}
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 1806 "preproc.y"
    { 
 (yyval.str) = make_str("nocreaterole");
;}
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 1810 "preproc.y"
    { 
 (yyval.str) = make_str("createuser");
;}
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 1814 "preproc.y"
    { 
 (yyval.str) = make_str("nocreateuser");
;}
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 1818 "preproc.y"
    { 
 (yyval.str) = make_str("login");
;}
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 1822 "preproc.y"
    { 
 (yyval.str) = make_str("nologin");
;}
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 1826 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("connection limit"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 1830 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("valid until"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 1834 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("user"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 1842 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 1846 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("sysid"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 1850 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("admin"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 1854 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("role"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 1858 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("in role"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 1862 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("in group"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 1870 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("create user"),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 158:

/* Line 1455 of yacc.c  */
#line 1878 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter role"),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 159:

/* Line 1455 of yacc.c  */
#line 1886 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 1889 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("in database"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 1897 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter role"),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 1905 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter user"),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 1913 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("alter user"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 1921 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("drop role"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 1925 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("drop role if exists"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 166:

/* Line 1455 of yacc.c  */
#line 1933 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("drop user"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 167:

/* Line 1455 of yacc.c  */
#line 1937 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("drop user if exists"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 168:

/* Line 1455 of yacc.c  */
#line 1945 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("create group"),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 169:

/* Line 1455 of yacc.c  */
#line 1953 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("alter group"),(yyvsp[(3) - (6)].str),(yyvsp[(4) - (6)].str),make_str("user"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 170:

/* Line 1455 of yacc.c  */
#line 1961 "preproc.y"
    { 
 (yyval.str) = make_str("add");
;}
    break;

  case 171:

/* Line 1455 of yacc.c  */
#line 1965 "preproc.y"
    { 
 (yyval.str) = make_str("drop");
;}
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 1973 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("drop group"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 173:

/* Line 1455 of yacc.c  */
#line 1977 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("drop group if exists"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 1985 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("create schema"),(yyvsp[(3) - (6)].str),make_str("authorization"),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 1989 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("create schema"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 1997 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 2001 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 2008 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 179:

/* Line 1455 of yacc.c  */
#line 2012 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 180:

/* Line 1455 of yacc.c  */
#line 2019 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 181:

/* Line 1455 of yacc.c  */
#line 2023 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 182:

/* Line 1455 of yacc.c  */
#line 2027 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 183:

/* Line 1455 of yacc.c  */
#line 2031 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 184:

/* Line 1455 of yacc.c  */
#line 2035 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 185:

/* Line 1455 of yacc.c  */
#line 2039 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 186:

/* Line 1455 of yacc.c  */
#line 2047 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("set"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 187:

/* Line 1455 of yacc.c  */
#line 2051 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("set local"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 188:

/* Line 1455 of yacc.c  */
#line 2055 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("set session"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 189:

/* Line 1455 of yacc.c  */
#line 2063 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("to"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 190:

/* Line 1455 of yacc.c  */
#line 2067 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("="),(yyvsp[(3) - (3)].str));
;}
    break;

  case 191:

/* Line 1455 of yacc.c  */
#line 2071 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (3)].str),make_str("to default"));
;}
    break;

  case 192:

/* Line 1455 of yacc.c  */
#line 2075 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (3)].str),make_str("= default"));
;}
    break;

  case 193:

/* Line 1455 of yacc.c  */
#line 2079 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (3)].str),make_str("from current"));
;}
    break;

  case 194:

/* Line 1455 of yacc.c  */
#line 2083 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("time zone"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 195:

/* Line 1455 of yacc.c  */
#line 2087 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("transaction"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 196:

/* Line 1455 of yacc.c  */
#line 2091 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("session characteristics as transaction"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 197:

/* Line 1455 of yacc.c  */
#line 2095 "preproc.y"
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(2,make_str("catalog"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 198:

/* Line 1455 of yacc.c  */
#line 2100 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("schema"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 199:

/* Line 1455 of yacc.c  */
#line 2104 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("names"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 200:

/* Line 1455 of yacc.c  */
#line 2108 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("role"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 201:

/* Line 1455 of yacc.c  */
#line 2112 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("session authorization"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 202:

/* Line 1455 of yacc.c  */
#line 2116 "preproc.y"
    { 
 (yyval.str) = make_str("session authorization default");
;}
    break;

  case 203:

/* Line 1455 of yacc.c  */
#line 2120 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("xml option"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 204:

/* Line 1455 of yacc.c  */
#line 2128 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 205:

/* Line 1455 of yacc.c  */
#line 2132 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("."),(yyvsp[(3) - (3)].str));
;}
    break;

  case 206:

/* Line 1455 of yacc.c  */
#line 2140 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 207:

/* Line 1455 of yacc.c  */
#line 2144 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 208:

/* Line 1455 of yacc.c  */
#line 2152 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 209:

/* Line 1455 of yacc.c  */
#line 2156 "preproc.y"
    { 
		if ((yyvsp[(1) - (1)].str)[0] == '$')
		{
			free((yyvsp[(1) - (1)].str));
			(yyvsp[(1) - (1)].str) = make_str("$0");
		}

 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 210:

/* Line 1455 of yacc.c  */
#line 2170 "preproc.y"
    { 
 (yyval.str) = make_str("read uncommitted");
;}
    break;

  case 211:

/* Line 1455 of yacc.c  */
#line 2174 "preproc.y"
    { 
 (yyval.str) = make_str("read committed");
;}
    break;

  case 212:

/* Line 1455 of yacc.c  */
#line 2178 "preproc.y"
    { 
 (yyval.str) = make_str("repeatable read");
;}
    break;

  case 213:

/* Line 1455 of yacc.c  */
#line 2182 "preproc.y"
    { 
 (yyval.str) = make_str("serializable");
;}
    break;

  case 214:

/* Line 1455 of yacc.c  */
#line 2190 "preproc.y"
    { 
 (yyval.str) = make_str("true");
;}
    break;

  case 215:

/* Line 1455 of yacc.c  */
#line 2194 "preproc.y"
    { 
 (yyval.str) = make_str("false");
;}
    break;

  case 216:

/* Line 1455 of yacc.c  */
#line 2198 "preproc.y"
    { 
 (yyval.str) = make_str("on");
;}
    break;

  case 217:

/* Line 1455 of yacc.c  */
#line 2202 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 218:

/* Line 1455 of yacc.c  */
#line 2210 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 219:

/* Line 1455 of yacc.c  */
#line 2214 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 220:

/* Line 1455 of yacc.c  */
#line 2218 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 221:

/* Line 1455 of yacc.c  */
#line 2222 "preproc.y"
    { 
 (yyval.str) = cat_str(6,(yyvsp[(1) - (6)].str),make_str("("),(yyvsp[(3) - (6)].str),make_str(")"),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 222:

/* Line 1455 of yacc.c  */
#line 2226 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 223:

/* Line 1455 of yacc.c  */
#line 2230 "preproc.y"
    { 
 (yyval.str) = make_str("default");
;}
    break;

  case 224:

/* Line 1455 of yacc.c  */
#line 2234 "preproc.y"
    { 
 (yyval.str) = make_str("local");
;}
    break;

  case 225:

/* Line 1455 of yacc.c  */
#line 2242 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 226:

/* Line 1455 of yacc.c  */
#line 2246 "preproc.y"
    { 
 (yyval.str) = make_str("default");
;}
    break;

  case 227:

/* Line 1455 of yacc.c  */
#line 2250 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 228:

/* Line 1455 of yacc.c  */
#line 2257 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 229:

/* Line 1455 of yacc.c  */
#line 2261 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 230:

/* Line 1455 of yacc.c  */
#line 2269 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("reset"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 231:

/* Line 1455 of yacc.c  */
#line 2273 "preproc.y"
    { 
 (yyval.str) = make_str("reset time zone");
;}
    break;

  case 232:

/* Line 1455 of yacc.c  */
#line 2277 "preproc.y"
    { 
 (yyval.str) = make_str("reset transaction isolation level");
;}
    break;

  case 233:

/* Line 1455 of yacc.c  */
#line 2281 "preproc.y"
    { 
 (yyval.str) = make_str("reset session authorization");
;}
    break;

  case 234:

/* Line 1455 of yacc.c  */
#line 2285 "preproc.y"
    { 
 (yyval.str) = make_str("reset all");
;}
    break;

  case 235:

/* Line 1455 of yacc.c  */
#line 2293 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("set"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 236:

/* Line 1455 of yacc.c  */
#line 2297 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 237:

/* Line 1455 of yacc.c  */
#line 2305 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("show"),(yyvsp[(2) - (3)].str));
;}
    break;

  case 238:

/* Line 1455 of yacc.c  */
#line 2309 "preproc.y"
    { 
 (yyval.str) = make_str("show time zone");
;}
    break;

  case 239:

/* Line 1455 of yacc.c  */
#line 2313 "preproc.y"
    { 
 (yyval.str) = make_str("show transaction isolation level");
;}
    break;

  case 240:

/* Line 1455 of yacc.c  */
#line 2317 "preproc.y"
    { 
 (yyval.str) = make_str("show session authorization");
;}
    break;

  case 241:

/* Line 1455 of yacc.c  */
#line 2321 "preproc.y"
    {
		mmerror(PARSE_ERROR, ET_ERROR, "SHOW ALL is not implemented");
		(yyval.str) = EMPTY;
	;}
    break;

  case 242:

/* Line 1455 of yacc.c  */
#line 2330 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("set constraints"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 243:

/* Line 1455 of yacc.c  */
#line 2338 "preproc.y"
    { 
 (yyval.str) = make_str("all");
;}
    break;

  case 244:

/* Line 1455 of yacc.c  */
#line 2342 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 245:

/* Line 1455 of yacc.c  */
#line 2350 "preproc.y"
    { 
 (yyval.str) = make_str("deferred");
;}
    break;

  case 246:

/* Line 1455 of yacc.c  */
#line 2354 "preproc.y"
    { 
 (yyval.str) = make_str("immediate");
;}
    break;

  case 247:

/* Line 1455 of yacc.c  */
#line 2362 "preproc.y"
    { 
 (yyval.str) = make_str("checkpoint");
;}
    break;

  case 248:

/* Line 1455 of yacc.c  */
#line 2370 "preproc.y"
    { 
 (yyval.str) = make_str("discard all");
;}
    break;

  case 249:

/* Line 1455 of yacc.c  */
#line 2374 "preproc.y"
    { 
 (yyval.str) = make_str("discard temp");
;}
    break;

  case 250:

/* Line 1455 of yacc.c  */
#line 2378 "preproc.y"
    { 
 (yyval.str) = make_str("discard temporary");
;}
    break;

  case 251:

/* Line 1455 of yacc.c  */
#line 2382 "preproc.y"
    { 
 (yyval.str) = make_str("discard plans");
;}
    break;

  case 252:

/* Line 1455 of yacc.c  */
#line 2390 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("alter table"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 253:

/* Line 1455 of yacc.c  */
#line 2394 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("alter index"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 254:

/* Line 1455 of yacc.c  */
#line 2398 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("alter sequence"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 255:

/* Line 1455 of yacc.c  */
#line 2402 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("alter view"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 256:

/* Line 1455 of yacc.c  */
#line 2410 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 257:

/* Line 1455 of yacc.c  */
#line 2414 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 258:

/* Line 1455 of yacc.c  */
#line 2422 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("add"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 259:

/* Line 1455 of yacc.c  */
#line 2426 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("add column"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 260:

/* Line 1455 of yacc.c  */
#line 2430 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter"),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 261:

/* Line 1455 of yacc.c  */
#line 2434 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter"),(yyvsp[(2) - (6)].str),(yyvsp[(3) - (6)].str),make_str("drop not null"));
;}
    break;

  case 262:

/* Line 1455 of yacc.c  */
#line 2438 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter"),(yyvsp[(2) - (6)].str),(yyvsp[(3) - (6)].str),make_str("set not null"));
;}
    break;

  case 263:

/* Line 1455 of yacc.c  */
#line 2442 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("alter"),(yyvsp[(2) - (6)].str),(yyvsp[(3) - (6)].str),make_str("set statistics"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 264:

/* Line 1455 of yacc.c  */
#line 2446 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("alter"),(yyvsp[(2) - (5)].str),(yyvsp[(3) - (5)].str),make_str("set"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 265:

/* Line 1455 of yacc.c  */
#line 2450 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("alter"),(yyvsp[(2) - (5)].str),(yyvsp[(3) - (5)].str),make_str("reset"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 266:

/* Line 1455 of yacc.c  */
#line 2454 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("alter"),(yyvsp[(2) - (6)].str),(yyvsp[(3) - (6)].str),make_str("set storage"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 267:

/* Line 1455 of yacc.c  */
#line 2458 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("drop"),(yyvsp[(2) - (6)].str),make_str("if exists"),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 268:

/* Line 1455 of yacc.c  */
#line 2462 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("drop"),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 269:

/* Line 1455 of yacc.c  */
#line 2466 "preproc.y"
    { 
 (yyval.str) = cat_str(7,make_str("alter"),(yyvsp[(2) - (7)].str),(yyvsp[(3) - (7)].str),(yyvsp[(4) - (7)].str),make_str("type"),(yyvsp[(6) - (7)].str),(yyvsp[(7) - (7)].str));
;}
    break;

  case 270:

/* Line 1455 of yacc.c  */
#line 2470 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("add"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 271:

/* Line 1455 of yacc.c  */
#line 2474 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("drop constraint if exists"),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 272:

/* Line 1455 of yacc.c  */
#line 2478 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("drop constraint"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 273:

/* Line 1455 of yacc.c  */
#line 2482 "preproc.y"
    { 
 (yyval.str) = make_str("set with oids");
;}
    break;

  case 274:

/* Line 1455 of yacc.c  */
#line 2486 "preproc.y"
    { 
 (yyval.str) = make_str("set without oids");
;}
    break;

  case 275:

/* Line 1455 of yacc.c  */
#line 2490 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("cluster on"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 276:

/* Line 1455 of yacc.c  */
#line 2494 "preproc.y"
    { 
 (yyval.str) = make_str("set without cluster");
;}
    break;

  case 277:

/* Line 1455 of yacc.c  */
#line 2498 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("enable trigger"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 278:

/* Line 1455 of yacc.c  */
#line 2502 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("enable always trigger"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 279:

/* Line 1455 of yacc.c  */
#line 2506 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("enable replica trigger"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 280:

/* Line 1455 of yacc.c  */
#line 2510 "preproc.y"
    { 
 (yyval.str) = make_str("enable trigger all");
;}
    break;

  case 281:

/* Line 1455 of yacc.c  */
#line 2514 "preproc.y"
    { 
 (yyval.str) = make_str("enable trigger user");
;}
    break;

  case 282:

/* Line 1455 of yacc.c  */
#line 2518 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("disable trigger"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 283:

/* Line 1455 of yacc.c  */
#line 2522 "preproc.y"
    { 
 (yyval.str) = make_str("disable trigger all");
;}
    break;

  case 284:

/* Line 1455 of yacc.c  */
#line 2526 "preproc.y"
    { 
 (yyval.str) = make_str("disable trigger user");
;}
    break;

  case 285:

/* Line 1455 of yacc.c  */
#line 2530 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("enable rule"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 286:

/* Line 1455 of yacc.c  */
#line 2534 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("enable always rule"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 287:

/* Line 1455 of yacc.c  */
#line 2538 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("enable replica rule"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 288:

/* Line 1455 of yacc.c  */
#line 2542 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("disable rule"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 289:

/* Line 1455 of yacc.c  */
#line 2546 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("inherit"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 290:

/* Line 1455 of yacc.c  */
#line 2550 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("no inherit"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 291:

/* Line 1455 of yacc.c  */
#line 2554 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("owner to"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 292:

/* Line 1455 of yacc.c  */
#line 2558 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("set tablespace"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 293:

/* Line 1455 of yacc.c  */
#line 2562 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("set"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 294:

/* Line 1455 of yacc.c  */
#line 2566 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("reset"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 295:

/* Line 1455 of yacc.c  */
#line 2574 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("set default"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 296:

/* Line 1455 of yacc.c  */
#line 2578 "preproc.y"
    { 
 (yyval.str) = make_str("drop default");
;}
    break;

  case 297:

/* Line 1455 of yacc.c  */
#line 2586 "preproc.y"
    { 
 (yyval.str) = make_str("cascade");
;}
    break;

  case 298:

/* Line 1455 of yacc.c  */
#line 2590 "preproc.y"
    { 
 (yyval.str) = make_str("restrict");
;}
    break;

  case 299:

/* Line 1455 of yacc.c  */
#line 2594 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 300:

/* Line 1455 of yacc.c  */
#line 2601 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("using"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 301:

/* Line 1455 of yacc.c  */
#line 2605 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 302:

/* Line 1455 of yacc.c  */
#line 2612 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 303:

/* Line 1455 of yacc.c  */
#line 2620 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("with"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 304:

/* Line 1455 of yacc.c  */
#line 2624 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 305:

/* Line 1455 of yacc.c  */
#line 2631 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 306:

/* Line 1455 of yacc.c  */
#line 2635 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 307:

/* Line 1455 of yacc.c  */
#line 2643 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("="),(yyvsp[(3) - (3)].str));
;}
    break;

  case 308:

/* Line 1455 of yacc.c  */
#line 2647 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 309:

/* Line 1455 of yacc.c  */
#line 2651 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (5)].str),make_str("."),(yyvsp[(3) - (5)].str),make_str("="),(yyvsp[(5) - (5)].str));
;}
    break;

  case 310:

/* Line 1455 of yacc.c  */
#line 2655 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("."),(yyvsp[(3) - (3)].str));
;}
    break;

  case 311:

/* Line 1455 of yacc.c  */
#line 2663 "preproc.y"
    {
		char *cursor_marker = (yyvsp[(2) - (2)].str)[0] == ':' ? make_str("$0") : (yyvsp[(2) - (2)].str);
		(yyval.str) = cat2_str(make_str("close"), cursor_marker);
	;}
    break;

  case 312:

/* Line 1455 of yacc.c  */
#line 2668 "preproc.y"
    { 
 (yyval.str) = make_str("close all");
;}
    break;

  case 313:

/* Line 1455 of yacc.c  */
#line 2676 "preproc.y"
    { 
			if (strcmp((yyvsp[(6) - (10)].str), "to") == 0 && strcmp((yyvsp[(7) - (10)].str), "stdin") == 0)
				mmerror(PARSE_ERROR, ET_ERROR, "COPY TO STDIN is not possible");
			else if (strcmp((yyvsp[(6) - (10)].str), "from") == 0 && strcmp((yyvsp[(7) - (10)].str), "stdout") == 0)
				mmerror(PARSE_ERROR, ET_ERROR, "COPY FROM STDOUT is not possible");
			else if (strcmp((yyvsp[(6) - (10)].str), "from") == 0 && strcmp((yyvsp[(7) - (10)].str), "stdin") == 0)
				mmerror(PARSE_ERROR, ET_WARNING, "COPY FROM STDIN is not implemented");

 (yyval.str) = cat_str(10,make_str("copy"),(yyvsp[(2) - (10)].str),(yyvsp[(3) - (10)].str),(yyvsp[(4) - (10)].str),(yyvsp[(5) - (10)].str),(yyvsp[(6) - (10)].str),(yyvsp[(7) - (10)].str),(yyvsp[(8) - (10)].str),(yyvsp[(9) - (10)].str),(yyvsp[(10) - (10)].str));
;}
    break;

  case 314:

/* Line 1455 of yacc.c  */
#line 2687 "preproc.y"
    { 
			if (strcmp((yyvsp[(4) - (6)].str), "stdin") == 0)
				mmerror(PARSE_ERROR, ET_ERROR, "COPY TO STDIN is not possible");

 (yyval.str) = cat_str(6,make_str("copy"),(yyvsp[(2) - (6)].str),make_str("to"),(yyvsp[(4) - (6)].str),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 315:

/* Line 1455 of yacc.c  */
#line 2698 "preproc.y"
    { 
 (yyval.str) = make_str("from");
;}
    break;

  case 316:

/* Line 1455 of yacc.c  */
#line 2702 "preproc.y"
    { 
 (yyval.str) = make_str("to");
;}
    break;

  case 317:

/* Line 1455 of yacc.c  */
#line 2710 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 318:

/* Line 1455 of yacc.c  */
#line 2714 "preproc.y"
    { 
 (yyval.str) = make_str("stdin");
;}
    break;

  case 319:

/* Line 1455 of yacc.c  */
#line 2718 "preproc.y"
    { 
 (yyval.str) = make_str("stdout");
;}
    break;

  case 320:

/* Line 1455 of yacc.c  */
#line 2726 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 321:

/* Line 1455 of yacc.c  */
#line 2730 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 322:

/* Line 1455 of yacc.c  */
#line 2738 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 323:

/* Line 1455 of yacc.c  */
#line 2742 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 324:

/* Line 1455 of yacc.c  */
#line 2749 "preproc.y"
    { 
 (yyval.str) = make_str("binary");
;}
    break;

  case 325:

/* Line 1455 of yacc.c  */
#line 2753 "preproc.y"
    { 
 (yyval.str) = make_str("oids");
;}
    break;

  case 326:

/* Line 1455 of yacc.c  */
#line 2757 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("delimiter"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 327:

/* Line 1455 of yacc.c  */
#line 2761 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("null"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 328:

/* Line 1455 of yacc.c  */
#line 2765 "preproc.y"
    { 
 (yyval.str) = make_str("csv");
;}
    break;

  case 329:

/* Line 1455 of yacc.c  */
#line 2769 "preproc.y"
    { 
 (yyval.str) = make_str("header");
;}
    break;

  case 330:

/* Line 1455 of yacc.c  */
#line 2773 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("quote"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 331:

/* Line 1455 of yacc.c  */
#line 2777 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("escape"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 332:

/* Line 1455 of yacc.c  */
#line 2781 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("force quote"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 333:

/* Line 1455 of yacc.c  */
#line 2785 "preproc.y"
    { 
 (yyval.str) = make_str("force quote *");
;}
    break;

  case 334:

/* Line 1455 of yacc.c  */
#line 2789 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("force not null"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 335:

/* Line 1455 of yacc.c  */
#line 2797 "preproc.y"
    { 
 (yyval.str) = make_str("binary");
;}
    break;

  case 336:

/* Line 1455 of yacc.c  */
#line 2801 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 337:

/* Line 1455 of yacc.c  */
#line 2808 "preproc.y"
    { 
 (yyval.str) = make_str("with oids");
;}
    break;

  case 338:

/* Line 1455 of yacc.c  */
#line 2812 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 339:

/* Line 1455 of yacc.c  */
#line 2819 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("delimiters"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 340:

/* Line 1455 of yacc.c  */
#line 2823 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 341:

/* Line 1455 of yacc.c  */
#line 2830 "preproc.y"
    { 
 (yyval.str) = make_str("using");
;}
    break;

  case 342:

/* Line 1455 of yacc.c  */
#line 2834 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 343:

/* Line 1455 of yacc.c  */
#line 2841 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 344:

/* Line 1455 of yacc.c  */
#line 2845 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 345:

/* Line 1455 of yacc.c  */
#line 2853 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 346:

/* Line 1455 of yacc.c  */
#line 2861 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 347:

/* Line 1455 of yacc.c  */
#line 2865 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 348:

/* Line 1455 of yacc.c  */
#line 2869 "preproc.y"
    { 
 (yyval.str) = make_str("*");
;}
    break;

  case 349:

/* Line 1455 of yacc.c  */
#line 2873 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 350:

/* Line 1455 of yacc.c  */
#line 2877 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 351:

/* Line 1455 of yacc.c  */
#line 2884 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 352:

/* Line 1455 of yacc.c  */
#line 2888 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 353:

/* Line 1455 of yacc.c  */
#line 2896 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 354:

/* Line 1455 of yacc.c  */
#line 2904 "preproc.y"
    { 
 (yyval.str) = cat_str(11,make_str("create"),(yyvsp[(2) - (11)].str),make_str("table"),(yyvsp[(4) - (11)].str),make_str("("),(yyvsp[(6) - (11)].str),make_str(")"),(yyvsp[(8) - (11)].str),(yyvsp[(9) - (11)].str),(yyvsp[(10) - (11)].str),(yyvsp[(11) - (11)].str));
;}
    break;

  case 355:

/* Line 1455 of yacc.c  */
#line 2908 "preproc.y"
    { 
 (yyval.str) = cat_str(10,make_str("create"),(yyvsp[(2) - (10)].str),make_str("table"),(yyvsp[(4) - (10)].str),make_str("of"),(yyvsp[(6) - (10)].str),(yyvsp[(7) - (10)].str),(yyvsp[(8) - (10)].str),(yyvsp[(9) - (10)].str),(yyvsp[(10) - (10)].str));
;}
    break;

  case 356:

/* Line 1455 of yacc.c  */
#line 2916 "preproc.y"
    { 
 (yyval.str) = make_str("temporary");
;}
    break;

  case 357:

/* Line 1455 of yacc.c  */
#line 2920 "preproc.y"
    { 
 (yyval.str) = make_str("temp");
;}
    break;

  case 358:

/* Line 1455 of yacc.c  */
#line 2924 "preproc.y"
    { 
 (yyval.str) = make_str("local temporary");
;}
    break;

  case 359:

/* Line 1455 of yacc.c  */
#line 2928 "preproc.y"
    { 
 (yyval.str) = make_str("local temp");
;}
    break;

  case 360:

/* Line 1455 of yacc.c  */
#line 2932 "preproc.y"
    { 
 (yyval.str) = make_str("global temporary");
;}
    break;

  case 361:

/* Line 1455 of yacc.c  */
#line 2936 "preproc.y"
    { 
 (yyval.str) = make_str("global temp");
;}
    break;

  case 362:

/* Line 1455 of yacc.c  */
#line 2940 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 363:

/* Line 1455 of yacc.c  */
#line 2947 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 364:

/* Line 1455 of yacc.c  */
#line 2951 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 365:

/* Line 1455 of yacc.c  */
#line 2958 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 366:

/* Line 1455 of yacc.c  */
#line 2962 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 367:

/* Line 1455 of yacc.c  */
#line 2969 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 368:

/* Line 1455 of yacc.c  */
#line 2973 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 369:

/* Line 1455 of yacc.c  */
#line 2981 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 370:

/* Line 1455 of yacc.c  */
#line 2985 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 371:

/* Line 1455 of yacc.c  */
#line 2993 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 372:

/* Line 1455 of yacc.c  */
#line 2997 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 373:

/* Line 1455 of yacc.c  */
#line 3001 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 374:

/* Line 1455 of yacc.c  */
#line 3009 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 375:

/* Line 1455 of yacc.c  */
#line 3013 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 376:

/* Line 1455 of yacc.c  */
#line 3021 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 377:

/* Line 1455 of yacc.c  */
#line 3029 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (4)].str),make_str("with options"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 378:

/* Line 1455 of yacc.c  */
#line 3037 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 379:

/* Line 1455 of yacc.c  */
#line 3041 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 380:

/* Line 1455 of yacc.c  */
#line 3048 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("constraint"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 381:

/* Line 1455 of yacc.c  */
#line 3052 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 382:

/* Line 1455 of yacc.c  */
#line 3056 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 383:

/* Line 1455 of yacc.c  */
#line 3064 "preproc.y"
    { 
 (yyval.str) = make_str("not null");
;}
    break;

  case 384:

/* Line 1455 of yacc.c  */
#line 3068 "preproc.y"
    { 
 (yyval.str) = make_str("null");
;}
    break;

  case 385:

/* Line 1455 of yacc.c  */
#line 3072 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("unique"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 386:

/* Line 1455 of yacc.c  */
#line 3076 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("primary key"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 387:

/* Line 1455 of yacc.c  */
#line 3080 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("check ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 388:

/* Line 1455 of yacc.c  */
#line 3084 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("default"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 389:

/* Line 1455 of yacc.c  */
#line 3088 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("references"),(yyvsp[(2) - (5)].str),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 390:

/* Line 1455 of yacc.c  */
#line 3096 "preproc.y"
    { 
 (yyval.str) = make_str("deferrable");
;}
    break;

  case 391:

/* Line 1455 of yacc.c  */
#line 3100 "preproc.y"
    { 
 (yyval.str) = make_str("not deferrable");
;}
    break;

  case 392:

/* Line 1455 of yacc.c  */
#line 3104 "preproc.y"
    { 
 (yyval.str) = make_str("initially deferred");
;}
    break;

  case 393:

/* Line 1455 of yacc.c  */
#line 3108 "preproc.y"
    { 
 (yyval.str) = make_str("initially immediate");
;}
    break;

  case 394:

/* Line 1455 of yacc.c  */
#line 3116 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("like"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 395:

/* Line 1455 of yacc.c  */
#line 3124 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("including"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 396:

/* Line 1455 of yacc.c  */
#line 3128 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("excluding"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 397:

/* Line 1455 of yacc.c  */
#line 3132 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 398:

/* Line 1455 of yacc.c  */
#line 3139 "preproc.y"
    { 
 (yyval.str) = make_str("defaults");
;}
    break;

  case 399:

/* Line 1455 of yacc.c  */
#line 3143 "preproc.y"
    { 
 (yyval.str) = make_str("constraints");
;}
    break;

  case 400:

/* Line 1455 of yacc.c  */
#line 3147 "preproc.y"
    { 
 (yyval.str) = make_str("indexes");
;}
    break;

  case 401:

/* Line 1455 of yacc.c  */
#line 3151 "preproc.y"
    { 
 (yyval.str) = make_str("storage");
;}
    break;

  case 402:

/* Line 1455 of yacc.c  */
#line 3155 "preproc.y"
    { 
 (yyval.str) = make_str("comments");
;}
    break;

  case 403:

/* Line 1455 of yacc.c  */
#line 3159 "preproc.y"
    { 
 (yyval.str) = make_str("all");
;}
    break;

  case 404:

/* Line 1455 of yacc.c  */
#line 3167 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("constraint"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 405:

/* Line 1455 of yacc.c  */
#line 3171 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 406:

/* Line 1455 of yacc.c  */
#line 3179 "preproc.y"
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(4,make_str("check ("),(yyvsp[(3) - (5)].str),make_str(")"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 407:

/* Line 1455 of yacc.c  */
#line 3184 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("unique ("),(yyvsp[(3) - (7)].str),make_str(")"),(yyvsp[(5) - (7)].str),(yyvsp[(6) - (7)].str),(yyvsp[(7) - (7)].str));
;}
    break;

  case 408:

/* Line 1455 of yacc.c  */
#line 3188 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("primary key ("),(yyvsp[(4) - (8)].str),make_str(")"),(yyvsp[(6) - (8)].str),(yyvsp[(7) - (8)].str),(yyvsp[(8) - (8)].str));
;}
    break;

  case 409:

/* Line 1455 of yacc.c  */
#line 3192 "preproc.y"
    { 
 (yyval.str) = cat_str(9,make_str("exclude"),(yyvsp[(2) - (9)].str),make_str("("),(yyvsp[(4) - (9)].str),make_str(")"),(yyvsp[(6) - (9)].str),(yyvsp[(7) - (9)].str),(yyvsp[(8) - (9)].str),(yyvsp[(9) - (9)].str));
;}
    break;

  case 410:

/* Line 1455 of yacc.c  */
#line 3196 "preproc.y"
    { 
 (yyval.str) = cat_str(8,make_str("foreign key ("),(yyvsp[(4) - (11)].str),make_str(") references"),(yyvsp[(7) - (11)].str),(yyvsp[(8) - (11)].str),(yyvsp[(9) - (11)].str),(yyvsp[(10) - (11)].str),(yyvsp[(11) - (11)].str));
;}
    break;

  case 411:

/* Line 1455 of yacc.c  */
#line 3204 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 412:

/* Line 1455 of yacc.c  */
#line 3208 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 413:

/* Line 1455 of yacc.c  */
#line 3215 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 414:

/* Line 1455 of yacc.c  */
#line 3219 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 415:

/* Line 1455 of yacc.c  */
#line 3227 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 416:

/* Line 1455 of yacc.c  */
#line 3235 "preproc.y"
    { 
 (yyval.str) = make_str("match full");
;}
    break;

  case 417:

/* Line 1455 of yacc.c  */
#line 3239 "preproc.y"
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = make_str("match partial");
;}
    break;

  case 418:

/* Line 1455 of yacc.c  */
#line 3244 "preproc.y"
    { 
 (yyval.str) = make_str("match simple");
;}
    break;

  case 419:

/* Line 1455 of yacc.c  */
#line 3248 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 420:

/* Line 1455 of yacc.c  */
#line 3255 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 421:

/* Line 1455 of yacc.c  */
#line 3259 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 422:

/* Line 1455 of yacc.c  */
#line 3267 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("with"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 423:

/* Line 1455 of yacc.c  */
#line 3271 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (6)].str),make_str("with operator ("),(yyvsp[(5) - (6)].str),make_str(")"));
;}
    break;

  case 424:

/* Line 1455 of yacc.c  */
#line 3279 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("where ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 425:

/* Line 1455 of yacc.c  */
#line 3283 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 426:

/* Line 1455 of yacc.c  */
#line 3290 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 427:

/* Line 1455 of yacc.c  */
#line 3294 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 428:

/* Line 1455 of yacc.c  */
#line 3298 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 429:

/* Line 1455 of yacc.c  */
#line 3302 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 430:

/* Line 1455 of yacc.c  */
#line 3306 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 431:

/* Line 1455 of yacc.c  */
#line 3313 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("on update"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 432:

/* Line 1455 of yacc.c  */
#line 3321 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("on delete"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 433:

/* Line 1455 of yacc.c  */
#line 3329 "preproc.y"
    { 
 (yyval.str) = make_str("no action");
;}
    break;

  case 434:

/* Line 1455 of yacc.c  */
#line 3333 "preproc.y"
    { 
 (yyval.str) = make_str("restrict");
;}
    break;

  case 435:

/* Line 1455 of yacc.c  */
#line 3337 "preproc.y"
    { 
 (yyval.str) = make_str("cascade");
;}
    break;

  case 436:

/* Line 1455 of yacc.c  */
#line 3341 "preproc.y"
    { 
 (yyval.str) = make_str("set null");
;}
    break;

  case 437:

/* Line 1455 of yacc.c  */
#line 3345 "preproc.y"
    { 
 (yyval.str) = make_str("set default");
;}
    break;

  case 438:

/* Line 1455 of yacc.c  */
#line 3353 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("inherits ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 439:

/* Line 1455 of yacc.c  */
#line 3357 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 440:

/* Line 1455 of yacc.c  */
#line 3364 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("with"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 441:

/* Line 1455 of yacc.c  */
#line 3368 "preproc.y"
    { 
 (yyval.str) = make_str("with oids");
;}
    break;

  case 442:

/* Line 1455 of yacc.c  */
#line 3372 "preproc.y"
    { 
 (yyval.str) = make_str("without oids");
;}
    break;

  case 443:

/* Line 1455 of yacc.c  */
#line 3376 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 444:

/* Line 1455 of yacc.c  */
#line 3383 "preproc.y"
    { 
 (yyval.str) = make_str("on commit drop");
;}
    break;

  case 445:

/* Line 1455 of yacc.c  */
#line 3387 "preproc.y"
    { 
 (yyval.str) = make_str("on commit delete rows");
;}
    break;

  case 446:

/* Line 1455 of yacc.c  */
#line 3391 "preproc.y"
    { 
 (yyval.str) = make_str("on commit preserve rows");
;}
    break;

  case 447:

/* Line 1455 of yacc.c  */
#line 3395 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 448:

/* Line 1455 of yacc.c  */
#line 3402 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("tablespace"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 449:

/* Line 1455 of yacc.c  */
#line 3406 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 450:

/* Line 1455 of yacc.c  */
#line 3413 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("using index tablespace"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 451:

/* Line 1455 of yacc.c  */
#line 3417 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 452:

/* Line 1455 of yacc.c  */
#line 3424 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (5)].str),(yyvsp[(2) - (5)].str),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 453:

/* Line 1455 of yacc.c  */
#line 3432 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 454:

/* Line 1455 of yacc.c  */
#line 3436 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 455:

/* Line 1455 of yacc.c  */
#line 3443 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 456:

/* Line 1455 of yacc.c  */
#line 3447 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 457:

/* Line 1455 of yacc.c  */
#line 3455 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 458:

/* Line 1455 of yacc.c  */
#line 3463 "preproc.y"
    { 
 (yyval.str) = make_str("with data");
;}
    break;

  case 459:

/* Line 1455 of yacc.c  */
#line 3467 "preproc.y"
    { 
 (yyval.str) = make_str("with no data");
;}
    break;

  case 460:

/* Line 1455 of yacc.c  */
#line 3471 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 461:

/* Line 1455 of yacc.c  */
#line 3478 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("create"),(yyvsp[(2) - (5)].str),make_str("sequence"),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 462:

/* Line 1455 of yacc.c  */
#line 3486 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("alter sequence"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 463:

/* Line 1455 of yacc.c  */
#line 3494 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 464:

/* Line 1455 of yacc.c  */
#line 3498 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 465:

/* Line 1455 of yacc.c  */
#line 3505 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 466:

/* Line 1455 of yacc.c  */
#line 3509 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 467:

/* Line 1455 of yacc.c  */
#line 3517 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("cache"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 468:

/* Line 1455 of yacc.c  */
#line 3521 "preproc.y"
    { 
 (yyval.str) = make_str("cycle");
;}
    break;

  case 469:

/* Line 1455 of yacc.c  */
#line 3525 "preproc.y"
    { 
 (yyval.str) = make_str("no cycle");
;}
    break;

  case 470:

/* Line 1455 of yacc.c  */
#line 3529 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("increment"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 471:

/* Line 1455 of yacc.c  */
#line 3533 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("maxvalue"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 472:

/* Line 1455 of yacc.c  */
#line 3537 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("minvalue"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 473:

/* Line 1455 of yacc.c  */
#line 3541 "preproc.y"
    { 
 (yyval.str) = make_str("no maxvalue");
;}
    break;

  case 474:

/* Line 1455 of yacc.c  */
#line 3545 "preproc.y"
    { 
 (yyval.str) = make_str("no minvalue");
;}
    break;

  case 475:

/* Line 1455 of yacc.c  */
#line 3549 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("owned by"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 476:

/* Line 1455 of yacc.c  */
#line 3553 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("start"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 477:

/* Line 1455 of yacc.c  */
#line 3557 "preproc.y"
    { 
 (yyval.str) = make_str("restart");
;}
    break;

  case 478:

/* Line 1455 of yacc.c  */
#line 3561 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("restart"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 479:

/* Line 1455 of yacc.c  */
#line 3569 "preproc.y"
    { 
 (yyval.str) = make_str("by");
;}
    break;

  case 480:

/* Line 1455 of yacc.c  */
#line 3573 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 481:

/* Line 1455 of yacc.c  */
#line 3580 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 482:

/* Line 1455 of yacc.c  */
#line 3584 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("-"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 483:

/* Line 1455 of yacc.c  */
#line 3588 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 484:

/* Line 1455 of yacc.c  */
#line 3596 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 485:

/* Line 1455 of yacc.c  */
#line 3600 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 486:

/* Line 1455 of yacc.c  */
#line 3608 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("create"),(yyvsp[(2) - (6)].str),(yyvsp[(3) - (6)].str),(yyvsp[(4) - (6)].str),make_str("language"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 487:

/* Line 1455 of yacc.c  */
#line 3612 "preproc.y"
    { 
 (yyval.str) = cat_str(10,make_str("create"),(yyvsp[(2) - (10)].str),(yyvsp[(3) - (10)].str),(yyvsp[(4) - (10)].str),make_str("language"),(yyvsp[(6) - (10)].str),make_str("handler"),(yyvsp[(8) - (10)].str),(yyvsp[(9) - (10)].str),(yyvsp[(10) - (10)].str));
;}
    break;

  case 488:

/* Line 1455 of yacc.c  */
#line 3620 "preproc.y"
    { 
 (yyval.str) = make_str("trusted");
;}
    break;

  case 489:

/* Line 1455 of yacc.c  */
#line 3624 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 490:

/* Line 1455 of yacc.c  */
#line 3631 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 491:

/* Line 1455 of yacc.c  */
#line 3635 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 492:

/* Line 1455 of yacc.c  */
#line 3643 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("inline"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 493:

/* Line 1455 of yacc.c  */
#line 3647 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 494:

/* Line 1455 of yacc.c  */
#line 3654 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("validator"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 495:

/* Line 1455 of yacc.c  */
#line 3658 "preproc.y"
    { 
 (yyval.str) = make_str("no validator");
;}
    break;

  case 496:

/* Line 1455 of yacc.c  */
#line 3666 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 497:

/* Line 1455 of yacc.c  */
#line 3670 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 498:

/* Line 1455 of yacc.c  */
#line 3677 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("drop"),(yyvsp[(2) - (5)].str),make_str("language"),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 499:

/* Line 1455 of yacc.c  */
#line 3681 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("drop"),(yyvsp[(2) - (7)].str),make_str("language if exists"),(yyvsp[(6) - (7)].str),(yyvsp[(7) - (7)].str));
;}
    break;

  case 500:

/* Line 1455 of yacc.c  */
#line 3689 "preproc.y"
    { 
 (yyval.str) = make_str("procedural");
;}
    break;

  case 501:

/* Line 1455 of yacc.c  */
#line 3693 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 502:

/* Line 1455 of yacc.c  */
#line 3700 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("create tablespace"),(yyvsp[(3) - (6)].str),(yyvsp[(4) - (6)].str),make_str("location"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 503:

/* Line 1455 of yacc.c  */
#line 3708 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("owner"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 504:

/* Line 1455 of yacc.c  */
#line 3712 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 505:

/* Line 1455 of yacc.c  */
#line 3719 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("drop tablespace"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 506:

/* Line 1455 of yacc.c  */
#line 3723 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("drop tablespace if exists"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 507:

/* Line 1455 of yacc.c  */
#line 3731 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("create foreign data wrapper"),(yyvsp[(5) - (7)].str),(yyvsp[(6) - (7)].str),(yyvsp[(7) - (7)].str));
;}
    break;

  case 508:

/* Line 1455 of yacc.c  */
#line 3739 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("drop foreign data wrapper"),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 509:

/* Line 1455 of yacc.c  */
#line 3743 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("drop foreign data wrapper if exists"),(yyvsp[(7) - (8)].str),(yyvsp[(8) - (8)].str));
;}
    break;

  case 510:

/* Line 1455 of yacc.c  */
#line 3751 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter foreign data wrapper"),(yyvsp[(5) - (7)].str),(yyvsp[(6) - (7)].str),(yyvsp[(7) - (7)].str));
;}
    break;

  case 511:

/* Line 1455 of yacc.c  */
#line 3755 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("alter foreign data wrapper"),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 512:

/* Line 1455 of yacc.c  */
#line 3759 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("alter foreign data wrapper"),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 513:

/* Line 1455 of yacc.c  */
#line 3767 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("options ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 514:

/* Line 1455 of yacc.c  */
#line 3771 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 515:

/* Line 1455 of yacc.c  */
#line 3778 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 516:

/* Line 1455 of yacc.c  */
#line 3782 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 517:

/* Line 1455 of yacc.c  */
#line 3790 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("options ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 518:

/* Line 1455 of yacc.c  */
#line 3798 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 519:

/* Line 1455 of yacc.c  */
#line 3802 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 520:

/* Line 1455 of yacc.c  */
#line 3810 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 521:

/* Line 1455 of yacc.c  */
#line 3814 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("set"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 522:

/* Line 1455 of yacc.c  */
#line 3818 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("add"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 523:

/* Line 1455 of yacc.c  */
#line 3822 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("drop"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 524:

/* Line 1455 of yacc.c  */
#line 3830 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 525:

/* Line 1455 of yacc.c  */
#line 3838 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 526:

/* Line 1455 of yacc.c  */
#line 3846 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 527:

/* Line 1455 of yacc.c  */
#line 3854 "preproc.y"
    { 
 (yyval.str) = cat_str(7,make_str("create server"),(yyvsp[(3) - (10)].str),(yyvsp[(4) - (10)].str),(yyvsp[(5) - (10)].str),make_str("foreign data wrapper"),(yyvsp[(9) - (10)].str),(yyvsp[(10) - (10)].str));
;}
    break;

  case 528:

/* Line 1455 of yacc.c  */
#line 3862 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("type"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 529:

/* Line 1455 of yacc.c  */
#line 3866 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 530:

/* Line 1455 of yacc.c  */
#line 3873 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("version"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 531:

/* Line 1455 of yacc.c  */
#line 3877 "preproc.y"
    { 
 (yyval.str) = make_str("version null");
;}
    break;

  case 532:

/* Line 1455 of yacc.c  */
#line 3885 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 533:

/* Line 1455 of yacc.c  */
#line 3889 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 534:

/* Line 1455 of yacc.c  */
#line 3896 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("drop server"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 535:

/* Line 1455 of yacc.c  */
#line 3900 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("drop server if exists"),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 536:

/* Line 1455 of yacc.c  */
#line 3908 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter server"),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 537:

/* Line 1455 of yacc.c  */
#line 3912 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("alter server"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 538:

/* Line 1455 of yacc.c  */
#line 3916 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("alter server"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 539:

/* Line 1455 of yacc.c  */
#line 3924 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("create user mapping for"),(yyvsp[(5) - (8)].str),make_str("server"),(yyvsp[(7) - (8)].str),(yyvsp[(8) - (8)].str));
;}
    break;

  case 540:

/* Line 1455 of yacc.c  */
#line 3932 "preproc.y"
    { 
 (yyval.str) = make_str("current_user");
;}
    break;

  case 541:

/* Line 1455 of yacc.c  */
#line 3936 "preproc.y"
    { 
 (yyval.str) = make_str("user");
;}
    break;

  case 542:

/* Line 1455 of yacc.c  */
#line 3940 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 543:

/* Line 1455 of yacc.c  */
#line 3948 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("drop user mapping for"),(yyvsp[(5) - (7)].str),make_str("server"),(yyvsp[(7) - (7)].str));
;}
    break;

  case 544:

/* Line 1455 of yacc.c  */
#line 3952 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("drop user mapping if exists for"),(yyvsp[(7) - (9)].str),make_str("server"),(yyvsp[(9) - (9)].str));
;}
    break;

  case 545:

/* Line 1455 of yacc.c  */
#line 3960 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("alter user mapping for"),(yyvsp[(5) - (8)].str),make_str("server"),(yyvsp[(7) - (8)].str),(yyvsp[(8) - (8)].str));
;}
    break;

  case 546:

/* Line 1455 of yacc.c  */
#line 3968 "preproc.y"
    { 
 (yyval.str) = cat_str(13,make_str("create trigger"),(yyvsp[(3) - (15)].str),(yyvsp[(4) - (15)].str),(yyvsp[(5) - (15)].str),make_str("on"),(yyvsp[(7) - (15)].str),(yyvsp[(8) - (15)].str),(yyvsp[(9) - (15)].str),make_str("execute procedure"),(yyvsp[(12) - (15)].str),make_str("("),(yyvsp[(14) - (15)].str),make_str(")"));
;}
    break;

  case 547:

/* Line 1455 of yacc.c  */
#line 3972 "preproc.y"
    { 
 (yyval.str) = cat_str(15,make_str("create constraint trigger"),(yyvsp[(4) - (20)].str),make_str("after"),(yyvsp[(6) - (20)].str),make_str("on"),(yyvsp[(8) - (20)].str),(yyvsp[(9) - (20)].str),(yyvsp[(10) - (20)].str),make_str("for each row"),(yyvsp[(14) - (20)].str),make_str("execute procedure"),(yyvsp[(17) - (20)].str),make_str("("),(yyvsp[(19) - (20)].str),make_str(")"));
;}
    break;

  case 548:

/* Line 1455 of yacc.c  */
#line 3980 "preproc.y"
    { 
 (yyval.str) = make_str("before");
;}
    break;

  case 549:

/* Line 1455 of yacc.c  */
#line 3984 "preproc.y"
    { 
 (yyval.str) = make_str("after");
;}
    break;

  case 550:

/* Line 1455 of yacc.c  */
#line 3992 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 551:

/* Line 1455 of yacc.c  */
#line 3996 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("or"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 552:

/* Line 1455 of yacc.c  */
#line 4004 "preproc.y"
    { 
 (yyval.str) = make_str("insert");
;}
    break;

  case 553:

/* Line 1455 of yacc.c  */
#line 4008 "preproc.y"
    { 
 (yyval.str) = make_str("delete");
;}
    break;

  case 554:

/* Line 1455 of yacc.c  */
#line 4012 "preproc.y"
    { 
 (yyval.str) = make_str("update");
;}
    break;

  case 555:

/* Line 1455 of yacc.c  */
#line 4016 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("update of"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 556:

/* Line 1455 of yacc.c  */
#line 4020 "preproc.y"
    { 
 (yyval.str) = make_str("truncate");
;}
    break;

  case 557:

/* Line 1455 of yacc.c  */
#line 4028 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("for"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 558:

/* Line 1455 of yacc.c  */
#line 4032 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 559:

/* Line 1455 of yacc.c  */
#line 4039 "preproc.y"
    { 
 (yyval.str) = make_str("each");
;}
    break;

  case 560:

/* Line 1455 of yacc.c  */
#line 4043 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 561:

/* Line 1455 of yacc.c  */
#line 4050 "preproc.y"
    { 
 (yyval.str) = make_str("row");
;}
    break;

  case 562:

/* Line 1455 of yacc.c  */
#line 4054 "preproc.y"
    { 
 (yyval.str) = make_str("statement");
;}
    break;

  case 563:

/* Line 1455 of yacc.c  */
#line 4062 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("when ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 564:

/* Line 1455 of yacc.c  */
#line 4066 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 565:

/* Line 1455 of yacc.c  */
#line 4073 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 566:

/* Line 1455 of yacc.c  */
#line 4077 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 567:

/* Line 1455 of yacc.c  */
#line 4081 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 568:

/* Line 1455 of yacc.c  */
#line 4088 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 569:

/* Line 1455 of yacc.c  */
#line 4092 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 570:

/* Line 1455 of yacc.c  */
#line 4096 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 571:

/* Line 1455 of yacc.c  */
#line 4100 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 572:

/* Line 1455 of yacc.c  */
#line 4104 "preproc.y"
    { 
 (yyval.str) = make_str("xconst");
;}
    break;

  case 573:

/* Line 1455 of yacc.c  */
#line 4108 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 574:

/* Line 1455 of yacc.c  */
#line 4116 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("from"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 575:

/* Line 1455 of yacc.c  */
#line 4120 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 576:

/* Line 1455 of yacc.c  */
#line 4127 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 577:

/* Line 1455 of yacc.c  */
#line 4131 "preproc.y"
    { 
			if (strcmp((yyvsp[(1) - (2)].str), "deferrable") != 0 && strcmp((yyvsp[(2) - (2)].str), "initially deferrable") == 0 )
				mmerror(PARSE_ERROR, ET_ERROR, "constraint declared INITIALLY DEFERRED must be DEFERRABLE");

 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 578:

/* Line 1455 of yacc.c  */
#line 4138 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 579:

/* Line 1455 of yacc.c  */
#line 4142 "preproc.y"
    { 
			if (strcmp((yyvsp[(2) - (2)].str), "deferrable") != 0 && strcmp((yyvsp[(1) - (2)].str), "initially deferrable") == 0 )
				mmerror(PARSE_ERROR, ET_ERROR, "constraint declared INITIALLY DEFERRED must be DEFERRABLE");

 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 580:

/* Line 1455 of yacc.c  */
#line 4149 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 581:

/* Line 1455 of yacc.c  */
#line 4156 "preproc.y"
    { 
 (yyval.str) = make_str("not deferrable");
;}
    break;

  case 582:

/* Line 1455 of yacc.c  */
#line 4160 "preproc.y"
    { 
 (yyval.str) = make_str("deferrable");
;}
    break;

  case 583:

/* Line 1455 of yacc.c  */
#line 4168 "preproc.y"
    { 
 (yyval.str) = make_str("initially immediate");
;}
    break;

  case 584:

/* Line 1455 of yacc.c  */
#line 4172 "preproc.y"
    { 
 (yyval.str) = make_str("initially deferred");
;}
    break;

  case 585:

/* Line 1455 of yacc.c  */
#line 4180 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("drop trigger"),(yyvsp[(3) - (6)].str),make_str("on"),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 586:

/* Line 1455 of yacc.c  */
#line 4184 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("drop trigger if exists"),(yyvsp[(5) - (8)].str),make_str("on"),(yyvsp[(7) - (8)].str),(yyvsp[(8) - (8)].str));
;}
    break;

  case 587:

/* Line 1455 of yacc.c  */
#line 4192 "preproc.y"
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(6,make_str("create assertion"),(yyvsp[(3) - (8)].str),make_str("check ("),(yyvsp[(6) - (8)].str),make_str(")"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 588:

/* Line 1455 of yacc.c  */
#line 4201 "preproc.y"
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(3,make_str("drop assertion"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 589:

/* Line 1455 of yacc.c  */
#line 4210 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("create aggregate"),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 590:

/* Line 1455 of yacc.c  */
#line 4214 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("create aggregate"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 591:

/* Line 1455 of yacc.c  */
#line 4218 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("create operator"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 592:

/* Line 1455 of yacc.c  */
#line 4222 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("create type"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 593:

/* Line 1455 of yacc.c  */
#line 4226 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("create type"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 594:

/* Line 1455 of yacc.c  */
#line 4230 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("create type"),(yyvsp[(3) - (7)].str),make_str("as ("),(yyvsp[(6) - (7)].str),make_str(")"));
;}
    break;

  case 595:

/* Line 1455 of yacc.c  */
#line 4234 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("create type"),(yyvsp[(3) - (8)].str),make_str("as enum ("),(yyvsp[(7) - (8)].str),make_str(")"));
;}
    break;

  case 596:

/* Line 1455 of yacc.c  */
#line 4238 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("create text search parser"),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 597:

/* Line 1455 of yacc.c  */
#line 4242 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("create text search dictionary"),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 598:

/* Line 1455 of yacc.c  */
#line 4246 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("create text search template"),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 599:

/* Line 1455 of yacc.c  */
#line 4250 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("create text search configuration"),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 600:

/* Line 1455 of yacc.c  */
#line 4258 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 601:

/* Line 1455 of yacc.c  */
#line 4266 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 602:

/* Line 1455 of yacc.c  */
#line 4270 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 603:

/* Line 1455 of yacc.c  */
#line 4278 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("="),(yyvsp[(3) - (3)].str));
;}
    break;

  case 604:

/* Line 1455 of yacc.c  */
#line 4282 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 605:

/* Line 1455 of yacc.c  */
#line 4290 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 606:

/* Line 1455 of yacc.c  */
#line 4294 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 607:

/* Line 1455 of yacc.c  */
#line 4298 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 608:

/* Line 1455 of yacc.c  */
#line 4302 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 609:

/* Line 1455 of yacc.c  */
#line 4306 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 610:

/* Line 1455 of yacc.c  */
#line 4314 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 611:

/* Line 1455 of yacc.c  */
#line 4318 "preproc.y"
    { 
 (yyval.str) = make_str("( * )");
;}
    break;

  case 612:

/* Line 1455 of yacc.c  */
#line 4326 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 613:

/* Line 1455 of yacc.c  */
#line 4334 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 614:

/* Line 1455 of yacc.c  */
#line 4338 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 615:

/* Line 1455 of yacc.c  */
#line 4346 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("="),(yyvsp[(3) - (3)].str));
;}
    break;

  case 616:

/* Line 1455 of yacc.c  */
#line 4354 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 617:

/* Line 1455 of yacc.c  */
#line 4358 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 618:

/* Line 1455 of yacc.c  */
#line 4365 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 619:

/* Line 1455 of yacc.c  */
#line 4369 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 620:

/* Line 1455 of yacc.c  */
#line 4377 "preproc.y"
    { 
 (yyval.str) = cat_str(10,make_str("create operator class"),(yyvsp[(4) - (13)].str),(yyvsp[(5) - (13)].str),make_str("for type"),(yyvsp[(8) - (13)].str),make_str("using"),(yyvsp[(10) - (13)].str),(yyvsp[(11) - (13)].str),make_str("as"),(yyvsp[(13) - (13)].str));
;}
    break;

  case 621:

/* Line 1455 of yacc.c  */
#line 4385 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 622:

/* Line 1455 of yacc.c  */
#line 4389 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 623:

/* Line 1455 of yacc.c  */
#line 4397 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("operator"),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 624:

/* Line 1455 of yacc.c  */
#line 4401 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("operator"),(yyvsp[(2) - (5)].str),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 625:

/* Line 1455 of yacc.c  */
#line 4405 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("function"),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 626:

/* Line 1455 of yacc.c  */
#line 4409 "preproc.y"
    { 
 (yyval.str) = cat_str(7,make_str("function"),(yyvsp[(2) - (7)].str),make_str("("),(yyvsp[(4) - (7)].str),make_str(")"),(yyvsp[(6) - (7)].str),(yyvsp[(7) - (7)].str));
;}
    break;

  case 627:

/* Line 1455 of yacc.c  */
#line 4413 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("storage"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 628:

/* Line 1455 of yacc.c  */
#line 4421 "preproc.y"
    { 
 (yyval.str) = make_str("default");
;}
    break;

  case 629:

/* Line 1455 of yacc.c  */
#line 4425 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 630:

/* Line 1455 of yacc.c  */
#line 4432 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("family"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 631:

/* Line 1455 of yacc.c  */
#line 4436 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 632:

/* Line 1455 of yacc.c  */
#line 4443 "preproc.y"
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = make_str("recheck");
;}
    break;

  case 633:

/* Line 1455 of yacc.c  */
#line 4448 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 634:

/* Line 1455 of yacc.c  */
#line 4455 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("create operator family"),(yyvsp[(4) - (6)].str),make_str("using"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 635:

/* Line 1455 of yacc.c  */
#line 4463 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("alter operator family"),(yyvsp[(4) - (8)].str),make_str("using"),(yyvsp[(6) - (8)].str),make_str("add"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 636:

/* Line 1455 of yacc.c  */
#line 4467 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("alter operator family"),(yyvsp[(4) - (8)].str),make_str("using"),(yyvsp[(6) - (8)].str),make_str("drop"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 637:

/* Line 1455 of yacc.c  */
#line 4475 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 638:

/* Line 1455 of yacc.c  */
#line 4479 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 639:

/* Line 1455 of yacc.c  */
#line 4487 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("operator"),(yyvsp[(2) - (5)].str),make_str("("),(yyvsp[(4) - (5)].str),make_str(")"));
;}
    break;

  case 640:

/* Line 1455 of yacc.c  */
#line 4491 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("function"),(yyvsp[(2) - (5)].str),make_str("("),(yyvsp[(4) - (5)].str),make_str(")"));
;}
    break;

  case 641:

/* Line 1455 of yacc.c  */
#line 4499 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("drop operator class"),(yyvsp[(4) - (7)].str),make_str("using"),(yyvsp[(6) - (7)].str),(yyvsp[(7) - (7)].str));
;}
    break;

  case 642:

/* Line 1455 of yacc.c  */
#line 4503 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("drop operator class if exists"),(yyvsp[(6) - (9)].str),make_str("using"),(yyvsp[(8) - (9)].str),(yyvsp[(9) - (9)].str));
;}
    break;

  case 643:

/* Line 1455 of yacc.c  */
#line 4511 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("drop operator family"),(yyvsp[(4) - (7)].str),make_str("using"),(yyvsp[(6) - (7)].str),(yyvsp[(7) - (7)].str));
;}
    break;

  case 644:

/* Line 1455 of yacc.c  */
#line 4515 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("drop operator family if exists"),(yyvsp[(6) - (9)].str),make_str("using"),(yyvsp[(8) - (9)].str),(yyvsp[(9) - (9)].str));
;}
    break;

  case 645:

/* Line 1455 of yacc.c  */
#line 4523 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("drop owned by"),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 646:

/* Line 1455 of yacc.c  */
#line 4531 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("reassign owned by"),(yyvsp[(4) - (6)].str),make_str("to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 647:

/* Line 1455 of yacc.c  */
#line 4539 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("drop"),(yyvsp[(2) - (6)].str),make_str("if exists"),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 648:

/* Line 1455 of yacc.c  */
#line 4543 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("drop"),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 649:

/* Line 1455 of yacc.c  */
#line 4551 "preproc.y"
    { 
 (yyval.str) = make_str("table");
;}
    break;

  case 650:

/* Line 1455 of yacc.c  */
#line 4555 "preproc.y"
    { 
 (yyval.str) = make_str("sequence");
;}
    break;

  case 651:

/* Line 1455 of yacc.c  */
#line 4559 "preproc.y"
    { 
 (yyval.str) = make_str("view");
;}
    break;

  case 652:

/* Line 1455 of yacc.c  */
#line 4563 "preproc.y"
    { 
 (yyval.str) = make_str("index");
;}
    break;

  case 653:

/* Line 1455 of yacc.c  */
#line 4567 "preproc.y"
    { 
 (yyval.str) = make_str("type");
;}
    break;

  case 654:

/* Line 1455 of yacc.c  */
#line 4571 "preproc.y"
    { 
 (yyval.str) = make_str("domain");
;}
    break;

  case 655:

/* Line 1455 of yacc.c  */
#line 4575 "preproc.y"
    { 
 (yyval.str) = make_str("conversion");
;}
    break;

  case 656:

/* Line 1455 of yacc.c  */
#line 4579 "preproc.y"
    { 
 (yyval.str) = make_str("schema");
;}
    break;

  case 657:

/* Line 1455 of yacc.c  */
#line 4583 "preproc.y"
    { 
 (yyval.str) = make_str("text search parser");
;}
    break;

  case 658:

/* Line 1455 of yacc.c  */
#line 4587 "preproc.y"
    { 
 (yyval.str) = make_str("text search dictionary");
;}
    break;

  case 659:

/* Line 1455 of yacc.c  */
#line 4591 "preproc.y"
    { 
 (yyval.str) = make_str("text search template");
;}
    break;

  case 660:

/* Line 1455 of yacc.c  */
#line 4595 "preproc.y"
    { 
 (yyval.str) = make_str("text search configuration");
;}
    break;

  case 661:

/* Line 1455 of yacc.c  */
#line 4603 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 662:

/* Line 1455 of yacc.c  */
#line 4607 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 663:

/* Line 1455 of yacc.c  */
#line 4615 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 664:

/* Line 1455 of yacc.c  */
#line 4619 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 665:

/* Line 1455 of yacc.c  */
#line 4627 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("."),(yyvsp[(2) - (2)].str));
;}
    break;

  case 666:

/* Line 1455 of yacc.c  */
#line 4631 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("."),(yyvsp[(3) - (3)].str));
;}
    break;

  case 667:

/* Line 1455 of yacc.c  */
#line 4639 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("truncate"),(yyvsp[(2) - (5)].str),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 668:

/* Line 1455 of yacc.c  */
#line 4647 "preproc.y"
    { 
 (yyval.str) = make_str("continue identity");
;}
    break;

  case 669:

/* Line 1455 of yacc.c  */
#line 4651 "preproc.y"
    { 
 (yyval.str) = make_str("restart identity");
;}
    break;

  case 670:

/* Line 1455 of yacc.c  */
#line 4655 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 671:

/* Line 1455 of yacc.c  */
#line 4662 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("comment on"),(yyvsp[(3) - (6)].str),(yyvsp[(4) - (6)].str),make_str("is"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 672:

/* Line 1455 of yacc.c  */
#line 4666 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("comment on aggregate"),(yyvsp[(4) - (7)].str),(yyvsp[(5) - (7)].str),make_str("is"),(yyvsp[(7) - (7)].str));
;}
    break;

  case 673:

/* Line 1455 of yacc.c  */
#line 4670 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("comment on function"),(yyvsp[(4) - (7)].str),(yyvsp[(5) - (7)].str),make_str("is"),(yyvsp[(7) - (7)].str));
;}
    break;

  case 674:

/* Line 1455 of yacc.c  */
#line 4674 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("comment on operator"),(yyvsp[(4) - (7)].str),(yyvsp[(5) - (7)].str),make_str("is"),(yyvsp[(7) - (7)].str));
;}
    break;

  case 675:

/* Line 1455 of yacc.c  */
#line 4678 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("comment on constraint"),(yyvsp[(4) - (8)].str),make_str("on"),(yyvsp[(6) - (8)].str),make_str("is"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 676:

/* Line 1455 of yacc.c  */
#line 4682 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("comment on rule"),(yyvsp[(4) - (8)].str),make_str("on"),(yyvsp[(6) - (8)].str),make_str("is"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 677:

/* Line 1455 of yacc.c  */
#line 4686 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("comment on rule"),(yyvsp[(4) - (6)].str),make_str("is"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 678:

/* Line 1455 of yacc.c  */
#line 4690 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("comment on trigger"),(yyvsp[(4) - (8)].str),make_str("on"),(yyvsp[(6) - (8)].str),make_str("is"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 679:

/* Line 1455 of yacc.c  */
#line 4694 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("comment on operator class"),(yyvsp[(5) - (9)].str),make_str("using"),(yyvsp[(7) - (9)].str),make_str("is"),(yyvsp[(9) - (9)].str));
;}
    break;

  case 680:

/* Line 1455 of yacc.c  */
#line 4698 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("comment on operator family"),(yyvsp[(5) - (9)].str),make_str("using"),(yyvsp[(7) - (9)].str),make_str("is"),(yyvsp[(9) - (9)].str));
;}
    break;

  case 681:

/* Line 1455 of yacc.c  */
#line 4702 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("comment on large object"),(yyvsp[(5) - (7)].str),make_str("is"),(yyvsp[(7) - (7)].str));
;}
    break;

  case 682:

/* Line 1455 of yacc.c  */
#line 4706 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("comment on cast ("),(yyvsp[(5) - (10)].str),make_str("as"),(yyvsp[(7) - (10)].str),make_str(") is"),(yyvsp[(10) - (10)].str));
;}
    break;

  case 683:

/* Line 1455 of yacc.c  */
#line 4710 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("comment on"),(yyvsp[(3) - (7)].str),make_str("language"),(yyvsp[(5) - (7)].str),make_str("is"),(yyvsp[(7) - (7)].str));
;}
    break;

  case 684:

/* Line 1455 of yacc.c  */
#line 4714 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("comment on text search parser"),(yyvsp[(6) - (8)].str),make_str("is"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 685:

/* Line 1455 of yacc.c  */
#line 4718 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("comment on text search dictionary"),(yyvsp[(6) - (8)].str),make_str("is"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 686:

/* Line 1455 of yacc.c  */
#line 4722 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("comment on text search template"),(yyvsp[(6) - (8)].str),make_str("is"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 687:

/* Line 1455 of yacc.c  */
#line 4726 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("comment on text search configuration"),(yyvsp[(6) - (8)].str),make_str("is"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 688:

/* Line 1455 of yacc.c  */
#line 4734 "preproc.y"
    { 
 (yyval.str) = make_str("column");
;}
    break;

  case 689:

/* Line 1455 of yacc.c  */
#line 4738 "preproc.y"
    { 
 (yyval.str) = make_str("database");
;}
    break;

  case 690:

/* Line 1455 of yacc.c  */
#line 4742 "preproc.y"
    { 
 (yyval.str) = make_str("schema");
;}
    break;

  case 691:

/* Line 1455 of yacc.c  */
#line 4746 "preproc.y"
    { 
 (yyval.str) = make_str("index");
;}
    break;

  case 692:

/* Line 1455 of yacc.c  */
#line 4750 "preproc.y"
    { 
 (yyval.str) = make_str("sequence");
;}
    break;

  case 693:

/* Line 1455 of yacc.c  */
#line 4754 "preproc.y"
    { 
 (yyval.str) = make_str("table");
;}
    break;

  case 694:

/* Line 1455 of yacc.c  */
#line 4758 "preproc.y"
    { 
 (yyval.str) = make_str("domain");
;}
    break;

  case 695:

/* Line 1455 of yacc.c  */
#line 4762 "preproc.y"
    { 
 (yyval.str) = make_str("type");
;}
    break;

  case 696:

/* Line 1455 of yacc.c  */
#line 4766 "preproc.y"
    { 
 (yyval.str) = make_str("view");
;}
    break;

  case 697:

/* Line 1455 of yacc.c  */
#line 4770 "preproc.y"
    { 
 (yyval.str) = make_str("conversion");
;}
    break;

  case 698:

/* Line 1455 of yacc.c  */
#line 4774 "preproc.y"
    { 
 (yyval.str) = make_str("tablespace");
;}
    break;

  case 699:

/* Line 1455 of yacc.c  */
#line 4778 "preproc.y"
    { 
 (yyval.str) = make_str("role");
;}
    break;

  case 700:

/* Line 1455 of yacc.c  */
#line 4786 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 701:

/* Line 1455 of yacc.c  */
#line 4790 "preproc.y"
    { 
 (yyval.str) = make_str("null");
;}
    break;

  case 702:

/* Line 1455 of yacc.c  */
#line 4798 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("fetch"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 703:

/* Line 1455 of yacc.c  */
#line 4802 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("move"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 704:

/* Line 1455 of yacc.c  */
#line 4806 "preproc.y"
    {
		(yyval.str) = cat2_str(make_str("fetch"), (yyvsp[(2) - (3)].str));
	;}
    break;

  case 705:

/* Line 1455 of yacc.c  */
#line 4810 "preproc.y"
    {
		char *cursor_marker = (yyvsp[(3) - (4)].str)[0] == ':' ? make_str("$0") : (yyvsp[(3) - (4)].str);
		add_additional_variables((yyvsp[(3) - (4)].str), false);
		(yyval.str) = cat_str(2, make_str("fetch forward"), cursor_marker);
	;}
    break;

  case 706:

/* Line 1455 of yacc.c  */
#line 4816 "preproc.y"
    {
		char *cursor_marker = (yyvsp[(4) - (5)].str)[0] == ':' ? make_str("$0") : (yyvsp[(4) - (5)].str);
		add_additional_variables((yyvsp[(4) - (5)].str), false);
		(yyval.str) = cat_str(2, make_str("fetch forward from"), cursor_marker);
	;}
    break;

  case 707:

/* Line 1455 of yacc.c  */
#line 4822 "preproc.y"
    {
		char *cursor_marker = (yyvsp[(3) - (4)].str)[0] == ':' ? make_str("$0") : (yyvsp[(3) - (4)].str);
		add_additional_variables((yyvsp[(3) - (4)].str), false);
		(yyval.str) = cat_str(2, make_str("fetch backward"), cursor_marker);
	;}
    break;

  case 708:

/* Line 1455 of yacc.c  */
#line 4828 "preproc.y"
    {
		char *cursor_marker = (yyvsp[(4) - (5)].str)[0] == ':' ? make_str("$0") : (yyvsp[(4) - (5)].str);
		add_additional_variables((yyvsp[(4) - (5)].str), false);
		(yyval.str) = cat_str(2, make_str("fetch backward from"), cursor_marker);
	;}
    break;

  case 709:

/* Line 1455 of yacc.c  */
#line 4834 "preproc.y"
    {
		char *cursor_marker = (yyvsp[(3) - (3)].str)[0] == ':' ? make_str("$0") : (yyvsp[(3) - (3)].str);
		add_additional_variables((yyvsp[(3) - (3)].str), false);
		(yyval.str) = cat_str(2, make_str("move forward"), cursor_marker);
	;}
    break;

  case 710:

/* Line 1455 of yacc.c  */
#line 4840 "preproc.y"
    {
		char *cursor_marker = (yyvsp[(4) - (4)].str)[0] == ':' ? make_str("$0") : (yyvsp[(4) - (4)].str);
		add_additional_variables((yyvsp[(4) - (4)].str), false);
		(yyval.str) = cat_str(2, make_str("move forward from"), cursor_marker);
	;}
    break;

  case 711:

/* Line 1455 of yacc.c  */
#line 4846 "preproc.y"
    {
		char *cursor_marker = (yyvsp[(3) - (3)].str)[0] == ':' ? make_str("$0") : (yyvsp[(3) - (3)].str);
		add_additional_variables((yyvsp[(3) - (3)].str), false);
		(yyval.str) = cat_str(2, make_str("move backward"), cursor_marker);
	;}
    break;

  case 712:

/* Line 1455 of yacc.c  */
#line 4852 "preproc.y"
    {
		char *cursor_marker = (yyvsp[(4) - (4)].str)[0] == ':' ? make_str("$0") : (yyvsp[(4) - (4)].str);
		add_additional_variables((yyvsp[(4) - (4)].str), false);
		(yyval.str) = cat_str(2, make_str("move backward from"), cursor_marker);
	;}
    break;

  case 713:

/* Line 1455 of yacc.c  */
#line 4862 "preproc.y"
    { 
		add_additional_variables((yyvsp[(1) - (1)].str), false);
		if ((yyvsp[(1) - (1)].str)[0] == ':')
		{
			free((yyvsp[(1) - (1)].str));
			(yyvsp[(1) - (1)].str) = make_str("$0");
		}

 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 714:

/* Line 1455 of yacc.c  */
#line 4873 "preproc.y"
    { 
		add_additional_variables((yyvsp[(2) - (2)].str), false);
		if ((yyvsp[(2) - (2)].str)[0] == ':')
		{
			free((yyvsp[(2) - (2)].str));
			(yyvsp[(2) - (2)].str) = make_str("$0");
		}

 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 715:

/* Line 1455 of yacc.c  */
#line 4884 "preproc.y"
    { 
		add_additional_variables((yyvsp[(3) - (3)].str), false);
		if ((yyvsp[(3) - (3)].str)[0] == ':')
		{
			free((yyvsp[(3) - (3)].str));
			(yyvsp[(3) - (3)].str) = make_str("$0");
		}

 (yyval.str) = cat_str(3,make_str("next"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 716:

/* Line 1455 of yacc.c  */
#line 4895 "preproc.y"
    { 
		add_additional_variables((yyvsp[(3) - (3)].str), false);
		if ((yyvsp[(3) - (3)].str)[0] == ':')
		{
			free((yyvsp[(3) - (3)].str));
			(yyvsp[(3) - (3)].str) = make_str("$0");
		}

 (yyval.str) = cat_str(3,make_str("prior"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 717:

/* Line 1455 of yacc.c  */
#line 4906 "preproc.y"
    { 
		add_additional_variables((yyvsp[(3) - (3)].str), false);
		if ((yyvsp[(3) - (3)].str)[0] == ':')
		{
			free((yyvsp[(3) - (3)].str));
			(yyvsp[(3) - (3)].str) = make_str("$0");
		}

 (yyval.str) = cat_str(3,make_str("first"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 718:

/* Line 1455 of yacc.c  */
#line 4917 "preproc.y"
    { 
		add_additional_variables((yyvsp[(3) - (3)].str), false);
		if ((yyvsp[(3) - (3)].str)[0] == ':')
		{
			free((yyvsp[(3) - (3)].str));
			(yyvsp[(3) - (3)].str) = make_str("$0");
		}

 (yyval.str) = cat_str(3,make_str("last"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 719:

/* Line 1455 of yacc.c  */
#line 4928 "preproc.y"
    { 
		add_additional_variables((yyvsp[(4) - (4)].str), false);
		if ((yyvsp[(4) - (4)].str)[0] == ':')
		{
			free((yyvsp[(4) - (4)].str));
			(yyvsp[(4) - (4)].str) = make_str("$0");
		}
		if ((yyvsp[(2) - (4)].str)[0] == '$')
		{
			free((yyvsp[(2) - (4)].str));
			(yyvsp[(2) - (4)].str) = make_str("$0");
		}

 (yyval.str) = cat_str(4,make_str("absolute"),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 720:

/* Line 1455 of yacc.c  */
#line 4944 "preproc.y"
    { 
		add_additional_variables((yyvsp[(4) - (4)].str), false);
		if ((yyvsp[(4) - (4)].str)[0] == ':')
		{
			free((yyvsp[(4) - (4)].str));
			(yyvsp[(4) - (4)].str) = make_str("$0");
		}
		if ((yyvsp[(2) - (4)].str)[0] == '$')
		{
			free((yyvsp[(2) - (4)].str));
			(yyvsp[(2) - (4)].str) = make_str("$0");
		}

 (yyval.str) = cat_str(4,make_str("relative"),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 721:

/* Line 1455 of yacc.c  */
#line 4960 "preproc.y"
    { 
		add_additional_variables((yyvsp[(3) - (3)].str), false);
		if ((yyvsp[(3) - (3)].str)[0] == ':')
		{
			free((yyvsp[(3) - (3)].str));
			(yyvsp[(3) - (3)].str) = make_str("$0");
		}
		if ((yyvsp[(1) - (3)].str)[0] == '$')
		{
			free((yyvsp[(1) - (3)].str));
			(yyvsp[(1) - (3)].str) = make_str("$0");
		}

 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 722:

/* Line 1455 of yacc.c  */
#line 4976 "preproc.y"
    { 
		add_additional_variables((yyvsp[(3) - (3)].str), false);
		if ((yyvsp[(3) - (3)].str)[0] == ':')
		{
			free((yyvsp[(3) - (3)].str));
			(yyvsp[(3) - (3)].str) = make_str("$0");
		}

 (yyval.str) = cat_str(3,make_str("all"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 723:

/* Line 1455 of yacc.c  */
#line 4987 "preproc.y"
    { 
		add_additional_variables((yyvsp[(4) - (4)].str), false);
		if ((yyvsp[(4) - (4)].str)[0] == ':')
		{
			free((yyvsp[(4) - (4)].str));
			(yyvsp[(4) - (4)].str) = make_str("$0");
		}
		if ((yyvsp[(2) - (4)].str)[0] == '$')
		{
			free((yyvsp[(2) - (4)].str));
			(yyvsp[(2) - (4)].str) = make_str("$0");
		}

 (yyval.str) = cat_str(4,make_str("forward"),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 724:

/* Line 1455 of yacc.c  */
#line 5003 "preproc.y"
    { 
		add_additional_variables((yyvsp[(4) - (4)].str), false);
		if ((yyvsp[(4) - (4)].str)[0] == ':')
		{
			free((yyvsp[(4) - (4)].str));
			(yyvsp[(4) - (4)].str) = make_str("$0");
		}

 (yyval.str) = cat_str(3,make_str("forward all"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 725:

/* Line 1455 of yacc.c  */
#line 5014 "preproc.y"
    { 
		add_additional_variables((yyvsp[(4) - (4)].str), false);
		if ((yyvsp[(4) - (4)].str)[0] == ':')
		{
			free((yyvsp[(4) - (4)].str));
			(yyvsp[(4) - (4)].str) = make_str("$0");
		}
		if ((yyvsp[(2) - (4)].str)[0] == '$')
		{
			free((yyvsp[(2) - (4)].str));
			(yyvsp[(2) - (4)].str) = make_str("$0");
		}

 (yyval.str) = cat_str(4,make_str("backward"),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 726:

/* Line 1455 of yacc.c  */
#line 5030 "preproc.y"
    { 
		add_additional_variables((yyvsp[(4) - (4)].str), false);
		if ((yyvsp[(4) - (4)].str)[0] == ':')
		{
			free((yyvsp[(4) - (4)].str));
			(yyvsp[(4) - (4)].str) = make_str("$0");
		}

 (yyval.str) = cat_str(3,make_str("backward all"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 727:

/* Line 1455 of yacc.c  */
#line 5045 "preproc.y"
    { 
 (yyval.str) = make_str("from");
;}
    break;

  case 728:

/* Line 1455 of yacc.c  */
#line 5049 "preproc.y"
    { 
 (yyval.str) = make_str("in");
;}
    break;

  case 729:

/* Line 1455 of yacc.c  */
#line 5057 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 730:

/* Line 1455 of yacc.c  */
#line 5061 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 731:

/* Line 1455 of yacc.c  */
#line 5068 "preproc.y"
    { 
 (yyval.str) = cat_str(7,make_str("grant"),(yyvsp[(2) - (7)].str),make_str("on"),(yyvsp[(4) - (7)].str),make_str("to"),(yyvsp[(6) - (7)].str),(yyvsp[(7) - (7)].str));
;}
    break;

  case 732:

/* Line 1455 of yacc.c  */
#line 5076 "preproc.y"
    { 
 (yyval.str) = cat_str(7,make_str("revoke"),(yyvsp[(2) - (7)].str),make_str("on"),(yyvsp[(4) - (7)].str),make_str("from"),(yyvsp[(6) - (7)].str),(yyvsp[(7) - (7)].str));
;}
    break;

  case 733:

/* Line 1455 of yacc.c  */
#line 5080 "preproc.y"
    { 
 (yyval.str) = cat_str(7,make_str("revoke grant option for"),(yyvsp[(5) - (10)].str),make_str("on"),(yyvsp[(7) - (10)].str),make_str("from"),(yyvsp[(9) - (10)].str),(yyvsp[(10) - (10)].str));
;}
    break;

  case 734:

/* Line 1455 of yacc.c  */
#line 5088 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 735:

/* Line 1455 of yacc.c  */
#line 5092 "preproc.y"
    { 
 (yyval.str) = make_str("all");
;}
    break;

  case 736:

/* Line 1455 of yacc.c  */
#line 5096 "preproc.y"
    { 
 (yyval.str) = make_str("all privileges");
;}
    break;

  case 737:

/* Line 1455 of yacc.c  */
#line 5100 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("all ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 738:

/* Line 1455 of yacc.c  */
#line 5104 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("all privileges ("),(yyvsp[(4) - (5)].str),make_str(")"));
;}
    break;

  case 739:

/* Line 1455 of yacc.c  */
#line 5112 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 740:

/* Line 1455 of yacc.c  */
#line 5116 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 741:

/* Line 1455 of yacc.c  */
#line 5124 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("select"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 742:

/* Line 1455 of yacc.c  */
#line 5128 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("references"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 743:

/* Line 1455 of yacc.c  */
#line 5132 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("create"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 744:

/* Line 1455 of yacc.c  */
#line 5136 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 745:

/* Line 1455 of yacc.c  */
#line 5144 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 746:

/* Line 1455 of yacc.c  */
#line 5148 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("table"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 747:

/* Line 1455 of yacc.c  */
#line 5152 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("sequence"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 748:

/* Line 1455 of yacc.c  */
#line 5156 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("foreign data wrapper"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 749:

/* Line 1455 of yacc.c  */
#line 5160 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("foreign server"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 750:

/* Line 1455 of yacc.c  */
#line 5164 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("function"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 751:

/* Line 1455 of yacc.c  */
#line 5168 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("database"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 752:

/* Line 1455 of yacc.c  */
#line 5172 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("language"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 753:

/* Line 1455 of yacc.c  */
#line 5176 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("large object"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 754:

/* Line 1455 of yacc.c  */
#line 5180 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("schema"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 755:

/* Line 1455 of yacc.c  */
#line 5184 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("tablespace"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 756:

/* Line 1455 of yacc.c  */
#line 5188 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("all tables in schema"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 757:

/* Line 1455 of yacc.c  */
#line 5192 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("all sequences in schema"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 758:

/* Line 1455 of yacc.c  */
#line 5196 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("all functions in schema"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 759:

/* Line 1455 of yacc.c  */
#line 5204 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 760:

/* Line 1455 of yacc.c  */
#line 5208 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 761:

/* Line 1455 of yacc.c  */
#line 5216 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 762:

/* Line 1455 of yacc.c  */
#line 5220 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("group"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 763:

/* Line 1455 of yacc.c  */
#line 5228 "preproc.y"
    { 
 (yyval.str) = make_str("with grant option");
;}
    break;

  case 764:

/* Line 1455 of yacc.c  */
#line 5232 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 765:

/* Line 1455 of yacc.c  */
#line 5239 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 766:

/* Line 1455 of yacc.c  */
#line 5243 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 767:

/* Line 1455 of yacc.c  */
#line 5251 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 768:

/* Line 1455 of yacc.c  */
#line 5259 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("grant"),(yyvsp[(2) - (6)].str),make_str("to"),(yyvsp[(4) - (6)].str),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 769:

/* Line 1455 of yacc.c  */
#line 5267 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("revoke"),(yyvsp[(2) - (6)].str),make_str("from"),(yyvsp[(4) - (6)].str),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 770:

/* Line 1455 of yacc.c  */
#line 5271 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("revoke admin option for"),(yyvsp[(5) - (9)].str),make_str("from"),(yyvsp[(7) - (9)].str),(yyvsp[(8) - (9)].str),(yyvsp[(9) - (9)].str));
;}
    break;

  case 771:

/* Line 1455 of yacc.c  */
#line 5279 "preproc.y"
    { 
 (yyval.str) = make_str("with admin option");
;}
    break;

  case 772:

/* Line 1455 of yacc.c  */
#line 5283 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 773:

/* Line 1455 of yacc.c  */
#line 5290 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("granted by"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 774:

/* Line 1455 of yacc.c  */
#line 5294 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 775:

/* Line 1455 of yacc.c  */
#line 5301 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("alter default privileges"),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 776:

/* Line 1455 of yacc.c  */
#line 5309 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 777:

/* Line 1455 of yacc.c  */
#line 5313 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 778:

/* Line 1455 of yacc.c  */
#line 5320 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("in schema"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 779:

/* Line 1455 of yacc.c  */
#line 5324 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("for role"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 780:

/* Line 1455 of yacc.c  */
#line 5328 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("for user"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 781:

/* Line 1455 of yacc.c  */
#line 5336 "preproc.y"
    { 
 (yyval.str) = cat_str(7,make_str("grant"),(yyvsp[(2) - (7)].str),make_str("on"),(yyvsp[(4) - (7)].str),make_str("to"),(yyvsp[(6) - (7)].str),(yyvsp[(7) - (7)].str));
;}
    break;

  case 782:

/* Line 1455 of yacc.c  */
#line 5340 "preproc.y"
    { 
 (yyval.str) = cat_str(7,make_str("revoke"),(yyvsp[(2) - (7)].str),make_str("on"),(yyvsp[(4) - (7)].str),make_str("from"),(yyvsp[(6) - (7)].str),(yyvsp[(7) - (7)].str));
;}
    break;

  case 783:

/* Line 1455 of yacc.c  */
#line 5344 "preproc.y"
    { 
 (yyval.str) = cat_str(7,make_str("revoke grant option for"),(yyvsp[(5) - (10)].str),make_str("on"),(yyvsp[(7) - (10)].str),make_str("from"),(yyvsp[(9) - (10)].str),(yyvsp[(10) - (10)].str));
;}
    break;

  case 784:

/* Line 1455 of yacc.c  */
#line 5352 "preproc.y"
    { 
 (yyval.str) = make_str("tables");
;}
    break;

  case 785:

/* Line 1455 of yacc.c  */
#line 5356 "preproc.y"
    { 
 (yyval.str) = make_str("functions");
;}
    break;

  case 786:

/* Line 1455 of yacc.c  */
#line 5360 "preproc.y"
    { 
 (yyval.str) = make_str("sequences");
;}
    break;

  case 787:

/* Line 1455 of yacc.c  */
#line 5368 "preproc.y"
    { 
 (yyval.str) = cat_str(14,make_str("create"),(yyvsp[(2) - (14)].str),make_str("index"),(yyvsp[(4) - (14)].str),(yyvsp[(5) - (14)].str),make_str("on"),(yyvsp[(7) - (14)].str),(yyvsp[(8) - (14)].str),make_str("("),(yyvsp[(10) - (14)].str),make_str(")"),(yyvsp[(12) - (14)].str),(yyvsp[(13) - (14)].str),(yyvsp[(14) - (14)].str));
;}
    break;

  case 788:

/* Line 1455 of yacc.c  */
#line 5376 "preproc.y"
    { 
 (yyval.str) = make_str("unique");
;}
    break;

  case 789:

/* Line 1455 of yacc.c  */
#line 5380 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 790:

/* Line 1455 of yacc.c  */
#line 5387 "preproc.y"
    { 
 (yyval.str) = make_str("concurrently");
;}
    break;

  case 791:

/* Line 1455 of yacc.c  */
#line 5391 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 792:

/* Line 1455 of yacc.c  */
#line 5398 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 793:

/* Line 1455 of yacc.c  */
#line 5402 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 794:

/* Line 1455 of yacc.c  */
#line 5409 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("using"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 795:

/* Line 1455 of yacc.c  */
#line 5413 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 796:

/* Line 1455 of yacc.c  */
#line 5420 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 797:

/* Line 1455 of yacc.c  */
#line 5424 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 798:

/* Line 1455 of yacc.c  */
#line 5432 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (4)].str),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 799:

/* Line 1455 of yacc.c  */
#line 5436 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (4)].str),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 800:

/* Line 1455 of yacc.c  */
#line 5440 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("("),(yyvsp[(2) - (6)].str),make_str(")"),(yyvsp[(4) - (6)].str),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 801:

/* Line 1455 of yacc.c  */
#line 5448 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 802:

/* Line 1455 of yacc.c  */
#line 5452 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("using"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 803:

/* Line 1455 of yacc.c  */
#line 5456 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 804:

/* Line 1455 of yacc.c  */
#line 5463 "preproc.y"
    { 
 (yyval.str) = make_str("asc");
;}
    break;

  case 805:

/* Line 1455 of yacc.c  */
#line 5467 "preproc.y"
    { 
 (yyval.str) = make_str("desc");
;}
    break;

  case 806:

/* Line 1455 of yacc.c  */
#line 5471 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 807:

/* Line 1455 of yacc.c  */
#line 5478 "preproc.y"
    { 
 (yyval.str) = make_str("nulls first");
;}
    break;

  case 808:

/* Line 1455 of yacc.c  */
#line 5482 "preproc.y"
    { 
 (yyval.str) = make_str("nulls last");
;}
    break;

  case 809:

/* Line 1455 of yacc.c  */
#line 5486 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 810:

/* Line 1455 of yacc.c  */
#line 5493 "preproc.y"
    { 
 (yyval.str) = cat_str(9,make_str("create"),(yyvsp[(2) - (9)].str),make_str("function"),(yyvsp[(4) - (9)].str),(yyvsp[(5) - (9)].str),make_str("returns"),(yyvsp[(7) - (9)].str),(yyvsp[(8) - (9)].str),(yyvsp[(9) - (9)].str));
;}
    break;

  case 811:

/* Line 1455 of yacc.c  */
#line 5497 "preproc.y"
    { 
 (yyval.str) = cat_str(10,make_str("create"),(yyvsp[(2) - (12)].str),make_str("function"),(yyvsp[(4) - (12)].str),(yyvsp[(5) - (12)].str),make_str("returns table ("),(yyvsp[(9) - (12)].str),make_str(")"),(yyvsp[(11) - (12)].str),(yyvsp[(12) - (12)].str));
;}
    break;

  case 812:

/* Line 1455 of yacc.c  */
#line 5501 "preproc.y"
    { 
 (yyval.str) = cat_str(7,make_str("create"),(yyvsp[(2) - (7)].str),make_str("function"),(yyvsp[(4) - (7)].str),(yyvsp[(5) - (7)].str),(yyvsp[(6) - (7)].str),(yyvsp[(7) - (7)].str));
;}
    break;

  case 813:

/* Line 1455 of yacc.c  */
#line 5509 "preproc.y"
    { 
 (yyval.str) = make_str("or replace");
;}
    break;

  case 814:

/* Line 1455 of yacc.c  */
#line 5513 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 815:

/* Line 1455 of yacc.c  */
#line 5520 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 816:

/* Line 1455 of yacc.c  */
#line 5524 "preproc.y"
    { 
 (yyval.str) = make_str("( )");
;}
    break;

  case 817:

/* Line 1455 of yacc.c  */
#line 5532 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 818:

/* Line 1455 of yacc.c  */
#line 5536 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 819:

/* Line 1455 of yacc.c  */
#line 5544 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 820:

/* Line 1455 of yacc.c  */
#line 5548 "preproc.y"
    { 
 (yyval.str) = make_str("( )");
;}
    break;

  case 821:

/* Line 1455 of yacc.c  */
#line 5556 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 822:

/* Line 1455 of yacc.c  */
#line 5560 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 823:

/* Line 1455 of yacc.c  */
#line 5568 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 824:

/* Line 1455 of yacc.c  */
#line 5572 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 825:

/* Line 1455 of yacc.c  */
#line 5576 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 826:

/* Line 1455 of yacc.c  */
#line 5580 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 827:

/* Line 1455 of yacc.c  */
#line 5584 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 828:

/* Line 1455 of yacc.c  */
#line 5592 "preproc.y"
    { 
 (yyval.str) = make_str("in");
;}
    break;

  case 829:

/* Line 1455 of yacc.c  */
#line 5596 "preproc.y"
    { 
 (yyval.str) = make_str("out");
;}
    break;

  case 830:

/* Line 1455 of yacc.c  */
#line 5600 "preproc.y"
    { 
 (yyval.str) = make_str("inout");
;}
    break;

  case 831:

/* Line 1455 of yacc.c  */
#line 5604 "preproc.y"
    { 
 (yyval.str) = make_str("in out");
;}
    break;

  case 832:

/* Line 1455 of yacc.c  */
#line 5608 "preproc.y"
    { 
 (yyval.str) = make_str("variadic");
;}
    break;

  case 833:

/* Line 1455 of yacc.c  */
#line 5616 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 834:

/* Line 1455 of yacc.c  */
#line 5624 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 835:

/* Line 1455 of yacc.c  */
#line 5632 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 836:

/* Line 1455 of yacc.c  */
#line 5636 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (4)].str),(yyvsp[(2) - (4)].str),make_str("% type"));
;}
    break;

  case 837:

/* Line 1455 of yacc.c  */
#line 5640 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("setof"),(yyvsp[(2) - (5)].str),(yyvsp[(3) - (5)].str),make_str("% type"));
;}
    break;

  case 838:

/* Line 1455 of yacc.c  */
#line 5648 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 839:

/* Line 1455 of yacc.c  */
#line 5652 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("default"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 840:

/* Line 1455 of yacc.c  */
#line 5656 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("="),(yyvsp[(3) - (3)].str));
;}
    break;

  case 841:

/* Line 1455 of yacc.c  */
#line 5664 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 842:

/* Line 1455 of yacc.c  */
#line 5668 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 843:

/* Line 1455 of yacc.c  */
#line 5676 "preproc.y"
    { 
 (yyval.str) = make_str("called on null input");
;}
    break;

  case 844:

/* Line 1455 of yacc.c  */
#line 5680 "preproc.y"
    { 
 (yyval.str) = make_str("returns null on null input");
;}
    break;

  case 845:

/* Line 1455 of yacc.c  */
#line 5684 "preproc.y"
    { 
 (yyval.str) = make_str("strict");
;}
    break;

  case 846:

/* Line 1455 of yacc.c  */
#line 5688 "preproc.y"
    { 
 (yyval.str) = make_str("immutable");
;}
    break;

  case 847:

/* Line 1455 of yacc.c  */
#line 5692 "preproc.y"
    { 
 (yyval.str) = make_str("stable");
;}
    break;

  case 848:

/* Line 1455 of yacc.c  */
#line 5696 "preproc.y"
    { 
 (yyval.str) = make_str("volatile");
;}
    break;

  case 849:

/* Line 1455 of yacc.c  */
#line 5700 "preproc.y"
    { 
 (yyval.str) = make_str("external security definer");
;}
    break;

  case 850:

/* Line 1455 of yacc.c  */
#line 5704 "preproc.y"
    { 
 (yyval.str) = make_str("external security invoker");
;}
    break;

  case 851:

/* Line 1455 of yacc.c  */
#line 5708 "preproc.y"
    { 
 (yyval.str) = make_str("security definer");
;}
    break;

  case 852:

/* Line 1455 of yacc.c  */
#line 5712 "preproc.y"
    { 
 (yyval.str) = make_str("security invoker");
;}
    break;

  case 853:

/* Line 1455 of yacc.c  */
#line 5716 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("cost"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 854:

/* Line 1455 of yacc.c  */
#line 5720 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("rows"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 855:

/* Line 1455 of yacc.c  */
#line 5724 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 856:

/* Line 1455 of yacc.c  */
#line 5732 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("as"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 857:

/* Line 1455 of yacc.c  */
#line 5736 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("language"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 858:

/* Line 1455 of yacc.c  */
#line 5740 "preproc.y"
    { 
 (yyval.str) = make_str("window");
;}
    break;

  case 859:

/* Line 1455 of yacc.c  */
#line 5744 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 860:

/* Line 1455 of yacc.c  */
#line 5752 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 861:

/* Line 1455 of yacc.c  */
#line 5756 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 862:

/* Line 1455 of yacc.c  */
#line 5764 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("with"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 863:

/* Line 1455 of yacc.c  */
#line 5768 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 864:

/* Line 1455 of yacc.c  */
#line 5775 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 865:

/* Line 1455 of yacc.c  */
#line 5783 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 866:

/* Line 1455 of yacc.c  */
#line 5787 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 867:

/* Line 1455 of yacc.c  */
#line 5795 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter function"),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 868:

/* Line 1455 of yacc.c  */
#line 5803 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 869:

/* Line 1455 of yacc.c  */
#line 5807 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 870:

/* Line 1455 of yacc.c  */
#line 5815 "preproc.y"
    { 
 (yyval.str) = make_str("restrict");
;}
    break;

  case 871:

/* Line 1455 of yacc.c  */
#line 5819 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 872:

/* Line 1455 of yacc.c  */
#line 5826 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("drop function"),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 873:

/* Line 1455 of yacc.c  */
#line 5830 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("drop function if exists"),(yyvsp[(5) - (7)].str),(yyvsp[(6) - (7)].str),(yyvsp[(7) - (7)].str));
;}
    break;

  case 874:

/* Line 1455 of yacc.c  */
#line 5838 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("drop aggregate"),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 875:

/* Line 1455 of yacc.c  */
#line 5842 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("drop aggregate if exists"),(yyvsp[(5) - (7)].str),(yyvsp[(6) - (7)].str),(yyvsp[(7) - (7)].str));
;}
    break;

  case 876:

/* Line 1455 of yacc.c  */
#line 5850 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("drop operator"),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 877:

/* Line 1455 of yacc.c  */
#line 5854 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("drop operator if exists"),(yyvsp[(5) - (7)].str),(yyvsp[(6) - (7)].str),(yyvsp[(7) - (7)].str));
;}
    break;

  case 878:

/* Line 1455 of yacc.c  */
#line 5862 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 879:

/* Line 1455 of yacc.c  */
#line 5866 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("("),(yyvsp[(2) - (5)].str),make_str(","),(yyvsp[(4) - (5)].str),make_str(")"));
;}
    break;

  case 880:

/* Line 1455 of yacc.c  */
#line 5870 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("( none ,"),(yyvsp[(4) - (5)].str),make_str(")"));
;}
    break;

  case 881:

/* Line 1455 of yacc.c  */
#line 5874 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (5)].str),make_str(", none )"));
;}
    break;

  case 882:

/* Line 1455 of yacc.c  */
#line 5882 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 883:

/* Line 1455 of yacc.c  */
#line 5886 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("."),(yyvsp[(3) - (3)].str));
;}
    break;

  case 884:

/* Line 1455 of yacc.c  */
#line 5894 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("do"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 885:

/* Line 1455 of yacc.c  */
#line 5902 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 886:

/* Line 1455 of yacc.c  */
#line 5906 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 887:

/* Line 1455 of yacc.c  */
#line 5914 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 888:

/* Line 1455 of yacc.c  */
#line 5918 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("language"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 889:

/* Line 1455 of yacc.c  */
#line 5926 "preproc.y"
    { 
 (yyval.str) = cat_str(7,make_str("create cast ("),(yyvsp[(4) - (11)].str),make_str("as"),(yyvsp[(6) - (11)].str),make_str(") with function"),(yyvsp[(10) - (11)].str),(yyvsp[(11) - (11)].str));
;}
    break;

  case 890:

/* Line 1455 of yacc.c  */
#line 5930 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("create cast ("),(yyvsp[(4) - (10)].str),make_str("as"),(yyvsp[(6) - (10)].str),make_str(") without function"),(yyvsp[(10) - (10)].str));
;}
    break;

  case 891:

/* Line 1455 of yacc.c  */
#line 5934 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("create cast ("),(yyvsp[(4) - (10)].str),make_str("as"),(yyvsp[(6) - (10)].str),make_str(") with inout"),(yyvsp[(10) - (10)].str));
;}
    break;

  case 892:

/* Line 1455 of yacc.c  */
#line 5942 "preproc.y"
    { 
 (yyval.str) = make_str("as implicit");
;}
    break;

  case 893:

/* Line 1455 of yacc.c  */
#line 5946 "preproc.y"
    { 
 (yyval.str) = make_str("as assignment");
;}
    break;

  case 894:

/* Line 1455 of yacc.c  */
#line 5950 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 895:

/* Line 1455 of yacc.c  */
#line 5957 "preproc.y"
    { 
 (yyval.str) = cat_str(8,make_str("drop cast"),(yyvsp[(3) - (9)].str),make_str("("),(yyvsp[(5) - (9)].str),make_str("as"),(yyvsp[(7) - (9)].str),make_str(")"),(yyvsp[(9) - (9)].str));
;}
    break;

  case 896:

/* Line 1455 of yacc.c  */
#line 5965 "preproc.y"
    { 
 (yyval.str) = make_str("if exists");
;}
    break;

  case 897:

/* Line 1455 of yacc.c  */
#line 5969 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 898:

/* Line 1455 of yacc.c  */
#line 5976 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("reindex"),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 899:

/* Line 1455 of yacc.c  */
#line 5980 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("reindex system"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 900:

/* Line 1455 of yacc.c  */
#line 5984 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("reindex database"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 901:

/* Line 1455 of yacc.c  */
#line 5992 "preproc.y"
    { 
 (yyval.str) = make_str("index");
;}
    break;

  case 902:

/* Line 1455 of yacc.c  */
#line 5996 "preproc.y"
    { 
 (yyval.str) = make_str("table");
;}
    break;

  case 903:

/* Line 1455 of yacc.c  */
#line 6004 "preproc.y"
    { 
 (yyval.str) = make_str("force");
;}
    break;

  case 904:

/* Line 1455 of yacc.c  */
#line 6008 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 905:

/* Line 1455 of yacc.c  */
#line 6015 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("alter aggregate"),(yyvsp[(3) - (7)].str),(yyvsp[(4) - (7)].str),make_str("rename to"),(yyvsp[(7) - (7)].str));
;}
    break;

  case 906:

/* Line 1455 of yacc.c  */
#line 6019 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter conversion"),(yyvsp[(3) - (6)].str),make_str("rename to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 907:

/* Line 1455 of yacc.c  */
#line 6023 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter database"),(yyvsp[(3) - (6)].str),make_str("rename to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 908:

/* Line 1455 of yacc.c  */
#line 6027 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter function"),(yyvsp[(3) - (6)].str),make_str("rename to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 909:

/* Line 1455 of yacc.c  */
#line 6031 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter group"),(yyvsp[(3) - (6)].str),make_str("rename to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 910:

/* Line 1455 of yacc.c  */
#line 6035 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("alter"),(yyvsp[(2) - (7)].str),make_str("language"),(yyvsp[(4) - (7)].str),make_str("rename to"),(yyvsp[(7) - (7)].str));
;}
    break;

  case 911:

/* Line 1455 of yacc.c  */
#line 6039 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("alter operator class"),(yyvsp[(4) - (9)].str),make_str("using"),(yyvsp[(6) - (9)].str),make_str("rename to"),(yyvsp[(9) - (9)].str));
;}
    break;

  case 912:

/* Line 1455 of yacc.c  */
#line 6043 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("alter operator family"),(yyvsp[(4) - (9)].str),make_str("using"),(yyvsp[(6) - (9)].str),make_str("rename to"),(yyvsp[(9) - (9)].str));
;}
    break;

  case 913:

/* Line 1455 of yacc.c  */
#line 6047 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter schema"),(yyvsp[(3) - (6)].str),make_str("rename to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 914:

/* Line 1455 of yacc.c  */
#line 6051 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter table"),(yyvsp[(3) - (6)].str),make_str("rename to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 915:

/* Line 1455 of yacc.c  */
#line 6055 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter sequence"),(yyvsp[(3) - (6)].str),make_str("rename to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 916:

/* Line 1455 of yacc.c  */
#line 6059 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter view"),(yyvsp[(3) - (6)].str),make_str("rename to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 917:

/* Line 1455 of yacc.c  */
#line 6063 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter index"),(yyvsp[(3) - (6)].str),make_str("rename to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 918:

/* Line 1455 of yacc.c  */
#line 6067 "preproc.y"
    { 
 (yyval.str) = cat_str(7,make_str("alter table"),(yyvsp[(3) - (8)].str),make_str("rename"),(yyvsp[(5) - (8)].str),(yyvsp[(6) - (8)].str),make_str("to"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 919:

/* Line 1455 of yacc.c  */
#line 6071 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("alter trigger"),(yyvsp[(3) - (8)].str),make_str("on"),(yyvsp[(5) - (8)].str),make_str("rename to"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 920:

/* Line 1455 of yacc.c  */
#line 6075 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter role"),(yyvsp[(3) - (6)].str),make_str("rename to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 921:

/* Line 1455 of yacc.c  */
#line 6079 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter user"),(yyvsp[(3) - (6)].str),make_str("rename to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 922:

/* Line 1455 of yacc.c  */
#line 6083 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter tablespace"),(yyvsp[(3) - (6)].str),make_str("rename to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 923:

/* Line 1455 of yacc.c  */
#line 6087 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter tablespace"),(yyvsp[(3) - (5)].str),make_str("set"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 924:

/* Line 1455 of yacc.c  */
#line 6091 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter tablespace"),(yyvsp[(3) - (5)].str),make_str("reset"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 925:

/* Line 1455 of yacc.c  */
#line 6095 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter text search parser"),(yyvsp[(5) - (8)].str),make_str("rename to"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 926:

/* Line 1455 of yacc.c  */
#line 6099 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter text search dictionary"),(yyvsp[(5) - (8)].str),make_str("rename to"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 927:

/* Line 1455 of yacc.c  */
#line 6103 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter text search template"),(yyvsp[(5) - (8)].str),make_str("rename to"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 928:

/* Line 1455 of yacc.c  */
#line 6107 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter text search configuration"),(yyvsp[(5) - (8)].str),make_str("rename to"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 929:

/* Line 1455 of yacc.c  */
#line 6111 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter type"),(yyvsp[(3) - (6)].str),make_str("rename to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 930:

/* Line 1455 of yacc.c  */
#line 6119 "preproc.y"
    { 
 (yyval.str) = make_str("column");
;}
    break;

  case 931:

/* Line 1455 of yacc.c  */
#line 6123 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 932:

/* Line 1455 of yacc.c  */
#line 6130 "preproc.y"
    { 
 (yyval.str) = make_str("set data");
;}
    break;

  case 933:

/* Line 1455 of yacc.c  */
#line 6134 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 934:

/* Line 1455 of yacc.c  */
#line 6141 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("alter aggregate"),(yyvsp[(3) - (7)].str),(yyvsp[(4) - (7)].str),make_str("set schema"),(yyvsp[(7) - (7)].str));
;}
    break;

  case 935:

/* Line 1455 of yacc.c  */
#line 6145 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter domain"),(yyvsp[(3) - (6)].str),make_str("set schema"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 936:

/* Line 1455 of yacc.c  */
#line 6149 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter function"),(yyvsp[(3) - (6)].str),make_str("set schema"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 937:

/* Line 1455 of yacc.c  */
#line 6153 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter table"),(yyvsp[(3) - (6)].str),make_str("set schema"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 938:

/* Line 1455 of yacc.c  */
#line 6157 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter sequence"),(yyvsp[(3) - (6)].str),make_str("set schema"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 939:

/* Line 1455 of yacc.c  */
#line 6161 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter view"),(yyvsp[(3) - (6)].str),make_str("set schema"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 940:

/* Line 1455 of yacc.c  */
#line 6165 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter type"),(yyvsp[(3) - (6)].str),make_str("set schema"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 941:

/* Line 1455 of yacc.c  */
#line 6173 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("alter aggregate"),(yyvsp[(3) - (7)].str),(yyvsp[(4) - (7)].str),make_str("owner to"),(yyvsp[(7) - (7)].str));
;}
    break;

  case 942:

/* Line 1455 of yacc.c  */
#line 6177 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter conversion"),(yyvsp[(3) - (6)].str),make_str("owner to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 943:

/* Line 1455 of yacc.c  */
#line 6181 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter database"),(yyvsp[(3) - (6)].str),make_str("owner to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 944:

/* Line 1455 of yacc.c  */
#line 6185 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter domain"),(yyvsp[(3) - (6)].str),make_str("owner to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 945:

/* Line 1455 of yacc.c  */
#line 6189 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter function"),(yyvsp[(3) - (6)].str),make_str("owner to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 946:

/* Line 1455 of yacc.c  */
#line 6193 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("alter"),(yyvsp[(2) - (7)].str),make_str("language"),(yyvsp[(4) - (7)].str),make_str("owner to"),(yyvsp[(7) - (7)].str));
;}
    break;

  case 947:

/* Line 1455 of yacc.c  */
#line 6197 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter large object"),(yyvsp[(4) - (7)].str),make_str("owner to"),(yyvsp[(7) - (7)].str));
;}
    break;

  case 948:

/* Line 1455 of yacc.c  */
#line 6201 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("alter operator"),(yyvsp[(3) - (7)].str),(yyvsp[(4) - (7)].str),make_str("owner to"),(yyvsp[(7) - (7)].str));
;}
    break;

  case 949:

/* Line 1455 of yacc.c  */
#line 6205 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("alter operator class"),(yyvsp[(4) - (9)].str),make_str("using"),(yyvsp[(6) - (9)].str),make_str("owner to"),(yyvsp[(9) - (9)].str));
;}
    break;

  case 950:

/* Line 1455 of yacc.c  */
#line 6209 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("alter operator family"),(yyvsp[(4) - (9)].str),make_str("using"),(yyvsp[(6) - (9)].str),make_str("owner to"),(yyvsp[(9) - (9)].str));
;}
    break;

  case 951:

/* Line 1455 of yacc.c  */
#line 6213 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter schema"),(yyvsp[(3) - (6)].str),make_str("owner to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 952:

/* Line 1455 of yacc.c  */
#line 6217 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter type"),(yyvsp[(3) - (6)].str),make_str("owner to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 953:

/* Line 1455 of yacc.c  */
#line 6221 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter tablespace"),(yyvsp[(3) - (6)].str),make_str("owner to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 954:

/* Line 1455 of yacc.c  */
#line 6225 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter text search dictionary"),(yyvsp[(5) - (8)].str),make_str("owner to"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 955:

/* Line 1455 of yacc.c  */
#line 6229 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter text search configuration"),(yyvsp[(5) - (8)].str),make_str("owner to"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 956:

/* Line 1455 of yacc.c  */
#line 6233 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter foreign data wrapper"),(yyvsp[(5) - (8)].str),make_str("owner to"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 957:

/* Line 1455 of yacc.c  */
#line 6237 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter server"),(yyvsp[(3) - (6)].str),make_str("owner to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 958:

/* Line 1455 of yacc.c  */
#line 6245 "preproc.y"
    { 
 (yyval.str) = cat_str(12,make_str("create"),(yyvsp[(2) - (13)].str),make_str("rule"),(yyvsp[(4) - (13)].str),make_str("as on"),(yyvsp[(7) - (13)].str),make_str("to"),(yyvsp[(9) - (13)].str),(yyvsp[(10) - (13)].str),make_str("do"),(yyvsp[(12) - (13)].str),(yyvsp[(13) - (13)].str));
;}
    break;

  case 959:

/* Line 1455 of yacc.c  */
#line 6253 "preproc.y"
    { 
 (yyval.str) = make_str("nothing");
;}
    break;

  case 960:

/* Line 1455 of yacc.c  */
#line 6257 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 961:

/* Line 1455 of yacc.c  */
#line 6261 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 962:

/* Line 1455 of yacc.c  */
#line 6269 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(";"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 963:

/* Line 1455 of yacc.c  */
#line 6273 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 964:

/* Line 1455 of yacc.c  */
#line 6281 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 965:

/* Line 1455 of yacc.c  */
#line 6285 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 966:

/* Line 1455 of yacc.c  */
#line 6289 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 967:

/* Line 1455 of yacc.c  */
#line 6293 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 968:

/* Line 1455 of yacc.c  */
#line 6297 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 969:

/* Line 1455 of yacc.c  */
#line 6305 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 970:

/* Line 1455 of yacc.c  */
#line 6309 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 971:

/* Line 1455 of yacc.c  */
#line 6316 "preproc.y"
    { 
 (yyval.str) = make_str("select");
;}
    break;

  case 972:

/* Line 1455 of yacc.c  */
#line 6320 "preproc.y"
    { 
 (yyval.str) = make_str("update");
;}
    break;

  case 973:

/* Line 1455 of yacc.c  */
#line 6324 "preproc.y"
    { 
 (yyval.str) = make_str("delete");
;}
    break;

  case 974:

/* Line 1455 of yacc.c  */
#line 6328 "preproc.y"
    { 
 (yyval.str) = make_str("insert");
;}
    break;

  case 975:

/* Line 1455 of yacc.c  */
#line 6336 "preproc.y"
    { 
 (yyval.str) = make_str("instead");
;}
    break;

  case 976:

/* Line 1455 of yacc.c  */
#line 6340 "preproc.y"
    { 
 (yyval.str) = make_str("also");
;}
    break;

  case 977:

/* Line 1455 of yacc.c  */
#line 6344 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 978:

/* Line 1455 of yacc.c  */
#line 6351 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("drop rule"),(yyvsp[(3) - (6)].str),make_str("on"),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 979:

/* Line 1455 of yacc.c  */
#line 6355 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("drop rule if exists"),(yyvsp[(5) - (8)].str),make_str("on"),(yyvsp[(7) - (8)].str),(yyvsp[(8) - (8)].str));
;}
    break;

  case 980:

/* Line 1455 of yacc.c  */
#line 6363 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("notify"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 981:

/* Line 1455 of yacc.c  */
#line 6371 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str(","),(yyvsp[(2) - (2)].str));
;}
    break;

  case 982:

/* Line 1455 of yacc.c  */
#line 6375 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 983:

/* Line 1455 of yacc.c  */
#line 6382 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("listen"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 984:

/* Line 1455 of yacc.c  */
#line 6390 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("unlisten"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 985:

/* Line 1455 of yacc.c  */
#line 6394 "preproc.y"
    { 
 (yyval.str) = make_str("unlisten *");
;}
    break;

  case 986:

/* Line 1455 of yacc.c  */
#line 6402 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("abort"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 987:

/* Line 1455 of yacc.c  */
#line 6406 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("begin"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 988:

/* Line 1455 of yacc.c  */
#line 6410 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("start transaction"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 989:

/* Line 1455 of yacc.c  */
#line 6414 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("commit"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 990:

/* Line 1455 of yacc.c  */
#line 6418 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("end"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 991:

/* Line 1455 of yacc.c  */
#line 6422 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("rollback"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 992:

/* Line 1455 of yacc.c  */
#line 6426 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("savepoint"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 993:

/* Line 1455 of yacc.c  */
#line 6430 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("release savepoint"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 994:

/* Line 1455 of yacc.c  */
#line 6434 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("release"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 995:

/* Line 1455 of yacc.c  */
#line 6438 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("rollback"),(yyvsp[(2) - (5)].str),make_str("to savepoint"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 996:

/* Line 1455 of yacc.c  */
#line 6442 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("rollback"),(yyvsp[(2) - (4)].str),make_str("to"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 997:

/* Line 1455 of yacc.c  */
#line 6446 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("prepare transaction"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 998:

/* Line 1455 of yacc.c  */
#line 6450 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("commit prepared"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 999:

/* Line 1455 of yacc.c  */
#line 6454 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("rollback prepared"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1000:

/* Line 1455 of yacc.c  */
#line 6462 "preproc.y"
    { 
 (yyval.str) = make_str("work");
;}
    break;

  case 1001:

/* Line 1455 of yacc.c  */
#line 6466 "preproc.y"
    { 
 (yyval.str) = make_str("transaction");
;}
    break;

  case 1002:

/* Line 1455 of yacc.c  */
#line 6470 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1003:

/* Line 1455 of yacc.c  */
#line 6477 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("isolation level"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1004:

/* Line 1455 of yacc.c  */
#line 6481 "preproc.y"
    { 
 (yyval.str) = make_str("read only");
;}
    break;

  case 1005:

/* Line 1455 of yacc.c  */
#line 6485 "preproc.y"
    { 
 (yyval.str) = make_str("read write");
;}
    break;

  case 1006:

/* Line 1455 of yacc.c  */
#line 6493 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1007:

/* Line 1455 of yacc.c  */
#line 6497 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1008:

/* Line 1455 of yacc.c  */
#line 6501 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1009:

/* Line 1455 of yacc.c  */
#line 6509 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1010:

/* Line 1455 of yacc.c  */
#line 6513 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1011:

/* Line 1455 of yacc.c  */
#line 6520 "preproc.y"
    { 
 (yyval.str) = cat_str(8,make_str("create"),(yyvsp[(2) - (8)].str),make_str("view"),(yyvsp[(4) - (8)].str),(yyvsp[(5) - (8)].str),make_str("as"),(yyvsp[(7) - (8)].str),(yyvsp[(8) - (8)].str));
;}
    break;

  case 1012:

/* Line 1455 of yacc.c  */
#line 6524 "preproc.y"
    { 
 (yyval.str) = cat_str(8,make_str("create or replace"),(yyvsp[(4) - (10)].str),make_str("view"),(yyvsp[(6) - (10)].str),(yyvsp[(7) - (10)].str),make_str("as"),(yyvsp[(9) - (10)].str),(yyvsp[(10) - (10)].str));
;}
    break;

  case 1013:

/* Line 1455 of yacc.c  */
#line 6532 "preproc.y"
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = make_str("with check option");
;}
    break;

  case 1014:

/* Line 1455 of yacc.c  */
#line 6537 "preproc.y"
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = make_str("with cascaded check option");
;}
    break;

  case 1015:

/* Line 1455 of yacc.c  */
#line 6542 "preproc.y"
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = make_str("with local check option");
;}
    break;

  case 1016:

/* Line 1455 of yacc.c  */
#line 6547 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1017:

/* Line 1455 of yacc.c  */
#line 6554 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("load"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1018:

/* Line 1455 of yacc.c  */
#line 6562 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("create database"),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1019:

/* Line 1455 of yacc.c  */
#line 6570 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1020:

/* Line 1455 of yacc.c  */
#line 6574 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1021:

/* Line 1455 of yacc.c  */
#line 6581 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("tablespace"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1022:

/* Line 1455 of yacc.c  */
#line 6585 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("tablespace"),(yyvsp[(2) - (3)].str),make_str("default"));
;}
    break;

  case 1023:

/* Line 1455 of yacc.c  */
#line 6589 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("location"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1024:

/* Line 1455 of yacc.c  */
#line 6593 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("location"),(yyvsp[(2) - (3)].str),make_str("default"));
;}
    break;

  case 1025:

/* Line 1455 of yacc.c  */
#line 6597 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("template"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1026:

/* Line 1455 of yacc.c  */
#line 6601 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("template"),(yyvsp[(2) - (3)].str),make_str("default"));
;}
    break;

  case 1027:

/* Line 1455 of yacc.c  */
#line 6605 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("encoding"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1028:

/* Line 1455 of yacc.c  */
#line 6609 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("encoding"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1029:

/* Line 1455 of yacc.c  */
#line 6613 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("encoding"),(yyvsp[(2) - (3)].str),make_str("default"));
;}
    break;

  case 1030:

/* Line 1455 of yacc.c  */
#line 6617 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("lc_collate"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1031:

/* Line 1455 of yacc.c  */
#line 6621 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("lc_collate"),(yyvsp[(2) - (3)].str),make_str("default"));
;}
    break;

  case 1032:

/* Line 1455 of yacc.c  */
#line 6625 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("lc_ctype"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1033:

/* Line 1455 of yacc.c  */
#line 6629 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("lc_ctype"),(yyvsp[(2) - (3)].str),make_str("default"));
;}
    break;

  case 1034:

/* Line 1455 of yacc.c  */
#line 6633 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("connection limit"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1035:

/* Line 1455 of yacc.c  */
#line 6637 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("owner"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1036:

/* Line 1455 of yacc.c  */
#line 6641 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("owner"),(yyvsp[(2) - (3)].str),make_str("default"));
;}
    break;

  case 1037:

/* Line 1455 of yacc.c  */
#line 6649 "preproc.y"
    { 
 (yyval.str) = make_str("=");
;}
    break;

  case 1038:

/* Line 1455 of yacc.c  */
#line 6653 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1039:

/* Line 1455 of yacc.c  */
#line 6660 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter database"),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1040:

/* Line 1455 of yacc.c  */
#line 6664 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter database"),(yyvsp[(3) - (6)].str),make_str("set tablespace"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 1041:

/* Line 1455 of yacc.c  */
#line 6672 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("alter database"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1042:

/* Line 1455 of yacc.c  */
#line 6680 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1043:

/* Line 1455 of yacc.c  */
#line 6684 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1044:

/* Line 1455 of yacc.c  */
#line 6691 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("connection limit"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1045:

/* Line 1455 of yacc.c  */
#line 6699 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("drop database"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1046:

/* Line 1455 of yacc.c  */
#line 6703 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("drop database if exists"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1047:

/* Line 1455 of yacc.c  */
#line 6711 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("create domain"),(yyvsp[(3) - (6)].str),(yyvsp[(4) - (6)].str),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 1048:

/* Line 1455 of yacc.c  */
#line 6719 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("alter domain"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1049:

/* Line 1455 of yacc.c  */
#line 6723 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("alter domain"),(yyvsp[(3) - (6)].str),make_str("drop not null"));
;}
    break;

  case 1050:

/* Line 1455 of yacc.c  */
#line 6727 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("alter domain"),(yyvsp[(3) - (6)].str),make_str("set not null"));
;}
    break;

  case 1051:

/* Line 1455 of yacc.c  */
#line 6731 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter domain"),(yyvsp[(3) - (5)].str),make_str("add"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1052:

/* Line 1455 of yacc.c  */
#line 6735 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("alter domain"),(yyvsp[(3) - (7)].str),make_str("drop constraint"),(yyvsp[(6) - (7)].str),(yyvsp[(7) - (7)].str));
;}
    break;

  case 1053:

/* Line 1455 of yacc.c  */
#line 6743 "preproc.y"
    { 
 (yyval.str) = make_str("as");
;}
    break;

  case 1054:

/* Line 1455 of yacc.c  */
#line 6747 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1055:

/* Line 1455 of yacc.c  */
#line 6754 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("alter text search dictionary"),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 1056:

/* Line 1455 of yacc.c  */
#line 6762 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("alter text search configuration"),(yyvsp[(5) - (11)].str),make_str("add mapping for"),(yyvsp[(9) - (11)].str),make_str("with"),(yyvsp[(11) - (11)].str));
;}
    break;

  case 1057:

/* Line 1455 of yacc.c  */
#line 6766 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("alter text search configuration"),(yyvsp[(5) - (11)].str),make_str("alter mapping for"),(yyvsp[(9) - (11)].str),make_str("with"),(yyvsp[(11) - (11)].str));
;}
    break;

  case 1058:

/* Line 1455 of yacc.c  */
#line 6770 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("alter text search configuration"),(yyvsp[(5) - (11)].str),make_str("alter mapping replace"),(yyvsp[(9) - (11)].str),make_str("with"),(yyvsp[(11) - (11)].str));
;}
    break;

  case 1059:

/* Line 1455 of yacc.c  */
#line 6774 "preproc.y"
    { 
 (yyval.str) = cat_str(8,make_str("alter text search configuration"),(yyvsp[(5) - (13)].str),make_str("alter mapping for"),(yyvsp[(9) - (13)].str),make_str("replace"),(yyvsp[(11) - (13)].str),make_str("with"),(yyvsp[(13) - (13)].str));
;}
    break;

  case 1060:

/* Line 1455 of yacc.c  */
#line 6778 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter text search configuration"),(yyvsp[(5) - (9)].str),make_str("drop mapping for"),(yyvsp[(9) - (9)].str));
;}
    break;

  case 1061:

/* Line 1455 of yacc.c  */
#line 6782 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter text search configuration"),(yyvsp[(5) - (11)].str),make_str("drop mapping if exists for"),(yyvsp[(11) - (11)].str));
;}
    break;

  case 1062:

/* Line 1455 of yacc.c  */
#line 6790 "preproc.y"
    { 
 (yyval.str) = cat_str(10,make_str("create"),(yyvsp[(2) - (10)].str),make_str("conversion"),(yyvsp[(4) - (10)].str),make_str("for"),(yyvsp[(6) - (10)].str),make_str("to"),(yyvsp[(8) - (10)].str),make_str("from"),(yyvsp[(10) - (10)].str));
;}
    break;

  case 1063:

/* Line 1455 of yacc.c  */
#line 6798 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("cluster"),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1064:

/* Line 1455 of yacc.c  */
#line 6802 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("cluster"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1065:

/* Line 1455 of yacc.c  */
#line 6806 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("cluster"),(yyvsp[(2) - (5)].str),(yyvsp[(3) - (5)].str),make_str("on"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1066:

/* Line 1455 of yacc.c  */
#line 6814 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("using"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1067:

/* Line 1455 of yacc.c  */
#line 6818 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1068:

/* Line 1455 of yacc.c  */
#line 6825 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("vacuum"),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1069:

/* Line 1455 of yacc.c  */
#line 6829 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("vacuum"),(yyvsp[(2) - (5)].str),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1070:

/* Line 1455 of yacc.c  */
#line 6833 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("vacuum"),(yyvsp[(2) - (5)].str),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1071:

/* Line 1455 of yacc.c  */
#line 6837 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("vacuum ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1072:

/* Line 1455 of yacc.c  */
#line 6841 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("vacuum ("),(yyvsp[(3) - (6)].str),make_str(")"),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 1073:

/* Line 1455 of yacc.c  */
#line 6849 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1074:

/* Line 1455 of yacc.c  */
#line 6853 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1075:

/* Line 1455 of yacc.c  */
#line 6861 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1076:

/* Line 1455 of yacc.c  */
#line 6865 "preproc.y"
    { 
 (yyval.str) = make_str("verbose");
;}
    break;

  case 1077:

/* Line 1455 of yacc.c  */
#line 6869 "preproc.y"
    { 
 (yyval.str) = make_str("freeze");
;}
    break;

  case 1078:

/* Line 1455 of yacc.c  */
#line 6873 "preproc.y"
    { 
 (yyval.str) = make_str("full");
;}
    break;

  case 1079:

/* Line 1455 of yacc.c  */
#line 6881 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1080:

/* Line 1455 of yacc.c  */
#line 6885 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (4)].str),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1081:

/* Line 1455 of yacc.c  */
#line 6893 "preproc.y"
    { 
 (yyval.str) = make_str("analyze");
;}
    break;

  case 1082:

/* Line 1455 of yacc.c  */
#line 6897 "preproc.y"
    { 
 (yyval.str) = make_str("analyse");
;}
    break;

  case 1083:

/* Line 1455 of yacc.c  */
#line 6905 "preproc.y"
    { 
 (yyval.str) = make_str("verbose");
;}
    break;

  case 1084:

/* Line 1455 of yacc.c  */
#line 6909 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1085:

/* Line 1455 of yacc.c  */
#line 6916 "preproc.y"
    { 
 (yyval.str) = make_str("full");
;}
    break;

  case 1086:

/* Line 1455 of yacc.c  */
#line 6920 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1087:

/* Line 1455 of yacc.c  */
#line 6927 "preproc.y"
    { 
 (yyval.str) = make_str("freeze");
;}
    break;

  case 1088:

/* Line 1455 of yacc.c  */
#line 6931 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1089:

/* Line 1455 of yacc.c  */
#line 6938 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 1090:

/* Line 1455 of yacc.c  */
#line 6942 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1091:

/* Line 1455 of yacc.c  */
#line 6949 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("explain"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1092:

/* Line 1455 of yacc.c  */
#line 6953 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("explain"),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1093:

/* Line 1455 of yacc.c  */
#line 6957 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("explain verbose"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1094:

/* Line 1455 of yacc.c  */
#line 6961 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("explain ("),(yyvsp[(3) - (5)].str),make_str(")"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1095:

/* Line 1455 of yacc.c  */
#line 6969 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1096:

/* Line 1455 of yacc.c  */
#line 6973 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1097:

/* Line 1455 of yacc.c  */
#line 6977 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1098:

/* Line 1455 of yacc.c  */
#line 6981 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1099:

/* Line 1455 of yacc.c  */
#line 6985 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1100:

/* Line 1455 of yacc.c  */
#line 6989 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1101:

/* Line 1455 of yacc.c  */
#line 6993 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1102:

/* Line 1455 of yacc.c  */
#line 7001 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1103:

/* Line 1455 of yacc.c  */
#line 7005 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1104:

/* Line 1455 of yacc.c  */
#line 7013 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1105:

/* Line 1455 of yacc.c  */
#line 7021 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1106:

/* Line 1455 of yacc.c  */
#line 7025 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1107:

/* Line 1455 of yacc.c  */
#line 7029 "preproc.y"
    { 
 (yyval.str) = make_str("verbose");
;}
    break;

  case 1108:

/* Line 1455 of yacc.c  */
#line 7037 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1109:

/* Line 1455 of yacc.c  */
#line 7041 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1110:

/* Line 1455 of yacc.c  */
#line 7045 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1111:

/* Line 1455 of yacc.c  */
#line 7052 "preproc.y"
    {
		(yyval.prep).name = (yyvsp[(2) - (5)].str);
		(yyval.prep).type = (yyvsp[(3) - (5)].str);
		(yyval.prep).stmt = cat_str(3, make_str("\""), (yyvsp[(5) - (5)].str), make_str("\""));
	;}
    break;

  case 1112:

/* Line 1455 of yacc.c  */
#line 7058 "preproc.y"
    {
		(yyval.prep).name = (yyvsp[(2) - (4)].str);
		(yyval.prep).type = NULL;
		(yyval.prep).stmt = (yyvsp[(4) - (4)].str);
	;}
    break;

  case 1113:

/* Line 1455 of yacc.c  */
#line 7068 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 1114:

/* Line 1455 of yacc.c  */
#line 7072 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1115:

/* Line 1455 of yacc.c  */
#line 7079 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1116:

/* Line 1455 of yacc.c  */
#line 7083 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1117:

/* Line 1455 of yacc.c  */
#line 7087 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1118:

/* Line 1455 of yacc.c  */
#line 7091 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1119:

/* Line 1455 of yacc.c  */
#line 7099 "preproc.y"
    { (yyval.str) = (yyvsp[(2) - (4)].str); ;}
    break;

  case 1120:

/* Line 1455 of yacc.c  */
#line 7101 "preproc.y"
    { 
 (yyval.str) = cat_str(7,make_str("create"),(yyvsp[(2) - (8)].str),make_str("table"),(yyvsp[(4) - (8)].str),make_str("as execute"),(yyvsp[(7) - (8)].str),(yyvsp[(8) - (8)].str));
;}
    break;

  case 1121:

/* Line 1455 of yacc.c  */
#line 7109 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 1122:

/* Line 1455 of yacc.c  */
#line 7113 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1123:

/* Line 1455 of yacc.c  */
#line 7120 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("insert into"),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1124:

/* Line 1455 of yacc.c  */
#line 7128 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1125:

/* Line 1455 of yacc.c  */
#line 7132 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("("),(yyvsp[(2) - (4)].str),make_str(")"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1126:

/* Line 1455 of yacc.c  */
#line 7136 "preproc.y"
    { 
 (yyval.str) = make_str("default values");
;}
    break;

  case 1127:

/* Line 1455 of yacc.c  */
#line 7144 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1128:

/* Line 1455 of yacc.c  */
#line 7148 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1129:

/* Line 1455 of yacc.c  */
#line 7156 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1130:

/* Line 1455 of yacc.c  */
#line 7164 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("returning"),(yyvsp[(2) - (3)].str));
;}
    break;

  case 1131:

/* Line 1455 of yacc.c  */
#line 7168 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1132:

/* Line 1455 of yacc.c  */
#line 7175 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("delete from"),(yyvsp[(3) - (6)].str),(yyvsp[(4) - (6)].str),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 1133:

/* Line 1455 of yacc.c  */
#line 7183 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("using"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1134:

/* Line 1455 of yacc.c  */
#line 7187 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1135:

/* Line 1455 of yacc.c  */
#line 7194 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("lock"),(yyvsp[(2) - (5)].str),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1136:

/* Line 1455 of yacc.c  */
#line 7202 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("in"),(yyvsp[(2) - (3)].str),make_str("mode"));
;}
    break;

  case 1137:

/* Line 1455 of yacc.c  */
#line 7206 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1138:

/* Line 1455 of yacc.c  */
#line 7213 "preproc.y"
    { 
 (yyval.str) = make_str("access share");
;}
    break;

  case 1139:

/* Line 1455 of yacc.c  */
#line 7217 "preproc.y"
    { 
 (yyval.str) = make_str("row share");
;}
    break;

  case 1140:

/* Line 1455 of yacc.c  */
#line 7221 "preproc.y"
    { 
 (yyval.str) = make_str("row exclusive");
;}
    break;

  case 1141:

/* Line 1455 of yacc.c  */
#line 7225 "preproc.y"
    { 
 (yyval.str) = make_str("share update exclusive");
;}
    break;

  case 1142:

/* Line 1455 of yacc.c  */
#line 7229 "preproc.y"
    { 
 (yyval.str) = make_str("share");
;}
    break;

  case 1143:

/* Line 1455 of yacc.c  */
#line 7233 "preproc.y"
    { 
 (yyval.str) = make_str("share row exclusive");
;}
    break;

  case 1144:

/* Line 1455 of yacc.c  */
#line 7237 "preproc.y"
    { 
 (yyval.str) = make_str("exclusive");
;}
    break;

  case 1145:

/* Line 1455 of yacc.c  */
#line 7241 "preproc.y"
    { 
 (yyval.str) = make_str("access exclusive");
;}
    break;

  case 1146:

/* Line 1455 of yacc.c  */
#line 7249 "preproc.y"
    { 
 (yyval.str) = make_str("nowait");
;}
    break;

  case 1147:

/* Line 1455 of yacc.c  */
#line 7253 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1148:

/* Line 1455 of yacc.c  */
#line 7260 "preproc.y"
    { 
 (yyval.str) = cat_str(7,make_str("update"),(yyvsp[(2) - (7)].str),make_str("set"),(yyvsp[(4) - (7)].str),(yyvsp[(5) - (7)].str),(yyvsp[(6) - (7)].str),(yyvsp[(7) - (7)].str));
;}
    break;

  case 1149:

/* Line 1455 of yacc.c  */
#line 7268 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1150:

/* Line 1455 of yacc.c  */
#line 7272 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1151:

/* Line 1455 of yacc.c  */
#line 7280 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1152:

/* Line 1455 of yacc.c  */
#line 7284 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1153:

/* Line 1455 of yacc.c  */
#line 7292 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("="),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1154:

/* Line 1455 of yacc.c  */
#line 7300 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("("),(yyvsp[(2) - (5)].str),make_str(") ="),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1155:

/* Line 1455 of yacc.c  */
#line 7308 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1156:

/* Line 1455 of yacc.c  */
#line 7316 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1157:

/* Line 1455 of yacc.c  */
#line 7320 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1158:

/* Line 1455 of yacc.c  */
#line 7328 "preproc.y"
    {
		struct cursor *ptr, *this;
		char *cursor_marker = (yyvsp[(2) - (7)].str)[0] == ':' ? make_str("$0") : mm_strdup((yyvsp[(2) - (7)].str));
		char *comment, *c1, *c2;

		for (ptr = cur; ptr != NULL; ptr = ptr->next)
		{
			if (strcmp((yyvsp[(2) - (7)].str), ptr->name) == 0)
			{
				if ((yyvsp[(2) - (7)].str)[0] == ':')
                                        mmerror(PARSE_ERROR, ET_ERROR, "using variable \"%s\" in different declare statements is not supported", (yyvsp[(2) - (7)].str)+1);
                                else
					mmerror(PARSE_ERROR, ET_ERROR, "cursor \"%s\" is already defined", (yyvsp[(2) - (7)].str));
			}
		}

		this = (struct cursor *) mm_alloc(sizeof(struct cursor));

		this->next = cur;
		this->name = (yyvsp[(2) - (7)].str);
		this->function = (current_function ? mm_strdup(current_function) : NULL);
		this->connection = connection;
		this->opened = false;
		this->command =  cat_str(7, make_str("declare"), cursor_marker, (yyvsp[(3) - (7)].str), make_str("cursor"), (yyvsp[(5) - (7)].str), make_str("for"), (yyvsp[(7) - (7)].str));
		this->argsinsert = argsinsert;
		this->argsinsert_oos = NULL;
		this->argsresult = argsresult;
		this->argsresult_oos = NULL;
		argsinsert = argsresult = NULL;
		cur = this;

		c1 = mm_strdup(this->command);
		if ((c2 = strstr(c1, "*/")) != NULL)
		{
			/* We put this text into a comment, so we better remove [*][/]. */
			c2[0] = '.';
			c2[1] = '.';
		}
		comment = cat_str(3, make_str("/*"), c1, make_str("*/"));

		if ((braces_open > 0) && INFORMIX_MODE) /* we're in a function */
			(yyval.str) = cat_str(3, adjust_outofscope_cursor_vars(this),
				make_str("ECPG_informix_reset_sqlca();"),
				comment);
		else
			(yyval.str) = cat2_str(adjust_outofscope_cursor_vars(this), comment);
	;}
    break;

  case 1159:

/* Line 1455 of yacc.c  */
#line 7380 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1160:

/* Line 1455 of yacc.c  */
#line 7384 "preproc.y"
    {
			char *curname = mm_alloc(strlen((yyvsp[(1) - (1)].str)) + 2);
			sprintf(curname, ":%s", (yyvsp[(1) - (1)].str));
			free((yyvsp[(1) - (1)].str));
			(yyvsp[(1) - (1)].str) = curname;
			(yyval.str) = (yyvsp[(1) - (1)].str);
		;}
    break;

  case 1161:

/* Line 1455 of yacc.c  */
#line 7396 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1162:

/* Line 1455 of yacc.c  */
#line 7399 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (3)].str),make_str("no scroll"));
;}
    break;

  case 1163:

/* Line 1455 of yacc.c  */
#line 7403 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),make_str("scroll"));
;}
    break;

  case 1164:

/* Line 1455 of yacc.c  */
#line 7407 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),make_str("binary"));
;}
    break;

  case 1165:

/* Line 1455 of yacc.c  */
#line 7411 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),make_str("insensitive"));
;}
    break;

  case 1166:

/* Line 1455 of yacc.c  */
#line 7419 "preproc.y"
    {
		if (compat == ECPG_COMPAT_INFORMIX_SE && autocommit == true)
			(yyval.str) = make_str("with hold");
		else
			(yyval.str) = EMPTY;
	;}
    break;

  case 1167:

/* Line 1455 of yacc.c  */
#line 7426 "preproc.y"
    { 
 (yyval.str) = make_str("with hold");
;}
    break;

  case 1168:

/* Line 1455 of yacc.c  */
#line 7430 "preproc.y"
    { 
 (yyval.str) = make_str("without hold");
;}
    break;

  case 1169:

/* Line 1455 of yacc.c  */
#line 7438 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1170:

/* Line 1455 of yacc.c  */
#line 7442 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1171:

/* Line 1455 of yacc.c  */
#line 7450 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 1172:

/* Line 1455 of yacc.c  */
#line 7454 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 1173:

/* Line 1455 of yacc.c  */
#line 7462 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1174:

/* Line 1455 of yacc.c  */
#line 7466 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1175:

/* Line 1455 of yacc.c  */
#line 7470 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (4)].str),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1176:

/* Line 1455 of yacc.c  */
#line 7474 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (4)].str),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1177:

/* Line 1455 of yacc.c  */
#line 7478 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1178:

/* Line 1455 of yacc.c  */
#line 7482 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1179:

/* Line 1455 of yacc.c  */
#line 7486 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (5)].str),(yyvsp[(2) - (5)].str),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1180:

/* Line 1455 of yacc.c  */
#line 7490 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (5)].str),(yyvsp[(2) - (5)].str),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1181:

/* Line 1455 of yacc.c  */
#line 7498 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1182:

/* Line 1455 of yacc.c  */
#line 7502 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1183:

/* Line 1455 of yacc.c  */
#line 7510 "preproc.y"
    { 
 (yyval.str) = cat_str(9,make_str("select"),(yyvsp[(2) - (9)].str),(yyvsp[(3) - (9)].str),(yyvsp[(4) - (9)].str),(yyvsp[(5) - (9)].str),(yyvsp[(6) - (9)].str),(yyvsp[(7) - (9)].str),(yyvsp[(8) - (9)].str),(yyvsp[(9) - (9)].str));
;}
    break;

  case 1184:

/* Line 1455 of yacc.c  */
#line 7514 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1185:

/* Line 1455 of yacc.c  */
#line 7518 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("table"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1186:

/* Line 1455 of yacc.c  */
#line 7522 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (4)].str),make_str("union"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1187:

/* Line 1455 of yacc.c  */
#line 7526 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (4)].str),make_str("intersect"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1188:

/* Line 1455 of yacc.c  */
#line 7530 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (4)].str),make_str("except"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1189:

/* Line 1455 of yacc.c  */
#line 7538 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("with"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1190:

/* Line 1455 of yacc.c  */
#line 7542 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("with recursive"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1191:

/* Line 1455 of yacc.c  */
#line 7550 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1192:

/* Line 1455 of yacc.c  */
#line 7554 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1193:

/* Line 1455 of yacc.c  */
#line 7562 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (4)].str),(yyvsp[(2) - (4)].str),make_str("as"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1194:

/* Line 1455 of yacc.c  */
#line 7570 "preproc.y"
    {
						FoundInto = 1;
						(yyval.str)= cat2_str(make_str("into"), (yyvsp[(2) - (2)].str));
					;}
    break;

  case 1195:

/* Line 1455 of yacc.c  */
#line 7574 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 1196:

/* Line 1455 of yacc.c  */
#line 7576 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1197:

/* Line 1455 of yacc.c  */
#line 7583 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("temporary"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1198:

/* Line 1455 of yacc.c  */
#line 7587 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("temp"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1199:

/* Line 1455 of yacc.c  */
#line 7591 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("local temporary"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1200:

/* Line 1455 of yacc.c  */
#line 7595 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("local temp"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1201:

/* Line 1455 of yacc.c  */
#line 7599 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("global temporary"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1202:

/* Line 1455 of yacc.c  */
#line 7603 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("global temp"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1203:

/* Line 1455 of yacc.c  */
#line 7607 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("table"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1204:

/* Line 1455 of yacc.c  */
#line 7611 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1205:

/* Line 1455 of yacc.c  */
#line 7619 "preproc.y"
    { 
 (yyval.str) = make_str("table");
;}
    break;

  case 1206:

/* Line 1455 of yacc.c  */
#line 7623 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1207:

/* Line 1455 of yacc.c  */
#line 7630 "preproc.y"
    { 
 (yyval.str) = make_str("all");
;}
    break;

  case 1208:

/* Line 1455 of yacc.c  */
#line 7634 "preproc.y"
    { 
 (yyval.str) = make_str("distinct");
;}
    break;

  case 1209:

/* Line 1455 of yacc.c  */
#line 7638 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1210:

/* Line 1455 of yacc.c  */
#line 7645 "preproc.y"
    { 
 (yyval.str) = make_str("distinct");
;}
    break;

  case 1211:

/* Line 1455 of yacc.c  */
#line 7649 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("distinct on ("),(yyvsp[(4) - (5)].str),make_str(")"));
;}
    break;

  case 1212:

/* Line 1455 of yacc.c  */
#line 7653 "preproc.y"
    { 
 (yyval.str) = make_str("all");
;}
    break;

  case 1213:

/* Line 1455 of yacc.c  */
#line 7657 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1214:

/* Line 1455 of yacc.c  */
#line 7664 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1215:

/* Line 1455 of yacc.c  */
#line 7668 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1216:

/* Line 1455 of yacc.c  */
#line 7675 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("order by"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1217:

/* Line 1455 of yacc.c  */
#line 7683 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1218:

/* Line 1455 of yacc.c  */
#line 7687 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1219:

/* Line 1455 of yacc.c  */
#line 7695 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (4)].str),make_str("using"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1220:

/* Line 1455 of yacc.c  */
#line 7699 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1221:

/* Line 1455 of yacc.c  */
#line 7707 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1222:

/* Line 1455 of yacc.c  */
#line 7711 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1223:

/* Line 1455 of yacc.c  */
#line 7715 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1224:

/* Line 1455 of yacc.c  */
#line 7719 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1225:

/* Line 1455 of yacc.c  */
#line 7727 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1226:

/* Line 1455 of yacc.c  */
#line 7731 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1227:

/* Line 1455 of yacc.c  */
#line 7738 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("limit"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1228:

/* Line 1455 of yacc.c  */
#line 7742 "preproc.y"
    {
                mmerror(PARSE_ERROR, ET_WARNING, "no longer supported LIMIT #,# syntax passed to server");
                (yyval.str) = cat_str(4, make_str("limit"), (yyvsp[(2) - (4)].str), make_str(","), (yyvsp[(4) - (4)].str));
        ;}
    break;

  case 1229:

/* Line 1455 of yacc.c  */
#line 7747 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("fetch"),(yyvsp[(2) - (5)].str),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),make_str("only"));
;}
    break;

  case 1230:

/* Line 1455 of yacc.c  */
#line 7755 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("offset"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1231:

/* Line 1455 of yacc.c  */
#line 7759 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("offset"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1232:

/* Line 1455 of yacc.c  */
#line 7767 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1233:

/* Line 1455 of yacc.c  */
#line 7771 "preproc.y"
    { 
 (yyval.str) = make_str("all");
;}
    break;

  case 1234:

/* Line 1455 of yacc.c  */
#line 7779 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1235:

/* Line 1455 of yacc.c  */
#line 7787 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1236:

/* Line 1455 of yacc.c  */
#line 7791 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 1237:

/* Line 1455 of yacc.c  */
#line 7795 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1238:

/* Line 1455 of yacc.c  */
#line 7802 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1239:

/* Line 1455 of yacc.c  */
#line 7810 "preproc.y"
    { 
 (yyval.str) = make_str("row");
;}
    break;

  case 1240:

/* Line 1455 of yacc.c  */
#line 7814 "preproc.y"
    { 
 (yyval.str) = make_str("rows");
;}
    break;

  case 1241:

/* Line 1455 of yacc.c  */
#line 7822 "preproc.y"
    { 
 (yyval.str) = make_str("first");
;}
    break;

  case 1242:

/* Line 1455 of yacc.c  */
#line 7826 "preproc.y"
    { 
 (yyval.str) = make_str("next");
;}
    break;

  case 1243:

/* Line 1455 of yacc.c  */
#line 7834 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("group by"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1244:

/* Line 1455 of yacc.c  */
#line 7838 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1245:

/* Line 1455 of yacc.c  */
#line 7845 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("having"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1246:

/* Line 1455 of yacc.c  */
#line 7849 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1247:

/* Line 1455 of yacc.c  */
#line 7856 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1248:

/* Line 1455 of yacc.c  */
#line 7860 "preproc.y"
    { 
 (yyval.str) = make_str("for read only");
;}
    break;

  case 1249:

/* Line 1455 of yacc.c  */
#line 7868 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1250:

/* Line 1455 of yacc.c  */
#line 7872 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1251:

/* Line 1455 of yacc.c  */
#line 7879 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1252:

/* Line 1455 of yacc.c  */
#line 7883 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1253:

/* Line 1455 of yacc.c  */
#line 7891 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("for update"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1254:

/* Line 1455 of yacc.c  */
#line 7895 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("for share"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1255:

/* Line 1455 of yacc.c  */
#line 7903 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("of"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1256:

/* Line 1455 of yacc.c  */
#line 7907 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1257:

/* Line 1455 of yacc.c  */
#line 7914 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("values"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1258:

/* Line 1455 of yacc.c  */
#line 7918 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1259:

/* Line 1455 of yacc.c  */
#line 7926 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("from"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1260:

/* Line 1455 of yacc.c  */
#line 7930 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1261:

/* Line 1455 of yacc.c  */
#line 7937 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1262:

/* Line 1455 of yacc.c  */
#line 7941 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1263:

/* Line 1455 of yacc.c  */
#line 7949 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1264:

/* Line 1455 of yacc.c  */
#line 7953 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1265:

/* Line 1455 of yacc.c  */
#line 7957 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1266:

/* Line 1455 of yacc.c  */
#line 7961 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1267:

/* Line 1455 of yacc.c  */
#line 7965 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (5)].str),make_str("as ("),(yyvsp[(4) - (5)].str),make_str(")"));
;}
    break;

  case 1268:

/* Line 1455 of yacc.c  */
#line 7969 "preproc.y"
    { 
 (yyval.str) = cat_str(6,(yyvsp[(1) - (6)].str),make_str("as"),(yyvsp[(3) - (6)].str),make_str("("),(yyvsp[(5) - (6)].str),make_str(")"));
;}
    break;

  case 1269:

/* Line 1455 of yacc.c  */
#line 7973 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (5)].str),(yyvsp[(2) - (5)].str),make_str("("),(yyvsp[(4) - (5)].str),make_str(")"));
;}
    break;

  case 1270:

/* Line 1455 of yacc.c  */
#line 7977 "preproc.y"
    { 
		mmerror(PARSE_ERROR, ET_ERROR, "subquery in FROM must have an alias");

 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1271:

/* Line 1455 of yacc.c  */
#line 7983 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1272:

/* Line 1455 of yacc.c  */
#line 7987 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1273:

/* Line 1455 of yacc.c  */
#line 7991 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("("),(yyvsp[(2) - (4)].str),make_str(")"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1274:

/* Line 1455 of yacc.c  */
#line 7999 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 1275:

/* Line 1455 of yacc.c  */
#line 8003 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (4)].str),make_str("cross join"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1276:

/* Line 1455 of yacc.c  */
#line 8007 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (5)].str),(yyvsp[(2) - (5)].str),make_str("join"),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1277:

/* Line 1455 of yacc.c  */
#line 8011 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (4)].str),make_str("join"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1278:

/* Line 1455 of yacc.c  */
#line 8015 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (5)].str),make_str("natural"),(yyvsp[(3) - (5)].str),make_str("join"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1279:

/* Line 1455 of yacc.c  */
#line 8019 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (4)].str),make_str("natural join"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1280:

/* Line 1455 of yacc.c  */
#line 8027 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("as"),(yyvsp[(2) - (5)].str),make_str("("),(yyvsp[(4) - (5)].str),make_str(")"));
;}
    break;

  case 1281:

/* Line 1455 of yacc.c  */
#line 8031 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("as"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1282:

/* Line 1455 of yacc.c  */
#line 8035 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (4)].str),make_str("("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1283:

/* Line 1455 of yacc.c  */
#line 8039 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1284:

/* Line 1455 of yacc.c  */
#line 8047 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("full"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1285:

/* Line 1455 of yacc.c  */
#line 8051 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("left"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1286:

/* Line 1455 of yacc.c  */
#line 8055 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("right"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1287:

/* Line 1455 of yacc.c  */
#line 8059 "preproc.y"
    { 
 (yyval.str) = make_str("inner");
;}
    break;

  case 1288:

/* Line 1455 of yacc.c  */
#line 8067 "preproc.y"
    { 
 (yyval.str) = make_str("outer");
;}
    break;

  case 1289:

/* Line 1455 of yacc.c  */
#line 8071 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1290:

/* Line 1455 of yacc.c  */
#line 8078 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("using ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1291:

/* Line 1455 of yacc.c  */
#line 8082 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("on"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1292:

/* Line 1455 of yacc.c  */
#line 8090 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1293:

/* Line 1455 of yacc.c  */
#line 8094 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),make_str("*"));
;}
    break;

  case 1294:

/* Line 1455 of yacc.c  */
#line 8098 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("only"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1295:

/* Line 1455 of yacc.c  */
#line 8102 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("only ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1296:

/* Line 1455 of yacc.c  */
#line 8110 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1297:

/* Line 1455 of yacc.c  */
#line 8114 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1298:

/* Line 1455 of yacc.c  */
#line 8122 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1299:

/* Line 1455 of yacc.c  */
#line 8126 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1300:

/* Line 1455 of yacc.c  */
#line 8130 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("as"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1301:

/* Line 1455 of yacc.c  */
#line 8138 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1302:

/* Line 1455 of yacc.c  */
#line 8146 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("where"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1303:

/* Line 1455 of yacc.c  */
#line 8150 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1304:

/* Line 1455 of yacc.c  */
#line 8157 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("where"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1305:

/* Line 1455 of yacc.c  */
#line 8161 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("where current of"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1306:

/* Line 1455 of yacc.c  */
#line 8165 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1307:

/* Line 1455 of yacc.c  */
#line 8172 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1308:

/* Line 1455 of yacc.c  */
#line 8176 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1309:

/* Line 1455 of yacc.c  */
#line 8184 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1310:

/* Line 1455 of yacc.c  */
#line 8192 "preproc.y"
    {	(yyval.str) = cat2_str((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].index).str); ;}
    break;

  case 1311:

/* Line 1455 of yacc.c  */
#line 8194 "preproc.y"
    {	(yyval.str) = cat_str(3, make_str("setof"), (yyvsp[(2) - (3)].str), (yyvsp[(3) - (3)].index).str); ;}
    break;

  case 1312:

/* Line 1455 of yacc.c  */
#line 8196 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (5)].str),make_str("array ["),(yyvsp[(4) - (5)].str),make_str("]"));
;}
    break;

  case 1313:

/* Line 1455 of yacc.c  */
#line 8200 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("setof"),(yyvsp[(2) - (6)].str),make_str("array ["),(yyvsp[(5) - (6)].str),make_str("]"));
;}
    break;

  case 1314:

/* Line 1455 of yacc.c  */
#line 8204 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),make_str("array"));
;}
    break;

  case 1315:

/* Line 1455 of yacc.c  */
#line 8208 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("setof"),(yyvsp[(2) - (3)].str),make_str("array"));
;}
    break;

  case 1316:

/* Line 1455 of yacc.c  */
#line 8216 "preproc.y"
    {
		(yyval.index).index1 = (yyvsp[(1) - (3)].index).index1;
		(yyval.index).index2 = (yyvsp[(1) - (3)].index).index2;
		if (strcmp((yyval.index).index1, "-1") == 0)
			(yyval.index).index1 = make_str("0");
		else if (strcmp((yyvsp[(1) - (3)].index).index2, "-1") == 0)
			(yyval.index).index2 = make_str("0");
		(yyval.index).str = cat_str(2, (yyvsp[(1) - (3)].index).str, make_str("[]"));
	;}
    break;

  case 1317:

/* Line 1455 of yacc.c  */
#line 8226 "preproc.y"
    {
		(yyval.index).index1 = (yyvsp[(1) - (4)].index).index1;
		(yyval.index).index2 = (yyvsp[(1) - (4)].index).index2;
		if (strcmp((yyvsp[(1) - (4)].index).index1, "-1") == 0)
			(yyval.index).index1 = strdup((yyvsp[(3) - (4)].str));
		else if (strcmp((yyvsp[(1) - (4)].index).index2, "-1") == 0)
			(yyval.index).index2 = strdup((yyvsp[(3) - (4)].str));
		(yyval.index).str = cat_str(4, (yyvsp[(1) - (4)].index).str, make_str("["), (yyvsp[(3) - (4)].str), make_str("]"));
	;}
    break;

  case 1318:

/* Line 1455 of yacc.c  */
#line 8236 "preproc.y"
    {
		(yyval.index).index1 = make_str("-1");
		(yyval.index).index2 = make_str("-1");
		(yyval.index).str= EMPTY;
	;}
    break;

  case 1319:

/* Line 1455 of yacc.c  */
#line 8246 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1320:

/* Line 1455 of yacc.c  */
#line 8250 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1321:

/* Line 1455 of yacc.c  */
#line 8254 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1322:

/* Line 1455 of yacc.c  */
#line 8258 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1323:

/* Line 1455 of yacc.c  */
#line 8262 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1324:

/* Line 1455 of yacc.c  */
#line 8266 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1325:

/* Line 1455 of yacc.c  */
#line 8270 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (5)].str),make_str("("),(yyvsp[(3) - (5)].str),make_str(")"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1326:

/* Line 1455 of yacc.c  */
#line 8278 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1327:

/* Line 1455 of yacc.c  */
#line 8282 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1328:

/* Line 1455 of yacc.c  */
#line 8286 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1329:

/* Line 1455 of yacc.c  */
#line 8290 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1330:

/* Line 1455 of yacc.c  */
#line 8298 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1331:

/* Line 1455 of yacc.c  */
#line 8302 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1332:

/* Line 1455 of yacc.c  */
#line 8310 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 1333:

/* Line 1455 of yacc.c  */
#line 8314 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1334:

/* Line 1455 of yacc.c  */
#line 8321 "preproc.y"
    { 
 (yyval.str) = make_str("int");
;}
    break;

  case 1335:

/* Line 1455 of yacc.c  */
#line 8325 "preproc.y"
    { 
 (yyval.str) = make_str("integer");
;}
    break;

  case 1336:

/* Line 1455 of yacc.c  */
#line 8329 "preproc.y"
    { 
 (yyval.str) = make_str("smallint");
;}
    break;

  case 1337:

/* Line 1455 of yacc.c  */
#line 8333 "preproc.y"
    { 
 (yyval.str) = make_str("bigint");
;}
    break;

  case 1338:

/* Line 1455 of yacc.c  */
#line 8337 "preproc.y"
    { 
 (yyval.str) = make_str("real");
;}
    break;

  case 1339:

/* Line 1455 of yacc.c  */
#line 8341 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("float"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1340:

/* Line 1455 of yacc.c  */
#line 8345 "preproc.y"
    { 
 (yyval.str) = make_str("double precision");
;}
    break;

  case 1341:

/* Line 1455 of yacc.c  */
#line 8349 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("decimal"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1342:

/* Line 1455 of yacc.c  */
#line 8353 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("dec"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1343:

/* Line 1455 of yacc.c  */
#line 8357 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("numeric"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1344:

/* Line 1455 of yacc.c  */
#line 8361 "preproc.y"
    { 
 (yyval.str) = make_str("boolean");
;}
    break;

  case 1345:

/* Line 1455 of yacc.c  */
#line 8369 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 1346:

/* Line 1455 of yacc.c  */
#line 8373 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1347:

/* Line 1455 of yacc.c  */
#line 8380 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1348:

/* Line 1455 of yacc.c  */
#line 8384 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1349:

/* Line 1455 of yacc.c  */
#line 8392 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1350:

/* Line 1455 of yacc.c  */
#line 8396 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1351:

/* Line 1455 of yacc.c  */
#line 8404 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("bit"),(yyvsp[(2) - (5)].str),make_str("("),(yyvsp[(4) - (5)].str),make_str(")"));
;}
    break;

  case 1352:

/* Line 1455 of yacc.c  */
#line 8412 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("bit"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1353:

/* Line 1455 of yacc.c  */
#line 8420 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1354:

/* Line 1455 of yacc.c  */
#line 8424 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1355:

/* Line 1455 of yacc.c  */
#line 8432 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1356:

/* Line 1455 of yacc.c  */
#line 8436 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1357:

/* Line 1455 of yacc.c  */
#line 8444 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (5)].str),make_str("("),(yyvsp[(3) - (5)].str),make_str(")"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1358:

/* Line 1455 of yacc.c  */
#line 8452 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1359:

/* Line 1455 of yacc.c  */
#line 8460 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("character"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1360:

/* Line 1455 of yacc.c  */
#line 8464 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("char"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1361:

/* Line 1455 of yacc.c  */
#line 8468 "preproc.y"
    { 
 (yyval.str) = make_str("varchar");
;}
    break;

  case 1362:

/* Line 1455 of yacc.c  */
#line 8472 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("national character"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1363:

/* Line 1455 of yacc.c  */
#line 8476 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("national char"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1364:

/* Line 1455 of yacc.c  */
#line 8480 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("nchar"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1365:

/* Line 1455 of yacc.c  */
#line 8488 "preproc.y"
    { 
 (yyval.str) = make_str("varying");
;}
    break;

  case 1366:

/* Line 1455 of yacc.c  */
#line 8492 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1367:

/* Line 1455 of yacc.c  */
#line 8499 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("character set"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1368:

/* Line 1455 of yacc.c  */
#line 8503 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1369:

/* Line 1455 of yacc.c  */
#line 8510 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("timestamp ("),(yyvsp[(3) - (5)].str),make_str(")"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1370:

/* Line 1455 of yacc.c  */
#line 8514 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("timestamp"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1371:

/* Line 1455 of yacc.c  */
#line 8518 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("time ("),(yyvsp[(3) - (5)].str),make_str(")"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1372:

/* Line 1455 of yacc.c  */
#line 8522 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("time"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1373:

/* Line 1455 of yacc.c  */
#line 8530 "preproc.y"
    { 
 (yyval.str) = make_str("interval");
;}
    break;

  case 1374:

/* Line 1455 of yacc.c  */
#line 8538 "preproc.y"
    { 
 (yyval.str) = make_str("with time zone");
;}
    break;

  case 1375:

/* Line 1455 of yacc.c  */
#line 8542 "preproc.y"
    { 
 (yyval.str) = make_str("without time zone");
;}
    break;

  case 1376:

/* Line 1455 of yacc.c  */
#line 8546 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1377:

/* Line 1455 of yacc.c  */
#line 8553 "preproc.y"
    { 
 (yyval.str) = make_str("year");
;}
    break;

  case 1378:

/* Line 1455 of yacc.c  */
#line 8557 "preproc.y"
    { 
 (yyval.str) = make_str("month");
;}
    break;

  case 1379:

/* Line 1455 of yacc.c  */
#line 8561 "preproc.y"
    { 
 (yyval.str) = make_str("day");
;}
    break;

  case 1380:

/* Line 1455 of yacc.c  */
#line 8565 "preproc.y"
    { 
 (yyval.str) = make_str("hour");
;}
    break;

  case 1381:

/* Line 1455 of yacc.c  */
#line 8569 "preproc.y"
    { 
 (yyval.str) = make_str("minute");
;}
    break;

  case 1382:

/* Line 1455 of yacc.c  */
#line 8573 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1383:

/* Line 1455 of yacc.c  */
#line 8577 "preproc.y"
    { 
 (yyval.str) = make_str("year to month");
;}
    break;

  case 1384:

/* Line 1455 of yacc.c  */
#line 8581 "preproc.y"
    { 
 (yyval.str) = make_str("day to hour");
;}
    break;

  case 1385:

/* Line 1455 of yacc.c  */
#line 8585 "preproc.y"
    { 
 (yyval.str) = make_str("day to minute");
;}
    break;

  case 1386:

/* Line 1455 of yacc.c  */
#line 8589 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("day to"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1387:

/* Line 1455 of yacc.c  */
#line 8593 "preproc.y"
    { 
 (yyval.str) = make_str("hour to minute");
;}
    break;

  case 1388:

/* Line 1455 of yacc.c  */
#line 8597 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("hour to"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1389:

/* Line 1455 of yacc.c  */
#line 8601 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("minute to"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1390:

/* Line 1455 of yacc.c  */
#line 8605 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1391:

/* Line 1455 of yacc.c  */
#line 8612 "preproc.y"
    { 
 (yyval.str) = make_str("second");
;}
    break;

  case 1392:

/* Line 1455 of yacc.c  */
#line 8616 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("second ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1393:

/* Line 1455 of yacc.c  */
#line 8624 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1394:

/* Line 1455 of yacc.c  */
#line 8628 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("::"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1395:

/* Line 1455 of yacc.c  */
#line 8632 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (5)].str),make_str("at time zone"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1396:

/* Line 1455 of yacc.c  */
#line 8636 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("+"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1397:

/* Line 1455 of yacc.c  */
#line 8640 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("-"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1398:

/* Line 1455 of yacc.c  */
#line 8644 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("+"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1399:

/* Line 1455 of yacc.c  */
#line 8648 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("-"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1400:

/* Line 1455 of yacc.c  */
#line 8652 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("*"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1401:

/* Line 1455 of yacc.c  */
#line 8656 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("/"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1402:

/* Line 1455 of yacc.c  */
#line 8660 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("%"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1403:

/* Line 1455 of yacc.c  */
#line 8664 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("^"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1404:

/* Line 1455 of yacc.c  */
#line 8668 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("<"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1405:

/* Line 1455 of yacc.c  */
#line 8672 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(">"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1406:

/* Line 1455 of yacc.c  */
#line 8676 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("="),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1407:

/* Line 1455 of yacc.c  */
#line 8680 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1408:

/* Line 1455 of yacc.c  */
#line 8684 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1409:

/* Line 1455 of yacc.c  */
#line 8688 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1410:

/* Line 1455 of yacc.c  */
#line 8692 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("and"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1411:

/* Line 1455 of yacc.c  */
#line 8696 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("or"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1412:

/* Line 1455 of yacc.c  */
#line 8700 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("not"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1413:

/* Line 1455 of yacc.c  */
#line 8704 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("like"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1414:

/* Line 1455 of yacc.c  */
#line 8708 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (5)].str),make_str("like"),(yyvsp[(3) - (5)].str),make_str("escape"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1415:

/* Line 1455 of yacc.c  */
#line 8712 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (4)].str),make_str("not like"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1416:

/* Line 1455 of yacc.c  */
#line 8716 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (6)].str),make_str("not like"),(yyvsp[(4) - (6)].str),make_str("escape"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 1417:

/* Line 1455 of yacc.c  */
#line 8720 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("ilike"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1418:

/* Line 1455 of yacc.c  */
#line 8724 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (5)].str),make_str("ilike"),(yyvsp[(3) - (5)].str),make_str("escape"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1419:

/* Line 1455 of yacc.c  */
#line 8728 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (4)].str),make_str("not ilike"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1420:

/* Line 1455 of yacc.c  */
#line 8732 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (6)].str),make_str("not ilike"),(yyvsp[(4) - (6)].str),make_str("escape"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 1421:

/* Line 1455 of yacc.c  */
#line 8736 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (4)].str),make_str("similar to"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1422:

/* Line 1455 of yacc.c  */
#line 8740 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (6)].str),make_str("similar to"),(yyvsp[(4) - (6)].str),make_str("escape"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 1423:

/* Line 1455 of yacc.c  */
#line 8744 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (5)].str),make_str("not similar to"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1424:

/* Line 1455 of yacc.c  */
#line 8748 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (7)].str),make_str("not similar to"),(yyvsp[(5) - (7)].str),make_str("escape"),(yyvsp[(7) - (7)].str));
;}
    break;

  case 1425:

/* Line 1455 of yacc.c  */
#line 8752 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (3)].str),make_str("is null"));
;}
    break;

  case 1426:

/* Line 1455 of yacc.c  */
#line 8756 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),make_str("isnull"));
;}
    break;

  case 1427:

/* Line 1455 of yacc.c  */
#line 8760 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (4)].str),make_str("is not null"));
;}
    break;

  case 1428:

/* Line 1455 of yacc.c  */
#line 8764 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),make_str("notnull"));
;}
    break;

  case 1429:

/* Line 1455 of yacc.c  */
#line 8768 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("overlaps"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1430:

/* Line 1455 of yacc.c  */
#line 8772 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (3)].str),make_str("is true"));
;}
    break;

  case 1431:

/* Line 1455 of yacc.c  */
#line 8776 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (4)].str),make_str("is not true"));
;}
    break;

  case 1432:

/* Line 1455 of yacc.c  */
#line 8780 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (3)].str),make_str("is false"));
;}
    break;

  case 1433:

/* Line 1455 of yacc.c  */
#line 8784 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (4)].str),make_str("is not false"));
;}
    break;

  case 1434:

/* Line 1455 of yacc.c  */
#line 8788 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (3)].str),make_str("is unknown"));
;}
    break;

  case 1435:

/* Line 1455 of yacc.c  */
#line 8792 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (4)].str),make_str("is not unknown"));
;}
    break;

  case 1436:

/* Line 1455 of yacc.c  */
#line 8796 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (5)].str),make_str("is distinct from"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1437:

/* Line 1455 of yacc.c  */
#line 8800 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (6)].str),make_str("is not distinct from"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 1438:

/* Line 1455 of yacc.c  */
#line 8804 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (6)].str),make_str("is of ("),(yyvsp[(5) - (6)].str),make_str(")"));
;}
    break;

  case 1439:

/* Line 1455 of yacc.c  */
#line 8808 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (7)].str),make_str("is not of ("),(yyvsp[(6) - (7)].str),make_str(")"));
;}
    break;

  case 1440:

/* Line 1455 of yacc.c  */
#line 8812 "preproc.y"
    { 
 (yyval.str) = cat_str(6,(yyvsp[(1) - (6)].str),make_str("between"),(yyvsp[(3) - (6)].str),(yyvsp[(4) - (6)].str),make_str("and"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 1441:

/* Line 1455 of yacc.c  */
#line 8816 "preproc.y"
    { 
 (yyval.str) = cat_str(6,(yyvsp[(1) - (7)].str),make_str("not between"),(yyvsp[(4) - (7)].str),(yyvsp[(5) - (7)].str),make_str("and"),(yyvsp[(7) - (7)].str));
;}
    break;

  case 1442:

/* Line 1455 of yacc.c  */
#line 8820 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (6)].str),make_str("between symmetric"),(yyvsp[(4) - (6)].str),make_str("and"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 1443:

/* Line 1455 of yacc.c  */
#line 8824 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (7)].str),make_str("not between symmetric"),(yyvsp[(5) - (7)].str),make_str("and"),(yyvsp[(7) - (7)].str));
;}
    break;

  case 1444:

/* Line 1455 of yacc.c  */
#line 8828 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("in"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1445:

/* Line 1455 of yacc.c  */
#line 8832 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (4)].str),make_str("not in"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1446:

/* Line 1455 of yacc.c  */
#line 8836 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (4)].str),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1447:

/* Line 1455 of yacc.c  */
#line 8840 "preproc.y"
    { 
 (yyval.str) = cat_str(6,(yyvsp[(1) - (6)].str),(yyvsp[(2) - (6)].str),(yyvsp[(3) - (6)].str),make_str("("),(yyvsp[(5) - (6)].str),make_str(")"));
;}
    break;

  case 1448:

/* Line 1455 of yacc.c  */
#line 8844 "preproc.y"
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(2,make_str("unique"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1449:

/* Line 1455 of yacc.c  */
#line 8849 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (3)].str),make_str("is document"));
;}
    break;

  case 1450:

/* Line 1455 of yacc.c  */
#line 8853 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (4)].str),make_str("is not document"));
;}
    break;

  case 1451:

/* Line 1455 of yacc.c  */
#line 8861 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1452:

/* Line 1455 of yacc.c  */
#line 8865 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("::"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1453:

/* Line 1455 of yacc.c  */
#line 8869 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("+"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1454:

/* Line 1455 of yacc.c  */
#line 8873 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("-"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1455:

/* Line 1455 of yacc.c  */
#line 8877 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("+"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1456:

/* Line 1455 of yacc.c  */
#line 8881 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("-"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1457:

/* Line 1455 of yacc.c  */
#line 8885 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("*"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1458:

/* Line 1455 of yacc.c  */
#line 8889 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("/"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1459:

/* Line 1455 of yacc.c  */
#line 8893 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("%"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1460:

/* Line 1455 of yacc.c  */
#line 8897 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("^"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1461:

/* Line 1455 of yacc.c  */
#line 8901 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("<"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1462:

/* Line 1455 of yacc.c  */
#line 8905 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(">"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1463:

/* Line 1455 of yacc.c  */
#line 8909 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("="),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1464:

/* Line 1455 of yacc.c  */
#line 8913 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1465:

/* Line 1455 of yacc.c  */
#line 8917 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1466:

/* Line 1455 of yacc.c  */
#line 8921 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1467:

/* Line 1455 of yacc.c  */
#line 8925 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (5)].str),make_str("is distinct from"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1468:

/* Line 1455 of yacc.c  */
#line 8929 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (6)].str),make_str("is not distinct from"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 1469:

/* Line 1455 of yacc.c  */
#line 8933 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (6)].str),make_str("is of ("),(yyvsp[(5) - (6)].str),make_str(")"));
;}
    break;

  case 1470:

/* Line 1455 of yacc.c  */
#line 8937 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (7)].str),make_str("is not of ("),(yyvsp[(6) - (7)].str),make_str(")"));
;}
    break;

  case 1471:

/* Line 1455 of yacc.c  */
#line 8941 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (3)].str),make_str("is document"));
;}
    break;

  case 1472:

/* Line 1455 of yacc.c  */
#line 8945 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (4)].str),make_str("is not document"));
;}
    break;

  case 1473:

/* Line 1455 of yacc.c  */
#line 8953 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1474:

/* Line 1455 of yacc.c  */
#line 8957 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1475:

/* Line 1455 of yacc.c  */
#line 8961 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1476:

/* Line 1455 of yacc.c  */
#line 8965 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("("),(yyvsp[(2) - (4)].str),make_str(")"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1477:

/* Line 1455 of yacc.c  */
#line 8969 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1478:

/* Line 1455 of yacc.c  */
#line 8973 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1479:

/* Line 1455 of yacc.c  */
#line 8977 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1480:

/* Line 1455 of yacc.c  */
#line 8981 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("exists"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1481:

/* Line 1455 of yacc.c  */
#line 8985 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("array"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1482:

/* Line 1455 of yacc.c  */
#line 8989 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("array"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1483:

/* Line 1455 of yacc.c  */
#line 8993 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1484:

/* Line 1455 of yacc.c  */
#line 9001 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (4)].str),make_str("( )"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1485:

/* Line 1455 of yacc.c  */
#line 9005 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (5)].str),make_str("("),(yyvsp[(3) - (5)].str),make_str(")"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1486:

/* Line 1455 of yacc.c  */
#line 9009 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (6)].str),make_str("( variadic"),(yyvsp[(4) - (6)].str),make_str(")"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 1487:

/* Line 1455 of yacc.c  */
#line 9013 "preproc.y"
    { 
 (yyval.str) = cat_str(7,(yyvsp[(1) - (8)].str),make_str("("),(yyvsp[(3) - (8)].str),make_str(", variadic"),(yyvsp[(6) - (8)].str),make_str(")"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 1488:

/* Line 1455 of yacc.c  */
#line 9017 "preproc.y"
    { 
 (yyval.str) = cat_str(6,(yyvsp[(1) - (6)].str),make_str("("),(yyvsp[(3) - (6)].str),(yyvsp[(4) - (6)].str),make_str(")"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 1489:

/* Line 1455 of yacc.c  */
#line 9021 "preproc.y"
    { 
 (yyval.str) = cat_str(6,(yyvsp[(1) - (7)].str),make_str("( all"),(yyvsp[(4) - (7)].str),(yyvsp[(5) - (7)].str),make_str(")"),(yyvsp[(7) - (7)].str));
;}
    break;

  case 1490:

/* Line 1455 of yacc.c  */
#line 9025 "preproc.y"
    { 
 (yyval.str) = cat_str(6,(yyvsp[(1) - (7)].str),make_str("( distinct"),(yyvsp[(4) - (7)].str),(yyvsp[(5) - (7)].str),make_str(")"),(yyvsp[(7) - (7)].str));
;}
    break;

  case 1491:

/* Line 1455 of yacc.c  */
#line 9029 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (5)].str),make_str("( * )"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1492:

/* Line 1455 of yacc.c  */
#line 9033 "preproc.y"
    { 
 (yyval.str) = make_str("current_date");
;}
    break;

  case 1493:

/* Line 1455 of yacc.c  */
#line 9037 "preproc.y"
    { 
 (yyval.str) = make_str("current_time");
;}
    break;

  case 1494:

/* Line 1455 of yacc.c  */
#line 9041 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("current_time ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1495:

/* Line 1455 of yacc.c  */
#line 9045 "preproc.y"
    { 
 (yyval.str) = make_str("current_timestamp");
;}
    break;

  case 1496:

/* Line 1455 of yacc.c  */
#line 9049 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("current_timestamp ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1497:

/* Line 1455 of yacc.c  */
#line 9053 "preproc.y"
    { 
 (yyval.str) = make_str("localtime");
;}
    break;

  case 1498:

/* Line 1455 of yacc.c  */
#line 9057 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("localtime ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1499:

/* Line 1455 of yacc.c  */
#line 9061 "preproc.y"
    { 
 (yyval.str) = make_str("localtimestamp");
;}
    break;

  case 1500:

/* Line 1455 of yacc.c  */
#line 9065 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("localtimestamp ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1501:

/* Line 1455 of yacc.c  */
#line 9069 "preproc.y"
    { 
 (yyval.str) = make_str("current_role");
;}
    break;

  case 1502:

/* Line 1455 of yacc.c  */
#line 9073 "preproc.y"
    { 
 (yyval.str) = make_str("current_user");
;}
    break;

  case 1503:

/* Line 1455 of yacc.c  */
#line 9077 "preproc.y"
    { 
 (yyval.str) = make_str("session_user");
;}
    break;

  case 1504:

/* Line 1455 of yacc.c  */
#line 9081 "preproc.y"
    { 
 (yyval.str) = make_str("user");
;}
    break;

  case 1505:

/* Line 1455 of yacc.c  */
#line 9085 "preproc.y"
    { 
 (yyval.str) = make_str("current_catalog");
;}
    break;

  case 1506:

/* Line 1455 of yacc.c  */
#line 9089 "preproc.y"
    { 
 (yyval.str) = make_str("current_schema");
;}
    break;

  case 1507:

/* Line 1455 of yacc.c  */
#line 9093 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("cast ("),(yyvsp[(3) - (6)].str),make_str("as"),(yyvsp[(5) - (6)].str),make_str(")"));
;}
    break;

  case 1508:

/* Line 1455 of yacc.c  */
#line 9097 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("extract ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1509:

/* Line 1455 of yacc.c  */
#line 9101 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("overlay ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1510:

/* Line 1455 of yacc.c  */
#line 9105 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("position ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1511:

/* Line 1455 of yacc.c  */
#line 9109 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("substring ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1512:

/* Line 1455 of yacc.c  */
#line 9113 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("treat ("),(yyvsp[(3) - (6)].str),make_str("as"),(yyvsp[(5) - (6)].str),make_str(")"));
;}
    break;

  case 1513:

/* Line 1455 of yacc.c  */
#line 9117 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("trim ( both"),(yyvsp[(4) - (5)].str),make_str(")"));
;}
    break;

  case 1514:

/* Line 1455 of yacc.c  */
#line 9121 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("trim ( leading"),(yyvsp[(4) - (5)].str),make_str(")"));
;}
    break;

  case 1515:

/* Line 1455 of yacc.c  */
#line 9125 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("trim ( trailing"),(yyvsp[(4) - (5)].str),make_str(")"));
;}
    break;

  case 1516:

/* Line 1455 of yacc.c  */
#line 9129 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("trim ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1517:

/* Line 1455 of yacc.c  */
#line 9133 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("nullif ("),(yyvsp[(3) - (6)].str),make_str(","),(yyvsp[(5) - (6)].str),make_str(")"));
;}
    break;

  case 1518:

/* Line 1455 of yacc.c  */
#line 9137 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("coalesce ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1519:

/* Line 1455 of yacc.c  */
#line 9141 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("greatest ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1520:

/* Line 1455 of yacc.c  */
#line 9145 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("least ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1521:

/* Line 1455 of yacc.c  */
#line 9149 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("xmlconcat ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1522:

/* Line 1455 of yacc.c  */
#line 9153 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("xmlelement ( name"),(yyvsp[(4) - (5)].str),make_str(")"));
;}
    break;

  case 1523:

/* Line 1455 of yacc.c  */
#line 9157 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("xmlelement ( name"),(yyvsp[(4) - (7)].str),make_str(","),(yyvsp[(6) - (7)].str),make_str(")"));
;}
    break;

  case 1524:

/* Line 1455 of yacc.c  */
#line 9161 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("xmlelement ( name"),(yyvsp[(4) - (7)].str),make_str(","),(yyvsp[(6) - (7)].str),make_str(")"));
;}
    break;

  case 1525:

/* Line 1455 of yacc.c  */
#line 9165 "preproc.y"
    { 
 (yyval.str) = cat_str(7,make_str("xmlelement ( name"),(yyvsp[(4) - (9)].str),make_str(","),(yyvsp[(6) - (9)].str),make_str(","),(yyvsp[(8) - (9)].str),make_str(")"));
;}
    break;

  case 1526:

/* Line 1455 of yacc.c  */
#line 9169 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("xmlforest ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1527:

/* Line 1455 of yacc.c  */
#line 9173 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("xmlparse ("),(yyvsp[(3) - (6)].str),(yyvsp[(4) - (6)].str),(yyvsp[(5) - (6)].str),make_str(")"));
;}
    break;

  case 1528:

/* Line 1455 of yacc.c  */
#line 9177 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("xmlpi ( name"),(yyvsp[(4) - (5)].str),make_str(")"));
;}
    break;

  case 1529:

/* Line 1455 of yacc.c  */
#line 9181 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("xmlpi ( name"),(yyvsp[(4) - (7)].str),make_str(","),(yyvsp[(6) - (7)].str),make_str(")"));
;}
    break;

  case 1530:

/* Line 1455 of yacc.c  */
#line 9185 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("xmlroot ("),(yyvsp[(3) - (7)].str),make_str(","),(yyvsp[(5) - (7)].str),(yyvsp[(6) - (7)].str),make_str(")"));
;}
    break;

  case 1531:

/* Line 1455 of yacc.c  */
#line 9189 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("xmlserialize ("),(yyvsp[(3) - (7)].str),(yyvsp[(4) - (7)].str),make_str("as"),(yyvsp[(6) - (7)].str),make_str(")"));
;}
    break;

  case 1532:

/* Line 1455 of yacc.c  */
#line 9197 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("version"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1533:

/* Line 1455 of yacc.c  */
#line 9201 "preproc.y"
    { 
 (yyval.str) = make_str("version no value");
;}
    break;

  case 1534:

/* Line 1455 of yacc.c  */
#line 9209 "preproc.y"
    { 
 (yyval.str) = make_str(", standalone yes");
;}
    break;

  case 1535:

/* Line 1455 of yacc.c  */
#line 9213 "preproc.y"
    { 
 (yyval.str) = make_str(", standalone no");
;}
    break;

  case 1536:

/* Line 1455 of yacc.c  */
#line 9217 "preproc.y"
    { 
 (yyval.str) = make_str(", standalone no value");
;}
    break;

  case 1537:

/* Line 1455 of yacc.c  */
#line 9221 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1538:

/* Line 1455 of yacc.c  */
#line 9228 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("xmlattributes ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1539:

/* Line 1455 of yacc.c  */
#line 9236 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1540:

/* Line 1455 of yacc.c  */
#line 9240 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1541:

/* Line 1455 of yacc.c  */
#line 9248 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("as"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1542:

/* Line 1455 of yacc.c  */
#line 9252 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1543:

/* Line 1455 of yacc.c  */
#line 9260 "preproc.y"
    { 
 (yyval.str) = make_str("document");
;}
    break;

  case 1544:

/* Line 1455 of yacc.c  */
#line 9264 "preproc.y"
    { 
 (yyval.str) = make_str("content");
;}
    break;

  case 1545:

/* Line 1455 of yacc.c  */
#line 9272 "preproc.y"
    { 
 (yyval.str) = make_str("preserve whitespace");
;}
    break;

  case 1546:

/* Line 1455 of yacc.c  */
#line 9276 "preproc.y"
    { 
 (yyval.str) = make_str("strip whitespace");
;}
    break;

  case 1547:

/* Line 1455 of yacc.c  */
#line 9280 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1548:

/* Line 1455 of yacc.c  */
#line 9287 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("window"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1549:

/* Line 1455 of yacc.c  */
#line 9291 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1550:

/* Line 1455 of yacc.c  */
#line 9298 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1551:

/* Line 1455 of yacc.c  */
#line 9302 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1552:

/* Line 1455 of yacc.c  */
#line 9310 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("as"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1553:

/* Line 1455 of yacc.c  */
#line 9318 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("over"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1554:

/* Line 1455 of yacc.c  */
#line 9322 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("over"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1555:

/* Line 1455 of yacc.c  */
#line 9326 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1556:

/* Line 1455 of yacc.c  */
#line 9333 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("("),(yyvsp[(2) - (6)].str),(yyvsp[(3) - (6)].str),(yyvsp[(4) - (6)].str),(yyvsp[(5) - (6)].str),make_str(")"));
;}
    break;

  case 1557:

/* Line 1455 of yacc.c  */
#line 9341 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1558:

/* Line 1455 of yacc.c  */
#line 9345 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1559:

/* Line 1455 of yacc.c  */
#line 9352 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("partition by"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1560:

/* Line 1455 of yacc.c  */
#line 9356 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1561:

/* Line 1455 of yacc.c  */
#line 9363 "preproc.y"
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(2,make_str("range"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1562:

/* Line 1455 of yacc.c  */
#line 9368 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("rows"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1563:

/* Line 1455 of yacc.c  */
#line 9372 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1564:

/* Line 1455 of yacc.c  */
#line 9379 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1565:

/* Line 1455 of yacc.c  */
#line 9383 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("between"),(yyvsp[(2) - (4)].str),make_str("and"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1566:

/* Line 1455 of yacc.c  */
#line 9391 "preproc.y"
    { 
 (yyval.str) = make_str("unbounded preceding");
;}
    break;

  case 1567:

/* Line 1455 of yacc.c  */
#line 9395 "preproc.y"
    { 
 (yyval.str) = make_str("unbounded following");
;}
    break;

  case 1568:

/* Line 1455 of yacc.c  */
#line 9399 "preproc.y"
    { 
 (yyval.str) = make_str("current row");
;}
    break;

  case 1569:

/* Line 1455 of yacc.c  */
#line 9403 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),make_str("preceding"));
;}
    break;

  case 1570:

/* Line 1455 of yacc.c  */
#line 9407 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),make_str("following"));
;}
    break;

  case 1571:

/* Line 1455 of yacc.c  */
#line 9415 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("row ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1572:

/* Line 1455 of yacc.c  */
#line 9419 "preproc.y"
    { 
 (yyval.str) = make_str("row ( )");
;}
    break;

  case 1573:

/* Line 1455 of yacc.c  */
#line 9423 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("("),(yyvsp[(2) - (5)].str),make_str(","),(yyvsp[(4) - (5)].str),make_str(")"));
;}
    break;

  case 1574:

/* Line 1455 of yacc.c  */
#line 9431 "preproc.y"
    { 
 (yyval.str) = make_str("any");
;}
    break;

  case 1575:

/* Line 1455 of yacc.c  */
#line 9435 "preproc.y"
    { 
 (yyval.str) = make_str("some");
;}
    break;

  case 1576:

/* Line 1455 of yacc.c  */
#line 9439 "preproc.y"
    { 
 (yyval.str) = make_str("all");
;}
    break;

  case 1577:

/* Line 1455 of yacc.c  */
#line 9447 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1578:

/* Line 1455 of yacc.c  */
#line 9451 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1579:

/* Line 1455 of yacc.c  */
#line 9459 "preproc.y"
    { 
 (yyval.str) = make_str("+");
;}
    break;

  case 1580:

/* Line 1455 of yacc.c  */
#line 9463 "preproc.y"
    { 
 (yyval.str) = make_str("-");
;}
    break;

  case 1581:

/* Line 1455 of yacc.c  */
#line 9467 "preproc.y"
    { 
 (yyval.str) = make_str("*");
;}
    break;

  case 1582:

/* Line 1455 of yacc.c  */
#line 9471 "preproc.y"
    { 
 (yyval.str) = make_str("/");
;}
    break;

  case 1583:

/* Line 1455 of yacc.c  */
#line 9475 "preproc.y"
    { 
 (yyval.str) = make_str("%");
;}
    break;

  case 1584:

/* Line 1455 of yacc.c  */
#line 9479 "preproc.y"
    { 
 (yyval.str) = make_str("^");
;}
    break;

  case 1585:

/* Line 1455 of yacc.c  */
#line 9483 "preproc.y"
    { 
 (yyval.str) = make_str("<");
;}
    break;

  case 1586:

/* Line 1455 of yacc.c  */
#line 9487 "preproc.y"
    { 
 (yyval.str) = make_str(">");
;}
    break;

  case 1587:

/* Line 1455 of yacc.c  */
#line 9491 "preproc.y"
    { 
 (yyval.str) = make_str("=");
;}
    break;

  case 1588:

/* Line 1455 of yacc.c  */
#line 9499 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1589:

/* Line 1455 of yacc.c  */
#line 9503 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("operator ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1590:

/* Line 1455 of yacc.c  */
#line 9511 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1591:

/* Line 1455 of yacc.c  */
#line 9515 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("operator ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1592:

/* Line 1455 of yacc.c  */
#line 9523 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1593:

/* Line 1455 of yacc.c  */
#line 9527 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("operator ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1594:

/* Line 1455 of yacc.c  */
#line 9531 "preproc.y"
    { 
 (yyval.str) = make_str("like");
;}
    break;

  case 1595:

/* Line 1455 of yacc.c  */
#line 9535 "preproc.y"
    { 
 (yyval.str) = make_str("not like");
;}
    break;

  case 1596:

/* Line 1455 of yacc.c  */
#line 9539 "preproc.y"
    { 
 (yyval.str) = make_str("ilike");
;}
    break;

  case 1597:

/* Line 1455 of yacc.c  */
#line 9543 "preproc.y"
    { 
 (yyval.str) = make_str("not ilike");
;}
    break;

  case 1598:

/* Line 1455 of yacc.c  */
#line 9551 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1599:

/* Line 1455 of yacc.c  */
#line 9555 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1600:

/* Line 1455 of yacc.c  */
#line 9563 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1601:

/* Line 1455 of yacc.c  */
#line 9567 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1602:

/* Line 1455 of yacc.c  */
#line 9575 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1603:

/* Line 1455 of yacc.c  */
#line 9579 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(":="),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1604:

/* Line 1455 of yacc.c  */
#line 9587 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1605:

/* Line 1455 of yacc.c  */
#line 9591 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1606:

/* Line 1455 of yacc.c  */
#line 9599 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("["),(yyvsp[(2) - (3)].str),make_str("]"));
;}
    break;

  case 1607:

/* Line 1455 of yacc.c  */
#line 9603 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("["),(yyvsp[(2) - (3)].str),make_str("]"));
;}
    break;

  case 1608:

/* Line 1455 of yacc.c  */
#line 9607 "preproc.y"
    { 
 (yyval.str) = make_str("[ ]");
;}
    break;

  case 1609:

/* Line 1455 of yacc.c  */
#line 9615 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1610:

/* Line 1455 of yacc.c  */
#line 9619 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1611:

/* Line 1455 of yacc.c  */
#line 9627 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("from"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1612:

/* Line 1455 of yacc.c  */
#line 9631 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1613:

/* Line 1455 of yacc.c  */
#line 9638 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1614:

/* Line 1455 of yacc.c  */
#line 9642 "preproc.y"
    { 
 (yyval.str) = make_str("year");
;}
    break;

  case 1615:

/* Line 1455 of yacc.c  */
#line 9646 "preproc.y"
    { 
 (yyval.str) = make_str("month");
;}
    break;

  case 1616:

/* Line 1455 of yacc.c  */
#line 9650 "preproc.y"
    { 
 (yyval.str) = make_str("day");
;}
    break;

  case 1617:

/* Line 1455 of yacc.c  */
#line 9654 "preproc.y"
    { 
 (yyval.str) = make_str("hour");
;}
    break;

  case 1618:

/* Line 1455 of yacc.c  */
#line 9658 "preproc.y"
    { 
 (yyval.str) = make_str("minute");
;}
    break;

  case 1619:

/* Line 1455 of yacc.c  */
#line 9662 "preproc.y"
    { 
 (yyval.str) = make_str("second");
;}
    break;

  case 1620:

/* Line 1455 of yacc.c  */
#line 9666 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1621:

/* Line 1455 of yacc.c  */
#line 9674 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (4)].str),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1622:

/* Line 1455 of yacc.c  */
#line 9678 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1623:

/* Line 1455 of yacc.c  */
#line 9686 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("placing"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1624:

/* Line 1455 of yacc.c  */
#line 9694 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("in"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1625:

/* Line 1455 of yacc.c  */
#line 9698 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1626:

/* Line 1455 of yacc.c  */
#line 9705 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1627:

/* Line 1455 of yacc.c  */
#line 9709 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1628:

/* Line 1455 of yacc.c  */
#line 9713 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1629:

/* Line 1455 of yacc.c  */
#line 9717 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1630:

/* Line 1455 of yacc.c  */
#line 9721 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1631:

/* Line 1455 of yacc.c  */
#line 9725 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1632:

/* Line 1455 of yacc.c  */
#line 9732 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("from"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1633:

/* Line 1455 of yacc.c  */
#line 9740 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("for"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1634:

/* Line 1455 of yacc.c  */
#line 9748 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("from"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1635:

/* Line 1455 of yacc.c  */
#line 9752 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("from"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1636:

/* Line 1455 of yacc.c  */
#line 9756 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1637:

/* Line 1455 of yacc.c  */
#line 9764 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1638:

/* Line 1455 of yacc.c  */
#line 9768 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 1639:

/* Line 1455 of yacc.c  */
#line 9776 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("case"),(yyvsp[(2) - (5)].str),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),make_str("end"));
;}
    break;

  case 1640:

/* Line 1455 of yacc.c  */
#line 9784 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1641:

/* Line 1455 of yacc.c  */
#line 9788 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1642:

/* Line 1455 of yacc.c  */
#line 9796 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("when"),(yyvsp[(2) - (4)].str),make_str("then"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1643:

/* Line 1455 of yacc.c  */
#line 9804 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("else"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1644:

/* Line 1455 of yacc.c  */
#line 9808 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1645:

/* Line 1455 of yacc.c  */
#line 9815 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1646:

/* Line 1455 of yacc.c  */
#line 9819 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1647:

/* Line 1455 of yacc.c  */
#line 9826 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1648:

/* Line 1455 of yacc.c  */
#line 9830 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1649:

/* Line 1455 of yacc.c  */
#line 9838 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("."),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1650:

/* Line 1455 of yacc.c  */
#line 9842 "preproc.y"
    { 
 (yyval.str) = make_str(". *");
;}
    break;

  case 1651:

/* Line 1455 of yacc.c  */
#line 9846 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("["),(yyvsp[(2) - (3)].str),make_str("]"));
;}
    break;

  case 1652:

/* Line 1455 of yacc.c  */
#line 9850 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("["),(yyvsp[(2) - (5)].str),make_str(":"),(yyvsp[(4) - (5)].str),make_str("]"));
;}
    break;

  case 1653:

/* Line 1455 of yacc.c  */
#line 9858 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1654:

/* Line 1455 of yacc.c  */
#line 9862 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1655:

/* Line 1455 of yacc.c  */
#line 9870 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1656:

/* Line 1455 of yacc.c  */
#line 9873 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1657:

/* Line 1455 of yacc.c  */
#line 9881 "preproc.y"
    { 
 (yyval.str) = make_str("asymmetric");
;}
    break;

  case 1658:

/* Line 1455 of yacc.c  */
#line 9885 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1659:

/* Line 1455 of yacc.c  */
#line 9892 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1660:

/* Line 1455 of yacc.c  */
#line 9896 "preproc.y"
    { 
 (yyval.str) = make_str("default");
;}
    break;

  case 1661:

/* Line 1455 of yacc.c  */
#line 9904 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1662:

/* Line 1455 of yacc.c  */
#line 9908 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1663:

/* Line 1455 of yacc.c  */
#line 9916 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 1664:

/* Line 1455 of yacc.c  */
#line 9924 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1665:

/* Line 1455 of yacc.c  */
#line 9928 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1666:

/* Line 1455 of yacc.c  */
#line 9936 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("as"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1667:

/* Line 1455 of yacc.c  */
#line 9940 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1668:

/* Line 1455 of yacc.c  */
#line 9944 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1669:

/* Line 1455 of yacc.c  */
#line 9948 "preproc.y"
    { 
 (yyval.str) = make_str("*");
;}
    break;

  case 1670:

/* Line 1455 of yacc.c  */
#line 9956 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1671:

/* Line 1455 of yacc.c  */
#line 9960 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1672:

/* Line 1455 of yacc.c  */
#line 9968 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1673:

/* Line 1455 of yacc.c  */
#line 9972 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1674:

/* Line 1455 of yacc.c  */
#line 9980 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1675:

/* Line 1455 of yacc.c  */
#line 9984 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1676:

/* Line 1455 of yacc.c  */
#line 9992 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1677:

/* Line 1455 of yacc.c  */
#line 10000 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1678:

/* Line 1455 of yacc.c  */
#line 10008 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1679:

/* Line 1455 of yacc.c  */
#line 10016 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1680:

/* Line 1455 of yacc.c  */
#line 10024 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1681:

/* Line 1455 of yacc.c  */
#line 10032 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1682:

/* Line 1455 of yacc.c  */
#line 10040 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1683:

/* Line 1455 of yacc.c  */
#line 10044 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1684:

/* Line 1455 of yacc.c  */
#line 10052 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1685:

/* Line 1455 of yacc.c  */
#line 10056 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1686:

/* Line 1455 of yacc.c  */
#line 10060 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1687:

/* Line 1455 of yacc.c  */
#line 10064 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1688:

/* Line 1455 of yacc.c  */
#line 10068 "preproc.y"
    { 
 (yyval.str) = make_str("xconst");
;}
    break;

  case 1689:

/* Line 1455 of yacc.c  */
#line 10072 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1690:

/* Line 1455 of yacc.c  */
#line 10076 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (5)].str),make_str("("),(yyvsp[(3) - (5)].str),make_str(")"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1691:

/* Line 1455 of yacc.c  */
#line 10080 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1692:

/* Line 1455 of yacc.c  */
#line 10084 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1693:

/* Line 1455 of yacc.c  */
#line 10088 "preproc.y"
    { 
 (yyval.str) = cat_str(6,(yyvsp[(1) - (6)].str),make_str("("),(yyvsp[(3) - (6)].str),make_str(")"),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 1694:

/* Line 1455 of yacc.c  */
#line 10092 "preproc.y"
    { 
 (yyval.str) = make_str("true");
;}
    break;

  case 1695:

/* Line 1455 of yacc.c  */
#line 10096 "preproc.y"
    { 
 (yyval.str) = make_str("false");
;}
    break;

  case 1696:

/* Line 1455 of yacc.c  */
#line 10100 "preproc.y"
    { 
 (yyval.str) = make_str("null");
;}
    break;

  case 1697:

/* Line 1455 of yacc.c  */
#line 10103 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1698:

/* Line 1455 of yacc.c  */
#line 10104 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1699:

/* Line 1455 of yacc.c  */
#line 10110 "preproc.y"
    { (yyval.str) = make_name(); ;}
    break;

  case 1700:

/* Line 1455 of yacc.c  */
#line 10116 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1701:

/* Line 1455 of yacc.c  */
#line 10124 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1702:

/* Line 1455 of yacc.c  */
#line 10127 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1703:

/* Line 1455 of yacc.c  */
#line 10129 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("+"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1704:

/* Line 1455 of yacc.c  */
#line 10133 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("-"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1705:

/* Line 1455 of yacc.c  */
#line 10141 "preproc.y"
    { 
 (yyval.str) = make_str("abort");
;}
    break;

  case 1706:

/* Line 1455 of yacc.c  */
#line 10145 "preproc.y"
    { 
 (yyval.str) = make_str("absolute");
;}
    break;

  case 1707:

/* Line 1455 of yacc.c  */
#line 10149 "preproc.y"
    { 
 (yyval.str) = make_str("access");
;}
    break;

  case 1708:

/* Line 1455 of yacc.c  */
#line 10153 "preproc.y"
    { 
 (yyval.str) = make_str("action");
;}
    break;

  case 1709:

/* Line 1455 of yacc.c  */
#line 10157 "preproc.y"
    { 
 (yyval.str) = make_str("add");
;}
    break;

  case 1710:

/* Line 1455 of yacc.c  */
#line 10161 "preproc.y"
    { 
 (yyval.str) = make_str("admin");
;}
    break;

  case 1711:

/* Line 1455 of yacc.c  */
#line 10165 "preproc.y"
    { 
 (yyval.str) = make_str("after");
;}
    break;

  case 1712:

/* Line 1455 of yacc.c  */
#line 10169 "preproc.y"
    { 
 (yyval.str) = make_str("aggregate");
;}
    break;

  case 1713:

/* Line 1455 of yacc.c  */
#line 10173 "preproc.y"
    { 
 (yyval.str) = make_str("also");
;}
    break;

  case 1714:

/* Line 1455 of yacc.c  */
#line 10177 "preproc.y"
    { 
 (yyval.str) = make_str("alter");
;}
    break;

  case 1715:

/* Line 1455 of yacc.c  */
#line 10181 "preproc.y"
    { 
 (yyval.str) = make_str("always");
;}
    break;

  case 1716:

/* Line 1455 of yacc.c  */
#line 10185 "preproc.y"
    { 
 (yyval.str) = make_str("assertion");
;}
    break;

  case 1717:

/* Line 1455 of yacc.c  */
#line 10189 "preproc.y"
    { 
 (yyval.str) = make_str("assignment");
;}
    break;

  case 1718:

/* Line 1455 of yacc.c  */
#line 10193 "preproc.y"
    { 
 (yyval.str) = make_str("at");
;}
    break;

  case 1719:

/* Line 1455 of yacc.c  */
#line 10197 "preproc.y"
    { 
 (yyval.str) = make_str("backward");
;}
    break;

  case 1720:

/* Line 1455 of yacc.c  */
#line 10201 "preproc.y"
    { 
 (yyval.str) = make_str("before");
;}
    break;

  case 1721:

/* Line 1455 of yacc.c  */
#line 10205 "preproc.y"
    { 
 (yyval.str) = make_str("begin");
;}
    break;

  case 1722:

/* Line 1455 of yacc.c  */
#line 10209 "preproc.y"
    { 
 (yyval.str) = make_str("by");
;}
    break;

  case 1723:

/* Line 1455 of yacc.c  */
#line 10213 "preproc.y"
    { 
 (yyval.str) = make_str("cache");
;}
    break;

  case 1724:

/* Line 1455 of yacc.c  */
#line 10217 "preproc.y"
    { 
 (yyval.str) = make_str("called");
;}
    break;

  case 1725:

/* Line 1455 of yacc.c  */
#line 10221 "preproc.y"
    { 
 (yyval.str) = make_str("cascade");
;}
    break;

  case 1726:

/* Line 1455 of yacc.c  */
#line 10225 "preproc.y"
    { 
 (yyval.str) = make_str("cascaded");
;}
    break;

  case 1727:

/* Line 1455 of yacc.c  */
#line 10229 "preproc.y"
    { 
 (yyval.str) = make_str("catalog");
;}
    break;

  case 1728:

/* Line 1455 of yacc.c  */
#line 10233 "preproc.y"
    { 
 (yyval.str) = make_str("chain");
;}
    break;

  case 1729:

/* Line 1455 of yacc.c  */
#line 10237 "preproc.y"
    { 
 (yyval.str) = make_str("characteristics");
;}
    break;

  case 1730:

/* Line 1455 of yacc.c  */
#line 10241 "preproc.y"
    { 
 (yyval.str) = make_str("checkpoint");
;}
    break;

  case 1731:

/* Line 1455 of yacc.c  */
#line 10245 "preproc.y"
    { 
 (yyval.str) = make_str("class");
;}
    break;

  case 1732:

/* Line 1455 of yacc.c  */
#line 10249 "preproc.y"
    { 
 (yyval.str) = make_str("close");
;}
    break;

  case 1733:

/* Line 1455 of yacc.c  */
#line 10253 "preproc.y"
    { 
 (yyval.str) = make_str("cluster");
;}
    break;

  case 1734:

/* Line 1455 of yacc.c  */
#line 10257 "preproc.y"
    { 
 (yyval.str) = make_str("comment");
;}
    break;

  case 1735:

/* Line 1455 of yacc.c  */
#line 10261 "preproc.y"
    { 
 (yyval.str) = make_str("comments");
;}
    break;

  case 1736:

/* Line 1455 of yacc.c  */
#line 10265 "preproc.y"
    { 
 (yyval.str) = make_str("commit");
;}
    break;

  case 1737:

/* Line 1455 of yacc.c  */
#line 10269 "preproc.y"
    { 
 (yyval.str) = make_str("committed");
;}
    break;

  case 1738:

/* Line 1455 of yacc.c  */
#line 10273 "preproc.y"
    { 
 (yyval.str) = make_str("configuration");
;}
    break;

  case 1739:

/* Line 1455 of yacc.c  */
#line 10277 "preproc.y"
    { 
 (yyval.str) = make_str("constraints");
;}
    break;

  case 1740:

/* Line 1455 of yacc.c  */
#line 10281 "preproc.y"
    { 
 (yyval.str) = make_str("content");
;}
    break;

  case 1741:

/* Line 1455 of yacc.c  */
#line 10285 "preproc.y"
    { 
 (yyval.str) = make_str("continue");
;}
    break;

  case 1742:

/* Line 1455 of yacc.c  */
#line 10289 "preproc.y"
    { 
 (yyval.str) = make_str("conversion");
;}
    break;

  case 1743:

/* Line 1455 of yacc.c  */
#line 10293 "preproc.y"
    { 
 (yyval.str) = make_str("copy");
;}
    break;

  case 1744:

/* Line 1455 of yacc.c  */
#line 10297 "preproc.y"
    { 
 (yyval.str) = make_str("cost");
;}
    break;

  case 1745:

/* Line 1455 of yacc.c  */
#line 10301 "preproc.y"
    { 
 (yyval.str) = make_str("createdb");
;}
    break;

  case 1746:

/* Line 1455 of yacc.c  */
#line 10305 "preproc.y"
    { 
 (yyval.str) = make_str("createrole");
;}
    break;

  case 1747:

/* Line 1455 of yacc.c  */
#line 10309 "preproc.y"
    { 
 (yyval.str) = make_str("createuser");
;}
    break;

  case 1748:

/* Line 1455 of yacc.c  */
#line 10313 "preproc.y"
    { 
 (yyval.str) = make_str("csv");
;}
    break;

  case 1749:

/* Line 1455 of yacc.c  */
#line 10317 "preproc.y"
    { 
 (yyval.str) = make_str("cursor");
;}
    break;

  case 1750:

/* Line 1455 of yacc.c  */
#line 10321 "preproc.y"
    { 
 (yyval.str) = make_str("cycle");
;}
    break;

  case 1751:

/* Line 1455 of yacc.c  */
#line 10325 "preproc.y"
    { 
 (yyval.str) = make_str("data");
;}
    break;

  case 1752:

/* Line 1455 of yacc.c  */
#line 10329 "preproc.y"
    { 
 (yyval.str) = make_str("database");
;}
    break;

  case 1753:

/* Line 1455 of yacc.c  */
#line 10333 "preproc.y"
    { 
 (yyval.str) = make_str("deallocate");
;}
    break;

  case 1754:

/* Line 1455 of yacc.c  */
#line 10337 "preproc.y"
    { 
 (yyval.str) = make_str("declare");
;}
    break;

  case 1755:

/* Line 1455 of yacc.c  */
#line 10341 "preproc.y"
    { 
 (yyval.str) = make_str("defaults");
;}
    break;

  case 1756:

/* Line 1455 of yacc.c  */
#line 10345 "preproc.y"
    { 
 (yyval.str) = make_str("deferred");
;}
    break;

  case 1757:

/* Line 1455 of yacc.c  */
#line 10349 "preproc.y"
    { 
 (yyval.str) = make_str("definer");
;}
    break;

  case 1758:

/* Line 1455 of yacc.c  */
#line 10353 "preproc.y"
    { 
 (yyval.str) = make_str("delete");
;}
    break;

  case 1759:

/* Line 1455 of yacc.c  */
#line 10357 "preproc.y"
    { 
 (yyval.str) = make_str("delimiter");
;}
    break;

  case 1760:

/* Line 1455 of yacc.c  */
#line 10361 "preproc.y"
    { 
 (yyval.str) = make_str("delimiters");
;}
    break;

  case 1761:

/* Line 1455 of yacc.c  */
#line 10365 "preproc.y"
    { 
 (yyval.str) = make_str("dictionary");
;}
    break;

  case 1762:

/* Line 1455 of yacc.c  */
#line 10369 "preproc.y"
    { 
 (yyval.str) = make_str("disable");
;}
    break;

  case 1763:

/* Line 1455 of yacc.c  */
#line 10373 "preproc.y"
    { 
 (yyval.str) = make_str("discard");
;}
    break;

  case 1764:

/* Line 1455 of yacc.c  */
#line 10377 "preproc.y"
    { 
 (yyval.str) = make_str("document");
;}
    break;

  case 1765:

/* Line 1455 of yacc.c  */
#line 10381 "preproc.y"
    { 
 (yyval.str) = make_str("domain");
;}
    break;

  case 1766:

/* Line 1455 of yacc.c  */
#line 10385 "preproc.y"
    { 
 (yyval.str) = make_str("double");
;}
    break;

  case 1767:

/* Line 1455 of yacc.c  */
#line 10389 "preproc.y"
    { 
 (yyval.str) = make_str("drop");
;}
    break;

  case 1768:

/* Line 1455 of yacc.c  */
#line 10393 "preproc.y"
    { 
 (yyval.str) = make_str("each");
;}
    break;

  case 1769:

/* Line 1455 of yacc.c  */
#line 10397 "preproc.y"
    { 
 (yyval.str) = make_str("enable");
;}
    break;

  case 1770:

/* Line 1455 of yacc.c  */
#line 10401 "preproc.y"
    { 
 (yyval.str) = make_str("encoding");
;}
    break;

  case 1771:

/* Line 1455 of yacc.c  */
#line 10405 "preproc.y"
    { 
 (yyval.str) = make_str("encrypted");
;}
    break;

  case 1772:

/* Line 1455 of yacc.c  */
#line 10409 "preproc.y"
    { 
 (yyval.str) = make_str("enum");
;}
    break;

  case 1773:

/* Line 1455 of yacc.c  */
#line 10413 "preproc.y"
    { 
 (yyval.str) = make_str("escape");
;}
    break;

  case 1774:

/* Line 1455 of yacc.c  */
#line 10417 "preproc.y"
    { 
 (yyval.str) = make_str("exclude");
;}
    break;

  case 1775:

/* Line 1455 of yacc.c  */
#line 10421 "preproc.y"
    { 
 (yyval.str) = make_str("excluding");
;}
    break;

  case 1776:

/* Line 1455 of yacc.c  */
#line 10425 "preproc.y"
    { 
 (yyval.str) = make_str("exclusive");
;}
    break;

  case 1777:

/* Line 1455 of yacc.c  */
#line 10429 "preproc.y"
    { 
 (yyval.str) = make_str("execute");
;}
    break;

  case 1778:

/* Line 1455 of yacc.c  */
#line 10433 "preproc.y"
    { 
 (yyval.str) = make_str("explain");
;}
    break;

  case 1779:

/* Line 1455 of yacc.c  */
#line 10437 "preproc.y"
    { 
 (yyval.str) = make_str("external");
;}
    break;

  case 1780:

/* Line 1455 of yacc.c  */
#line 10441 "preproc.y"
    { 
 (yyval.str) = make_str("family");
;}
    break;

  case 1781:

/* Line 1455 of yacc.c  */
#line 10445 "preproc.y"
    { 
 (yyval.str) = make_str("first");
;}
    break;

  case 1782:

/* Line 1455 of yacc.c  */
#line 10449 "preproc.y"
    { 
 (yyval.str) = make_str("following");
;}
    break;

  case 1783:

/* Line 1455 of yacc.c  */
#line 10453 "preproc.y"
    { 
 (yyval.str) = make_str("force");
;}
    break;

  case 1784:

/* Line 1455 of yacc.c  */
#line 10457 "preproc.y"
    { 
 (yyval.str) = make_str("forward");
;}
    break;

  case 1785:

/* Line 1455 of yacc.c  */
#line 10461 "preproc.y"
    { 
 (yyval.str) = make_str("function");
;}
    break;

  case 1786:

/* Line 1455 of yacc.c  */
#line 10465 "preproc.y"
    { 
 (yyval.str) = make_str("functions");
;}
    break;

  case 1787:

/* Line 1455 of yacc.c  */
#line 10469 "preproc.y"
    { 
 (yyval.str) = make_str("global");
;}
    break;

  case 1788:

/* Line 1455 of yacc.c  */
#line 10473 "preproc.y"
    { 
 (yyval.str) = make_str("granted");
;}
    break;

  case 1789:

/* Line 1455 of yacc.c  */
#line 10477 "preproc.y"
    { 
 (yyval.str) = make_str("handler");
;}
    break;

  case 1790:

/* Line 1455 of yacc.c  */
#line 10481 "preproc.y"
    { 
 (yyval.str) = make_str("header");
;}
    break;

  case 1791:

/* Line 1455 of yacc.c  */
#line 10485 "preproc.y"
    { 
 (yyval.str) = make_str("hold");
;}
    break;

  case 1792:

/* Line 1455 of yacc.c  */
#line 10489 "preproc.y"
    { 
 (yyval.str) = make_str("identity");
;}
    break;

  case 1793:

/* Line 1455 of yacc.c  */
#line 10493 "preproc.y"
    { 
 (yyval.str) = make_str("if");
;}
    break;

  case 1794:

/* Line 1455 of yacc.c  */
#line 10497 "preproc.y"
    { 
 (yyval.str) = make_str("immediate");
;}
    break;

  case 1795:

/* Line 1455 of yacc.c  */
#line 10501 "preproc.y"
    { 
 (yyval.str) = make_str("immutable");
;}
    break;

  case 1796:

/* Line 1455 of yacc.c  */
#line 10505 "preproc.y"
    { 
 (yyval.str) = make_str("implicit");
;}
    break;

  case 1797:

/* Line 1455 of yacc.c  */
#line 10509 "preproc.y"
    { 
 (yyval.str) = make_str("including");
;}
    break;

  case 1798:

/* Line 1455 of yacc.c  */
#line 10513 "preproc.y"
    { 
 (yyval.str) = make_str("increment");
;}
    break;

  case 1799:

/* Line 1455 of yacc.c  */
#line 10517 "preproc.y"
    { 
 (yyval.str) = make_str("index");
;}
    break;

  case 1800:

/* Line 1455 of yacc.c  */
#line 10521 "preproc.y"
    { 
 (yyval.str) = make_str("indexes");
;}
    break;

  case 1801:

/* Line 1455 of yacc.c  */
#line 10525 "preproc.y"
    { 
 (yyval.str) = make_str("inherit");
;}
    break;

  case 1802:

/* Line 1455 of yacc.c  */
#line 10529 "preproc.y"
    { 
 (yyval.str) = make_str("inherits");
;}
    break;

  case 1803:

/* Line 1455 of yacc.c  */
#line 10533 "preproc.y"
    { 
 (yyval.str) = make_str("inline");
;}
    break;

  case 1804:

/* Line 1455 of yacc.c  */
#line 10537 "preproc.y"
    { 
 (yyval.str) = make_str("insensitive");
;}
    break;

  case 1805:

/* Line 1455 of yacc.c  */
#line 10541 "preproc.y"
    { 
 (yyval.str) = make_str("insert");
;}
    break;

  case 1806:

/* Line 1455 of yacc.c  */
#line 10545 "preproc.y"
    { 
 (yyval.str) = make_str("instead");
;}
    break;

  case 1807:

/* Line 1455 of yacc.c  */
#line 10549 "preproc.y"
    { 
 (yyval.str) = make_str("invoker");
;}
    break;

  case 1808:

/* Line 1455 of yacc.c  */
#line 10553 "preproc.y"
    { 
 (yyval.str) = make_str("isolation");
;}
    break;

  case 1809:

/* Line 1455 of yacc.c  */
#line 10557 "preproc.y"
    { 
 (yyval.str) = make_str("key");
;}
    break;

  case 1810:

/* Line 1455 of yacc.c  */
#line 10561 "preproc.y"
    { 
 (yyval.str) = make_str("language");
;}
    break;

  case 1811:

/* Line 1455 of yacc.c  */
#line 10565 "preproc.y"
    { 
 (yyval.str) = make_str("large");
;}
    break;

  case 1812:

/* Line 1455 of yacc.c  */
#line 10569 "preproc.y"
    { 
 (yyval.str) = make_str("last");
;}
    break;

  case 1813:

/* Line 1455 of yacc.c  */
#line 10573 "preproc.y"
    { 
 (yyval.str) = make_str("lc_collate");
;}
    break;

  case 1814:

/* Line 1455 of yacc.c  */
#line 10577 "preproc.y"
    { 
 (yyval.str) = make_str("lc_ctype");
;}
    break;

  case 1815:

/* Line 1455 of yacc.c  */
#line 10581 "preproc.y"
    { 
 (yyval.str) = make_str("level");
;}
    break;

  case 1816:

/* Line 1455 of yacc.c  */
#line 10585 "preproc.y"
    { 
 (yyval.str) = make_str("listen");
;}
    break;

  case 1817:

/* Line 1455 of yacc.c  */
#line 10589 "preproc.y"
    { 
 (yyval.str) = make_str("load");
;}
    break;

  case 1818:

/* Line 1455 of yacc.c  */
#line 10593 "preproc.y"
    { 
 (yyval.str) = make_str("local");
;}
    break;

  case 1819:

/* Line 1455 of yacc.c  */
#line 10597 "preproc.y"
    { 
 (yyval.str) = make_str("location");
;}
    break;

  case 1820:

/* Line 1455 of yacc.c  */
#line 10601 "preproc.y"
    { 
 (yyval.str) = make_str("lock");
;}
    break;

  case 1821:

/* Line 1455 of yacc.c  */
#line 10605 "preproc.y"
    { 
 (yyval.str) = make_str("login");
;}
    break;

  case 1822:

/* Line 1455 of yacc.c  */
#line 10609 "preproc.y"
    { 
 (yyval.str) = make_str("mapping");
;}
    break;

  case 1823:

/* Line 1455 of yacc.c  */
#line 10613 "preproc.y"
    { 
 (yyval.str) = make_str("match");
;}
    break;

  case 1824:

/* Line 1455 of yacc.c  */
#line 10617 "preproc.y"
    { 
 (yyval.str) = make_str("maxvalue");
;}
    break;

  case 1825:

/* Line 1455 of yacc.c  */
#line 10621 "preproc.y"
    { 
 (yyval.str) = make_str("minvalue");
;}
    break;

  case 1826:

/* Line 1455 of yacc.c  */
#line 10625 "preproc.y"
    { 
 (yyval.str) = make_str("mode");
;}
    break;

  case 1827:

/* Line 1455 of yacc.c  */
#line 10629 "preproc.y"
    { 
 (yyval.str) = make_str("move");
;}
    break;

  case 1828:

/* Line 1455 of yacc.c  */
#line 10633 "preproc.y"
    { 
 (yyval.str) = make_str("name");
;}
    break;

  case 1829:

/* Line 1455 of yacc.c  */
#line 10637 "preproc.y"
    { 
 (yyval.str) = make_str("names");
;}
    break;

  case 1830:

/* Line 1455 of yacc.c  */
#line 10641 "preproc.y"
    { 
 (yyval.str) = make_str("next");
;}
    break;

  case 1831:

/* Line 1455 of yacc.c  */
#line 10645 "preproc.y"
    { 
 (yyval.str) = make_str("no");
;}
    break;

  case 1832:

/* Line 1455 of yacc.c  */
#line 10649 "preproc.y"
    { 
 (yyval.str) = make_str("nocreatedb");
;}
    break;

  case 1833:

/* Line 1455 of yacc.c  */
#line 10653 "preproc.y"
    { 
 (yyval.str) = make_str("nocreaterole");
;}
    break;

  case 1834:

/* Line 1455 of yacc.c  */
#line 10657 "preproc.y"
    { 
 (yyval.str) = make_str("nocreateuser");
;}
    break;

  case 1835:

/* Line 1455 of yacc.c  */
#line 10661 "preproc.y"
    { 
 (yyval.str) = make_str("noinherit");
;}
    break;

  case 1836:

/* Line 1455 of yacc.c  */
#line 10665 "preproc.y"
    { 
 (yyval.str) = make_str("nologin");
;}
    break;

  case 1837:

/* Line 1455 of yacc.c  */
#line 10669 "preproc.y"
    { 
 (yyval.str) = make_str("nosuperuser");
;}
    break;

  case 1838:

/* Line 1455 of yacc.c  */
#line 10673 "preproc.y"
    { 
 (yyval.str) = make_str("nothing");
;}
    break;

  case 1839:

/* Line 1455 of yacc.c  */
#line 10677 "preproc.y"
    { 
 (yyval.str) = make_str("notify");
;}
    break;

  case 1840:

/* Line 1455 of yacc.c  */
#line 10681 "preproc.y"
    { 
 (yyval.str) = make_str("nowait");
;}
    break;

  case 1841:

/* Line 1455 of yacc.c  */
#line 10685 "preproc.y"
    { 
 (yyval.str) = make_str("nulls");
;}
    break;

  case 1842:

/* Line 1455 of yacc.c  */
#line 10689 "preproc.y"
    { 
 (yyval.str) = make_str("object");
;}
    break;

  case 1843:

/* Line 1455 of yacc.c  */
#line 10693 "preproc.y"
    { 
 (yyval.str) = make_str("of");
;}
    break;

  case 1844:

/* Line 1455 of yacc.c  */
#line 10697 "preproc.y"
    { 
 (yyval.str) = make_str("off");
;}
    break;

  case 1845:

/* Line 1455 of yacc.c  */
#line 10701 "preproc.y"
    { 
 (yyval.str) = make_str("oids");
;}
    break;

  case 1846:

/* Line 1455 of yacc.c  */
#line 10705 "preproc.y"
    { 
 (yyval.str) = make_str("operator");
;}
    break;

  case 1847:

/* Line 1455 of yacc.c  */
#line 10709 "preproc.y"
    { 
 (yyval.str) = make_str("option");
;}
    break;

  case 1848:

/* Line 1455 of yacc.c  */
#line 10713 "preproc.y"
    { 
 (yyval.str) = make_str("options");
;}
    break;

  case 1849:

/* Line 1455 of yacc.c  */
#line 10717 "preproc.y"
    { 
 (yyval.str) = make_str("owned");
;}
    break;

  case 1850:

/* Line 1455 of yacc.c  */
#line 10721 "preproc.y"
    { 
 (yyval.str) = make_str("owner");
;}
    break;

  case 1851:

/* Line 1455 of yacc.c  */
#line 10725 "preproc.y"
    { 
 (yyval.str) = make_str("parser");
;}
    break;

  case 1852:

/* Line 1455 of yacc.c  */
#line 10729 "preproc.y"
    { 
 (yyval.str) = make_str("partial");
;}
    break;

  case 1853:

/* Line 1455 of yacc.c  */
#line 10733 "preproc.y"
    { 
 (yyval.str) = make_str("partition");
;}
    break;

  case 1854:

/* Line 1455 of yacc.c  */
#line 10737 "preproc.y"
    { 
 (yyval.str) = make_str("password");
;}
    break;

  case 1855:

/* Line 1455 of yacc.c  */
#line 10741 "preproc.y"
    { 
 (yyval.str) = make_str("plans");
;}
    break;

  case 1856:

/* Line 1455 of yacc.c  */
#line 10745 "preproc.y"
    { 
 (yyval.str) = make_str("preceding");
;}
    break;

  case 1857:

/* Line 1455 of yacc.c  */
#line 10749 "preproc.y"
    { 
 (yyval.str) = make_str("prepare");
;}
    break;

  case 1858:

/* Line 1455 of yacc.c  */
#line 10753 "preproc.y"
    { 
 (yyval.str) = make_str("prepared");
;}
    break;

  case 1859:

/* Line 1455 of yacc.c  */
#line 10757 "preproc.y"
    { 
 (yyval.str) = make_str("preserve");
;}
    break;

  case 1860:

/* Line 1455 of yacc.c  */
#line 10761 "preproc.y"
    { 
 (yyval.str) = make_str("prior");
;}
    break;

  case 1861:

/* Line 1455 of yacc.c  */
#line 10765 "preproc.y"
    { 
 (yyval.str) = make_str("privileges");
;}
    break;

  case 1862:

/* Line 1455 of yacc.c  */
#line 10769 "preproc.y"
    { 
 (yyval.str) = make_str("procedural");
;}
    break;

  case 1863:

/* Line 1455 of yacc.c  */
#line 10773 "preproc.y"
    { 
 (yyval.str) = make_str("procedure");
;}
    break;

  case 1864:

/* Line 1455 of yacc.c  */
#line 10777 "preproc.y"
    { 
 (yyval.str) = make_str("quote");
;}
    break;

  case 1865:

/* Line 1455 of yacc.c  */
#line 10781 "preproc.y"
    { 
 (yyval.str) = make_str("range");
;}
    break;

  case 1866:

/* Line 1455 of yacc.c  */
#line 10785 "preproc.y"
    { 
 (yyval.str) = make_str("read");
;}
    break;

  case 1867:

/* Line 1455 of yacc.c  */
#line 10789 "preproc.y"
    { 
 (yyval.str) = make_str("reassign");
;}
    break;

  case 1868:

/* Line 1455 of yacc.c  */
#line 10793 "preproc.y"
    { 
 (yyval.str) = make_str("recheck");
;}
    break;

  case 1869:

/* Line 1455 of yacc.c  */
#line 10797 "preproc.y"
    { 
 (yyval.str) = make_str("recursive");
;}
    break;

  case 1870:

/* Line 1455 of yacc.c  */
#line 10801 "preproc.y"
    { 
 (yyval.str) = make_str("reindex");
;}
    break;

  case 1871:

/* Line 1455 of yacc.c  */
#line 10805 "preproc.y"
    { 
 (yyval.str) = make_str("relative");
;}
    break;

  case 1872:

/* Line 1455 of yacc.c  */
#line 10809 "preproc.y"
    { 
 (yyval.str) = make_str("release");
;}
    break;

  case 1873:

/* Line 1455 of yacc.c  */
#line 10813 "preproc.y"
    { 
 (yyval.str) = make_str("rename");
;}
    break;

  case 1874:

/* Line 1455 of yacc.c  */
#line 10817 "preproc.y"
    { 
 (yyval.str) = make_str("repeatable");
;}
    break;

  case 1875:

/* Line 1455 of yacc.c  */
#line 10821 "preproc.y"
    { 
 (yyval.str) = make_str("replace");
;}
    break;

  case 1876:

/* Line 1455 of yacc.c  */
#line 10825 "preproc.y"
    { 
 (yyval.str) = make_str("replica");
;}
    break;

  case 1877:

/* Line 1455 of yacc.c  */
#line 10829 "preproc.y"
    { 
 (yyval.str) = make_str("reset");
;}
    break;

  case 1878:

/* Line 1455 of yacc.c  */
#line 10833 "preproc.y"
    { 
 (yyval.str) = make_str("restart");
;}
    break;

  case 1879:

/* Line 1455 of yacc.c  */
#line 10837 "preproc.y"
    { 
 (yyval.str) = make_str("restrict");
;}
    break;

  case 1880:

/* Line 1455 of yacc.c  */
#line 10841 "preproc.y"
    { 
 (yyval.str) = make_str("returns");
;}
    break;

  case 1881:

/* Line 1455 of yacc.c  */
#line 10845 "preproc.y"
    { 
 (yyval.str) = make_str("revoke");
;}
    break;

  case 1882:

/* Line 1455 of yacc.c  */
#line 10849 "preproc.y"
    { 
 (yyval.str) = make_str("role");
;}
    break;

  case 1883:

/* Line 1455 of yacc.c  */
#line 10853 "preproc.y"
    { 
 (yyval.str) = make_str("rollback");
;}
    break;

  case 1884:

/* Line 1455 of yacc.c  */
#line 10857 "preproc.y"
    { 
 (yyval.str) = make_str("rows");
;}
    break;

  case 1885:

/* Line 1455 of yacc.c  */
#line 10861 "preproc.y"
    { 
 (yyval.str) = make_str("rule");
;}
    break;

  case 1886:

/* Line 1455 of yacc.c  */
#line 10865 "preproc.y"
    { 
 (yyval.str) = make_str("savepoint");
;}
    break;

  case 1887:

/* Line 1455 of yacc.c  */
#line 10869 "preproc.y"
    { 
 (yyval.str) = make_str("schema");
;}
    break;

  case 1888:

/* Line 1455 of yacc.c  */
#line 10873 "preproc.y"
    { 
 (yyval.str) = make_str("scroll");
;}
    break;

  case 1889:

/* Line 1455 of yacc.c  */
#line 10877 "preproc.y"
    { 
 (yyval.str) = make_str("search");
;}
    break;

  case 1890:

/* Line 1455 of yacc.c  */
#line 10881 "preproc.y"
    { 
 (yyval.str) = make_str("security");
;}
    break;

  case 1891:

/* Line 1455 of yacc.c  */
#line 10885 "preproc.y"
    { 
 (yyval.str) = make_str("sequence");
;}
    break;

  case 1892:

/* Line 1455 of yacc.c  */
#line 10889 "preproc.y"
    { 
 (yyval.str) = make_str("sequences");
;}
    break;

  case 1893:

/* Line 1455 of yacc.c  */
#line 10893 "preproc.y"
    { 
 (yyval.str) = make_str("serializable");
;}
    break;

  case 1894:

/* Line 1455 of yacc.c  */
#line 10897 "preproc.y"
    { 
 (yyval.str) = make_str("server");
;}
    break;

  case 1895:

/* Line 1455 of yacc.c  */
#line 10901 "preproc.y"
    { 
 (yyval.str) = make_str("session");
;}
    break;

  case 1896:

/* Line 1455 of yacc.c  */
#line 10905 "preproc.y"
    { 
 (yyval.str) = make_str("set");
;}
    break;

  case 1897:

/* Line 1455 of yacc.c  */
#line 10909 "preproc.y"
    { 
 (yyval.str) = make_str("share");
;}
    break;

  case 1898:

/* Line 1455 of yacc.c  */
#line 10913 "preproc.y"
    { 
 (yyval.str) = make_str("show");
;}
    break;

  case 1899:

/* Line 1455 of yacc.c  */
#line 10917 "preproc.y"
    { 
 (yyval.str) = make_str("simple");
;}
    break;

  case 1900:

/* Line 1455 of yacc.c  */
#line 10921 "preproc.y"
    { 
 (yyval.str) = make_str("stable");
;}
    break;

  case 1901:

/* Line 1455 of yacc.c  */
#line 10925 "preproc.y"
    { 
 (yyval.str) = make_str("standalone");
;}
    break;

  case 1902:

/* Line 1455 of yacc.c  */
#line 10929 "preproc.y"
    { 
 (yyval.str) = make_str("start");
;}
    break;

  case 1903:

/* Line 1455 of yacc.c  */
#line 10933 "preproc.y"
    { 
 (yyval.str) = make_str("statement");
;}
    break;

  case 1904:

/* Line 1455 of yacc.c  */
#line 10937 "preproc.y"
    { 
 (yyval.str) = make_str("statistics");
;}
    break;

  case 1905:

/* Line 1455 of yacc.c  */
#line 10941 "preproc.y"
    { 
 (yyval.str) = make_str("stdin");
;}
    break;

  case 1906:

/* Line 1455 of yacc.c  */
#line 10945 "preproc.y"
    { 
 (yyval.str) = make_str("stdout");
;}
    break;

  case 1907:

/* Line 1455 of yacc.c  */
#line 10949 "preproc.y"
    { 
 (yyval.str) = make_str("storage");
;}
    break;

  case 1908:

/* Line 1455 of yacc.c  */
#line 10953 "preproc.y"
    { 
 (yyval.str) = make_str("strict");
;}
    break;

  case 1909:

/* Line 1455 of yacc.c  */
#line 10957 "preproc.y"
    { 
 (yyval.str) = make_str("strip");
;}
    break;

  case 1910:

/* Line 1455 of yacc.c  */
#line 10961 "preproc.y"
    { 
 (yyval.str) = make_str("superuser");
;}
    break;

  case 1911:

/* Line 1455 of yacc.c  */
#line 10965 "preproc.y"
    { 
 (yyval.str) = make_str("sysid");
;}
    break;

  case 1912:

/* Line 1455 of yacc.c  */
#line 10969 "preproc.y"
    { 
 (yyval.str) = make_str("system");
;}
    break;

  case 1913:

/* Line 1455 of yacc.c  */
#line 10973 "preproc.y"
    { 
 (yyval.str) = make_str("tables");
;}
    break;

  case 1914:

/* Line 1455 of yacc.c  */
#line 10977 "preproc.y"
    { 
 (yyval.str) = make_str("tablespace");
;}
    break;

  case 1915:

/* Line 1455 of yacc.c  */
#line 10981 "preproc.y"
    { 
 (yyval.str) = make_str("temp");
;}
    break;

  case 1916:

/* Line 1455 of yacc.c  */
#line 10985 "preproc.y"
    { 
 (yyval.str) = make_str("template");
;}
    break;

  case 1917:

/* Line 1455 of yacc.c  */
#line 10989 "preproc.y"
    { 
 (yyval.str) = make_str("temporary");
;}
    break;

  case 1918:

/* Line 1455 of yacc.c  */
#line 10993 "preproc.y"
    { 
 (yyval.str) = make_str("text");
;}
    break;

  case 1919:

/* Line 1455 of yacc.c  */
#line 10997 "preproc.y"
    { 
 (yyval.str) = make_str("transaction");
;}
    break;

  case 1920:

/* Line 1455 of yacc.c  */
#line 11001 "preproc.y"
    { 
 (yyval.str) = make_str("trigger");
;}
    break;

  case 1921:

/* Line 1455 of yacc.c  */
#line 11005 "preproc.y"
    { 
 (yyval.str) = make_str("truncate");
;}
    break;

  case 1922:

/* Line 1455 of yacc.c  */
#line 11009 "preproc.y"
    { 
 (yyval.str) = make_str("trusted");
;}
    break;

  case 1923:

/* Line 1455 of yacc.c  */
#line 11013 "preproc.y"
    { 
 (yyval.str) = make_str("type");
;}
    break;

  case 1924:

/* Line 1455 of yacc.c  */
#line 11017 "preproc.y"
    { 
 (yyval.str) = make_str("unbounded");
;}
    break;

  case 1925:

/* Line 1455 of yacc.c  */
#line 11021 "preproc.y"
    { 
 (yyval.str) = make_str("uncommitted");
;}
    break;

  case 1926:

/* Line 1455 of yacc.c  */
#line 11025 "preproc.y"
    { 
 (yyval.str) = make_str("unencrypted");
;}
    break;

  case 1927:

/* Line 1455 of yacc.c  */
#line 11029 "preproc.y"
    { 
 (yyval.str) = make_str("unknown");
;}
    break;

  case 1928:

/* Line 1455 of yacc.c  */
#line 11033 "preproc.y"
    { 
 (yyval.str) = make_str("unlisten");
;}
    break;

  case 1929:

/* Line 1455 of yacc.c  */
#line 11037 "preproc.y"
    { 
 (yyval.str) = make_str("until");
;}
    break;

  case 1930:

/* Line 1455 of yacc.c  */
#line 11041 "preproc.y"
    { 
 (yyval.str) = make_str("update");
;}
    break;

  case 1931:

/* Line 1455 of yacc.c  */
#line 11045 "preproc.y"
    { 
 (yyval.str) = make_str("vacuum");
;}
    break;

  case 1932:

/* Line 1455 of yacc.c  */
#line 11049 "preproc.y"
    { 
 (yyval.str) = make_str("valid");
;}
    break;

  case 1933:

/* Line 1455 of yacc.c  */
#line 11053 "preproc.y"
    { 
 (yyval.str) = make_str("validator");
;}
    break;

  case 1934:

/* Line 1455 of yacc.c  */
#line 11057 "preproc.y"
    { 
 (yyval.str) = make_str("value");
;}
    break;

  case 1935:

/* Line 1455 of yacc.c  */
#line 11061 "preproc.y"
    { 
 (yyval.str) = make_str("varying");
;}
    break;

  case 1936:

/* Line 1455 of yacc.c  */
#line 11065 "preproc.y"
    { 
 (yyval.str) = make_str("version");
;}
    break;

  case 1937:

/* Line 1455 of yacc.c  */
#line 11069 "preproc.y"
    { 
 (yyval.str) = make_str("view");
;}
    break;

  case 1938:

/* Line 1455 of yacc.c  */
#line 11073 "preproc.y"
    { 
 (yyval.str) = make_str("volatile");
;}
    break;

  case 1939:

/* Line 1455 of yacc.c  */
#line 11077 "preproc.y"
    { 
 (yyval.str) = make_str("whitespace");
;}
    break;

  case 1940:

/* Line 1455 of yacc.c  */
#line 11081 "preproc.y"
    { 
 (yyval.str) = make_str("without");
;}
    break;

  case 1941:

/* Line 1455 of yacc.c  */
#line 11085 "preproc.y"
    { 
 (yyval.str) = make_str("work");
;}
    break;

  case 1942:

/* Line 1455 of yacc.c  */
#line 11089 "preproc.y"
    { 
 (yyval.str) = make_str("wrapper");
;}
    break;

  case 1943:

/* Line 1455 of yacc.c  */
#line 11093 "preproc.y"
    { 
 (yyval.str) = make_str("write");
;}
    break;

  case 1944:

/* Line 1455 of yacc.c  */
#line 11097 "preproc.y"
    { 
 (yyval.str) = make_str("xml");
;}
    break;

  case 1945:

/* Line 1455 of yacc.c  */
#line 11101 "preproc.y"
    { 
 (yyval.str) = make_str("yes");
;}
    break;

  case 1946:

/* Line 1455 of yacc.c  */
#line 11105 "preproc.y"
    { 
 (yyval.str) = make_str("zone");
;}
    break;

  case 1947:

/* Line 1455 of yacc.c  */
#line 11113 "preproc.y"
    { 
 (yyval.str) = make_str("between");
;}
    break;

  case 1948:

/* Line 1455 of yacc.c  */
#line 11117 "preproc.y"
    { 
 (yyval.str) = make_str("bigint");
;}
    break;

  case 1949:

/* Line 1455 of yacc.c  */
#line 11121 "preproc.y"
    { 
 (yyval.str) = make_str("bit");
;}
    break;

  case 1950:

/* Line 1455 of yacc.c  */
#line 11125 "preproc.y"
    { 
 (yyval.str) = make_str("boolean");
;}
    break;

  case 1951:

/* Line 1455 of yacc.c  */
#line 11129 "preproc.y"
    { 
 (yyval.str) = make_str("character");
;}
    break;

  case 1952:

/* Line 1455 of yacc.c  */
#line 11133 "preproc.y"
    { 
 (yyval.str) = make_str("coalesce");
;}
    break;

  case 1953:

/* Line 1455 of yacc.c  */
#line 11137 "preproc.y"
    { 
 (yyval.str) = make_str("dec");
;}
    break;

  case 1954:

/* Line 1455 of yacc.c  */
#line 11141 "preproc.y"
    { 
 (yyval.str) = make_str("decimal");
;}
    break;

  case 1955:

/* Line 1455 of yacc.c  */
#line 11145 "preproc.y"
    { 
 (yyval.str) = make_str("exists");
;}
    break;

  case 1956:

/* Line 1455 of yacc.c  */
#line 11149 "preproc.y"
    { 
 (yyval.str) = make_str("extract");
;}
    break;

  case 1957:

/* Line 1455 of yacc.c  */
#line 11153 "preproc.y"
    { 
 (yyval.str) = make_str("float");
;}
    break;

  case 1958:

/* Line 1455 of yacc.c  */
#line 11157 "preproc.y"
    { 
 (yyval.str) = make_str("greatest");
;}
    break;

  case 1959:

/* Line 1455 of yacc.c  */
#line 11161 "preproc.y"
    { 
 (yyval.str) = make_str("inout");
;}
    break;

  case 1960:

/* Line 1455 of yacc.c  */
#line 11165 "preproc.y"
    { 
 (yyval.str) = make_str("integer");
;}
    break;

  case 1961:

/* Line 1455 of yacc.c  */
#line 11169 "preproc.y"
    { 
 (yyval.str) = make_str("interval");
;}
    break;

  case 1962:

/* Line 1455 of yacc.c  */
#line 11173 "preproc.y"
    { 
 (yyval.str) = make_str("least");
;}
    break;

  case 1963:

/* Line 1455 of yacc.c  */
#line 11177 "preproc.y"
    { 
 (yyval.str) = make_str("national");
;}
    break;

  case 1964:

/* Line 1455 of yacc.c  */
#line 11181 "preproc.y"
    { 
 (yyval.str) = make_str("nchar");
;}
    break;

  case 1965:

/* Line 1455 of yacc.c  */
#line 11185 "preproc.y"
    { 
 (yyval.str) = make_str("none");
;}
    break;

  case 1966:

/* Line 1455 of yacc.c  */
#line 11189 "preproc.y"
    { 
 (yyval.str) = make_str("nullif");
;}
    break;

  case 1967:

/* Line 1455 of yacc.c  */
#line 11193 "preproc.y"
    { 
 (yyval.str) = make_str("numeric");
;}
    break;

  case 1968:

/* Line 1455 of yacc.c  */
#line 11197 "preproc.y"
    { 
 (yyval.str) = make_str("out");
;}
    break;

  case 1969:

/* Line 1455 of yacc.c  */
#line 11201 "preproc.y"
    { 
 (yyval.str) = make_str("overlay");
;}
    break;

  case 1970:

/* Line 1455 of yacc.c  */
#line 11205 "preproc.y"
    { 
 (yyval.str) = make_str("position");
;}
    break;

  case 1971:

/* Line 1455 of yacc.c  */
#line 11209 "preproc.y"
    { 
 (yyval.str) = make_str("precision");
;}
    break;

  case 1972:

/* Line 1455 of yacc.c  */
#line 11213 "preproc.y"
    { 
 (yyval.str) = make_str("real");
;}
    break;

  case 1973:

/* Line 1455 of yacc.c  */
#line 11217 "preproc.y"
    { 
 (yyval.str) = make_str("row");
;}
    break;

  case 1974:

/* Line 1455 of yacc.c  */
#line 11221 "preproc.y"
    { 
 (yyval.str) = make_str("setof");
;}
    break;

  case 1975:

/* Line 1455 of yacc.c  */
#line 11225 "preproc.y"
    { 
 (yyval.str) = make_str("smallint");
;}
    break;

  case 1976:

/* Line 1455 of yacc.c  */
#line 11229 "preproc.y"
    { 
 (yyval.str) = make_str("substring");
;}
    break;

  case 1977:

/* Line 1455 of yacc.c  */
#line 11233 "preproc.y"
    { 
 (yyval.str) = make_str("time");
;}
    break;

  case 1978:

/* Line 1455 of yacc.c  */
#line 11237 "preproc.y"
    { 
 (yyval.str) = make_str("timestamp");
;}
    break;

  case 1979:

/* Line 1455 of yacc.c  */
#line 11241 "preproc.y"
    { 
 (yyval.str) = make_str("treat");
;}
    break;

  case 1980:

/* Line 1455 of yacc.c  */
#line 11245 "preproc.y"
    { 
 (yyval.str) = make_str("trim");
;}
    break;

  case 1981:

/* Line 1455 of yacc.c  */
#line 11249 "preproc.y"
    { 
 (yyval.str) = make_str("varchar");
;}
    break;

  case 1982:

/* Line 1455 of yacc.c  */
#line 11253 "preproc.y"
    { 
 (yyval.str) = make_str("xmlattributes");
;}
    break;

  case 1983:

/* Line 1455 of yacc.c  */
#line 11257 "preproc.y"
    { 
 (yyval.str) = make_str("xmlconcat");
;}
    break;

  case 1984:

/* Line 1455 of yacc.c  */
#line 11261 "preproc.y"
    { 
 (yyval.str) = make_str("xmlelement");
;}
    break;

  case 1985:

/* Line 1455 of yacc.c  */
#line 11265 "preproc.y"
    { 
 (yyval.str) = make_str("xmlforest");
;}
    break;

  case 1986:

/* Line 1455 of yacc.c  */
#line 11269 "preproc.y"
    { 
 (yyval.str) = make_str("xmlparse");
;}
    break;

  case 1987:

/* Line 1455 of yacc.c  */
#line 11273 "preproc.y"
    { 
 (yyval.str) = make_str("xmlpi");
;}
    break;

  case 1988:

/* Line 1455 of yacc.c  */
#line 11277 "preproc.y"
    { 
 (yyval.str) = make_str("xmlroot");
;}
    break;

  case 1989:

/* Line 1455 of yacc.c  */
#line 11281 "preproc.y"
    { 
 (yyval.str) = make_str("xmlserialize");
;}
    break;

  case 1990:

/* Line 1455 of yacc.c  */
#line 11289 "preproc.y"
    { 
 (yyval.str) = make_str("authorization");
;}
    break;

  case 1991:

/* Line 1455 of yacc.c  */
#line 11293 "preproc.y"
    { 
 (yyval.str) = make_str("binary");
;}
    break;

  case 1992:

/* Line 1455 of yacc.c  */
#line 11297 "preproc.y"
    { 
 (yyval.str) = make_str("concurrently");
;}
    break;

  case 1993:

/* Line 1455 of yacc.c  */
#line 11301 "preproc.y"
    { 
 (yyval.str) = make_str("cross");
;}
    break;

  case 1994:

/* Line 1455 of yacc.c  */
#line 11305 "preproc.y"
    { 
 (yyval.str) = make_str("current_schema");
;}
    break;

  case 1995:

/* Line 1455 of yacc.c  */
#line 11309 "preproc.y"
    { 
 (yyval.str) = make_str("freeze");
;}
    break;

  case 1996:

/* Line 1455 of yacc.c  */
#line 11313 "preproc.y"
    { 
 (yyval.str) = make_str("full");
;}
    break;

  case 1997:

/* Line 1455 of yacc.c  */
#line 11317 "preproc.y"
    { 
 (yyval.str) = make_str("ilike");
;}
    break;

  case 1998:

/* Line 1455 of yacc.c  */
#line 11321 "preproc.y"
    { 
 (yyval.str) = make_str("inner");
;}
    break;

  case 1999:

/* Line 1455 of yacc.c  */
#line 11325 "preproc.y"
    { 
 (yyval.str) = make_str("is");
;}
    break;

  case 2000:

/* Line 1455 of yacc.c  */
#line 11329 "preproc.y"
    { 
 (yyval.str) = make_str("isnull");
;}
    break;

  case 2001:

/* Line 1455 of yacc.c  */
#line 11333 "preproc.y"
    { 
 (yyval.str) = make_str("join");
;}
    break;

  case 2002:

/* Line 1455 of yacc.c  */
#line 11337 "preproc.y"
    { 
 (yyval.str) = make_str("left");
;}
    break;

  case 2003:

/* Line 1455 of yacc.c  */
#line 11341 "preproc.y"
    { 
 (yyval.str) = make_str("like");
;}
    break;

  case 2004:

/* Line 1455 of yacc.c  */
#line 11345 "preproc.y"
    { 
 (yyval.str) = make_str("natural");
;}
    break;

  case 2005:

/* Line 1455 of yacc.c  */
#line 11349 "preproc.y"
    { 
 (yyval.str) = make_str("notnull");
;}
    break;

  case 2006:

/* Line 1455 of yacc.c  */
#line 11353 "preproc.y"
    { 
 (yyval.str) = make_str("outer");
;}
    break;

  case 2007:

/* Line 1455 of yacc.c  */
#line 11357 "preproc.y"
    { 
 (yyval.str) = make_str("over");
;}
    break;

  case 2008:

/* Line 1455 of yacc.c  */
#line 11361 "preproc.y"
    { 
 (yyval.str) = make_str("overlaps");
;}
    break;

  case 2009:

/* Line 1455 of yacc.c  */
#line 11365 "preproc.y"
    { 
 (yyval.str) = make_str("right");
;}
    break;

  case 2010:

/* Line 1455 of yacc.c  */
#line 11369 "preproc.y"
    { 
 (yyval.str) = make_str("similar");
;}
    break;

  case 2011:

/* Line 1455 of yacc.c  */
#line 11373 "preproc.y"
    { 
 (yyval.str) = make_str("verbose");
;}
    break;

  case 2012:

/* Line 1455 of yacc.c  */
#line 11381 "preproc.y"
    { 
 (yyval.str) = make_str("all");
;}
    break;

  case 2013:

/* Line 1455 of yacc.c  */
#line 11385 "preproc.y"
    { 
 (yyval.str) = make_str("analyse");
;}
    break;

  case 2014:

/* Line 1455 of yacc.c  */
#line 11389 "preproc.y"
    { 
 (yyval.str) = make_str("analyze");
;}
    break;

  case 2015:

/* Line 1455 of yacc.c  */
#line 11393 "preproc.y"
    { 
 (yyval.str) = make_str("and");
;}
    break;

  case 2016:

/* Line 1455 of yacc.c  */
#line 11397 "preproc.y"
    { 
 (yyval.str) = make_str("any");
;}
    break;

  case 2017:

/* Line 1455 of yacc.c  */
#line 11401 "preproc.y"
    { 
 (yyval.str) = make_str("array");
;}
    break;

  case 2018:

/* Line 1455 of yacc.c  */
#line 11405 "preproc.y"
    { 
 (yyval.str) = make_str("as");
;}
    break;

  case 2019:

/* Line 1455 of yacc.c  */
#line 11409 "preproc.y"
    { 
 (yyval.str) = make_str("asc");
;}
    break;

  case 2020:

/* Line 1455 of yacc.c  */
#line 11413 "preproc.y"
    { 
 (yyval.str) = make_str("asymmetric");
;}
    break;

  case 2021:

/* Line 1455 of yacc.c  */
#line 11417 "preproc.y"
    { 
 (yyval.str) = make_str("both");
;}
    break;

  case 2022:

/* Line 1455 of yacc.c  */
#line 11421 "preproc.y"
    { 
 (yyval.str) = make_str("case");
;}
    break;

  case 2023:

/* Line 1455 of yacc.c  */
#line 11425 "preproc.y"
    { 
 (yyval.str) = make_str("cast");
;}
    break;

  case 2024:

/* Line 1455 of yacc.c  */
#line 11429 "preproc.y"
    { 
 (yyval.str) = make_str("check");
;}
    break;

  case 2025:

/* Line 1455 of yacc.c  */
#line 11433 "preproc.y"
    { 
 (yyval.str) = make_str("collate");
;}
    break;

  case 2026:

/* Line 1455 of yacc.c  */
#line 11437 "preproc.y"
    { 
 (yyval.str) = make_str("column");
;}
    break;

  case 2027:

/* Line 1455 of yacc.c  */
#line 11441 "preproc.y"
    { 
 (yyval.str) = make_str("constraint");
;}
    break;

  case 2028:

/* Line 1455 of yacc.c  */
#line 11445 "preproc.y"
    { 
 (yyval.str) = make_str("create");
;}
    break;

  case 2029:

/* Line 1455 of yacc.c  */
#line 11449 "preproc.y"
    { 
 (yyval.str) = make_str("current_catalog");
;}
    break;

  case 2030:

/* Line 1455 of yacc.c  */
#line 11453 "preproc.y"
    { 
 (yyval.str) = make_str("current_date");
;}
    break;

  case 2031:

/* Line 1455 of yacc.c  */
#line 11457 "preproc.y"
    { 
 (yyval.str) = make_str("current_role");
;}
    break;

  case 2032:

/* Line 1455 of yacc.c  */
#line 11461 "preproc.y"
    { 
 (yyval.str) = make_str("current_time");
;}
    break;

  case 2033:

/* Line 1455 of yacc.c  */
#line 11465 "preproc.y"
    { 
 (yyval.str) = make_str("current_timestamp");
;}
    break;

  case 2034:

/* Line 1455 of yacc.c  */
#line 11469 "preproc.y"
    { 
 (yyval.str) = make_str("current_user");
;}
    break;

  case 2035:

/* Line 1455 of yacc.c  */
#line 11473 "preproc.y"
    { 
 (yyval.str) = make_str("default");
;}
    break;

  case 2036:

/* Line 1455 of yacc.c  */
#line 11477 "preproc.y"
    { 
 (yyval.str) = make_str("deferrable");
;}
    break;

  case 2037:

/* Line 1455 of yacc.c  */
#line 11481 "preproc.y"
    { 
 (yyval.str) = make_str("desc");
;}
    break;

  case 2038:

/* Line 1455 of yacc.c  */
#line 11485 "preproc.y"
    { 
 (yyval.str) = make_str("distinct");
;}
    break;

  case 2039:

/* Line 1455 of yacc.c  */
#line 11489 "preproc.y"
    { 
 (yyval.str) = make_str("do");
;}
    break;

  case 2040:

/* Line 1455 of yacc.c  */
#line 11493 "preproc.y"
    { 
 (yyval.str) = make_str("else");
;}
    break;

  case 2041:

/* Line 1455 of yacc.c  */
#line 11497 "preproc.y"
    { 
 (yyval.str) = make_str("end");
;}
    break;

  case 2042:

/* Line 1455 of yacc.c  */
#line 11501 "preproc.y"
    { 
 (yyval.str) = make_str("except");
;}
    break;

  case 2043:

/* Line 1455 of yacc.c  */
#line 11505 "preproc.y"
    { 
 (yyval.str) = make_str("false");
;}
    break;

  case 2044:

/* Line 1455 of yacc.c  */
#line 11509 "preproc.y"
    { 
 (yyval.str) = make_str("fetch");
;}
    break;

  case 2045:

/* Line 1455 of yacc.c  */
#line 11513 "preproc.y"
    { 
 (yyval.str) = make_str("for");
;}
    break;

  case 2046:

/* Line 1455 of yacc.c  */
#line 11517 "preproc.y"
    { 
 (yyval.str) = make_str("foreign");
;}
    break;

  case 2047:

/* Line 1455 of yacc.c  */
#line 11521 "preproc.y"
    { 
 (yyval.str) = make_str("from");
;}
    break;

  case 2048:

/* Line 1455 of yacc.c  */
#line 11525 "preproc.y"
    { 
 (yyval.str) = make_str("grant");
;}
    break;

  case 2049:

/* Line 1455 of yacc.c  */
#line 11529 "preproc.y"
    { 
 (yyval.str) = make_str("group");
;}
    break;

  case 2050:

/* Line 1455 of yacc.c  */
#line 11533 "preproc.y"
    { 
 (yyval.str) = make_str("having");
;}
    break;

  case 2051:

/* Line 1455 of yacc.c  */
#line 11537 "preproc.y"
    { 
 (yyval.str) = make_str("in");
;}
    break;

  case 2052:

/* Line 1455 of yacc.c  */
#line 11541 "preproc.y"
    { 
 (yyval.str) = make_str("initially");
;}
    break;

  case 2053:

/* Line 1455 of yacc.c  */
#line 11545 "preproc.y"
    { 
 (yyval.str) = make_str("intersect");
;}
    break;

  case 2054:

/* Line 1455 of yacc.c  */
#line 11549 "preproc.y"
    { 
 (yyval.str) = make_str("into");
;}
    break;

  case 2055:

/* Line 1455 of yacc.c  */
#line 11553 "preproc.y"
    { 
 (yyval.str) = make_str("leading");
;}
    break;

  case 2056:

/* Line 1455 of yacc.c  */
#line 11557 "preproc.y"
    { 
 (yyval.str) = make_str("limit");
;}
    break;

  case 2057:

/* Line 1455 of yacc.c  */
#line 11561 "preproc.y"
    { 
 (yyval.str) = make_str("localtime");
;}
    break;

  case 2058:

/* Line 1455 of yacc.c  */
#line 11565 "preproc.y"
    { 
 (yyval.str) = make_str("localtimestamp");
;}
    break;

  case 2059:

/* Line 1455 of yacc.c  */
#line 11569 "preproc.y"
    { 
 (yyval.str) = make_str("not");
;}
    break;

  case 2060:

/* Line 1455 of yacc.c  */
#line 11573 "preproc.y"
    { 
 (yyval.str) = make_str("null");
;}
    break;

  case 2061:

/* Line 1455 of yacc.c  */
#line 11577 "preproc.y"
    { 
 (yyval.str) = make_str("offset");
;}
    break;

  case 2062:

/* Line 1455 of yacc.c  */
#line 11581 "preproc.y"
    { 
 (yyval.str) = make_str("on");
;}
    break;

  case 2063:

/* Line 1455 of yacc.c  */
#line 11585 "preproc.y"
    { 
 (yyval.str) = make_str("only");
;}
    break;

  case 2064:

/* Line 1455 of yacc.c  */
#line 11589 "preproc.y"
    { 
 (yyval.str) = make_str("or");
;}
    break;

  case 2065:

/* Line 1455 of yacc.c  */
#line 11593 "preproc.y"
    { 
 (yyval.str) = make_str("order");
;}
    break;

  case 2066:

/* Line 1455 of yacc.c  */
#line 11597 "preproc.y"
    { 
 (yyval.str) = make_str("placing");
;}
    break;

  case 2067:

/* Line 1455 of yacc.c  */
#line 11601 "preproc.y"
    { 
 (yyval.str) = make_str("primary");
;}
    break;

  case 2068:

/* Line 1455 of yacc.c  */
#line 11605 "preproc.y"
    { 
 (yyval.str) = make_str("references");
;}
    break;

  case 2069:

/* Line 1455 of yacc.c  */
#line 11609 "preproc.y"
    { 
 (yyval.str) = make_str("returning");
;}
    break;

  case 2070:

/* Line 1455 of yacc.c  */
#line 11613 "preproc.y"
    { 
 (yyval.str) = make_str("select");
;}
    break;

  case 2071:

/* Line 1455 of yacc.c  */
#line 11617 "preproc.y"
    { 
 (yyval.str) = make_str("session_user");
;}
    break;

  case 2072:

/* Line 1455 of yacc.c  */
#line 11621 "preproc.y"
    { 
 (yyval.str) = make_str("some");
;}
    break;

  case 2073:

/* Line 1455 of yacc.c  */
#line 11625 "preproc.y"
    { 
 (yyval.str) = make_str("symmetric");
;}
    break;

  case 2074:

/* Line 1455 of yacc.c  */
#line 11629 "preproc.y"
    { 
 (yyval.str) = make_str("table");
;}
    break;

  case 2075:

/* Line 1455 of yacc.c  */
#line 11633 "preproc.y"
    { 
 (yyval.str) = make_str("then");
;}
    break;

  case 2076:

/* Line 1455 of yacc.c  */
#line 11637 "preproc.y"
    { 
 (yyval.str) = make_str("trailing");
;}
    break;

  case 2077:

/* Line 1455 of yacc.c  */
#line 11641 "preproc.y"
    { 
 (yyval.str) = make_str("true");
;}
    break;

  case 2078:

/* Line 1455 of yacc.c  */
#line 11645 "preproc.y"
    { 
 (yyval.str) = make_str("unique");
;}
    break;

  case 2079:

/* Line 1455 of yacc.c  */
#line 11649 "preproc.y"
    { 
 (yyval.str) = make_str("user");
;}
    break;

  case 2080:

/* Line 1455 of yacc.c  */
#line 11653 "preproc.y"
    { 
 (yyval.str) = make_str("using");
;}
    break;

  case 2081:

/* Line 1455 of yacc.c  */
#line 11657 "preproc.y"
    { 
 (yyval.str) = make_str("variadic");
;}
    break;

  case 2082:

/* Line 1455 of yacc.c  */
#line 11661 "preproc.y"
    { 
 (yyval.str) = make_str("when");
;}
    break;

  case 2083:

/* Line 1455 of yacc.c  */
#line 11665 "preproc.y"
    { 
 (yyval.str) = make_str("where");
;}
    break;

  case 2084:

/* Line 1455 of yacc.c  */
#line 11669 "preproc.y"
    { 
 (yyval.str) = make_str("window");
;}
    break;

  case 2085:

/* Line 1455 of yacc.c  */
#line 11673 "preproc.y"
    { 
 (yyval.str) = make_str("with");
;}
    break;

  case 2088:

/* Line 1455 of yacc.c  */
#line 11686 "preproc.y"
    { connection = NULL; ;}
    break;

  case 2090:

/* Line 1455 of yacc.c  */
#line 11689 "preproc.y"
    {
                        fprintf(yyout, "%s", (yyvsp[(2) - (2)].str));
                        free((yyvsp[(2) - (2)].str));
                        output_line_number();
                ;}
    break;

  case 2092:

/* Line 1455 of yacc.c  */
#line 11695 "preproc.y"
    { fprintf(yyout, "%s", (yyvsp[(1) - (1)].str)); free((yyvsp[(1) - (1)].str)); ;}
    break;

  case 2093:

/* Line 1455 of yacc.c  */
#line 11696 "preproc.y"
    { fprintf(yyout, "%s", (yyvsp[(1) - (1)].str)); free((yyvsp[(1) - (1)].str)); ;}
    break;

  case 2094:

/* Line 1455 of yacc.c  */
#line 11697 "preproc.y"
    { braces_open++; fputs("{", yyout); ;}
    break;

  case 2095:

/* Line 1455 of yacc.c  */
#line 11699 "preproc.y"
    {
			remove_typedefs(braces_open);
			remove_variables(braces_open--);
			if (braces_open == 0)
			{
				free(current_function);
				current_function = NULL;
			}
			fputs("}", yyout);
		;}
    break;

  case 2096:

/* Line 1455 of yacc.c  */
#line 11711 "preproc.y"
    {FoundInto = 0;;}
    break;

  case 2097:

/* Line 1455 of yacc.c  */
#line 11712 "preproc.y"
    {
			if (FoundInto == 1)
				mmerror(PARSE_ERROR, ET_ERROR, "CREATE TABLE AS cannot specify INTO");

			(yyval.str) = cat_str(6, make_str("create"), (yyvsp[(2) - (8)].str), make_str("table"), (yyvsp[(4) - (8)].str), make_str("as"), (yyvsp[(7) - (8)].str));
		;}
    break;

  case 2098:

/* Line 1455 of yacc.c  */
#line 11721 "preproc.y"
    {
                        connection = (yyvsp[(2) - (2)].str);
                        /*
                         *      Do we have a variable as connection target?
                         *      Remove the variable from the variable
                         *      list or else it will be used twice
                         */
                        if (argsinsert != NULL)
                                argsinsert = NULL;
                ;}
    break;

  case 2099:

/* Line 1455 of yacc.c  */
#line 11737 "preproc.y"
    { (yyval.str) = cat_str(5, (yyvsp[(3) - (5)].str), make_str(","), (yyvsp[(5) - (5)].str), make_str(","), (yyvsp[(4) - (5)].str)); ;}
    break;

  case 2100:

/* Line 1455 of yacc.c  */
#line 11739 "preproc.y"
    { (yyval.str) = make_str("NULL, NULL, NULL, \"DEFAULT\""); ;}
    break;

  case 2101:

/* Line 1455 of yacc.c  */
#line 11742 "preproc.y"
    { (yyval.str) = cat_str(3, make_str("NULL,"), (yyvsp[(2) - (2)].str), make_str(", NULL")); ;}
    break;

  case 2102:

/* Line 1455 of yacc.c  */
#line 11744 "preproc.y"
    { (yyval.str) = cat2_str((yyvsp[(2) - (2)].str), make_str(", NULL, NULL, NULL")); ;}
    break;

  case 2103:

/* Line 1455 of yacc.c  */
#line 11748 "preproc.y"
    {
			/* old style: dbname[@server][:port] */
			if (strlen((yyvsp[(2) - (3)].str)) > 0 && *((yyvsp[(2) - (3)].str)) != '@')
				mmerror(PARSE_ERROR, ET_ERROR, "expected \"@\", found \"%s\"", (yyvsp[(2) - (3)].str));
			
			/* C strings need to be handled differently */
			if ((yyvsp[(1) - (3)].str)[0] == '\"')
				(yyval.str) = (yyvsp[(1) - (3)].str);
			else
				(yyval.str) = make3_str(make_str("\""), make3_str((yyvsp[(1) - (3)].str), (yyvsp[(2) - (3)].str), (yyvsp[(3) - (3)].str)), make_str("\""));
		;}
    break;

  case 2104:

/* Line 1455 of yacc.c  */
#line 11760 "preproc.y"
    {
			/* new style: <tcp|unix>:postgresql://server[:port][/dbname] */
			if (strncmp((yyvsp[(1) - (7)].str), "unix:postgresql", strlen("unix:postgresql")) != 0 && strncmp((yyvsp[(1) - (7)].str), "tcp:postgresql", strlen("tcp:postgresql")) != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "only protocols \"tcp\" and \"unix\" and database type \"postgresql\" are supported");

			if (strncmp((yyvsp[(3) - (7)].str), "//", strlen("//")) != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "expected \"://\", found \"%s\"", (yyvsp[(3) - (7)].str));

			if (strncmp((yyvsp[(1) - (7)].str), "unix", strlen("unix")) == 0 &&
				strncmp((yyvsp[(3) - (7)].str) + strlen("//"), "localhost", strlen("localhost")) != 0 &&
				strncmp((yyvsp[(3) - (7)].str) + strlen("//"), "127.0.0.1", strlen("127.0.0.1")) != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "Unix-domain sockets only work on \"localhost\" but not on \"%s\"", (yyvsp[(3) - (7)].str) + strlen("//"));

			(yyval.str) = make3_str(make3_str(make_str("\""), (yyvsp[(1) - (7)].str), make_str(":")), (yyvsp[(3) - (7)].str), make3_str(make3_str((yyvsp[(4) - (7)].str), make_str("/"), (yyvsp[(6) - (7)].str)),	(yyvsp[(7) - (7)].str), make_str("\"")));
		;}
    break;

  case 2105:

/* Line 1455 of yacc.c  */
#line 11776 "preproc.y"
    {
			(yyval.str) = (yyvsp[(1) - (1)].str);
		;}
    break;

  case 2106:

/* Line 1455 of yacc.c  */
#line 11780 "preproc.y"
    {
			/* We can only process double quoted strings not single quotes ones,
			 * so we change the quotes.
			 * Note, that the rule for ecpg_sconst adds these single quotes. */
			(yyvsp[(1) - (1)].str)[0] = '\"';
			(yyvsp[(1) - (1)].str)[strlen((yyvsp[(1) - (1)].str))-1] = '\"';
			(yyval.str) = (yyvsp[(1) - (1)].str);
		;}
    break;

  case 2107:

/* Line 1455 of yacc.c  */
#line 11790 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2108:

/* Line 1455 of yacc.c  */
#line 11791 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2109:

/* Line 1455 of yacc.c  */
#line 11795 "preproc.y"
    {
			if (strcmp((yyvsp[(2) - (2)].str), "postgresql") != 0 && strcmp((yyvsp[(2) - (2)].str), "postgres") != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "expected \"postgresql\", found \"%s\"", (yyvsp[(2) - (2)].str));

			if (strcmp((yyvsp[(1) - (2)].str), "tcp") != 0 && strcmp((yyvsp[(1) - (2)].str), "unix") != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "invalid connection type: %s", (yyvsp[(1) - (2)].str));

			(yyval.str) = make3_str((yyvsp[(1) - (2)].str), make_str(":"), (yyvsp[(2) - (2)].str));
		;}
    break;

  case 2110:

/* Line 1455 of yacc.c  */
#line 11807 "preproc.y"
    {
			if (strcmp((yyvsp[(1) - (2)].str), "@") != 0 && strcmp((yyvsp[(1) - (2)].str), "//") != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "expected \"@\" or \"://\", found \"%s\"", (yyvsp[(1) - (2)].str));

			(yyval.str) = make2_str((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].str));
		;}
    break;

  case 2111:

/* Line 1455 of yacc.c  */
#line 11815 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2112:

/* Line 1455 of yacc.c  */
#line 11816 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2113:

/* Line 1455 of yacc.c  */
#line 11819 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2114:

/* Line 1455 of yacc.c  */
#line 11820 "preproc.y"
    { (yyval.str) = make3_str((yyvsp[(1) - (3)].str), make_str("."), (yyvsp[(3) - (3)].str)); ;}
    break;

  case 2115:

/* Line 1455 of yacc.c  */
#line 11821 "preproc.y"
    { (yyval.str) = make_name(); ;}
    break;

  case 2116:

/* Line 1455 of yacc.c  */
#line 11824 "preproc.y"
    { (yyval.str) = make2_str(make_str(":"), (yyvsp[(2) - (2)].str)); ;}
    break;

  case 2117:

/* Line 1455 of yacc.c  */
#line 11825 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2118:

/* Line 1455 of yacc.c  */
#line 11828 "preproc.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 2119:

/* Line 1455 of yacc.c  */
#line 11829 "preproc.y"
    { (yyval.str) = make_str("NULL"); ;}
    break;

  case 2120:

/* Line 1455 of yacc.c  */
#line 11832 "preproc.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 2121:

/* Line 1455 of yacc.c  */
#line 11833 "preproc.y"
    { (yyval.str) = make_str("NULL, NULL"); ;}
    break;

  case 2122:

/* Line 1455 of yacc.c  */
#line 11837 "preproc.y"
    { (yyval.str) = cat2_str((yyvsp[(1) - (1)].str), make_str(", NULL")); ;}
    break;

  case 2123:

/* Line 1455 of yacc.c  */
#line 11839 "preproc.y"
    { (yyval.str) = cat_str(3, (yyvsp[(1) - (3)].str), make_str(","), (yyvsp[(3) - (3)].str)); ;}
    break;

  case 2124:

/* Line 1455 of yacc.c  */
#line 11841 "preproc.y"
    { (yyval.str) = cat_str(3, (yyvsp[(1) - (4)].str), make_str(","), (yyvsp[(4) - (4)].str)); ;}
    break;

  case 2125:

/* Line 1455 of yacc.c  */
#line 11843 "preproc.y"
    { (yyval.str) = cat_str(3, (yyvsp[(1) - (3)].str), make_str(","), (yyvsp[(3) - (3)].str)); ;}
    break;

  case 2126:

/* Line 1455 of yacc.c  */
#line 11847 "preproc.y"
    {
			if ((yyvsp[(1) - (1)].str)[0] == '\"')
				(yyval.str) = (yyvsp[(1) - (1)].str);
			else
				(yyval.str) = make3_str(make_str("\""), (yyvsp[(1) - (1)].str), make_str("\""));
		;}
    break;

  case 2127:

/* Line 1455 of yacc.c  */
#line 11854 "preproc.y"
    {
			if ((yyvsp[(1) - (1)].str)[0] == '\"')
				(yyval.str) = (yyvsp[(1) - (1)].str);
			else
				(yyval.str) = make3_str(make_str("\""), (yyvsp[(1) - (1)].str), make_str("\""));
		;}
    break;

  case 2128:

/* Line 1455 of yacc.c  */
#line 11861 "preproc.y"
    {
			enum ECPGttype type = argsinsert->variable->type->type;

			/* if array see what's inside */
			if (type == ECPGt_array)
				type = argsinsert->variable->type->u.element->type;

			/* handle varchars */
			if (type == ECPGt_varchar)
				(yyval.str) = make2_str(mm_strdup(argsinsert->variable->name), make_str(".arr"));
			else
				(yyval.str) = mm_strdup(argsinsert->variable->name);
		;}
    break;

  case 2129:

/* Line 1455 of yacc.c  */
#line 11877 "preproc.y"
    {
			/* check if we have a string variable */
			struct variable *p = find_variable((yyvsp[(1) - (1)].str));
			enum ECPGttype type = p->type->type;

			/* If we have just one character this is not a string */
			if (atol(p->type->size) == 1)
					mmerror(PARSE_ERROR, ET_ERROR, "invalid data type");
			else
			{
				/* if array see what's inside */
				if (type == ECPGt_array)
					type = p->type->u.element->type;

				switch (type)
				{
					case ECPGt_char:
					case ECPGt_unsigned_char:
					case ECPGt_string:
						(yyval.str) = (yyvsp[(1) - (1)].str);
						break;
					case ECPGt_varchar:
						(yyval.str) = make2_str((yyvsp[(1) - (1)].str), make_str(".arr"));
						break;
					default:
						mmerror(PARSE_ERROR, ET_ERROR, "invalid data type");
						(yyval.str) = (yyvsp[(1) - (1)].str);
						break;
				}
			}
		;}
    break;

  case 2130:

/* Line 1455 of yacc.c  */
#line 11911 "preproc.y"
    {
			if (strlen((yyvsp[(1) - (2)].str)) == 0)
				mmerror(PARSE_ERROR, ET_ERROR, "incomplete statement");

			if (strcmp((yyvsp[(1) - (2)].str), "?") != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "unrecognized token \"%s\"", (yyvsp[(1) - (2)].str));

			(yyval.str) = make2_str(make_str("?"), (yyvsp[(2) - (2)].str));
		;}
    break;

  case 2131:

/* Line 1455 of yacc.c  */
#line 11920 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2132:

/* Line 1455 of yacc.c  */
#line 11924 "preproc.y"
    { (yyval.str) = make2_str((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].str)); ;}
    break;

  case 2133:

/* Line 1455 of yacc.c  */
#line 11926 "preproc.y"
    {
				if (strlen((yyvsp[(3) - (4)].str)) == 0)
					mmerror(PARSE_ERROR, ET_ERROR, "incomplete statement");

				if (strcmp((yyvsp[(3) - (4)].str), "&") != 0)
					mmerror(PARSE_ERROR, ET_ERROR, "unrecognized token \"%s\"", (yyvsp[(3) - (4)].str));

				(yyval.str) = cat_str(3, make2_str((yyvsp[(1) - (4)].str), (yyvsp[(2) - (4)].str)), (yyvsp[(3) - (4)].str), (yyvsp[(4) - (4)].str));
			;}
    break;

  case 2134:

/* Line 1455 of yacc.c  */
#line 11938 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2135:

/* Line 1455 of yacc.c  */
#line 11940 "preproc.y"
    { (yyval.str) = make2_str(make_str("="), (yyvsp[(2) - (2)].str)); ;}
    break;

  case 2136:

/* Line 1455 of yacc.c  */
#line 11942 "preproc.y"
    { (yyval.str) = make2_str(make_str("="), (yyvsp[(2) - (2)].str)); ;}
    break;

  case 2137:

/* Line 1455 of yacc.c  */
#line 11944 "preproc.y"
    { (yyval.str) = make2_str(make_str("="), (yyvsp[(2) - (2)].str)); ;}
    break;

  case 2138:

/* Line 1455 of yacc.c  */
#line 11947 "preproc.y"
    {
                                        if ((yyvsp[(1) - (1)].str)[0] == '\"' && (yyvsp[(1) - (1)].str)[strlen((yyvsp[(1) - (1)].str))-1] == '\"') /* already quoted? */
                                                (yyval.str) = (yyvsp[(1) - (1)].str);
                                        else /* not quoted => convert to lowercase */
                                        {
                                                int i;

                                                for (i = 0; i< strlen((yyvsp[(1) - (1)].str)); i++)
                                                        (yyvsp[(1) - (1)].str)[i] = tolower((unsigned char) (yyvsp[(1) - (1)].str)[i]);

                                                (yyval.str) = make3_str(make_str("\""), (yyvsp[(1) - (1)].str), make_str("\""));
                                        }
                                ;}
    break;

  case 2139:

/* Line 1455 of yacc.c  */
#line 11960 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2140:

/* Line 1455 of yacc.c  */
#line 11968 "preproc.y"
    {
			struct cursor *ptr, *this;
			char *cursor_marker = (yyvsp[(2) - (7)].str)[0] == ':' ? make_str("$0") : mm_strdup((yyvsp[(2) - (7)].str));
			struct variable *thisquery = (struct variable *)mm_alloc(sizeof(struct variable));
			const char *con = connection ? connection : "NULL";
			char *comment;

			for (ptr = cur; ptr != NULL; ptr = ptr->next)
			{
				if (strcmp((yyvsp[(2) - (7)].str), ptr->name) == 0)
				{
					/* re-definition is a bug */
					if ((yyvsp[(2) - (7)].str)[0] == ':')
	                                        mmerror(PARSE_ERROR, ET_ERROR, "using variable \"%s\" in different declare statements is not supported", (yyvsp[(2) - (7)].str)+1);
        	                        else
						mmerror(PARSE_ERROR, ET_ERROR, "cursor \"%s\" is already defined", (yyvsp[(2) - (7)].str));
				}
			}

			this = (struct cursor *) mm_alloc(sizeof(struct cursor));

			/* initial definition */
			this->next = cur;
			this->name = (yyvsp[(2) - (7)].str);
			this->function = (current_function ? mm_strdup(current_function) : NULL);
			this->connection = connection;
			this->command =  cat_str(6, make_str("declare"), cursor_marker, (yyvsp[(3) - (7)].str), make_str("cursor"), (yyvsp[(5) - (7)].str), make_str("for $1"));
			this->argsresult = NULL;
			this->argsresult_oos = NULL;

			thisquery->type = &ecpg_query;
			thisquery->brace_level = 0;
			thisquery->next = NULL;
			thisquery->name = (char *) mm_alloc(sizeof("ECPGprepared_statement(, , __LINE__)") + strlen(con) + strlen((yyvsp[(7) - (7)].str)));
			sprintf(thisquery->name, "ECPGprepared_statement(%s, %s, __LINE__)", con, (yyvsp[(7) - (7)].str));

			this->argsinsert = NULL;
			this->argsinsert_oos = NULL;
			if ((yyvsp[(2) - (7)].str)[0] == ':')
			{
				struct variable *var = find_variable((yyvsp[(2) - (7)].str) + 1);
				remove_variable_from_list(&argsinsert, var);
				add_variable_to_head(&(this->argsinsert), var, &no_indicator);
			}
			add_variable_to_head(&(this->argsinsert), thisquery, &no_indicator);

			cur = this;

			comment = cat_str(3, make_str("/*"), mm_strdup(this->command), make_str("*/"));

			if ((braces_open > 0) && INFORMIX_MODE) /* we're in a function */
				(yyval.str) = cat_str(3, adjust_outofscope_cursor_vars(this),
					make_str("ECPG_informix_reset_sqlca();"),
					comment);
			else
				(yyval.str) = cat2_str(adjust_outofscope_cursor_vars(this), comment);
		;}
    break;

  case 2141:

/* Line 1455 of yacc.c  */
#line 12028 "preproc.y"
    { 
			  /* execute immediate means prepare the statement and
			   * immediately execute it */
			  (yyval.str) = (yyvsp[(3) - (3)].str);
			;}
    break;

  case 2143:

/* Line 1455 of yacc.c  */
#line 12038 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2144:

/* Line 1455 of yacc.c  */
#line 12039 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2145:

/* Line 1455 of yacc.c  */
#line 12042 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2146:

/* Line 1455 of yacc.c  */
#line 12044 "preproc.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 2147:

/* Line 1455 of yacc.c  */
#line 12045 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2148:

/* Line 1455 of yacc.c  */
#line 12048 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2149:

/* Line 1455 of yacc.c  */
#line 12049 "preproc.y"
    { (yyval.str) = make_str("year to minute"); ;}
    break;

  case 2150:

/* Line 1455 of yacc.c  */
#line 12050 "preproc.y"
    { (yyval.str) = make_str("year to second"); ;}
    break;

  case 2151:

/* Line 1455 of yacc.c  */
#line 12051 "preproc.y"
    { (yyval.str) = make_str("day to day"); ;}
    break;

  case 2152:

/* Line 1455 of yacc.c  */
#line 12052 "preproc.y"
    { (yyval.str) = make_str("month to month"); ;}
    break;

  case 2153:

/* Line 1455 of yacc.c  */
#line 12059 "preproc.y"
    { fputs("/* exec sql begin declare section */", yyout); ;}
    break;

  case 2154:

/* Line 1455 of yacc.c  */
#line 12061 "preproc.y"
    {
			fprintf(yyout, "%s/* exec sql end declare section */", (yyvsp[(3) - (4)].str));
			free((yyvsp[(3) - (4)].str));
			output_line_number();
		;}
    break;

  case 2155:

/* Line 1455 of yacc.c  */
#line 12068 "preproc.y"
    {;}
    break;

  case 2156:

/* Line 1455 of yacc.c  */
#line 12070 "preproc.y"
    {;}
    break;

  case 2157:

/* Line 1455 of yacc.c  */
#line 12072 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2158:

/* Line 1455 of yacc.c  */
#line 12073 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2159:

/* Line 1455 of yacc.c  */
#line 12076 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2160:

/* Line 1455 of yacc.c  */
#line 12077 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2161:

/* Line 1455 of yacc.c  */
#line 12078 "preproc.y"
    { (yyval.str) = cat2_str((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].str)); ;}
    break;

  case 2162:

/* Line 1455 of yacc.c  */
#line 12079 "preproc.y"
    { (yyval.str) = cat2_str((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].str)); ;}
    break;

  case 2163:

/* Line 1455 of yacc.c  */
#line 12082 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2164:

/* Line 1455 of yacc.c  */
#line 12083 "preproc.y"
    { (yyval.str) = cat2_str((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].str)); ;}
    break;

  case 2165:

/* Line 1455 of yacc.c  */
#line 12087 "preproc.y"
    {
		/* reset this variable so we see if there was */
		/* an initializer specified */
		initializer = 0;
	;}
    break;

  case 2166:

/* Line 1455 of yacc.c  */
#line 12093 "preproc.y"
    {
		add_typedef((yyvsp[(5) - (7)].str), (yyvsp[(6) - (7)].index).index1, (yyvsp[(6) - (7)].index).index2, (yyvsp[(3) - (7)].type).type_enum, (yyvsp[(3) - (7)].type).type_dimension, (yyvsp[(3) - (7)].type).type_index, initializer, *(yyvsp[(4) - (7)].str) ? 1 : 0);

		fprintf(yyout, "typedef %s %s %s %s;\n", (yyvsp[(3) - (7)].type).type_str, *(yyvsp[(4) - (7)].str) ? "*" : "", (yyvsp[(5) - (7)].str), (yyvsp[(6) - (7)].index).str);
		output_line_number();
		(yyval.str) = make_str("");
	;}
    break;

  case 2167:

/* Line 1455 of yacc.c  */
#line 12103 "preproc.y"
    {
			actual_type[struct_level].type_enum = (yyvsp[(2) - (2)].type).type_enum;
			actual_type[struct_level].type_str = (yyvsp[(2) - (2)].type).type_str;
			actual_type[struct_level].type_dimension = (yyvsp[(2) - (2)].type).type_dimension;
			actual_type[struct_level].type_index = (yyvsp[(2) - (2)].type).type_index;
			actual_type[struct_level].type_sizeof = (yyvsp[(2) - (2)].type).type_sizeof;

			actual_startline[struct_level] = hashline_number();
		;}
    break;

  case 2168:

/* Line 1455 of yacc.c  */
#line 12113 "preproc.y"
    {
			(yyval.str) = cat_str(5, actual_startline[struct_level], (yyvsp[(1) - (5)].str), (yyvsp[(2) - (5)].type).type_str, (yyvsp[(4) - (5)].str), make_str(";\n"));
		;}
    break;

  case 2169:

/* Line 1455 of yacc.c  */
#line 12117 "preproc.y"
    {
			actual_type[struct_level].type_enum = (yyvsp[(1) - (1)].type).type_enum;
			actual_type[struct_level].type_str = (yyvsp[(1) - (1)].type).type_str;
			actual_type[struct_level].type_dimension = (yyvsp[(1) - (1)].type).type_dimension;
			actual_type[struct_level].type_index = (yyvsp[(1) - (1)].type).type_index;
			actual_type[struct_level].type_sizeof = (yyvsp[(1) - (1)].type).type_sizeof;

			actual_startline[struct_level] = hashline_number();
		;}
    break;

  case 2170:

/* Line 1455 of yacc.c  */
#line 12127 "preproc.y"
    {
			(yyval.str) = cat_str(4, actual_startline[struct_level], (yyvsp[(1) - (4)].type).type_str, (yyvsp[(3) - (4)].str), make_str(";\n"));
		;}
    break;

  case 2171:

/* Line 1455 of yacc.c  */
#line 12131 "preproc.y"
    {
			(yyval.str) = cat2_str((yyvsp[(1) - (2)].str), make_str(";"));
		;}
    break;

  case 2172:

/* Line 1455 of yacc.c  */
#line 12136 "preproc.y"
    { (yyval.str) =cat2_str(make_str(":"), (yyvsp[(2) - (2)].str)); ;}
    break;

  case 2173:

/* Line 1455 of yacc.c  */
#line 12137 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2174:

/* Line 1455 of yacc.c  */
#line 12141 "preproc.y"
    {(yyval.str) = cat2_str ((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].str)); ;}
    break;

  case 2175:

/* Line 1455 of yacc.c  */
#line 12142 "preproc.y"
    {(yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2176:

/* Line 1455 of yacc.c  */
#line 12143 "preproc.y"
    {(yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2177:

/* Line 1455 of yacc.c  */
#line 12146 "preproc.y"
    { (yyval.str) = make_str("extern"); ;}
    break;

  case 2178:

/* Line 1455 of yacc.c  */
#line 12147 "preproc.y"
    { (yyval.str) = make_str("static"); ;}
    break;

  case 2179:

/* Line 1455 of yacc.c  */
#line 12148 "preproc.y"
    { (yyval.str) = make_str("register"); ;}
    break;

  case 2180:

/* Line 1455 of yacc.c  */
#line 12149 "preproc.y"
    { (yyval.str) = make_str("auto"); ;}
    break;

  case 2181:

/* Line 1455 of yacc.c  */
#line 12152 "preproc.y"
    { (yyval.str) = make_str("const"); ;}
    break;

  case 2182:

/* Line 1455 of yacc.c  */
#line 12153 "preproc.y"
    { (yyval.str) = make_str("volatile"); ;}
    break;

  case 2183:

/* Line 1455 of yacc.c  */
#line 12157 "preproc.y"
    {
			(yyval.type).type_enum = (yyvsp[(1) - (1)].type_enum);
			(yyval.type).type_str = mm_strdup(ecpg_type_name((yyvsp[(1) - (1)].type_enum)));
			(yyval.type).type_dimension = make_str("-1");
			(yyval.type).type_index = make_str("-1");
			(yyval.type).type_sizeof = NULL;
		;}
    break;

  case 2184:

/* Line 1455 of yacc.c  */
#line 12165 "preproc.y"
    {
			(yyval.type).type_str = (yyvsp[(1) - (1)].str);
			(yyval.type).type_dimension = make_str("-1");
			(yyval.type).type_index = make_str("-1");

			if (strncmp((yyvsp[(1) - (1)].str), "struct", sizeof("struct")-1) == 0)
			{
				(yyval.type).type_enum = ECPGt_struct;
				(yyval.type).type_sizeof = ECPGstruct_sizeof;
			}
			else
			{
				(yyval.type).type_enum = ECPGt_union;
				(yyval.type).type_sizeof = NULL;
			}
		;}
    break;

  case 2185:

/* Line 1455 of yacc.c  */
#line 12182 "preproc.y"
    {
			(yyval.type).type_str = (yyvsp[(1) - (1)].str);
			(yyval.type).type_enum = ECPGt_int;
			(yyval.type).type_dimension = make_str("-1");
			(yyval.type).type_index = make_str("-1");
			(yyval.type).type_sizeof = NULL;
		;}
    break;

  case 2186:

/* Line 1455 of yacc.c  */
#line 12190 "preproc.y"
    {
			if (strcmp((yyvsp[(1) - (5)].str), "numeric") == 0)
			{
				(yyval.type).type_enum = ECPGt_numeric;
				(yyval.type).type_str = make_str("numeric");
			}
			else if (strcmp((yyvsp[(1) - (5)].str), "decimal") == 0)
			{
				(yyval.type).type_enum = ECPGt_decimal;
				(yyval.type).type_str = make_str("decimal");
			}
			else
			{
				mmerror(PARSE_ERROR, ET_ERROR, "only data types numeric and decimal have precision/scale argument");
				(yyval.type).type_enum = ECPGt_numeric;
				(yyval.type).type_str = make_str("numeric");
			}

			(yyval.type).type_dimension = make_str("-1");
			(yyval.type).type_index = make_str("-1");
			(yyval.type).type_sizeof = NULL;
		;}
    break;

  case 2187:

/* Line 1455 of yacc.c  */
#line 12213 "preproc.y"
    {
			if (strlen((yyvsp[(2) - (2)].str)) != 0 && strcmp ((yyvsp[(1) - (2)].str), "datetime") != 0 && strcmp ((yyvsp[(1) - (2)].str), "interval") != 0)
				mmerror (PARSE_ERROR, ET_ERROR, "interval specification not allowed here");

			/*
			 * Check for type names that the SQL grammar treats as
			 * unreserved keywords
			 */
			if (strcmp((yyvsp[(1) - (2)].str), "varchar") == 0)
			{
				(yyval.type).type_enum = ECPGt_varchar;
				(yyval.type).type_str = EMPTY; /*make_str("varchar");*/
				(yyval.type).type_dimension = make_str("-1");
				(yyval.type).type_index = make_str("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[(1) - (2)].str), "float") == 0)
			{
				(yyval.type).type_enum = ECPGt_float;
				(yyval.type).type_str = make_str("float");
				(yyval.type).type_dimension = make_str("-1");
				(yyval.type).type_index = make_str("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[(1) - (2)].str), "double") == 0)
			{
				(yyval.type).type_enum = ECPGt_double;
				(yyval.type).type_str = make_str("double");
				(yyval.type).type_dimension = make_str("-1");
				(yyval.type).type_index = make_str("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[(1) - (2)].str), "numeric") == 0)
			{
				(yyval.type).type_enum = ECPGt_numeric;
				(yyval.type).type_str = make_str("numeric");
				(yyval.type).type_dimension = make_str("-1");
				(yyval.type).type_index = make_str("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[(1) - (2)].str), "decimal") == 0)
			{
				(yyval.type).type_enum = ECPGt_decimal;
				(yyval.type).type_str = make_str("decimal");
				(yyval.type).type_dimension = make_str("-1");
				(yyval.type).type_index = make_str("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[(1) - (2)].str), "date") == 0)
			{
				(yyval.type).type_enum = ECPGt_date;
				(yyval.type).type_str = make_str("date");
				(yyval.type).type_dimension = make_str("-1");
				(yyval.type).type_index = make_str("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[(1) - (2)].str), "timestamp") == 0)
			{
				(yyval.type).type_enum = ECPGt_timestamp;
				(yyval.type).type_str = make_str("timestamp");
				(yyval.type).type_dimension = make_str("-1");
				(yyval.type).type_index = make_str("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[(1) - (2)].str), "interval") == 0)
			{
				(yyval.type).type_enum = ECPGt_interval;
				(yyval.type).type_str = make_str("interval");
				(yyval.type).type_dimension = make_str("-1");
				(yyval.type).type_index = make_str("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[(1) - (2)].str), "datetime") == 0)
			{
				(yyval.type).type_enum = ECPGt_timestamp;
				(yyval.type).type_str = make_str("timestamp");
				(yyval.type).type_dimension = make_str("-1");
				(yyval.type).type_index = make_str("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if ((strcmp((yyvsp[(1) - (2)].str), "string") == 0) && INFORMIX_MODE)
			{
				(yyval.type).type_enum = ECPGt_string;
				(yyval.type).type_str = make_str("char");
				(yyval.type).type_dimension = make_str("-1");
				(yyval.type).type_index = make_str("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else
			{
				/* this is for typedef'ed types */
				struct typedefs *this = get_typedef((yyvsp[(1) - (2)].str));

				(yyval.type).type_str = (this->type->type_enum == ECPGt_varchar) ? EMPTY : mm_strdup(this->name);
				(yyval.type).type_enum = this->type->type_enum;
				(yyval.type).type_dimension = this->type->type_dimension;
				(yyval.type).type_index = this->type->type_index;
				if (this->type->type_sizeof && strlen(this->type->type_sizeof) != 0)
					(yyval.type).type_sizeof = this->type->type_sizeof;
				else 
					(yyval.type).type_sizeof = cat_str(3, make_str("sizeof("), mm_strdup(this->name), make_str(")"));

				struct_member_list[struct_level] = ECPGstruct_member_dup(this->struct_member_list);
			}
		;}
    break;

  case 2188:

/* Line 1455 of yacc.c  */
#line 12319 "preproc.y"
    {
			/* this is for named structs/unions */
			char *name;
			struct typedefs *this;
			bool forward = (forward_name != NULL && strcmp((yyvsp[(1) - (1)].struct_union).symbol, forward_name) == 0 && strcmp((yyvsp[(1) - (1)].struct_union).su, "struct") == 0);

			name = cat2_str((yyvsp[(1) - (1)].struct_union).su, (yyvsp[(1) - (1)].struct_union).symbol);
			/* Do we have a forward definition? */
			if (!forward)
			{
				/* No */

				this = get_typedef(name);
				(yyval.type).type_str = mm_strdup(this->name);
				(yyval.type).type_enum = this->type->type_enum;
				(yyval.type).type_dimension = this->type->type_dimension;
				(yyval.type).type_index = this->type->type_index;
				(yyval.type).type_sizeof = this->type->type_sizeof;
				struct_member_list[struct_level] = ECPGstruct_member_dup(this->struct_member_list);
				free(name);
			}
			else
			{
				(yyval.type).type_str = name;
				(yyval.type).type_enum = ECPGt_long;
				(yyval.type).type_dimension = make_str("-1");
				(yyval.type).type_index = make_str("-1");
				(yyval.type).type_sizeof = make_str("");
				struct_member_list[struct_level] = NULL;
			}
		;}
    break;

  case 2189:

/* Line 1455 of yacc.c  */
#line 12353 "preproc.y"
    { (yyval.str) = cat_str(3, make_str("enum"), (yyvsp[(2) - (3)].str), (yyvsp[(3) - (3)].str)); ;}
    break;

  case 2190:

/* Line 1455 of yacc.c  */
#line 12355 "preproc.y"
    { (yyval.str) = cat2_str(make_str("enum"), (yyvsp[(2) - (2)].str)); ;}
    break;

  case 2191:

/* Line 1455 of yacc.c  */
#line 12357 "preproc.y"
    { (yyval.str) = cat2_str(make_str("enum"), (yyvsp[(2) - (2)].str)); ;}
    break;

  case 2192:

/* Line 1455 of yacc.c  */
#line 12361 "preproc.y"
    { (yyval.str) = cat_str(3, make_str("{"), (yyvsp[(2) - (3)].str), make_str("}")); ;}
    break;

  case 2193:

/* Line 1455 of yacc.c  */
#line 12364 "preproc.y"
    {
			struct_member_list[struct_level++] = NULL;
			if (struct_level >= STRUCT_DEPTH)
				 mmerror(PARSE_ERROR, ET_ERROR, "too many levels in nested structure/union definition");
			forward_name = mm_strdup((yyvsp[(1) - (1)].struct_union).symbol);
		;}
    break;

  case 2194:

/* Line 1455 of yacc.c  */
#line 12371 "preproc.y"
    {
			struct typedefs *ptr, *this;
			struct this_type su_type;

			ECPGfree_struct_member(struct_member_list[struct_level]);
			struct_member_list[struct_level] = NULL;
			struct_level--;
			if (strncmp((yyvsp[(1) - (5)].struct_union).su, "struct", sizeof("struct")-1) == 0)
				su_type.type_enum = ECPGt_struct;
			else
				su_type.type_enum = ECPGt_union;
			su_type.type_str = cat2_str((yyvsp[(1) - (5)].struct_union).su, (yyvsp[(1) - (5)].struct_union).symbol);
			free(forward_name);
			forward_name = NULL;

			/* This is essantially a typedef but needs the keyword struct/union as well.
			 * So we create the typedef for each struct definition with symbol */
			for (ptr = types; ptr != NULL; ptr = ptr->next)
			{
					if (strcmp(su_type.type_str, ptr->name) == 0)
							/* re-definition is a bug */
							mmerror(PARSE_ERROR, ET_ERROR, "type \"%s\" is already defined", su_type.type_str);
			}

			this = (struct typedefs *) mm_alloc(sizeof(struct typedefs));

			/* initial definition */
			this->next = types;
			this->name = mm_strdup(su_type.type_str);
			this->brace_level = braces_open;
			this->type = (struct this_type *) mm_alloc(sizeof(struct this_type));
			this->type->type_enum = su_type.type_enum;
			this->type->type_str = mm_strdup(su_type.type_str);
			this->type->type_dimension = make_str("-1"); /* dimension of array */
			this->type->type_index = make_str("-1");	/* length of string */
			this->type->type_sizeof = ECPGstruct_sizeof;
			this->struct_member_list = struct_member_list[struct_level];

			types = this;
			(yyval.str) = cat_str(4, su_type.type_str, make_str("{"), (yyvsp[(4) - (5)].str), make_str("}"));
		;}
    break;

  case 2195:

/* Line 1455 of yacc.c  */
#line 12414 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2196:

/* Line 1455 of yacc.c  */
#line 12416 "preproc.y"
    {
			struct_member_list[struct_level++] = NULL;
			if (struct_level >= STRUCT_DEPTH)
				 mmerror(PARSE_ERROR, ET_ERROR, "too many levels in nested structure/union definition");
		;}
    break;

  case 2197:

/* Line 1455 of yacc.c  */
#line 12422 "preproc.y"
    {
			ECPGfree_struct_member(struct_member_list[struct_level]);
			struct_member_list[struct_level] = NULL;
			struct_level--;
			(yyval.str) = cat_str(4, (yyvsp[(1) - (5)].str), make_str("{"), (yyvsp[(4) - (5)].str), make_str("}"));
		;}
    break;

  case 2198:

/* Line 1455 of yacc.c  */
#line 12431 "preproc.y"
    {
			(yyval.struct_union).su = make_str("struct");
			(yyval.struct_union).symbol = (yyvsp[(2) - (2)].str);
			ECPGstruct_sizeof = cat_str(3, make_str("sizeof("), cat2_str(mm_strdup((yyval.struct_union).su), mm_strdup((yyval.struct_union).symbol)), make_str(")"));
		;}
    break;

  case 2199:

/* Line 1455 of yacc.c  */
#line 12437 "preproc.y"
    {
			(yyval.struct_union).su = make_str("union");
			(yyval.struct_union).symbol = (yyvsp[(2) - (2)].str);
		;}
    break;

  case 2200:

/* Line 1455 of yacc.c  */
#line 12444 "preproc.y"
    {
			ECPGstruct_sizeof = make_str(""); /* This must not be NULL to distinguish from simple types. */
			(yyval.str) = make_str("struct");
		;}
    break;

  case 2201:

/* Line 1455 of yacc.c  */
#line 12448 "preproc.y"
    { (yyval.str) = make_str("union"); ;}
    break;

  case 2202:

/* Line 1455 of yacc.c  */
#line 12451 "preproc.y"
    { (yyval.type_enum)=(yyvsp[(1) - (1)].type_enum); ;}
    break;

  case 2203:

/* Line 1455 of yacc.c  */
#line 12452 "preproc.y"
    { (yyval.type_enum)=(yyvsp[(2) - (2)].type_enum); ;}
    break;

  case 2204:

/* Line 1455 of yacc.c  */
#line 12455 "preproc.y"
    { (yyval.type_enum) = ECPGt_unsigned_short; ;}
    break;

  case 2205:

/* Line 1455 of yacc.c  */
#line 12456 "preproc.y"
    { (yyval.type_enum) = ECPGt_unsigned_short; ;}
    break;

  case 2206:

/* Line 1455 of yacc.c  */
#line 12457 "preproc.y"
    { (yyval.type_enum) = ECPGt_unsigned_int; ;}
    break;

  case 2207:

/* Line 1455 of yacc.c  */
#line 12458 "preproc.y"
    { (yyval.type_enum) = ECPGt_unsigned_int; ;}
    break;

  case 2208:

/* Line 1455 of yacc.c  */
#line 12459 "preproc.y"
    { (yyval.type_enum) = ECPGt_unsigned_long; ;}
    break;

  case 2209:

/* Line 1455 of yacc.c  */
#line 12460 "preproc.y"
    { (yyval.type_enum) = ECPGt_unsigned_long; ;}
    break;

  case 2210:

/* Line 1455 of yacc.c  */
#line 12462 "preproc.y"
    {
#ifdef HAVE_LONG_LONG_INT
			(yyval.type_enum) = ECPGt_unsigned_long_long;
#else
			(yyval.type_enum) = ECPGt_unsigned_long;
#endif
		;}
    break;

  case 2211:

/* Line 1455 of yacc.c  */
#line 12470 "preproc.y"
    {
#ifdef HAVE_LONG_LONG_INT
			(yyval.type_enum) = ECPGt_unsigned_long_long;
#else
			(yyval.type_enum) = ECPGt_unsigned_long;
#endif
		;}
    break;

  case 2212:

/* Line 1455 of yacc.c  */
#line 12477 "preproc.y"
    { (yyval.type_enum) = ECPGt_unsigned_char; ;}
    break;

  case 2213:

/* Line 1455 of yacc.c  */
#line 12480 "preproc.y"
    { (yyval.type_enum) = ECPGt_short; ;}
    break;

  case 2214:

/* Line 1455 of yacc.c  */
#line 12481 "preproc.y"
    { (yyval.type_enum) = ECPGt_short; ;}
    break;

  case 2215:

/* Line 1455 of yacc.c  */
#line 12482 "preproc.y"
    { (yyval.type_enum) = ECPGt_int; ;}
    break;

  case 2216:

/* Line 1455 of yacc.c  */
#line 12483 "preproc.y"
    { (yyval.type_enum) = ECPGt_long; ;}
    break;

  case 2217:

/* Line 1455 of yacc.c  */
#line 12484 "preproc.y"
    { (yyval.type_enum) = ECPGt_long; ;}
    break;

  case 2218:

/* Line 1455 of yacc.c  */
#line 12486 "preproc.y"
    {
#ifdef HAVE_LONG_LONG_INT
			(yyval.type_enum) = ECPGt_long_long;
#else
			(yyval.type_enum) = ECPGt_long;
#endif
		;}
    break;

  case 2219:

/* Line 1455 of yacc.c  */
#line 12494 "preproc.y"
    {
#ifdef HAVE_LONG_LONG_INT
			(yyval.type_enum) = ECPGt_long_long;
#else
			(yyval.type_enum) = ECPGt_long;
#endif
		;}
    break;

  case 2220:

/* Line 1455 of yacc.c  */
#line 12501 "preproc.y"
    { (yyval.type_enum) = ECPGt_bool; ;}
    break;

  case 2221:

/* Line 1455 of yacc.c  */
#line 12502 "preproc.y"
    { (yyval.type_enum) = ECPGt_char; ;}
    break;

  case 2222:

/* Line 1455 of yacc.c  */
#line 12503 "preproc.y"
    { (yyval.type_enum) = ECPGt_double; ;}
    break;

  case 2225:

/* Line 1455 of yacc.c  */
#line 12511 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2226:

/* Line 1455 of yacc.c  */
#line 12513 "preproc.y"
    { (yyval.str) = cat_str(3, (yyvsp[(1) - (3)].str), make_str(","), (yyvsp[(3) - (3)].str)); ;}
    break;

  case 2227:

/* Line 1455 of yacc.c  */
#line 12517 "preproc.y"
    {
			struct ECPGtype * type;
			char *dimension = (yyvsp[(3) - (5)].index).index1; /* dimension of array */
			char *length = (yyvsp[(3) - (5)].index).index2;    /* length of string */
			char *dim_str;
			char *vcn;

			adjust_array(actual_type[struct_level].type_enum, &dimension, &length, actual_type[struct_level].type_dimension, actual_type[struct_level].type_index, strlen((yyvsp[(1) - (5)].str)), false);

			switch (actual_type[struct_level].type_enum)
			{
				case ECPGt_struct:
				case ECPGt_union:
					if (atoi(dimension) < 0)
						type = ECPGmake_struct_type(struct_member_list[struct_level], actual_type[struct_level].type_enum, actual_type[struct_level].type_str, actual_type[struct_level].type_sizeof);
					else
						type = ECPGmake_array_type(ECPGmake_struct_type(struct_member_list[struct_level], actual_type[struct_level].type_enum, actual_type[struct_level].type_str, actual_type[struct_level].type_sizeof), dimension);

					(yyval.str) = cat_str(5, (yyvsp[(1) - (5)].str), mm_strdup((yyvsp[(2) - (5)].str)), (yyvsp[(3) - (5)].index).str, (yyvsp[(4) - (5)].str), (yyvsp[(5) - (5)].str));
					break;

				case ECPGt_varchar:
					if (atoi(dimension) < 0)
						type = ECPGmake_simple_type(actual_type[struct_level].type_enum, length, varchar_counter);
					else
						type = ECPGmake_array_type(ECPGmake_simple_type(actual_type[struct_level].type_enum, length, varchar_counter), dimension);
					
					if (strcmp(dimension, "0") == 0 || abs(atoi(dimension)) == 1)
							dim_str=make_str("");
					else
							dim_str=cat_str(3, make_str("["), mm_strdup(dimension), make_str("]"));
					/* cannot check for atoi <= 0 because a defined constant will yield 0 here as well */
					if (atoi(length) < 0 || strcmp(length, "0") == 0)
						mmerror(PARSE_ERROR, ET_ERROR, "pointers to varchar are not implemented");

					/* make sure varchar struct name is unique by adding a unique counter to its definition */
					vcn = (char *) mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);
					sprintf(vcn, "%d", varchar_counter);
					if (strcmp(dimension, "0") == 0)
						(yyval.str) = cat_str(7, make2_str(make_str(" struct varchar_"), vcn), make_str(" { int len; char arr["), mm_strdup(length), make_str("]; } *"), mm_strdup((yyvsp[(2) - (5)].str)), (yyvsp[(4) - (5)].str), (yyvsp[(5) - (5)].str));
					else
						(yyval.str) = cat_str(8, make2_str(make_str(" struct varchar_"), vcn), make_str(" { int len; char arr["), mm_strdup(length), make_str("]; } "), mm_strdup((yyvsp[(2) - (5)].str)), dim_str, (yyvsp[(4) - (5)].str), (yyvsp[(5) - (5)].str));
					varchar_counter++;
					break;

				case ECPGt_char:
				case ECPGt_unsigned_char:
				case ECPGt_string:
					if (atoi(dimension) == -1)
					{
						int i = strlen((yyvsp[(5) - (5)].str));

						if (atoi(length) == -1 && i > 0) /* char <var>[] = "string" */
						{
							/* if we have an initializer but no string size set, let's use the initializer's length */
							free(length);
							length = mm_alloc(i+sizeof("sizeof()"));
							sprintf(length, "sizeof(%s)", (yyvsp[(5) - (5)].str)+2);
						}
						type = ECPGmake_simple_type(actual_type[struct_level].type_enum, length, 0);
					}
					else
						type = ECPGmake_array_type(ECPGmake_simple_type(actual_type[struct_level].type_enum, length, 0), dimension);

					(yyval.str) = cat_str(5, (yyvsp[(1) - (5)].str), mm_strdup((yyvsp[(2) - (5)].str)), (yyvsp[(3) - (5)].index).str, (yyvsp[(4) - (5)].str), (yyvsp[(5) - (5)].str));
					break;

				default:
					if (atoi(dimension) < 0)
						type = ECPGmake_simple_type(actual_type[struct_level].type_enum, make_str("1"), 0);
					else
						type = ECPGmake_array_type(ECPGmake_simple_type(actual_type[struct_level].type_enum, make_str("1"), 0), dimension);

					(yyval.str) = cat_str(5, (yyvsp[(1) - (5)].str), mm_strdup((yyvsp[(2) - (5)].str)), (yyvsp[(3) - (5)].index).str, (yyvsp[(4) - (5)].str), (yyvsp[(5) - (5)].str));
					break;
			}

			if (struct_level == 0)
				new_variable((yyvsp[(2) - (5)].str), type, braces_open);
			else
				ECPGmake_struct_member((yyvsp[(2) - (5)].str), type, &(struct_member_list[struct_level - 1]));

			free((yyvsp[(2) - (5)].str));
		;}
    break;

  case 2228:

/* Line 1455 of yacc.c  */
#line 12604 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2229:

/* Line 1455 of yacc.c  */
#line 12606 "preproc.y"
    {
			initializer = 1;
			(yyval.str) = cat2_str(make_str("="), (yyvsp[(2) - (2)].str));
		;}
    break;

  case 2230:

/* Line 1455 of yacc.c  */
#line 12612 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2231:

/* Line 1455 of yacc.c  */
#line 12613 "preproc.y"
    { (yyval.str) = make_str("*"); ;}
    break;

  case 2232:

/* Line 1455 of yacc.c  */
#line 12614 "preproc.y"
    { (yyval.str) = make_str("**"); ;}
    break;

  case 2233:

/* Line 1455 of yacc.c  */
#line 12621 "preproc.y"
    {
			/* this is only supported for compatibility */
			(yyval.str) = cat_str(3, make_str("/* declare statement"), (yyvsp[(3) - (3)].str), make_str("*/"));
		;}
    break;

  case 2234:

/* Line 1455 of yacc.c  */
#line 12629 "preproc.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 2235:

/* Line 1455 of yacc.c  */
#line 12632 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2236:

/* Line 1455 of yacc.c  */
#line 12633 "preproc.y"
    { (yyval.str) = make_str("\"CURRENT\""); ;}
    break;

  case 2237:

/* Line 1455 of yacc.c  */
#line 12634 "preproc.y"
    { (yyval.str) = make_str("\"ALL\""); ;}
    break;

  case 2238:

/* Line 1455 of yacc.c  */
#line 12635 "preproc.y"
    { (yyval.str) = make_str("\"CURRENT\""); ;}
    break;

  case 2239:

/* Line 1455 of yacc.c  */
#line 12638 "preproc.y"
    { (yyval.str) = make3_str(make_str("\""), (yyvsp[(1) - (1)].str), make_str("\"")); ;}
    break;

  case 2240:

/* Line 1455 of yacc.c  */
#line 12639 "preproc.y"
    { (yyval.str) = make_str("\"DEFAULT\""); ;}
    break;

  case 2241:

/* Line 1455 of yacc.c  */
#line 12640 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2242:

/* Line 1455 of yacc.c  */
#line 12644 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2243:

/* Line 1455 of yacc.c  */
#line 12646 "preproc.y"
    { (yyval.str) = make3_str(make_str("\""), (yyvsp[(1) - (1)].str), make_str("\"")); ;}
    break;

  case 2244:

/* Line 1455 of yacc.c  */
#line 12653 "preproc.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 2245:

/* Line 1455 of yacc.c  */
#line 12654 "preproc.y"
    { (yyval.str) = make_str("all"); ;}
    break;

  case 2246:

/* Line 1455 of yacc.c  */
#line 12661 "preproc.y"
    {
			if ((yyvsp[(2) - (3)].str)[0] == ':')
				remove_variable_from_list(&argsinsert, find_variable((yyvsp[(2) - (3)].str) + 1));
			(yyval.str) = (yyvsp[(2) - (3)].str);
		;}
    break;

  case 2247:

/* Line 1455 of yacc.c  */
#line 12668 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2248:

/* Line 1455 of yacc.c  */
#line 12669 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2249:

/* Line 1455 of yacc.c  */
#line 12672 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2250:

/* Line 1455 of yacc.c  */
#line 12673 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2251:

/* Line 1455 of yacc.c  */
#line 12677 "preproc.y"
    {
			add_variable_to_head(&argsinsert, descriptor_variable((yyvsp[(4) - (4)].str),0), &no_indicator);
			(yyval.str) = EMPTY;
		;}
    break;

  case 2252:

/* Line 1455 of yacc.c  */
#line 12682 "preproc.y"
    {
			add_variable_to_head(&argsinsert, sqlda_variable((yyvsp[(3) - (3)].str)), &no_indicator);
			(yyval.str) = EMPTY;
		;}
    break;

  case 2253:

/* Line 1455 of yacc.c  */
#line 12689 "preproc.y"
    {
			add_variable_to_head(&argsresult, descriptor_variable((yyvsp[(4) - (4)].str),1), &no_indicator);
			(yyval.str) = EMPTY;
		;}
    break;

  case 2254:

/* Line 1455 of yacc.c  */
#line 12694 "preproc.y"
    {
			add_variable_to_head(&argsresult, sqlda_variable((yyvsp[(3) - (3)].str)), &no_indicator);
			(yyval.str) = EMPTY;
		;}
    break;

  case 2255:

/* Line 1455 of yacc.c  */
#line 12701 "preproc.y"
    {
			add_variable_to_head(&argsresult, sqlda_variable((yyvsp[(2) - (2)].str)), &no_indicator);
			(yyval.str) = EMPTY;
		;}
    break;

  case 2258:

/* Line 1455 of yacc.c  */
#line 12710 "preproc.y"
    {
			char *length = mm_alloc(32);

			sprintf(length, "%d", (int) strlen((yyvsp[(1) - (1)].str)));
			add_variable_to_head(&argsinsert, new_variable((yyvsp[(1) - (1)].str), ECPGmake_simple_type(ECPGt_const, length, 0), 0), &no_indicator);
		;}
    break;

  case 2259:

/* Line 1455 of yacc.c  */
#line 12716 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2260:

/* Line 1455 of yacc.c  */
#line 12717 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2261:

/* Line 1455 of yacc.c  */
#line 12720 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2262:

/* Line 1455 of yacc.c  */
#line 12721 "preproc.y"
    { (yyval.str) = cat_str(2, make_str("+"), (yyvsp[(2) - (2)].str)); ;}
    break;

  case 2263:

/* Line 1455 of yacc.c  */
#line 12722 "preproc.y"
    { (yyval.str) = cat_str(2, make_str("-"), (yyvsp[(2) - (2)].str)); ;}
    break;

  case 2264:

/* Line 1455 of yacc.c  */
#line 12723 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2265:

/* Line 1455 of yacc.c  */
#line 12724 "preproc.y"
    { (yyval.str) = cat_str(2, make_str("+"), (yyvsp[(2) - (2)].str)); ;}
    break;

  case 2266:

/* Line 1455 of yacc.c  */
#line 12725 "preproc.y"
    { (yyval.str) = cat_str(2, make_str("-"), (yyvsp[(2) - (2)].str)); ;}
    break;

  case 2267:

/* Line 1455 of yacc.c  */
#line 12726 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2268:

/* Line 1455 of yacc.c  */
#line 12727 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2269:

/* Line 1455 of yacc.c  */
#line 12728 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2270:

/* Line 1455 of yacc.c  */
#line 12735 "preproc.y"
    {
		const char *con = connection ? connection : "NULL";
		mmerror(PARSE_ERROR, ET_WARNING, "using unsupported DESCRIBE statement");
		(yyval.str) = (char *) mm_alloc(sizeof("1, , ") + strlen(con) + strlen((yyvsp[(3) - (4)].str)));
		sprintf((yyval.str), "1, %s, %s", con, (yyvsp[(3) - (4)].str));
	;}
    break;

  case 2271:

/* Line 1455 of yacc.c  */
#line 12742 "preproc.y"
    {
		const char *con = connection ? connection : "NULL";
		struct variable *var;

		var = argsinsert->variable;
		remove_variable_from_list(&argsinsert, var);
		add_variable_to_head(&argsresult, var, &no_indicator);

		(yyval.str) = (char *) mm_alloc(sizeof("0, , ") + strlen(con) + strlen((yyvsp[(3) - (4)].str)));
		sprintf((yyval.str), "0, %s, %s", con, (yyvsp[(3) - (4)].str));
	;}
    break;

  case 2272:

/* Line 1455 of yacc.c  */
#line 12754 "preproc.y"
    {
		const char *con = connection ? connection : "NULL";
		(yyval.str) = (char *) mm_alloc(sizeof("0, , ") + strlen(con) + strlen((yyvsp[(3) - (4)].str)));
		sprintf((yyval.str), "0, %s, %s", con, (yyvsp[(3) - (4)].str));
	;}
    break;

  case 2273:

/* Line 1455 of yacc.c  */
#line 12760 "preproc.y"
    {
		const char *con = connection ? connection : "NULL";
		mmerror(PARSE_ERROR, ET_WARNING, "using unsupported DESCRIBE statement");
		(yyval.str) = (char *) mm_alloc(sizeof("1, , ") + strlen(con) + strlen((yyvsp[(3) - (4)].str)));
		sprintf((yyval.str), "1, %s, %s", con, (yyvsp[(3) - (4)].str));
	;}
    break;

  case 2274:

/* Line 1455 of yacc.c  */
#line 12767 "preproc.y"
    {
		const char *con = connection ? connection : "NULL";
		(yyval.str) = (char *) mm_alloc(sizeof("0, , ") + strlen(con) + strlen((yyvsp[(3) - (4)].str)));
		sprintf((yyval.str), "0, %s, %s", con, (yyvsp[(3) - (4)].str));
	;}
    break;

  case 2275:

/* Line 1455 of yacc.c  */
#line 12774 "preproc.y"
    { (yyval.str) = make_str("output"); ;}
    break;

  case 2276:

/* Line 1455 of yacc.c  */
#line 12775 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2277:

/* Line 1455 of yacc.c  */
#line 12788 "preproc.y"
    {
			add_descriptor((yyvsp[(3) - (3)].str),connection);
			(yyval.str) = (yyvsp[(3) - (3)].str);
		;}
    break;

  case 2278:

/* Line 1455 of yacc.c  */
#line 12799 "preproc.y"
    {
			drop_descriptor((yyvsp[(3) - (3)].str),connection);
			(yyval.str) = (yyvsp[(3) - (3)].str);
		;}
    break;

  case 2279:

/* Line 1455 of yacc.c  */
#line 12810 "preproc.y"
    {  (yyval.str) = (yyvsp[(3) - (4)].str); ;}
    break;

  case 2282:

/* Line 1455 of yacc.c  */
#line 12818 "preproc.y"
    { push_assignment((yyvsp[(1) - (3)].str), (yyvsp[(3) - (3)].dtype_enum)); ;}
    break;

  case 2283:

/* Line 1455 of yacc.c  */
#line 12823 "preproc.y"
    { (yyval.str) = (yyvsp[(3) - (4)].str); ;}
    break;

  case 2286:

/* Line 1455 of yacc.c  */
#line 12831 "preproc.y"
    {
			push_assignment((yyvsp[(3) - (3)].str), (yyvsp[(1) - (3)].dtype_enum));
		;}
    break;

  case 2287:

/* Line 1455 of yacc.c  */
#line 12837 "preproc.y"
    {
                        char *length = mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);

                        sprintf(length, "%d", (int) strlen((yyvsp[(1) - (1)].str)));
                        new_variable((yyvsp[(1) - (1)].str), ECPGmake_simple_type(ECPGt_const, length, 0), 0);
                        (yyval.str) = (yyvsp[(1) - (1)].str);
                ;}
    break;

  case 2288:

/* Line 1455 of yacc.c  */
#line 12844 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2289:

/* Line 1455 of yacc.c  */
#line 12847 "preproc.y"
    { (yyval.dtype_enum) = ECPGd_count; ;}
    break;

  case 2290:

/* Line 1455 of yacc.c  */
#line 12855 "preproc.y"
    {  (yyval.descriptor).str = (yyvsp[(5) - (6)].str); (yyval.descriptor).name = (yyvsp[(3) - (6)].str); ;}
    break;

  case 2293:

/* Line 1455 of yacc.c  */
#line 12862 "preproc.y"
    { push_assignment((yyvsp[(1) - (3)].str), (yyvsp[(3) - (3)].dtype_enum)); ;}
    break;

  case 2294:

/* Line 1455 of yacc.c  */
#line 12866 "preproc.y"
    {  (yyval.descriptor).str = (yyvsp[(5) - (6)].str); (yyval.descriptor).name = (yyvsp[(3) - (6)].str); ;}
    break;

  case 2297:

/* Line 1455 of yacc.c  */
#line 12874 "preproc.y"
    {
			push_assignment((yyvsp[(3) - (3)].str), (yyvsp[(1) - (3)].dtype_enum));
		;}
    break;

  case 2298:

/* Line 1455 of yacc.c  */
#line 12880 "preproc.y"
    {
                        char *length = mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);

                        sprintf(length, "%d", (int) strlen((yyvsp[(1) - (1)].str)));
                        new_variable((yyvsp[(1) - (1)].str), ECPGmake_simple_type(ECPGt_const, length, 0), 0);
                        (yyval.str) = (yyvsp[(1) - (1)].str);
                ;}
    break;

  case 2299:

/* Line 1455 of yacc.c  */
#line 12887 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2300:

/* Line 1455 of yacc.c  */
#line 12889 "preproc.y"
    {
                        char *length = mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);
                        char *var = cat2_str(make_str("-"), (yyvsp[(2) - (2)].str));

                        sprintf(length, "%d", (int) strlen(var));
                        new_variable(var, ECPGmake_simple_type(ECPGt_const, length, 0), 0);
                        (yyval.str) = var;
                ;}
    break;

  case 2301:

/* Line 1455 of yacc.c  */
#line 12898 "preproc.y"
    {
                        char *length = mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);
                        char *var = cat2_str(make_str("-"), (yyvsp[(2) - (2)].str));

                        sprintf(length, "%d", (int) strlen(var));
                        new_variable(var, ECPGmake_simple_type(ECPGt_const, length, 0), 0);
                        (yyval.str) = var;
                ;}
    break;

  case 2302:

/* Line 1455 of yacc.c  */
#line 12907 "preproc.y"
    {
                        char *length = mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);
                        char *var = (yyvsp[(1) - (1)].str) + 1;

                        var[strlen(var) - 1] = '\0';
                        sprintf(length, "%d", (int) strlen(var));
                        new_variable(var, ECPGmake_simple_type(ECPGt_const, length, 0), 0);
                        (yyval.str) = var;
                ;}
    break;

  case 2303:

/* Line 1455 of yacc.c  */
#line 12918 "preproc.y"
    { (yyval.dtype_enum) = ECPGd_cardinality; ;}
    break;

  case 2304:

/* Line 1455 of yacc.c  */
#line 12919 "preproc.y"
    { (yyval.dtype_enum) = ECPGd_data; ;}
    break;

  case 2305:

/* Line 1455 of yacc.c  */
#line 12920 "preproc.y"
    { (yyval.dtype_enum) = ECPGd_di_code; ;}
    break;

  case 2306:

/* Line 1455 of yacc.c  */
#line 12921 "preproc.y"
    { (yyval.dtype_enum) = ECPGd_di_precision; ;}
    break;

  case 2307:

/* Line 1455 of yacc.c  */
#line 12922 "preproc.y"
    { (yyval.dtype_enum) = ECPGd_indicator; ;}
    break;

  case 2308:

/* Line 1455 of yacc.c  */
#line 12923 "preproc.y"
    { (yyval.dtype_enum) = ECPGd_key_member; ;}
    break;

  case 2309:

/* Line 1455 of yacc.c  */
#line 12924 "preproc.y"
    { (yyval.dtype_enum) = ECPGd_length; ;}
    break;

  case 2310:

/* Line 1455 of yacc.c  */
#line 12925 "preproc.y"
    { (yyval.dtype_enum) = ECPGd_name; ;}
    break;

  case 2311:

/* Line 1455 of yacc.c  */
#line 12926 "preproc.y"
    { (yyval.dtype_enum) = ECPGd_nullable; ;}
    break;

  case 2312:

/* Line 1455 of yacc.c  */
#line 12927 "preproc.y"
    { (yyval.dtype_enum) = ECPGd_octet; ;}
    break;

  case 2313:

/* Line 1455 of yacc.c  */
#line 12928 "preproc.y"
    { (yyval.dtype_enum) = ECPGd_precision; ;}
    break;

  case 2314:

/* Line 1455 of yacc.c  */
#line 12929 "preproc.y"
    { (yyval.dtype_enum) = ECPGd_length; ;}
    break;

  case 2315:

/* Line 1455 of yacc.c  */
#line 12930 "preproc.y"
    { (yyval.dtype_enum) = ECPGd_ret_octet; ;}
    break;

  case 2316:

/* Line 1455 of yacc.c  */
#line 12931 "preproc.y"
    { (yyval.dtype_enum) = ECPGd_scale; ;}
    break;

  case 2317:

/* Line 1455 of yacc.c  */
#line 12932 "preproc.y"
    { (yyval.dtype_enum) = ECPGd_type; ;}
    break;

  case 2318:

/* Line 1455 of yacc.c  */
#line 12939 "preproc.y"
    { (yyval.str) = (yyvsp[(4) - (4)].str); ;}
    break;

  case 2319:

/* Line 1455 of yacc.c  */
#line 12940 "preproc.y"
    { (yyval.str) = (yyvsp[(4) - (4)].str); ;}
    break;

  case 2320:

/* Line 1455 of yacc.c  */
#line 12943 "preproc.y"
    { (yyval.str) = make_str("on"); ;}
    break;

  case 2321:

/* Line 1455 of yacc.c  */
#line 12944 "preproc.y"
    { (yyval.str) = make_str("off"); ;}
    break;

  case 2322:

/* Line 1455 of yacc.c  */
#line 12951 "preproc.y"
    { (yyval.str) = (yyvsp[(4) - (4)].str); ;}
    break;

  case 2323:

/* Line 1455 of yacc.c  */
#line 12952 "preproc.y"
    { (yyval.str) = (yyvsp[(4) - (4)].str); ;}
    break;

  case 2324:

/* Line 1455 of yacc.c  */
#line 12953 "preproc.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); ;}
    break;

  case 2325:

/* Line 1455 of yacc.c  */
#line 12960 "preproc.y"
    {
			/* reset this variable so we see if there was */
			/* an initializer specified */
			initializer = 0;
		;}
    break;

  case 2326:

/* Line 1455 of yacc.c  */
#line 12966 "preproc.y"
    {
			add_typedef((yyvsp[(3) - (7)].str), (yyvsp[(6) - (7)].index).index1, (yyvsp[(6) - (7)].index).index2, (yyvsp[(5) - (7)].type).type_enum, (yyvsp[(5) - (7)].type).type_dimension, (yyvsp[(5) - (7)].type).type_index, initializer, *(yyvsp[(7) - (7)].str) ? 1 : 0);

			if (auto_create_c == false)
				(yyval.str) = cat_str(7, make_str("/* exec sql type"), mm_strdup((yyvsp[(3) - (7)].str)), make_str("is"), mm_strdup((yyvsp[(5) - (7)].type).type_str), mm_strdup((yyvsp[(6) - (7)].index).str), (yyvsp[(7) - (7)].str), make_str("*/"));
			else
				(yyval.str) = cat_str(6, make_str("typedef "), mm_strdup((yyvsp[(5) - (7)].type).type_str), *(yyvsp[(7) - (7)].str)?make_str("*"):make_str(""), mm_strdup((yyvsp[(6) - (7)].index).str), mm_strdup((yyvsp[(3) - (7)].str)), make_str(";"));
		;}
    break;

  case 2327:

/* Line 1455 of yacc.c  */
#line 12976 "preproc.y"
    { (yyval.str) = make_str("reference"); ;}
    break;

  case 2328:

/* Line 1455 of yacc.c  */
#line 12977 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2329:

/* Line 1455 of yacc.c  */
#line 12984 "preproc.y"
    {
			/* reset this variable so we see if there was */
			/* an initializer specified */
			initializer = 0;
		;}
    break;

  case 2330:

/* Line 1455 of yacc.c  */
#line 12990 "preproc.y"
    {
			struct variable *p = find_variable((yyvsp[(3) - (7)].str));
			char *dimension = (yyvsp[(6) - (7)].index).index1;
			char *length = (yyvsp[(6) - (7)].index).index2;
			struct ECPGtype * type;

			if (((yyvsp[(5) - (7)].type).type_enum == ECPGt_struct ||
				 (yyvsp[(5) - (7)].type).type_enum == ECPGt_union) &&
				initializer == 1)
				mmerror(PARSE_ERROR, ET_ERROR, "initializer not allowed in EXEC SQL VAR command");
			else
			{
				adjust_array((yyvsp[(5) - (7)].type).type_enum, &dimension, &length, (yyvsp[(5) - (7)].type).type_dimension, (yyvsp[(5) - (7)].type).type_index, *(yyvsp[(7) - (7)].str)?1:0, false);

				switch ((yyvsp[(5) - (7)].type).type_enum)
				{
					case ECPGt_struct:
					case ECPGt_union:
						if (atoi(dimension) < 0)
							type = ECPGmake_struct_type(struct_member_list[struct_level], (yyvsp[(5) - (7)].type).type_enum, (yyvsp[(5) - (7)].type).type_str, (yyvsp[(5) - (7)].type).type_sizeof);
						else
							type = ECPGmake_array_type(ECPGmake_struct_type(struct_member_list[struct_level], (yyvsp[(5) - (7)].type).type_enum, (yyvsp[(5) - (7)].type).type_str, (yyvsp[(5) - (7)].type).type_sizeof), dimension);
						break;

					case ECPGt_varchar:
						if (atoi(dimension) == -1)
							type = ECPGmake_simple_type((yyvsp[(5) - (7)].type).type_enum, length, 0);
						else
							type = ECPGmake_array_type(ECPGmake_simple_type((yyvsp[(5) - (7)].type).type_enum, length, 0), dimension);
						break;

					case ECPGt_char:
					case ECPGt_unsigned_char:
					case ECPGt_string:
						if (atoi(dimension) == -1)
							type = ECPGmake_simple_type((yyvsp[(5) - (7)].type).type_enum, length, 0);
						else
							type = ECPGmake_array_type(ECPGmake_simple_type((yyvsp[(5) - (7)].type).type_enum, length, 0), dimension);
						break;

					default:
						if (atoi(length) >= 0)
							mmerror(PARSE_ERROR, ET_ERROR, "multidimensional arrays for simple data types are not supported");

						if (atoi(dimension) < 0)
							type = ECPGmake_simple_type((yyvsp[(5) - (7)].type).type_enum, make_str("1"), 0);
						else
							type = ECPGmake_array_type(ECPGmake_simple_type((yyvsp[(5) - (7)].type).type_enum, make_str("1"), 0), dimension);
						break;
				}

				ECPGfree_type(p->type);
				p->type = type;
			}

			(yyval.str) = cat_str(7, make_str("/* exec sql var"), mm_strdup((yyvsp[(3) - (7)].str)), make_str("is"), mm_strdup((yyvsp[(5) - (7)].type).type_str), mm_strdup((yyvsp[(6) - (7)].index).str), (yyvsp[(7) - (7)].str), make_str("*/"));
		;}
    break;

  case 2331:

/* Line 1455 of yacc.c  */
#line 13054 "preproc.y"
    {
			when_error.code = (yyvsp[(3) - (3)].action).code;
			when_error.command = (yyvsp[(3) - (3)].action).command;
			(yyval.str) = cat_str(3, make_str("/* exec sql whenever sqlerror "), (yyvsp[(3) - (3)].action).str, make_str("; */"));
		;}
    break;

  case 2332:

/* Line 1455 of yacc.c  */
#line 13060 "preproc.y"
    {
			when_nf.code = (yyvsp[(4) - (4)].action).code;
			when_nf.command = (yyvsp[(4) - (4)].action).command;
			(yyval.str) = cat_str(3, make_str("/* exec sql whenever not found "), (yyvsp[(4) - (4)].action).str, make_str("; */"));
		;}
    break;

  case 2333:

/* Line 1455 of yacc.c  */
#line 13066 "preproc.y"
    {
			when_warn.code = (yyvsp[(3) - (3)].action).code;
			when_warn.command = (yyvsp[(3) - (3)].action).command;
			(yyval.str) = cat_str(3, make_str("/* exec sql whenever sql_warning "), (yyvsp[(3) - (3)].action).str, make_str("; */"));
		;}
    break;

  case 2334:

/* Line 1455 of yacc.c  */
#line 13074 "preproc.y"
    {
			(yyval.action).code = W_NOTHING;
			(yyval.action).command = NULL;
			(yyval.action).str = make_str("continue");
		;}
    break;

  case 2335:

/* Line 1455 of yacc.c  */
#line 13080 "preproc.y"
    {
			(yyval.action).code = W_SQLPRINT;
			(yyval.action).command = NULL;
			(yyval.action).str = make_str("sqlprint");
		;}
    break;

  case 2336:

/* Line 1455 of yacc.c  */
#line 13086 "preproc.y"
    {
			(yyval.action).code = W_STOP;
			(yyval.action).command = NULL;
			(yyval.action).str = make_str("stop");
		;}
    break;

  case 2337:

/* Line 1455 of yacc.c  */
#line 13092 "preproc.y"
    {
			(yyval.action).code = W_GOTO;
			(yyval.action).command = strdup((yyvsp[(2) - (2)].str));
			(yyval.action).str = cat2_str(make_str("goto "), (yyvsp[(2) - (2)].str));
		;}
    break;

  case 2338:

/* Line 1455 of yacc.c  */
#line 13098 "preproc.y"
    {
			(yyval.action).code = W_GOTO;
			(yyval.action).command = strdup((yyvsp[(3) - (3)].str));
			(yyval.action).str = cat2_str(make_str("goto "), (yyvsp[(3) - (3)].str));
		;}
    break;

  case 2339:

/* Line 1455 of yacc.c  */
#line 13104 "preproc.y"
    {
			(yyval.action).code = W_DO;
			(yyval.action).command = cat_str(4, (yyvsp[(2) - (5)].str), make_str("("), (yyvsp[(4) - (5)].str), make_str(")"));
			(yyval.action).str = cat2_str(make_str("do"), mm_strdup((yyval.action).command));
		;}
    break;

  case 2340:

/* Line 1455 of yacc.c  */
#line 13110 "preproc.y"
    {
			(yyval.action).code = W_BREAK;
			(yyval.action).command = NULL;
			(yyval.action).str = make_str("break");
		;}
    break;

  case 2341:

/* Line 1455 of yacc.c  */
#line 13116 "preproc.y"
    {
			(yyval.action).code = W_DO;
			(yyval.action).command = cat_str(4, (yyvsp[(2) - (5)].str), make_str("("), (yyvsp[(4) - (5)].str), make_str(")"));
			(yyval.action).str = cat2_str(make_str("call"), mm_strdup((yyval.action).command));
		;}
    break;

  case 2342:

/* Line 1455 of yacc.c  */
#line 13122 "preproc.y"
    {
			(yyval.action).code = W_DO;
			(yyval.action).command = cat2_str((yyvsp[(2) - (2)].str), make_str("()"));
			(yyval.action).str = cat2_str(make_str("call"), mm_strdup((yyval.action).command));
		;}
    break;

  case 2343:

/* Line 1455 of yacc.c  */
#line 13132 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2344:

/* Line 1455 of yacc.c  */
#line 13133 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2345:

/* Line 1455 of yacc.c  */
#line 13136 "preproc.y"
    { (yyval.str) = make_str("break"); ;}
    break;

  case 2346:

/* Line 1455 of yacc.c  */
#line 13137 "preproc.y"
    { (yyval.str) = make_str("call"); ;}
    break;

  case 2347:

/* Line 1455 of yacc.c  */
#line 13138 "preproc.y"
    { (yyval.str) = make_str("cardinality"); ;}
    break;

  case 2348:

/* Line 1455 of yacc.c  */
#line 13139 "preproc.y"
    { (yyval.str) = make_str("count"); ;}
    break;

  case 2349:

/* Line 1455 of yacc.c  */
#line 13140 "preproc.y"
    { (yyval.str) = make_str("datetime_interval_code"); ;}
    break;

  case 2350:

/* Line 1455 of yacc.c  */
#line 13141 "preproc.y"
    { (yyval.str) = make_str("datetime_interval_precision"); ;}
    break;

  case 2351:

/* Line 1455 of yacc.c  */
#line 13142 "preproc.y"
    { (yyval.str) = make_str("found"); ;}
    break;

  case 2352:

/* Line 1455 of yacc.c  */
#line 13143 "preproc.y"
    { (yyval.str) = make_str("go"); ;}
    break;

  case 2353:

/* Line 1455 of yacc.c  */
#line 13144 "preproc.y"
    { (yyval.str) = make_str("goto"); ;}
    break;

  case 2354:

/* Line 1455 of yacc.c  */
#line 13145 "preproc.y"
    { (yyval.str) = make_str("identified"); ;}
    break;

  case 2355:

/* Line 1455 of yacc.c  */
#line 13146 "preproc.y"
    { (yyval.str) = make_str("indicator"); ;}
    break;

  case 2356:

/* Line 1455 of yacc.c  */
#line 13147 "preproc.y"
    { (yyval.str) = make_str("key_member"); ;}
    break;

  case 2357:

/* Line 1455 of yacc.c  */
#line 13148 "preproc.y"
    { (yyval.str) = make_str("length"); ;}
    break;

  case 2358:

/* Line 1455 of yacc.c  */
#line 13149 "preproc.y"
    { (yyval.str) = make_str("nullable"); ;}
    break;

  case 2359:

/* Line 1455 of yacc.c  */
#line 13150 "preproc.y"
    { (yyval.str) = make_str("octet_length"); ;}
    break;

  case 2360:

/* Line 1455 of yacc.c  */
#line 13151 "preproc.y"
    { (yyval.str) = make_str("returned_length"); ;}
    break;

  case 2361:

/* Line 1455 of yacc.c  */
#line 13152 "preproc.y"
    { (yyval.str) = make_str("returned_octet_length"); ;}
    break;

  case 2362:

/* Line 1455 of yacc.c  */
#line 13153 "preproc.y"
    { (yyval.str) = make_str("scale"); ;}
    break;

  case 2363:

/* Line 1455 of yacc.c  */
#line 13154 "preproc.y"
    { (yyval.str) = make_str("section"); ;}
    break;

  case 2364:

/* Line 1455 of yacc.c  */
#line 13155 "preproc.y"
    { (yyval.str) = make_str("sql"); ;}
    break;

  case 2365:

/* Line 1455 of yacc.c  */
#line 13156 "preproc.y"
    { (yyval.str) = make_str("sqlerror"); ;}
    break;

  case 2366:

/* Line 1455 of yacc.c  */
#line 13157 "preproc.y"
    { (yyval.str) = make_str("sqlprint"); ;}
    break;

  case 2367:

/* Line 1455 of yacc.c  */
#line 13158 "preproc.y"
    { (yyval.str) = make_str("sqlwarning"); ;}
    break;

  case 2368:

/* Line 1455 of yacc.c  */
#line 13159 "preproc.y"
    { (yyval.str) = make_str("stop"); ;}
    break;

  case 2369:

/* Line 1455 of yacc.c  */
#line 13162 "preproc.y"
    { (yyval.str) = make_str("connect"); ;}
    break;

  case 2370:

/* Line 1455 of yacc.c  */
#line 13163 "preproc.y"
    { (yyval.str) = make_str("describe"); ;}
    break;

  case 2371:

/* Line 1455 of yacc.c  */
#line 13164 "preproc.y"
    { (yyval.str) = make_str("disconnect"); ;}
    break;

  case 2372:

/* Line 1455 of yacc.c  */
#line 13165 "preproc.y"
    { (yyval.str) = make_str("open"); ;}
    break;

  case 2373:

/* Line 1455 of yacc.c  */
#line 13166 "preproc.y"
    { (yyval.str) = make_str("var"); ;}
    break;

  case 2374:

/* Line 1455 of yacc.c  */
#line 13167 "preproc.y"
    { (yyval.str) = make_str("whenever"); ;}
    break;

  case 2375:

/* Line 1455 of yacc.c  */
#line 13171 "preproc.y"
    { (yyval.str) = make_str("bool"); ;}
    break;

  case 2376:

/* Line 1455 of yacc.c  */
#line 13172 "preproc.y"
    { (yyval.str) = make_str("long"); ;}
    break;

  case 2377:

/* Line 1455 of yacc.c  */
#line 13173 "preproc.y"
    { (yyval.str) = make_str("output"); ;}
    break;

  case 2378:

/* Line 1455 of yacc.c  */
#line 13174 "preproc.y"
    { (yyval.str) = make_str("short"); ;}
    break;

  case 2379:

/* Line 1455 of yacc.c  */
#line 13175 "preproc.y"
    { (yyval.str) = make_str("struct"); ;}
    break;

  case 2380:

/* Line 1455 of yacc.c  */
#line 13176 "preproc.y"
    { (yyval.str) = make_str("signed"); ;}
    break;

  case 2381:

/* Line 1455 of yacc.c  */
#line 13177 "preproc.y"
    { (yyval.str) = make_str("unsigned"); ;}
    break;

  case 2382:

/* Line 1455 of yacc.c  */
#line 13180 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2383:

/* Line 1455 of yacc.c  */
#line 13183 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2384:

/* Line 1455 of yacc.c  */
#line 13184 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2385:

/* Line 1455 of yacc.c  */
#line 13185 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2386:

/* Line 1455 of yacc.c  */
#line 13186 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2387:

/* Line 1455 of yacc.c  */
#line 13187 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2388:

/* Line 1455 of yacc.c  */
#line 13188 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2389:

/* Line 1455 of yacc.c  */
#line 13189 "preproc.y"
    { (yyval.str) = make_str("char"); ;}
    break;

  case 2390:

/* Line 1455 of yacc.c  */
#line 13190 "preproc.y"
    { (yyval.str) = make_str("values"); ;}
    break;

  case 2391:

/* Line 1455 of yacc.c  */
#line 13203 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2392:

/* Line 1455 of yacc.c  */
#line 13204 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2393:

/* Line 1455 of yacc.c  */
#line 13205 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2394:

/* Line 1455 of yacc.c  */
#line 13206 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2395:

/* Line 1455 of yacc.c  */
#line 13207 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2396:

/* Line 1455 of yacc.c  */
#line 13208 "preproc.y"
    { (yyval.str) = make_str("char"); ;}
    break;

  case 2397:

/* Line 1455 of yacc.c  */
#line 13209 "preproc.y"
    { (yyval.str) = make_str("values"); ;}
    break;

  case 2398:

/* Line 1455 of yacc.c  */
#line 13214 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2399:

/* Line 1455 of yacc.c  */
#line 13215 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2400:

/* Line 1455 of yacc.c  */
#line 13216 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2401:

/* Line 1455 of yacc.c  */
#line 13217 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2402:

/* Line 1455 of yacc.c  */
#line 13218 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2403:

/* Line 1455 of yacc.c  */
#line 13219 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2404:

/* Line 1455 of yacc.c  */
#line 13225 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2405:

/* Line 1455 of yacc.c  */
#line 13226 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2406:

/* Line 1455 of yacc.c  */
#line 13227 "preproc.y"
    { (yyval.str) = make_str("char"); ;}
    break;

  case 2407:

/* Line 1455 of yacc.c  */
#line 13228 "preproc.y"
    { (yyval.str) = make_str("current"); ;}
    break;

  case 2408:

/* Line 1455 of yacc.c  */
#line 13229 "preproc.y"
    { (yyval.str) = make_str("input"); ;}
    break;

  case 2409:

/* Line 1455 of yacc.c  */
#line 13230 "preproc.y"
    { (yyval.str) = make_str("int"); ;}
    break;

  case 2410:

/* Line 1455 of yacc.c  */
#line 13231 "preproc.y"
    { (yyval.str) = make_str("to"); ;}
    break;

  case 2411:

/* Line 1455 of yacc.c  */
#line 13232 "preproc.y"
    { (yyval.str) = make_str("union"); ;}
    break;

  case 2412:

/* Line 1455 of yacc.c  */
#line 13233 "preproc.y"
    { (yyval.str) = make_str("values"); ;}
    break;

  case 2413:

/* Line 1455 of yacc.c  */
#line 13234 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2414:

/* Line 1455 of yacc.c  */
#line 13235 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2415:

/* Line 1455 of yacc.c  */
#line 13238 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2416:

/* Line 1455 of yacc.c  */
#line 13239 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2417:

/* Line 1455 of yacc.c  */
#line 13240 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2418:

/* Line 1455 of yacc.c  */
#line 13241 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2419:

/* Line 1455 of yacc.c  */
#line 13242 "preproc.y"
    { (yyval.str) = make_str("connection"); ;}
    break;

  case 2420:

/* Line 1455 of yacc.c  */
#line 13245 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2421:

/* Line 1455 of yacc.c  */
#line 13246 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2422:

/* Line 1455 of yacc.c  */
#line 13247 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2423:

/* Line 1455 of yacc.c  */
#line 13248 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2424:

/* Line 1455 of yacc.c  */
#line 13251 "preproc.y"
    { (yyval.str) = make_str("auto"); ;}
    break;

  case 2425:

/* Line 1455 of yacc.c  */
#line 13252 "preproc.y"
    { (yyval.str) = make_str("const"); ;}
    break;

  case 2426:

/* Line 1455 of yacc.c  */
#line 13253 "preproc.y"
    { (yyval.str) = make_str("extern"); ;}
    break;

  case 2427:

/* Line 1455 of yacc.c  */
#line 13254 "preproc.y"
    { (yyval.str) = make_str("register"); ;}
    break;

  case 2428:

/* Line 1455 of yacc.c  */
#line 13255 "preproc.y"
    { (yyval.str) = make_str("static"); ;}
    break;

  case 2429:

/* Line 1455 of yacc.c  */
#line 13256 "preproc.y"
    { (yyval.str) = make_str("typedef"); ;}
    break;

  case 2430:

/* Line 1455 of yacc.c  */
#line 13257 "preproc.y"
    { (yyval.str) = make_str("volatile"); ;}
    break;

  case 2431:

/* Line 1455 of yacc.c  */
#line 13274 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2432:

/* Line 1455 of yacc.c  */
#line 13275 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2433:

/* Line 1455 of yacc.c  */
#line 13276 "preproc.y"
    { (yyval.str) = make_str("connection"); ;}
    break;

  case 2434:

/* Line 1455 of yacc.c  */
#line 13279 "preproc.y"
    { (yyval.str) = make_str("day"); ;}
    break;

  case 2435:

/* Line 1455 of yacc.c  */
#line 13280 "preproc.y"
    { (yyval.str) = make_str("hour"); ;}
    break;

  case 2436:

/* Line 1455 of yacc.c  */
#line 13281 "preproc.y"
    { (yyval.str) = make_str("minute"); ;}
    break;

  case 2437:

/* Line 1455 of yacc.c  */
#line 13282 "preproc.y"
    { (yyval.str) = make_str("month"); ;}
    break;

  case 2438:

/* Line 1455 of yacc.c  */
#line 13283 "preproc.y"
    { (yyval.str) = make_str("second"); ;}
    break;

  case 2439:

/* Line 1455 of yacc.c  */
#line 13284 "preproc.y"
    { (yyval.str) = make_str("year"); ;}
    break;

  case 2442:

/* Line 1455 of yacc.c  */
#line 13291 "preproc.y"
    {
				reset_variables();
				pacounter = 1;
			;}
    break;

  case 2443:

/* Line 1455 of yacc.c  */
#line 13297 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2444:

/* Line 1455 of yacc.c  */
#line 13298 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2445:

/* Line 1455 of yacc.c  */
#line 13302 "preproc.y"
    { add_variable_to_head(&argsresult, find_variable((yyvsp[(1) - (2)].str)), find_variable((yyvsp[(2) - (2)].str))); ;}
    break;

  case 2446:

/* Line 1455 of yacc.c  */
#line 13304 "preproc.y"
    { add_variable_to_head(&argsresult, find_variable((yyvsp[(1) - (1)].str)), &no_indicator); ;}
    break;

  case 2447:

/* Line 1455 of yacc.c  */
#line 13309 "preproc.y"
    {
			if (find_variable((yyvsp[(2) - (2)].str))->type->type == ECPGt_array)
				mmerror(PARSE_ERROR, ET_ERROR, "arrays of indicators are not allowed on input");

			add_variable_to_head(&argsinsert, find_variable((yyvsp[(1) - (2)].str)), find_variable((yyvsp[(2) - (2)].str)));
			(yyval.str) = create_questionmarks((yyvsp[(1) - (2)].str), false);
		;}
    break;

  case 2448:

/* Line 1455 of yacc.c  */
#line 13319 "preproc.y"
    {
			char *ptr = strstr((yyvsp[(1) - (1)].str), ".arr");

			if (ptr) /* varchar, we need the struct name here, not the struct element */
				*ptr = '\0';
			add_variable_to_head(&argsinsert, find_variable((yyvsp[(1) - (1)].str)), &no_indicator);
			(yyval.str) = (yyvsp[(1) - (1)].str);
		;}
    break;

  case 2449:

/* Line 1455 of yacc.c  */
#line 13330 "preproc.y"
    {
			add_variable_to_head(&argsinsert, find_variable((yyvsp[(1) - (1)].str)), &no_indicator);
			(yyval.str) = create_questionmarks((yyvsp[(1) - (1)].str), false);
		;}
    break;

  case 2450:

/* Line 1455 of yacc.c  */
#line 13336 "preproc.y"
    { check_indicator((find_variable((yyvsp[(1) - (1)].str)))->type); (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2451:

/* Line 1455 of yacc.c  */
#line 13337 "preproc.y"
    { check_indicator((find_variable((yyvsp[(2) - (2)].str)))->type); (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 2452:

/* Line 1455 of yacc.c  */
#line 13338 "preproc.y"
    { check_indicator((find_variable((yyvsp[(2) - (2)].str)))->type); (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 2453:

/* Line 1455 of yacc.c  */
#line 13342 "preproc.y"
    {
			/* As long as multidimensional arrays are not implemented we have to check for those here */
			char *ptr = (yyvsp[(1) - (1)].str);
			int brace_open=0, brace = false;

			for (; *ptr; ptr++)
			{
				switch (*ptr)
				{
					case '[':
							if (brace)
								mmerror(PARSE_ERROR, ET_FATAL, "multidimensional arrays for simple data types are not supported");
							brace_open++;
							break;
					case ']':
							brace_open--;
							if (brace_open == 0)
								brace = true;
							break;
					case '\t':
					case ' ':
							break;
					default:
							if (brace_open == 0)
								brace = false;
							break;
				}
			}
			(yyval.str) = (yyvsp[(1) - (1)].str);
		;}
    break;

  case 2454:

/* Line 1455 of yacc.c  */
#line 13374 "preproc.y"
    { (yyval.str) = make_name(); ;}
    break;

  case 2455:

/* Line 1455 of yacc.c  */
#line 13376 "preproc.y"
    { (yyval.str) = make_name(); ;}
    break;

  case 2456:

/* Line 1455 of yacc.c  */
#line 13378 "preproc.y"
    { (yyval.str) = make_name(); ;}
    break;

  case 2457:

/* Line 1455 of yacc.c  */
#line 13382 "preproc.y"
    {
			/* could have been input as '' or $$ */
			(yyval.str) = (char *)mm_alloc(strlen((yyvsp[(1) - (1)].str)) + 3);
			(yyval.str)[0]='\'';
			strcpy((yyval.str)+1, (yyvsp[(1) - (1)].str));
			(yyval.str)[strlen((yyvsp[(1) - (1)].str))+1]='\'';
			(yyval.str)[strlen((yyvsp[(1) - (1)].str))+2]='\0';
			free((yyvsp[(1) - (1)].str));
		;}
    break;

  case 2458:

/* Line 1455 of yacc.c  */
#line 13392 "preproc.y"
    {
			(yyval.str) = (char *)mm_alloc(strlen((yyvsp[(1) - (1)].str)) + 4);
			(yyval.str)[0]='E';
			(yyval.str)[1]='\'';
			strcpy((yyval.str)+2, (yyvsp[(1) - (1)].str));
			(yyval.str)[strlen((yyvsp[(1) - (1)].str))+2]='\'';
			(yyval.str)[strlen((yyvsp[(1) - (1)].str))+3]='\0';
			free((yyvsp[(1) - (1)].str));
		;}
    break;

  case 2459:

/* Line 1455 of yacc.c  */
#line 13402 "preproc.y"
    {
			(yyval.str) = (char *)mm_alloc(strlen((yyvsp[(1) - (1)].str)) + 4);
			(yyval.str)[0]='N';
			(yyval.str)[1]='\'';
			strcpy((yyval.str)+2, (yyvsp[(1) - (1)].str));
			(yyval.str)[strlen((yyvsp[(1) - (1)].str))+2]='\'';
			(yyval.str)[strlen((yyvsp[(1) - (1)].str))+3]='\0';
			free((yyvsp[(1) - (1)].str));
		;}
    break;

  case 2460:

/* Line 1455 of yacc.c  */
#line 13411 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2461:

/* Line 1455 of yacc.c  */
#line 13412 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2462:

/* Line 1455 of yacc.c  */
#line 13415 "preproc.y"
    { (yyval.str) = make_name(); ;}
    break;

  case 2463:

/* Line 1455 of yacc.c  */
#line 13417 "preproc.y"
    { (yyval.str) = make_name(); ;}
    break;

  case 2464:

/* Line 1455 of yacc.c  */
#line 13418 "preproc.y"
    { (yyval.str) = make3_str(make_str("\""), (yyvsp[(1) - (1)].str), make_str("\"")); ;}
    break;

  case 2465:

/* Line 1455 of yacc.c  */
#line 13419 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2466:

/* Line 1455 of yacc.c  */
#line 13423 "preproc.y"
    { (yyval.str) = make3_str(make_str("\""), (yyvsp[(1) - (1)].str), make_str("\"")); ;}
    break;

  case 2467:

/* Line 1455 of yacc.c  */
#line 13425 "preproc.y"
    { (yyval.str) = make3_str(make_str("("), (yyvsp[(1) - (1)].str), make_str(")")); ;}
    break;

  case 2468:

/* Line 1455 of yacc.c  */
#line 13432 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2469:

/* Line 1455 of yacc.c  */
#line 13433 "preproc.y"
    { (yyval.str) = make_str("()"); ;}
    break;

  case 2470:

/* Line 1455 of yacc.c  */
#line 13435 "preproc.y"
    { (yyval.str) = cat_str(3, make_str("("), (yyvsp[(2) - (3)].str), make_str(")")); ;}
    break;

  case 2471:

/* Line 1455 of yacc.c  */
#line 13438 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2472:

/* Line 1455 of yacc.c  */
#line 13440 "preproc.y"
    { (yyval.str) = cat2_str((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].str)); ;}
    break;

  case 2473:

/* Line 1455 of yacc.c  */
#line 13443 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2474:

/* Line 1455 of yacc.c  */
#line 13444 "preproc.y"
    { (yyval.str) = cat_str(3, (yyvsp[(1) - (3)].str), make_str(","), (yyvsp[(3) - (3)].str)); ;}
    break;

  case 2475:

/* Line 1455 of yacc.c  */
#line 13447 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2476:

/* Line 1455 of yacc.c  */
#line 13448 "preproc.y"
    { (yyval.str) = cat_str(3, make_str("{"), (yyvsp[(2) - (3)].str), make_str("}")); ;}
    break;

  case 2477:

/* Line 1455 of yacc.c  */
#line 13451 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2478:

/* Line 1455 of yacc.c  */
#line 13452 "preproc.y"
    { (yyval.str) = make_str("("); ;}
    break;

  case 2479:

/* Line 1455 of yacc.c  */
#line 13453 "preproc.y"
    { (yyval.str) = make_str(")"); ;}
    break;

  case 2480:

/* Line 1455 of yacc.c  */
#line 13454 "preproc.y"
    { (yyval.str) = make_str(","); ;}
    break;

  case 2481:

/* Line 1455 of yacc.c  */
#line 13455 "preproc.y"
    { (yyval.str) = make_str(";"); ;}
    break;

  case 2482:

/* Line 1455 of yacc.c  */
#line 13458 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2483:

/* Line 1455 of yacc.c  */
#line 13459 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2484:

/* Line 1455 of yacc.c  */
#line 13460 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2485:

/* Line 1455 of yacc.c  */
#line 13461 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2486:

/* Line 1455 of yacc.c  */
#line 13462 "preproc.y"
    { (yyval.str) = make_str("*"); ;}
    break;

  case 2487:

/* Line 1455 of yacc.c  */
#line 13463 "preproc.y"
    { (yyval.str) = make_str("+"); ;}
    break;

  case 2488:

/* Line 1455 of yacc.c  */
#line 13464 "preproc.y"
    { (yyval.str) = make_str("-"); ;}
    break;

  case 2489:

/* Line 1455 of yacc.c  */
#line 13465 "preproc.y"
    { (yyval.str) = make_str("/"); ;}
    break;

  case 2490:

/* Line 1455 of yacc.c  */
#line 13466 "preproc.y"
    { (yyval.str) = make_str("%"); ;}
    break;

  case 2491:

/* Line 1455 of yacc.c  */
#line 13467 "preproc.y"
    { (yyval.str) = make_str("NULL"); ;}
    break;

  case 2492:

/* Line 1455 of yacc.c  */
#line 13468 "preproc.y"
    { (yyval.str) = make_str("+="); ;}
    break;

  case 2493:

/* Line 1455 of yacc.c  */
#line 13469 "preproc.y"
    { (yyval.str) = make_str("&&"); ;}
    break;

  case 2494:

/* Line 1455 of yacc.c  */
#line 13470 "preproc.y"
    { (yyval.str) = make_name(); ;}
    break;

  case 2495:

/* Line 1455 of yacc.c  */
#line 13471 "preproc.y"
    { (yyval.str) = make_str("auto"); ;}
    break;

  case 2496:

/* Line 1455 of yacc.c  */
#line 13472 "preproc.y"
    { (yyval.str) = make_str("const"); ;}
    break;

  case 2497:

/* Line 1455 of yacc.c  */
#line 13473 "preproc.y"
    { (yyval.str) = make_str("--"); ;}
    break;

  case 2498:

/* Line 1455 of yacc.c  */
#line 13474 "preproc.y"
    { (yyval.str) = make_str("/="); ;}
    break;

  case 2499:

/* Line 1455 of yacc.c  */
#line 13475 "preproc.y"
    { (yyval.str) = make_str(".*"); ;}
    break;

  case 2500:

/* Line 1455 of yacc.c  */
#line 13476 "preproc.y"
    { (yyval.str) = make_str("=="); ;}
    break;

  case 2501:

/* Line 1455 of yacc.c  */
#line 13477 "preproc.y"
    { (yyval.str) = make_str("extern"); ;}
    break;

  case 2502:

/* Line 1455 of yacc.c  */
#line 13478 "preproc.y"
    { (yyval.str) = make_str("++"); ;}
    break;

  case 2503:

/* Line 1455 of yacc.c  */
#line 13479 "preproc.y"
    { (yyval.str) = make_str("<<"); ;}
    break;

  case 2504:

/* Line 1455 of yacc.c  */
#line 13480 "preproc.y"
    { (yyval.str) = make_str("->"); ;}
    break;

  case 2505:

/* Line 1455 of yacc.c  */
#line 13481 "preproc.y"
    { (yyval.str) = make_str("->*"); ;}
    break;

  case 2506:

/* Line 1455 of yacc.c  */
#line 13482 "preproc.y"
    { (yyval.str) = make_str("%="); ;}
    break;

  case 2507:

/* Line 1455 of yacc.c  */
#line 13483 "preproc.y"
    { (yyval.str) = make_str("*="); ;}
    break;

  case 2508:

/* Line 1455 of yacc.c  */
#line 13484 "preproc.y"
    { (yyval.str) = make_str("!="); ;}
    break;

  case 2509:

/* Line 1455 of yacc.c  */
#line 13485 "preproc.y"
    { (yyval.str) = make_str("||"); ;}
    break;

  case 2510:

/* Line 1455 of yacc.c  */
#line 13486 "preproc.y"
    { (yyval.str) = make_str("register"); ;}
    break;

  case 2511:

/* Line 1455 of yacc.c  */
#line 13487 "preproc.y"
    { (yyval.str) = make_str(">>"); ;}
    break;

  case 2512:

/* Line 1455 of yacc.c  */
#line 13488 "preproc.y"
    { (yyval.str) = make_str("static"); ;}
    break;

  case 2513:

/* Line 1455 of yacc.c  */
#line 13489 "preproc.y"
    { (yyval.str) = make_str("-="); ;}
    break;

  case 2514:

/* Line 1455 of yacc.c  */
#line 13490 "preproc.y"
    { (yyval.str) = make_str("typedef"); ;}
    break;

  case 2515:

/* Line 1455 of yacc.c  */
#line 13491 "preproc.y"
    { (yyval.str) = make_str("volatile"); ;}
    break;

  case 2516:

/* Line 1455 of yacc.c  */
#line 13492 "preproc.y"
    { (yyval.str) = make_str("bool"); ;}
    break;

  case 2517:

/* Line 1455 of yacc.c  */
#line 13493 "preproc.y"
    { (yyval.str) = make_str("enum"); ;}
    break;

  case 2518:

/* Line 1455 of yacc.c  */
#line 13494 "preproc.y"
    { (yyval.str) = make_str("hour"); ;}
    break;

  case 2519:

/* Line 1455 of yacc.c  */
#line 13495 "preproc.y"
    { (yyval.str) = make_str("int"); ;}
    break;

  case 2520:

/* Line 1455 of yacc.c  */
#line 13496 "preproc.y"
    { (yyval.str) = make_str("long"); ;}
    break;

  case 2521:

/* Line 1455 of yacc.c  */
#line 13497 "preproc.y"
    { (yyval.str) = make_str("minute"); ;}
    break;

  case 2522:

/* Line 1455 of yacc.c  */
#line 13498 "preproc.y"
    { (yyval.str) = make_str("month"); ;}
    break;

  case 2523:

/* Line 1455 of yacc.c  */
#line 13499 "preproc.y"
    { (yyval.str) = make_str("second"); ;}
    break;

  case 2524:

/* Line 1455 of yacc.c  */
#line 13500 "preproc.y"
    { (yyval.str) = make_str("short"); ;}
    break;

  case 2525:

/* Line 1455 of yacc.c  */
#line 13501 "preproc.y"
    { (yyval.str) = make_str("signed"); ;}
    break;

  case 2526:

/* Line 1455 of yacc.c  */
#line 13502 "preproc.y"
    { (yyval.str) = make_str("struct"); ;}
    break;

  case 2527:

/* Line 1455 of yacc.c  */
#line 13503 "preproc.y"
    { (yyval.str) = make_str("unsigned"); ;}
    break;

  case 2528:

/* Line 1455 of yacc.c  */
#line 13504 "preproc.y"
    { (yyval.str) = make_str("year"); ;}
    break;

  case 2529:

/* Line 1455 of yacc.c  */
#line 13505 "preproc.y"
    { (yyval.str) = make_str("char"); ;}
    break;

  case 2530:

/* Line 1455 of yacc.c  */
#line 13506 "preproc.y"
    { (yyval.str) = make_str("float"); ;}
    break;

  case 2531:

/* Line 1455 of yacc.c  */
#line 13507 "preproc.y"
    { (yyval.str) = make_str("to"); ;}
    break;

  case 2532:

/* Line 1455 of yacc.c  */
#line 13508 "preproc.y"
    { (yyval.str) = make_str("union"); ;}
    break;

  case 2533:

/* Line 1455 of yacc.c  */
#line 13509 "preproc.y"
    { (yyval.str) = make_str("varchar"); ;}
    break;

  case 2534:

/* Line 1455 of yacc.c  */
#line 13510 "preproc.y"
    { (yyval.str) = make_str("["); ;}
    break;

  case 2535:

/* Line 1455 of yacc.c  */
#line 13511 "preproc.y"
    { (yyval.str) = make_str("]"); ;}
    break;

  case 2536:

/* Line 1455 of yacc.c  */
#line 13512 "preproc.y"
    { (yyval.str) = make_str("="); ;}
    break;

  case 2537:

/* Line 1455 of yacc.c  */
#line 13513 "preproc.y"
    { (yyval.str) = make_str(":"); ;}
    break;

  case 2538:

/* Line 1455 of yacc.c  */
#line 13516 "preproc.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 2539:

/* Line 1455 of yacc.c  */
#line 13517 "preproc.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); ;}
    break;

  case 2540:

/* Line 1455 of yacc.c  */
#line 13518 "preproc.y"
    { (yyval.str) = make_str("all"); ;}
    break;

  case 2541:

/* Line 1455 of yacc.c  */
#line 13519 "preproc.y"
    { (yyval.str) = make_str("all"); ;}
    break;

  case 2542:

/* Line 1455 of yacc.c  */
#line 13522 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2543:

/* Line 1455 of yacc.c  */
#line 13523 "preproc.y"
    { (yyval.str) = cat_str(3, make_str("("), (yyvsp[(2) - (3)].str), make_str(")")); ;}
    break;

  case 2544:

/* Line 1455 of yacc.c  */
#line 13524 "preproc.y"
    { (yyval.str) = cat_str(3, (yyvsp[(1) - (3)].str), make_str("+"), (yyvsp[(3) - (3)].str)); ;}
    break;

  case 2545:

/* Line 1455 of yacc.c  */
#line 13525 "preproc.y"
    { (yyval.str) = cat_str(3, (yyvsp[(1) - (3)].str), make_str("-"), (yyvsp[(3) - (3)].str)); ;}
    break;

  case 2546:

/* Line 1455 of yacc.c  */
#line 13526 "preproc.y"
    { (yyval.str) = cat_str(3, (yyvsp[(1) - (3)].str), make_str("*"), (yyvsp[(3) - (3)].str)); ;}
    break;

  case 2547:

/* Line 1455 of yacc.c  */
#line 13527 "preproc.y"
    { (yyval.str) = cat_str(3, (yyvsp[(1) - (3)].str), make_str("/"), (yyvsp[(3) - (3)].str)); ;}
    break;

  case 2548:

/* Line 1455 of yacc.c  */
#line 13528 "preproc.y"
    { (yyval.str) = cat_str(3, (yyvsp[(1) - (3)].str), make_str("%"), (yyvsp[(3) - (3)].str)); ;}
    break;

  case 2549:

/* Line 1455 of yacc.c  */
#line 13529 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2550:

/* Line 1455 of yacc.c  */
#line 13530 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2551:

/* Line 1455 of yacc.c  */
#line 13533 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2552:

/* Line 1455 of yacc.c  */
#line 13534 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2553:

/* Line 1455 of yacc.c  */
#line 13535 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2554:

/* Line 1455 of yacc.c  */
#line 13536 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2555:

/* Line 1455 of yacc.c  */
#line 13537 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2556:

/* Line 1455 of yacc.c  */
#line 13540 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2557:

/* Line 1455 of yacc.c  */
#line 13541 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2558:

/* Line 1455 of yacc.c  */
#line 13544 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2559:

/* Line 1455 of yacc.c  */
#line 13546 "preproc.y"
    {
		struct variable *var;

		var = argsinsert->variable;
		remove_variable_from_list(&argsinsert, var);
		add_variable_to_head(&argsresult, var, &no_indicator);
		(yyval.str) = (yyvsp[(1) - (1)].str);
	;}
    break;

  case 2560:

/* Line 1455 of yacc.c  */
#line 13556 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2561:

/* Line 1455 of yacc.c  */
#line 13557 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;



/* Line 1455 of yacc.c  */
#line 47569 "preproc.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }

  yyerror_range[0] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[0] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[0] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;

  yyerror_range[1] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, (yyerror_range - 1), 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval, &yylloc);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 13560 "preproc.y"


void base_yyerror(const char *error)
{
	/* translator: %s is typically the translation of "syntax error" */
	mmerror(PARSE_ERROR, ET_ERROR, "%s at or near \"%s\"",
			_(error), token_start ? token_start : yytext);
}

void parser_init(void)
{
 /* This function is empty. It only exists for compatibility with the backend parser right now. */
}

/*
 * Must undefine base_yylex before including pgc.c, since we want it
 * to create the function base_yylex not filtered_base_yylex.
 */
#undef base_yylex

#include "pgc.c"

